/*	DIVERSE KONSTANTER : */

#define	maxfaelt	50	/* max antal faelt/blankett */
#define	maxrub		50	/* max antal rubriker/blankett */
#define	maxatt		5	/* max antal attribut/faelt */
#define arkvidd		79	/* vidd pa en blankett */
#define	arkhojd		23	/* hojd pa en blankett */
#define	arksize		arkvidd*arkhojd	/* antal tecken per blankett */
#define	rfsize		2*arksize/* storlek paa rf-buffern */

/*	STRUKTURER OCH TYPER : */

typedef	unsigned int	uint;
typedef	char	trf[rfsize];	/* rubriker, defaultvaerden o faeltinnehaall */

typedef char	*CHPTR;		/* char pointer */
typedef	CHPTR	(*PFCP)();	/* pointer to function returning char ptr */

typedef	struct {
	int	rad;		/* varje faelts radpos */
	int	kol;		/* varje faelts kolpos */
	int	len;		/* varje faelts laengd */
	char	*data;		/* adress till datat i faeltet */
	PFCP	edit[maxatt];	/* adresser till edittime-checkrutiner */
	PFCP	exit[maxatt];	/* adresser till exit-checkrutiner */
	/* oevriga attribut */
	uint	auto_enter:1;	/* "a" automatiskt faeltbyte vid slut */
	uint	numeric:1;	/* "n" bara numeriska tecken */
	uint	right:1;	/* "r" hoegerjusterat */
	uint	centrate:1;	/* "c" centrerat */
	uint	inverse:1;	/* "i" inverse video */
	uint	nospace:1;	/* "f" blanktecken ej tillaatna */
	uint	left:1;		/* "l" vaensterjusterat */
	uint	redisp:1;	/* om faeltet skall uppdateras paa skaermen */
	} tfaelt;

typedef	struct {
	int	rad;		/* rubrikens radpos */
	int	kol;		/* rubrikens kolpos */
	char	*text;		/* adress till rubriktexten */
	} trub;

typedef struct {
	int	faeltant;	/* antal faelt i blanketten */
	int	rubant;		/* antal rubriker */
	uint	rubdisp:1;	/* om rubrikerna ska redisplayas vid edit */
	uint	fbuflen;	/* summan av alla faeltens laengder */
	tfaelt	fl[maxfaelt];	/* blankettens faelt */
	trub	ru[maxrub];	/* blankettens rubriker */
	char	*flptr;		/* pekare till buffert foer faelten */
	char	*ruptr;		/* pekare till buffert foer rubrikerna */
	char	*dvptr;		/* pekare till buffert foer defaultvaerdena */
	} tbl;

/* EXTERNALS */

extern	int	kommando;	/* senaste kommando till editorn */
