/************************************************************************
 *									*
 *	Denna modul editerar ett record, innan anrop			*
 *	foersta gaangen maaste bildskaermen ha initierats		*
 *									*
 *	rev.hist.							*
 *	840903	AN	orginal vers.					*
 *	850220	AN	rev. 1						*
 *									*
 ************************************************************************/

#include <stdio.h>
#include "ble.h"
#include "edit.h"

int 	xnotimp(),xdum(),xbackch(),xclear(),xdelchar(),xforwch();
int	xbacksp(),xnewwin(),xnextfield(),xnextli(),xprevli(),xquit();
int	xtop(),xexit(),xhelp();
char	*exitkoll(),*editkoll();

int	kommando;	/* senaste kommandot */

/* array med adresser till editeringskommando-rutiner (cntrl-@ - cntrl-_) */
static	int	(*xkom[])() = {
	xdum,			/* cntrl-@ */
	xnotimp,		/* cntrl-A */
	xbackch,		/* cntrl-B */
	xclear,			/* cntrl-C */
	xdelchar,		/* cntrl-D */
	xnotimp,		/* cntrl-E */
	xforwch,		/* cntrl-F */
	xnotimp,		/* cntrl-G */
	xbacksp,		/* cntrl-H */
	xnotimp,		/* cntrl-I */
	xnotimp,		/* cntrl-J */
	xnotimp,		/* cntrl-K */
	xnewwin,		/* cntrl-L */
	xnextfield,		/* cntrl-M */
	xnextli,		/* cntrl-N */
	xnotimp,		/* cntrl-O */
	xprevli,		/* cntrl-P */
	xquit,			/* cntrl-Q */
	xnotimp,		/* cntrl-R */
	xnotimp,		/* cntrl-S */
	xtop,			/* cntrl-T */
	xnotimp,		/* cntrl-U */
	xnotimp,		/* cntrl-V */
	xnotimp,		/* cntrl-W */
	xexit,			/* cntrl-X */
	xnotimp,		/* cntrl-Y */
	xnotimp,		/* cntrl-Z */
	xnotimp,		/* cntrl-[ escape ! */
	xnotimp,		/* cntrl-\ */
	xhelp,			/* cntrl-] */
	xnotimp,		/* cntrl-^ */
	xnotimp			/* cntrl-_ */
	} ;

static	char	*attrmsg;	/* noll om attributkontrollen gaatt bra*/
static	int	touch;		/* TRUE om naagot aendrats i faeltet */
static	int	faeltnr;	/* current faelt */
static	int	faeltpos;	/* current faeltpos */
static	tbl	*bl;		/* pekare till blanketten */

/**/
/*********************************************************************

haer startar huvudslingan foer editorn

*********************************************************************/

edit(bll)
tbl	*bll;
{
	int	i;

	/*	div initieringar */
	faeltnr = 0;
	faeltpos = 0;
	attrmsg = 0;
	touch = FALSE;
	bl = bll;

	if (bl->rubdisp)
		xnewwin();	/* uppdatera hela skaermen */
	else
		for ( i = 0 ; i < bl->faeltant ; ++i ) /* bara faelten */
			fieldout(i);

	cpos(bl->fl[faeltnr].rad,bl->fl[faeltnr].kol+faeltpos);

	kommando = k_dum;

	while ( ( kommando != k_exit && kommando != k_quit ) || attrmsg ) {

		kommando = ink();

		if ( attrmsg ) {
			attrmsg = 0;
			clline(23);
			cpos(bl->fl[faeltnr].rad,bl->fl[faeltnr].kol+faeltpos);
		}

		if ( kommando < ' ' )
			(*xkom[kommando])();
		else
			xcharacter();
		cpos(bl->fl[faeltnr].rad,bl->fl[faeltnr].kol+faeltpos);

	}
	norvid();

	if ( kommando != k_quit )
		return ( ink() );
	else
		return ( kommando );

}
/**/
/*********************************************************************
dummy procedure do nothing
*********************************************************************/
xdum()
{
	/*	*/
}
/**/
/*********************************************************************
ta hand om ett printbart tecken och eka det
*********************************************************************/
xcharacter()
{


	if ( editkoll() )
		return;

	if ( bl->fl[faeltnr].data[faeltpos] != kommando ) {
		touch = TRUE;
		bl->fl[faeltnr].data[faeltpos] = kommando;
	}


	outc(kommando);
	++faeltpos;

	if ( faeltpos == bl->fl[faeltnr].len &&
	   ( bl->fl[faeltnr].auto_enter ) )
		xnextfield();
}
/**/
/*********************************************************************
flytta cursorn ett steg tillbaka
*********************************************************************/
xbackch()
{

	if ( faeltpos != 0 )
		--faeltpos;
	else
		if ( faeltnr != 0 && exitkoll(faeltnr) == 0 ) {
			--faeltnr;
			faeltpos = (bl->fl[faeltnr].len-1);
			fieldbeg(faeltnr);
		}

}
/**/
/*********************************************************************
clear field
*********************************************************************/
xclear()
{
	int	i;

	for ( i = 0 ; i < bl->fl[faeltnr].len ; ++i ) {
		if ( bl->fl[faeltnr].data[i] != ' ' ) 
			touch = TRUE;
		bl->fl[faeltnr].data[i] = ' ';
	}
	if ( touch )
		fieldout(faeltnr);
	faeltpos = 0;


}
/**/
/*********************************************************************
delete character
*********************************************************************/
xdelchar()
{
	int	i;

	if ( faeltpos < bl->fl[faeltnr].len ) {
		for ( i = faeltpos ; i < bl->fl[faeltnr].len-1 ; ++i ) {
			if ( bl->fl[faeltnr].data[i] != bl->fl[faeltnr].data[i+1] ) {
				bl->fl[faeltnr].data[i] = bl->fl[faeltnr].data[i+1];
				cpos(bl->fl[faeltnr].rad,bl->fl[faeltnr].kol+i);
				outc(bl->fl[faeltnr].data[i]);
				touch = TRUE;
			}
		}
		if ( bl->fl[faeltnr].data[i] != ' ' ) {
			bl->fl[faeltnr].data[i] = ' ';
			cpos(bl->fl[faeltnr].rad,bl->fl[faeltnr].kol+i);
			outc(' ');
			touch = TRUE;
		}

	}

}
/**/
/*********************************************************************
flytta cursorn ett steg framaat
*********************************************************************/
xforwch()
{

	if ( faeltpos < (bl->fl[faeltnr].len-1) )
		outc(bl->fl[faeltnr].data[faeltpos++]);
	else
		if ( faeltnr < (bl->faeltant-1) )
			xnextfield();

}
/**/
/*********************************************************************
backspace
*********************************************************************/
xbacksp()
{

	if ( faeltpos != 0 ) {
		--faeltpos;
		cpos(bl->fl[faeltnr].rad,bl->fl[faeltnr].kol+faeltpos);
		xdelchar();
	}
}
/**/
/*********************************************************************
rita om bildskaermen
*********************************************************************/
xnewwin()
{
	int	i;

	clscr();	/* rensa skaermen */

	norvid();

	for ( i = 0 ; i < bl->rubant ; ++i )
		cpouts(bl->ru[i].rad,bl->ru[i].kol,bl->ru[i].text);

	for ( i = 0 ; i < bl->faeltant ; ++i )
		fieldout(i);

	fieldbeg(faeltnr);
}
/**/
/*********************************************************************
next field - carrige return
*********************************************************************/
xnextfield()
{
	if (exitkoll(faeltnr) == 0) {
		faeltnr = (faeltnr+1) % bl->faeltant;
		faeltpos = 0;
		fieldbeg(faeltnr);
	}
}
/**/
/*********************************************************************
next line
*********************************************************************/
xnextli()
{
	int	r,k;	/* oenskad rad o kol */
	int	i;

	k = bl->fl[faeltnr].kol + faeltpos;

	for ( i = faeltnr ; bl->fl[i].rad == bl->fl[faeltnr].rad && i < bl->faeltant-1 ; ++i );
	if ( bl->fl[i].rad == bl->fl[faeltnr].rad )
		return;

	if (exitkoll(faeltnr))
		return;

	r = bl->fl[i].rad;
	for ( ; r == bl->fl[i+1].rad && i+1 < bl->faeltant ; ++i );
	for ( ; r == bl->fl[i].rad && k < bl->fl[i].kol ; --i );

	if ( r == bl->fl[i].rad ) {
		faeltnr = i;
		if ( k >= bl->fl[i].kol + bl->fl[i].len )
			faeltpos = bl->fl[i].len - 1;
		else
			faeltpos = k - bl->fl[i].kol;
	} else {
		faeltnr = i + 1;
		faeltpos = 0;
	}

	fieldbeg(faeltnr);
}
/**/
/*********************************************************************
previous line
*********************************************************************/
xprevli()
{
	int	r,k;	/* oenskad rad o kol */
	int	i;

	k = bl->fl[faeltnr].kol + faeltpos;

	for ( i = faeltnr ; bl->fl[i].rad == bl->fl[faeltnr].rad && i > 0 ; --i );

	if ( bl->fl[i].rad == bl->fl[faeltnr].rad )
		return;

	if (exitkoll(faeltnr))
		return;

	r = bl->fl[i].rad;

	for ( ; r == bl->fl[i].rad && k < bl->fl[i].kol ; --i );

	if ( r == bl->fl[i].rad ) {
		faeltnr = i;
		if ( k >= bl->fl[i].kol + bl->fl[i].len )
			faeltpos = bl->fl[i].len - 1;
		else
			faeltpos = k - bl->fl[i].kol;
	} else {
		faeltnr = i + 1;
		faeltpos = 0;
	}

	fieldbeg(faeltnr);
}
/**/
/*********************************************************************
quit
*********************************************************************/
xquit()
{
	/*	*/
}
/**/
/*********************************************************************
top - top of page
*********************************************************************/
xtop()
{
	if ( faeltnr == 0 || exitkoll(faeltnr) == 0 ) {
		faeltnr = 0;
		faeltpos = 0;
		fieldbeg(faeltnr);
	}
}
/**/
/*********************************************************************
exit	
*********************************************************************/
xexit()
{
	exitkoll(faeltnr);
}
/**/
/*********************************************************************
help
*********************************************************************/
xhelp()
{

	if ( (attrmsg = help(bl,faeltnr) ) == 0)
		attrmsg = "hj{lp saknas";

	invvid();
	cpouts(23,0,attrmsg);
	fieldbeg(faeltnr);

}
/**/
/*********************************************************************
ta hand om ett icke implementerat kommando
*********************************************************************/
xnotimp()
{

	putch(CTRL(G));	/* BELL */

}
/**/
/*********************************************************************
fieldbeg - kontrollera ev. attribut foere editering av faeltet
*********************************************************************/
fieldbeg(field)
{

	if ( bl->fl[field].inverse )
		invvid();
	else
		norvid();

}
/**/
/*********************************************************************
editkoll - kontrollera ev. attribut f|r varje tecken i faeltet
returkod 0 eller adress till felmeddelandet
*********************************************************************/
char *editkoll()
{
	int	i;

	attrmsg = 0;

	/* kontrollera foerst att faeltpos inte aer utanfoer faeltet */
	if ( faeltpos == bl->fl[faeltnr].len )
		attrmsg = "f{ltet fullt";

	/* numeric */
	if ( ! attrmsg )
		if ( bl->fl[faeltnr].numeric )
			if ( kommando < '0' || kommando > '9' )
				attrmsg = "enbart numeriska tecken till}tna";

	/* edit-checkar */
	if ( ! attrmsg )
		for ( i = 0 ; bl->fl[faeltnr].edit[i] != 0 && i < maxatt ; ++i )
			if ( (attrmsg =(bl->fl[faeltnr].edit[i])(bl,faeltnr)) != 0)
				break;

	mfieldout();	/* displaya aendrade faelt */

	if ( attrmsg ) {
		putch(CTRL(G));	/* bell */
		invvid();
		cpouts(23,0,attrmsg);
		fieldbeg(faeltnr);
	}

	return(attrmsg);

}
/**/
/*********************************************************************
exitkoll - kontrollera ev. attribut naer ett faelt aer klart
returkod 0 eller adress till felmeddelandet
*********************************************************************/
char *exitkoll(field)
{
	int	i,j;
	int	last;		/* index till sista tecken i data */
	char	*data;		/* pekare till faeltets data */

	if ( !touch )
		return(0);

	last = bl->fl[field].len - 1;
	data = bl->fl[field].data;
	attrmsg = 0;

	/* right */
	if ( bl->fl[field].right ) {
		if ( data[last] == ' ' ) {
			for ( i = last ; data[i] == ' ' && i > 0 ; --i );
			if ( data[i] != ' ' ) {
				bl->fl[field].redisp = TRUE;
				j = last;
				while ( i >= 0 )
					data[j--] = data[i--];
				while ( j >= 0 )
					data[j--] = ' ';
			}
		}
	}


	/* centrate */
	if ( bl->fl[field].centrate ) {
		for ( j = last ; data[j] == ' ' && j > 0 ; --j ); /* sista ickeblanka */
		for ( i = 0 ; data[i] == ' ' && i < last ; ++i ); /* foersta ickeblanka */
		if ( i != last-j && i != last-j-1 ) {
			bl->fl[field].redisp = TRUE;
			if ( last-j > i ) {	/* knuffa aat hoeger */
				i = last - (last-j+i+1)/2;
				while ( j >= 0 )
					data[i--] = data[j--];
				while ( i >= 0 )
					data[i--] = ' ';
			} else {		/* knuffa aat vaenster */
				j = (last-j+i)/2;
				while ( i <= last )
					data[j++] = data[i++];
				while ( j <= last )
					data[j++] = ' ';
			}
		}
	}

	/* left */
	if ( bl->fl[field].left ) {
		if ( data[0] == ' ' ) {
			for ( i = 0 ; data[i] == ' ' && i < last ; ++i );
			if ( data[i] != ' ' ) {
				bl->fl[field].redisp = TRUE;
				j = 0;
				while ( i <= last )
					data[j++] = data[i++];
				while ( j <= last )
					data[j++] = ' ';
			}
		}
	}

	/* nospace */
	if ( bl->fl[field].nospace )
		for ( i = 0 ; i <= last ; ++i )
			if ( data[i] == ' ' )
				attrmsg = "blanktecken ej till}tna";

	/* exit-checkar */
	for ( i = 0 ; bl->fl[field].exit[i] != 0 && i < maxatt ; ++i )
		if ( (attrmsg = (bl->fl[field].exit[i])(bl,field)) != 0)
			break;

	mfieldout();	/* displaya aendrade faelt */

	if ( attrmsg ) {
		putch(CTRL(G));	/* bell */
		invvid();
		cpouts(23,0,attrmsg);
		fieldbeg(field);
	}

	if ( attrmsg == 0 )
		touch = FALSE;

	return(attrmsg);

}
/**/
/*********************************************************************
fieldout - displayar ett faelt
*********************************************************************/
fieldout(field)
{
	int	i;

	fieldbeg(field);
	cpos(bl->fl[field].rad,bl->fl[field].kol);
	for ( i = 0 ; i < bl->fl[field].len ; ++i )
		outc(bl->fl[field].data[i]);
}
/**/
/*********************************************************************
mfieldout - displayar de faelt som aer markerade foer det
*********************************************************************/
mfieldout()
{
	int	i;

	for ( i = 0 ; i < bl->faeltant ; ++i )
		if (bl->fl[i].redisp) {
			bl->fl[i].redisp = FALSE;
			fieldout(i);
		}
}
