/************************************************************************
 *									*
 *	Denna modul innehaaller syntaxchecken				*
 *									*
 *	rev.hist.							*
 *	840903	AN	orginal vers.					*
 *	850218	AN	rev 1.						*
 *									*
 ************************************************************************/

#include <stdio.h>
#include "ble.h"
#include "edit.h"

static	int	exitcnt;	/* index i bl.fl[].exit */
static	int	editcnt;	/* index i bl.fl[].edit */
static	FILE	*attrfile;	/* attributfil */

/**/
syntax(attr,bl,rfbuf)
char	*attr;
tbl	*bl;
trf	rfbuf;
{

int	errcode;	/* felkod att returnera till anropande rutin */
int	i,j;

	/* initiera attributen */
	for ( i = 0 ; i < maxfaelt ; ++i ) {
		bl->fl[i].auto_enter = FALSE;
		bl->fl[i].numeric = FALSE;
		bl->fl[i].right = FALSE;
		bl->fl[i].centrate = FALSE;
		bl->fl[i].inverse = FALSE;
		bl->fl[i].nospace = FALSE;
		bl->fl[i].left = FALSE;
		bl->fl[i].redisp = FALSE;
		for ( j = 0 ; j < maxatt ; ++j ) {
			bl->fl[i].edit[j] = 0;
			bl->fl[i].exit[j] = 0;
		}
	}

	/* nollstaell rfbuf (saa det blir avslutande null efter varje rubrik) */
	for ( i = 0 ; i < rfsize ; rfbuf[i++] = NULL );

	/*	oeppna attribut-filen */
	if ((attrfile = fopen(attr,"r")) == NULL)
		return(e_opattr);

	/*	syntaxcheck */
	errcode = syntaxcheck(bl,rfbuf);

	/*	staeng attribut-filen */
	fclose(attrfile);

	return(errcode);

}
/**/
/*********************************************************************

haer startar syntaxcheck-rutinerna
returnerar errorcode

*********************************************************************/

syntaxcheck(bl,rfbuf)
tbl	*bl;
trf	rfbuf;
{

int	i;
char	par[parsize];	/* array foer parametrar fraan attributfilen */
int	rkod;

	ble_rad = 1;
	bl->rubant = 0;
	bl->ruptr = rfbuf;

	/* laes foerst in mall-bilden */

	if ( ( rkod = getparm(par)) != r_ok )
		return(e_syntax+1);

	while ( rkod != r_eof && par[0] != 'i' ) {

		/* kontrollera att det inte finns */
		/* fler rubriker aen maxrub */

		if ( bl->rubant >= maxrub )
			return(e_rubant);

		/* kontrollera radnummer */

		if ( ( bl->ru[bl->rubant].rad = numkoll(par) ) == r_error )
			return(e_syntax+2);

		if ( bl->ru[bl->rubant].rad >= arkhojd )
			return(e_illrad);

		if ((rkod = getparm(par)) != r_ok)
			return(e_syntax+3);

		/* kontrollera kolumn */

		if ( ( bl->ru[bl->rubant].kol = numkoll(par) ) == r_error)
			return(e_syntax+4);

		if ( bl->ru[bl->rubant].kol >= arkvidd )
			return(e_illkol);

		rkod = getparm(par);
		if ( rkod != r_eol && rkod != r_ok )
			return(e_syntax+5);

		bl->ru[bl->rubant].text = rfbuf;

		/* kontrollera innehaallet */

		if (par[0] != '\0') {
			i = movetext(rfbuf,par,arkvidd-bl->ru[bl->rubant].kol);
			if (i == r_error)
				return(e_syntax+6);
			if (i == r_size)
				return(e_tolong);
		}

		while ( *rfbuf != '\0' )
			++rfbuf;
		++rfbuf;
		if ( rfbuf >= &bl->ruptr[rfsize] )
			return(e_rubovf);

		/* laes ev. foerbi ett avslutande semikolon */
		if ( rkod != r_eol )
			rkod = getparm(par);

		if ( rkod != r_eol )
			return(e_syntax+7);

		++ble_rad;

		if ((rkod = getparm(par)) == r_error)
			return(e_syntax+8);

		++bl->rubant;
	}

	/*	kontrollera input faelten */

	bl->dvptr = rfbuf;
	bl->fbuflen = 0;
	bl->faeltant = 0;

	if ((rkod = getparm(par)) != r_ok )
		return(e_syntax+9);

	++ble_rad;

	while ( rkod != r_eof ) {

		/* kontrollera att det inte finns */
		/* fler inputfaelt aen maxfaelt   */

		if ( bl->faeltant >= maxfaelt )
			return(e_inpant);

		/* kontrollera radnummer */

		if ( ( bl->fl[bl->faeltant].rad = numkoll(par) ) == r_error )
			return(e_syntax+10);

		if ( bl->fl[bl->faeltant].rad >= arkhojd )
			return(e_illrad);

		if ((rkod = getparm(par)) != r_ok)
			return(e_syntax+11);

		/* kontrollera kolumn */

		if ( ( bl->fl[bl->faeltant].kol = numkoll(par) ) == r_error )
			return(e_syntax+12);

		if ( bl->fl[bl->faeltant].kol >= arkvidd )
			return (e_illkol);

		if ( (rkod = getparm(par)) == r_error)
			return(e_syntax+13);

		/* kontrollera faeltlaengd */

		if ( ( bl->fl[bl->faeltant].len = numkoll(par) ) == r_error )
			return(e_syntax+14);

		if ( bl->fl[bl->faeltant].kol + bl->fl[bl->faeltant].len > arkvidd)
			return(e_illlen);


		/* nollstaell faeltets defaultvaerde */

		if ( &rfbuf[bl->fl[bl->faeltant].len] >= &bl->ruptr[rfsize] )
			return(e_dvalov);

		for ( i = 0 ; i < bl->fl[bl->faeltant].len ; rfbuf[i++] = ' ' );


		/* kontrollera attributfaelten */

		editcnt = 0;
		exitcnt = 0;

		while (rkod == r_ok) {
			if ((rkod = getparm(par)) == r_error)
				return(e_syntax+15);
			if (par[0] != '\0') {
				i = getattr(par,&bl->fl[bl->faeltant],rfbuf);
				if (i == r_error)
					return(e_syntax+16);
				if (i == r_size)
					return(e_deflen);
			}
		}

		if ((rkod = getparm(par)) == r_error)
			return(e_syntax+17);

		bl->fbuflen += bl->fl[bl->faeltant].len;
		rfbuf += bl->fl[bl->faeltant].len;

		++ble_rad;
		++bl->faeltant;

	}

	if ( bl->faeltant == 0 )
		return(e_noinp);

	bl->flptr = rfbuf;


	/* kontrolera overflow och nollstaell faeltbuffern */

	if ( &rfbuf[bl->fbuflen] >= &bl->ruptr[rfsize] )
		return(e_flovf);

	for ( i = 0 ; i < bl->fbuflen ; rfbuf[i++] = ' ' );

	/* initiera faeltpekarna */

	for ( i = 0 ; i < bl->faeltant ; ++i ) {
		bl->fl[i].data = rfbuf;
		rfbuf += bl->fl[i].len;
	}

	return (r_ok);

}
/**/
/************************************************************************/
/*	kontrollerar att det finns numeriska tecken i str		*/
/*	och returnerar det numeriska vaerdet,eller r_error vid fel	*/
/************************************************************************/
numkoll(str)
char	*str;
{
	int	val;

	val = 0;

	while ( *str >= '0' && *str <= '9' )
		val = val*10 + *str++ - '0';

	if ( *str == '\0' )
		return(val);
	else
		return(r_error);
}
/**/
/****************************************************************/
/*	analyserar ett attribut i raden "str" 			*/
/*	returnerar felkod eller "r_ok" om det gaar bra		*/
/****************************************************************/
getattr(str,fl,rfbuf)
char	*str;
tfaelt	*fl;
trf	rfbuf;
{
	int	rkod;

	switch (*str) {
	case '"' :
		if ( (rkod = movetext(rfbuf,str,fl->len)) != r_ok )
			return(rkod);
		break;
	case a_auto_enter :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->auto_enter = TRUE;
		break;
	case a_numeric :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->numeric = TRUE;
		break;
	case a_right :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->right = TRUE;
		break;
	case a_centrate :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->centrate = TRUE;
		break;
	case a_inverse :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->inverse = TRUE;
		break;
	case a_nospace :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->nospace = TRUE;
		break;
	case a_left :
		if ( str[1] != '\0' ) 
			return (r_error);
		fl->left = TRUE;
		break;
	case a_edit :
		if (editcnt >= maxatt )
			return (r_error);
		if ( (fl->edit[editcnt++] = findcheck(str) ) == 0 )
			return (r_error);
		break;
	case a_exit :
		if (exitcnt >= maxatt )
			return (r_error);
		if ( (fl->exit[exitcnt++] = findcheck(str) ) == 0 )
			return (r_error);
		break;
	default :
		return (r_error);
	}
	return (r_ok);
}
/**/
/************************************************************************/
/*	flyttar en straeng fraan source till dest, dock ej fler		*/
/*	tecken aen maxlen						*/
/************************************************************************/
movetext(dest,source,maxlen)
char	*dest,*source;
{
	int	i;
	char	c;
	int	blipp;


	if (*source++ != '"')
		return(r_error);

	blipp = 0;
	i = 0;

	while (FOREVER) {

		if ( (c = *source++) == '"')
			if ( blipp ) {		/* dubbel-blipp */
				dest[i++] = '"'; /* "" ==> " */
				blipp = 0;
			} else
				blipp = 1;
		else	
			if ( blipp )	/* enkel-blipp */
				if (c == NULL)
					return(r_ok); /* klart, allt ok */
				else
					return(r_error); /* " avslutar ej */
			else
				dest[i++] = c; /* flytta tecknet */

		if (i > maxlen)
			return(r_size);
	}

}
/**/
/************************************************************************/
/*	laeser tecken mellen tvaa ; fraan attributfilen			*/
/*	returnerar r_error,r_ok,r_eof och r_eol				*/
/************************************************************************/
getparm(line)
char	*line;
{
	int	count;
	int	c;

	count = 0;

	while (FOREVER) {
		if ( (c = getc(attrfile)) == EOF) {
			*line++ = '\0';
			return(r_eof);
		}
		if ( c == ';' ) {
			*line++ = '\0';
			return(r_ok);
		}
		if ( c == '\n' ) {
			*line++ = '\0';
			return(r_eol);
		}
		if ( count++ == (parsize-1) ) {
			return(r_error);
		}

		*line++ = c;


	}
}
