#define	CTRL(c)		('c' & 0x1F)

/*	FELKODER : */

#define	e_ok		0	/* ok */
/* initieringen : */
#define	e_noterm	1	/* STDIN aer ingen terminal */
#define	e_notenv	2	/* TERM environment variabel saknas */
#define	e_notety	3	/* terminaltypen saknas i termcap */
#define	e_tcbovf	4	/* TCB-buffer overflow */
#define	e_scrsiz	5	/* otillaatna screendimensioner i termcap */
#define	e_nocl		6	/* CL (clear screen) saknas i termcap */
#define	e_nocm		7	/* CM (cursor motion) saknas i termcap */
#define	e_ioctl		8	/* fel vid anrop av ioctl */
/* syntaxkontrollen : */
#define e_opattr	10	/* open av attributfilen */
#define	e_opdata	11	/* open av data filen */
#define	e_illrad	12	/* felaktigt radnummer, (0-22) */
#define	e_illkol	13	/* felaktig kolumn, (0-78) */
#define	e_illlen	14	/* felaktig faeltlaengd, (0-79) */
#define	e_noinp		15	/* inputfaelt saknas i attributfilen */
#define	e_dvalov	16	/* overflow i defaultvaerdena */
#define	e_deflen	17	/* defaultvaerde laengre aen faeltlaengd */
#define	e_inpant	18	/* foer maanga inputfaelt */
#define	e_tolong	19	/* straengen aer foer laang */
#define	e_rubovf	20	/* overflow i rubrikerna */
#define	e_rubant	21	/* foert maanga rubriker */
#define	e_flovf		22	/* overflow i faelten */
#define	e_syntax	100	/* syntax fel */

/* returkoder :*/
#define	r_error		(-1)	/* error */
#define	r_ok		0	/* ok */
#define	r_eol		1	/* end of line */
#define	r_eof		2	/* end of file */
#define	r_size		3	/* fel storlek */


/*	DIVERSE KONSTANTER : */

#define parsize		82	/* max antal tkn/parameter ( i attrfile ) */

#define	FOREVER		1	/* in while-loops */
#define	TRUE		1
#define	FALSE		0

#define	k_dum		CTRL(@)	/* dummy - do nothing */
#define	k_backch	CTRL(B)	/* backward char */
#define	k_delch		CTRL(D)	/* delete char */
#define	k_forwch	CTRL(F)	/* forward char */
#define	k_backsp	CTRL(H)	/* backspace */
#define	k_redraw	CTRL(L)	/* redraw screen */
#define	k_nextfield	CTRL(M)	/* next field (CR) */
#define	k_nextli	CTRL(N)	/* next line */
#define	k_prevli	CTRL(P)	/* previous line */
#define	k_quit		CTRL(Q)	/* quit */
#define	k_top		CTRL(T)	/* top of page */
#define	k_exit		CTRL(X)	/* exit */
#define	k_pf1		CTRL(\\)/* pf1 */
#define	k_pf2		CTRL(])	/* pf2 */
#define	k_pf3		CTRL(^)	/* pf3 */
#define	k_pf4		CTRL(_)	/* pf4 */

#define	delete		'\177'	/* delete */

/*	ATTRIBUTPARAMETRARNAS VAERDE I ATTRIBUTFILEN : */

#define	a_edit		'D'	/* edittime checkrutiner */
#define	a_exit		'X'	/* exit checkrutiner */
#define	a_auto_enter	'a'	/* automatiskt faeltbyte vid slut */
#define	a_numeric	'n'	/* bara numeriska tecken */
#define	a_right		'r'	/* hoegerjusterat */
#define	a_centrate	'c'	/* centrerat */
#define	a_inverse	'i'	/* inverse video */
#define	a_nospace	'f'	/* blanktecken ej tillaatna */
#define	a_left		'l'	/* vaensterjusterat */

/*	EXTERNALS */

extern	int	ble_rad;	/* rad i attrfilen vid syntaxfel */
extern	PFCP	findcheck();	/* edittime o exit-rutinerna */
extern	char	*help();	/* hjaelprutin */
