{$nolist}
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{ Name:         asynch1.int - Asynch Manager Level 1 interface  }
{                                                               }
{ Description:  This file declares all constants and functions  }
{               in Asynch Manager Level One                     }
{                                                               }
{ Version 1.0   (C) Copyright Blaise Computing Inc. 1984        }
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

TYPE
    str_arr	= packed array [1..1024] of byte;
    adsmem	= ^str_arr;

CONST
  COM1              =  1;              { Mnemonics for port }
  COM2              =  2;              { numbers }

  OK                =  0;              { Mnemonics for }
  INV_PORT          =  2;              { Level Zero return codes }
  PORT_NOT_OPEN     =  3;
  INV_PARAMETER     =  4;
  NO_PORT_FOUND     =  6;
  OUT_Q_FULL        =  7;
  PORT_OPEN_ALREADY =  9;
  IN_Q_EMPTY        = 10;

  INPUT_LOST        = 16#0001;           { Mnemonics for }
  ASYNCH_ERROR      = 16#0002;           { port status word bits }
  PARITY_ERR        = 16#0010;
  OVERRUN           = 16#0020;
  FRAMING           = 16#0040;
  BREAK_SIGNAL      = 16#0080;
  REM_XOFF          = 16#1000;
  REM_XON           = 16#2000;
  LOC_XOFF          = 16#4000;
  LOC_XON           = 16#8000;


function open_a1 (port_no       : int2;    { Open a COM port. }
                  iq_size       : int2;
                  oq_size       : int2;
                  int_level     : int2;
                  port_ads      : int2;
                  buf_ads       : adsmem)
         : int2; FORTRAN;

function close_a1(port_no       : int2)    { Close a COM port. }
         : int2; FORTRAN;

Function wrtch_a1(port_no       : int2;    { Write a character }
                  ch            : char)       { to a COM port. }
         : int2; FORTRAN;

Function wrtst_a1(port_no       : int2;    { Write a string to }
                  length        : int2;    { a COM port. }
                  str_ads       : adsmem;
                  var no_wrt    : int2)
         : int2; FORTRAN;

Function wrtbk_a1(port_no       : int2;    { Write a character }
                  upbound       : int2;    { block to a COM }
                  term_ch       : char;       { port. }
                  blk_ads       : adsmem;
                  var no_wrt    : int2)
         : int2; FORTRAN;

Function rdch_a1 (port_no       : int2;    { Read a character }
                  var ch        : char;       { from a COM port. }
                  var iqsize    : int2;
                  var pstatus   : word)
         : int2; FORTRAN;

Function rdst_a1 (port_no       : int2;    { Read a string }
                  length        : int2;    { from a COM port. }
                  str_ads       : adsmem;
                  var no_read   : int2;
                  var iqsize    : int2;
                  var pstatus   : word)
         : int2; FORTRAN;

Function rdbk_a1 (port_no       : int2;    { Read a character }
                  upbound       : int2;    { block from a COM }
                  term_ch       : char;       { port. }
                  blk_ads       : adsmem;
                  var no_read   : int2;
                  var iqsize    : int2;
                  var pstatus   : word)
         : int2; FORTRAN;

Function qsize_a1(port_no       : int2;    { Read an input }
                  var iqsize    : int2;    { queue size. }
                  var pstatus   : word)
         : int2; FORTRAN;

Function iflsh_a1(port_no       : int2)    { Flush an input }
         : int2; FORTRAN;                  { queue. }

Function oflsh_a1(port_no       : int2)    { Flush an output }
         : int2; FORTRAN;                  { queue. }

Function setop_a1(port_no       : int2;    { Set a transmis- }
                  option        : int2;    { sion option. }
                  parameter     : int2)
         : int2; FORTRAN;

Function retop_a1(port_no       : int2;    { Return a trans- }
                  option        : int2;    { mission option }
                  var parameter : int2)    { parameter. }
         : int2; FORTRAN;

Function break_a1(port_no       : int2)    { Send a break }
         : int2; FORTRAN;                  { signal. }

Function stat_a1 (port_no       : int2;    { Return the line }
                  var lstatus   : byte;       { and modem status. }
                  var mstatus   : byte)
         : int2; FORTRAN;

Function init_a1 (port_no       : int2;    { Initialize a COM }
                  baudrate      : int2;    { port via the }
                  parity        : int2;    { BIOS. }
                  stopbits      : int2;
                  wordlen       : int2;
                  var lstatus   : byte;
                  var mstatus   : byte)
         : int2; FORTRAN;

Function rcvch_a1(port_no       : int2;    { Receive a charac- }
                  var ch        : char)       { directly from a }
         : int2; FORTRAN;                     { COM port. }

Function sndch_a1(port_no       : int2;    { Send a character }
                  ch            : char)       { directly to a COM }
         : int2; FORTRAN;                     { port. }

Function time_a1                              { Time of day }
         : real; FORTRAN;

procedure wait_a1( seconds: real );	      { Suspend }
	  FORTRAN;                            { processing. }
{$list}
