{$nolist}
{*******************************************************}
{	includefile:	global.h			}
{	GLOBAL DECLARATIONS				}
{*******************************************************}

CONST
    PausMin	= 1;		{ Minimum pausetime }
    PausMax	= 1000.5;	{ Maximum pausetime}
    FileNameSize = 30;		{ Number of characters in filenames }

    NULL	= #0;
    BS		= #8;
    TAB		= #9;
    CR		= #13;
    ESC		= #27;

TYPE
	  	{ Existing menues }  
    Menu_t = (	MainMenu, SetupMenu, BatchMenu,
  		InteractiveMenu, EditMenu, DOS	);

		{ Existing function keys }
    Fkey_t = (	fk_1, fk_2, fk_3, fk_4, fk_5, fk_6, fk_7, fk_8,
		fk_9, fk_10, fk_up, fk_down, fk_left, fk_right,
		fk_ins, fk_del, fk_home, fk_end, fk_other );

    Fkey_set =	set of Fkey_t;

    Keytype_t = ( character, functionkey );	{ Type returned from ScanKbd }

    Mode_t = (	Main, Setup, Setup_GPIB, Setup_RS232, Setup_LogType, 
		BatchIdle, BatchSend, InteractiveIdle, InteractiveSend,
		Edit );

    MsgType_t	= ( AnswRec, SpoRec, UexRec, ErrRec );


{ ***** Strings ***** }

    str1 	= packed array [1..1] of char;
    str2 	= packed array [1..2] of char;
    str3 	= packed array [1..3] of char;
    str4 	= packed array [1..4] of char;
    str5 	= packed array [1..5] of char;
    str8 	= packed array [1..8] of char;
    str9 	= packed array [1..9] of char;
    str10 	= packed array [1..10] of char;
    str255 	= packed array [1..255] of char;

    lstr2 	= string[2];
    lstr3 	= string[3];
    lstr4 	= string[4];
    lstr5 	= string[5];
    lstr6 	= string[6];
    lstr8 	= string[8];
    lstr10	= string[10];
    lstr12	= string[12];
    lstr20	= string[20];
    lstr30	= string[30];
    lstr40	= string[40];
    lstr78	= string[78];
    lstr80	= string[80];
    lstr132	= string[132];
    lstr255	= string[255];

    FileName_str = string[FileNameSize];


{ **** Value types ***** }

    byte	= 0..255;
    word	= 0..65535;

    int2	= shortint;	{ 2 bytes integer }
    int4	= integer;	{ 4 bytes integer }

{ **** Batch commands ***** }

CONST
    BigValue		=  32767;	{ Used in BIG strings }
    MaxBatLineSize	=  800;		{ Max lenth of a line in batch file }

TYPE
    BatFileLine_t = packed array [1..MaxBatLineSize] of char;

    lstrX	= packed array [1..BigValue] of char;	{ Allocation of BIG }
    							{ dynamic strings   }
    lstrX_ptr	= ^lstrX;

    BaCmd_t = (
		bc_For, bc_Pause, bc_Stop, bc_Echo, bc_Log, bc_Next,
		bc_Remote, bc_missing, bc_comment, bc_TooManyAnswExp   );

    BaList_ptr = ^BaListRec_t;

    BaListRec_t = RECORD	{ A record in the linked command list }
	pnext	   : BaList_ptr;{ Pointer to next link in command list }
	Text	   : lstrX_ptr;	{ Text part of the batch file line }
	TextSize   : int2;	{ Length of Text }
	CASE BaCmd : BaCmd_t OF  { The batch command }
	    bc_Remote : (
		AnswExp	: int2;	{ Number of expected answers }
	    );
	    bc_For{..bc_Next} : (
		Arg1	: int2;	{ First (and only) argument on batch file line }
		ForNextPtr : BaList_ptr; { Corresponding FOR or NEXT }
		LoopCnt	: int2;	{ For-loop counter }
	    )
    END; { RECORD }


{ ***** Operator input ***** }

    OpInput_exp_t	= ( Cmd, Parm ); { What is expected from operator? }

    OpLineParm_rec = RECORD
    	Num	: int2;		 		{ Number of parameters (Txt) }
	Txt	: array [1..6] of lstr30; 	{ The parameters }
    END;

{ ***** Error types ***** }

    { Errors split into different types depending on which actions }
    { has to be performed }

    ErrType_t = ( BatSyntax, IntactSynt, BatchFileRead, EditFileRead,
                  EditFileWrite, LogFileWrite, Comm, MemAlloc, OpInput,
                  PgmInternal, PrnTimeout, PrnIo, Prn_desel,
                  Prn_OutOfPaper, Prn_busy ); 

    BatSyntErr_t = ( No_BatSyntErr, Illeg_char, Line_too_long, Unknown_cmd,
                     Parm_missing, Too_many_parms, Not_a_value,
                     Parm_out_of_range, Value_out_of_range,
                     ForNext_level, No_corresp_FOR_stmt,
                     Missing_NEXT_stmt, Too_many_answ_exp,
                     No_EndOfString_found ); 

		     					{ Comm. general }
    CommErr_t = ( No_CommErr, Invalid_msg, MsgTooLong, Timeout );

    OpErr_t = ( OpCmdOk, InvalidCmd, InvalidMode, InvalidFkey,
                TooFewParms, TooManyParms, InvalidParm ); { Operator command }

    PrintErr_t = ( No_PrintErr, PrintTimeout, Io, Deselected, Out_of_paper,
                   Busy ); 

    InternErr_t = ( One, The_other );

    FileErr_t = ( No_FileErr, InvalidFileName, FileOpen, FileRead, FileWrite,
                  NoStringEnd, IllegalCharacter, TooLongLine ); 

{ ***** Global variables ***** }

VAR
    BatchList		: BaList_ptr;	{ Pointer to the linked command list }
    BatchFileName	: FileName_str;		{ Name of batch file }
    BatchFile		: text;			{ Batch file }
    EditFileName	: FileName_str;		{ Name of interactive file }
    EditFile		: text;			{ Interactive file }
    LogFileName		: FileName_str;		{ Name of log file }
    LogFile		: text;			{ Log file }
    PrintOn		: boolean;		{ True if printer activated }
    TotTime		: int4;		{ Total test time in seconds }
    Menu		: menu_t;	{ Current menu }
    Mode		: mode_t;	{ Current mode (set of func. key's) }
    LastMode		: mode_t;	{ Last mode (set of function key's) }
    OpLineParm		: OpLineParm_rec;{ Operator command parameter area }
    Prompter		: lstr10;	{ Prompter displayed on op. cmd line }
    OpInput_exp		: OpInput_exp_t;{ Type of current part of the opline }

{$list}
