{$nolist}
{***************************************************************}
{	includefile: hpib.h					}
{	interface to HP-IB Command library for MS-DOS		}
{***************************************************************}

CONST
    noerr	= 0;
    eunknown	= 1;
    esel	= 2;
    erange	= 3;
    etime	= 4;
    ectrl	= 5;
    epass	= 6;
    enum	= 7;
    eaddr	= 8;
    UNL		= #63;		{ chr(63); }
    UNT		= #95;		{ chr(95); }
    TAD		= #64;		{ chr(64); }
    LAD		= #32;		{ chr(32); }


Function IOABORT (isc		: int4 )
				: int2;
	 FORTRAN;

Function IOCLEAR (dev_or_isc	: int4 )
				: int2;
	 FORTRAN;

Function IOCONTROL (isc		: int4;
                    condition	: int2;
                    status	: int2 )
				: int2;
	 FORTRAN;

Function IODMA  (isc		: int4;
		 count		: int2;
		 channel	: int2 )
				: int2;
	 FORTRAN;

Function IOENTERS (dev_or_isc	: int4;
                   VAR str	: univ lstrX;
                   VAR length	: int2 )
				: int2;
	 FORTRAN;

Function IOEOI (isc		: int4;
                eoistate	: int2 )
				: int2;
	 FORTRAN;

Function IOEOL (isc		: int4;
                VAR endline	: univ lstrX;
                length		: int2 )
				: int2;
	 FORTRAN;

Function IOGETTERM (isc		: int4;
                    VAR reason	: int2 )
				: int2;
	 FORTRAN;

Function IOLLOCKOUT (isc	: int4 )
				: int2;
	 FORTRAN;

Function IOLOCAL (dev_or_isc	: int4 )
				: int2;
	 FORTRAN;

Function IOMATCH (isc		: int4;
                  matchchar	: char;
                  enable	: int2 )
				: int2;
	 FORTRAN;

Function IOOUTPUTS (dev_or_isc	: int4;
                    VAR outstr	: univ lstrX;
                    length	: int2 )
				: int2;
	 FORTRAN;

Function IOREMOTE (dev_or_isc	: int4 )
				: int2;
	 FORTRAN;

Function IORESET (isc		: int4 )
				: int2;
	 FORTRAN;

Function IOSEND (isc		: int4;
                 VAR commands	: univ lstrX;
                 length		: int2 )
		 		: int2;
	 FORTRAN;

Function IOSPOLL (dev_or_isc	: int4;
                  VAR response	: int2 )
				: int2;
	 FORTRAN;

Function IOSTATUS (isc		: int4;
                   condition	: int2;
                   VAR status	: int2 )
				: int2;
	 FORTRAN;

Function IOTIMEOUT (isc		: int4;
                    timeout	: real )
				: int2;
	 FORTRAN;


{$list}

Procedure errstr (error		: int2;
		  var estring	: lstr40 );

begin
   case error of
	NoErr:	 estring := 'No error';
	EUnknown:estring := 'Unknown error';
	Esel:	 estring := 'Invalid select code or device address';
	ERange:	 estring := 'Value out of range';
	ETime:	 estring := 'Timeout';
	ECtrl:	 estring := 'HP-IB must be controller';
	EPass:	 estring := 'Pass control not permitted';
	ENum:	 estring := 'Invalid number';
	EAddr:	 estring := 'Improper addressing';
	otherwise
	    estring := ' What?';
   end;
end;
