{$nomain}
{***************************************************************}
{	This module contains routines performing the 		}
{	interactive commands.					}
{***************************************************************}

%Include 'global.h';
%Include 'turbodef.h';
%Include 'main.h';
%Include 'screen.h';
%Include 'kbd.h';
%Include 'opipret.h';
%Include 'inter.h';

{***************************************************************}
{	InteractiveInit:					}
{	Initiation of the interactive test.			}
{***************************************************************}

Procedure InteractiveInit;				{ Global }

BEGIN	{ InteractiveInit }


END;	{ InteractiveInit }

{***************************************************************}
{	CF_Intact_p:						}
{	The INTACT command. 					}
{***************************************************************}

Procedure CF_intact_p;				{ Global }

BEGIN	{ CF_intact_p }

    WriteWindow ( InteractiveIdle );
    Mode := InteractiveIdle;
    DisplayFKeys;
    Menu := InteractiveMenu;
    Display_IntactParms;

END;	{ CF_Intact_p }

{***************************************************************}
{	CF_SndOne_p:						}
{	The SndOne command. 					}
{***************************************************************}

Procedure CF_SndOne_p;				{ Global }

BEGIN	{ CF_SndOne_p }

    CposWrite ( 20, 35, 'cf_SndOne' );

END;	{ CF_SndOne_p }

{***************************************************************}
{	CF_SndBuf_p:						}
{	The SndBuf command. 					}
{***************************************************************}

Procedure CF_SndBuf_p;				{ Global }

BEGIN	{ CF_SndBuf_p }

    CposWrite ( 20, 35, 'cf_SndBuf' );

END;	{ CF_SndBuf_p }

{***************************************************************}
{	CF_Send_p:						}
{	The Send command. 					}
{***************************************************************}

Procedure CF_Send_p;				{ Global }

BEGIN	{ CF_Send_p }

    CposWrite ( 20, 35, 'cf_Send' );

END;	{ CF_Send_p }

{***************************************************************}
{	F_PrevLine_p:						}
{	The up arrow in interactive mode.			}
{***************************************************************}

Procedure F_PrevLine_p;				{ Global }

BEGIN	{ F_PrevLine_p }

    CposWrite ( 20, 35, 'F_PrevLine' );

END;	{ F_PrevLine_p }

{***************************************************************}
{	F_NextLine_p:						}
{	The down arrow in interactive mode.			}
{***************************************************************}

Procedure F_NextLine_p;				{ Global }

BEGIN	{ F_NextLine_p }

    CposWrite ( 20, 35, 'F_NextLine' );

END;	{ F_NextLine_p }

{***************************************************************}
{	CF_IntActStop_p:					}
{	The Stop command in Interactive mode.			}
{***************************************************************}

Procedure CF_IntActStop_p;			{ Global }

BEGIN	{ CF_IntActStop_p }

    CposWrite ( 20, 35, 'cf_IntActStop' );

END;	{ CF_IntActStop_p }

{***************************************************************}
{	InteractiveLoop:					}
{***************************************************************}

Procedure InteractiveLoop;			{ Global }

VAR
    ChFetched	: boolean;		{ Was there a character fetched? }
    Keytype	: Keytype_t;		{ What's in ch }
    ch		: char;			{ The character }

BEGIN	{ InteractiveLoop }

    REPEAT
	Scan_Kbd( ChFetched, Keytype, ch );
	IF ChFetched THEN BEGIN
	    Get_OpCmd( ChFetched, Keytype, ch );
	END;
    UNTIL Menu <> InteractiveMenu;

END;	{ InteractiveLoop }
