{ NOTICE OF COPYRIGHT AND OWNERSHIP OF SOFTWARE:

  Copyright 1977, 1978, 1979, 1980, 1981, 1982, 1983, 1985 by Oregon Software, 
  Inc.  All Rights Reserved.

  This computer program is the property of Oregon Software, Inc.
  of Portland, Oregon, U.S.A., and may be used
  and copied only as specifically permitted under written
  license agreement signed by Oregon Software, Inc.

  Whether this program is copied in whole or in part and whether this
  program is copied in original or in modified form, ALL COPIES OF THIS
  PROGRAM MUST DISPLAY THIS NOTICE OF COPYRIGHT AND OWNERSHIP IN FULL.

   Conformant array string routines.
   Release version: 0013 Level: 1  Date: 15-Sep-1986 12:07:10
   Processor: ALL  System: All
}

{

Declare string variables for this package with type declarations of the
form "packed array [0..n] of char", where n >= 1.  The length of the string
is stored in element 0, elements 1 to n are the characters of the string.
The routines will also accept parameters of type "packed array [1..n] of
char", in which case "n" is considered to be the length of the string.  In
particular, quoted strings in Pascal are considered to be of this type, and
may be intermixed with string variables when calling routines which don't
require "var" params.

The capabilities provided are:

Len(S) - a function giving the current length of string S;

Clear(S) - initializes string S to empty;

ReadString(F,S) - reads a value for string S from the text
  file F.  The string is terminated by Eoln(F) and a
  Readln(F) is performed.  String overflow (input data contains
  more characters than the target array can hold) results in truncation.

WriteString(F,S) - writes the string S to the text file F.

Concatenate(T,S) - appends string S to the target string T.
  The resulting value is string T.  Overflow results in
  truncation to StringMax characters.

Search(S,T,Start) - searches string S for the first
  occurrence of string T to the right of position Start
  (characters are numbered beginning with one).  The
  function Search() returns the position of the first
  character in the matching substring, or the value zero if
  the string T does not appear.

Insert(T,S,Start) - inserts the string S into the target
  string T at position Start.  Characters are shifted to the
  right as necessary.  Overflow produces a truncated target
  string;  a Start position which would produce a string
  which was not contiguous has no effect.

Assign(T,S) - Assign string S to the target string T.  Especially
useful for assigning a literal string to a variable string.

AssChar(T,C) - Assign character C to the target string T.
Especially useful for assigning a single character to a
variable string.

Equal(T,S) - Function Equal returns TRUE when T=S, returns
FALSE otherwise.

The Start and Span parameters in the following procedures
define a substring beginning at position Start (between
characters Start-1 and Start) with a length of Abs(Span).
If Span is positive, the substring is to the right of Start;
if negative, the substring is to the left.

DelString(S,Start,Span) - deletes the substring defined by
  Start, Span from the string S.

Substring(T,S,Start,Span) - the substring of string S
  defined by Start, Span is assigned to the target string T.

Leftstring(T,S,Last) - the substring of string S to the
  left of Last is assigned to target string T.

Rightstring(T,S,First) - the substring of string S to the
  right of First is assigned to target string T.
}
{[b+]}

procedure exitst(error: integer);

{ exit with status, forces abort of pascal program.
}
  external; {in the pascal library}


procedure abort(s: packed array [low..high: integer] of char);
	  EXTERNAL;
{ abort program if an illegal combination of arguments has been
  detected.
}

procedure writestring(var f: text; {an output file, we hope}
                      var s: packed array [slow..shigh: integer] of char);
	  EXTERNAL;
 { Write a string variable to file "f". }


procedure abort;
	  EXTERNAL;

function len(s: packed array [slow..shigh: integer] of char): integer;
	 EXTERNAL;

procedure clear(var s: packed array [low..high: integer] of char);
	  EXTERNAL;

procedure concatenate(var t: packed array [tlow..thigh: integer] of char;
                      s: packed array [slow..shigh: integer] of char);
	  EXTERNAL;

function search(s: packed array [slow..shigh: integer] of char;
                t: packed array [tlow..thigh: integer] of char;
                start: integer): integer;
	 EXTERNAL;

procedure readstring(var f: text; { an input file }
                     var s: packed array [slow..shigh: integer] of char);
	  EXTERNAL;

procedure substring(var t: packed array [tlow..thigh: integer] of char;
                    s: packed array [slow..shigh: integer] of char;
                    start, span: integer);
	  EXTERNAL;

procedure delstring(var t: packed array [tlow..thigh: integer] of char;
                    start, span: integer);
	  EXTERNAL;

procedure insert(var t: packed array [tlow..thigh: integer] of char;
                 s: packed array [slow..shigh: integer] of char;
                 p: integer);
	  EXTERNAL;

procedure assign(var t: packed array [tlow..thigh: integer] of char;
                 s: packed array [slow..shigh: integer] of char);
	  EXTERNAL;

procedure asschar(var t: packed array [tlow..thigh: integer] of char;
                  c: char);
	  EXTERNAL;

function equal(s1: packed array [s1low..s1high: integer] of char;
               s2: packed array [s2low..s2high: integer] of char): boolean;
	 EXTERNAL;

procedure leftstring(var t: packed array [tlow..thigh: integer] of char;
                     s: packed array [slow..shigh: integer] of char;
                     last: integer);
	  EXTERNAL;

procedure rightstring(var t: packed array [tlow..thigh: integer] of char;
                      s: packed array [slow..shigh: integer] of char;
                      first: integer);
	  EXTERNAL;
