{$nomain}
{*******************************************************}
{	Modulen innehaller kommandona FOR och NEXT	}
{	samt PAUSE-command.				}
{*******************************************************}

%Include 'global.h';
%Include 'synt.h';
%Include 'time.h';
%Include 'log.h';
%Include 'screen.h';

{*******************************************************}
{	FOR-command.					}
{*******************************************************}


Procedure Do_For  ( VAR	ptr	: Cmd_ptr;
			LinePart: linepart_t;
			Num   : int2 )    ; EXTERNAL;

VAR
    StartValueType	: elType;
    StartValue		: real;
    StartVariableName	: lstr10;
    StopValueType	: elType;
    StopValue		: real;
    StopVariableName	: lstr10;
    IdentifierName	: lstr10;
    IdentifierValue	: real;
    Step		: real;
    StepType		: elType;
    StepVariableName	: lstr10;

BEGIN	{ Do_For }

    StartValueType := LinePart[3].Type;
    IF StartValueType = Variable THEN BEGIN
	StartVariableName := LinePart[3].txt;
	StartValue := Get_VarValue ( StartVariableName ); END
    ELSE StartValue := LinePart[3].vaerde;

    IdentifierValue := StartValue;
    IdentifierName := LinePart[2].txt;
    Put_VarValue ( IdentifierName, IdentifierValue );

    StopValueType := LinePart[4].Type;
    IF StopValueType = Variable THEN BEGIN
	StopVariableName := LinePart[4].txt;
	StopValue := Get_VarValue ( StopVariableName ); END
    ELSE StopValue := LinePart[4].vaerde;

    IF Num = 5 THEN BEGIN
	StepType := LinePart[5].Type;
	IF StepType = Variable THEN BEGIN
	    StepVariableName := LinePart[5].txt;
	    Step := Get_VarValue ( StepVariableName ); END
	ELSE Step := LinePart[5].vaerde; END
    ELSE Step := 1;

    IF Step >= 0 THEN BEGIN
    	IF ( IdentifierValue - StopValue ) > 0.0005 THEN
	    ptr := ptr^.pjmp; END { IF }
    ELSE 
    	IF ( StopValue - IdentifierValue ) > 0.0005 THEN
	    ptr := ptr^.pjmp;

END;	{ Do_For }

{*******************************************************}
{	NEXT-command.					}
{*******************************************************}

procedure Do_Next ( VAR	ptr : Cmd_ptr ) ; EXTERNAL;

VAR
    LinePart		: linepart_t;
    Num		: int2;
    errcode		: error_t;
    StepType		: elType;
    Step		: real;
    StepVariableName	: lstr10;
    StopValueType	: elType;
    StopValue		: real;
    StopVariableName	: lstr10;
    IdentifierName	: lstr10;
    IdentifierValue	: real;

BEGIN	{ Do_Next }

    ptr := ptr^.pjmp;			{ Motsvarande FOR-kommando }
    SplitLine ( LinePart, Num, errcode, ptr^.txt );	{ dela upp raden }
    IF errcode <> NoError THEN
	DebugWriteLn ( 'Error in Do_Next' );		{ D }
    IF Num = 5 THEN BEGIN
	StepType := LinePart[5].Type;
	IF StepType = Variable THEN BEGIN
	    StepVariableName := LinePart[5].txt;
	    Step := Get_VarValue ( StepVariableName ); END
	ELSE Step := LinePart[5].vaerde; END
    ELSE Step := 1;

    IdentifierName := LinePart[2].txt;
    IdentifierValue := Get_VarValue ( IdentifierName );
    IdentifierValue := IdentifierValue + Step;
    Put_VarValue ( IdentifierName, IdentifierValue );

    StopValueType := LinePart[4].Type;
    IF StopValueType = Variable THEN BEGIN
	StopVariableName := LinePart[4].txt;
	StopValue := Get_VarValue ( StopVariableName ); END
    ELSE StopValue := LinePart[4].vaerde;

    IF Step >= 0 THEN BEGIN
    	IF ( IdentifierValue - StopValue ) > 0.0005 THEN
	    ptr := ptr^.pjmp; END { IF }
    ELSE 
    	IF ( StopValue - IdentifierValue ) > 0.0005 THEN
	    ptr := ptr^.pjmp;

END;	{ Do_Next }

{*******************************************************}
{	PAUSE-command.					}
{*******************************************************}

Function Pause ( ptr	 : Cmd_ptr;
		LinePart : linepart_t ) : int4 ; EXTERNAL;

VAR
    TimeValueType	: elType;
    TimeVarName	: lstr10;
    PauseTime	: int2;		{ Pauseens langd (i sekunder) }
    ErrParm	: ErrParmArea_t;	{ For Erraktiga parametrar }

BEGIN	{ Pause }

    TimeValueType := LinePart[2].Type;
    IF TimeValueType = Variable THEN BEGIN
	TimeVarName := LinePart[2].txt;
	PauseTime := Round ( Get_VarValue ( TimeVarName ) ); END
    ELSE PauseTime := Round ( LinePart[2].vaerde );

    IF ( Pausemin <= PauseTime ) AND ( PauseTime <= Pausemax ) THEN
	Pause := SecUsed + PauseTime	{ Utfor command }
    ELSE BEGIN			{ Logga den Erraktiga parametern }
	ErrParm[1].ParmType := TimeParm;
	ErrParm[1].Value := PauseTime;
	Log_ParmErr ( LinePart[1], ptr^.linenr, ErrParm, 1 );
	Pause := SecUsed;
    END; { ELSE }

END;	{ Pause }
