Program Main(input,output);

{***************************************************************}
{	Main program						}
{***************************************************************}

%Include 'global.h';
%Include 'turbodef.h';
%Include 'main.h';
%Include 'screen.h';
%Include 'kbd.h';
%Include 'opipret.h';
%Include 'setup.h';
%Include 'batch.h'; 
%Include 'inter.h';
%Include 'edit.h';
{ %Include 'log.h'; }

{VAR	{$own = 'Main' }

{***************************************************************}
{	Cf_Main_p:						}
{	MAIN command. Displays the main menu.			}
{***************************************************************}

Procedure Cf_Main_p;

BEGIN	{ Cf_Main_p }

    WriteWindow ( Main );
    Mode := Main;
    DisplayFKeys;
    Menu := MainMenu;

END;	{ Cf_Main_p }


{***************************************************************}
{	Startup:						}
{	Initiations.						}
{***************************************************************}

Procedure Startup;

BEGIN	{ Startup }

    ClrScr;
    CursOff;
    InitKbd;			{ Initiate keyboard variables }
    InitOpipret;		{ Initiate operator command interpreter }
    Ini_Setup;			{ Initiate setup parameters }
    WriteStdPic;		{ Write what is always on the screen }
    InteractiveInit;
    BatchInit;
    Cf_Main_p;			{ Display main menu }
    Prompter := '>';
    DisplayPrompt;

END;	{ Startup }

VAR
    ChFetched	: boolean;		{ Was there a character fetched? }
    Keytype	: Keytype_t;		{ What's in ch }
    ch		: char;			{ The character }

BEGIN	{ Main }

    Startup;
    REPEAT
	Scan_Kbd( ChFetched, Keytype, ch );
	IF ChFetched THEN BEGIN
	    Get_OpCmd( ChFetched, Keytype, ch );
	END;
	CASE Menu OF
	    SetupMenu : BEGIN
		SetupLoop;
		END;	{ SetupMenu }
	    BatchMenu : BEGIN
		BatchLoop;
		END;	{ BatchMenu }
	    InteractiveMenu : BEGIN
		InteractiveLoop;
		END;	{ InteractiveMenu }
	    EditMenu : BEGIN
		EditLoop;
		END; 	{ EditMenu }
	    OTHERWISE BEGIN		{ Main or DOS }
		END;
 	END; { CASE }
    UNTIL Menu = DOS;			{ Terminate program }

    ClrLine (25);
    GotoXY (1,24);
    CursOn;

END. { Main }
