{ NOTICE OF COPYRIGHT AND OWNERSHIP OF SOFTWARE:

  Copyright 1986 by Oregon Software, Inc.
  All Rights Reserved.

  This computer program is the property of Oregon Software, Inc.
  of Portland, Oregon, U.S.A., and may be used
  and copied only as specifically permitted under written
  license agreement signed by Oregon Software, Inc.

  Whether this program is copied in whole or in part and whether this
  program is copied in original or in modified form, ALL COPIES OF THIS
  PROGRAM MUST DISPLAY THIS NOTICE OF COPYRIGHT AND OWNERSHIP IN FULL.

  Release version: 0013  Level: 1
  Processor: iAPX-86
  System: ms-dos

  Pascal-2 Run Time Support Library Module for MS-DOS.

 Last modified by JAN on 15-Sep-1986 12:35:05
 Purpose:
Update before General Release.
}

type
  pChar = ^char;

  ErrorType = (NOERR, PANIC, NOMEM, SUBSCR, OVRFLO, UNDRFL, DIVZER, NUMERR,
               SQRTER, LNERR, EXPERR, LOGERR, BADSW, CNTOPN, DEFNAM, DEFSWI,
               FILNAM, ISOPN, TOOMNY, FILEND, GETERR, PUTERR, INTOVR, NEWOF0,
               DDEAL, BADINT, BADSET, BADPTR, FILERR, FPPERR, SEEK0, NOTRND,
               TRAP10, NOTOPN, BADVER, NILPTR, STOVFL, SUBRNG, CASERR, DISNIL,
               BADDIS, INCREC, CNTDEL, CNTREN, STROVR, LCKERR, NOREAD, NOWRIT,
               INIERR, NOFMEM, PUTEOF);

  wordregs =
    record
      ax, bx, cx, dx, si, di, ds, es: 0..65535;
      cflag, wspare: boolean;
    end;
  byteregs =
    packed record
      al, ah, bl, bh, cl, ch, dl, dh: 0..255;
    end;
  regs =
    record
      case boolean of
        true:
          (w: wordregs);
        false:
          (b: byteregs);
    end;


procedure timestamp(var day, month, year, hour, min, sec: integer);

  external;


function p_ticks: shortint;

  external;


function p_ToLower(ch: char): char;

  external;


function space: integer;

  external;


procedure exitst(stat: integer);

  external;


procedure GetPos(var F: univ text;
                 var Block, Offset: integer);
  external;


procedure SetPos(var F: univ text;
                 Block, Offset: integer);
  external;


procedure p_lock(var f: univ text;
                 startnr, count: integer);

  external;


procedure p_unlock(var f: univ text;
                   startnr, count: integer);

  external;


procedure p_truncate(var f: univ text);

  external;


function p_FileSize(var f: univ text): integer;

  external;


procedure p_rdsfst(var f: text;
                   var ptr: univ pChar;
                   var len: integer);

  external;


procedure p_ctoi(function nextch: char;
                 var val: integer;
                 var err: ErrorType);
  external;


procedure p_ctof(function nextch: char;
                 var val: real;
                 var errorcode: ErrorType);
  external;


procedure p_ctod(function nextch: char;
                 var val: real;
                 var errorcode: ErrorType);
  external;


procedure p_itoc(procedure putch(ch: char);
                 val: integer;
                 width: ShortInt);
  external;


procedure p_ftoc1(procedure putf(ch: char);
                  value: real;
                  TotalWidth: ShortInt);
  external;


procedure p_ftoc2(procedure putf(ch: char);
                  value: real;
                  TotalWidth: ShortInt;
                  Fracdigits: ShortInt);
  external;


procedure p_dtoc1(procedure putf(ch: char);
                  value: real;
                  TotalWidth: ShortInt);
  external;


procedure p_dtoc2(procedure putf(ch: char);
                  value: real;
                  TotalWidth: ShortInt;
                  Fracdigits: ShortInt);
  external;


procedure p_new(var p: univ pChar;
                size: ShortInt);

  external;


function p_inew(size: ShortInt): pChar;

  external;


procedure p_dispos(var p: univ pChar;
                   size: ShortInt);

  external;


procedure p_getcmdline(var line: packed array [l..h: shortint] of char;
                       var length: shortint);
  external;


procedure p_getenv(n: shortint;
                   var str: packed array [l..h: shortint] of char;
                   var len: shortint);

  external;


function p_exec(command: packed array [l..h: shortint] of char;
                len: shortint; {length of valid data}
                musttrypath: boolean; {use pathname if needed}
                mustask: boolean {ask a filename} ): shortint;
  external;


procedure p_intdos(var inregs, outregs: regs);

  external;


procedure p_int86(int: shortint;
                  var inregs, outregs: regs);

  external;

{ The next three procedure cannot be called by user programs.
  Instead these procedures are used in the library but the user
  can specify his own versions.  Those procedures will than
  be used in stead of the versions in the library.
}

type
  ErrorClass = (Fatal, FatalIO, Warn);
  ErrorMsg = packed array [1..1000] of char;


procedure Error(class: ErrorClass;
                typ: integer;
                MsgLen: integer;
                var Msg: ErrorMsg;
                var f: univ text;
                IOStatus: integer;
                userpc: integer;
                NamLen: integer;
                var Nam: ErrorMsg);
  external;


procedure p_userinit;
  external;


procedure p_userexit;
  external;
