program Pointertest;
{$nopointercheck}

{$nolist}
%include p2memdef.pas
{$list}

TYPE
    var_type = char;
    address  = 0..4294967295;
    pointer  = pMem;
    lstr255  = string[255];
    relptr   = ^real;
    intptr   = ^integer;
    strptr   = ^lstr255;

VAR
    a,b,c,d : var_type;
    Buffer  : lstr255;
    BufLen  : shortint;
    ib      : shortint;
    rpnt    : relptr;
    ipnt    : intptr;
    spnt    : strptr;
    rel     : real;
    int     : integer;

Function Increment_pointer( ptr : pointer; step : shortint ) : pointer;

BEGIN

    Increment_pointer := Loophole( pointer, Loophole(address, ptr) + step ); 

END;

Procedure DumpMemory(Start, Finish : pointer);

VAR
    p : pointer;

BEGIN	{ DumpMemory }

    p := Start;
    WHILE Loophole( address, p) <= Loophole( address, Finish) DO BEGIN
        Writeln( Loophole( address, p ): -8, ':', p^: -8 );
	p := Increment_Pointer( p, 1 );
    END;

END;	{ DumpMemory }

Procedure DumpBuffer(Bufptr : pointer; Length : shortint);

VAR
    i : shortint;
    p : pointer;

BEGIN	{ DumpBuffer }

    p := Increment_Pointer( Bufptr, 1 );
    FOR i := 1 TO Length DO BEGIN
        Writeln( p^, ' ', Ord( p^ ): -3 );
	p := Increment_Pointer( p, 1 );
    END;

END;	{ DumpBuffer }
        
BEGIN	{ Pointertest }

    a := '1';    
    b := '2';    
    c := '5';    
    d := 'A';
    BufLen := 255;
    DumpMemory( Ref( a ), Ref( d ) );
    FOR ib := 1 TO BufLen DO
        Buffer[ib] := Chr(ib);
    rpnt := Ref(rel);
    ipnt := Ref(int);
    spnt := Ref(Buffer);
    DumpBuffer( Loophole(pointer,spnt), BufLen );

END.	{ Pointertest }
