{***************************************************************}
{	This module contains routines calling Asynch Manager.	}
{	(Communication through RS232.)				}
{***************************************************************}

%Include 'global.h';
%Include 'time.h';
%Include 'asynch.h';
%Include 'screen.h';

{*******************************************************}
{	Rs232Send.					}
{	Sends commands to remote.			}
{*******************************************************}

Procedure Rs232Send( str255 );

VAR
    Status	: integer;

BEGIN	{ Rs232Send }

    Status := WrtBk_a1( COM1, MaxCharsOut, CR, OutBuf_Ads, No_Wrt );
    IF Status <> OK THEN Rs232RetCodeHandler( Status );

END;	{ Rs232Send }

{***************************************************************}
{	Rs232CharsAvail:					}
{	Checks if there are any characters available.		}
{***************************************************************}

Procedure Rs232CharsAvail;				{ Global }

BEGIN	{ Rs232CharsAvail }

    Status := Qsize_a1( COM1, iqsize, pstatus );	{ l{s av status }
    IF Status = OK THEN BEGIN
###    	Rs232CharsAvail := IqSize <> 0;
    END ELSE BEGIN
    	Rs232RetCodeHandler( Status );
    END;

END;	{ Rs232CharsAvail }

{***************************************************************}
{	Rs232Read:						}
{	Reads the characters available.				}
{***************************************************************}

Procedure Rs232Read;				{ Global }

CONST
    STX		= CHR(2);
    PStatusMask	= 16#00FF;

VAR
    Status	: integer;	{ Funktions-status }
    Iqsize	: integer;	{ Antal tecken i bufferten }
    PStatus	: word;		{ Kommunikations-status }

BEGIN	{ Rs232Read }

    Status := RdBk_a1( COM1, MaxCharsIn, CR, InBuf_Ads,
    		       No_read, IqSize, PStatus		);
    PStatus := PStatus AND PStatusMask;
    IF ( Status = OK ) AND ( PStatus = 0 ) THEN
    	Protokoll;

    PortStatus := Ord( PStatus );

END;	{ Rs232Read }
