{$nomain}
{***************************************************************}
{	This module contains "time routines".			}
{***************************************************************}

%Include 'global.h';
%Include 'screen.h';
%Include 'asynch.h';

VAR
    Latest_Num_Sec : int4; { Latest "Number of seconds since 00:00" }
    Latest_SecUsed : int4; { Latest "Used test time" in seconds }

Procedure Date   ( VAR	s : string   ); EXTERN;
Procedure Time   ( VAR	s : string   ); EXTERN;

{***************************************************************}
{	SweDate:						}
{	Gets "Swedish" date.					}
{***************************************************************}

Function SweDate	: str9;		{ Global }

VAR
    TmpDat	: str8;

BEGIN	{ SweDate }

    Date( TmpDat );
    CopyStr( TmpDat, SweDate );

    SweDate[1] := TmpDat[7];	{ Year }
    SweDate[2] := TmpDat[8];

    SweDate[4] := TmpDat[1];	{ Month }
    SweDate[5] := TmpDat[2];

    SweDate[7] := TmpDat[4];	{ Day }
    SweDate[8] := TmpDat[5];

END;	{ SweDate }

{***************************************************************}
{	SecUsed:						}
{	Gets used test time in seconds.				}
{***************************************************************}

Function SecUsed : int4;		{ Global }

VAR
    Num_sec	: int4;
    TimeDiff	: int4;
    ReVal	: real;

BEGIN	{ SecUsed }

    ReVal := Time_a1;
    Num_sec := RoundX( ReVal );
    TimeDiff := Num_sec - Latest_Num_Sec;
    IF TimeDiff < 0 THEN TimeDiff := TimeDiff + 86400;	{ New day }
    Latest_Num_Sec := Num_sec;
    Latest_SecUsed := Latest_SecUsed + TimeDiff;
    SecUsed := Latest_SecUsed;

END;	{ SecUsed }

{***************************************************************}
{	Display_Time_Left:					}
{	Writes how much is left of a batch test.		}
{***************************************************************}

Procedure Display_Time_Left;				{ Global }

BEGIN	{ Display_Time_Left }


END;	{ Display_Time_Left }

{***************************************************************}
{	IniTime							}
{	Initiation of time variables.				}
{***************************************************************}

Procedure IniTime;		{ Global }

VAR
    ReVal	: real;

BEGIN	{ IniTime }

    ReVal := Time_a1;
    Latest_Num_Sec := RoundX( ReVal );	{ Starttime }
    Latest_SecUsed := 0;
    Display_Time_Left;

END;	{ IniTime }

{***************************************************************}
{	TimeUsed:						}
{	Gets used test time in hours, minutes and seconds.	}
{***************************************************************}

Function TimeUsed : str9;		{ Global }

VAR
    TimePart	: lstring(2);
    TotSec	: int4;
    Hours	: int4;
    Min		: int4;
    Sec		: int4;

BEGIN	{ TimeUsed }

    TotSec := SecUsed;
    Hours := TotSec DIV 3600;
    TotSec := TotSec - Hours * 3600;
    Min := TotSec DIV 60;
    TotSec := TotSec - Min * 60;
    Sec := TotSec;

    Str( Hours :2, TimePart );
    IF TimePart[1] = ' ' THEN TimePart[1] := '0';
    TimeUsed[1] := TimePart[1];
    TimeUsed[2] := TimePart[2];
    TimeUsed[3] := ':';
    Str( Min :2, TimePart );
    IF TimePart[1] = ' ' THEN TimePart[1] := '0';
    TimeUsed[4] := TimePart[1];
    TimeUsed[5] := TimePart[2];
    TimeUsed[6] := ':';
    Str( Sec :2, TimePart );
    IF TimePart[1] = ' ' THEN TimePart[1] := '0';
    TimeUsed[7] := TimePart[1];
    TimeUsed[8] := TimePart[2];
    TimeUsed[9] := ' ';

END;	{ TimeUsed }
