H{r beskrivs kort vad som g|rs i varje rutin, modul f|r modul.

%title 3        chknov.src

CHKNOV
------

Beskrivning : Kopierar inneh}llet i promdelen av novram till
              ramdelen. Kontrollerar att det {r detsamma som
              skrevs i novram av SETNOV (i modul setnov).
              Anropar PUTCHR och PUTNUM f|r att skicka
              testresultatet. 

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        enable.src

ENABLE
------

Beskrivning : Ser till att transmit-interrupt {r enablat. Tittar
              om SIO'n kan ta emot ett tecken och anropar i s}
              fall TRMCHR f|r s{ndande av ett tecken. 

Anropas fr}n: 1) PUTCHR i modul putchar n{r ett tecken har lagts
                 i transmit-bufferten, om ett XON mottagits. 
              2) RECIRQ i modul recirq, om ett XON mottagits.

Globala variabler som {ndras: TXIRQS


%title 3        fixprom.src

FIXPROM
-------

Beskrivning : Ser till att checksumman i prom kommer att bli
              0000. Rutinen anv{nds endast vid skapandet av den
              exekverbara filen. D{rf|r l{ggs rutinen p} ram-
              adresserna och exekveras efter l{nkning i BSO
              Symbolic Debugger. Fungerar p} s} vis att 16-bit-
              summan i anv{nd del av prom-adresserna r{knas fram
              och d{refter l{ggs ett kompensationsv{rde p}
              adress CHKSUM (i modul startup). 

Anropas fr}n: Batch-filen som sk|ter l{nkningen, n{r man
              befinner sig i debuggern. 
%page
%title 3        insig.src

INSIG
-----

Beskrivning : L{ser p} beg{rd port. Anropar PUTCHR och PUTNUM
              f|r att skicka l{st v{rde.

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        ipret.src

MAIN
----

Beskrivning : H{r finns mainloopen i vilken man ligger och
              tittar om det finns n}got tecken i receive-
              bufferten. N{r det finns tecken, kollas om det
              finns s} pass gott om plats i bufferten att det {r
              dags att skicka XON. I s} fall s{tts XONFLG f|r
              att tala om att n{sta g}ng n}got skall skickas
              till PC'n, skall det vara XON. 

Anropas fr}n: Modul startup.

Globala variabler som {ndras: NCHRRX, PARAM, PARAMP, RXTALP,
                              STXFLG, XONFLG 


WDOGR
-----

Beskrivning : Skriver p} watchdog-porten f|r att watchdog inte
              ska l|sa ut. 

Anropas fr}n: MAIN (i denna modul.)


%title 3        outsig.src

OUTSIG
------

Beskrivning : Skriver beg{rt data p} beg{rd port. Anropar PUTCHR
              f|r att skicka svar.

Anropas fr}n: CHRCHK i modul tknkoll.
%page
%title 3        promtest.src

PRMTST
------

Beskrivning : Adderar alla bytes i anv{nd del av prom, tv} och
              tv}. Anropar PUTCHR och PUTNUM f|r att skicka
              resultatet. 

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        putchar.src

PUTCHR
------

Beskrivning : L{gger ett tecken i transmit-bufferten(, efter att
              eventuellt ha v{ntat p} att tecknet ska f} plats,)
              och justerar buffertpekarna. Om PC'n inte skickat
              ett XOFF anropas ENABLE. 

Anropas fr}n: 1) CHKNOV, INSIG, OUTSIG, PRMTST, RAMTST, RSTTST,
                 SETNOV, SIOTEST och WDGTST f|r s{ndande av STX
                 och kommandot.
              2) PUTNUM f|r s{ndande av retur-parametrar.

Globala variabler som {ndras: NCHRTX, TXBUFF, TXHEDP


%title 3        putnum.src

PUTNUM
------

Beskrivning : Tar emot en byte och konverterar inneh}llet i
              denna till tv} ASCII hex-tecken. Anropar sedan
              PUTCHR f|r vart och ett av tecknen. 

Anropas fr}n: CHKNOV, INSIG, PRMTST, RAMTST, RSTTST, SIOTEST och
              WDGTST f|r konvertering av retur-parametrar.
%page
%title 3        ram.src

H{r finns de globala variablerna deklarerade. En special-rutin
som exekveras i ram finns ocks} h{r: 

EIRETI
------

Beskrivning : Enablar interrupt och g|r return fr}n interrupt-
              rutin. Anledningen till att den finns h{r {r att
              n{r programmet k|rs med Mice 1 (, emulator), {r
              man tvungen att g|ra p} det h{r viset.

Anropas fr}n: ASPCRXIRQ, BSPCRXIRQ och DUMIRQ i modul startup.
              RECIRQ i modul recirq och TRMIRQ i modul trmirq. 


%title 3        ramtest.src

RAMTST
------

Beskrivning : Kontrollerar att adresserna {r ram-adresser och
              olika. Om b}da adresserna = 0 s{tts de till f|rsta
              och sista i ram (8000-87FF). Om riktiga adresser
              anropas TEST, annars s{tts returparametern till
              att tala om att dessa var felaktiga. PUTCHR och
              PUTNUM anropas f|r att skicka svar med retur-
              parameter. 

Anropas fr}n: CHRCHK i modul tknkoll. 


TEST
----

Beskrivning : Kontrollerar att ram fungerar mellan beg{rda
              adresser. 

              Testen utf|rs i 3 olika steg. Om fel uppt{cks i
              n}got av deltesten g}r man direkt till n{sta test. 

              1) Adresstest: I ram skrivs ett m|nster som sedan
              kontrolleras. Vid fel s{tts bit 0 i felmarkerings-
              registret.

              2) Vandrande etta: F|rst nollst{lls ram. F|r en
              byte i taget s{tter man sedan en bit i taget och
              kontrollerar att inga andra bitar i byten {r
              satta. Vid fel s{tts bit 1 i felmarkerings-
              registret.

              3) Vandrande nolla: Som "Vandrande etta".
              Fast tv{rtom.
              Vid fel s{tts bit 2 i felmarkerings-registret.

              Efter utf|rt test anropas: INIRAM i modul startup,
              f|r ny initiering av ram. Felmarkeringsregistret
              blir returparameter. 

Anropas fr}n: RAMTST i denna modul. 

Globala variabler som {ndras: Vid test av ram f|rst|rs
              inneh}llet i alla variabler, och variablerna
              initieras p} nytt. Efter initiering av ram, s{tts
              dock TSTFLG till true. 


%title 3        recirq.src

RECIRQ
------

Beskrivning : Receive-interrupt-rutin. Plockar tecken fr}n SIO'n
              p} A-kanalen. Om tecknet {r XON eller XOFF anropas
              ENABLE respektive disablas transmit-interrupt. Om
              inte, l{ggs det i receive-bufferten. Om receive-
              bufferten b|rjar bli full s{tts XOFFLG f|r att
              tala om att n{sta g}ng n}got skall skickas till
              PC'n, skall det vara XOFF. 

Anropas fr}n: (SIO'n.)

Globala variabler som {ndras: NCHRRX, RXBUFF, RXHEDP, RXSTAT,
              TXIRQS, TXSTAT, XOFFLG 


%title 3        resettest.src

RSTTST
------

Beskrivning : Skriver 'RE' p} ett visst st{lle i ram och skriver
              sedan p} en viss port f|r reset av kortet. Om
              reseten inte fungerade anropas PUTCHR och PUTNUM
              f|r att skicka det negativa svaret. Om reseten
              fungerat, tas det om hand i startup.

Anropas fr}n: CHRCHK i modul tknkoll. 

Globala variabler som {ndras: STATUS

OBS! Ej implementerad {nnu.
%page
%title 3        setnov.src

SETNOV
-----

Beskrivning : Skriver ett visst m|nster i ramdelen av novram och
              kopierar detta till promdelen. Anropar PUTCHR f|r
              att skicka svar. 

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        siotest.src

SIOTEST
-------

Beskrivning : Skickar ett tecken till sig sj{lv p} B-kanalen. Om
              inget mottaget s{tts bit 0 i felmarkerings-
              variabeln. Om fel tecken mottagits s{tts bit 1. P}
              samma s{tt g|rs sedan med komplementet till
              tecknet. En kontroll av DTR, RTS, CTS och DCD p}
              b}da kanalerna g|rs med hj{lp av SIGNALTEST. Man
              tittar h{r om CTS och DCD har haft den status som
              f|rv{ntats. Om inte, s{tts f|r kanal A: CTS bit 2,
              DCD bit 3, kanal B: CTS bit 4 och DCD bit 5 i
              felmarkerings-variabeln. PUTCHR och PUTNUM anropas
              f|r att skicka svar inneh}llande felmarkerings-
              variabeln. 

Anropas fr}n: CHRCHK i modul tknkoll. 


SIGNALTEST
----------

Beskrivning : S{tter upp DTR och RTS enligt en tabell och
              kontrollerar CTS och DCD mot en annan tabell.Detta
              g|rs med alla fyra kombinationer av upps{ttningen
              av DTR och RTS.

Anropas fr}n: SIOTEST i denna modul. 

%page
%title 3        startup.src

Huvudrutinen
------------

H{r b|rjar programmet exekveras (, adress 0).

Beskrivning : Upps{ttning av stackpekare, initiering av ram (i
              INIRAM), upps{ttning av CTC , upps{ttning av SIO
              med hj{lp av LDCW. H{r g|rs ocks} en kontroll av
              anledningen till start av programmet. Programmet
              kan ha startats om efter ett watchdogtest eller
              resettest(, det senare dock ej implementerat
              {nnu,). Detta uppt{cks genom att respektive test
              har l{mnat ett par tecken i variabel STATUS. Om
              det visar sig vara s} skickas svar p} detta test
              med hj{lp av PUTCHR. 

Anropas fr}n: (WDGTST, RSTTST)

Globala variabler som {ndras: STATUS


INIRAM
------

Beskrivning : Globala variablerna s{tts upp till sina
              startv{rden och rutinen EIRETI skapas.

Anropas fr}n: Huvudrutinen i denna modul och TEST i modul
              ramtest.src. 

Globala variabler som {ndras: Alla.


LDCW
----

Beskrivning : S{tter upp SIO'n med hj{lp av ett par tabeller. 

Anropas fr}n: Huvudrutinen i denna modul.


ASPCRXIRQ
---------

Beskrivning : Interruptrutin som tar hand om parity, receiver
              overrun och framing error p} A-kanalen. G|r en
              error reset och plockar tecknet ur SIO'n. 

Anropas fr}n: (SIO'n.)
%page
BSPCRXIRQ
---------

Beskrivning : Likadan som ASPCRXIRQ fast f|r B-kanalen.

Anropas fr}n: (SIO'n.)


DUMIRQ
------

Beskrivning : Tar hand om ointressanta interrupt fr}n SIO'n.
              (G|r ingenting.) 

Anropas fr}n: (SIO'n.)


%title 3        tknkoll.src

CHRCHK
------

Beskrivning : Hit kommer man efter att ha hittat ett STX i
              receivebufferten, d.v.s. n{r ett meddelande {r p}
              g}ng. Denna rutin tolkar tecknen efter ett STX,
              d.v.s. sorterar ut parametrar och kommandon och
              anropar aktuellt test. Hittas ett odefinierat
              tecken }terg}r man till att v{nta p} nytt
              meddelande.

Anropas fr}n: MAIN i modul ipret.

Globala variabler som {ndras: PARAM, PARAMP, STXFLG


%title 3        trmchr.src

TRMCHR
------

Beskrivning : Tittar om det {r dags att skicka XON/XOFF, disabla
              transmit-interruptet och om det finns n}got i
              transmit-bufferten att skicka, g|rs detta p}
              SIO'ns A-kanal. 

Anropas fr}n: 1) ENABLE efter enablande av transmit-interrupt.
              2) TRMIRQ vid transmit-interrupt. 

Globala variabler som {ndras: NCHRTX, TXIRQS, TXTALP, XOFFLG,
              XONFLG 
%page
%title 3        trmirq.src

TRMIRQ
------

Beskrivning : Transmit-interrupt-rutinen. Anropar TRMCHR i modul
              trmchr. 

Anropas fr}n: (SIO'n.)


%title 3        wdogtest.src

WDGTST
------

Beskrivning : Skriver 'WA' p} ett visst st{lle i ram och l{gger
              sig sedan i en loop och v{ntar i ca 25 sekunder.
              (En watchdog-reset b|r ha kommit efter ca 20
              sekunder.) Om reseten inte fungerade anropas PUTCHR
              och PUTNUM f|r att skicka det negativa svaret. Om
              reseten fungerat, tas det om hand i startup. 

Anropas fr}n: CHRCHK i modul tknkoll. 

Globala variabler som {ndras: STATUS
