%lines 61
%lang swe
%head 2
Programbeskrivning MDDM: Testsystem MDDM/Controller (TMC)
Rev 1.0 / 86-10-14      IND AB / AN o LOS
%pos_page 61
%margin_text 6
%margin_title 2
%margin_head 2
%pos_title 14
%rest 3

Inneh}llsf|rteckning

%title 1        Filf|rteckning

AFIL            : Inneh}ller de filer som skall assembleras.
ASS.ABS         : Abstraktkod f|r assemblerdelarna.
ASS.COM         : Assemblerar en fil.
BATCH.COM       : Assemblerar alla filer i AFIL.
CHKNOV.SRC      : Kontrollerar att det som skrevs i NOVRAM {r
                  of|r{ndrat. 
ENABLE.SRC      : Enablar transmit-interrupt och anropar TRMCHR.
FILER.ASS       : Denna filf|rteckning.
FIXPROM.SRC     : Fixar med hj{lp av debuggern till checksumman
                  i prommet till 0000. 
INSIG.SRC       : L{ser p} en port.
IPRET.SRC       : H{mtar tecken fr}n rx-buffert.
OUTSIG.SRC      : Skriver p} en port.
PROMTEST.SRC    : Kontrollerar att PROM har checksumma 0000.
PUTCHAR.SRC     : L{gger tecken i tx-buffert.
PUTNUM.SRC      : Omvandlar returparametrarna till hex-tkn och
                  anropar PUTCHAR. 
RAM.SRC         : Variabeldeklaration.
RAM.VAR         : Talar om i vilka moduler variablerna anv{nds.
RAMTEST.SRC     : RAM-test.
RECIRQ.SRC      : Recieve-interrupt-rutin, l{gger tecken i rx-
                  buffert.
RESETTEST.SRC   : Kontrollerar att reset fungerar.
SETNOV.SRC      : Fyller NOVRAM.
SIOTEST.SRC     : Testar SIO'n.
STARTUP.SRC     : Initierar RAM, CTC, SIO och stackpekare,
                  kontrollerar om ett Watchdog- eller reset-test
                  {r anledn till startup.
STRUKTUR.ASS    : F|rh}llandet mellan program-modulerna.
TKNKOLL.SRC     : Tolkar tecknen fr}n rx-buffert och anropar
                  aktuellt test.
TMC.COM         : L{nkar assembler-modulerna, drar ig}ng FIXPROM
                  och konverterar exekverbara filen till Intel-
                  hex.
TMC.H           : Includefil, inneh}ller konstanter.
TMC.INT         : Exekverbar fil i Intelhex-format.
TMC.MAP         : Mapen f|r kort-programmet.
TRMCHR.SRC      : Skickar tecken fr}n tx-buffert.
TRMIRQ.SRC      : Transmit-interrupt-rutin, anropar trmchr.
VAR.ASS         : F|rklaring till hur variablerna anv{nds.
WDOGTEST.SRC    : Kontrollerar att Watchdog l|ser ut.

%page
%title 0
%title 1        Funktionsbeskrivning

Programmen p} kortet har till uppgift att testa vissa funktioner
p} detsamma. Vilka tester som skall utf|ras best{ms fr}n en PC.
Programmen kan uppdelas i nedanst}ende tre delar.

%title 2        Driver

F|r att kommunicera med PC'n anv{nds SIO'ns A-kanal. Interrupt-
rutiner talar om n{r det {r dags att h{mta respektive l{gga ett
tecken i SIO'n. F|r att programmet ska kunna arbeta i sin takt
anv{nds ringbuffrar. 

%title 2        Interpretator

Plockar meddelandena ur receivebufferten och ser till att r{tt
funktion p} kortet blir testad. Ett meddelande {r ett STX direkt
f|ljt av eventuella parametrar, }tskiljda av semikolon, och ett
kommando. \vriga meddelanden sl{ngs. N{rmare beskrivning |ver
hur meddelandena ser ut finns i beskrivningen av programmvaran
p} PC'n. 

%title 2 Tester 

Ett antal funktioner p} kortet kan testas. Efter avslutat test
l{ggs ett meddelande till PC'n om hur testet har utfallit i
transmit-bufferten. 

%page
%title 0
%title 1        Programutveckling

Programvaran {r skriven i assembler f|r Z80 p} VAX 730.

%title 2        Assemblering

F|r att assemblera programmen p} kortet anv{nds BSO
Z80 Cross Assembler att k|ra p} VAX. 

F|ljande source-filer finns:

CHKNOV.SRC
ENABLE.SRC
FIXPROM.SRC
INSIG.SRC
IPRET.SRC
OUTSIG.SRC
PROMTEST.SRC
PUTCHAR.SRC
PUTNUM.SRC
RAM.SRC
RAMTEST.SRC
RECIRQ.SRC
RESETTEST.SRC
SETNOV.SRC
SIOTEST.SRC
STARTUP.SRC
TKNKOLL.SRC
TRMCHR.SRC
TRMIRQ.SRC
WDOGTEST.SRC

Endast en fil som inkluderas i sourcarna finns:

TMC.H

%title 3        Batch-filer

F|r enkelhets skull finns f{rdiga batch-filer f|r att assemblera.

ASS.COM         Assemblerar en fil.

                F|r att k|ra, skriv: ASS <filnamn>

BATCH.COM       Assemblerar de filer som finns uppr{knade i filen
                AFIL, genom att anropa ASS.COM. Inneh}ller
                normalt alla sourcarna.

                F|r att k|ra, skriv: @BATCH

%page
%title 2        L{nkning

%title 3        L{nkare

F|r att l{nka objektfilerna f|r kortet anv{nds BSO Z80 Cross
Linker att k|ra p} VAX. 

%title 3        L{nkningsordning

STARTUP m}ste l{nkas f|rst. PROMTEST m}ste l{nkas sist beroende
p} att promchecksumman endast r{knas p} anv{nd del av prom. (I
promtestmodulen finns en label PRMEND, som talar om att det {r
sista adressen i prom.)

%title 3        Batch-fil

F|r enkelhets skull finns en batch-fil f|r att l{nka.

TMC.COM

F|rutom att l{nka, drar den ig}ng FIXPROM som med hj{lp av BSO
Symbolic Debugger ser till att checksumman i prommet kommer att
bli 0000. Filen anropar dessutom BSO Object File Conversion som
omvandlar f{rdigl{nkade objektfilen fr}n BSO-format till
Intel-format. Programfilen f}r namnet TMC.INT

%page
%title 0
%title 1        Modulbeskrivning

%title 2        Struktur
%page

%title 2        Inneh}ll

H{r beskrivs kort vad som g|rs i varje rutin, modul f|r modul.

%title 3        chknov.src

CHKNOV
------

Beskrivning : Kopierar inneh}llet i promdelen av novram till
              ramdelen. Kontrollerar att det {r detsamma som
              skrevs i novram av SETNOV (i modul setnov).
              Anropar PUTCHR och PUTNUM f|r att skicka
              testresultatet. 

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        enable.src

ENABLE
------

Beskrivning : Ser till att transmit-interrupt {r enablat. Tittar
              om SIO'n kan ta emot ett tecken och anropar i s}
              fall TRMCHR f|r s{ndande av ett tecken. 

Anropas fr}n: 1) PUTCHR i modul putchar n{r ett tecken har lagts
                 i transmit-bufferten, om ett XON mottagits. 
              2) RECIRQ i modul recirq, om ett XON mottagits.

Globala variabler som {ndras: TXIRQS


%title 3        fixprom.src

FIXPROM
-------

Beskrivning : Ser till att checksumman i prom kommer att bli
              0000. Rutinen anv{nds endast vid skapandet av den
              exekverbara filen. D{rf|r l{ggs rutinen p} ram-
              adresserna och exekveras efter l{nkning i BSO
              Symbolic Debugger. Fungerar p} s} vis att 16-bit-
              summan i anv{nd del av prom-adresserna r{knas fram
              och d{refter l{ggs ett kompensationsv{rde p}
              adress CHKSUM (i modul startup). 

Anropas fr}n: Batch-filen som sk|ter l{nkningen, n{r man
              befinner sig i debuggern. 
%page
%title 3        insig.src

INSIG
-----

Beskrivning : L{ser p} beg{rd port. Anropar PUTCHR och PUTNUM
              f|r att skicka l{st v{rde.

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        ipret.src

MAIN
----

Beskrivning : H{r finns mainloopen i vilken man ligger och
              tittar om det finns n}got tecken i receive-
              bufferten. N{r det finns tecken, kollas om det
              finns s} pass gott om plats i bufferten att det {r
              dags att skicka XON. I s} fall s{tts XONFLG f|r
              att tala om att n{sta g}ng n}got skall skickas
              till PC'n, skall det vara XON. 

Anropas fr}n: Modul startup.

Globala variabler som {ndras: NCHRRX, PARAM, PARAMP, RXTALP,
                              STXFLG, XONFLG 


WDOGR
-----

Beskrivning : Skriver p} watchdog-porten f|r att watchdog inte
              ska l|sa ut. 

Anropas fr}n: MAIN (i denna modul.)


%title 3        outsig.src

OUTSIG
------

Beskrivning : Skriver beg{rt data p} beg{rd port. Anropar PUTCHR
              f|r att skicka svar.

Anropas fr}n: CHRCHK i modul tknkoll.
%page
%title 3        promtest.src

PRMTST
------

Beskrivning : Adderar alla bytes i anv{nd del av prom, tv} och
              tv}. Anropar PUTCHR och PUTNUM f|r att skicka
              resultatet. 

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        putchar.src

PUTCHR
------

Beskrivning : L{gger ett tecken i transmit-bufferten(, efter att
              eventuellt ha v{ntat p} att tecknet ska f} plats,)
              och justerar buffertpekarna. Om PC'n inte skickat
              ett XOFF anropas ENABLE. 

Anropas fr}n: 1) CHKNOV, INSIG, OUTSIG, PRMTST, RAMTST, RSTTST,
                 SETNOV, SIOTEST och WDGTST f|r s{ndande av STX
                 och kommandot.
              2) PUTNUM f|r s{ndande av retur-parametrar.

Globala variabler som {ndras: NCHRTX, TXBUFF, TXHEDP


%title 3        putnum.src

PUTNUM
------

Beskrivning : Tar emot en byte och konverterar inneh}llet i
              denna till tv} ASCII hex-tecken. Anropar sedan
              PUTCHR f|r vart och ett av tecknen. 

Anropas fr}n: CHKNOV, INSIG, PRMTST, RAMTST, RSTTST, SIOTEST och
              WDGTST f|r konvertering av retur-parametrar.
%page
%title 3        ram.src

H{r finns de globala variablerna deklarerade. En special-rutin
som exekveras i ram finns ocks} h{r: 

EIRETI
------

Beskrivning : Enablar interrupt och g|r return fr}n interrupt-
              rutin. Anledningen till att den finns h{r {r att
              n{r programmet k|rs med Mice 1 (, emulator), {r
              man tvungen att g|ra p} det h{r viset.

Anropas fr}n: ASPCRXIRQ, BSPCRXIRQ och DUMIRQ i modul startup.
              RECIRQ i modul recirq och TRMIRQ i modul trmirq. 


%title 3        ramtest.src

RAMTST
------

Beskrivning : Kontrollerar att adresserna {r ram-adresser och
              olika. Om b}da adresserna = 0 s{tts de till f|rsta
              och sista i ram (8000-87FF). Om riktiga adresser
              anropas TEST, annars s{tts returparametern till
              att tala om att dessa var felaktiga. PUTCHR och
              PUTNUM anropas f|r att skicka svar med retur-
              parameter. 

Anropas fr}n: CHRCHK i modul tknkoll. 


TEST
----

Beskrivning : Kontrollerar att ram fungerar mellan beg{rda
              adresser. 

              Testen utf|rs i 3 olika steg. Om fel uppt{cks i
              n}got av deltesten g}r man direkt till n{sta test. 

              1) Adresstest: I ram skrivs ett m|nster som sedan
              kontrolleras. Vid fel s{tts bit 0 i felmarkerings-
              registret.

              2) Vandrande etta: F|rst nollst{lls ram. F|r en
              byte i taget s{tter man sedan en bit i taget och
              kontrollerar att inga andra bitar i byten {r
              satta. Vid fel s{tts bit 1 i felmarkerings-
              registret.

              3) Vandrande nolla: Som "Vandrande etta".
              Fast tv{rtom.
              Vid fel s{tts bit 2 i felmarkerings-registret.

              Efter utf|rt test anropas: INIRAM i modul startup,
              f|r ny initiering av ram. Felmarkeringsregistret
              blir returparameter. 

Anropas fr}n: RAMTST i denna modul. 

Globala variabler som {ndras: Vid test av ram f|rst|rs
              inneh}llet i alla variabler, och variablerna
              initieras p} nytt. Efter initiering av ram, s{tts
              dock TSTFLG till true. 


%title 3        recirq.src

RECIRQ
------

Beskrivning : Receive-interrupt-rutin. Plockar tecken fr}n SIO'n
              p} A-kanalen. Om tecknet {r XON eller XOFF anropas
              ENABLE respektive disablas transmit-interrupt. Om
              inte, l{ggs det i receive-bufferten. Om receive-
              bufferten b|rjar bli full s{tts XOFFLG f|r att
              tala om att n{sta g}ng n}got skall skickas till
              PC'n, skall det vara XOFF. 

Anropas fr}n: (SIO'n.)

Globala variabler som {ndras: NCHRRX, RXBUFF, RXHEDP, RXSTAT,
              TXIRQS, TXSTAT, XOFFLG 


%title 3        resettest.src

RSTTST
------

Beskrivning : Skriver 'RE' p} ett visst st{lle i ram och skriver
              sedan p} en viss port f|r reset av kortet. Om
              reseten inte fungerade anropas PUTCHR och PUTNUM
              f|r att skicka det negativa svaret. Om reseten
              fungerat, tas det om hand i startup.

Anropas fr}n: CHRCHK i modul tknkoll. 

Globala variabler som {ndras: STATUS

OBS! Ej implementerad {nnu.
%page
%title 3        setnov.src

SETNOV
-----

Beskrivning : Skriver ett visst m|nster i ramdelen av novram och
              kopierar detta till promdelen. Anropar PUTCHR f|r
              att skicka svar. 

Anropas fr}n: CHRCHK i modul tknkoll.


%title 3        siotest.src

SIOTEST
-------

Beskrivning : Skickar ett tecken till sig sj{lv p} B-kanalen. Om
              inget mottaget s{tts bit 0 i felmarkerings-
              variabeln. Om fel tecken mottagits s{tts bit 1. P}
              samma s{tt g|rs sedan med komplementet till
              tecknet. En kontroll av DTR, RTS, CTS och DCD p}
              b}da kanalerna g|rs med hj{lp av SIGNALTEST. Man
              tittar h{r om CTS och DCD har haft den status som
              f|rv{ntats. Om inte, s{tts f|r kanal A: CTS bit 2,
              DCD bit 3, kanal B: CTS bit 4 och DCD bit 5 i
              felmarkerings-variabeln. PUTCHR och PUTNUM anropas
              f|r att skicka svar inneh}llande felmarkerings-
              variabeln. 

Anropas fr}n: CHRCHK i modul tknkoll. 


SIGNALTEST
----------

Beskrivning : S{tter upp DTR och RTS enligt en tabell och
              kontrollerar CTS och DCD mot en annan tabell.Detta
              g|rs med alla fyra kombinationer av upps{ttningen
              av DTR och RTS.

Anropas fr}n: SIOTEST i denna modul. 

%page
%title 3        startup.src

Huvudrutinen
------------

H{r b|rjar programmet exekveras (, adress 0).

Beskrivning : Upps{ttning av stackpekare, initiering av ram (i
              INIRAM), upps{ttning av CTC , upps{ttning av SIO
              med hj{lp av LDCW. H{r g|rs ocks} en kontroll av
              anledningen till start av programmet. Programmet
              kan ha startats om efter ett watchdogtest eller
              resettest(, det senare dock ej implementerat
              {nnu,). Detta uppt{cks genom att respektive test
              har l{mnat ett par tecken i variabel STATUS. Om
              det visar sig vara s} skickas svar p} detta test
              med hj{lp av PUTCHR. 

Anropas fr}n: (WDGTST, RSTTST)

Globala variabler som {ndras: STATUS


INIRAM
------

Beskrivning : Globala variablerna s{tts upp till sina
              startv{rden och rutinen EIRETI skapas.

Anropas fr}n: Huvudrutinen i denna modul och TEST i modul
              ramtest.src. 

Globala variabler som {ndras: Alla.


LDCW
----

Beskrivning : S{tter upp SIO'n med hj{lp av ett par tabeller. 

Anropas fr}n: Huvudrutinen i denna modul.


ASPCRXIRQ
---------

Beskrivning : Interruptrutin som tar hand om parity, receiver
              overrun och framing error p} A-kanalen. G|r en
              error reset och plockar tecknet ur SIO'n. 

Anropas fr}n: (SIO'n.)
%page
BSPCRXIRQ
---------

Beskrivning : Likadan som ASPCRXIRQ fast f|r B-kanalen.

Anropas fr}n: (SIO'n.)


DUMIRQ
------

Beskrivning : Tar hand om ointressanta interrupt fr}n SIO'n.
              (G|r ingenting.) 

Anropas fr}n: (SIO'n.)


%title 3        tknkoll.src

CHRCHK
------

Beskrivning : Hit kommer man efter att ha hittat ett STX i
              receivebufferten, d.v.s. n{r ett meddelande {r p}
              g}ng. Denna rutin tolkar tecknen efter ett STX,
              d.v.s. sorterar ut parametrar och kommandon och
              anropar aktuellt test. Hittas ett odefinierat
              tecken }terg}r man till att v{nta p} nytt
              meddelande.

Anropas fr}n: MAIN i modul ipret.

Globala variabler som {ndras: PARAM, PARAMP, STXFLG


%title 3        trmchr.src

TRMCHR
------

Beskrivning : Tittar om det {r dags att skicka XON/XOFF, disabla
              transmit-interruptet och om det finns n}got i
              transmit-bufferten att skicka, g|rs detta p}
              SIO'ns A-kanal. 

Anropas fr}n: 1) ENABLE efter enablande av transmit-interrupt.
              2) TRMIRQ vid transmit-interrupt. 

Globala variabler som {ndras: NCHRTX, TXIRQS, TXTALP, XOFFLG,
              XONFLG 
%page
%title 3        trmirq.src

TRMIRQ
------

Beskrivning : Transmit-interrupt-rutinen. Anropar TRMCHR i modul
              trmchr. 

Anropas fr}n: (SIO'n.)


%title 3        wdogtest.src

WDGTST
------

Beskrivning : Skriver 'WA' p} ett visst st{lle i ram och l{gger
              sig sedan i en loop och v{ntar i ca 25 sekunder.
              (En watchdog-reset b|r ha kommit efter ca 20
              sekunder.) Om reseten inte fungerade anropas PUTCHR
              och PUTNUM f|r att skicka det negativa svaret. Om
              reseten fungerat, tas det om hand i startup. 

Anropas fr}n: CHRCHK i modul tknkoll. 

Globala variabler som {ndras: STATUS

%page
%title 2        Variabler

%title 3        Funktion

CTSFEL  CTS-status felaktigt.

        M|jliga v{rden  : TRUE, FALSE
        Startv{rde      : FALSE
        [ndras          : I SIOTEST.
        L{ses           : (Av PC-programmet.)


DCDFEL  DCD-status felaktigt

        M|jliga v{rden  : TRUE, FALSE
        Startv{rde      : FALSE
        [ndras          : I SIOTEST.
        L{ses           : (Av PC-programmet.)


EIRETI  H{r l{ggs EI och RETI under exekvering, pga. att Mice
        inte klarar av att g|ra RETI i sitt eget ram.

FELTYP  Typ av fel p} SIO'n.

        M|jliga v{rden  : 0 - 3F
        Startv{rde      : 0
        [ndras          : Vid fel uppt{ckt p} SIO'n, i SIOTEST.
        L{ses           : (Av PC-programmet.)


NCHRRX  Antal tecken i recieve-bufferten.

        M|jliga v{rden  : 0 - BUFSIZ
        Startv{rde      : 0
        [ndras          : \kas i RECIRQ, minskas i IPRET
        L{ses           : Vid koll om >= UPLIM (i RECIRQ).

        
NCHRTX  Antal tecken i transmit-bufferten.

        M|jliga v{rden  : 0 - BUFSIZ
        Startv{rde      : 0
        [ndras          : \kas i PUTCHAR, minskas i TRMCHR.
        L{ses           : Vid koll om < LOLIM (i TRMCHR).

        
PARAM   Parameterarea.

        M|jliga v{rden  : 0 - FFFF HEX (i varje parameter).
        Startv{rde      : 0
        [ndras          : Nollst{lls i IPRET vid mottagande av
                          STX. Fylles p} i TKNKOLL.
        L{ses           : I RAMTEST, INSIGNAL och UTSIGNAL.

%page
PARAMP  Parameterpekare.

        M|jliga v{rden  : PARAM - PARAM+NPARAM-1
                          (NPARAM = antal parametrar*2).
        Startv{rde      : PARAM
        [ndras          : S{tts till PARAM i IPRET vid mottagande
                          av STX. Justeras i TKNKOLL.
        L{ses           : I TKNKOLL vid kontroll om parameter-
                          arean {r full.

        
RXBUFF  Recieve-buffert.

        M|jliga v{rden  : Alla ASCII-tecken utom XON, XOFF.
        Startv{rde      : NUL
        [ndras          : I RECIRQ
        L{ses           : I IPRET

        
RXHEDP  Huvudpekare recieve-buffert.

        M|jliga v{rden  : RXBUFF - RXBUFF+BUFSIZ-1
        Startv{rde      : RXBUFF
        [ndras          : N{r tecken l{ggs i r-b (i RECIRQ).
        L{ses           : Vid placering av tecken i r-b och vid
                          {ndring (i RECIRQ).
        

RXSTAT  Talar om vad som senast skickades till PC (XON/XOFF).

        M|jliga v{rden  : XON, XOFF
        Startv{rde      : XON
        [ndras          : S{tts till XOFF n{r XOFF-flaggan s{tts
                          (i RECIRQ). S{tts till XON n{r XON-
                          flaggan s{tts.
        L{ses           : I IPRET, f|r att inte skicka XON hela
                          tiden antalet tecken i r-b {r < LOLIM.
        

RXTALP  Svanspekare recieve-buffert.

        M|jliga v{rden  : RXBUFF - RXBUFF+BUFSIZ-1
        Startv{rde      : RXBUFF
        [ndras          : Justeras n{r tecken h{mtas ur r-b
                          (i IPRET).
        L{ses           : Vid h{mtning av tecken i r-b och vid
                          justering (i IPRET).

        
STACK -
STKTOP  Stacken.

        Adress STKTOP l{ggs i SP i STARTUP.

%page
STATUS  Vad h{nde f|re startup?

        M|jliga v{rden  : EX, RE, WA
        Startv{rde      : EX
        [ndras          : S{tts till RE i RESETTEST, WA i
                          WDOGTEST.
        L{ses           : I STARTUP f|r kontroll om ett testsvar
                          skall skickas.

        
STXFLG  Ett meddelande {r p} v{g.

        M|jliga v{rden  : TRUE, FALSE
        Startv{rde      : FALSE
        [ndras          : S{tts till TRUE n{r ett STX plockas ur
                          r-b (i IPRET). Till FALSE efter ett
                          test och vid skr{ptecken efter STX(, i
                          TKNKOLL).
        L{ses           : Vid kontroll om ett tecken ing}r i ett
                          meddelande, i IPRET.
        

TSTFLG  Talar om att ramtestet {r utf|rt.

        M|jliga v{rden  : TRUE, FALSE
        Startv{rde      : FALSE
        [ndras          : S{tts till TRUE efter ett ramtest
                          (i RAMTEST). Till FALSE efter s{nt svar
                          (i RAMTEST).
        L{ses           : F|r kontroll vilket svar som skall
                          s{ndas efter ramtest (i RAMTEST).
        

TXBUFF  Transmit-buffert.

        M|jliga v{rden  : 'STX', ';', '0' - '9', 'A' - 'Z'
        Startv{rde      : NUL
        [ndras          : I PUTCHAR
        L{ses           : I TRMCHR

        
TXHEDP  Huvudpekare Transmit-buffert.

        M|jliga v{rden  : TXBUFF - TXBUFF+BUFSIZ-1
        Startv{rde      : TXBUFF
        [ndras          : N{r tecken l{ggs i t-b (i PUTCHAR).
        L{ses           : Vid placering av tecken i t-b och vid
                          {ndring (i PUTCHAR).

%page
TXIRQS  Txirq-status (txirq ENablat eller DISablat).

        M|jliga v{rden  : ENABL, DISABL
        Startv{rde      : DISABL
        [ndras          : Till ENABL i ENABLE efter enabling av
                          txirq (, n{r tecken finns i t-b och
                          TXSTAT = XON). Till DISABL,
                          (efter disabling av txirq,) 
                          i RECIRQ n{r ett XOFF mottages,
                          i TRMCHR n{r TXSTAT = XOFF
                          eller om t-b {r tom.
        L{ses           : I ENABLE kollas om txirq redan enablat.
                          Om inte, enablas txirq.
        

TXSTAT  Talar om vad som senast mottogs fr}n PC (XON/XOFF), dvs
        om txirq skall ENablas eller DISablas.

        M|jliga v{rden  : XON, XOFF
        Startv{rde      : XON
        [ndras          : I RECIRQ n{r n}got av dessa mottages.
                          D{refter EN-/ DISablas txirq.
        L{ses           : I PUTCHAR, f|r eventuell enabling,
                          i TRMCHR, f|r eventuell disabling.

        
TXTALP  Svanspekare Transmit-buffert.

        M|jliga v{rden  : TXBUFF - TXBUFF+BUFSIZ-1
        Startv{rde      : TXBUFF
        [ndras          : Justeras n{r tecken h{mtas ur t-b
                          (i TRMCHR).
        L{ses           : Vid h{mtning av tecken i t-b och vid
                          justering (i TRMCHR).


VARVCNT Varvr{knare f|r statustest

        M|jliga v{rden  : 0 - 4
        Startv{rde      : 0
        [ndras          : I SIOTEST.
        L{ses           : I SIOTEST.


XOFFLG  Ett XOFF skall skickas vid txirq.

        M|jliga v{rden  : TRUE, FALSE
        Startv{rde      : FALSE
        [ndras          : S{tts till TRUE i RECIRQ n{r antal
                          tecken i r-b blir >= UPLIM. Till FALSE
                          i TRMCHR efter att ha s{nt ett XOFF.
        L{ses           : I TRMCHR, om TRUE s{nds ett XOFF.

%page
XONFLG  Ett XON skall skickas vid txirq.

        M|jliga v{rden  : TRUE, FALSE
        Startv{rde      : FALSE
        [ndras          : S{tts till TRUE i IPRET n{r antal
                          tecken i r-b blir < LOLIM, om
                          RXSTAT = XOFF. Till FALSE i TRMCHR
                          efter att ha s{nt ett XON.
        L{ses           : I TRMCHR, om TRUE s{nds ett XON.

%page
%title 3        Anv{ndningsst{llen
