Modulen inneh}ller alla rutiner som sk|ter loggningen.


Lokala statiska variabler
-------------------------


LoggFilNamn : Namnet p} loggfilen.

HuvudStr_1  : Logghuvud pa varje sida. Datum, loggfilnamn
              kommandofilnamn och sidnummer.

HuvudStr_2  : Logghuvud, rubriker.

TextStr     : Strangen som fylls p} av olika loggrutiner och
              sedan loggas (av Logga). Skrivs oftast {ven ut p}
              sk{rm, dock i avkortad form. Tid, f|rbrukad
              testtid, sp{nning hylla och slot tas bort. Om
              str{ngen fortfarande {r l{ngre {n 80 tecken,
              kastas tecknen efter det 80:e. 

Count       : En tabell som inneh}ller alla resultat, i form av
              r{knare, av test p} korten under en k|rning.
              Anv{nds f|r att h}lla reda p} n{r n}gonting
              g{llande MDDM skall loggas samt vid den samman-
              fattande utskriften.

TmpDatum    : Anv{nds f|r att datum inte skall {ndra p} sig
              under tiden man jobbar med det. 

OldDate     : Datum d} senaste raden loggades. Anv{nds f|r att
              f} sidbyte vid nytt datum. 

Sida        : Sidnummer p} logglistan.

LineNr      : Radr{knare. F|r att f} r{tt antal rader p} sidan.

MddmHuvud   : Skall HuvudStr_2 ut p} loggen?

LowIO       : I/O-adress till port med l{gsta nummer som skall
              ha en felr{knare per ioport

HighIO      : I/O-adress till port med h|gsta nummer som skall
              ha en felr{knare per ioport

NumIO       : Antal i/o-adresser som har en felr{knare per
              ioport dvs HighIO - LowIO + 1.

IOCntAlloc  : Har minne f|r felr{knare till IO-portarna
              allokerats?
%page
PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Time
----

Biblioteksrutin i MS-Pascal.


Open_LoggFil 
------------

Beskrivning : \ppnar loggfilen f|r skrivning. Misslyckas detta
              skrivs det ut p} sk{rmen. 

Anropas fr}n: DoTest i modul Batch

Deklaration : Procedure Open_LoggFil [PUBLIC];

Statiska variabler som {ndras:

    Globala: LoggFil


Make_LoggFilNamn
----------------

Beskrivning : Skapar ett loggfilnamn med hj{lp av datum och tid.
              F|r m}nad anv{nds hexadecimalt tecken.

Anropas fr}n: Open_LoggFil. (Intern procedur i densamma.)

Deklaration : Procedure Make_LoggFilNamn;

Statiska variabler som {ndras:

    Lokala : LoggFilNamn


PrOff 
-----

Beskrivning : Sl}r av printning och s{tter printflaggan p}
              sk{rmen till "PrOff".

Anropas fr}n: 1) DoTest i Batch vid initiering och d} operat|ren
                 v{ljer bort printning. 
              2) Check_Printer i denna modul.

Deklaration : Procedure PrOff [PUBLIC];

Statiska variabler som {ndras:

    Globala: PrintOn
%page
Check_Printer 
-------------

Beskrivning : Tittar hur printningen st}r i f|rh}llande till hur
              printern m}r. Om olika justeras detta och print-
              flaggan p} sk{rmen {ndras. 

Anropas fr}n: 1) DoTest i Batch vid initiering och d} operat|ren
                 v{ljer printning. 
              2) Logga i denna modul.

Deklaration : Procedure Check_Printer ( Status : byte )
              [PUBLIC];

    Status : Avl{st printerstatus.

Statiska variabler som {ndras:

    Globala: PrintOn


HexKonv
-------

Beskrivning : Konverterar en integer till en str{ng i hexformat.
              Ex: #FF

Anropas fr}n: 1) Insignal i modul Mddmkomn.
              2) PstatKonv i denna modul.

Deklaration : Function HexKonv ( AntNumTkn : integer;
				 talet     : integer ): lstr5
              [PUBLIC];

    AntNumTkn : Antal numeriska tecken. Anger hur m}nga
                positioner i str{ngen som kr{vs.
    Talet     : Integern som skall konverteras.


PStatKonv
---------

Beskrivning : Konverterar PStatus till en str{ng i hexformat.
              Ex. #XX01

Anropas fr}n: 1) Procedurerna i modul Mddmkomn och
              2) PwCComm i modul Pwckomn
              vid kommunikationsfel.

Deklaration : Function PStatKonv ( PStat : integer ): lstr5
              [PUBLIC];

    PStat : PStatus
%page
Add_Space
---------

Beskrivning : Fyller TextStr med space till angiven kolumn.

Anropas fr}n: Flera av rutinerna i denna modul.

Deklaration : Procedure Add_Space ( Kolumn : byte );

    Kolumn : Till (men inte med) vilken kolumn space skall
             fyllas.

Statiska variabler som {ndras:

    Lokala : TextStr


Concat_Value
------------

Beskrivning : Plockar bort decimalerna ur en real om dessa {r
              < 0.0005 och l{gger till talet i TextStr.

Anropas fr}n: Logg och Logga_ParmFel i denna modul. Vid utskrift
              av v{rde- eller variabel-parametrar till
              kommandona i kommandofilen. 

Deklaration : Procedure Concat_Value ( ReVal  : real;
			               HexFlg : boolean );

    ReVal  : V{rdet som skall snyggas till.
    HexFlg : Flagga som talar om ifall talet skall skrivas p}
             hexform.

Statiska variabler som {ndras:

    Lokala : TextStr


Make_LoggHuvud
--------------

Beskrivning : Skapar logghuvudena.

Anropas fr}n: Init_Lista och Logga i denna modul.

Deklaration : Procedure Make_LoggHuvud;

Statiska variabler som {ndras:

    Lokala : HuvudStr_1, HuvudStr_2 
%page
Put_Times
---------

Beskrivning : L{gger tid och f|rbrukad testtid i TextStr.

Anropas fr}n: Flera av rutinerna i denna modul.

Deklaration : Procedure Put_Times;

Statiska variabler som {ndras:

    Lokala : TmpDatum, TextStr


Add_MddmInfo
------------

Beskrivning : L{gger till hylla, slot och id till TextStr.

Anropas fr}n: Logga_MddmKomFel, Logga_TestOK och Logga_TestFel i
              denna modul. 

Deklaration : Procedure Add_MddmInfo;

Statiska variabler som {ndras:

    Lokala : TextStr


Logga_Msg
---------

Beskrivning : Loggar ett valfritt meddelande p} loggmedierna,
              skriver aktuell tid och f|rbrukad testtid f|rst p}
              raden.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Logga_Msg ( CONST msg : string )
              [PUBLIC];

    msg      : texten som skall skrivas ut.

Statiska variabler som {ndras:

    Lokala : TextStr
%page
DiskLogg
--------

Beskrivning : Skriver ut TextStr och eventuella huvud p}
              LoggFil. Om skrivningen p} LoggFil misslyckas
              p.g.a. att disken {r full skrivs detta ut p} sk{rm
              och printer. I |vriga fall d} skrivning misslyckas
              skrivs en felkod. Meddelande att loggning
              forts{tter endast p} printer l{mnas ocks}.

Anropas fr}n: Logga i denna modul.

Deklaration : Procedure DiskLogg ( CONST msg : string );

Statiska variabler som {ndras:

    Globala: LoggFil, PrintOn
    Lokala : DiskErr


Logga
-----

Beskrivning : Ser till att sidbyten, rubriker och texter kommer
              snyggt p} loggen. Anropar DiskLogg och PrintLn f|r
              att f} ut texterna. F|r att anrop av PrintLn skall
              ske kr{vs att printning {r vald och att printern
              {r beredd att skriva. [r printern avslagen,
              offline, busy f|r l{nge, ( 15 s,) eller det blir
              fel vid skrivning, s{tts print-flaggan p} sk{rmen
              till "PrOff" och ingen printning kommer att ske
              f|rr{n printern {r OK och printning har valts p}
              nytt. 

Anropas fr}n: Flera av rutinerna i denna modul.

Deklaration : Procedure Logga;

Statiska variabler som {ndras:

    Globala: LoggFil, SerErr, PrintOn
    Lokala : OldDate, Sida, LineNr
%page
Logga_SyntErr
-------------

Beskrivning : L{gger vid syntaxfel ett felmeddelande i TextStr,
              skriver ut det och den felaktiga raden p} sk{rmen
              och loggen.

Anropas fr}n: Flera av rutinerna i Synt.

Deklaration : Procedure Logga_SyntErr ( err : error_t;
			                ptr : komm_ptr )
              [PUBLIC];

    err : Typ av syntaxfel.
    ptr : Pekare till kommandoraden i den l{nkade listan.

Statiska variabler som {ndras:

    Lokala : TextStr, MddmHuvud


Logg
----

Beskrivning : Logg-kommandot. Skriver ut beg{rda variabler,
              v{rden och str{ngar p} loggen.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Logg ( RadDelar : linepart_t;
		               Antal    : integer     )
              [PUBLIC];

    RadDelar : Kommandot + de olika delarna av raden i kommando-
               filen som skall skrivas ut.
    Antal    : Antal RadDelar.

Statiska variabler som {ndras:

    Lokala : TextStr
%page
Logga_ParmFel
-------------

Beskrivning : Skriver ut att en eller flera felaktiga parametrar
              har hittats i kommandofilen, typ av parameter,
              parameterv{rdet och vilken rad i kommandofilen det
              g{ller. Utskriften kommer b}de p} logg och sk{rm.
              Dock endast d} parametern {r en variabel (som g}tt
              utanf|r till}tna v{rden). (Felaktiga konstant-
              parametrar uppt{cks i syntaxchecken och loggas av
              Logga_SyntErr.) 

Anropas fr}n: 1) Paus i modul Loop.
              2) Utsignal, Insignal och Ramtest i modul
                 Mddmkomn.
              3) Choose_Objekt i modul Objkomn.
              4) Set_Spanning och Set_Analog i modul Pwckomn.

Deklaration : Procedure Logga_ParmFel
                        ( KomndStr   : element;
			  KomnRadI   : integer;
	                  ErrParm    : ErrParmArea_t;
  	                  AntErrParm : integer        )
	      [PUBLIC];

    KomndStr   : Kommandot.
    KomnRadI   : Raden i kommandofilen.
    ErrParm    : De felaktiga parametrarna.
    AntErrParm : Antal felaktiga parametrar.

Statiska variabler som {ndras:

    Lokala : TextStr


Logga_SerErr
------------

Beskrivning : Skriver p} logg och sk{rm, vid fatalt fel ut vad
              som {r fel och s{tter SerErr-variabeln om denna ej
              redan {r satt. 

Anropas fr}n: 1) Ini_COM_Ports i modul Batch.
              2) PwCCTS, PwCComm och Ini_PwC i modul Pwckomn.

Deklaration : Procedure Logga_SerErr ( ErrVarde : SerErr_t ;
			               Status   : integer    )
              [PUBLIC];

    ErrVarde : Typ av fel.
    Status   : Eventuella statuskoder som n{rmare beskriver
               felet.

Statiska variabler som {ndras:

    Globala: SerErr
    Lokala : TextStr
%page
Reset_Counters 
--------------

Beskrivning : Nollst{ller alla r{knare och pekare i Count.
              Nollst{ller io-portsr{kneriet (LowIO, HighIO och
              NumIO).

Anropas fr}n: Startup i modul Batch.

Deklaration : Procedure Reset_Counters [PUBLIC];

Statiska variabler som {ndras:

    Lokala : Count, IOCntAlloc, LowIO, HighIO, NumIO och DiskErr


Ioport
------

Beskrivning : Allokerar minne f|r, och nollst{ller felr{knare
              f|r de io-portar som skall ha en felr{knare per
              port. Markerar detta i IOCntAlloc. Skriver ut
              felmeddelande om minne redan allokerats. Avbryter
              testet om minnet inte r{cker till. 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Ioport ( lowport, highport : real )
              [PUBLIC]; 

Statiska variabler som {ndras:

    Globala: SerErr
    Lokala : Count, IOcntAlloc, HighIO, LowIO, NumIO


Release_PortCnt
---------------

Beskrivning : Deallokerar minne f|r port-felr{knarna, och
              markerar detta i IOCntAlloc. Detta g|rs n{r en
              testsekvens k|rts f{rdigt. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Procedure Release_PortCnt [PUBLIC]; 

Statiska variabler som {ndras:

    Lokala : Count, IOcntAlloc
%page
Init_Lista
----------

Beskrivning : Initieringar av variabler som ser till att loggen
              blir snygg.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Init_Lista [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TmpDatum, OldDate, Sida, LineNr, MddmHuvud


Logga_ObjektFel
---------------

Beskrivning : Skriver vid start av testet ut vilka kortplatser
              som inte l{mnat ngt svar trots att id f|r kort-
              platsen finns inmatat samt vilka kortplatser som
              l{mnat svar trots att id ej finns inmatat. 

Anropas fr}n: Check_Objekts i modul Mddmkomn. 

Deklaration : Procedure Logga_ObjektFel ( RackTab : RackTab_t )
			[PUBLIC];

    RackTab : Tabell inneh}llande flagga som talar om ifall det
	      finns ngt fel i just den hyllan samt en variabel,
	      f|r varje kortplats, som talar om av vilken typ det
	      eventuella felet {r.

Statiska variabler som {ndras:

    Lokala : TextStr
%page
Logga_TestResultat
------------------

Beskrivning : R{knar upp totalr{knaren f|r varje kort och
              funktion, och ser till att svaren fr}n korten
              loggas p} riktigt s{tt. 

Anropas fr}n: Rutinerna f|r kommandon i modul Mddmkomn.

Deklaration : Procedure Logga_TestResultat
                        ( Komnd     : char;
			  KortErr   : KortFel_t;
		          PortNr    : integer;
                          Varde     : lstr5;
	                  InData    : integer	 ) [PUBLIC];

Komnd     : Kommandot till MDDM-kortet. Anv{nds h{r f|r
            indexering i Count.
KortErr   : Vilken typ av svar kortet gav.
PortNr    : Inneh}ller portnummer efter INSIGNAL-test.
Varde     : Kan inneh}lla kommunikationsfeltyp (mot MDDM),
            feltyp p} RAM, feltyp p} SIO'n samt erh}llet v{rde
            efter negativt INSIGNAL-test. 
InData    : F|rv{ntat v{rde vid INSIGNAL-test.

Statiska variabler som {ndras:

    Lokala : Count


PortNr_Ok
---------

Beskrivning : Kontrollerar om den testade porten i
              insignalkommandot har egen r{knare. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Function PortNr_Ok;
%page
Logga_MddmKomFel
----------------

Beskrivning : Vid kommunikationsfel mot MDDM skrivs detta ut p}
              sk{rm och logg. F|r varje kort skrivs dock h|gst
              100 kommunikationsfel ut. Vid det 101:a felet
              talas om att antalet fel {r > 100. D{refter g|rs
              vid kommunikationsfel inget annat {n att |ka
              r{knaren. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Procedure Logga_MddmKomFel;

Statiska variabler som {ndras:

    Lokala : TextStr, Count


Logga_TestOK
------------

Beskrivning : Testad funktion fungerade, kontroll av hur testet
              p} funktionen utf|ll senast. Om n}got av:
              negativt, felaktigt svar eller timeout, skrivs,
              endast p} loggen, ut att resultatet blev positivt,
              vid INSIGNAL {ven portnummer, och tidigare feltyp
              samt antalet s}dana. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Procedure Logga_TestOK;

Statiska variabler som {ndras:

    Lokala : TextStr, Count
%page
Logga_TestFel
-------------

Beskrivning : Testad funktion fungerade ej. Om parametrarna
              PortStr, Varde eller InDataStr inneh}ller n}got,
              skrivs detta. Annars skrivs texten "NEGATIVT".
              Kontroll g|rs av hur testet p} funktionen utf|ll
              senast. Om n}got av: negativt, felaktigt svar
              eller timeout, skrivs {ven tidigare feltyp samt
              antalet s}dana. Denna utskrift g|rs alltid p}
              sk{rmen. Utskrift p} loggen sker endast om senaste
              test av funktionen gav ett annat resultat. Vid
              RAMTEST r{knas som annat resultat att typen av fel
              p} RAM {r ett annat. Vid PROMTEST skiljs ej p}
              felaktiga checksummor. Vid INSIGNAL-test tas bara
              h{nsyn till vilken port som ger det felaktiga
              v{rdet om den har en separat felr{knare enl.
              tidigare IOPORT-kommando. H{nsyn tas d} ocks} till
              senaste l{sta och f|rv{ntade v{rde f|r porten. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Procedure Logga_TestFel;

Statiska variabler som {ndras:

    Lokala : TextStr, Count


Logga_PwCErr
------------

Beskrivning : Ett "SRQ" har mottagits fr}n Power-controllern.
              Rutinen skriver, p} sk{rm och logg, ut vad PwC'n
              tyckte var fel i kommandot fr}n PC'n.

Anropas fr}n: Check_PwC_Answer i modul Pwckomn.

Deklaration : Procedure Logga_PwCErr ( BitVarde : integer )
              [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TextStr
%page
Logga_PwCKomFel
---------------

Beskrivning : Skriver ut att kommunikationsfel mot PwC'n har
              uppt{ckts.

Anropas fr}n: PwCComm i modul Pwckomn.

Deklaration : Procedure Logga_PwCKomFel ( KomFelTyp : lstr5 );

Statiska variabler som {ndras:

    Lokala : TextStr


Screen_logg
-----------

Beskrivning : Skriver ut varje rad p} sk{rmen i samband med att
              den interpreteras. Variabler ers{tts med aktuellt
              v{rde (utom f|rsta variabeln i FOR-kommandot).
              Kommentarer skrivs i 40:e kolumn. 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Screen_logg (
			raddelar : linepart_t;
			antal    : integer;
			raden    : komm_ptr);  [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TextStr


Statistik 
---------

Beskrivning : Skriver p} loggen en sammanfattning f|r varje kort
              inneh}llande hur m}nga tester av varje funktion
              som har gjorts och d{rav antal negativa resultat,
              felaktiga svar och timeouter. F|r de portar som
              angetts i IOPORT-kommadot skrivs felr{knarna ut om
              de {r st|rre {n noll. F|r varje kort skrivs ocks}
              ut antal kommunikationsfel. 

Anropas fr}n: DoTest i modul Batch, n{r k|rningen avbryts eller
              {r klar, om n}gon funktion p} n}got kort {r
              testad. 

Deklaration : Procedure Statistik [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TextStr, LinenNr, MddmHuvud
