Modulen inneh}ller rutiner som beg{r test av n}gon funktion p}
MDDM-korten. 


Lokala statiska variabler
-------------------------


OldValue : Tabell med v{rden, f|r varje port/kort, som senast
           skickats ner till MDDM-korten. F|r att kunna {ndra
           endast p} enstaka bitar vid skrivning p} en port, (i
           UTSIGNAL-kommandot).


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Check_Objekts
-------------

Beskrivning : Kontrollerar att inmatade id st{mmer |verens med
              hur korten sitter i racken. G}r till p} s} vis att
              RAMTEST-kommandot med felaktiga parametrar skickas
              till samtliga kortplatser. Svar f|rv{ntas endast
              fr}n de platser som har f}tt ett id.P} svar v{ntas
              i h|gst 1/2 sekund. Ett svar ser ut s} h{r: FFG
              Allt annat betraktas som uteblivet svar. Allts} kan
              tv} typer av fel uppst}:
	      1) Svar f}s fr}n en plats utan id,
              2) Svar fr}n en plats med id uteblir.
	      Om fel uppt{cks markeras typen av fel i en tabell,
	      testet avbryts och felen loggas.

Anropas fr}n: Startup i modul Batch. 

Deklaration : Procedure Check_Objekts [PUBLIC];

Statiska variabler som {ndras:

    Globala : Obj


Reset_OldValue
--------------

Beskrivning : Nollst{ller OldValue.

Anropas fr}n: Startup i modul Batch.

Deklaration : Procedure Reset_OldValue [PUBLIC];

Statiska variabler som {ndras:

    Lokala : OldValue
%page
Utsignal
--------

Beskrivning : Justerar |nskade bitar p} en port, om portnummer,
              indata och mask ligger inom till}tna gr{nser, G}r
              till p} f|ljande s{tt: Bitar som skall justeras
              maskas fram ur UtData. Bitar som inte skall r|ras
              plockas ur OldValue. Datat och portnumret
              konverteras till ASCII hex-tecken och skickas,
              m.h.a. Send_MddmMessage, tillsammans med
              UTSIGNAL-kommandot (J) till MDDM som skriver datat
              p} porten. 

              Meddelandet till kortet: portnummer ; data J
              Svar fr}n kortet       : J

              \vriga svar {r felaktiga. Kan allts} ej ge
              resultat "negativt". P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas aktuell loggrutin, (f|r eventuell
              utskrift).

Anropas fr}n: DoTest i Batch. 

Deklaration : Procedure Utsignal (     ptr      : komm_ptr;
                                   VAR RadDelar : linepart_t;
                                       Antal    : integer     )
              [PUBLIC];

    ptr      : Pekare till recordet i kommandolistan som
               inneh}ller detta UTSIGNAL-kommando. Anv{nds h{r
               f|r att vid parameterfel kunna skriva ut p}
               vilken rad den felaktiga parametern p}tr{ffades.

    RadDelar : De olika delarna av kommandoraden i kommando-
               filen.

    Antal    : Antal RadDelar.

Statiska variabler som {ndras: 

    Lokala : OldValue
%page
Insignal
--------

Beskrivning : Om portnummer, indata och mask ligger inom
              till}tna gr{nser, konverteras portnumret till
              ASCII hex-tecken och skickas, m.h.a.
              Send_MddmMessage, tillsammans med
              INSIGNAL-kommandot (I) till MDDM som l{ser p}
              porten. 

              Meddelandet till kortet: portnummer I
              Svar fr}n kortet       : l{st v{rde I

              \vriga svar {r felaktiga. Kan allts} ej ge
              resultat "negativt". P} svar v{ntas i h|gst 1
              sekund. 

              Det l{sta v{rdet maskas med masken och j{mf|rs med
              indata. 

              Aktuell loggrutin anropas, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i Batch.

Deklaration : Procedure Insignal (     ptr      : komm_ptr;
                                   VAR RadDelar : linepart_t;
                                       Antal    : integer     )
              [PUBLIC];

    Se Utsignal f|r parameterbeskrivning.
%page
Ramtest
-------

Beskrivning : Eventuella adresser mellan vilka RAM skall testas,
              konverteras till ASCII hex-tecken och skickas,
              m.h.a. Send_MddmMessage, tillsammans med
              RAMTEST-kommandot (G) till MDDM. 

              Meddelandet till kortet: (adress ; adress) G
              Svar fr}n kortet: 00 G     Om OK
                                FF G     Om felaktiga adresser
                                01-07 G  Om fel p} RAM

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 2
              sekunder. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas aktuell loggrutin, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Ramtest (     ptr      : komm_ptr;
                                  VAR RadDelar : linepart_t;
                                      Antal    : integer     )
              [PUBLIC];

    Se Utsignal f|r parameterbeskrivning.


Promtest
--------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              PROMTEST (H) till MDDM. 

              Meddelandet till kortet: H
              Svar fr}n kortet       : checksumma H

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Promtest [PUBLIC];
%page
Watchdog
--------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              WATCHDOG (K) till MDDM. 

              Meddelandet till kortet: K
              Svar fr}n kortet: K     Om OK
                                FF K  Om watchdog ej l|ste ut

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 30
              sekunder. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Watchdog [PUBLIC];


Reset
-----

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot RESET
              (L) till MDDM. 

              Meddelandet till kortet: L
              Svar fr}n kortet: L     Om OK
                                FF L  Om reset inte fungerat

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 2
              sekunder. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: -  Ej implementerad.

Deklaration : Procedure Reset [PUBLIC];
%page
SetNov
------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot SETNOV
              (M) till MDDM. 

              Meddelandet till kortet: M
              Svar fr}n kortet       : M

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure SetNov [PUBLIC];


CheckNov
--------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              CHECKNOV (N) till MDDM. 

              Meddelandet till kortet: N
              Svar fr}n kortet: 00 N  Om OK.
                                FF N  Om fel uppt{ckt.

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure CheckNov [PUBLIC];
%page
SioTest
--------
Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              SIOTEST (O) till MDDM. 

              Meddelandet till kortet: O
              Svar fr}n kortet: 00 O  Om OK.
                                01-1F O Om fel p} Sio'n

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure SioTest [PUBLIC];
