Modulen inneh}ller alla rutiner som sk|ter syntaxchecken av
kommandofilen. 


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


SplitLine
---------

Beskrivning : Delar upp en rad fr}n kommandofilen i element, d{r
              varje element {r det som avskilljs med blanka, tab
              eller kommatecken. Kontrollerar att numeriska
              v{rden {r ok, och konverterar dem till variabler.
              Returnerar felkod om det uppt{cks syntaxfel p}
              raden.

Anropas fr}n: 1) DoTest i modul Batch. (n{r kommandot utf|rs.) 
	      2) Do_Next i modul Loop. (n{r ett next-kommando
              ska titta p} motsv. for-komanndo.) 
	      3) SkapaKommandoLista i denna modul. (vid
              syntaxkontroll.) 

Deklaration : Procedure SplitLine (
			VAR delarna : linepart_t;
			VAR antal   : integer;
			VAR err     : error_t;
			VAR raden   : lstr80) [PUBLIC];

	Delarna : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
	antal : Antal element i delarna. 
	Err : felkod, visar om raden inneh}ller syntaxfel. 
	Raden : Raden som den ser ut i kommandofilen. 


ValOut
------

Beskrivning : Kontrollerar om ett v{rde ligger mellan ett max
              och ett minv{rde. Om v{rdet ligger mellan
              gr{nserna returnerar fall false annars true. 

Anropas fr}n: Flera av procedurerna i denna modul (Synt). 

Deklaration : Function ValOut(vaerde,lo,hi:real):boolean;

	Vaerde : V{rdet som skall kollas. 
	Lo : Undre gr{nsen. 
	Hi : \vre gr{nsen. 
%page
CheckFor
--------

Beskrivning : Syntaxkontrollerar FOR-kommandot, skapar
              loopvariabeln om den inte redan finns, loggar om
              det blir fel. Adressen till kommandot i den
              l{nkade listan l{ggs p} en stack s} att motsv.
              next-kommando skall hitta den. Kontrollerar att
              variablen inte {r en f|rdefinierad, att antal
              parametrar till for-kommandot {r tre eller fyra,
              att parametrarna {r av till}ten typ och att
              loopvariabeln inte redan anv{nds i en yttre
              for-slinga. Returnerar felkod om fel uppt{cks.

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckFor(
			curr:komm_ptr;	
		    VAR fnstack:fornext_a;
		    VAR	fnind:integer;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till for-kommandot i den l{nkade listan. 
	Fnstack : For-next stacken. Anv{nds f|r att hitta motsv
              for-kommando till ett next-kommando. 
	Fnind : Index i fnstack, var nuvarande for-next loop har
              sin kontrollinformation. 
	Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
	Numparts : Antal element i lineparts. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
CheckNext
---------

Beskrivning : Syntaxkontrollerar NEXT-kommandot, kollar att det
              finns ett for-kommando p} fornext-stacken och
              kopplar i hop det med next-kommandot. Returnerar
              felkod om fel uppt{cks. Loggar om det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckNext(
			curr:komm_ptr;	
		    VAR fnstack:fornext_a;
		    VAR	fnind:integer;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till next-kommandot i den l{nkade listan. 
	Fnstack : For-next stacken. Anv{nds f|r att hitta motsv
              for-kommando.
	Fnind : Index i fnstack, var nuvarande for-next loop har
              sin kontrollinformation. 
	Numparts : Antal element i raden.
	Error : felkod, visar om raden inneh}ller syntaxfel. 


CheckUtsignal
-------------

Beskrivning : Syntaxkontrollerar UTSIGNAL-kommandot, kollar att
              utsignalkommandot har r{tt antal parametrar, (2
              eller 3), att de {r av r{tt typ (variabel eller
              v{rde), att de {r mellan 0 och 255 och loggar om
              det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckUtsignal(
			curr:komm_ptr;	
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till utsignal-kommandot i den l{nkade
              listan. 
	Lineparts : raden uppdelad i element.
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel.
%page
CheckInsignal
-------------

Beskrivning : Syntaxkontrollerar INSIGNAL-kommandot, kollar att
              Insignalkommandot har r{tt antal parametrar, (2, 3
              eller 4), att de {r av r{tt typ (variabel eller
              v{rde), att de {r mellan 0 och 255 och loggar om
              det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckInsignal(
			curr:komm_ptr;	
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till Insignal-kommandot i den l{nkade
              listan. 
	Lineparts : raden uppdelad i element.
	Numparts : Antal element i raden.
	Error : felkod, visar om raden inneh}ller syntaxfel. 


CheckRamtest
------------

Beskrivning : Syntaxkontrollerar RAMTEST-kommandot, kollar att
              Ramtestkommandot har r{tt antal parametrar, (inga
              eller 2), att de {r av r{tt typ (variabel eller
              v{rde), att f|rstaparametern inte {r st|rre {n den
              andra om 2 v{rden angetts, kollar att
              parameterv{rden {r mellan 0 och 65535 och loggar
              om det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckRamtest(
			curr:komm_ptr;	
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till Ramtest-kommandot i den l{nkade
              listan. 
	Lineparts : raden uppdelad i element.
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
CheckIoport
-----------

Beskrivning : Syntaxkontrollerar IOPORT-kommandot, kollar att
              ioportkommandot har r{tt antal parametrar, (2 st),
              att de {r av r{tt typ (v{rde), att f|rsta
              parametern inte {r st|rre {n den andra, kollar att
              parameterv{rden {r mellan 0 och 65535 och loggar
              om det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckIoport(
			curr:komm_ptr;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till Ioport-kommandot i den l{nkade
              listan. 
	Lineparts : raden uppdelad i element.
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 


CheckNoparm
-----------

Beskrivning : Syntaxkontrollerar PROMTEST, WATCHDOG, SETNOV,
              CHECKNOV och SIOTEST dvs alla kommandon utom NEXT
              som {r parameterl|sa. Kontrollerar att de inte har
              n}gra parametrar. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckNoparm(
			curr:komm_ptr;	
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till kommandot i den l{nkade listan. 
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
CheckEnparm
-----------

Beskrivning : Syntaxkontrollerar SPANNING, ANALOG, PAUS och
              OBJEKT dvs de kommandon som bara ska ha en
              parameter. Kollar att parameter inte {r en str{ng
              samt att den ligger mellan gr{nsv{rden. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckEnparm(
			curr : komm_ptr;
		    VAR lineparts : linepart_t;
			numparts : integer;
		    VAR error : error_t;
			lolim : real;
			hilim : real);

	Curr : Adress till kommandot i den l{nkade listan. 
	Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 
	Lolim : l{gsta v{rde som parametern f}r anta.
	Hilim : h|gsta v{rde som parametern f}r anta. 


CheckLogg
---------

Beskrivning : Syntaxkontrollerar LOGG-kommandot. Kollar att det
              har minst en parameter. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckLogg(
			curr : komm_ptr;
		    VAR lineparts : linepart_t;
			numparts : integer;
		    VAR error : error_t);

	Curr : Adress till logg-kommandot i den l{nkade listan. 
	Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
SyntaxCheck
-----------

Beskrivning : Syntaxkontrollerar en rad i kommandofilen. Kollar
              att f|rsta delen av raden {r ett giltigt kommando,
              och att det inte har n}gra syntaxfel. 

Anropas fr}n: SkapaKommandoLista

Deklaration : Procedure SyntaxCheck(
			curr:komm_ptr;
		    VAR fnstack:fornext_a;
		    VAR fnind:integer;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

	Curr : Adress till logg-kommandot i den l{nkade listan. 
	Fnstack : For-next stacken. Anv{nds f|r att hitta motsv
              for-kommando till ett next-kommando. 
	Fnind : Index i fnstack, var nuvarande for-next loop har
              sin kontrollinformation. 
	Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
	Numparts : Antal element i raden. 
	Error : felkod, visar om raden inneh}ller syntaxfel. 


Open_KommandoFil
----------------

Beskrivning : \ppnar KommandoFil, filnamnet st}r i den globala
              variabeln ComFileName. Meddelar p} bildsk{rmen om
              |ppnandet misslyckades, samt returnerar en felkod.
              Felkoden kan vara NoError om |ppning gick bra
              annars OpenComFile. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Open_KommandoFil( VAR errcode:error_t ) [PUBLIC];

	Errcode : Felkod, visar om det g}tt bra att |ppna filen. 

Statiska variabler som {ndras:

Globala: KommandoFil.
%page
SkapaKommandoLista
------------------

Beskrivning : Huvudrutinen i syntaxcheckaren. Initierar l{nkade
              variabel- och kommando-listorna, l{ser in en rad i
              taget fr}n kommandofilen, utf|r syntaxkontroll av
              raden, kontrollerar att det finns tillr{ckligt med
              minne, l{mnar dock utrymme motsv. 20 l{nkar s} att
              stacken f}r plats, allokerar minne f|r raden i
              l{nkade kommandolistan, ser till att fel i raden
              loggas, returnerar felkod om syntaxkontrollen inte
              g}tt bra. Klist initieras till att peka p} det
              f|rsta kommandot i den l{nkade listan. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Procedure SkapaKommandoLista(VAR errcode:error_t)
              [PUBLIC]; 

	Errcode : Felkod, visar om det blivit n}got syntaxfel. 

Statiska variabler som {ndras:

Globala: klist.


TaBortKommandoLista
-------------------

Beskrivning : ]terl{mnar det minnet som tidigare allokerats till
              kommandolistan. Klist s{tts till NULL. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Procedure TaBortKommandoLista [PUBLIC];

Statiska variabler som {ndras:

Globala: klist.
