{*******************************************************}
{	includefile:	asynch.h			}
{*******************************************************}
{$list- $symtab-}

CONST
  COM1              =  1;              ! Mnemonics for port
  COM2              =  2;              ! numbers

  OK                =  0;              ! Mnemonics for
  INV_PORT          =  2;              ! Level Zero return codes
  PORT_NOT_OPEN     =  3;
  INV_PARAMETER     =  4;
  NO_PORT_FOUND     =  6;
  OUT_Q_FULL        =  7;
  PORT_OPEN_ALREADY =  9;
  IN_Q_EMPTY        = 10;

  INPUT_LOST        = #0001;           ! Mnemonics for
  ASYNCH_ERROR      = #0002;           ! port status word bits
  PARITY            = #0010;
  OVERRUN           = #0020;
  FRAMING           = #0040;
  BREAK_SIGNAL      = #0080;
  REM_XOFF          = #1000;
  REM_XON           = #2000;
  LOC_XOFF          = #4000;
  LOC_XON           = #8000;

  STATUS_ERR = INPUT_LOST or ASYNCH_ERROR or PARITY or OVERRUN
                  or FRAMING or BREAK_SIGNAL;

function open_a1 (port_no       : integer;    ! Open a COM port.
                  iq_size       : integer;
                  oq_size       : integer;
                  int_level     : integer;
                  port_ads      : integer;
                  buf_ads       : adsmem)
         : integer; EXTERN;

function close_a1(port_no       : integer)   ! Close a COM port.
         : integer; EXTERN;

function wrtch_a1(port_no       : integer;    ! Write a character
                  ch            : char)       ! to a COM port.
         : integer; EXTERN;

function wrtst_a1(port_no       : integer;    ! Write a string to
                  length        : integer;    ! a COM port.
                  str_ads       : adsmem;
                  var no_wrt    : integer)
         : integer; EXTERN;

function rdch_a1 (port_no       : integer;    ! Read a character
                  var ch        : char;       ! from a COM port.
                  var iqsize    : integer;
                  var pstatus   : word)
         : integer; EXTERN;

function rdst_a1 (port_no       : integer;    ! Read a string
                  length        : integer;    ! from a COM port.
                  str_ads       : adsmem;
                  var no_read   : integer;
                  var iqsize    : integer;
                  var pstatus   : word)
         : integer; EXTERN;

function qsize_a1(port_no       : integer;    ! Read an input
                  var iqsize    : integer;    ! queue size.
                  var pstatus   : word)
         : integer; EXTERN;

function iflsh_a1(port_no       : integer)    ! Flush an input
         : integer; EXTERN;                   ! queue.

function setop_a1(port_no       : integer;    ! Set a transmis-
                  option        : integer;    ! sion option.
                  parameter     : integer)
         : integer; EXTERN;

function time_a1                              ! Time of day
         : real; EXTERN;

procedure wait_a1(consts seconds: real); EXTERN; ! Suspend

function stat_a1 (	 port_no : integer;
		     var lstatus : byte;
		     var mstatus : byte    )
	   : integer; EXTERN;

{$list+ $symtab+}
