{$title:'MODULE: Batch' $pagesize:41 $linesize:106}

Module Batch;

{*******************************************************}
{	Denna modul innehaaller				}
{	testloopen som koers i batch mode		}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'screen.h'}
{$Include:'kbd.h'}
{$Include:'varhandl.h'}
{$Include:'synt.h'}
{$Include:'mddm.h'}
{$Include:'mddmkomn.h'}
{$Include:'pwckomn.h'}
{$Include:'objkomn.h'}
{$Include:'temp.h'}
{$Include:'loop.h'}
{$Include:'logg.h'}
{$Include:'tid.h'}
{$Include:'asynch.h'}
{$Include:'io.h'}

CONST
    ESC		= CHR (27);
    InBufSiz	= 256;
    OutBufSiz	= 256;
		  
VAR
    IOBuf_1	: string ( InBufSiz + OutBufSiz );
    IOBuf_2	: string ( InBufSiz + OutBufSiz );

Function Freect ( size : word ) : word; EXTERN;

{$page+}
{*******************************************************}
{	Ini_COM_Ports:					}
{	Initiera COM-portarna.				}
{*******************************************************}

Procedure Ini_COM_Ports;

VAR
    Status	: integer;

BEGIN	{ Ini_COM_Ports }
		{ Mot MDDM-korten }

    Eval ( Open_a1  ( COM1, InBufSiz, OutBufSiz, 0, 0, Ads IOBuf_1 ) );
    Eval ( close_a1 ( COM1 ) );		{ F|r s{kerhets skull }

    Status := Open_a1  ( COM1, InBufSiz, OutBufSiz, 0, 0, Ads IOBuf_1 );
    IF Status <> OK THEN
        Logga_SerErr ( Open_COM1, Status );
    Eval ( setop_a1 ( COM1, 1, 7 ) );	{ Baudrate 9600 }
    Eval ( setop_a1 ( COM1, 2, 1 ) );	{ Odd parity }
    Eval ( setop_a1 ( COM1, 3, 2 ) );	{ 7 data bits }
    Eval ( setop_a1 ( COM1, 4, 1 ) );	{ One stop bit }
    Eval ( setop_a1 ( COM1, 5, 1 ) );	{ XON - XOFF }
    Eval ( setop_a1 ( COM1, 6, 1 ) );	{ XON - XOFF }
    Eval ( setop_a1 ( COM1, 9, 0 ) );	{ No CTS }

		{ Mot Power-Controllern }

    Eval ( Open_a1  ( COM2, InBufSiz, OutBufSiz, 0, 0, Ads IOBuf_2 ) );
    Eval ( close_a1 ( COM2) );		{ F|r s{kerhets skull }

    Status := Open_a1  ( COM2, InBufSiz, OutBufSiz, 0, 0, Ads IOBuf_2 );
    IF Status <> OK THEN
        Logga_SerErr ( Open_COM2, Status );
    Eval ( setop_a1 ( COM2, 1, 7 ) );	{ Baudrate 9600 }
    Eval ( setop_a1 ( COM2, 2, 1 ) );	{ Odd parity }
    Eval ( setop_a1 ( COM2, 3, 2 ) );	{ 7 data bits }
    Eval ( setop_a1 ( COM2, 4, 1 ) );	{ One stop bit }
    Eval ( setop_a1 ( COM2, 5, 1 ) );	{ XON - XOFF }
    Eval ( setop_a1 ( COM2, 6, 1 ) );	{ XON - XOFF }
    Eval ( setop_a1 ( COM2, 9, 0 ) );	{ No CTS }

END;	{ Ini_COM_Ports }

{$page+}
{*******************************************************}
{	Startup:					}
{	Initieringar					}
{*******************************************************}

Procedure Startup;

BEGIN	{ Startup }

    DebugWriteLn ( 'Nollst{llning av tid' );
    IniTime;		{ For berakning av forbrukad testtid }

    DebugWriteLn ( 'Nollst{llning av statistiken' );
    Reset_Counters;	{ Test-statistik-tabellen }

    DisplayTimes;
    DebugWriteLn ( 'Initiering av COM-portarna' );
    Ini_COM_Ports;	{ Initiera portarna mot Mddm-korten och PwC:n }
    IF SerErr <> No_SerErr THEN RETURN;

    DisplayTimes;
    DebugWriteLn ( 'Initiering av Power-controllern' );
    Ini_PwC;		{ Initiering av Power-controllern }
    IF SerErr <> No_SerErr THEN RETURN;

    DisplayTimes;
    DebugWriteLn ( 'Initiering av rel{-portarna' );
    Ini_RelaPorts;	{ Initiera portarna mot relakortet }

    DisplayTimes;
    DebugWriteLn ( 'Kontroll av samtliga kortplatser' );
    Check_Objekts;	{ Svarar objektinmatningen mot hur korten sitter? }
    IF SerErr <> No_SerErr THEN RETURN;

    DisplayTimes;
    DebugWriteLn ( 'Nollst{llning av masktabell f|r UTSIGNAL' );
    Reset_OldValue;	{ Tabell vid maskning i Utsignal }

END;	{ Startup }

{$page+}
{*******************************************************}
{	DoTest:						}
{	Kor igenom den laenkade listan			}
{*******************************************************}

Function DoTest:error_t [PUBLIC];

VAR
    ptr		: komm_ptr;
    raddelar	: linepart_t;	{ den uppdelade raden }
    antal	: integer;	{ antal element i raden }
    errcode	: error_t;
    i		: integer;
    PausEnd	: integer4;
    EscOn	: boolean;	{ true om escape har tryckts }
    Avbryt	: boolean;	{ true om avbrytning begaerts }
    EscTid	: real;		{ tid naer "escape-raden" skall tas bort }
    MddmTestat	: boolean;	{ s{tts till true om n}got mddmkommando k|rts, dvs n{r statistiken skall ut }
    c		: char;
    MsgStr	: lstring(80);

BEGIN	{ DoTest }

    IF Ant_obj = 0 THEN BEGIN
    	DoTest := NoTestObjects;
	RETURN;
    END;

    SerErr := No_SerErr;

    DoTest := NoError;
    Open_KommandoFil (errcode);
    IF errcode <> NoError THEN BEGIN
	DoTest := errcode;
	Close(KommandoFil);
	RETURN;
    END;

    Open_LoggFil;

    Make_FdefVarTab;

    Proff;			{ Satt printflagga till kant varde  }
    Check_Printer(PrStat);	{ Satt printning om printern OK }
    Init_Lista;			{ initiera rubrikerna i loggfilen }

    New(ptr);
    EVAL ( Encode ( MsgStr, (Freect( Sizeof(ptr^) )-20):1 ) );
    DebugWrite ( 'Max antal exekverbara rader i kommandofilen ca. ');
    DebugWriteLn ( MsgStr );
    Dispose(ptr);

    SkapaKommandoLista(errcode);
    Close (KommandoFil);
    IF errcode <> NoError THEN BEGIN   { error fraan Skapa... }
	DoTest := errcode;
	Close(LoggFil);
	TaBortKommandoLista;
	TaBortVariabelLista;
	Return;
    END;

    CposWrite( 1, 1, 'Sp{nn:       H:   SL:');

    Startup;		{ Initieringar }

    ptr := klist;	{ initiera pointern }
    PausEnd := 0;

    EscOn := false;
    Avbryt := false;

    MddmTestat := FALSE;

    IF SerErr = No_SerErr THEN BEGIN
    	InvVid;
	ScrollWriteLn ( 'Testen startar' );
	NorVid;
    END;

    WHILE ( SecUsed < TotTid ) AND ( ptr <> NIL ) AND ( NOT avbryt ) AND
          ( SerErr = No_SerErr ) DO BEGIN
	DisplayTimes;		{ uppdatera klockorna }
	IF SecUsed >= PausEnd THEN BEGIN
	    SplitLine(raddelar,antal,errcode,ptr^.txt);	{ dela upp raden }
	    IF errcode <> NoError THEN
		DebugWriteLn ( 'Error in batch' );	{ D }

	    Screen_logg ( raddelar, antal, ptr );	{ skriv p} sk{rmen }

	    CASE ptr^.komm OF
		kUtsignal : BEGIN MddmTestat := TRUE; Utsignal ( ptr, raddelar, antal ); END;
		kInsignal : BEGIN MddmTestat := TRUE; Insignal ( ptr, raddelar, antal ); END;
		kRamtest  : BEGIN MddmTestat := TRUE; Ramtest  ( ptr, raddelar, antal ); END;
		kPromtest : BEGIN MddmTestat := TRUE; Promtest; END;
		kWatchdog : BEGIN MddmTestat := TRUE; Watchdog; END;
		kReset    : BEGIN MddmTestat := TRUE; Reset; END;
		kSetnov   : BEGIN MddmTestat := TRUE; SetNov; END;
		kChecknov : BEGIN MddmTestat := TRUE; CheckNov; END;
		kSiotest  : BEGIN MddmTestat := TRUE; SioTest; END;
		kIoport   : Ioport( raddelar[2].vaerde, raddelar[3].vaerde ); 
		kFor      : Do_For   ( ptr, raddelar, antal );
		kNext     : Do_Next  ( ptr );
		kPaus     : PausEnd := Paus ( ptr, raddelar );
		kTemp     : Set_Temp	( ptr, raddelar );
		kSpanning : Set_Spanning	( ptr, raddelar );
		kAnalog   : Set_Analog	( ptr, raddelar );
		kLogg     : Logg	 ( raddelar, antal );
		kObjekt   : Choose_Objekt	( ptr, raddelar );
	    END;  { CASE }
	    ptr := ptr^.pnext;		{ Nasta kommando }
	END; { IF }


	{ ta hand om ev. tangentnertryckning }
	WHILE KeyPressed DO BEGIN
	    c := GetCh;
	    IF EscOn THEN BEGIN		{ var foerra tecken ett escape ? }
		EscOn := false;
		ClrLine(24);
		CASE c OF
		    'p','P' : Check_Printer(PrStat);	{ printer paa om OK }
		    'q','Q' : avbryt := true;	{ avbryt test }
		    's','S' : PrOff;		{ printer av }
		OTHERWISE
		    ;				{ dummy }
		END; { CASE }
	    END ELSE BEGIN
		IF c = ESC THEN BEGIN
		    EscOn := true;
		    EscTid := SecUsed + 15;	{ Man har 15 sek pa sig att ange val }
		    InvVid;
		    CposWrite(24,1,'P: printer p}, S: printer av, Q: avbryt test');
		    NorVid;
		END; { c = ESC }
	    END; { EscOn }
	END; { WHILE }

	IF EscOn AND ( EscTid < SecUsed ) THEN BEGIN
	    EscOn := false;
	    ClrLine(24);	{ rensa meddelandet paa rad 24 }
	END; { IF }

    END;  { WHILE }


    IF NOT ( SerErr in [PwCContact, PwC_Init, PwcNoAck,
    			PwC_SRQ, PwCComErr,Open_COM2] ) THEN
    	Exit_PwC;		{ sl} av 5-volten }

    Ini_RelaPorts;	{ Sl{pp alla rel{er }

    Disconnect_Kort;	{ Koppla bort 12-volten }

    CposWrite( 1, 1, '                     '); { Blanka sp{nning, hylla & slot }

    IF SerErr <> No_SerErr THEN
	MsgStr := 'Fel har intr{ffat, testet kan ej forts{tta'
    ELSE IF avbryt THEN
    	MsgStr := 'Testet avbrutet av operat|ren'
    ELSE IF ptr = NIL THEN
    	MsgStr := 'Testsekvensen slut'
    ELSE
	MsgStr := 'Testet klart';
    
    Logga_Msg(MsgStr);		{ skriv p} loggen }

    IF MddmTestat THEN BEGIN
    	DebugWriteLn ( ' ' );
    	DebugWriteLn ( 'Statistikutskrift p}g}r' );
    	Statistik;
    END;

    If PrintOn THEN
    	Check_Printer ( Print ( chr(12) ) );	{ Formfeed till printern }

    ScrollWriteLn(' ');		{ blankrad p} sk{rmen }
    ErrMsg(MsgStr);		{ meddelandet + kvittera... }

    Eval ( Close_a1 ( COM1 ) );		{ Stang portar }
    Eval ( Close_a1 ( COM2 ) );

    CposWrite ( 1, 60, '                    ' ); { Sl{ck tiderna }

    Close ( LoggFil );

    TaBortKommandoLista;
    TaBortVariabelLista;
    Release_PortCnt;	{ tar bort ev. allokerat minne f|r portfelr{knarna }

END; { DoTest }

END. { module }
