{*******************************************************}
{	includefile:	decl.h				}
{*******************************************************}
{$list- $symtab-}
CONST
  maxparm = 10;		{ max antal parametrar paa en kommandorad }
  maxelem = maxparm+1;	{ max antal element per rad }
  fnmax   = 15;		{ max antal nivaaer i for-next-loopar }

  tempmin = 0;		{ minsta temperatur }
  tempmax = 50.0005;	{ hoegsta temperatur }
  spamin = 0;		{ minsta spaenning }
  spamax = 5.2505;	{ hoegsta spaenning }
  anamin = 1;		{ Minsta analog-spaenning }
  anamax = 9.005;	{ Hoegsta analog-spaenning }
  pausmin = 1;		{ minsta paustid }
  pausmax = 1000.5;	{ hoegsta paustid }
  objmin = 1;		{ minsta antal objekt }
  objmax = 50;		{ hoegsta antal objekt }
  hyllant = 5;		{ antal hyllor }
  slotant = 10;		{ antal slot i varje hylla }
  objidsize = 40;	{ antal tecken i objekt-id }
  antkomm = 18;		{ antal kommandon }
  comfilename_size = 30;{ antal tecken i kommandofilnamn }

  TAB = chr(9);

  delim = [' ',TAB,','];	{ blank, tab & komma }

TYPE
  SerErr_t = (	No_SerErr, PwCContact, PwC_Init, PwcNoAck,
  		PwC_SRQ, PwCComErr,
  		Open_COM1, Open_COM2, Mem_Alloc, Id_Obj_Not_OK );

	{ funktionstangenter som foerekommer }
  ftang_t = (	f_1, f_2, f_3, f_4, f_5, f_6, f_7, f_8,
		f_9, f_10, f_up, f_down, f_left, f_right,
		f_home, f_end, f_pgup, f_pgdn, f_enter,
		f_esc, f_other );
  ftang_set = set of ftang_t;

	{ menuer som foerekommer }
  menu_t = (	m_main, m_objekt );

  error_t = (	NoError, KommandoSaknas, AntParms,
		ParmTyp, NestedForVariable,
		ForLevel, NextLevel, ValueOut,
		NoStringEnd, NoValue,
		MissingNextStatement, IllegalCharacter,
		NoFilename, NoTestobjects,
		OpenComFile, ReadComFile, OutOfMemory
		);

  ktyp = (	kFor, kUtsignal, kInsignal, kRamtest,
		kPromtest, kWatchdog, kTemp,
		kSpanning, kAnalog, kPaus, kLogg, kObjekt,
		kSetnov, kChecknov, kReset, kSiotest,
		kIoport,
		kNext, saknas, kommentar);

  vartyp_t = ( Fordefinierad, Egendefinierad );

  eltyp = (variabel,vaerde,strng);	{ de tre olika elementen }

  str8  = string(8);
  str9  = string(9);

  lstr2  = lstring(2);
  lstr3  = lstring(3);
  lstr4  = lstring(4);
  lstr5  = lstring(5);
  lstr8  = lstring(8);
  lstr10 = lstring(10);
  lstr12 = lstring(12);
  lstr80 = lstring(80);

  element = RECORD	{ en del av kommandoraden }
    txt : lstr80;	{ straengen }
    typ : eltyp;	{ vilken sorts element }
    indx : integer;	{ index var i kommandoraden elementet boerjar }
    vaerde : real;	{ vaerde pae elementet om det aer en konstant }
  END;

  linepart_t = ARRAY [1..maxelem] OF element;

  komm_ptr = ^komm_t;

  komm_t = RECORD	{ ett record i laenkade kommanolistan }
    txt : lstr80;	{ raden som den ser ut i kommandofilen }
    komm : ktyp;	{ kommandot }
    pnext : komm_ptr;	{ pekare till naesta kommando i laenkade listan }
    pjmp : komm_ptr;	{ pekare till motsv. for eller next-kommando }
    linenr : integer;	{ radnr i kommandofilen }
  END;

  id_t = lstring(objidsize);

  obj_t = record
    hyllnr : integer;	{ vilken hylla }
    slotnr : integer;	{ vilket slot i aktuell hylla }
    id : id_t;
  END;

  rack_t = array [1..objmax] of obj_t;	{ hela racket }

  PlatsStat_t	= ( Plats_OK, Kort_Saknas, Id_Saknas );
  ObjInfo_t	= array [1..10] of PlatsStat_t;
  HyllInfo_t	= RECORD
    		  HyllFel : boolean;
		  ObjInfo : ObjInfo_t;
		  END;
  RackTab_t	= array [1..5] of HyllInfo_t;

  ParmTyp_t	= ( AdressParm, PortParm, MaskParm, InDataParm, UtDataParm,
		    TempParm, SpanningParm, AnaSpannParm, ObjNrParm, TidParm );

  ErrParmRec_t	= RECORD
		  Varde		: real;
		  ParmTyp	: ParmTyp_t; END;

  ErrParmArea_t	= ARRAY [1..3] OF ErrParmRec_t; { For felaktiga parametrar }

  KortFel_t	= ( No_Error, KomFel, TestNeg, FelSvar, TimeOut );

{$list+ $symtab+}
