{$title:'MODULE: Kbd' $pagesize:41 $linesize:106}

Module Kbd;

{*******************************************************}
{	Denna modul innehaaller				}
{	rutiner som hanterar keyboard			}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'io.h'}
{$Include:'screen.h'}

function DOSXQQ(command,parameter:word):byte; EXTERN;

TYPE
	ft_arr = array[f_1..f_pgdn] of char;

CONST
	BS = chr(8);
	NULL = CHR(0);
	ENTER = CHR(13);

	{ koppling mellan ftang_t och tecknena efter null }
	ft_char = ft_arr (
		chr(59),chr(60),chr(61),	{ f_1 - f_3 }
		chr(62),chr(63),chr(64),	{ f_4 - f_6 }
		chr(65),chr(66),chr(67),	{ f_7 - f_9 }
		chr(68),chr(72),chr(80),	{ f_10,f_up,f_down }
		chr(75),chr(77),chr(71),	{ f_left,f_right,f_home }
		chr(79),chr(73),chr(81) );	{ f_end,f_prup,f_pgdn }


{$page+}
{*******************************************************}
{	GetCh:						}
{	laeser ett tecken fraan keyboard		}
{	vaentar tills naagon tangent tryckts		}
{*******************************************************}
function GetCh : char [PUBLIC];

BEGIN { GetCh }

	GetCh := chr(DOSXQQ(8,0));	{ laes ett tecken utan echo }

END; { GetCh }

{$page+}
{*******************************************************}
{	GetStr:						}
{	laeser ett antal tecken fraan keyboard		}
{	t.o.m. godkaend funktionstangent		}
{*******************************************************}
function GetStr( VAR txt  : lstring ;	{ datat }
		     f_ok : ftang_set;	{ tillatna funktionstangenter }
		     rad  : integer;	{ vilken rad foer kursorn }
		     kol  : integer;	{ vilken kolumn foer kursorn }
		     size : integer	{ max laengd }
		         ): ftang_t [PUBLIC];	{ retur: funktionstangenten }

VAR
	pos : integer;		{ position inom fealtet (index i txt) }
	ftang : ftang_t;	{ senast tryckta funktionstangent }
	fi : ftang_t;		{ soek-index }
	i : integer;
	changed : boolean;	{ om innehaallet i faeltet aendrats }
	ftflag : boolean;	{ om funktionstangent tryckts }
	ch : char;		{ tecknet }

BEGIN { GetStr }
	IF size <> 0 THEN
	    CursOn;	{ taend cursor }
	pos := 1;
	Cpos(rad,kol);
	changed := false;
	REPEAT
	    ftflag := false;	{ ingen funktiontangent }
	    ch := GetCh;	{ laes ett tecken }
	    CASE ch OF
		NULL : BEGIN
		    ch := GetCh;	{ tecknet efter null }
		    FOR fi := f_1 TO f_pgdn DO
			IF ch = ft_char[fi] THEN BEGIN
			    ftflag := true;
			    ftang := fi;
			END;
		END; { NULL }

		ENTER : BEGIN
		    ftflag := true;
		    ftang := f_enter;
		END; { ENTER }

		BS : IF pos > 1 THEN BEGIN
		    pos := pos - 1;
		    Write(BS,' ',BS);
		    txt[pos] := ' ';
		END; { BS }

		chr(32)..chr(126),chr(128)..chr(254) : BEGIN
		    IF (pos = 1) and (size > 0) and (NOT changed) THEN BEGIN
			txt.len := wrd(size);
			txt[1] := ch;
			FOR i := 2 TO size DO
			    txt[i] := ' ';	{ blanka faeltet }
			write(txt);
			Cpos(rad,kol+1);
			changed := true;
			pos := pos + 1;
		    END ELSE BEGIN
			IF pos <= size THEN BEGIN
			    txt[pos] := ch;
			    pos := pos + 1;
			    Write(ch);
			END;
		    END;
		END; { printbara tecken }

		OTHERWISE
 	    ;	{ dummy }

	    END; { CASE }
	UNTIL ftflag AND (ftang in f_ok);

	IF changed THEN
	    txt.LEN := wrd(pos - 1);
	GetStr := ftang;
	CursOff;	{ slaeck cursor }
END; { GetStr }

{$page+}
{*******************************************************}
{	KeyPressed:					}
{	Kontrollerar (utan att goera naagon laesning)	}
{	ifall naagon tangent har tryckts ner		}
{*******************************************************}
function KeyPressed : boolean [PUBLIC];

BEGIN { KeyPressed }

	KeyPressed := ( DOSXQQ(11,0) = 255 );

END; { KeyPressed }


END. { module }
