{$title:'MODULE: Log' $pagesize:41 $linesize:106}

Module Log;

{*******************************************************}
{	Modulen innehaller loggrutinerna.	 	}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'varhandl.h'}
{$Include:'mddm.h'}
{$Include:'tid.h'}
{$Include:'kbd.h'}
{$Include:'screen.h'}
{$Include:'io.h'}

Function Freect ( size : word ) : word; EXTERN;
Procedure Time  ( VAR	S  : string ); EXTERN;
Function ALLMQQ ( WANTS : WORD ) : ADSMEM; EXTERN; 
Function FREMQQ ( BLOCK : ADSMEM ) : WORD; EXTERN;

Procedure Logga; FORWARD;

TYPE
    NrStr_t	= ARRAY [1..10] OF lstring(3);

    FelCount_t	= RECORD
		  Sub	: integer4; { Antal fel sedan senast lyckade }
		  Tot 	: integer4; { Totalt antal fel } END;

    FelTyp_t	= ARRAY [TestNeg..TimeOut] OF FelCount_t;

    TestStat_t	= RECORD
		  TestAnt : integer4; { Totalt antal tester }
 		  Fel	  : FelTyp_t; { Felstatistik } END;

    PortRec_t	= PACKED RECORD
   		  FelCnt     : FelCount_t; { Felr{knarna f|r porten }
		  LastVal    : byte;	   { Senast l{sta v{rde p} porten }
		  LastExpVal : byte; { Senast f|rv{ntade v{rde p} porten }
		  END;  

    Port_t	= ARRAY [0..255] OF PortRec_t;

    ObjStat_t	= RECORD
    		  KretsStat : ARRAY ['G'..'O'] OF TestStat_t;
		  RamFelTyp : lstr3;	{ feltyp vid senaste ramfel }
		  SioFelTyp : lstr3;	{ feltyp vid senaste SIOTEST-fel }
		  CommCnt   : Integer4; { antal kommunikationsfel mot mddm }
		  ioport    : ADS OF port_t;	{ felr{knare f|r varje port } END;

    StatTab_t	= ARRAY [objmin..objmax] OF ObjStat_T;

    ParmTypStr_t= ARRAY [AdressParm..TidParm] OF lstring(15);

    TestNamn_t	= ARRAY ['G'..'O'] OF lstring(10);

    FelStr_t	= ARRAY [TestNeg..TimeOut] OF lstring(13);

{$page+}
CONST

    LastLine		= 42;		{ Antal rader pa papperet }
    streck = '------------------------------------------------------------------------------------------------------------------';

    NrStr	= NrStr_t(' 1',' 2',' 3',' 4',' 5',' 6',' 7',' 8',' 9',' 10');

    ParmTypStr	= ParmTypStr_t(	'ADRESS',
				'PORT',
				'MASK',
				'INDATA',
				'UTDATA',
				'TEMP',
				'SPANNING',
				'ANALOG-SPANNING',
				'OBJEKT-NUMMER',
				'TID'		  );

    TestNamn	= TestNamn_t (	'RAMTEST',
				'PROMTEST',
				'INSIGNAL',
				'UTSIGNAL',
				'WATCHDOG',
				'RESET',
				'SETNOV',
				'CHECKNOV',
				'SIOTEST'   );

    FelStr	= FelStr_t (	'NEGATIVT',
				'KORT-SVAR FEL',
				'TIMEOUT'        );

VAR
    LoggFilNamn	: lstring(13);
    HuvudStr_1	: lstring(132);	{ Logghuvud pa  varje sida }
    HuvudStr_2	: lstring(132);	{ Logghuvud, rubriker }
    TextStr	: lstring(132);	{ Strangen som loggas }
    Count	: StatTab_t;	{ Teststatistk }
    TmpDatum	: str9;		{ l{gg datum h{r medans loggning sker s} att man har samma datum hela tiden }
    OldDate	: str9;		{ Datum senast loggade rad }
    Sida	: integer;	{ Sida i loggningen }
    LineNr	: integer;	{ Radraknare }
    MddmHuvud	: boolean;	{ om alla rubrikrader skall ut }
    LowIO	: integer;	{ i/o-adress till port med l{gsta nummer vars fel skall separatr{knas }
    HighIO	: integer;	{ i/o-adress till port med h|gsta nummer vars fel skall separatr{knas }
    NumIO	: integer;	{ antal i/o-adresser dvs HighIO-LowIO+1 }
    IOCntAlloc	: boolean;	{ s{tts true n{r minne f|r ioportfelr{knarna allokeras }
    DiskErr	: boolean;	{ true om det blir felkod fr}n disken }

{$page+}
{*******************************************************}
{	Open_LoggFil.					}
{	Oppnar loggfilen.				}
{*******************************************************}

Procedure Open_LoggFil [PUBLIC];

{$page+}
{*******************************************************}
{	Make_LoggFilNamn.				}
{	Skapar ett loggfil-namn.			}
{*******************************************************}

Procedure Make_LoggFilNamn;

VAR
    TmpStr	: str9;
    StartTid	: lstr8;

BEGIN	{ Make_LoggFilNamn }

    TmpStr := Datum;
    StartTid.len := 8;
    Time ( StartTid );
    LoggFilNamn[1] := TmpStr[2];			{ Ar }
    IF TmpStr[4] = '1' THEN
	TmpStr[5] := Chr ( Ord(TmpStr[5]) + 17 );	{ ( HEX ) }
    LoggFilNamn[2] := TmpStr[5];			{ Manad }
    LoggFilNamn[3] := TmpStr[7];			{ Dag }
    LoggFilNamn[4] := TmpStr[8];			{ Dag }
    LoggFilNamn[5] := StartTid[1];			{ Timme }
    LoggFilNamn[6] := StartTid[2];			{ Timme }
    LoggFilNamn[7] := StartTid[4];			{ Minut }
    LoggFilNamn[8] := StartTid[5];			{ Minut }
    LoggFilNamn.LEN := 8;
    Concat ( LoggFilNamn, '.LOG ' );

    CposWrite ( 23, 1, 'LOGGFIL: ' );
    CposWrite ( 23, 10, LoggFilNamn );

END;	{ Make_LoggFilNamn }

{$page+}
{*******************************************************}

BEGIN	{ Open_LoggFil }

    Make_LoggFilNamn;
    Assign ( LoggFil, LoggFilNamn );
    Loggfil.TRAP := true;		{ Error trapping paaslagen }
    Loggfil.ERRS := 0;			{ For sakerhets skull }
    ReWrite ( LoggFil );
    IF Loggfil.ERRS <> 0 THEN BEGIN
	ShowFileErr( 'OPEN','Loggfil', LoggFilNamn, Ord( Loggfil.ERRS ) );
	Close( Loggfil );
	RETURN;
    END;

END;	{ Open_LoggFil }

{$page+}
{*******************************************************}
{	PrOff						}
{	Slar av printer					}
{*******************************************************}

Procedure PrOff [PUBLIC];

BEGIN	{ PrOff }

	PrintOn := false;
	InvVid;
	CposWrite(25,73,' PrOff ');
	NorVid;

END;	{ Proff }

{$page+}
{*******************************************************}
{	Check_Printer.					}
{	Kollar att printern ar OK.			}
{*******************************************************}

Procedure Check_Printer ( status:byte ) [PUBLIC];

VAR
    PrintOn_Old : boolean;

BEGIN	{ Check_Printer }

    PrintOn_Old := PrintOn;
    PrintOn := ( status AND 2#00111000 ) = 2#00010000;

    IF PrintOn <> PrintOn_Old THEN BEGIN
	IF PrintOn THEN BEGIN
	    InvVid;
	    CposWrite(25,73,' PrOn  ');
	    NorVid;
	END ELSE
	    PrOff;
    END;

END;	{ Check_Printer }

{$page+}
{*******************************************************}
{	HexKonv Konvertera integer till en str{ng i	}
{	hexformat. ex: #00				}
{*******************************************************}

function HexKonv ( AntNumTkn : integer;
		   talet     : integer ): lstr5 [PUBLIC];


VAR
    i   : integer;
    str : lstr5;

BEGIN	{ HexKonv }

    
    Eval ( Encode ( str, talet: AntNumTkn+1 :16 ) );
    str[1] := '#';
    FOR i := 2 TO AntNumTkn DO
	IF Str[i] = ' ' THEN
	    Str[i] := '0';
    HexKonv := str;


END;	{ HexKonv }

{$page+}
{*******************************************************}
{	PStatKonv Konverterar PStatus till hex		}
{	ex: #XX01					}
{*******************************************************}

function PStatKonv ( Pstat : integer ): lstr5 [PUBLIC];


BEGIN	{ PStatKonv }

    PStatkonv := HexKonv ( 4, Pstat );
    PStatkonv[2] := 'X';
    PStatkonv[3] := 'X';

END;	{ PStatKonv }

{$page+}
{*******************************************************}
{	Add_Space:					}
{	Lagg till blanka till angiven kolumn.		}
{*******************************************************}

Procedure Add_Space ( Kolumn : byte );

VAR
    i	: byte;

BEGIN	{ Add_Space }

    FOR i := (TextStr.LEN + 2)  TO Kolumn DO
	Concat ( TextStr, ' ' );

END;	{ Add_Space }

{$page+}
{*******************************************************}
{	Concat_Value:					}
{	Skrive en real pa snyggt satt pa loggen		}
{*******************************************************}

Procedure Concat_Value ( ReVal  : real;
			 HexFlg : boolean );

VAR
    VardeStr	: lstr10;

BEGIN	{ Concat_Value }

	IF ABS ( ReVal - Round (ReVal) ) > 0.001 THEN
	    Eval ( Encode ( VardeStr, ReVal :1 :3 ) )
	ELSE IF NOT HexFlg THEN
	    Eval ( Encode ( VardeStr, Round (ReVal) :1 ) )
	ELSE BEGIN
	    Eval ( Encode ( VardeStr, Round (ReVal) :1 :16 ) );
	    Insert ( '#', VardeStr, 1 );
	END; { ELSE }
	Concat ( TextStr, VardeStr );

END;	{ Concat_Value }

{$page+}
{*******************************************************}
{	Make_LoggHuvud					}
{*******************************************************}

Procedure Make_LoggHuvud;

CONST
    FF			= chr(12);	{ Formfeed }
    LF			= chr(10);	{ Linefeed }
    CR			= chr(13);	{ Carrige Return }

VAR
    SidaStr	: lstr4;
    i		: byte;

BEGIN	{ Make_LoggHuvud }
 
    HuvudStr_1 := FF;
    Concat ( HuvudStr_1, 'DATUM: ' );
    Concat ( HuvudStr_1, TmpDatum );
    Concat ( HuvudStr_1, ' LOGGFIL: ' );
    Concat ( HuvudStr_1, LoggFilNamn );
    Concat ( HuvudStr_1, ' KOMMANDOFIL: ' );
    Concat ( HuvudStr_1, ComFileName );
    FOR i := (HuvudStr_1.LEN + 2)  TO 110 DO
	Concat (HuvudStr_1, ' ' );
    Eval ( Encode (SidaStr, Sida :4 ) );
    Concat ( HuvudStr_1, SidaStr );
    Concat ( HuvudStr_1, CR );
    Concat ( HuvudStr_1, LF );
    HuvudStr_2 := 'TID      F\RB.TID SP[NN H SL TEXT';
    FOR i := 4 TO IdLength DO
    	Concat ( HuvudStr_2, ' ' );
    Concat ( HuvudStr_2, 'TEST       RESULTAT           TIDIGARE FELTYP' );

END;	{ Make_LoggHuvud }

{$page+}
{*******************************************************}
{	Put_Times:					}
{	Lagg tid och forbrukad testtid i strangen.	}
{*******************************************************}

Procedure Put_Times;

VAR
    Aktuell_Tid	: str8;
    UsedTime	: str9;

BEGIN	{ Put_Times }

    TmpDatum := Datum;		{ Sa att datum och tid stammer }
    Time ( Aktuell_Tid );
    CopyLst ( Aktuell_Tid, TextStr );
    Concat ( TextStr, ' ' );
    UsedTime := TimeUsed;
    Concat ( TextStr, UsedTime );

END;	{ Put_Times }

{$page+}
{*******************************************************}
{	Add_MddmInfo:					}
{	Lagg till hylla, slot och id.			}
{*******************************************************}

Procedure Add_MddmInfo;

VAR
    Hylla	: lstr2;
    Slot	: lstr3;

BEGIN	{ Add_MddmInfo }

    Add_Space (25);
    Eval ( Encode ( Hylla, rack[Obj].hyllnr :1 ) );
    Concat ( TextStr, Hylla );

    Add_Space (27);
    Eval ( Encode ( Slot, rack[Obj].slotnr :2 ) );
    Concat ( TextStr, Slot );

    Add_Space (30);
    Concat ( TextStr, rack[Obj].id );

END;	{ Add_MddmInfo }

{$page+}
{*******************************************************}
{	Logga_Msg Loggar ett valfritt meddelade p}	}
{	loggemedierna					}
{*******************************************************}

Procedure Logga_Msg ( CONST msg : string ) [PUBLIC];

VAR
    i		: integer;

BEGIN	{ Logga_Msg }

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (30);
    Concat( TextStr, msg);
    Logga;

END;	{ Logga_Msg }

{$page+}
{*******************************************************}
{	DiskLogg:					}
{	skriver en logg-rad p} disk.			}
{*******************************************************}

Procedure DiskLogg ( CONST msg : string );

VAR
    str		: lstr80;

BEGIN	{ DiskLogg }

    If NOT DiskErr THEN BEGIN
    	WriteLn ( LoggFil, msg );		{ Skriv ut pa loggfil }
	IF Loggfil.ERRS <> 0 THEN BEGIN
	    DiskErr := true;
	    IF Loggfil.ERRS = 8 THEN
		str := 'Disken full, loggning forts{tter endast p} printern'
	    ELSE BEGIN
		EVAL ( ENCODE ( str, Loggfil.ERRS : 1 ) );
		INSERT ( 'Fel fr}n Disk, loggning forts{tter endast p} printern, felkod: ', str, 1);
	    END;
	    logga_msg ( str );
	END;
    END; { IF }

END;	{ DiskLogg }

{$page+}
{*******************************************************}
{	Logga.						}
{	Loggar en textstrang.				}
{*******************************************************}

Procedure Logga;

CONST
    BusyTimeOut		= 5;		{ Sekunder }

VAR
    newpage		: boolean;	{ om det skall bytas sida }

BEGIN	{ Logga }

    IF (TmpDatum <> OldDate) OR (LineNr > LastLine) THEN BEGIN
    	OldDate := TmpDatum;
	Sida := Sida + 1;
	Make_LoggHuvud;			{ Fyll HuvudStr_1 och HuvudStr_2 }
	LineNr := 0;
    END; { IF }

    newpage := false;

    IF LineNr = 0 THEN BEGIN
        newpage := true;
        LineNr := 4;
	DiskLogg ( HuvudStr_1 );
	IF Mddmhuvud THEN BEGIN
	    LineNr := 5;
	    DiskLogg( HuvudStr_2 );
	END;
	DiskLogg ( streck );
    END;
    DiskLogg ( TextStr );		{ Skriv ut pa loggfil }

    IF newpage THEN BEGIN
    	IF PrintOn THEN
	    Check_Printer ( PrintLn ( HuvudStr_1 ) );
	IF Mddmhuvud AND PrintOn THEN
	    Check_Printer ( PrintLn ( HuvudStr_2 ) );
    	IF PrintOn THEN
	    Check_Printer ( PrintLn ( streck ) );
    END;
    IF PrintOn THEN
	Check_Printer ( PrintLn ( TextStr ) );	{ Skriv ut pa printer }

    LineNr := LineNr + 1;

END;	{ Logga }

{$page+}
{*******************************************************}
{	Logga_SyntErr:					}
{	Skriver vid syntaxfel ut ett felmeddelande 	}
{	och den rad dar felet finns.			}
{*******************************************************}

Procedure Logga_SyntErr	( err	: error_t;
			  ptr	: komm_ptr ) [PUBLIC];

VAR
    SyntErrStr	: string(29);

BEGIN	{ Logga_SyntErr }

    TextStr := 'Fel vid syntaxkontroll: ';
    CASE err OF 
	KommandoSaknas	     : SyntErrStr := 'Kommando saknas              ';
	AntParms	     : SyntErrStr := 'Felaktigt antal parametrar   ';
	ParmTyp		     : SyntErrStr := 'Felaktig parametertyp        ';
	NestedForVariable    : SyntErrStr := 'N{stlad FOR-variabel         ';
	ForLevel	     : SyntErrStr := 'F|r djupt n{stlad FOR-slinga ';
	NextLevel	     : SyntErrStr := 'FOR-kommando saknas          ';
	ValueOut	     : SyntErrStr := 'Otill}tet v{rde              ';
	NoStringEnd	     : SyntErrStr := 'Avsl. citationstkn(") saknas ';
	NoValue		     : SyntErrStr := 'Ej numeriskt v{rde           ';
	MissingNextStatement : SyntErrStr := 'Next-kommando saknas         ';
	IllegalCharacter     : SyntErrStr := 'Otill}tet tecken             ';
	OutOfMemory	     : SyntErrStr := 'Dynamiskta minnet slut       ';
    END; { CASE }

    Concat ( TextStr, SyntErrStr );
    ScrollWriteLn ( TextStr );
    ScrollWriteLn ( ptr^.txt );
    ScrollWriteLn ( NULL );

    MddmHuvud := false;		{ skriv inte ut rubrik2 }

    Logga;
    TextStr := ptr^.txt;
    Logga;
    TextStr := NULL;
    Logga;

    MddmHuvud := true;

END;	{ Logga_SyntErr }

{$page+}
{*******************************************************}
{	Logg-kommandot.					}
{*******************************************************}

Procedure Logg ( RadDelar : linepart_t;
		 Antal	  : integer	) [PUBLIC];

VAR
    i		: integer;

BEGIN	{ Logg }

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (30);
    FOR i := 2 TO Antal DO BEGIN
        CASE RadDelar[i].typ OF
	    Variabel : Concat_Value ( Get_VarValue (RadDelar[i].txt), FALSE );
	    Vaerde   : Concat_Value ( RadDelar[i].vaerde, FALSE );
	    Strng    : Concat ( TextStr, RadDelar[i].txt );
	END; { CASE }
    END; { FOR }
    Logga;

END;	{ Logg }

{$page+}
{*******************************************************}
{	Logga_ParmFel.					}
{*******************************************************}

Procedure Logga_ParmFel ( KomndStr   : element;
			  KomnRadI   : integer;
			  ErrParm    : ErrParmArea_t;
			  AntErrParm : integer	      )
					      [PUBLIC];

VAR
    i		: integer;
    KomnRadStr	: lstr4;

BEGIN	{ Logga_ParmFel }

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (30);
    Concat ( TextStr, 'PARAMETERFEL i rad ' );
    Eval ( Encode ( KomnRadStr, KomnRadI :1 ) );
    Concat ( TextStr, KomnRadStr );
    Add_Space (30 + IdLength + 1 );
    Concat ( TextStr, KomndStr.txt );
    Add_Space (30 + IdLength + 12);
    FOR i := 1 TO AntErrParm DO BEGIN
	Concat ( TextStr, ParmTypStr[ ErrParm[i].ParmTyp ] );
	Concat ( TextStr, ': ' );
	IF ( ErrParm[i].parmtyp >= AdressParm ) OR ( ErrParm[i].parmtyp <= UtDataParm ) THEN
	    Concat_Value ( ErrParm[i].Varde, TRUE )
	ELSE
	    Concat_Value ( ErrParm[i].Varde, FALSE );
	Concat ( TextStr, ' ' );
    END; { FOR }
    Logga;
    DisplayFel (TextStr);		{ skriv {ven p} screen }

END;	{ Logga_ParmFel }

{$page+}
{*******************************************************}
{	Logga_SerErr:					}
{	Skriver vid allvarligt fel ut felet och satter 	}
{	serious error variabeln om denna ej ar satt.	}
{*******************************************************}

Procedure Logga_SerErr	( ErrVarde : SerErr_t ;
			  Status   : integer ) [PUBLIC];

VAR
    SerErrStr	: lstring(6);

BEGIN	{ Logga_SerErr }

    IF SerErr = No_SerErr THEN
    	SerErr := ErrVarde;	{ ta bara foersta felet }

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (30);
    CASE ErrVarde OF 
	PwCContact : Concat( TextStr, 'Ingen kontakt med power-controllern ');
	Pwc_Init   : Concat( TextStr, 'Inget svar fr}n power-controllern ');
	PwCNoAck   : Concat( TextStr, 'Uteblivet ack fr}n power-controllern ');
	Open_COM1  : Concat( TextStr, 'Fel vid open COM1, status: ');
	Open_COM2  : Concat( TextStr, 'Fel vid open COM2, status: ');
	Mem_Alloc  : Concat( TextStr, 'Ej tillr{ckligt med dynamiskt minne ');
	Id_Obj_Not_OK : Concat( TextStr, 'Platser med id och svar fr}n kort st{mmer inte |verens!');
    END; { CASE }
    IF status <> 0 THEN BEGIN
    	Eval ( Encode ( SerErrStr , status :1 :16 ) );
	Concat ( TextStr, SerErrStr );
    END;

    Logga;
    DisplayFel (TextStr);		{ skriv {ven p} screen }
    TextStr := NULL;
    Logga;

END;	{ Logga_SerErr }

{$page+}
{*******************************************************}
{	Reset_Counters.					}
{	( Vid startup. )				}
{*******************************************************}

Procedure Reset_Counters [PUBLIC];

VAR
    oi	: integer;		{ Objekt-index }
    ki	: char;			{ Kommando-index }
    fi	: KortFel_t;		{ Fel-index }

BEGIN	{ Reset_Counters }

    FOR oi := objmin TO objmax DO WITH Count[Oi] DO BEGIN
    	CommCnt := 0;
	RamFelTyp := NULL;
	SioFelTyp := NULL;
	FOR ki := 'G' TO 'O' DO WITH Kretsstat[ki] DO BEGIN
	    TestAnt := 0;
	    FOR fi := TestNeg TO Timeout DO WITH Fel[fi] DO BEGIN
		Sub := 0;
		Tot := 0;
	    END; { FOR WITH }
	END; { FOR WITH }
    END; { FOR WITH }

    IOCntAlloc := false;	{ Inget minne till io-r{knarna allokerat {n }
    NumIO := 0;			{ Default - inga r{knare per port }
    HighIO := 0;
    LowIO := 1;

    DiskErr := false;

END;	{ Reset_Counters }

{$page+}
{*******************************************************}
{	Ioport.						}
{	allokera minne f|r felr{knare till de		}
{	io-adresser som skall ha separata r{knare,	}
{	allt enligt IOPORT-kommanot			}
{*******************************************************}

Procedure Ioport ( lowport, highport : real ) [PUBLIC] ;

VAR
    SaveErr	: SerErr_t;	{ f|r att spara undan ser_err }
    oi		: integer;	{ Objekt-index }
    i		: integer;
    DumRec	: PortRec_t;	{ bara f|r att g|ra sizeof }

BEGIN	{ Ioport }

    { kolla f|rst om man redan har allokerat minne f|r felr{knarna }

    IF IOCntAlloc THEN BEGIN
    	Put_Times;		{ Tid + forbrukad testtid till TextStr }
	Add_Space (30);
	Concat( TextStr, 'IOport-tabellen redan definierad en g}ng ');
	Logga;
	DisplayFel (TextStr);		{ skriv {ven p} screen }
	RETURN;
    END;

    HighIO := ROUND(highport);		{ s{tt upp h|gsta och l{gsta port }
    LowIO := ROUND(lowport);
    NumIO := ROUND(highport-lowport+1);

    { allokera minnet }

    FOR oi := objmin TO ROUND(ant_obj) DO BEGIN

    	DisplayTimes;

    	Count[Oi].ioport := ALLMQQ ( WRD(NumIO) * SIZEOF(DumRec) );

	IF ( Count[Oi].ioport.r = 0 ) OR ( Count[Oi].ioport.r = 1 ) THEN BEGIN
	    { minnet r{ckte inte - avbryt testet }
	    Logga_SerErr( Mem_Alloc, 0 );
	    FOR i := objmin TO (oi-1) DO    { l{mna tillbaka allokerat minne }
	    	IF FREMQQ ( Count[Oi].ioport ) <> 0 THEN
		    DebugWriteLn ( ' Error releasing segmented heap' );
	    RETURN;
	END; { IF }
	    
	WITH Count[Oi] DO
	    FOR i := 0 TO (NumIO-1) DO BEGIN
		ioport^[i].FelCnt.sub := 0;
		ioport^[i].FelCnt.tot := 0;
	    END;
    END;

    IOCntAlloc := true;

END;	{ Ioport }

{$page+}
{*******************************************************}
{	Release_PortCnt.				}
{	deallokera minnet f|r port-felr{knarna		}
{*******************************************************}

Procedure Release_PortCnt [PUBLIC] ;

VAR
    i : integer;

BEGIN	{ Release_PortCnt }

    { kolla om man har allokerat minne f|r felr{knarna }

    IF IOCntAlloc THEN BEGIN
    	FOR i := objmin TO ROUND(ant_obj) DO
	    IF FREMQQ ( Count[i].ioport ) <> 0 THEN
	    	DebugWriteLn ( ' Error releasing segmented heap' );
	IOCntAlloc := false;
    END;

END;	{ Release_PortCnt }

{$page+}
{*******************************************************}
{	Init_Lista.					}
{	Initiera listan f|re syntaxkontroll		}
{*******************************************************}

Procedure Init_Lista [PUBLIC];

BEGIN	{ Init_Lista }

    TmpDatum := Datum;
    OldDate := TmpDatum;		{ s} datum inte hinner {ndra p} sig }
    Sida := 1;
    Make_LoggHuvud;			{ Fyll HuvudStr_1 och HuvudStr_2 }
    Delete(Huvudstr_1,1,1);		{ ta bort ff f|re f|rsta utskrift }
    LineNr := 0;
    MddmHuvud := true;			{ skriv alla rubrikrader vid sidbyte }

END;	{ Init_Lista }

{$page+}
{*******************************************************}
{	Logga_ObjektFel.				}
{	Loggar att inmatade id inte st{mmer |verens med	}
{	svar fr}n korten i racken.			}
{*******************************************************}

Procedure Logga_ObjektFel ( RackTab : RackTab_t ) [PUBLIC];

VAR
    Hylla	: integer;
    Slot	: integer;
    Feltyp	: PlatsStat_t;

BEGIN	{ Logga_ObjektFel }

    TextStr := NULL; 			{ Blankrad }
    ScrollWriteLn ( TextStr ); Logga;
    TextStr := '         Slot utan svar                 Slot utan id';
    ScrollWriteLn ( TextStr ); Logga;
    TextStr := '         --------------                 ------------';
    ScrollWriteLn ( TextStr ); Logga;
    TextStr := NULL; 			{ Blankrad }
    ScrollWriteLn ( TextStr ); Logga;

    FOR Hylla := 1 TO 5 DO BEGIN
    	IF RackTab[Hylla].HyllFel THEN BEGIN
	    TextStr := 'HYLLA';
	    Concat ( TextStr, NrStr[Hylla] );
	    Concat ( TextStr, ':' );
	    FOR Feltyp := Kort_Saknas TO Id_Saknas DO BEGIN
	    	FOR Slot := 1 TO 10 DO BEGIN
		    IF RackTab[Hylla].ObjInfo[Slot] = FelTyp THEN
		    	Concat ( TextStr, NrStr[Slot] );
		END; { FOR Slot }
		Add_Space ( 40 );
	    END; { FOR FelTyp }
	    ScrollWriteLn ( TextStr ); Logga;
	END; { IF }
    END; { FOR Hylla }
    TextStr := NULL;
    Logga;			{ 2 Blankrader }
    Logga;

END;	{ Logga_ObjektFel }

{$page+}
{*******************************************************}
{	Logga_TestResultat.				}
{	Loggar svar fran korten.			}
{*******************************************************}

Procedure Logga_TestResultat (	Komnd	  : char;
				KortErr	  : KortFel_t;
				PortNr    : integer;
				Varde	  : lstr5;
				InData    : integer;
				ExtraRad  : lstr80	)
						     [PUBLIC];

VAR
    AntSubFelInt	: integer4;
    AntSubFelStr	: lstring(10);
    PortStr		: lstr3;
    InDataStr		: lstr3;

{$page+}
{*******************************************************}
{	PortNr_Ok					}
{	kollar om den testade porten i			}
{	insignalkommandot har egen r{knare		}
{*******************************************************}

Function PortNr_Ok : boolean;

BEGIN	{ PortNr_Ok }

    IF (komnd = 'I') AND (PortNr >= LowIO) AND (PortNr <= HighIO) THEN
    	PortNr_Ok := true
    ELSE
    	PortNr_Ok := false;

END;	{ PortNr_Ok }

{$page+}
{*******************************************************}
{	Logga_MddmKomFel.				}
{	Om kommunikationsfel.				}
{*******************************************************}

Procedure Logga_MddmKomFel;

BEGIN	{ Logga_MddmKomFel }

    count[obj].CommCnt := count[obj].CommCnt + 1;

    IF count[obj].CommCnt > 101 THEN
        RETURN;

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (19);
    Concat ( TextStr, Spanning );
    Add_MddmInfo;		{ Hylla, slot och id }

    Add_Space (30 + IdLength + 1);
    Concat ( TextStr, TestNamn[Komnd] );

    Add_Space (30 + IdLength + 12);
    IF count[Obj].CommCnt <= 100 THEN BEGIN
	Concat ( TextStr, 'KOMMUNIKATIONSFEL fr}n Mddm: ' );
	Concat ( TextStr, Varde ); END { IF }
    ELSE BEGIN  { CommCnt = 101 }
	Concat ( TextStr, 'ANTAL KOMMUNIKATIONSFEL Mddm > 100' );
    END;  { ELSE }

    Logga;
    DisplayFel (TextStr);		{ skriv {ven p} screen }

END;	{ Logga_MddmKomFel }

{$page+}
{*******************************************************}
{	Logga_TestOK.					}
{	Om testet gick bra.				}
{*******************************************************}

Procedure Logga_TestOK;

VAR
     fi		: KortFel_t;	{ Fel-index }
     InsigSub	: integer4;	{ spara sub-r{knare vid insignal och separantr{knade portar }

BEGIN	{ Logga_TestOK }

    { om det {r insignal, spara sub-r{knaren och h{mta den f|r aktuell port }
    IF PortNr_Ok THEN WITH Count[Obj] DO BEGIN
	InsigSub := kretsstat['I'].fel[TestNeg].sub; { spara undan ifall ickeseparatr{knade portar har anv{nt den tidigare }
	kretsstat['I'].fel[TestNeg].sub := ioport^[PortNr-LowIO].FelCnt.sub;
    END;

    FOR fi := TestNeg TO Timeout DO BEGIN	 { Tidigare fel i kretsen? }
	IF Count[Obj].kretsstat[Komnd].Fel[fi].Sub > 0 THEN BEGIN
	    Put_Times;		{ Tid + forbrukad testtid till TextStr }
	    Add_Space (19);
	    Concat ( TextStr, Spanning );
	    Add_MddmInfo;	{ Hylla, slot och id }
	    Add_Space (30 + IdLength + 1);
    	    Concat ( TextStr, TestNamn[Komnd] );
	    Add_Space (30 + IdLength + 12);
	    Concat ( TextStr, 'POSITIVT' );
	    IF Komnd = 'I' THEN BEGIN	{ PortNr vid insignalkommando  }
	    	Concat ( TextStr, ' P:' );
		PortStr := HexKonv ( 2 , PortNr );
		Concat ( TextStr, PortStr );
	    END;
	    Add_Space (30 + IdLength + 31);
	    Concat ( TextStr, FelStr[fi] );
	    Concat ( TextStr, ': ' );
	    AntSubFelInt := Count[Obj].kretsstat[Komnd].Fel[fi].Sub;
	    Eval ( Encode ( AntSubFelStr, AntSubFelInt :-1 ) );
	    Concat ( TextStr, AntSubFelStr );
	    Count[Obj].kretsstat[Komnd].Fel[fi].Sub := 0;
	    IF Komnd = 'G' THEN	Count[Obj].RamFelTyp := NULL;
	    IF Komnd = 'O' THEN	Count[Obj].SioFelTyp := NULL;
	    Logga;
	END; { IF }
    END; { FOR }

    { om det {r insignal, }terst{ll sub-r{knaren }
    IF PortNr_Ok THEN WITH Count[Obj] DO BEGIN
	kretsstat['I'].fel[TestNeg].sub := InsigSub;
	ioport^[PortNr-LowIO].FelCnt.sub := 0;
    END;

END;	{ Logga_TestOK }

{$page+}
{*******************************************************}
{	Logga_TestFel.					}
{	Om testet misslyckades.				}
{*******************************************************}

Procedure Logga_TestFel;

VAR
    fi		: KortFel_t;	{ Fel-index }
    Varde_B	: byte;		{ Varde i byte-form }
    LoggUtskr	: boolean;	{ om felet genererar utskrift p} loggen }
    InsigSub	: integer4;	{ spara sub och tot-r{knare vid insignal }
    InsigTot	: integer4;	{      och separantr{knade portar        }

BEGIN	{ Logga_TestFel }

    { om det {r insignal, spara sub och tot-r{knaren och h{mta den f|r aktuell port }
    IF PortNr_Ok THEN
    	WITH Count[Obj] DO BEGIN
	    InsigSub := kretsstat['I'].fel[TestNeg].sub;
	    InsigTot := kretsstat['I'].fel[TestNeg].tot;
	    kretsstat['I'].fel[TestNeg].sub := ioport^[PortNr-LowIO].FelCnt.sub;
	    kretsstat['I'].fel[TestNeg].tot := ioport^[PortNr-LowIO].FelCnt.tot;
	END;

    Put_Times;		{ Tid + forbrukad testtid till TextStr }
    Add_Space (19);
    Concat ( TextStr, Spanning );
    Add_MddmInfo;		{ Hylla, slot och id }
    Add_Space (30 + IdLength + 1);
    Concat ( TextStr, TestNamn[Komnd] );
    Add_Space (30 + IdLength + 12);
    IF Varde = NULL THEN
    	Concat ( TextStr, FelStr[KortErr] )
    ELSE BEGIN
    	IF PortNr <> 0 THEN BEGIN
	    Concat ( TextStr, 'P:' );
	    PortStr := HexKonv ( 2 , PortNr );
	    Concat ( TextStr, PortStr );	{ PortNr }
	    Concat ( TextStr, ' ' );
        END;
	Concat ( TextStr, 'V:' );
	Concat ( TextStr, Varde );		{ Last varde }
	Concat ( TextStr, ' ' );
	IF InData <> 0 THEN BEGIN
            Concat ( TextStr, 'F:' );
	    InDataStr := HexKonv ( 2 , InData );
	    Concat ( TextStr, InDataStr );	{ Forvantat varde }
	    Concat ( TextStr, ' ' );
        END;
    END; { ELSE }

    LoggUtskr := false;

    { Skall felet skrivas p} loggen ? }
    IF ( Count[Obj].kretsstat[Komnd].Fel[KortErr].Sub = 0 ) THEN
    	LoggUtskr := true;
    IF ( KortErr = TestNeg ) THEN BEGIN
    	IF ( Komnd = 'G' ) AND ( Varde <> Count[Obj].RamFelTyp ) THEN
	    LoggUtskr := true;
	IF ( Komnd = 'O' ) AND ( Varde <> Count[Obj].SioFelTyp ) THEN
	    LoggUtskr := true;
	EVAL ( Decode ( Varde, Varde_B ) );
	IF PortNr_Ok AND THEN
	 ( ( Varde_B  <> Count[Obj].ioport^[PortNr-LowIO].LastVal ) OR
	   ( WRD(InData) <> Count[Obj].ioport^[PortNr-LowIO].LastExpVal ) ) THEN
	    LoggUtskr := true;
    END;

    IF LoggUtskr THEN BEGIN
    	FOR fi := TestNeg TO Timeout DO BEGIN	 { Finns det n}gon tidigare feltyp att logga }
    	    IF ( Count[Obj].kretsstat[Komnd].Fel[fi].Sub > 0 ) THEN BEGIN
	    	Add_Space (30 + IdLength + 31);
		Concat ( TextStr, FelStr[fi] );
		Concat ( TextStr, ': ' );
		AntSubFelInt := Count[Obj].kretsstat[Komnd].Fel[fi].Sub;
		Eval ( Encode ( AntSubFelStr, AntSubFelInt :-1 ) );
		Concat ( TextStr, AntSubFelStr );	
		Count[Obj].kretsstat[Komnd].Fel[fi].Sub := 0;
	    END; { IF }
	END; { FOR }
	Logga;
    END; { IF }

    DisplayFel (TextStr);		{ skriv felet p} screen }

    IF LoggUtskr AND ( ExtraRad <> NULL ) THEN BEGIN { skriv ut extraraden }
    	TextStr := '  ---------- '''' ----------';
	Add_Space (30);
	Concat ( TextStr, ExtraRad );
	Logga;
    END; { IF }

    WITH Count[Obj].kretsstat[Komnd].Fel[KortErr] DO BEGIN
    	Sub := Sub + 1;
	Tot := Tot + 1;
    END;

    IF ( KortErr = TestNeg ) THEN BEGIN
    	IF ( Komnd = 'G' ) AND ( Varde <> Count[Obj].RamFelTyp ) THEN
	    Count[Obj].RamFelTyp := Varde;
	IF ( Komnd = 'O' ) AND ( Varde <> Count[Obj].SioFelTyp ) THEN
	    Count[Obj].SioFelTyp := Varde;
    	IF PortNr_Ok THEN BEGIN
	    WITH Count[Obj].ioport^[PortNr-LowIO] DO BEGIN
		LastVal := Varde_B;
		LastExpVal := WRD(InData);
	    END;
	END; { IF }
    END; { IF }

    { om det {r insignal, }terst{ll sub och tot-r{knaren f|r aktuell port }
    IF PortNr_Ok THEN
    	WITH Count[Obj] DO BEGIN
	    ioport^[PortNr-LowIO].FelCnt.sub := kretsstat['I'].fel[TestNeg].sub;
	    ioport^[PortNr-LowIO].FelCnt.tot := kretsstat['I'].fel[TestNeg].tot;
	    kretsstat['I'].fel[TestNeg].sub := InsigSub;
	    kretsstat['I'].fel[TestNeg].tot := InsigTot;
	END;


END;	{ Logga_TestFel }

{$page+}
{*******************************************************}

BEGIN	{ Logga_TestResultat }

    WITH Count[Obj].kretsstat[Komnd] DO TestAnt := TestAnt + 1;
    IF KortErr = KomFel THEN
	Logga_MddmKomFel
    ELSE IF KortErr = No_Error THEN
	Logga_TestOK
    ELSE
	Logga_TestFel;

END;	{ Logga_TestResultat }

{$page+}
{*******************************************************}
{	Logga_PwCErr:					}
{	Skriver vid SRQ fran Power-controllern ut	}
{	felmeddelandet. 				}
{*******************************************************}

Procedure Logga_PwCErr	( BitVarde : integer ) [PUBLIC];

VAR
    PwCErrStr	: lstring(35);

BEGIN	{ Logga_PwCErr }

    IF SerErr = No_SerErr THEN
    	SerErr := PwC_SRQ;	{ ta bara foersta felet } 

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (30);
    Concat ( TextStr, 'SRQ fran Power-controllern: ' );
    CASE BitVarde OF 
	16#0 : PwCErrStr := 'Fr}n INT-ing}ng';
	16#1 : PwCErrStr := 'Command not valid';
	16#2 : PwCErrStr := 'Command not valid for this cardtype';
	16#3 : PwCErrStr := 'Too many digits';
	16#4 : PwCErrStr := 'Too few digits';
	16#5 : PwCErrStr := 'No input data';
	16#6 : PwCErrStr := 'Wrong input data';
	16#7 : PwCErrStr := 'Owerflow, too big value';
	16#8 : PwCErrStr := 'Wrong card type';
	16#9 : PwCErrStr := 'Wrong slot number';
	16#A : PwCErrStr := 'No card in slot';
	16#B : PwCErrStr := 'More than maximum value';
	16#C : PwCErrStr := 'Strapped value';
	16#D : PwCErrStr := 'More than OVP/PCP value';
	16#E : PwCErrStr := 'Output limit > 10 volts';
	16#F : PwCErrStr := 'Step size > 10 volts';
	16#10: PwCErrStr := 'Ok{nt';

    END; { CASE }
    Concat ( TextStr, PwCErrStr );

    Logga;
    DisplayFel (TextStr);		{ skriv {ven p} screen }

END;	{ Logga_PwCErr }

{$page+}
{*******************************************************}
{	Logga_PwCKomFel.				}
{	Om kommunikationsfel.				}
{*******************************************************}

Procedure Logga_PwCKomFel ( KomFelTyp : lstr5 );

BEGIN	{ Logga_PwCKomFel }

    IF SerErr = No_SerErr THEN
    	SerErr := PwcComErr;	{ ta bara foersta felet } 

    Put_Times;			{ Tid + forbrukad testtid till TextStr }
    Add_Space (19);
    Concat ( TextStr, Spanning );
    Add_Space (30);
    Concat ( TextStr, 'KOMMUNIKATIONSFEL PwC : ' );
    Concat ( TextStr, KomFelTyp );

    Logga;
    DisplayFel (TextStr);		{ skriv {ven p} screen }

END;	{ Logga_PwCKomFel }

{$page+}
{*******************************************************}
{	Screen_logg.					}
{	Loggar p} bildsk{rmen den kommandorad		}
{	som intepreteras.				}
{*******************************************************}

Procedure Screen_logg ( raddelar : linepart_t;
			antal    : integer;
			raden    : komm_ptr) [PUBLIC];

VAR
	i, x	: integer;
    	

BEGIN	{ Screen_logg }

    TextStr := raddelar[1].txt;		{ kommandot }
    Add_Space (13);			{ parametrar i kol 13 }
    FOR i := 2 TO antal DO BEGIN
	IF i > 2 THEN Concat ( TextStr, ', ' );
	CASE raddelar[i].typ OF
	    variabel :
	    	IF ( i = 2 ) AND ( raden^.komm = kfor ) THEN
		    Concat ( TextStr, raddelar[i].txt )
		ELSE
		    Concat_Value( Get_VarValue(raddelar[i].txt), false );
	    strng : BEGIN
	    	Concat ( TextStr, '"' );
	    	Concat ( TextStr, raddelar[i].txt );
	    	Concat ( TextStr, '"' );
	    END;
	    vaerde : Concat ( TextStr, raddelar[i].txt );
	END; { CASE }
    END; { FOR }

    x := Positn('''', raden^.txt, 1);	   { kolla om det finns kommentar }
    IF x <> 0 THEN BEGIN
    	Concat ( TextStr, ' ' );	   { minst en blank f|re kommentar }
	Add_Space (40);			   { kommentarer i kol 40 }
	FOR i := x TO ord(raden^.txt.LEN) DO
	    IF TextStr.LEN < 79 THEN	   { max 79 tkn/rad }
	    	CONCAT (TextStr, raden^.txt[i]);
    END;

    ScrollWriteLn ( TextStr );		{ skriv ut raden }

END;	{ Screen_logg }

{$page+}
{*******************************************************}
{	Statistik.					}
{	Loggar statistiken				}
{*******************************************************}

Procedure Statistik [PUBLIC];

CONST
    FF			= chr(12);	{ Formfeed }

VAR
	c	: char;
	i,x	: integer;
	obj	: integer;
	tmpstr	: lstr10;
	rad	: array[1..4] of lstring(132);
	totsave	: integer4;

BEGIN	{ Statistik }

    TmpDatum := Datum;		{ Eftersom Logga anv{nder sig av TmpDatum }

    IF LineNr <> 0 THEN
	LineNr := 100;		{ forcera sidbyte }

    MddmHuvud := false;		{ inget mddmhuvud }


    FOR obj := objmin TO ROUND(ant_obj) DO WITH Count[obj] DO BEGIN

        TextStr := Rack[obj].Id;

	Add_Space (IdLength + 2 );

	Concat ( TextStr, 'Hylla: ' );
	Eval ( Encode ( tmpstr, rack[Obj].hyllnr :1 ) );
	Concat ( TextStr, tmpstr );

	Concat ( TextStr, '  Slot: ' );
	Eval ( Encode ( tmpstr, rack[Obj].slotnr :1 ) );
	Concat ( TextStr, tmpstr );

	Concat ( TextStr, '     Antal kommunikationsfel:  ');
	EVAL ( ENCODE ( tmpstr, CommCnt:1 ) );
	CONCAT ( TextStr, tmpstr );
	Logga;

	TextStr := NULL;
	Logga;

	Add_Space (23);
	Concat ( TextStr, '   RAMTEST  PROMTEST  INSIGNAL  UTSIGNAL  WATCHDOG    SETNOV  CHECKNOV   SIOTEST');
	Logga;

	Rad[1] := '     Antal tester     ';
	Rad[2] := '     Negativa resultat';
	Rad[3] := '     Felaktiga svar   ';
	Rad[4] := '     Timeouter        ';

	totsave := kretsstat['I'].Fel[TestNeg].tot;

	{ summera testneg f|r insignal om det finns separata portr{knare }
	IF LowIO <= HighIO THEN WITH kretsstat['I'].Fel[TestNeg] DO BEGIN
	    FOR i := 0 TO (NumIO-1) DO
	    	tot := tot + ioport^[i].FelCnt.tot;
	END;

	FOR c := 'G' TO 'O' DO
	    IF c <> 'L' THEN WITH kretsstat[c] DO BEGIN
	    	EVAL ( ENCODE ( tmpstr, Testant:10 ) );
		CONCAT ( Rad[1], tmpstr );
	        EVAL ( ENCODE ( tmpstr, fel[TestNeg].Tot:10 ) );
		CONCAT ( Rad[2], tmpstr );
	        EVAL ( ENCODE ( tmpstr, fel[FelSvar].Tot:10 ) );
		CONCAT ( Rad[3], tmpstr );
	        EVAL ( ENCODE ( tmpstr, fel[TimeOut].Tot:10 ) );
		CONCAT ( Rad[4], tmpstr );
	    END;

	FOR i := 1 TO 4 DO BEGIN
	    IF i = 2 THEN BEGIN
	    	TextStr := NULL;
		Logga;
	    END;
	    TextStr := Rad [i];
	    Logga;
	END;

	TextStr := NULL;
	Logga;

	{ skriv ut IO-portr{knarna, men bara om det har separatr{knats n}got }
	IF LowIO <= HighIO THEN BEGIN

	    TextStr := '     IOportar med separata felr{knare: #';
	    EVAL ( ENCODE ( tmpstr, LowIO:2:16 ) );
	    CONCAT ( TextStr, tmpstr );
	    CONCAT ( TextStr, '-#' );
	    EVAL ( ENCODE ( tmpstr, HighIO:2:16 ) );
	    CONCAT ( TextStr, tmpstr );
	    Logga;

	    TextStr := NULL;
	    Logga;

	    { kolla om det finns n}gra separatr{knade fel }
	    IF kretsstat['I'].Fel[TestNeg].tot = totsave THEN BEGIN
	    	TextStr := '     Alla portar med separata felr{knare OK ';
		Logga;
		TextStr := NULL;
	    END ELSE BEGIN

		Textstr := '     Portar med fel,  (portnr:antal fel)';
		Logga;

		TextStr := NULL;
		Logga;

		TextStr := '     ';
		x := 0;
		FOR i := 0 TO (NumIO-1) DO
		    IF ioport^[i].FelCnt.tot <> 0 THEN BEGIN
			CONCAT ( TextStr, '#' );
		    	EVAL ( ENCODE ( tmpstr, LowIO+i:2:16 ) ); { portnr }
			CONCAT ( TextStr, tmpstr );
			CONCAT ( TextStr, ':' );
			EVAL ( ENCODE ( tmpstr, ioport^[i].FelCnt.tot:-8 ) );
			CONCAT ( TextStr, tmpstr );
			x := x + 1;
			IF x = 7 THEN BEGIN
			    Logga;
			    TextStr := '     ';
			END; { If x }
		    END; { IF tot }

		Logga;			{ skriv ut den ev. halvfulla raden }
		TextStr := NULL;

	    END; { ELSE }

	END; { IF LowIO <= HighIO }

	Logga;

	IF LineNr < 20 THEN
	    WHILE LineNr < 20 DO
	    	Logga
	ELSE
	    LineNr := 100;	{ forcera sidbyte }

    END; { FOR }

    LineNr := 100;

    MddmHuvud := true;		{ }terst{ll }


END;	{ Statistik }

END.	{ Module }
