{$title:'MODULE: Loop' $pagesize:41 $linesize:106}

Module Loop;

{*******************************************************}
{	Modulen innehaller kommandona FOR och NEXT	}
{	samt PAUS-kommandot.				}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'synt.h'}
{$Include:'varhandl.h'}
{$Include:'tid.h'}
{$Include:'logg.h'}
{$Include:'screen.h'}

{$page+}
{*******************************************************}
{	FOR-kommandot.					}
{*******************************************************}


Procedure Do_For  ( VAR	ptr	: komm_ptr;
			raddelar: linepart_t;
			antal   : integer )    [PUBLIC];

VAR
    StartVardeTyp	: eltyp;
    StartVarde		: real;
    StartVariabelNamn	: lstr10;
    StoppVardeTyp	: eltyp;
    StoppVarde		: real;
    StoppVariabelNamn	: lstr10;
    IdentifierarNamn	: lstr10;
    IdentifierarVarde	: real;
    Steg		: real;
    StegTyp		: eltyp;
    StegVariabelNamn	: lstr10;

BEGIN	{ Do_For }

    StartVardeTyp := raddelar[3].typ;
    IF StartVardeTyp = variabel THEN BEGIN
	StartVariabelNamn := raddelar[3].txt;
	StartVarde := Get_VarValue ( StartVariabelNamn ); END
    ELSE StartVarde := raddelar[3].vaerde;

    IdentifierarVarde := StartVarde;
    IdentifierarNamn := raddelar[2].txt;
    Put_VarValue ( IdentifierarNamn, IdentifierarVarde );

    StoppVardeTyp := raddelar[4].typ;
    IF StoppVardeTyp = variabel THEN BEGIN
	StoppVariabelNamn := raddelar[4].txt;
	StoppVarde := Get_VarValue ( StoppVariabelNamn ); END
    ELSE StoppVarde := raddelar[4].vaerde;

    IF antal = 5 THEN BEGIN
	StegTyp := raddelar[5].typ;
	IF StegTyp = variabel THEN BEGIN
	    StegVariabelNamn := raddelar[5].txt;
	    Steg := Get_VarValue ( StegVariabelNamn ); END
	ELSE Steg := raddelar[5].vaerde; END
    ELSE Steg := 1;

    IF Steg >= 0 THEN BEGIN
    	IF ( IdentifierarVarde - StoppVarde ) > 0.0005 THEN
	    ptr := ptr^.pjmp; END { IF }
    ELSE 
    	IF ( StoppVarde - IdentifierarVarde ) > 0.0005 THEN
	    ptr := ptr^.pjmp;

END;	{ Do_For }

{$page+}
{*******************************************************}
{	NEXT-kommandot.					}
{*******************************************************}

procedure Do_Next ( VAR	ptr : komm_ptr ) [PUBLIC];

VAR
    RadDelar		: linepart_t;
    Antal		: integer;
    errcode		: error_t;
    StegTyp		: eltyp;
    Steg		: real;
    StegVariabelNamn	: lstr10;
    StoppVardeTyp	: eltyp;
    StoppVarde		: real;
    StoppVariabelNamn	: lstr10;
    IdentifierarNamn	: lstr10;
    IdentifierarVarde	: real;

BEGIN	{ Do_Next }

    ptr := ptr^.pjmp;			{ Motsvarande FOR-kommando }
    SplitLine ( RadDelar, Antal, errcode, ptr^.txt );	{ dela upp raden }
    IF errcode <> NoError THEN
	DebugWriteLn ( 'Error in Do_Next' );		{ D }
    IF antal = 5 THEN BEGIN
	StegTyp := raddelar[5].typ;
	IF StegTyp = variabel THEN BEGIN
	    StegVariabelNamn := raddelar[5].txt;
	    Steg := Get_VarValue ( StegVariabelNamn ); END
	ELSE Steg := raddelar[5].vaerde; END
    ELSE Steg := 1;

    IdentifierarNamn := raddelar[2].txt;
    IdentifierarVarde := Get_VarValue ( IdentifierarNamn );
    IdentifierarVarde := IdentifierarVarde + Steg;
    Put_VarValue ( IdentifierarNamn, IdentifierarVarde );

    StoppVardeTyp := raddelar[4].typ;
    IF StoppVardeTyp = variabel THEN BEGIN
	StoppVariabelNamn := raddelar[4].txt;
	StoppVarde := Get_VarValue ( StoppVariabelNamn ); END
    ELSE StoppVarde := raddelar[4].vaerde;

    IF Steg >= 0 THEN BEGIN
    	IF ( IdentifierarVarde - StoppVarde ) > 0.0005 THEN
	    ptr := ptr^.pjmp; END { IF }
    ELSE 
    	IF ( StoppVarde - IdentifierarVarde ) > 0.0005 THEN
	    ptr := ptr^.pjmp;

END;	{ Do_Next }

{$page+}
{*******************************************************}
{	PAUS-kommandot.					}
{*******************************************************}

Function Paus ( ptr	 : komm_ptr;
		RadDelar : linepart_t ) : integer4 [PUBLIC];

VAR
    TidVardeTyp	: eltyp;
    TidVarNamn	: lstr10;
    PausTid	: integer;		{ Pausens langd (i sekunder) }
    ErrParm	: ErrParmArea_t;	{ For felaktiga parametrar }

BEGIN	{ Paus }

    TidVardeTyp := RadDelar[2].typ;
    IF TidVardeTyp = variabel THEN BEGIN
	TidVarNamn := RadDelar[2].txt;
	PausTid := Round ( Get_VarValue ( TidVarNamn ) ); END
    ELSE PausTid := Round ( RadDelar[2].vaerde );

    IF ( pausmin <= PausTid ) AND ( PausTid <= pausmax ) THEN
	Paus := SecUsed + PausTid	{ Utfor kommandot }
    ELSE BEGIN			{ Logga den felaktiga parametern }
	ErrParm[1].ParmTyp := TidParm;
	ErrParm[1].Varde := PausTid;
	Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, 1 );
	Paus := SecUsed;
    END; { ELSE }

END;	{ Paus }

END.	{ Module }
