{$title:'PROGRAM: Main' $pagesize:41 $linesize:106}
Program Main(input,output);

{*******************************************************}
{							}
{	HUVUDPROGRAMMET					}
{							}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'io.h'}
{$Include:'screen.h'}
{$Include:'objekt.h'}
{$Include:'batch.h'}
{$Include:'logg.h'}

CONST
    Tim_72	= 259200;	{ 72 timmar i sekunder }

VAR [PUBLIC]			{ Globala variabler }
    klist	: komm_ptr;	{ pekare till den laenkade kommandolistan }
    ComFileName	: lstring ( comfilename_size );
	    			{ namn paa filen daer testsekvensen ligger }
    ant_obj	: real;		{ antal objekt i "rack" }
    rack	: rack_t;	{ racken med alla 50 korten i }
    Obj		: integer;	{ vilket objekt som aer valt }
    spanningflg	: boolean;	{ Spanning > 0 ? }
    Spanning	: lstring(5);	{ Vald spanning }
    AnaSpanning	: lstring(5);	{ Vald "analogspanning" }
    PrintOn	: boolean;	{ true om printern aer aktiverad }
    KommandoFil	: TEXT(80);
    LoggFil	: TEXT;
    SerErr	: SerErr_t;	{ om <> No_SerErr avbryt testen }
    IdLength	: byte;		{ l{ngd p} l{ngsta mddmid (f|r loggning) }
    TotTid	: integer4;	{ totala testtiden i sekunder }

VAR
    ftang	: ftang_t;
    error	: error_t;

{$page+}
BEGIN { main }

    Write(chr(27),'[2J');
    CursOff;

    ComFileName := 'CO303.TST';
    CposWrite(23, 30, 'KOMMANDOFIL:');

    TotTid := Tim_72;
    ant_obj := 0;

    ftang := f_other;
    klist := NIL;
    Clr_FTangPrintFlgs;			{ Inga funktionstangenter ar tanda }
    REPEAT

	CposWrite(23, 43, ComFileName);

	CASE ftang OF
	    f_other : BEGIN		{ Lagg ut initbild }
		ClrScr;
		WriteLine25 ( [ f_1, f_2, f_3, f_10 ] );
		ftang := Write_InitBild ( [ f_1, f_2, f_3, f_10 ] );
		END; { f_other }
	    f_1 : BEGIN			{ Mata in testobjekt }
		ClrScr;
		WriteLine25 ( [ f_2, f_3, f_10 ] );
		ftang := GetObjekt ( [ f_2, f_3, f_10 ] );
		END; { f_1 }
	    f_2 : BEGIN			{ Mata in kommandofil }
		ClrScr;
		WriteLine25 ( [ f_1, f_3, f_10 ] );
		ftang := Get_ComFileName ( [ f_1, f_3, f_10 ] );
		END; { f_2 }
	    f_3 : BEGIN			{ Koer testloopen }
		ClrScr;
		ClrLine (25);
		Clr_FTangPrintFlgs;	{ Inga funktionstangenter ar tanda }
		error := DoTest;
		CASE error OF
		    NoTestobjects :
			ftang := f_1;
		    NoFilename, OpenComFile, ReadComFile :
			ftang := f_2;
		    NoError :
			ftang := f_other; { Testet ar avbrutet eller klart }
		    OTHERWISE
			BEGIN
			    ftang := f_other; { Syntaxchecken gick snett }
			    ErrMsg ( 'Fel i syntaxcheck, testet kan ej starta' );
			END;
		END; { CASE }
		END; { f_3 }
 	END; { CASE }
    UNTIL ftang = f_10; { testet faerdigkoert }

    ClrLine(25);
    Cpos(24,1);
    CursOn;

END. { main }
