{$title:'MODULE: MddmKommandon' $pagesize:41 $linesize:106}

Module MddmKommandon;

{*******************************************************}
{	Modulen innehaller kommandon till kortet samt	}
{	en kontroll att	inmatningen st{mmer |verens med }
{	hur korten sitter i racken.			}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'mddm.h'}
{$Include:'varhandl.h'}
{$Include:'message.h'}
{$Include:'logg.h'}
{$Include:'tid.h'}
{$Include:'objkomn.h'}
{$Include:'screen.h'}

VAR
    OldValue	: packed ARRAY [objmin..objmax, 0..255] OF byte; { For Utsignal }

{$page+}
{*******************************************************}
{	Check_Objekts:					}
{	Kontrollerar att inmatade id st{mmer |verens	}
{	med hur korten sitter i racken.			}
{*******************************************************}

Procedure Check_Objekts [PUBLIC];

VAR
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    Svar_OK	: boolean;
    Fel_Finns	: boolean;
    RackTab	: RackTab_t;
    Hylla	: integer;
    Slot	: integer;

BEGIN	{ Check_Objekts }

    Fel_Finns := false;			{ Initiering }
    FOR Hylla := 1 TO 5 DO BEGIN
	RackTab[Hylla].HyllFel := false;
    	FOR Slot := 1 TO 10 DO BEGIN
	    RackTab[Hylla].ObjInfo[Slot] := Plats_OK;
	END { FOR };
    END { FOR };

    SRec.ParmArea[1] := '1';	{ RAMTEST-kommandot med felaktiga parametrar }
    SRec.ParmArea[2] := '1';
    SRec.Ant_Parm := 2;
    Kommando := 'G';
    Obj := 1;
    RRec.TimeOutTid := 0.5;
    FOR Hylla := 1 TO 5 DO BEGIN
    	FOR Slot := 1 TO 10 DO BEGIN
	    Stall_Relaerna ( Hylla, Slot );
	    Send_MddmMessage ( SRec, Kommando );

	    Receive_MddmAnswer ( RRec, Kommando );

	    Svar_OK := (RRec.PortStatus = 0) AND (NOT RRec.TimeOut)
	    AND (RRec.RetParmArea[1] = 'FF');

	    IF Obj <= ant_obj AND THEN { Endast om f|rsta villkoret = true }
	    ((rack[Obj].hyllnr=Hylla) AND (rack[Obj].slotnr=Slot))
	    THEN BEGIN			{ Id inmatat }
		    IF NOT Svar_OK THEN
		    	RackTab[Hylla].ObjInfo[Slot] := Kort_Saknas;
		    Obj := Obj + 1; END { IF }
	    ELSE BEGIN			{ Id ej inmatat }
	    	IF Svar_OK THEN RackTab[Hylla].ObjInfo[Slot] := Id_Saknas;
	    END; { ELSE }

	    IF RackTab[Hylla].ObjInfo[Slot] <> Plats_OK THEN BEGIN
	    	Fel_Finns := true;
		RackTab[Hylla].HyllFel := true;
	    END; { IF }
	END { FOR Slot };
    END { FOR Hylla };
    IF Fel_Finns THEN BEGIN
	Logga_SerErr ( Id_Obj_Not_OK, 0 );
    	Logga_ObjektFel ( RackTab );
    END; { IF }
    Obj := 1;
    Stall_Relaerna(rack[Obj].hyllnr, rack[Obj].slotnr);{Koppla in f|rsta objekt}

END;	{ Check_Objekts }

{$page+}
{*******************************************************}
{	Reset_OldValue.					}
{	( Vid startup. Ej kommando till kortet. )	}
{*******************************************************}

procedure Reset_OldValue [PUBLIC];

VAR
    PortNr	: integer;
    i		: integer;

BEGIN	{ Reset_OldValue }

    FOR i := objmin TO objmax DO BEGIN
    	DisplayTimes;
	FOR PortNr := 0 TO 255 DO
	    OldValue [i, PortNr] := 0;
    END;

END;	{ Reset_OldValue }

{$page+}
{*******************************************************}
{	UTSIGNAL-kommandot.				}
{*******************************************************}

procedure Utsignal ( 	 ptr	  : komm_ptr;
		     VAR RadDelar : linepart_t;
			 Antal	  : integer	) [PUBLIC];

VAR
    PortElem	: adr of element;
    UtDataElem	: adr of element;
    MaskElem	: adr of element;
    Port_OK	: boolean;
    UtData_OK	: boolean;
    Mask_OK	: boolean;
    Len_OK	: boolean;
    PortNr	: integer;
    UtData	: integer;
    Mask	: integer;
    DelRes_1	: integer;
    DelRes_2	: integer;
    ErrParm	: ErrParmArea_t;
    AntErrParm	: integer;
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ Utsignal }

    PortElem := ADR RadDelar[2];
    UtDataElem := ADR RadDelar[3];
    MaskElem := ADR RadDelar[4];
    SRec.Ant_Parm := 2;
    Kommando := 'J';

    IF PortElem^.typ = variabel THEN
	PortElem^.vaerde := Get_VarValue ( PortElem^.txt );
    PortNr := ROUND ( PortElem^.vaerde );
    Port_OK := ( 0 <= PortNr ) AND ( PortNr <= 255 );

    IF UtDataElem^.typ = variabel THEN
	UtDataElem^.vaerde := Get_VarValue ( UtDataElem^.txt );
    UtData := ROUND ( UtDataElem^.vaerde );
    UtData_OK := ( 0 <= UtData ) AND ( UtData <= 255 );

    IF Antal = 3 THEN
	Mask := 255
    ELSE BEGIN
	IF MaskElem^.typ = variabel THEN
	    MaskElem^.vaerde := Get_VarValue ( MaskElem^.txt );
	Mask := ROUND ( MaskElem^.vaerde );
    END;
    Mask_OK := ( 0 <= Mask ) AND ( Mask <= 255 );

    IF Port_OK AND UtData_OK AND Mask_OK THEN BEGIN
	DelRes_1 := ORD(OldValue[Obj,PortNr]) AND ( NOT Mask ); { h{mta inressanta bitar i OldValue }
	DelRes_2 := UtData AND Mask;				{ h{mta inressanta bitar i Utdata }
	UtData := DelRes_1 OR DelRes_2;				{ s{tt ihop dessa }
	OldValue[Obj,PortNr] := WRD(UtData);
	Len_OK := Encode ( SRec.ParmArea[1], PortNr :1 :16 );
	Len_OK := Encode ( SRec.ParmArea[2], UtData :1 :16 );
	Send_MddmMessage ( SRec, Kommando );

	RRec.TimeOutTid := 1;
	Receive_MddmAnswer ( RRec, Kommando );
	Varde := NULL;
	IF RRec.PortStatus <> 0 THEN BEGIN
	    KortErr := KomFel;
	    Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
	ELSE IF NOT RRec.TimeOut THEN
	    KortErr := No_Error
	ELSE
	    KortErr := TimeOut;
	Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );
    END { IF }
    ELSE BEGIN
	AntErrParm := 0;
	IF NOT Port_OK THEN BEGIN
	    AntErrParm := AntErrParm + 1;
	    ErrParm[AntErrParm].ParmTyp := PortParm;
	    ErrParm[AntErrParm].Varde := PortNr; END;
	IF NOT UtData_OK THEN BEGIN
	    AntErrParm := AntErrParm + 1;
	    ErrParm[AntErrParm].ParmTyp := UtDataParm;
	    ErrParm[AntErrParm].Varde := UtData; END;
	IF NOT Mask_OK THEN BEGIN
	    AntErrParm := AntErrParm + 1;
	    ErrParm[AntErrParm].ParmTyp := MaskParm;
	    ErrParm[AntErrParm].Varde := Mask; END;
	Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, AntErrParm );
    END; { ELSE }

END;	{ Utsignal }

{$page+}
{*******************************************************}
{       INSIGNAL-kommandot.                             }
{*******************************************************}

procedure Insignal (	 ptr	  : komm_ptr;
		     VAR RadDelar : linepart_t;
			 Antal    : integer	)
					[PUBLIC];

VAR
    PortElem    : adr of element;
    InDataElem  : adr of element;
    MaskElem    : adr of element;
    Port_OK     : boolean;
    InData_OK   : boolean;
    Mask_OK	: boolean;
    Len_OK	: boolean;
    Svar_OK     : boolean;
    PortNr	: integer;
    InData	: integer;
    Mask	: integer;
    Last_Varde  : integer;
    RetParmHex	: lstring(MaxParmLangd + 1);
    ErrParm	: ErrParmArea_t;
    AntErrParm	: integer;
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;
    ExtraRad	: lstr80;

BEGIN   { Insignal }

    PortElem := ADR RadDelar[2];
    InDataElem := ADR RadDelar[3];
    MaskElem := ADR RadDelar[4];
    SRec.Ant_Parm := 1;
    Kommando := 'I';

    IF PortElem^.typ = variabel THEN
        PortElem^.vaerde := Get_VarValue ( PortElem^.txt );
    PortNr := ROUND ( PortElem^.vaerde );
    Port_OK := ( 0 <= PortNr ) AND ( PortNr <= 255 );

    IF InDataElem^.typ = variabel THEN
        InDataElem^.vaerde := Get_VarValue ( InDataElem^.txt );
    InData := ROUND ( InDataElem^.vaerde );
    InData_OK := ( 0 <= InData ) AND ( InData <= 255 );

    IF Antal = 3 THEN
        Mask := 255
    ELSE BEGIN
        IF MaskElem^.typ = variabel THEN
            MaskElem^.vaerde := Get_VarValue ( MaskElem^.txt );
        Mask := ROUND ( MaskElem^.vaerde );
    END;
    Mask_OK := ( 0 <= Mask ) AND ( Mask <= 255 );

    IF Port_OK AND InData_OK AND Mask_OK THEN BEGIN
        Len_OK := Encode ( SRec.ParmArea[1], PortNr :1 :16 );
        Send_MddmMessage ( SRec, Kommando );

        RRec.TimeOutTid := 1;
	Receive_MddmAnswer ( RRec, Kommando );
	ExtraRad := NULL;
	Varde := NULL;
	IF RRec.PortStatus <> 0 THEN BEGIN
	    KortErr := KomFel;
	    Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
	ELSE IF NOT RRec.TimeOut THEN BEGIN
	    RetParmHex := '#';
	    Concat ( RetParmHex, RRec.RetParmArea[1] );
            Svar_OK := Decode ( RetParmHex, Last_Varde );
	    IF (RRec.RetParmArea[1].len = 2) AND (Svar_OK) THEN BEGIN
                Last_Varde := Last_Varde AND Mask;
                IF Last_Varde = InData THEN
		    KortErr := No_Error
		ELSE BEGIN
                    IF Antal = 5 THEN BEGIN	{ Skicka {ven feltexten }
                        ExtraRad := RadDelar[5].txt;
		    END; { IF }
		    KortErr := TestNeg;
		    Varde := HexKonv ( 2 , Last_Varde );
		END; { ELSE } END { IF }
            ELSE
		KortErr := Felsvar; END { IF }
	ELSE
	    KortErr := TimeOut;
	Logga_TestResultat ( Kommando, KortErr, PortNr, Varde, InData, ExtraRad );
    END { IF }
    ELSE BEGIN
	AntErrParm := 0;
	IF NOT Port_OK THEN BEGIN
	    AntErrParm := AntErrParm + 1;
	    ErrParm[AntErrParm].ParmTyp := PortParm;
	    ErrParm[AntErrParm].Varde := PortNr; END;
	IF NOT InData_OK THEN BEGIN
	    AntErrParm := AntErrParm + 1;
	    ErrParm[AntErrParm].ParmTyp := InDataParm;
	    ErrParm[AntErrParm].Varde := InData; END;
	IF NOT Mask_OK THEN BEGIN
	    AntErrParm := AntErrParm + 1;
	    ErrParm[AntErrParm].ParmTyp := MaskParm;
	    ErrParm[AntErrParm].Varde := Mask; END;
	Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, AntErrParm );
    END; { ELSE }

END;    { Insignal }

{$page+}
{*******************************************************}
{	RAMTEST-kommandot.				}
{*******************************************************}

procedure Ramtest (	ptr	 : komm_ptr;
		    VAR RadDelar : linepart_t;
			Antal	 : integer     ) [PUBLIC];

VAR
    Len_OK	: boolean;
    StartAdr	: adr of element;
    SlutAdr	: adr of element;
    StartAdr_i4	: integer4;
    SlutAdr_i4	: integer4;
    ErrParm	: ErrParmArea_t;
    AntErrParm	: integer;
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ Ramtest }

    StartAdr := ADR RadDelar[2];
    SlutAdr := ADR RadDelar[3];
    SRec.Ant_Parm := 0;
    Kommando := 'G';

    IF Antal = 3 THEN BEGIN
	SRec.Ant_Parm := 2;
	IF StartAdr^.typ = variabel THEN
	    StartAdr^.vaerde := Get_VarValue ( StartAdr^.txt );
	IF SlutAdr^.typ = variabel THEN
	    SlutAdr^.vaerde := Get_VarValue ( SlutAdr^.txt );
	StartAdr_i4 := RoundX ( StartAdr^.vaerde ) ;
	SlutAdr_i4 := RoundX ( SlutAdr^.vaerde );
	Len_OK := Encode ( SRec.ParmArea[1], StartAdr_i4 :1 :16 );
	Len_OK := Encode ( SRec.ParmArea[2], SlutAdr_i4 :1 :16 );
    END; { IF }
    Send_MddmMessage ( SRec, Kommando );

    RRec.TimeOutTid := 2;
    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
    ELSE IF NOT RRec.TimeOut THEN BEGIN
	IF RRec.RetParmArea[1] = 'FF' THEN BEGIN
	    ErrParm[1].ParmTyp := AdressParm;
	    ErrParm[1].Varde := StartAdr_i4;
	    ErrParm[2].ParmTyp := AdressParm;
	    ErrParm[2].Varde := SlutAdr_i4;
	    AntErrParm := 2;
	    Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, AntErrParm );
	END { IF }
	ELSE BEGIN
	    IF RRec.RetParmArea[1] = '00' THEN
		KortErr := No_Error
	    ELSE IF ( RRec.RetParmArea[1].len = 2 ) AND
	    ( RRec.RetParmArea[1,1] = '0' ) AND
	    ( RRec.RetParmArea[1,2] >= '1') AND (RRec.RetParmArea[1,2] <= '7')
	    THEN BEGIN			{ '01' - '07' }
		KortErr := TestNeg;
		Varde := RRec.RetParmArea[1];
		Insert ( '#', Varde, 1 ); END { ELSE IF }
	    ELSE
		KortErr := FelSvar;
	    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );
	END; { ELSE } END { IF }
    ELSE BEGIN
	KortErr := TimeOut;
	Logga_TestResultat ( Kommando, KortErr, 0, NULL, 0, NULL );
    END; { ELSE }

END;	{ Ramtest }

{$page+}
{*******************************************************}
{	PROMTEST-kommandot.				}
{*******************************************************}

procedure Promtest [PUBLIC];

VAR
    CheckSumma	: lstr10;
    CheckSumH	: lstring(11);
    CheckSumW	: word;
    Tal		: boolean;
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ Promtest }

    SRec.Ant_Parm := 0;
    Kommando := 'H';
    Send_MddmMessage ( SRec, Kommando );

    RRec.TimeOutTid := 1;
    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
    ELSE IF NOT RRec.TimeOut THEN BEGIN
	CheckSumma := RRec.RetParmArea[1];
	CheckSumH := '#';
	Concat ( CheckSumH, CheckSumma );
	Tal := Decode ( CheckSumH, CheckSumW );
	IF ( CheckSumma.len = 4 ) AND ( Tal ) THEN BEGIN
	    IF CheckSumW = 0 THEN
		KortErr := No_Error
	    ELSE BEGIN
		KortErr := TestNeg;
		Varde := CheckSumH;
	    END; { ELSE } END { IF }
	ELSE
	    KortErr := FelSvar; END { ELSE IF }
    ELSE
	KortErr := TimeOut;
    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );

END;	{ Promtest }

{$page+}
{*******************************************************}
{	WATCHDOG-kommandot.				}
{*******************************************************}

procedure Watchdog [PUBLIC];

VAR
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ Watchdog }

    SRec.Ant_Parm := 0;
    Kommando := 'K';
    Send_MddmMessage ( SRec, Kommando );

    RRec.TimeOutTid := 30;		{ v{nta en halv minut }
    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
    ELSE IF NOT RRec.TimeOut THEN BEGIN
	IF RRec.Ant_RetParm = 0 THEN
	    KortErr := No_Error
	ELSE BEGIN
	    IF RRec.RetParmArea[1] = 'FF' THEN
		KortErr := TestNeg
	    ELSE
		KortErr := FelSvar;
	END; { ELSE } END { IF }
    ELSE
	KortErr := TimeOut;
    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );

END;	{ Watchdog }

{$page+}
{*******************************************************}
{	RESET-kommandot.				}
{*******************************************************}

procedure Reset [PUBLIC];

VAR
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ Reset }

    SRec.Ant_Parm := 0;
    Kommando := 'L';
    Send_MddmMessage ( SRec, Kommando );
    RRec.TimeOutTid := 2;
    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
    ELSE IF NOT RRec.TimeOut THEN BEGIN
	IF RRec.Ant_RetParm = 0 THEN
	    KortErr := No_Error
	ELSE BEGIN
	    IF RRec.RetParmArea[1] = 'FF' THEN
		KortErr := TestNeg
	    ELSE
		KortErr := FelSvar;
	END; { ELSE } END { IF }
    ELSE
	KortErr := TimeOut;
    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );

END;	{ Reset }

{$page+}
{*******************************************************}
{	SetNov-kommandot.				}
{*******************************************************}

procedure SetNov [PUBLIC];

VAR
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ SetNov }

    SRec.Ant_Parm := 0;
    Kommando := 'M';
    Send_MddmMessage ( SRec, Kommando );
    RRec.TimeOutTid := 1;
    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
    ELSE IF NOT RRec.TimeOut THEN
	KortErr := No_Error
    ELSE
	KortErr := TimeOut;
    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );

END;	{ SetNov }

{$page+}
{*******************************************************}
{	CheckNov-kommandot.				}
{*******************************************************}

procedure CheckNov [PUBLIC];

VAR
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;

BEGIN	{ CheckNov }

    SRec.Ant_Parm := 0;
    Kommando := 'N';
    Send_MddmMessage ( SRec, Kommando );
    RRec.TimeOutTid := 1;
    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  ); END { IF }
    ELSE IF NOT RRec.TimeOut THEN BEGIN
	IF RRec.RetParmArea[1] = '00' THEN
	    KortErr := No_Error
	ELSE IF RRec.RetParmArea[1] = 'FF' THEN
	    KortErr := TestNeg
	ELSE
	    KortErr := FelSvar; END { IF }
    ELSE
	KortErr := TimeOut;
    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );

END;	{ CheckNov }

{$page+}
{*******************************************************}
{	SioTest-kommandot.				}
{*******************************************************}

procedure SioTest [PUBLIC];

VAR
    SRec	: s_message_t;
    RRec	: r_message_t;
    Kommando	: char;
    KortErr	: KortFel_t;
    Varde	: lstr5;
    retstr	: lstring(20);
    retint	: integer;


BEGIN	{ SioTest }

    SRec.Ant_Parm := 0;
    Kommando := 'O';
    Send_MddmMessage ( SRec, Kommando );
    RRec.TimeOutTid := 1;

    Receive_MddmAnswer ( RRec, Kommando );
    Varde := NULL;
    IF RRec.PortStatus <> 0 THEN BEGIN
	KortErr := KomFel;
	Varde := PStatKonv ( RRec.PortStatus  );
    END ELSE
    	IF RRec.TimeOut THEN
	    KortErr := TimeOut
	ELSE BEGIN
	    retstr := '#';
	    Concat ( retstr, RRec.RetParmArea[1] );
	    IF Decode ( retstr, retint ) AND THEN ( retint = 0 ) THEN 
		KortErr := No_Error
	    ELSE
		IF ( retint > 0 ) AND ( retint < #3F ) THEN BEGIN	{ '01' - '1F' }
		    KortErr := TestNeg;
		    Varde := RRec.RetParmArea[1];
		    Insert ( '#', Varde, 1 );
		END ELSE
		    KortErr := FelSvar;
	END;
    Logga_TestResultat ( Kommando, KortErr, 0, Varde, 0, NULL );

END;	{ SioTest }

END.	{ Module }
