{$title:'MODULE: MddmMessages' $pagesize:41 $linesize:106}

Module MddmMessages;

{*******************************************************}
{	Modulen innehaller meddelandehanteringen 	}
{	vid kommandon till kortet.			}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'mddm.h'}
{$Include:'tid.h'}
{$Include:'asynch.h'}
{$Include:'screen.h'}

Procedure Time	  ( VAR	S	: string   ); EXTERN;

{$page+}
{*******************************************************}
{	Send_MddmMessage.				}
{	Skickar meddelanden till korten.		}
{*******************************************************}

Procedure Send_MddmMessage ( SRec	: s_message_t;
			     Kommando	: char ) [PUBLIC];

CONST
    STX		= CHR(2);

VAR
    Tecken	: char;		{ Kommandot som liten bokstav }
    Ant_Char	: byte;
    i		: byte;
    Parm_Nr	: integer;
    Status	: integer;	{ Funktions-status }
    iqsize	: integer;
    pstatus	: word;
    tmpstr	: lstr80;	{ f|r debug }

BEGIN	{ Send_MddmMessage }

    Status := qsize_a1 ( COM1, iqsize, pstatus );	{ l{s av status }
    IF iqsize <> 0 THEN BEGIN
    	Status := IFlsh_a1 ( COM1 );			{ rensa buffert }
	IF Status <> OK THEN BEGIN
	    DebugWrite ( 'IFlsch-error in message: #' );	{ D }
	    Eval ( Encode ( tmpstr , Status :-1:16 ) );	{ D }
	    DebugWriteLn ( tmpstr );
	END;
    END;

    Status := WrtCh_a1 ( COM1, STX );
    Parm_Nr := 0;
    WHILE SRec.Ant_Parm > 0 DO BEGIN
	Parm_Nr := Parm_Nr + 1;
	Ant_Char := SRec.ParmArea[Parm_Nr].len;
	FOR i := 1 TO Ant_Char DO
	    Status := WrtCh_a1 ( COM1, SRec.ParmArea[Parm_Nr, i] );
	IF SRec.Ant_Parm > 1 THEN Status := WrtCh_a1 ( COM1, ';' );
	SRec.Ant_Parm := SRec.Ant_Parm - 1;
    END;
    Tecken := CHR ( ORD ( Kommando ) + #20 );	{ G|r om till liten bokstav }
    Status := WrtCh_a1 ( COM1, Tecken );

END;	{ Send_MddmMessage }

{$page+}
{*******************************************************}
{	Receive_MddmAnswer.				}
{	Hamtar svar fran korten.			}
{*******************************************************}

Procedure Receive_MddmAnswer (	VAR RRec	: r_message_t;
				    Kommando	: char	       )
	  [PUBLIC];

CONST
    STX		= CHR(2);
    PStatusMask	= 16#00FF;

VAR
    STXFlagga	: boolean;
    i		: integer;	{ Index }
    Tecken	: char;
    Status	: integer;	{ Funktions-status }
    Iqsize	: integer;	{ Antal tecken i bufferten }
    PStatus	: word;		{ Kommunikations-status }
    TimeStart	: real;
    TimeEnd	: real;
    TimeTmp	: real;

{$page+}
{*******************************************************}
{	Protokoll.					}
{	Kontrollerar tecknen.				}
{*******************************************************}

Procedure Protokoll;

VAR
    RetParm_Nr	: integer;

BEGIN	{ Protokoll }

    IF Tecken = STX THEN
	STXFlagga := TRUE
    ELSE BEGIN
	IF STXFlagga = TRUE THEN BEGIN
	    CASE Tecken OF
		';'	: BEGIN
		    IF RRec.Ant_RetParm = 0 THEN
			RRec.Ant_RetParm := 1;
		    IF RRec.Ant_RetParm < MaxAntParm THEN
		    	RRec.Ant_RetParm := RRec.Ant_RetParm + 1;
		    END;
		'0'..'9',
		'A'..'F': BEGIN
		    IF RRec.Ant_RetParm = 0 THEN
			RRec.Ant_RetParm := 1;
		    RetParm_Nr := RRec.Ant_RetParm;
		    IF RRec.RetParmArea[RetParm_Nr].len < MaxParmLangd THEN
		    	ConCat ( RRec.RetParmArea[RetParm_Nr], Tecken )
		    ELSE STXFlagga := FALSE;
		    END;
		OTHERWISE
		    IF Tecken <> Kommando THEN
		    	STXFlagga := FALSE;
	    END; { CASE }
	END; { IF }
    END; { ELSE }

END;	{ Protokoll }

{*******************************************************}

BEGIN	{ Receive_MddmAnswer }

    STXFlagga := false;
    Tecken := CHR(0);	{ se till att tecken <> kommando }
    FOR i := 1 to  MaxAntParm DO
        RRec.RetParmArea[i].len := 0;
    RRec.Ant_RetParm := 0;
    TimeStart := time_a1;
    TimeEnd := TimeStart + RRec.TimeOutTid;
    REPEAT
	Status := RdCh_a1 ( COM1, Tecken, IqSize, PStatus );
	PStatus := PStatus AND PStatusMask;
	IF ( Status = OK ) AND ( PStatus = 0 ) THEN
	    Protokoll;
	TimeTmp := time_a1;
	IF TimeTmp < TimeStart THEN
	    TimeTmp := TimeTmp + 86400;	{ 24 timmar i sekunder }
	RRec.TimeOut := TimeTmp >= TimeEnd;
	DisplayTimes;			{ uppdatera klockan p} displayen }
    UNTIL ((Tecken = Kommando) AND STXFlagga) OR (RRec.TimeOut) OR (PStatus <> 0);
    RRec.PortStatus := Ord ( PStatus );

END;	{ Receive_MddmAnswer }

END.	{ Module }
