{$title:'MODULE: Objekt' $pagesize:41 $linesize:106}

Module Objekt;

{*******************************************************}
{	Denna modul innehaaller				}
{	inmatning av objektidentifikationer		}
{	och kommandofilnamn.				}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'screen.h'}
{$Include:'kbd.h'}
{$Include:'global.h'}
{$Include:'io.h'}

{$page+}
{*******************************************************}
{	GetObjekt;					}
{	laeser kort-id och var i racken de aer placerade}
{*******************************************************}

function GetObjekt(fn_ok : ftang_set):ftang_t [PUBLIC];

TYPE
	allow_t1 = array [1..slotant] OF ftang_set;
	allow_t2 = array [1..hyllant] OF allow_t1;

CONST
	allow_slot = allow_t2 (		{ olika foer varje slot }
		allow_t1 (
		[f_down,f_end,f_pgdn,f_enter],		{ slot 1 }
	DO 8 OF	[f_up,f_down,f_home,f_end,f_pgdn,f_enter], {slot 2-9}
		[f_up,f_home,f_pgdn] ),			{ slot 10 }

		allow_t1 (
		[f_down,f_end,f_pgup,f_pgdn,f_enter],	{ slot 1 }
	DO 8 OF	[f_up,f_down,f_home,f_end,f_pgup,f_pgdn,f_enter],{2-9}
		[f_up,f_home,f_pgup,f_pgdn] ),		{ slot 10 }

		allow_t1 (
		[f_down,f_end,f_pgup,f_pgdn,f_enter],	{ slot 1 }
	DO 8 OF	[f_up,f_down,f_home,f_end,f_pgup,f_pgdn,f_enter],{2-9}
		[f_up,f_home,f_pgup,f_pgdn] ),		{ slot 10 }

		allow_t1 (
		[f_down,f_end,f_pgup,f_pgdn,f_enter],	{ slot 1 }
	DO 8 OF	[f_up,f_down,f_home,f_end,f_pgup,f_pgdn,f_enter],{2-9}
		[f_up,f_home,f_pgup,f_pgdn] ),		{ slot 10 }

		allow_t1 (
		[f_down,f_end,f_pgup,f_enter],		{ slot 1 }
	DO 8 OF	[f_up,f_down,f_home,f_end,f_pgup,f_enter], {slot 2-9}
		[f_up,f_home,f_pgup] ) );		{ slot 10 }

	FIRSTROW = 1;		{ rad fer foersta slot (+2) }
	FIRSTCOL = 24;		{ kolumn }

VAR
	id : array [1..hyllant , 1..slotant] of id_t;
	hylla : integer;	{ aktuellt hyllnummer }
	slot  : integer;	{ aktuellt slotnummer }
	ftang : ftang_t;	{ funktionstangent }	
	i : integer;

    procedure redraw;
    VAR	i : integer;
    BEGIN
	slot := 1;
	FOR i := 1 TO slotant DO BEGIN
	    Cpos(i*2+FIRSTROW, FIRSTCOL);
	    ClrEol;
	    CposWrite(i*2+FIRSTROW, FIRSTCOL, id[hylla,i]);
	END; { FOR }
	CposWrite(3, 8, chr(#30+hylla));	{ skriv ut hyllnumret }
    END;

BEGIN	{ GetObjekt }

	{ nollstaell id-arrayen }
    FOR hylla := 1 to hyllant DO
	FOR slot := 1 to slotant DO
	    id[hylla,slot] := NULL;


	{ haemta fraan objektarrayen }
    FOR i := 1 to Round (ant_obj) DO
	id[rack[i].hyllnr,rack[i].slotnr] := rack[i].id;


    Menu(m_objekt);		{ laegg ut objektmenyn }

    hylla := 1;
    slot := 1;

    redraw;			{ skriv ut variabelfaelten }

    REPEAT

    	ftang := GetStr(id[hylla,slot],fn_ok+allow_slot[hylla,slot],
		 slot*2+FIRSTROW,FIRSTCOL, upper(id[hylla,slot]));

	CASE ftang OF

	    f_enter : slot := slot + 1;
	    f_up : slot := slot - 1;
	    f_down : slot := slot + 1;
	    f_home : slot := 1;
	    f_end : slot := slotant;
	    f_pgup : BEGIN
		hylla := hylla - 1;
		redraw;
	    END;
	    f_pgdn : BEGIN
		hylla := hylla + 1;
		redraw;
	    END;
	    OTHERWISE
		;
	END; { CASE }

    UNTIL ftang in fn_ok;

	{ flytta till objektarayen }

    i := 0;
    IdLength := 22;		{ minsta l{ngd }
    FOR hylla := 1 to hyllant DO
	FOR slot := 1 to slotant DO BEGIN
	    WHILE (id[hylla, slot] <> NULL)
	    AND (id[hylla, slot, id[hylla, slot].LEN] = ' ') DO
	    	id[hylla, slot].LEN := id[hylla, slot].LEN - 1;
	    IF id[hylla,slot] <> NULL THEN BEGIN
	    	IF id[hylla, slot].LEN > IdLength THEN
		    IdLength := id[hylla, slot].LEN;
		i := i + 1;
		rack[i].id := id[hylla,slot];
		rack[i].hyllnr := hylla;
		rack[i].slotnr := slot;
	    END;
        END;
    ant_obj := i;
    GetObjekt := ftang;	{ vald funktion }

END;	{ GetObjekt }

{$page+}
{*******************************************************}
{	Get_ComFileName;				}
{	Laser kommandofilnamnet				}
{*******************************************************}

Function Get_ComFileName(fn_ok : ftang_set):ftang_t [PUBLIC];

CONST
    Row = 12;			{ rad	 }
    Column = 25;		{ kolumn }

VAR
    ftang	: ftang_t;	{ funktionstangent }
    TimStr	: lstr2;
    TimBin	: integer;
    ok		: boolean;

BEGIN	{ Get_ComFileName }

    TimBin := Ord(TotTid DIV 3600);
    EVAL ( ENCODE ( TimStr, TimBin:-2) );

    CposWrite ( 13, 25, 'TOTAL TESTTID :' );
    CposWrite ( 13, 41, TimStr );

    CposWrite ( 10, 25, 'TESTSEKVENS   :' );
    CposWrite ( 10, 41, ComFileName );

    REPEAT
	ftang := GetStr ( ComFileName, fn_ok + [f_enter,f_down,f_end],
		 10, 41, upper(ComFileName) );
	IF NOT ( ftang in fn_ok ) THEN
	    REPEAT
	    	ftang := GetStr ( TimStr, fn_ok + [f_enter,f_up,f_home],
			 13, 41, upper(TimStr) );
		ok := DECODE(TimStr, TimBin);
		IF ok THEN BEGIN
		    TotTid := TimBin;
		    TotTid := TotTid * 3600;
		END ELSE BEGIN
		    EVAL ( ENCODE ( TimStr, TimBin:-2) );
		    CposWrite ( 13, 41, TimStr );
		END;
	    UNTIL ok;
    UNTIL ftang in fn_ok;

    Get_ComFileName := ftang;	{ vald funktion }

    { Blanka gamla kommandofilnamnet, det nya skrivs ut av main }
    CposWrite ( 23, 43, '                                        ');

END;	{ Get_ComFileName }

END.	{ module }
