{$title:'MODULE: PwCkomn' $pagesize:41 $linesize:108}

Module PwCKomn;

{*******************************************************}
{	Modulen innehaller PowerController-rutiner.	}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'tid.h'}
{$Include:'asynch.h'}
{$Include:'logg.h'}
{$Include:'varhandl.h'}
{$Include:'io.h'}
{$Include:'objkomn.h'}
{$Include:'screen.h'}

CONST
    NULL	= CHR(0);
    ETX		= CHR(3);
    ACK		= CHR(6);
    CR		= CHR(13);
    MaxAntTry	= 2;		{ Max antal s{ndningar till PwC:n }

{$page+}
{*******************************************************}
{	Flush_PwCBuffer.				}
{	T|mmer In-bufferten.				}
{*******************************************************}

Procedure Flush_PwCBuffer;

VAR
    Status	: integer;	{ Funktions-status }
    tmpstr	: lstr4;

BEGIN	{ Flush_PwCBuffer }

    Status := IFlsh_a1 ( COM2 );
    IF Status <> OK THEN BEGIN				{ D }
	DebugWrite ( 'IFlsch-error in pwckomn: ' );	{ D }
	Eval ( Encode ( tmpstr , Status :1 ) );		{ D }
	DebugWriteLn ( tmpstr );			{ D }
    END;						{ D }

END;	{ Flush_PwCBuffer }

{$page+}
{*******************************************************}
{	PwCCTS.						}
{	Kollar om Pwc:n lagt ut CTS.			}
{*******************************************************}

Function PwCCTS : boolean;

CONST
    TimeOutTid	= 2;		{ V{nta p} kontakt med PwC:n }

VAR
    TimeEnd	: integer4;	{ TimeOuten slut }
    lstatus	: byte;		{ Line-status }
    mstatus	: byte;		{ Modem-status }
    TmpBool	: boolean;

BEGIN	{ PwCCTS }

{	PwCCTS := True;
	RETURN;				}

    TimeEnd := SecUsed + TimeOutTid;
    REPEAT
    	TmpBool := (Stat_a1 (COM2, lstatus, mstatus) AND #10 ) <> 0;
    UNTIL ( SecUsed >= TimeEnd ) OR TmpBool;
    IF NOT TmpBool THEN Logga_SerErr ( PwCContact, 0 );
    PwCCTS := TmpBool;

END;	{ PwCCTS }

{$page+}
{*******************************************************}
{	PwCComm.					}
{	S{nder en str{ng och kollar om			}
{	Power-Controllern svarar.			}
{*******************************************************}

Procedure PwCComm ( KomndStr : lstr12 );

CONST
    WaitTid	= 0.150;	{ Tid i sek att v{nta p} svar fr}n PwC:n
    				  {ven f|r att l}ta sp{nningen stabiliseras }
    PStatusMask	= 16#00FF;	{ Tar bort ointressanta bitar }

VAR
    Status	: integer;	{ Funktions-status }
    PStatus	: word;		{ Kommunikations-status }
    KomFelTyp	: lstr5;	{ Kommunikations-feltyp }
    StrLen	: integer;	{ Langden pa kommando-strangen }
    No_Wrt	: integer;	{ Antal skickade tecken }
    tkn		: char;		{ mottaget tecken }
    timeend	: integer4;	{ n{r v{ntetiden f|r svaret g}r ut }
    IqSize	: integer;	{ Antal tecken i bufferten }
    SRQAnswer	: boolean;

{$page+}
{#######################################################}
{	Check_PwC_Answer.				}
{	Tar hand om SRQ.				}
{#######################################################}

Procedure Check_PwC_Answer;

VAR
    No_Read	: integer;	{ Antal l{sta tecken }
    SvarStr2	: string(2);	{ 'SRQ' i powerController-svaret }
    SvarStr8	: string(8);	{ Bitm|nster i PowerController-svaret }
    Bit		: byte;		{ F|r indexering i bitm|nstret }
    BitVarde	: integer;	{ Bitm|nstret som en integer }
    Tecken	: char;

BEGIN	{ Check_PwC_Answer }

    Status := RdSt_a1 ( COM2, 2, ADS SvarStr2, No_Read, IqSize, PStatus );
    SRQAnswer := ( SvarStr2 = 'RQ' );
    IF SRQAnswer THEN BEGIN
	FOR Bit := 1 TO 8 DO BEGIN		{ Ettor och nollor? }
	    Status := RdCh_a1 ( COM2, Tecken, IqSize, PStatus );
	    IF ( Tecken <> '0' ) AND ( Tecken <> '1' ) THEN BEGIN
	    	Logga_PwCErr ( #10 );
	    	RETURN;
	    END; { IF }
	    SvarStr8[Bit] := Tecken;
	END; { FOR }
	BitVarde := 0;
	IF SvarStr8[1] = '1' THEN BEGIN		{ SRQ fran moderkort }
	    IF SvarStr8[8] = '1' THEN BitVarde := BitVarde + 1;
	    IF SvarStr8[7] = '1' THEN BitVarde := BitVarde + 2;
	    IF SvarStr8[6] = '1' THEN BitVarde := BitVarde + 4;
	    IF SvarStr8[5] = '1' THEN BitVarde := BitVarde + 8; END { IF }
	ELSE;			{ SRQ fran INT-ingang ( Bitvarde = 0 ) }
	Logga_PwCErr ( BitVarde );
    END; { IF }

END;	{ Check_PwC_Answer }
     
{#######################################################}

BEGIN	{ PwCComm }

    IF NOT PwCCTS THEN RETURN;			{ Ingen kontakt med PwC:n }
    Flush_PwCBuffer;				{ T|m bufferten }
    SRQAnswer := false;
    Concat ( KomndStr, CR );
    Concat ( KomndStr, ETX );
    StrLen := Ord ( KomndStr.Len );
    tkn := NULL;

    Status := WrtSt_a1 ( COM2, StrLen, ADS KomndStr[1], No_Wrt );
    timeend := SecUsed + 2;
    REPEAT
    	status := RdCh_a1 ( COM2, tkn, IqSize, PStatus ); { l{s ett tkn }
    UNTIL ( status = OK ) OR ( SecUsed > timeend );
    PStatus := PStatus AND PStatusMask;

    IF ( tkn <> ACK ) OR ( PStatus <> 0 ) THEN BEGIN	{ g|r ett nytt f|rs|k om 1:a misslyckades }
    	Wait_a1 ( WaitTid );	{ v{nta in ev SRQ eller annat skr{p }
	Flush_PwCBuffer;	{ T|m bufferten }

    	Status := WrtSt_a1 ( COM2, StrLen, ADS KomndStr[1], No_Wrt );
	tkn := NULL;
	timeend := SecUsed + 2;
	REPEAT
	    status := RdCh_a1 ( COM2, tkn, IqSize, PStatus ); { l{s ett tkn }
	    PStatus := PStatus AND PStatusMask;
	    IF ( Status = OK ) AND ( PStatus = 0 ) THEN
	    	IF ( tkn = 'S' ) THEN BEGIN
		    Wait_a1 ( WaitTid );	{ v{nta in SRQ }
		    IF ( IqSize > 2 ) THEN
		Check_PwC_Answer;		{ ta hand om SRQ }
		END; { IF }
	UNTIL ( tkn = ACK ) OR ( SecUsed > timeend ) OR ( PStatus <> 0 );

	IF NOT SRQAnswer THEN BEGIN	{ om det kommit SRQ beh|vs ej ytterligare loggning }

	    IF tkn <> ACK THEN
	    	Logga_SerErr ( PwCNoAck, 0 );

	    IF PStatus <> 0 THEN BEGIN
	    	KomFelTyp := PStatKonv ( ord(PStatus) );
		Logga_PwCKomFel ( KomFelTyp );
	    END; { IF }

	END; { IF }

    END; { IF }

END;	{ PwCComm }

{$page+}
{*******************************************************}
{	PwC_OK.						}
{	Kollar att PwC:n lever.				}
{*******************************************************}

Function PwC_OK : boolean;

CONST
    TimeOutTid	= 0.55;
 
VAR
    Status	: integer;	{ Funktions-status }
    KomndStr	: string(4);	{ Kommando-strangen }
    SvarStr	: string(4);	{ PowerController-svaret }
    No_Wrt	: integer;	{ Antal skickade tecken }
    No_Read	: integer;	{ Antal lasta tecken }
    IqSize	: integer;	{ Antal tecken i bufferten }
    PStatus	: word;		{ Kommunikations-status }
    AntTry	: integer;	{ Antal s{nd-f|rs|k }

BEGIN	{ PwC_OK }

    IF NOT PwCCTS THEN BEGIN 
    	PwC_OK := FALSE;
	RETURN;				{ Ingen kontakt med PwC:n }
    END;
    AntTry := 0;
    KomndStr := 'VS1 ';
    KomndStr[4] := CR;
    Flush_PwCBuffer;			{ T|m bufferten }
    REPEAT
        Status := WrtSt_a1 ( COM2, 4, ADS KomndStr, No_Wrt );
	Wait_a1 (TimeOutTid);			{ Vanta in svaret }
	Status := RdSt_a1 ( COM2, 4, ADS SvarStr, No_Read, IqSize, PStatus );
	Flush_PwCBuffer;			{ T|m bufferten }
	AntTry := AntTry + 1;
    UNTIL ( SvarStr = 'SL1,' ) OR ( AntTry = MaxAntTry );
    IF SvarStr = 'SL1,' THEN
        PwC_OK := TRUE
    ELSE PwC_OK := FALSE;

END;	{ PwC_OK }

{$page+}
{*******************************************************}
{	PowerController-initiering.			}
{*******************************************************}

Procedure Ini_PwC [PUBLIC];

TYPE
    IniKomndStr	= ARRAY [1..10] OF lstr8;

CONST
    IniKomnd = IniKomndStr    ( 'ERIN1',	{ Enable Error Interrupt }
				'INTNNNN',	{ Disable Interrupt }

	{ Spanning-slotet }	'SL1',		{ Slot 1 i PwC:n }
				'MV15.00',	{ Max Voltage }
				'OVP5.800',	{ Output Voltage Protection, kompensera bortfall +0.3v }	
				'V5.300',	{ Voltage, kompensera bortfall +0.3v }

	{ Analog-slotet }	'SL2',		{ Slot 2 i PwC:n }
				'MV10.00',	{ Max Voltage }
				'OVP9.000',	{ Output Voltage Protection }
				'V0.000'    );	{ Voltage }

VAR
    i		: integer;
    KomndStr	: lstr12;	{ Kommando-strangen }

BEGIN	{ Ini_PwC }

    IF Pwc_OK THEN BEGIN
    	Spanning := '5.000';		{ f|r loggning }
	SpanningFlg := TRUE;
	AnaSpanning := '0';
	FOR i := 1 TO 10 DO BEGIN
	    KomndStr := IniKomnd[i];
	    PwCComm ( KomndStr );	{ Skicka kommandot till PwC:n }
	END; { FOR }
	CposWrite (1, 8, Spanning );	{ Visa vald sp{nning p} bilden }
    END ELSE
    	Logga_SerErr ( PwC_Init, 0 );

END;	{ Ini_PwC }

{$page+}
{*******************************************************}
{	PowerController-avslut.				}
{*******************************************************}

Procedure Exit_PwC [PUBLIC];

TYPE
    IniKomndStr	= ARRAY [1..4] OF lstr8;

CONST
    IniKomnd	= IniKomndStr	( 'SL1',	{ spanning-slotet }
    				  'V0.000',	{ Voltage }
				  'SL2',	{ analog-slotet }
				  'V0.000'   );	{ Voltage }

VAR
    i		: integer;
    KomndStr	: lstr12;	{ Kommando-strangen }

BEGIN	{ Exit_PwC }

    FOR i := 1 TO 4 DO BEGIN
	KomndStr := IniKomnd[i];
	PwCComm ( KomndStr );	{ Skicka kommandot till PwC:n }
    END; { FOR }

END;	{ Exit_PwC }

{$page+}
{*******************************************************}
{	SPANNING-kommandot.				}
{*******************************************************}

Procedure Set_Spanning ( ptr	  : komm_ptr;
			 RadDelar : linepart_t ) [PUBLIC];

VAR
    KomndStr	: lstr12;	{ Kommando-strangen }
    ErrParm	: ErrParmArea_t;{ For felaktiga parametrar }
    tmpstr	: lstr5;

BEGIN	{ Set_Spanning }

    KomndStr := 'SL1V';
    IF RadDelar[2].typ = variabel THEN	{ Parametern till SPANNING-kommandot }
	RadDelar[2].vaerde := Get_VarValue ( RadDelar[2].txt );

    IF ( spamin <= RadDelar[2].vaerde ) AND ( RadDelar[2].vaerde <= spamax )
    THEN BEGIN						{ Utfor kommandot }
	Eval ( Encode ( Spanning, RadDelar[2].vaerde :1 :3 ) );	{ f|r loggning }
	CposWrite (1, 8, Spanning );	{ visa vald sp{nning p} bilden }
	IF ( RadDelar[2].vaerde < 0.001 ) THEN { 0 volt valt }
	    Concat ( KomndStr, '0' )
	ELSE BEGIN
	    Eval ( Encode ( tmpstr, (RadDelar[2].vaerde+0.3) :1 :3 ) ); { kompensera sp{nningsbortfall med +0.3 volt }
	    Concat ( KomndStr, tmpstr );
	END;
	PwCComm ( KomndStr );		{ Skicka kommandot till PwC:n }
	IF ( RadDelar[2].vaerde < 0.001 ) THEN BEGIN { 0 volt valt }
	    DisConnect_Kort;	{ Koppla bort kraftaggregatet }
	    SpanningFlg := FALSE; END { IF }
	ELSE BEGIN
	    IF NOT SpanningFlg THEN BEGIN	{ Om ingen spanning }
		SpanningFlg := TRUE;
		Connect_Kort;			{ Koppla in kraftaggregatet }
	    END;
	END; { ELSE } END { IF }
    ELSE BEGIN				{ Logga den felaktiga parametern }
	ErrParm[1].ParmTyp := SpanningParm;
	ErrParm[1].Varde := RadDelar[2].vaerde;
	Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, 1 );
    END; { ELSE }

END;	{ Set_Spanning }

{$page+}
{*******************************************************}
{	ANALOG-kommandot.				}
{*******************************************************}

Procedure Set_Analog (	ptr	 : komm_ptr;
			RadDelar : linepart_t ) [PUBLIC];

VAR
    KomndStr	: lstr12;	{ Kommando-strangen }
    ErrParm	: ErrParmArea_t;{ For felaktiga parametrar }

BEGIN	{ Set_Analog }

    KomndStr := 'SL2V';
    IF RadDelar[2].typ = variabel THEN	{ Parametern till ANALOG-kommandot }
	RadDelar[2].vaerde := Get_VarValue ( RadDelar[2].txt );

    IF ( anamin <= RadDelar[2].vaerde ) AND ( RadDelar[2].vaerde <= anamax )
    THEN BEGIN						{ Utfor kommandot }
	Eval ( Encode ( AnaSpanning, RadDelar[2].vaerde :1 :3 ) );
	Concat ( KomndStr, AnaSpanning );    
	PwCComm ( KomndStr ); END { IF } { Skicka kommandot till PwC:n }
    ELSE BEGIN			{ Logga den felaktiga parametern }
	ErrParm[1].ParmTyp := AnaSpannParm;
	ErrParm[1].Varde := RadDelar[2].vaerde;
	Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, 1 );
    END; { ELSE }

END;	{ Set_Analog }

END.	{ Module }
