{$title:'MODULE: Screen' $pagesize:41 $linesize:106}

Module Screen;

{*******************************************************}
{	Denna modul innehaaller				}
{	rutiner som hanterar bildskaermen		}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'kbd.h'}
{$Include:'io.h'}
{$Include:'tid.h'}

Procedure Time	 ( VAR	S  : string ); EXTERN;

CONST

    streck = '--------------------------------------------------------------------------------';

VAR
    Printed	: array [f_1..f_10] of boolean;
		{ Talar om vilka funktionstangenter som ar "tanda". }

{$page+}
{*******************************************************}
{	ClrLine						}
{	Clear Line					}
{*******************************************************}

Procedure ClrLine ( rad : integer ) [PUBLIC];

VAR
    OldRad	: integer;
    OldKol	: integer;

BEGIN	{ ClrLine }

     GetCpos (OldRad,OldKol);
     Cpos (Rad,1);
     Write(CHR(27),'[K');
     Cpos (OldRad,OldKol);

END;	{ ClrLine }
{$page+}
{*******************************************************}
{	ClrEol						}
{	Clear to end of line				}
{*******************************************************}

Procedure ClrEol [PUBLIC];

BEGIN	{ ClrEol }

    Write(CHR(27),'[K');

END;	{ ClrEol }
{$page+}
{*******************************************************}
{	InvVid						}
{	Inverse Video					}
{*******************************************************}

Procedure InvVid [PUBLIC];

BEGIN	{ InvVid }

	Write(CHR(27),'[7m');

END;	{ InvVid }
{$page+}
{*******************************************************}
{	NorVid						}
{	Normal Video					}
{*******************************************************}

Procedure NorVid [PUBLIC];

BEGIN	{ NorVid }

	Write(CHR(27),'[0m');

END;	{ NorVid }
{$page+}
{*******************************************************}
{	CposWrite:					}
{	Positionerar cursorn, skriver ut en strang och	}
{	positionerar tillbaka cursorn.			}
{*******************************************************}

Procedure CposWrite (	      rad,kol : integer;
			CONST strang  : string  ) [PUBLIC];

VAR
    OldRad	: integer;
    OldKol	: integer;

BEGIN	{ CposWrite }

     GetCpos (OldRad,OldKol);
     Cpos (Rad,Kol);
     Write (strang);
     Cpos (OldRad,OldKol);

END;	{ CposWrite }
{$page+}
{*******************************************************}
{	ScrollWrite:					}
{	Skriver ut en strang inom scrollomr}det.	}
{*******************************************************}

Procedure ScrollWrite ( CONST strang : string  ) [PUBLIC];

VAR
    str : lstring(255);
    Rad	: integer;
    Kol	: integer;
    i	: integer;

BEGIN	{ ScrollWrite }

    GetCpos (Rad,Kol);
    COPYLST(strang,str);
    IF str <> NULL THEN BEGIN		{ byt alla tabbar mot space }
    	i := POSITN ( chr(9), str, 1 ); 
    	WHILE i <> 0 DO BEGIN
	    str[i] := ' ';
	    i := POSITN ( chr(9), str, 1 );
	END;
    END;
    IF str.LEN > wrd ( 80 - kol ) THEN	{ ryms str{ngen p} raden }
	str.LEN := wrd ( 80 - kol );		{ nej ! }
    Write (str);

END;	{ ScrollWrite }
{$page+}
{*******************************************************}
{	DebugWrite:					}
{	Skriver ut en strang inom scrollomr}det.	}
{	Ej t{nkt att anvandas i produktionen.		}
{*******************************************************}

Procedure DebugWrite ( CONST strang : string  ) [PUBLIC];

BEGIN	{ DebugWrite }

    ScrollWrite ( strang );

END;	{ DebugWrite }
{$page+}
{*******************************************************}
{	ScrollWriteLn:					}
{	Skriver ut en strang och scrollar vi behov.	}
{*******************************************************}

Procedure ScrollWriteLn ( CONST strang : string  ) [PUBLIC];

VAR
    Rad	: integer;
    Kol	: integer;

BEGIN	{ ScrollWriteLn }

    GetCpos (Rad,Kol);
    ScrollWrite(strang);
    IF Rad >= 21 THEN BEGIN
	Scroll;
	Cpos (21,1);
    END ELSE
	WriteLn;

END;	{ ScrollWriteLn }
{$page+}
{*******************************************************}
{	DebugWriteLn:					}
{	Skriver ut en strang och scrollar vi behov.	}
{	Ej t{nkt att anvandas i produktionen.		}
{*******************************************************}

Procedure DebugWriteLn ( CONST strang : string  ) [PUBLIC];

BEGIN	{ DebugWriteLn }

    ScrollWriteLn ( strang );

END;	{ DebugWriteLn }
{$page+}
{*******************************************************}
{	DisplayFel:					}
{	skriver en TextStr utan tider p} bildsk{rmen	}
{*******************************************************}

Procedure DisplayFel( CONST str : string ) [PUBLIC];

VAR
    Dstr	: lstring(132);

BEGIN	{ DisplayFel }

    CopyLst (str, DStr);
    Delete ( DStr, 1, 29);	{ ta bort tiderna }
    InvVid;
    ScrollWriteLn ( DStr );
    NorVid;

END;	{ DisplayFel }
{$page+}
{*******************************************************}
{	ErrMsg:						}
{	skriver ett meddelade samt	 		}
{	"kvittera med valfri tangent" 			}
{	och vaentar paa kvittens			}
{*******************************************************}

Procedure ErrMsg( CONST str : string ) [PUBLIC];

VAR
	c : char;

BEGIN	{ ErrMsg }

    Write ( chr(7) );	{ Beep }

    InvVid;
    ScrollWriteLn( str );
    ScrollWriteLn( 'Kvittera med valfri tangent' );
    NorVid;

    WHILE Keypressed DO
    	c := GetCh;		{ sug ut ev. tecken ur kbd-buffeln }

    c := GetCh;

END;	{ ErrMsg }
{$page+}
{*******************************************************}
{	DisplayTimes:					}
{	skriver tiderna i |vre h|gra h|rnet 		}
{*******************************************************}

Procedure DisplayTimes [PUBLIC];

VAR
	Aktuell_Tid : str8;
	Used_Tid    : str9;

BEGIN	{ DisplayTimes }

        Used_Tid := TimeUsed;
	Time ( Aktuell_Tid );

	CPosWrite ( 1, 72, Used_Tid );
	CPosWrite ( 1, 62, Aktuell_Tid );

END;	{ DisplayTimes }
{$page+}
{*******************************************************}
{	ShowFileErr:					}
{	Skickar en feltext till ErrMsg ex:		}
{	'Fel vid OPEN kommandofil "MDDMTEST", felkod: 1'}
{*******************************************************}

Procedure ShowFileErr( CONST	action	: string;
				filtyp	: lstr80;
				filnamn	: lstr80;
				kod	: integer ) [PUBLIC];

VAR
    s1	: lstr80;
    s2	: lstring(6);
    rc	: boolean;

BEGIN	{ ShowFileErr }

    s1 := 'Fel vid ';
    concat(s1, action);
    concat(s1, ' ' );
    concat(s1, filtyp );
    concat(s1, ' "' );
    concat(s1, filnamn);
    concat(s1, '", felkod: ');
    rc := encode(s2, kod:-5 );
    concat(s1, s2);
    ErrMsg(s1);

END;	{ ShowFileErr }
{$page+}
{*******************************************************}
{	Menu:						}
{	skriver en menu paa displayen			}
{*******************************************************}

Procedure Menu( val : menu_t ) [PUBLIC];

VAR
	fil : lstr10;
	rad : INTEGER;
	kol : INTEGER;
	txt : lstr80;
	menufile : TEXT;
	i : integer;
	c : char;

BEGIN	{ Menu }

	CASE val OF
	    m_main : BEGIN
	        CPosWrite( 3 , 1, 'DETTA [R MAINBILDEN');
	    END;
	    m_objekt : BEGIN
	        CPosWrite( 3 , 1, 'HYLLA:');
	        CPosWrite( 3 , 15, 'SLOT  1:');
	        CPosWrite( 5 , 15, 'SLOT  2:');
	        CPosWrite( 7 , 15, 'SLOT  3:');
	        CPosWrite( 9 , 15, 'SLOT  4:');
	        CPosWrite( 11, 15, 'SLOT  5:');
	        CPosWrite( 13, 15, 'SLOT  6:');
	        CPosWrite( 15, 15, 'SLOT  7:');
	        CPosWrite( 17, 15, 'SLOT  8:');
	        CPosWrite( 19, 15, 'SLOT  9:');
	        CPosWrite( 21, 15, 'SLOT 10:');
	    END; { objekt }
	END;

END;	{ Menu }
{$page+}
{*******************************************************}
{	Write_InitBild;					}
{	Lagger ut "testbilden".				}
{*******************************************************}

Function Write_InitBild ( fn_ok : ftang_set ) : ftang_t [PUBLIC];

CONST
    Rad = 1;			{ Rad	 }
    Kol = 1;			{ Kolumn }

VAR
    BildFil	: text;		{ "Testbilden" }
    ftang	: ftang_t;	{ Funktionstangent }
    BildRad	: lstr80;	{ En rad i bilden }
    TomStr	: lstring(1);	{ Tom strang }

Begin	{ Write_InitBild }

    InvVid;
    CposWrite( 1, 26, ' Testsystem f|r MDDM controller ');
    NorVid;
    CposWrite( 2, 1, streck );
    CposWrite( 22, 1, streck );

    REPEAT			{ Vanta pa nedtryckning av funktionstangent }
	ftang := GetStr ( TomStr, fn_ok, Rad, Kol, 0 );
    UNTIL ftang in fn_ok;
    Write_InitBild := ftang;	{ Vald funktion }

END;	{ Write_InitBild }
{$page+}
{*******************************************************}
{	Clr_FTangPrintFlgs;				}
{	Talar om att inga funktionstangenter ar "tanda".}
{*******************************************************}

Procedure Clr_FTangPrintFlgs [PUBLIC];

VAR
    ftang	: ftang_t;	{ Funktionstangent }

BEGIN	{ Clr_FTangPrintFlgs }

    FOR ftang := f_1 TO f_10 DO
	Printed[ftang] := FALSE;

END;	{ Clr_FTangPrintFlgs }
{$page+}
{*******************************************************}
{	WriteLine25;					}
{	Skriver ut vilka funktionstangenter som kan	}
{	anvandas i olika situationer			}
{*******************************************************}

Procedure WriteLine25 ( fn_ok : ftang_set ) [PUBLIC];

TYPE
    FtangStr_t	= array [f_1..f_10] of  string(15);

CONST
    FtangStr	= FtangStr_t (	' F1 - ObjektId ',
				' F2 - Sekvens  ',
				' F3 - Start    ',
				' F4            ',
				' F5            ',
				' F6            ',
				' F7            ',
				' F8            ',
				' F9            ',
				' F10 - EXIT    ' );

VAR
    ftang	: ftang_t;	{ Funktionstangent }
    Kolumn	: integer;	{ Kolumn }

BEGIN	{ WriteLine25 }

    Kolumn := 1;
    FOR ftang := f_1 TO f_10 DO BEGIN
	IF ( ftang in fn_ok ) AND ( NOT Printed[ftang] ) THEN BEGIN
	    InvVid;		{ Inversed video }
	    CposWrite (25,Kolumn, FtangStr[ftang] );
	    NorVid;
	    Printed[ftang] := TRUE; END { IF }
	ELSE IF ( NOT (ftang in fn_ok) ) AND ( Printed[ftang] ) THEN BEGIN
	    CposWrite (25,Kolumn, '               ' );
	    Printed[ftang] := FALSE;
	END; { ELSE IF }
	IF ftang <= f_3 THEN Kolumn := Kolumn + 16;
    END; { FOR }

END;	{ WriteLine25 }

END.	{ module }
