{$title:'MODULE: Synt' $pagesize:41 $linesize:106}

Module Synt;

{*******************************************************}
{	modulen innehaaller syntaxcheckaren		}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'logg.h'}
{$Include:'varhandl.h'}
{$Include:'screen.h'}

Function Freect ( size : word ) : word; EXTERN;

TYPE

  komlist_t = RECORD	{ koppling mellan kommandonamn och ktyp }
    txt : string(10);	{ kommandonamn }
    komm : ktyp;	{ kommando }
  END;

  komlist_a = ARRAY [1..antkomm] OF komlist_t;

  fornext_t = RECORD	{ element i for-next stacken vid syntaxkontroll }
    variabel : lstr10;	{ namnet paa variabeln }
    forptr : komm_ptr;	{ pekare till for-kommandot }
  END;

  fornext_a = ARRAY [1..fnmax] OF fornext_t;	{ for-next stacken }

CONST

  komlist = komlist_a (
    komlist_t('FOR       ' , kFor)
   ,komlist_t('UTSIGNAL  ' , kUtsignal )
   ,komlist_t('INSIGNAL  ' , kInsignal )
   ,komlist_t('RAMTEST   ' , kRamtest )
   ,komlist_t('PROMTEST  ' , kPromtest )
   ,komlist_t('WATCHDOG  ' , kWatchdog )
   ,komlist_t('TEMP      ' , kTemp )
   ,komlist_t('SPANNING  ' , kSpanning )
   ,komlist_t('ANALOG    ' , kAnalog )
   ,komlist_t('PAUS      ' , kPaus )
   ,komlist_t('LOGG      ' , kLogg )
   ,komlist_t('OBJEKT    ' , kObjekt )
   ,komlist_t('SETNOV    ' , kSetnov )
   ,komlist_t('CHECKNOV  ' , kChecknov )
   ,komlist_t('RESET     ' , kReset )
   ,komlist_t('SIOTEST   ' , kSiotest )
   ,komlist_t('IOPORT    ' , kIoport )
   ,komlist_t('NEXT      ' , kNext )
     );

{$page+}
{*******************************************************}
{	SplitLine:					}
{	delar upp en rad fraan kommandofilen till	}
{	element, daer varje element aer det som		}
{	avskilljs med blanka, tab eller komma		}
{*******************************************************}
procedure SplitLine (	VAR delarna	: linepart_t;
			VAR antal	: integer;
			VAR err		: error_t;
			VAR raden	: lstr80) [PUBLIC];


VAR
  ri	: integer;	{ radindex }
  ei	: integer;	{ elementidex }
  wrkelem : lstr80;	{ arbetsbuffer foer ett element }
  klar	: boolean;	{ flagga naer raden aer klar }
  i	: integer;
  i4	: integer4;

BEGIN

  ri := 1;	{ radindex }
  ei := 0;	{ elementidex }
  err := NoError;
  klar := false;

  WHILE (klar = false) AND (ri < ord(raden.LEN)) AND (ei < maxelem) DO BEGIN

	{ skippa blanka, tab och komma }
    WHILE (raden[ri] in delim) AND (ri < ord(raden.LEN)) DO
      ri := ri + 1;

	{ haemta ett element }
    wrkelem := NULL;

    IF raden[ri] = '"' THEN BEGIN	{ straeng }
      Concat(wrkelem,raden[ri]);
      ri := ri + 1;
      REPEAT
	Concat(wrkelem,raden[ri]);
	ri := ri + 1;
      UNTIL (wrkelem[wrkelem.LEN] = '"') OR (ri > ord(raden.LEN));
      IF (wrkelem[wrkelem.LEN] <> '"') AND (err = NoError) THEN
	err := NoStringEnd;
    END ELSE BEGIN	{ inte straeng }
      REPEAT
	Concat(wrkelem,raden[ri]);
	ri := ri + 1;
      UNTIL (raden[ri] in delim) OR (ri > ord(raden.LEN)) OR (raden[ri] = '''');
      FOR i := 1 to ord(wrkelem.LEN) DO	{ konvertera till stora bokstaever }
	IF (wrkelem[i] >= 'a') AND (wrkelem[i] <= 'z') THEN
	  wrkelem[i] := chr( ord(wrkelem[i]) - ord(' ') );
    END;

    IF wrkelem[1] = '''' THEN BEGIN

      klar := true;	{ resten av raden kommentar }

    END ELSE
     IF (wrkelem <> NULL) AND NOT (wrkelem[1] IN delim) THEN BEGIN

      ei := ei + 1;
      delarna[ei].txt := wrkelem;
      delarna[ei].indx := ri-ord(wrkelem.LEN);	{ laengden }

      CASE wrkelem[1] OF

	'0'..'9','+','-' : BEGIN	{ hel eller flyttal }
	  delarna[ei].typ := vaerde;
	  IF (NOT Decode(wrkelem,delarna[ei].vaerde)) AND (err = NoError) THEN
	    err := NoValue;
	END;	{ vaerde }

	'#' : BEGIN	{ Hexadecimalt tal }
	  delarna[ei].typ := vaerde;
	  IF (NOT Decode(wrkelem,i4)) AND (err = NoError) THEN
	    err := NoValue;
	  Delarna[ei].vaerde := float4(i4);
	END;	{ vaerde }

	'A'..'Z' : BEGIN	{ variabel (eller kommando) }
	  delarna[ei].typ := variabel;
	  IF delarna[ei].txt.len > 10 THEN
	    delarna[ei].txt.len := 10;	{ 10 signifikanta tecken }
	END;	{ variabel }

	'"' : BEGIN	{ straeng }
	  delarna[ei].typ := strng;
		{ ta bort forsta och sista tecknet dvs. " }
	  Movel( ADR wrkelem[2], ADR delarna[ei].txt[1], wrkelem.LEN-2);
	  delarna[ei].txt.LEN := wrkelem.LEN-2;   { saett aeven upp laengden }
	END;	{ straeng }

	OTHERWISE BEGIN
	  IF err = NoError THEN
	    err := IllegalCharacter;
	END;	{ OTHERWISE }

      END;	{ CASE }

    END;	{ IF kommentar }

  END;	{ WHILE raden inte aer klar }

  antal := ei;	{ antal element }

END;	{ SplitLine }
{$page+}
{*******************************************************}
{	ValOut:						}
{	returnerar true om vaerdet paa 'vaerde' aer	}
{	mindre aen lo eller stoerre aen hi		}
{*******************************************************}
function ValOut(vaerde,lo,hi:real):boolean;


BEGIN	{ ValOut }

  ValOut := false;

  IF ( vaerde < lo ) OR ( vaerde > hi ) THEN
    ValOut := true;

END;	{ ValOut }
{$page+}
{*******************************************************}
{	CheckFor.					}
{	syntaxkontrollerar FOR-kommandot		}
{*******************************************************}
procedure CheckFor(	curr:komm_ptr;
		    VAR fnstack:fornext_a;
		    VAR	fnind:integer;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

VAR
  i : integer;
  tmpbo : boolean;

BEGIN	{ CheckFor }

  { kolla antal parametrar }

  IF (numparts-1 < 3) OR (numparts-1 > 4) THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  { kolla att loop-variabeln inte aer foerdefinierad }

  IF CheckVar(lineparts[2].txt) = ForDefinierad THEN BEGIN
    error := ParmTyp;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  { kolla om tillaaten elementtyp }

  FOR i := 2 to numparts DO BEGIN
    IF (i = 2) and (lineparts[i].typ in [vaerde,strng]) OR
       (i > 2) and (lineparts[i].typ = strng)           THEN BEGIN
      error := ParmTyp;
      Logga_SyntErr(error,curr);
      RETURN;
    END ELSE BEGIN
      IF (lineparts[i].typ = variabel) THEN
	IF CheckVar(lineparts[i].txt) = EgenDefinierad THEN
	  MakeVar(lineparts[i].txt);	{ bara egendefinierade behoevs skapas }
    END;
  END;

  tmpbo := false;	{ kolla om variabeln finns i ForNext-stacken }
  FOR i := 1 TO fnind DO
    IF fnstack[i].variabel = lineparts[2].txt THEN
      tmpbo := true;
  IF tmpbo THEN BEGIN
    error := NestedForVariable;
    Logga_SyntErr(error,curr);
    RETURN;
  END;
  IF fnind = fnmax THEN BEGIN
    error := ForLevel;
    Logga_SyntErr(error,curr);
    RETURN;
  END;
  fnind := fnind + 1;
  fnstack[fnind].variabel := lineparts[2].txt;
  fnstack[fnind].forptr := curr;
END;	{ CheckFor }
{$page+}
{*******************************************************}
{	CheckNext.					}
{	syntaxkontrollerar NEXT-kommandot		}
{*******************************************************}
procedure CheckNext(	curr:komm_ptr;
		    VAR fnstack:fornext_a;
		    VAR	fnind:integer;
			numparts:integer;
		    VAR error:error_t);

VAR
  i : integer;

BEGIN	{ CheckNext }

  { kolla antal parametrar }

  IF numparts-1 <> 0 THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  { finns naagon FOR paa stacken }

  IF fnind = 0 THEN BEGIN
    error := NextLevel;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

 { saett upp pekare foer motsv. FOR }

  curr^.pjmp := fnstack[fnind].forptr;
  fnstack[fnind].forptr^.pjmp := curr;
  fnind := fnind - 1;

END;	{ CheckNext }
{$page+}
{*******************************************************}
{	CheckUtsignal.					}
{	syntaxkontrollerar Utsignal-kommandot		}
{*******************************************************}
procedure CheckUtsignal(curr:komm_ptr;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

VAR
  i : integer;

BEGIN	{ CheckUtsignal }

  { kolla antal parametrar }

  IF (numparts-1 < 2) OR (numparts-1 > 3) THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  { kolla om tillaaten elementtyp }

  FOR i := 2 to numparts DO BEGIN

    IF (lineparts[i].typ = strng) THEN BEGIN
      error := ParmTyp;
      Logga_SyntErr(error,curr);
      RETURN;
    END ELSE BEGIN
      IF (lineparts[i].typ = variabel) THEN
	IF CheckVar(lineparts[i].txt) = EgenDefinierad THEN
	  MakeVar(lineparts[i].txt);
    END;

    IF lineparts[i].typ = vaerde THEN
      IF ValOut(lineparts[i].vaerde,0,255) THEN BEGIN
	error := ValueOut;
	Logga_SyntErr(error,curr);
	RETURN;
      END;

  END;

END;	{ CheckUtsignal }
{$page+}
{*******************************************************}
{	CheckInsignal.					}
{	syntaxkontrollerar Insignal-kommandot		}
{*******************************************************}
procedure CheckInsignal(curr:komm_ptr;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

VAR
  tmp : integer;
  i : integer;

BEGIN	{ CheckInsignal }

  { kolla antal parametrar }

  IF (numparts-1 < 2) OR (numparts-1 > 4) THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  FOR i := 2 to numparts DO BEGIN

	{ kolla om tillaaten elementtyp }
    IF (i <= 4) and (lineparts[i].typ = strng) OR
       (i = 5) and (lineparts[i].typ <> strng) THEN BEGIN
      error := ParmTyp;
      Logga_SyntErr(error,curr);
      RETURN;
    END ELSE BEGIN
      IF (lineparts[i].typ = variabel) THEN
	IF CheckVar(lineparts[i].txt) = EgenDefinierad THEN
	  MakeVar(lineparts[i].txt);
    END;

	{ graensvearden }
    IF lineparts[i].typ = vaerde THEN
      IF ValOut(lineparts[i].vaerde,0,255) THEN BEGIN
	error := ValueOut;
	Logga_SyntErr(error,curr);
	RETURN;
      END;

  END; { FOR }

  IF numparts > 3 THEN
    tmp := 3
  ELSE
    tmp := numparts;
  FOR i := 2 to tmp DO
    IF lineparts[i].typ = vaerde THEN
      IF ValOut(lineparts[i].vaerde,0,255) THEN BEGIN
	error := ValueOut;
	Logga_SyntErr(error,curr);
	RETURN;
      END;

END;	{ CheckInsignal }
{$page+}
{*******************************************************}
{	CheckRamtest.					}
{	syntaxkontrollerar Ramtest-kommandot		}
{*******************************************************}
procedure CheckRamtest(	curr:komm_ptr;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

VAR
  i : integer;

BEGIN	{ CheckRamtest }

  { kolla antal parametrar }

  IF (numparts-1 <> 0) AND (numparts-1 <> 2) THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  FOR i := 2 to numparts DO BEGIN

	{ kolla om tillaaten elementtyp }
    IF lineparts[i].typ = strng THEN BEGIN
      error := ParmTyp;
      Logga_SyntErr(error,curr);
      RETURN;
    END ELSE BEGIN
      IF (lineparts[i].typ = variabel) THEN
	IF CheckVar(lineparts[i].txt) = EgenDefinierad THEN
	  MakeVar(lineparts[i].txt);
    END;

	{ graensvearden }
    IF lineparts[i].typ = vaerde THEN
      IF ValOut(lineparts[i].vaerde,0,65535.0) THEN BEGIN
	error := ValueOut;
	Logga_SyntErr(error,curr);
	RETURN;
      END;

  END; { FOR }

  IF (numparts = 3) AND THEN
     (lineparts[2].typ = vaerde) AND (lineparts[3].typ = vaerde) AND
     (lineparts[2].vaerde > lineparts[3].vaerde) THEN BEGIN
    error := ValueOut;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

END;	{ CheckRamtest }
{$page+}
{*******************************************************}
{	CheckIoport.					}
{	syntaxkontrollerar Ioport-kommandot		}
{*******************************************************}
procedure CheckIoport(	curr:komm_ptr;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

VAR
  i : integer;

BEGIN	{ CheckIoport }

  { kolla antal parametrar }

  IF (numparts-1 <> 2) THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  FOR i := 2 to numparts DO BEGIN

	{ kolla om tillaaten elementtyp }
    IF lineparts[i].typ <> vaerde THEN BEGIN
      error := ParmTyp;
      Logga_SyntErr(error,curr);
      RETURN;
    END;

	{ graensvearden }
    IF ValOut(lineparts[i].vaerde,0,65535.0) THEN BEGIN
      error := ValueOut;
      Logga_SyntErr(error,curr);
      RETURN;
    END;

  END; { FOR }

  IF (lineparts[2].vaerde > lineparts[3].vaerde) THEN BEGIN
    error := ValueOut;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

END;	{ CheckIoport }
{$page+}
{***************************************************************}
{	CheckNoparm.						}
{	syntaxkontrollerar de kommandon som inte		}
{	skall ha naagra parametrar, dvs.			}
{	PROMTEST, WATCHDOG, SETNOV, CHECKNOV, RESET, SIOTEST	}
{***************************************************************}
procedure CheckNoparm(	curr:komm_ptr;
			numparts:integer;
		    VAR error:error_t);

BEGIN	{ CheckNoparm }

  { kolla antal parametrar }

  IF numparts-1 <> 0 THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

END;	{ CheckNoparm }
{$page+}
{*******************************************************}
{	CheckEnparm.					}
{	Syntaxkontrollerar kommandon med en numerisk	}
{	parameter, dvs.					}
{	TEMP, SPANNING, ANALOG, PAUS, OBJEKT		}
{*******************************************************}
procedure CheckEnparm (	curr	  : komm_ptr;
		    VAR lineparts : linepart_t;
			numparts  : integer;
		    VAR error	  : error_t;
			lolim	  : real;
			hilim	  : real	);

BEGIN	{ CheckEnparm }

  { kolla antal parametrar }

  IF numparts-1 <> 1 THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

	{ kolla om tillaaten elementtyp }
  IF lineparts[2].typ = strng THEN BEGIN
    error := ParmTyp;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  IF (lineparts[2].typ = variabel) THEN
    IF CheckVar(lineparts[2].txt) = EgenDefinierad THEN
      MakeVar(lineparts[2].txt);

	{ graensvearden }

  IF lineparts[2].typ = vaerde THEN
    IF ValOut(lineparts[2].vaerde,lolim,hilim) THEN BEGIN
      error := ValueOut;
      Logga_SyntErr(error,curr);
      RETURN;
    END;

END;	{ CheckEnparm }
{$page+}
{*******************************************************}
{	CheckLogg.					}
{	syntaxkontrollerar Logg-kommandot		}
{*******************************************************}
procedure CheckLogg(	curr:komm_ptr;
		    VAR lineparts:linepart_t;
			numparts:integer;
		    VAR error:error_t);

VAR
  i : integer;

BEGIN	{ CheckLogg }

  { kolla antal parametrar }

  IF numparts-1 = 0 THEN BEGIN
    error := AntParms;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  FOR i := 2 to numparts DO
    IF (lineparts[i].typ = variabel) THEN
      IF CheckVar(lineparts[i].txt) = EgenDefinierad THEN
	MakeVar(lineparts[i].txt);

END;	{ CheckLogg }
{$page+}
{*******************************************************}
{	SyntaxCheck:					}
{	syntaxkontrollerar en rad			}
{*******************************************************}
procedure SyntaxCheck(      curr:komm_ptr;
			VAR fnstack:fornext_a;
			VAR fnind:integer;
			VAR lineparts:linepart_t;
			    numparts:integer;
			VAR error:error_t);

VAR
  kommando:ktyp;	{ kommando }
  i,j	: integer;
  tmp	: integer;
  tmpbo	: boolean;
  komstr: lstr10;	{ temporaervariabel vid kommandokoll }

BEGIN	{ SyntaxCheck }

  kommando := saknas;

  FOR i := 1 to antkomm DO BEGIN { kolla om kommandot finns }
    WITH komlist[i] DO BEGIN
      j := 1;
      WHILE txt[j] <> ' ' DO BEGIN
	komstr[j] := txt[j];  { bara icke-blanka tecken }
	j := j + 1;
      END;
      komstr[0] := chr(j-1);	{ saett upp laengden }
      IF komstr = lineparts[1].txt THEN
	kommando := komm;
    END;  { WITH }
  END;  { FOR }

  IF ( kommando = saknas ) OR ( kommando = kReset) OR
			      ( kommando = kTemp) THEN BEGIN
    error := KommandoSaknas;
    Logga_SyntErr(error,curr);
    RETURN;
  END;

  curr^.komm := kommando;

  CASE kommando OF

    kFor : CheckFor( curr, fnstack, fnind, lineparts, numparts, error);

    kNext : CheckNext( curr, fnstack, fnind, numparts, error);

    kUtsignal : CheckUtsignal( curr, lineparts, numparts, error);

    kInsignal : CheckInsignal( curr, lineparts, numparts, error);

    kRamtest : CheckRamtest( curr, lineparts, numparts, error);

    kIoport : CheckIoport( curr, lineparts, numparts, error);

    kPromtest,
    kWatchdog,
    kSetnov,
    kChecknov,
    kReset,
    kSiotest : CheckNoparm( curr, numparts, error);

    kTemp : CheckEnparm( curr, lineparts, numparts, error, tempmin, tempmax);

    kSpanning : CheckEnparm( curr, lineparts, numparts, error, spamin, spamax);

    kAnalog : CheckEnparm( curr, lineparts, numparts, error, anamin, anamax);

    kPaus : CheckEnparm( curr, lineparts, numparts, error, pausmin, pausmax );

    kLogg : CheckLogg( curr, lineparts, numparts, error);

    kObjekt : CheckEnparm( curr, lineparts, numparts, error, objmin, objmax );

  END;	{ CASE }

END;	{ SyntaxCheck } 
{$page+}
{*******************************************************}
{	Open_KommandoFil:				}
{*******************************************************}

procedure Open_KommandoFil (VAR errcode:error_t) [PUBLIC];

BEGIN	{ Open_KommandoFil }

  Assign(KommandoFil,ComFileName);

  KommandoFil.TRAP := true;	{ error trapping paaslagen }
  KommandoFil.ERRS := 0;	{ for sakerhets skull }
  Reset(KommandoFil);

  IF Kommandofil.ERRS <> 0 THEN BEGIN
    ShowFileErr('OPEN', 'Kommandofil', ComFileName, ord(KommandoFil.ERRS));
    errcode := OpenComFile;
    Close(KommandoFil);
    RETURN;
  END;

  errcode := NoError;

END;	{ Open_KommandoFil } 
{$page+}
{*******************************************************}
{	SkapaKommandoLista:				}
{	bygger upp den laenkade kommando-listan och	}
{	syntax-kollar den				}
{*******************************************************}
procedure SkapaKommandoLista(VAR errcode:error_t) [PUBLIC];

VAR
  i		: integer;
  curr		: komm_ptr;
  currold	: komm_ptr;
  error		: error_t;
  tmperr	: error_t;
  linenr	: integer;
  lineparts	: linepart_t;	{ uppsplittrad rad }
  numparts	: integer;	{ antal element i raden }
  fnind		: integer;	{ index i ForNextStack }
  fnstack	: fornext_a;	{ FOR-NEXT stacken }

BEGIN	{ SkapaKommandoLista }

  error := NoError;
  New(curr);	{ bered plats foer foersta raden }
  klist := curr;
  ClrVlist;	{ nollstaell variabellistan foerst }
  linenr := 0;	{ radnummer i filen }
  fnind := 0;	{ index i fnstack }

  DebugWriteln ('Syntaxcheck av kommandofil');
  
  WHILE NOT eof(KommandoFil) DO BEGIN

    { kolla om minnet r{cker, avbryt annars syntaxchecken }
    { f|r att detta skall funka bra m}ste minst tv} "NEW" ha g}tt bra,
    men om minnet inte ens r{cker till det s} {r det nog dags att hitta
    p} n}got annat }

    IF Freect ( SIZEOF(klist^) ) < 21 THEN BEGIN { spara lite till stacken }
      error := OutOfMemory;
      Logga_SyntErr(error,currold);
      BREAK;				{ WHILE }
    END;

    linenr := linenr + 1;

    KommandoFil.ERRS := 0;	{ for sakerhets skull }
    ReadLn(KommandoFil,curr^.txt);

    IF Kommandofil.ERRS <> 0 THEN BEGIN
      ShowFileErr('READ', 'Kommandofil', ComFileName, ord(KommandoFil.ERRS));
      errcode := ReadComFile;
      Close(KommandoFil);
      RETURN;
    END;

    SplitLine(lineparts,numparts,tmperr,curr^.txt);

    IF tmperr <> NoError THEN BEGIN
      Logga_SyntErr(tmperr,curr);
      error := tmperr;
    END;
    IF (numparts <> 0) THEN BEGIN
      SyntaxCheck(curr,fnstack,fnind,lineparts,numparts,error);
      currold := curr;
      curr^.linenr := linenr;
      New(curr^.pnext);
      curr := curr^.pnext;
    END;
  END;	{ while }

  IF fnind <> 0 THEN BEGIN	{ foer faa next }
    error := MissingNextStatement;
    Logga_SyntErr(error,currold);
  END;

  dispose(curr);		{ den h{r beh|vdes inte }
  currold^.pnext := NIL;	{ avsluta l{nkade listan }

  errcode := error;

END;	{ SkapaKommandoLista } 
{$page+}
{*******************************************************}
{	TaBortKommandoLista:				}
{	releasar minnet som allokerats till		}
{	kommandolistan					}
{*******************************************************}
procedure TaBortKommandoLista [PUBLIC];

VAR
  curr		: komm_ptr;
  pnext		: komm_ptr;

BEGIN	{ TaBortKommandoLista }

    curr := klist;

    WHILE curr <> NIL DO BEGIN
	pnext := curr^.pnext;
	dispose(curr);
	curr := pnext;
    END;

  klist := NIL;

END;	{ TaBortKommandoLista }

END. { module }
