{$title:'MODULE: Tid' $pagesize:41 $linesize:106}

Module Tid;

{*******************************************************}
{	Denna modul innehaller "tidsrutiner".		}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'screen.h'}
{$Include:'asynch.h'}

VAR
    Last_Ant_Sec : integer4; { Senaste "antal sekunder sedan 00:00" }
    Last_SecUsed : integer4; { Senaste "forbrukad testtid" i sekunder }

Procedure Date   ( VAR	s : string   ); EXTERN;
Procedure Time   ( VAR	s : string   ); EXTERN;

{$page+}
{*******************************************************}
{	RoundX:						}
{	avrundar ett flyttal till integer4.		}
{	finns pga att Round4 inte klarar av att		}
{	avrunda 32768					}
{*******************************************************}

Function RoundX ( re : real ) : integer4 [PUBLIC];

BEGIN	{ RoundX }

    IF ( re >= 32767.5 ) AND ( re <= 32768.5 ) THEN
        RoundX := 32768
    ELSE
    	RoundX := Round4 ( re );

END;	{ RoundX }

{$page+}
{*******************************************************}
{	Datum:						}
{	Hamtar "svenskt" datum.				}
{*******************************************************}

Function Datum	: str9 [PUBLIC];

VAR
    TmpDat	: str8;

BEGIN	{ Datum }

    Date ( TmpDat );
    CopyStr ( TmpDat, Datum );

    Datum[1] := TmpDat[7];	{ Ar }
    Datum[2] := TmpDat[8];

    Datum[4] := TmpDat[1];	{ Manad }
    Datum[5] := TmpDat[2];

    Datum[7] := TmpDat[4];	{ Dag }
    Datum[8] := TmpDat[5];

END;	{ Datum }

{$page+}
{*******************************************************}
{	SecUsed:					}
{	Hamtar forbrukad testtid i sekunder.		}
{*******************************************************}

Function SecUsed : integer4 [PUBLIC];

VAR
    Ant_Sec	: integer4;
    TimeDiff	: integer4;
    re		: real;

BEGIN	{ SecUsed }

    re := Time_a1;
    Ant_Sec := RoundX ( re );
    TimeDiff := Ant_Sec - Last_Ant_Sec;
    IF TimeDiff < 0 THEN TimeDiff := TimeDiff + 86400;	{ Nytt dygn }
    Last_Ant_Sec := Ant_Sec;
    Last_SecUsed := Last_SecUsed + TimeDiff;
    SecUsed := Last_SecUsed;

END;	{ SecUsed }

{$page+}
{*******************************************************}
{	IniTime						}
{	Vid startup.					}
{*******************************************************}

Procedure IniTime [PUBLIC];

VAR
    re		: real;

BEGIN	{ IniTime }

    re := Time_a1;
    Last_Ant_Sec := RoundX ( re );	{ Starttid }
    Last_SecUsed := 0;
    DisplayTimes;

END;	{ IniTime }

{$page+}
{*******************************************************}
{	TimeUsed:					}
{	Hamtar forbrukad testtid i timmar, minuter och	}
{	sekunder.					}
{*******************************************************}

Function TimeUsed : str9 [PUBLIC];

VAR
    TimePart	: lstring(2);
    Slask	: boolean;
    TotSec	: integer4;
    Tim		: integer4;
    Min		: integer4;
    Sec		: integer4;

BEGIN	{ TimeUsed }

    TotSec := SecUsed;
    Tim := TotSec DIV 3600;
    TotSec := TotSec - Tim * 3600;
    Min := TotSec DIV 60;
    TotSec := TotSec - Min * 60;
    Sec := TotSec;

    Slask := Encode ( TimePart, Tim :2 );
    IF TimePart[1] = ' ' THEN TimePart[1] := '0';
    TimeUsed[1] := TimePart[1];
    TimeUsed[2] := TimePart[2];
    TimeUsed[3] := ':';
    Slask := Encode ( TimePart, Min :2 );
    IF TimePart[1] = ' ' THEN TimePart[1] := '0';
    TimeUsed[4] := TimePart[1];
    TimeUsed[5] := TimePart[2];
    TimeUsed[6] := ':';
    Slask := Encode ( TimePart, Sec :2 );
    IF TimePart[1] = ' ' THEN TimePart[1] := '0';
    TimeUsed[7] := TimePart[1];
    TimeUsed[8] := TimePart[2];
    TimeUsed[9] := ' ';

END;	{ TimeUsed }

END.	{ Module }
