{$title:'PROGRAM: Main' $pagesize:64 $linesize:106}
Program Main(input,output);

{*******************************************************}
{							}
{	Testar rel{kortet				}
{							}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'io.h'}
{$Include:'screen.h'}
{$Include:'kbd.h'}
{$Include:'objkomn.h'}
{$Include:'asynch.h'}


CONST
    InBufSiz	= 256;
    OutBufSiz	= 256;
    streck = '-------------------------------------------------------------------------------';


VAR [PUBLIC]			{ Globala variabler }
    klist	: komm_ptr;	{ pekare till den laenkade kommandolistan }
    ComFileName	: lstring ( comfilename_size );
	    			{ namn paa filen daer testsekvensen ligger }
    ant_obj	: real;		{ antal objekt i "rack" }
    rack	: rack_t;	{ racken med alla 50 korten i }
    Obj		: integer;	{ vilket objekt som aer valt }
    spanningflg	: boolean;	{ Spanning > 0 ? }
    Spanning	: lstring(5);	{ Vald spanning }
    AnaSpanning	: lstring(5);	{ Vald "analogspanning" }
    PrintOn	: boolean;	{ true om printern aer aktiverad }
    KommandoFil	: TEXT(80);
    LoggFil	: TEXT;
    Printer	: TEXT;
    MddmTestat	: boolean;	{ s{tts till true om n}got mddmkommando k|rts, dvs n{r statistiken skall ut }
    SerErr	: SerErr_t;	{ om <> No_SerErr avbryt testen }
    IdLength	: byte;		{ l{ngd p} l{ngsta mddmid (f|r loggning) }
    TotTid	: integer4;	{ totala testtiden i sekunder }
    IOPortNr	: integer;	{ s{tts av insignalkommandot s} att loggrutinen vet vilken i/o-port som g{ller }

VAR
    IOBuf_1	: string ( InBufSiz + OutBufSiz );
    IOBuf_2	: string ( InBufSiz + OutBufSiz );

    hylla,slot	: integer;
    rad,kol	: integer;
    i		: integer;
    Avbryt	: boolean;	{ true om avbrytning begaerts }
    KommandoOk	: boolean;
    status	: integer;
    str		: lstr80;
    SvarStr	: lstr80;
    No_Wrt	: integer;
    No_Read	: integer;
    IqSize	: integer;
    PStatus	: word;
    tmpstr	: lstr80;
    kommanderr	: boolean;
    portnr	: integer;
    varde	: byte;
    first	: boolean;

{$page+} !!
{*******************************************************}
{	Ini_COM_Ports:					}
{	Initiera COM-portarna.				}
{*******************************************************}

Procedure Ini_COM_Ports;

VAR
    Status	: integer;

BEGIN	{ Ini_COM_Ports }
		{ Mot MDDM-korten }

    Eval ( Open_a1  ( COM1, InBufSiz, OutBufSiz, 0, 0, Ads IOBuf_1 ) );
    Eval ( close_a1 ( COM1 ) );		{ F|r s{kerhets skull }

    Status := Open_a1  ( COM1, InBufSiz, OutBufSiz, 0, 0, Ads IOBuf_1 );
    IF Status <> OK THEN BEGIN
	InvVid;
	ScrollWriteLn ( 'fel vid open COM1');
	NorVid;
    END;
    Eval ( setop_a1 ( COM1, 1, 7 ) );	{ Baudrate 9600 }
    Eval ( setop_a1 ( COM1, 2, 1 ) );	{ Odd parity }
    Eval ( setop_a1 ( COM1, 3, 2 ) );	{ 7 data bits }
    Eval ( setop_a1 ( COM1, 4, 1 ) );	{ One stop bit }
    Eval ( setop_a1 ( COM1, 5, 0 ) );	{ XON - XOFF }
    Eval ( setop_a1 ( COM1, 6, 0 ) );	{ XON - XOFF }
    Eval ( setop_a1 ( COM1, 9, 0 ) );	{ No CTS }

END;	{ Ini_COM_Ports }

{$page+} !!
{*******************************************************}
{	Startup:					}
{	Initieringar					}
{*******************************************************}

Procedure Startup;

BEGIN	{ Startup }

    DebugWriteLn ( 'Initiering av COM-portarna' );
    Ini_COM_Ports;	{ Initiera portarna mot Mddm-korten och PwC:n }
    DebugWriteLn ( 'Initiering av rel{-portarna' );
    Ini_RelaPorts;	{ Initiera portarna mot relakortet }

END;	{ Startup }

function Get_VarValue ( varnamn : lstr10 ) : real [PUBLIC];

BEGIN
    InvVid;
    Scrollwriteln('passing Get_VarValue');
    NorVid;
    Get_VarValue := 0;
END;

Function TimeUsed : str9 [PUBLIC];

BEGIN
    InvVid;
    Scrollwriteln('passing TimeUsed');
    NorVid;
    TimeUsed := '00:00:00 ';
END;


Procedure Logga_ParmFel ( KomndStr   : element;
			  KomnRadI   : integer;
			  ErrParm    : ErrParmArea_t;
			  AntErrParm : integer ) [PUBLIC];
BEGIN
    InvVid;
    Scrollwriteln('felaktig parameter');
    NorVid;
END;

Procedure Skriv_portstatus;

var
    varde	: byte;
    str		: lstr10;

BEGIN

    Varde := InByte ( 16#213 );
    EVAL ( ENCODE ( str, varde:2:16 ) );
    CposWrite(23,1,'1a:');
    CposWrite(23,4,str);

    Varde := InByte ( 16#212 );
    EVAL ( ENCODE ( str, varde:2:16 ) );
    CposWrite(23,7,'1b:');
    CposWrite(23,10,str);

    Varde := InByte ( 16#211 );
    EVAL ( ENCODE ( str, varde:2:16 ) );
    CposWrite(23,13,'1c:');
    CposWrite(23,16,str);

    Varde := InByte ( 16#21B );
    EVAL ( ENCODE ( str, varde:2:16 ) );
    CposWrite(23,20,'2a:');
    CposWrite(23,23,str);

    Varde := InByte ( 16#21A );
    EVAL ( ENCODE ( str, varde:2:16 ) );
    CposWrite(23,26,'2b:');
    CposWrite(23,29,str);

    Varde := InByte ( 16#219 );
    EVAL ( ENCODE ( str, varde:2:16 ) );
    CposWrite(23,32,'2c:');
    CposWrite(23,35,str);

END;


{$page+} !!

BEGIN	{ Main }

    Startup;		{ Initieringar }

    Write(chr(27),'[2J');
    CursOff;
    CposWrite(25,1,'>');
    InvVid;
    CposWrite( 1, 26, ' Testprogram f|r rel{l}dan ');
    NorVid;
    CposWrite( 2, 1, streck );
    CposWrite( 22, 1, streck );
    CposWrite( 24, 1, streck );

    FOR i := 1 TO 50 DO BEGIN
    	Rack[i].hyllnr := ((i-1) DIV 10) + 1;
    	Rack[i].slotnr := ((i-1) MOD 10) + 1;
    END;

    obj := 1;
    CposWrite(23, 40, 'hylla:   ,  slot:             pwr: on');
    Skriv_portstatus;

    Cpos(3,1);
    Avbryt := false;
    first := true;

    WHILE avbryt = false DO BEGIN

	WHILE ( NOT KeyPressed ) AND ( NOT first ) DO BEGIN
	    str := '1;1g';
	    Status := WrtSt_a1 ( COM1, ORD(str.LEN), ADS str[1], No_Wrt );
	    If status <> OK THEN BEGIN
		InvVid;
		Scrollwriteln('fel vid s{nd');
		NorVid;
	    END;
	    IF No_Wrt <> ORD(str.LEN) THEN BEGIN
		InvVid;
		Scrollwriteln('fel antal tecken s{nda');
		NorVid;
	    END;

	    Wait_a1 (0.1);			{ V{nta p} svar }

	    Status := RdSt_a1 ( COM1, 80, ADS SvarStr[1], No_Read, IqSize, PStatus );
	    SvarStr.LEN := WRD(No_Read);
	    If ( status <> OK ) AND ( status <> IN_Q_EMPTY) THEN BEGIN
		InvVid;
		EVAL( ENCODE ( tmpstr, status:1 ) );
		INSERT('fel vid receive, status: ', tmpstr, 1);
		Scrollwriteln(tmpStr);
		NorVid;
	    END;

	    IF No_Read > 0 THEN
	    	IF Svarstr <> 'FFG' THEN BEGIN
		    InvVid;
		    Scrollwriteln(SvarStr);
		    NorVid;
		END ELSE
		    Scrollwriteln(SvarStr);
	END; { WHILE }

	first := false;
	KommandoOk := false;

	GetCpos(rad,kol);

	WHILE NOT KommandoOk DO BEGIN
	    CposWrite(25,1,'>      ');
	    str := '      ';
	    str.LEN := 0;
	    EVAL( GetStr ( str, [f_enter], 25, 2, 6 ) );

	    IF DECODE( str, i ) THEN BEGIN
	    	IF ( i > 0 ) AND ( i < 51 ) THEN BEGIN
		    obj := i;
		    hylla := ((obj-1) DIV 10) + 1;
		    slot := ((obj-1) MOD 10) + 1;
		    stall_relaerna( hylla, slot );
		    KommandoOk := true;
		    str := 'hylla: ';
		    EVAL( ENCODE ( tmpstr, hylla:1 ) );
		    CONCAT(str, tmpstr);
		    CONCAT(str, ' ,  slot: ');
		    EVAL( ENCODE ( tmpstr, slot:-2 ) );
		    CONCAT(str, tmpstr);
		    cposwrite(23, 40, Str);
		END ELSE BEGIN
		    Cpos(rad,kol);
		    InvVid;
		    ScrollWriteln('objekt = 1-50');		    
		    NorVid;
		    GetCpos(rad,kol);
		END;
	    END ELSE BEGIN
 		IF ( str = 'help' ) OR ( str = 'HELP' ) OR
		   ( str = 'h' ) OR ( str = 'H' ) THEN BEGIN
		    Cpos(rad,kol);
		    ScrollWriteLn(' ');
		    ScrollWriteLn('1..50  - Siffra mellan 1 och 50 kopplar in motsv. kort');
		    ScrollWriteLn('HELP   - Denna text');
		    ScrollWriteLn('OFF    - Disconnect kort');
		    ScrollWriteLn('ON     - Connect kort');
		    ScrollWriteLn('EXIT   - Avsluta testningen');
		    ScrollWriteLn('S p v  - S{tt port p till v{rde v');
		    ScrollWriteLn('noll   - Nollst{ll alla portar');
		    ScrollWriteLn('ett    - Ettst{ll alla portar');
		    ScrollWriteLn(' ');
		    GetCpos(rad,kol);
		END; { exit }
		IF ( str = 'exit' ) OR ( str = 'EXIT' ) OR
		   ( str = 'e' ) OR ( str = 'E' ) THEN BEGIN
		    KommandoOk := true;
		    avbryt := true;
		END; { exit }
		IF ( str = 'on' ) OR ( str = 'ON' ) THEN BEGIN
		    Connect_kort;
		    cposwrite(23, 70, 'pwr: on ');
		END; { on }
		IF ( str = 'off' ) OR ( str = 'OFF' ) OR
		   ( str = 'of' ) OR ( str = 'OF' ) THEN BEGIN
		    DisConnect_kort;
		    cposwrite(23, 70, 'pwr: off');
		END; { off }
		IF ( str = 'noll' ) OR ( str = 'NOLL' ) OR
		   ( str = 'n' ) OR ( str = 'N' ) THEN BEGIN
			OutByte ( #211,0 );
			OutByte ( #212,0 );
			OutByte ( #213,0 );
			OutByte ( #219,0 );
			OutByte ( #21A,0 );
			OutByte ( #21B,0 );
		END; { off }
		IF ( str = 'ett' ) OR ( str = 'ETT' ) OR
		   ( str = 'e' ) OR ( str = 'E' ) THEN BEGIN
			OutByte ( #211,#FF );
			OutByte ( #212,#FF );
			OutByte ( #213,#FF );
			OutByte ( #219,#FF );
			OutByte ( #21A,#FF );
			OutByte ( #21B,#FF );
		END; { off }
		IF str.LEN > 4 AND THEN 
		(( str[1] = 's' ) OR ( str[1] = 'S' )) THEN BEGIN
		    kommanderr := false;
		    portnr := ord(str[3]) - #30;
		    IF ( str[2] <> ' ' ) OR ( str[4] <> ' ') OR
		       ( portnr < 1 ) OR ( portnr > 6 ) THEN
		       	kommanderr := true;
		    str[4] := '#';
		    DELETE(str, 1, 3 );
		    IF NOT DECODE( str, varde ) THEN
		    	kommanderr := true;
		    IF ( varde < 0 ) OR ( varde > 255 ) THEN
		    	kommanderr := true;
		    IF NOT kommanderr THEN BEGIN
		    	CASE portnr OF
			    1 : portnr := #213;
			    2 : portnr := #212;
			    3 : portnr := #211;
			    4 : portnr := #21B;
			    5 : portnr := #21A;
			    6 : portnr := #219;
			END; 
			OutByte ( portnr, varde );
			KommandoOk := true;
		    END;
		END; { s }
	    END; { ELSE }

	    Skriv_portstatus;

	END; { WHILE }

    Cpos(rad,kol);

    END; { WHILE }

    ClrLine(25);
    Cpos(24,1);
    CursOn;

    Eval ( Close_a1 ( COM1 ) );		{ Stang portar }

END. { main }

