/*	Etikettskrivningsfilter 

	.AE <n>		Antal etiketter av denna typ
	.SP <n>		Startposition (v{nstermarginal)
	.EB <n>		Sidodelning (etikettbredd)
	.EH <n>		H|jddelning (etiketth|jd)
	.AK <n>		Antal etiketter i bredd
	.EJ		V{nsterjustera inte rader
	<text>
	  .
	  .
	<text>
	.AE	... osv

*/
/**/
#include <stdio.h>

#define	TRUE		1
#define	FALSE		0

#define MAXL		300

#define MAXRAD		132
#define	MAXHOJD		72

#define	L		0
#define	R		1
#define	M		2

char	line[MAXL], workl[MAXL];
char	immage[MAXRAD * MAXHOJD];	/* en etikett */
char	page[MAXRAD * MAXHOJD];		/* en rad av etiketter */

int	kol;		/* n{sta etikettkolumn att fylla */
int	rad;		/* n{sta etikettrad att l{sa fr}n fil */

int	net = 0;	/* antal etiketter av denna typ (kvar)  (.AE) */
int	startpos = 1;	/* startpos f|r utskrift		(.SP) */
int	nkol = 1;	/* antal kolumner av etiketter		(.AK) */
int	bredd = 120;	/* etikettbredd	(delning)		(.EB) */
int	hojd = 9;	/* etiketth|jd (delning)		(.EH) */

int	slut = FALSE;
int	leftjust = TRUE;	/* v{nsterjustera alla rader	(.EJ) */ 

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();
	char	*instr();

	if (argc == 1) {
		mkimmage(stdin);
	}

	else
		while (--argc > 0) {
			if ((fp = fopen(*++argv,"r")) == NULL) 
				fprintf(stderr,"Etikett: cannot open %s\n",*argv);

			else 
				mkimmage(fp);
		}
}
/**/
mkimmage(fp)
FILE	*fp;
{
	char		*instr();

	rad = 0;
	startpos = 1;

	while ((fgets(line, MAXL, fp)) != NULL) {
		*(line + strlen(line) - 1) = '\0';

		if (instr(line, ".AE") == line) {
			nyetikett();
			sscanf(line + 3, "%d", &net);
		}

		else if (instr(line, ".SP") == line) 
			sscanf(line + 3, "%d", &startpos);

		else if (instr(line, ".AK") == line) 
			sscanf(line + 3, "%d", &nkol);

		else if (instr(line, ".EB") == line) 
			sscanf(line + 3, "%d", &bredd);

		else if (instr(line, ".EH") == line) 
			sscanf(line + 3, "%d", &hojd);

		else if (instr(line, ".EJ") == line) 
			leftjust = FALSE;

		else
			nextrad(line);			/* N{sta etikettrad */
	}

	slut = TRUE;
	makepage();
}
/**/
nyetikett()
{
	char	*p;
	int	i;

	if (rad == 0) {
		fill();		/* f|rsta g}ngen */
		kol = 1;
	}

	else {
		makepage();

		for (i = 1, p = immage; i <= (MAXRAD * MAXHOJD); i++, p++)
			*p = ' ';
	}

	rad = 1;

}


/**/
nextrad(str)
char	*str;		/* str{ng */
{
	char	*p, *strncpy();
	int	l;

	if (rad > hojd || rad == 0)
		return;

	if (leftjust)
		while (*str == ' ' || *str == '\t')
			if (*str == '\0')
				return;

			else
				str++;

	l = strlen(str);
	l = (l > bredd - 1) ? bredd - 1 : l;

	for (p = str + l; l <= bredd; p++, l++)
		*p = ' ';

	*p = '\0';
	strncpy(immage + (bredd + 1) * (rad - 1), str, bredd + 1);

	rad++;	
}
/**/
makepage()
{
	char	*frm, *to;
	int	i, r;

	while (net > 0) {
		while (net > 0 && kol <= nkol) {
			for (r = 1; r <= hojd; r++) {
				frm = immage + (bredd + 1) * (r - 1);
				to = page + startpos - 1 + (r - 1) * MAXRAD 
							+ (kol - 1) * bredd;

				for (i = 1; i <= bredd && *frm != '\0'; i++, 
								frm++, to++)
					*to = *frm;
	
				for (; i <= bredd; i++, to++)
					*to = ' ';
			}

			net--;
			kol++;
		}

		if (kol > nkol) {
			outpage();
			kol = 1;
		}
	}

	if (kol > 1 && slut)
		outpage();
}

/**/
fill()
{
	char	*p;
	int	i;

	for (i = 1, p = page; i <= MAXRAD * MAXHOJD; i++, p++)
		*p = ' ';

	for (i = 1, p = immage; i <= (MAXRAD * MAXHOJD); i++, p++)
		*p = ' ';
}

/**/
outpage()
{
	char	*p, *p1;
	int	r;

	for (p = page, r = 1; r <= hojd; r++, p += MAXRAD) {
		for (p1 = p + MAXRAD - 1; p1 > p && *p1 == ' ' ; p1--)
			;

		*++p1 = '\0';
		printf("%s\n", p);
	}

	for(r = 1, p = page; r <= MAXRAD * MAXHOJD; r++, p++)
		*p = ' ';
}

/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
