
/*	text formatter

	860923	G|ran Bostr|m
*/
#include	<stdio.h>

#define	NKEYS	((sizeof keytab)/(sizeof (struct key)))
#define BUFFSIZE	160
#define	MAXLEVL		10
#define	MAXHEAD		5
#define	FALSE		0
#define	TRUE		1
#define	TOC		!mode
#define	LIST		mode
#define	ENGLISH		TRUE
#define	SWEDISH		FALSE

extern	flanguage(),fhead(),ftitle(),fmargin_text(),flines(),fpage();
extern	fspace(),frest(),funderline(),fblanks_head(),findent();
extern	fpos_page(),fpos_title(),fmargin_head(),fmargin_title();

struct	key
  {
  char	*name;		/* command name */
  int	(*routine)();	/* function */
  }
  keytab[] = {
  {"title",ftitle},
  {"language",flanguage},
  {"head",fhead},
  {"blanks_head",fblanks_head},
  {"margin_text",fmargin_text},
  {"margin_title",fmargin_title},
  {"margin_head",fmargin_head},
  {"pos_page",fpos_page},
  {"pos_title",fpos_title},
  {"indent",findent},
  {"lines",flines},
  {"page",fpage},
  {"space",fspace},
  {"rest",frest},
  {"underline",funderline},
  };

/* internal variables */

char	utbuff[BUFSIZ];
char	buffer[BUFFSIZE];
char	head[MAXHEAD][BUFFSIZE];
char	*scan_point;
char	*temp_point;
char	*syn_point;
int	errcount = 0;
int	mode=0;
int	language=FALSE;
int	head_cnt=0;
int	curr_line=0;
int	curr_page=0;
int	sign;			/* sign return value from getdigit */
int	title_count=0;
int	level_cnt[MAXLEVL+1];

FILE	*fp_in, *fp_out, *fopen();

/* variables accessable from text source */

#define	Def_margin	8

int	head_lines=0;
int	lines_page=55;
int	rest_line=10;
int	blanks_head=2;
int	pos_title=10;
int	pos_page=60;
int	margin_title=1;
int	margin_head=1;
int	margin_text=Def_margin;
int	indent=2;

main(argc, argv)
int	argc;
char	*argv[];
{
int	i;

 setbuf(stdout, utbuff);

 if (argc == 1) {
    fp_in = stdin;
    fprintf(stderr,"format: standard input kan tv ej anvendas pga programfel\n");
    exit(1);
 }
 else
 if ((fp_in = fopen (*++argv, "r")) == NULL) {
    fprintf (stderr, "format: can't open %s\n", *argv);
    exit (1); }

  if (argc <= 2)
    fp_out = stdout;
  else {
  
    if ((fp_out = fopen (*++argv, "r")) != NULL) {
      fprintf (stderr, "format: output file already exists %s\n", *argv);
      exit (1); }

    if ((fp_out = fopen (*argv, "w")) == NULL) {
      fprintf (stderr, "format: can't open %s\n",*argv);
      exit (1); }
  }

  create_toc();
  if (errcount > 0) {
    close(fp_out);
    sprintf(buffer,"rm %s\n",*argv);
fprintf(stderr, buffer);
/*    system(buffer); */
    exit(1); }

  rewind(fp_in);
  indent = 0;
  mode++;
  if (title_count != 0)
    list_file();

  close(fp_in);
  close(fp_out);
}
/**/
create_toc()
{
int	i;

  for (i=0; i<MAXLEVL; i++)
    level_cnt[i] = 0;

  for (i=0; i<BUFFSIZE; i++)
    head[0][i] = ' ';

  fprintf (stderr,"Creating table of contents\n");

  while (fgets (buffer, BUFFSIZE, fp_in) != NULL) {

    if (buffer[0] == '%') {
      scan_point = &buffer[1];
      exec_cmd(); }
    else if (head_cnt < head_lines) {
      strcpy (&head[head_cnt][0],buffer);
      if (head_cnt == 0) {
        for (i=0; head[0][i] != '\n'; i++)
	  ;
	head[0][i++] = ' ';
	head[0][i]   = ' '; }
      head_cnt++;}
    else if (title_count == 0) {
      if (curr_line == 0)
        write_head();
      if (buffer[0] != '\n')
        write_margin(margin_text);
      write_file(buffer); } }
}
/**/
list_file()
{
int	i;

  title_count = 0;

  for (i=0; i<MAXLEVL; i++)
    level_cnt[i] = 0;

  write_head();

  fprintf (stderr,"Copying file\n");
  while (fgets (buffer, BUFFSIZE, fp_in) != NULL)
    if (buffer[0] == '%') {
      scan_point = &buffer[1];
      exec_cmd(); }
    else if (title_count != 0) {
      if (buffer[0] != '\n')
        write_margin(margin_text);
      write_file(buffer); }
}
/**/
write_margin(margin)
int	margin;
{
int	i;

  for (i=0; i<margin/8; i++)
    write_file("\t");
  for (i=0; i<margin%8; i++)
    write_file(" ");
}
/**/
exec_cmd()
{
int	i = 0;
int	i0;

while (i < NKEYS) {		/* search for command */
  if (chkcmd(i) == TRUE)
    break;
  i++; }

syn_point = temp_point;
i0 = i;
if (i < NKEYS) i++;

while (i < NKEYS) {
  if (chkcmd(i) == TRUE)	/* search for duplicate command */
    break;
  i++; }

if (i < NKEYS) {		/* duplicate found */
  fprintf (stderr,"format: ambigous command\n");
  fprintf (stderr,"%s",buffer);
  errcount++; }
else {
  if (i0 == NKEYS) {		/* no command match */
    fprintf (stderr,"format: command not recognized\n");
    fprintf (stderr,"%s",buffer);
    errcount++; }
  else {			/* command matched */
    scan_point = syn_point;
    keytab[i0].routine(); } }
}
/**/
chkcmd(i)			/* test if command match */
int	i;
{
char	c;
char	*key_point;

temp_point = scan_point;
key_point = keytab[i].name;

while ((c = getlower(temp_point)) >= 'A' && c == getlower(key_point)) {
  *temp_point++;
  *key_point++; }

if (c >= 'A')
  return(FALSE);
else
  return(TRUE);
}

getlower(str)
char	*str;
{
return(tolower(*str));
}

/**/
char	*getdigit(str, pnt)
char	*str;
int	*pnt;
{
int	i,n;

for (i=0; str[i]==' ' || str[i]=='\n' || str[i]=='\t'; i++)
  ;	/* skip white spaces */

sign = 0;
if (str[i] == '+' || str[i]=='-')
  sign = (str[i++]=='+') ? 1 : -1;

for (n = 0; str[i] >= '0' && str[i] <= '9'; i++)
  n = 10 * n + str[i] - '0';

*pnt = n;

return(&str[i]);
}
/**/
write_file(str)
char	*str;
{
int	i;

if (curr_line >= lines_page) {
  write_head(); }

i = 0;
while (str[i] != '\0' ) {
  if (str[i] == '!' && str[i+1] == '!' && curr_line != 0) {
    write_head();
    break; }
  i++; }

fputs(str,fp_out);

i = 0;
while (*str != '\0') {
  if (*str == '\n')
    i++;
  str++; }
curr_line += i;
}
/**/
write_head()
{
int	i;

if (curr_line != 0)
  fputs("\f",fp_out);

curr_page++;
curr_line = 0;

if (language == SWEDISH)
  sprintf(&head[0][pos_page],"Sida %d\n\0",curr_page);
if (language == ENGLISH)
  sprintf(&head[0][pos_page],"Page %d\n\0",curr_page);

write_margin(margin_head);
write_file(&head[0][0]);

for (i=1; i < head_lines; i++) {
  write_margin(margin_head);
  write_file(&head[i][0]); }

for (i=0; i < blanks_head; i++)
  write_file("\n");
}
/**/
flanguage()
{
if (TOC) {
  while (*syn_point == ' ' || *syn_point == '\t')
    syn_point++;
  if (*syn_point == 's')
    language = SWEDISH;
  else if (*syn_point == 'e')
    language = ENGLISH;
  else {
    fprintf (stderr, "format: invalid language specification\n");
    fprintf (stderr, "%s\n", buffer);
    errcount++; } }
}

fhead()
{
if (TOC) {
  getdigit(syn_point,&head_lines);
  if (head_lines >= MAXHEAD) {
    fprintf(stderr,"format: invalid head size\n");
    fprintf(stderr,"%s",buffer);
    errcount++; } }
}
/**/
ftitle()
{
char	*point;
char	line[BUFFSIZE];
int	i,j,k;

title_count++;

point = getdigit(scan_point, &i);

if (TOC)
  if (i > MAXLEVL) {
    fprintf(stderr, "format: illegal title level number\n");
    fprintf(stderr, "%s",buffer);
    errcount++;
    return; }

if (LIST)
    if (curr_line + rest_line > lines_page)
      write_head();

if (i == 0) {
  if (TOC)
    write_file("\n");
  }
else {
  level_cnt[i-1]++;
  level_cnt[i] = 0;

  for (k=0; k < margin_title/8; k++)
    write_file("\t");

  for (k=0; k<margin_title%8; k++)
    write_file(" ");

  k = margin_title;

  for (j=0; j<i; j++) {
    sprintf(line,"%d.",level_cnt[j]);
    write_file(line);
    if (level_cnt[j] > 9)
      k +=3;
    else
      k +=2; }

  for (; k < (pos_title+(i-1)*indent); k++)
    write_file(" ");

  while (*point == ' ' || *point == '\t') /* skip white spaces */
    point++;

  write_file(point);
  }
}
/**/
fmargin_text()
{
int	i;

if (TOC) {
  getdigit(syn_point,&i);
  if (sign == 0)
    margin_text = i;
  else if (sign == -1) {
    margin_text -= i;
    if (margin_text < 0) {
      margin_text = 0;
      fprintf (stderr, "format: margin less than first column\n");
      fprintf (stderr,"%s", buffer);
      errcount++; } }
  else if (sign == 1)
    margin_text += i; }      
}
/**/
flines()
{
if (TOC)
  getdigit (syn_point, &lines_page);
}

fpage()
{
if (TOC)
  if (title_count == 0)
    write_head();

if (LIST)
  write_head();
}

fspace()
{
int	i;

getdigit (syn_point, &i);

if (TOC)
  if (i > lines_page) {
    fprintf(stderr, "format: space > lines_page");
    fprintf(stderr, buffer);
    errcount++; }

if (LIST) {
  if (i + curr_line > lines_page)
    write_head();
  for (; i > 0 ; i--)
    write_file("\n"); }
}

frest()
{
getdigit (syn_point, &rest_line);
}

funderline()
{
if (LIST) {
  curr_line--;
  write_file(".bl\n"); }
}

fmargin_title()
{
  getdigit(syn_point,&margin_title);
}

fmargin_head()
{
  getdigit(syn_point,&margin_head);
}

fpos_page()
{
  getdigit(syn_point,&pos_page);
}

fpos_title()
{
  getdigit(syn_point,&pos_title);
}

fblanks_head()
{
  getdigit(syn_point,&blanks_head);
}

findent()
{
  getdigit(syn_point,&indent);
}