#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/timeb.h>
#include <time.h>

#define	LA4		1
#define SA4		2
#define	IBMLST		4
#define NOHEAD		8
#define	PASLST		16

#define	TRUE		1
#define	FALSE		0

#define SMALL		150
#define MAXL		1000
#define PAGE		51
#define	PAGESA4		72
#define COLS		120
#define COLSSA4		75
#define HEADSKIP	4
#define LPSKIP		5
#define HEADMARG	3
#define FOOTMARG	3
#define PLZFF		"!\041"
#define CFF		"/\052*/"
#define IBMFF		"The IBM Personal"
#define PASFF		"{$page+}"

#define ENGCHAR		"\033\113"	/* english character set */
#define SWECHAR		"\033\115"	/* swedish character set */

struct	timeb tidtab;
int	pagelen;
int	pagenopos;
int	datepos;
int	headline = HEADSKIP + 1;
int	firstline;
int	footline;
int	maxline;	
int	lastline;

int	linec;
int	pagec;

int	mode = LA4;

int	langopt=FALSE;		/* language option selected */
int	swelst = TRUE;		/* swedish listing as default */
int	comment = FALSE;	/* inside a C-comment */

FILE	*put;

char	header[SMALL], date[SMALL], line[MAXL];
char	filename[SMALL] = "standard input";
char	foot[SMALL] = "\n";
char	konvarray[] = "C~`a{a}ceeeiii[]@{[o|ouuy\\^c#YPfaiounNao?    !<>   !++++++!+++++++++-++++++++-+++++++++++++     8BTpEoutoOOo8\\EU=+><SS-=oo.vn2. ";
/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen(), *popen();
	char	*instr();
	char	*string();

	ftime(&tidtab);			/* bara f|r att skaffa TZ */
	tidtab.millitm = 0;		/* skippa millisekunderna */
/**/
	if ((put = popen("lpr", "w")) == NULL) {
		fprintf(stderr, "someone har knyckt lpr\n");
		exit(-1);
	}
	while (instr(*++argv, "-")) {
		if (strncmp(*argv, "-i", 2) == 0)
			mode |= IBMLST;

		else if (strncmp(*argv, "-p", 2) == 0)
			mode |= PASLST;

		else if (strncmp(*argv, "-s", 2) == 0) {
			mode &= ~LA4;
			mode |= SA4;
		}

		else if (strncmp(*argv, "-h", 2) == 0)
			mode |= NOHEAD;

		else if (strncmp(*argv, "-e",2) == 0) {
			swelst = FALSE;
			langopt = TRUE;
		}

		else if (strncmp(*argv, "-w",2) == 0) {
			swelst = TRUE;
			langopt = TRUE;
		}

		--argc;
	}

	set();

	if (argc == 1) {
		makehead(header, filename);
		filelist(stdin);
	}

	else
		while (--argc > 0) {
			if ((fp = fopen(*argv,"r")) == NULL) {
				fprintf(stderr,"list: cannot open %s\n",*argv);
				fprintf(put,"missed file %s\n\f", *argv);
 			} 

			else {
				int	tmp;

				strncpy(filename, *argv, pagenopos);
				makehead(header, filename);

				modtime(date, *argv);
				tmp = strlen(date);
				string(foot, datepos, ' ');
				strncat(foot, date, SMALL - tmp - 2);
				strcat(foot, "\n");

				filelist(fp);
				fclose(fp);
			}

			argv++;
		}

	fprintf(put, "\f\n");
}
/**/
filelist(fp)
FILE	*fp;
{
	char	*pek;
	int	fffirst;
	register int	i, c;

	pagec = 1;
	if (langopt) {
		if (swelst)
			fprintf(put,SWECHAR);
		else
			fprintf(put,ENGCHAR);
	}
	fprintf(put, "\f");
	prhead();
	while((fgets(line, MAXL, fp)) != NULL) {

	/* konvertera IBM-tecken till standard-ASCII */

		if (langopt && !swelst) {
		  for(pek = line;*pek != '\0';pek++) {
		    c = *pek;

		    if (c == '/' && *(pek+1) == '*')
		      comment = TRUE;
		    if (c == '*' && *(pek+1) == '/')
		      comment = FALSE;

		    if (c < 0)
		      *pek = konvarray[128+c];
		    else
		    if (conv(pek) && comment) {
		      charins(pek++, '\033');
		      charins(pek++, '\115');
		      pek++;
		      charins(pek++, '\033');
		      charins(pek, '\113');
		    }
		  }
		}
		else
		  for(pek = line; *pek != '\0';pek++) {
		    c = *pek;
		    if (c < 0)
		      *pek = konvarray[128+c];
		  }

		if ( (instr(line, IBMFF) && (mode & IBMLST)) ||
		     (instr(line, PASFF) && (mode & PASLST)) ) {

			if ( (instr(line, IBMFF)) && (skip(fp, 3) == -1) )
				break;

			else if (linec != firstline || pagec != 1) {
				prfoot();
				prhead();
			}
		}

		else if (pek = instr(line, "\f")) { /* ff nagonstans i raden */
			if (*line == '\f')	/* ff forst pa raden ? */
				fffirst = TRUE;
			else
				fffirst = FALSE;
			delff(pek);		/* ta bort alla ff fran line */
			if ((fffirst == TRUE) && (linec != firstline)) {
				prfoot();
				prhead();
			}
			if (strcmp(line,"\n") != 0) {	/* printa ej rad med bara ff */
				fprintf(put,"%s", line);
				linec++;
			}
			if ((fffirst == FALSE) && (linec != firstline)) {
				prfoot();
				prhead();
			}
		}

		else if(instr(line, PLZFF) != NULL || instr(line, CFF) != NULL)
			if (nothingelse(line)) {
				if (linec != firstline) {
					prfoot();
					prhead();
				}
			}

			else if( (pek = instr(line, PLZFF)) != NULL) {
				fprintf(put,"%s", line);
				linec++;
				if (nothingelse(pek)) { /* sist p} raden ? */
					prfoot();
					prhead();
				}
			}

			else if( (pek = instr(line, CFF)) != NULL) {
				fprintf(put,"%s", line);
				linec++;
				if (nothingelse(pek)) { /* sist p} raden ? */
					prfoot();
					prhead();
				}
			}

			else if (linec >= lastline)
				prlast(line);

			else {
				fprintf(put,"%s", line);
				linec++;
			}

		else if (linec >= lastline)
			prlast(line);

		else {
			fprintf(put,"%s", line);
			linec++;
		}
	}

	prfoot();
	if (langopt)
		fprintf(put,SWECHAR);

}
/**/
delff(pek)
char	*pek;
{
	while ( *pek != NULL ) {
		++pek;
		if ( *pek == '\f' )
			delff(pek);
		*(pek-1) = *pek;
	}
}
/**/
makehead(h, s)
char	*h, *s;
{
	int	tmp;
	char	tmpstr[SMALL];

	tmp = strlen(s);
	string(tmpstr, pagenopos - tmp, ' ');
	strcat(s, tmpstr);
	strcpy(h, s);
}
/**/
modtime(str, file)
char	*str, *file;
{
	struct stat	filestat;
	struct tm	*tp, *localtime();
	int		y, mo, d, h, mi, s;

	stat(file, &filestat);

	tidtab.time = filestat.st_mtime;

	tp = localtime(&tidtab);

	y = tp->tm_year + 1900;
	mo = tp->tm_mon + 1;
	d = tp->tm_mday;
	h = tp->tm_hour;
	mi = tp->tm_min;
	s = tp->tm_sec;

	sprintf(str, "%4d-%02d-%02d   %02d:%02d:%02d", y, mo, d, h, mi, s);
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
/**/
prlast(l)
char	*l;
{
	fprintf(put,"%s", l);
	linec++;
	prfoot();
	prhead();
}
/**/
prhead()
{
	char	*string(), *pageplace;
	char	hline[MAXL];

	string(hline, headline - 1, '\n');
	fprintf(put,"%s", hline);

	if ((mode & NOHEAD) == FALSE) {
		pageplace = header + pagenopos;
		sprintf(pageplace, "%d\n", pagec);
		fprintf(put,"%s", header);

		string(hline, HEADMARG -1, '\n');
		fprintf(put, "%s", hline);
	}

	linec = firstline;
}
/**/
prfoot()
{
	char *string();
	char fline[MAXL];

	if (mode & NOHEAD)
		fprintf(put, "\f");

	else {
		string(fline, footline - linec, '\n');
		fprintf(put,"%s", fline);
		fprintf(put,"%s\f", foot);
	}

	pagec++;
}
/**/
char	*string(s, n, c)
register char	*s;
register int	n;
register char	c;
{
	while(n-- > 0)
		*s++ = c;
	*s = '\0';
	return(s);
}
/**/
set()
{
	if (mode & LA4) {
		pagelen = PAGE;
		pagenopos = COLS - 15;
		datepos = COLS - 35;
	}

	else {
		pagelen = PAGESA4;
		pagenopos = COLSSA4 - 5;
		datepos = COLSSA4 - 25;
	}

	firstline = headline;
	maxline = pagelen - LPSKIP;
	footline = maxline;
	lastline = footline;

	if ((mode & NOHEAD) == FALSE) {
		firstline = firstline + HEADMARG;
		lastline = lastline - FOOTMARG;
	}
}
/**/
skip(fp, n)
FILE	*fp;
int	n;
{
	while (n--)
		if (fgets(line, MAXL, fp) == NULL)
			return (-1);

	return(0);
}
/**/
nothingelse(l)	/* Inget annat {n sidbytare p} raden */
char	*l;
{
	char	*p = l;
	int	len;

	while (*p == ' ' || *p == '\t')
		p++;

	len = strlen(p) - 1;
	if (strncmp(p, PLZFF, len) == 0 || strncmp(p, CFF, len) == 0)
		return(TRUE);

	else
		return(FALSE);
}
/**/
/* testar om ett tecken {r }{| */
conv(pnt)
char	*pnt;
{
  static char	swespec[] = "}{|`~][\\@^";
  register char	*i;

  for (i = swespec; *i != '\0'; i++) {
    if (*pnt == *i)
      return(TRUE);
  }
  return(FALSE);
}
/**/
/***************************************************************************
*
*  charins
*
*  s{tter in ett tecken f|rst i en str{ng. |vriga tecken i str{ngen flyttas
*  fram}t ett tecken. ingen kontroll p} str{ngens storlek.
*
***************************************************************************/

charins(str, chr)
register char	*str;
register char	chr;
{
  register char	tmp;

  tmp = *str;
  *str++ = chr;

  while (tmp != '\0') {
    chr = tmp;
    tmp = *str;
    *str++ = chr;
  }
  *str = '\0';
}