/*
  Detta program listar en fil p} en serieanluten printer.
  Programmet f|ruts{tter att printern {r en ML-82A samt att den
  {r f|rsedd med 12" papper. Listningen g|rs med 16.5 c/i.
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/timeb.h>
#include <time.h>

#define SMALL		150
#define MAXL		1000
#define PAGE		72		/* 12" */
#define HEADSKIP	4
#define LPSKIP		5
#define HEADMARG	3
#define FOOTMARG	3
#define PRINT_ON	"\n\f\35"	/* 16.5 c/i */
#define PRINT_OFF	"\f\36\36"	/* 10 c/i */
#define PLZFF		"!!"
#define CFF		"/**/"

struct	timeb tidtab;
int	pagelen = PAGE;
int	pagenopos = 110;
int	datepos = 90;
int	headline = HEADSKIP + 1;
int	firstline;
int	footline;
int	maxline;	
int	lastline;

int	linec;
int	pagec;

char	header[SMALL], date[SMALL], line[MAXL];
char	filename[SMALL] = "standard input";
char	foot[SMALL] = "\n";
/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();
	char	*instr();

	firstline = headline + HEADMARG;
	maxline = pagelen - LPSKIP;
	footline = maxline;
	lastline = footline - FOOTMARG;

	ftime(&tidtab);			/* bara f|r att skaffa TZ */
	tidtab.millitm = 0;		/* skippa millisekunderna */
/**/
	if (argc == 1) {
		makehead(header, filename);
		filelist(stdin);
	} else
		while (--argc > 0)
			if ((fp = fopen(*++argv,"r")) == NULL) {
				fprintf(stderr,"list: cannot open %s\n",*argv);
				printf("missed file %s\n\f", *argv);
 			} else {
				int tmp;
				char *string();

				strncpy(filename, *argv, pagenopos);
				makehead(header, filename);

				modtime(date, *argv);
				tmp = strlen(date);
				string(foot, datepos, ' ');
				strncat(foot, date, SMALL - tmp - 2);
				strcat(foot, "\n");

				filelist(fp);
				fclose(fp);
			}
}
/**/
filelist(fp)
FILE	*fp;
{

	pagec = 1;
	printf(PRINT_ON);
	prhead();
	while((fgets(line, MAXL, fp)) != NULL) {
		if(linec == lastline)
			prlast(line);
		else if(instr(line, PLZFF) != NULL)
			prlast(line);
		else if(instr(line, CFF) != NULL)
			prlast(line);
		else {
			prline(line);
			linec++;
		}
	}
	prfoot();
	printf(PRINT_OFF);
}
/**/
makehead(h, s)
char	*h, *s;
{
	int	tmp;
	char	tmpstr[SMALL];

	tmp = strlen(s);
	string(tmpstr, pagenopos - tmp, ' ');
	strcat(s, tmpstr);
	strcpy(h, s);
}
/**/
modtime(str, file)
char	*str, *file;
{
	struct stat	filestat;
	struct tm	*tp, *localtime();
	int		y, mo, d, h, mi, s;

	stat(file, &filestat);

	tidtab.time = filestat.st_mtime;

	tp = localtime(&tidtab);

	y = tp->tm_year + 1900;
	mo = tp->tm_mon + 1;
	d = tp->tm_mday;
	h = tp->tm_hour;
	mi = tp->tm_min;
	s = tp->tm_sec;

	sprintf(str, "%4d-%02d-%02d   %02d:%02d:%02d", y, mo, d, h, mi, s);
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
/**/
prlast(l)
char	*l;
{
	prline(l);
	linec++;
	prfoot();
	prhead();
}
/**/
prhead()
{
	char	*string(), *pageplace;

	string(line, headline - 1, '\n');
	prline(line);

	pageplace = header + pagenopos;
	sprintf(pageplace, "%d\n", pagec);
	prline(header);

	string(line, HEADMARG -1, '\n');
	prline(line);
	linec = firstline;
}
/**/
prfoot()
{
	char *string();

	string(line, footline - linec, '\n');
	prline(line);
	prline(foot);
	printf("\f\n");
	pagec++;
}
/**/
prline(l)
char	*l;
{
	char	tmpstr[MAXL];

	string(tmpstr, 1, '\t');
	strcat(tmpstr, l);
	printf("%s", tmpstr);
}
/**/
char	*string(s, n, c)
register char	*s;
register int	n;
register char	c;
{
	while(n-- > 0)
		*s++ = c;
	*s = '\0';
	return(s);
}
