#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/timeb.h>
#include <time.h>

#define	LA4		1
#define SA4		2
#define	TRUE		1
#define	FALSE		0

#define SMALL		150
#define MAXL		1000
#define PAGE		51
#define	PAGESA4		72
#define COLS		120
#define COLSSA4		75
#define HEADSKIP	4
#define LPSKIP		5
#define HEADMARG	3
#define FOOTMARG	3
#define PLZFF		"!\041"
#define CFF		"/\052*/"
#define IBMFF		"The IBM Personal"
#define ENGCHAR		"\033\113"	/* english character set */
#define SWECHAR		"\033\115"	/* swedish character set */

struct	timeb tidtab;
int	pagelen;
int	pagenopos;
int	datepos;
int	headline = HEADSKIP + 1;
int	firstline;
int	footline;
int	maxline;	
int	lastline;

int	linec;
int	pagec;

int	ibmlst = FALSE;
int	langopt=FALSE;		/* language option selected */
int	swelst = TRUE;		/* swedish listing as default */

FILE	*put;

char	header[SMALL], date[SMALL], line[MAXL];
char	filename[SMALL] = "standard input";
char	foot[SMALL] = "\n";
/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen(), *popen();
	char	*instr();

	ftime(&tidtab);			/* bara f|r att skaffa TZ */
	tidtab.millitm = 0;		/* skippa millisekunderna */
/**/
	set(LA4);

	if ((put = popen("lpr", "w")) == NULL) {
		fprintf(stderr, "someone har knyckt lpr\n");
		exit(-1);
	}

	while (instr(*++argv, "-")) {
		if (strncmp(*argv, "-i",2) == 0)
			ibmlst = TRUE;

		if (strncmp(*argv, "-s", 2) == 0)
			set(SA4);

		if (strncmp(*argv, "-e",2) == 0) {
			swelst = FALSE;
			langopt = TRUE;
		}

		if (strncmp(*argv, "-w",2) == 0) {
			swelst = TRUE;
			langopt = TRUE;
		}

		--argc;
	}

	if (argc == 1) {
		makehead(header, filename);
		filelist(stdin);
	}

	else
		while (--argc > 0) {
			if ((fp = fopen(*argv,"r")) == NULL) {
				fprintf(stderr,"list: cannot open %s\n",*argv);
				fprintf(put,"missed file %s\n\f", *argv);
 			} else {
				int tmp;
				char *string();

				strncpy(filename, *argv, pagenopos);
				makehead(header, filename);

				modtime(date, *argv);
				tmp = strlen(date);
				string(foot, datepos, ' ');
				strncat(foot, date, SMALL - tmp - 2);
				strcat(foot, "\n");

				filelist(fp);
				fclose(fp);
			}

			argv++;
		}

	fprintf(put,"%s", "\f\n");
}
/**/
filelist(fp)
FILE	*fp;
{

	pagec = 1;

	if (langopt) {
		if (swelst)
			fprintf(put,SWECHAR);
		else
			fprintf(put,ENGCHAR);
	}
	fprintf(put,"%s", "\f");
	prhead();
	while((fgets(line, MAXL, fp)) != NULL) {
		if (instr(line, IBMFF) && ibmlst) {
			if (skip(fp, 3) == -1)
				break;

			else if (linec != firstline || pagec != 1) {
				prfoot();
				prhead();
			}
		}

		else if (instr(line, "\f")) {	/* ff n}gonstans i raden */
			prfoot();		/* skippa raden */
			prhead();
		}
			
		else if (linec == lastline)
			prlast(line);

		else if(instr(line, PLZFF) != NULL || instr(line, CFF) != NULL)
			if (linec != firstline)
				prlast(line);

			else {
				fprintf(put,"%s", line);
				linec++;
			}

		else {
			fprintf(put,"%s", line);
			linec++;
		}
	}

	prfoot();
	if (langopt)
		fprintf(put,SWECHAR);
}
/**/
makehead(h, s)
char	*h, *s;
{
	int	tmp;
	char	tmpstr[SMALL];

	tmp = strlen(s);
	string(tmpstr, pagenopos - tmp, ' ');
	strcat(s, tmpstr);
	strcpy(h, s);
}
/**/
modtime(str, file)
char	*str, *file;
{
	struct stat	filestat;
	struct tm	*tp, *localtime();
	int		y, mo, d, h, mi, s;

	stat(file, &filestat);

	tidtab.time = filestat.st_mtime;

	tp = localtime(&tidtab);

	y = tp->tm_year + 1900;
	mo = tp->tm_mon + 1;
	d = tp->tm_mday;
	h = tp->tm_hour;
	mi = tp->tm_min;
	s = tp->tm_sec;

	sprintf(str, "%4d-%02d-%02d   %02d:%02d:%02d", y, mo, d, h, mi, s);
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
/**/
prlast(l)
char	*l;
{
	fprintf(put,"%s", l);
	linec++;
	prfoot();
	prhead();
}
/**/
prhead()
{
	char	*string(), *pageplace;

	string(line, headline - 1, '\n');
	fprintf(put,"%s", line);

	pageplace = header + pagenopos;
	sprintf(pageplace, "%d\n", pagec);
	fprintf(put,"%s", header);

	string(line, HEADMARG -1, '\n');
	fprintf(put, "%s", line);
	linec = firstline;
}
/**/
prfoot()
{
	char *string();

	string(line, footline - linec, '\n');
	fprintf(put,"%s", line);
	fprintf(put,"%s\f", foot);
	pagec++;
}
/**/
char	*string(s, n, c)
register char	*s;
register int	n;
register char	c;
{
	while(n-- > 0)
		*s++ = c;
	*s = '\0';
	return(s);
}
/**/
set(pl)
int	pl;
{
	if (pl == LA4) {
		pagelen = PAGE;
		pagenopos = COLS - 15;
		datepos = COLS - 35;
	}

	else {
		pagelen = PAGESA4;
		pagenopos = COLSSA4 - 5;
		datepos = COLSSA4 - 25;
	}

	firstline = headline + HEADMARG;
	maxline = pagelen - LPSKIP;
	footline = maxline;
	lastline = footline - FOOTMARG;
}
/**/
skip(fp, n)
FILE	*fp;
int	n;
{
	while (n--)
		if (fgets(line, MAXL, fp) == NULL)
			return (-1);

	return(0);
}
