#include <stdio.h>
#include "lon.h"

#define PERSREG		"namnfil"
#define ACCREG		"acc"

#define LINES		48
#define COLS		79

#define	L		0
#define	R		1
#define	M		2

#define ASL		43
#define ASC		22
#define ALL		43
#define ALC		13
#define BDL		43
#define BDC		64
#define SUL		43
#define SUC		76
#define PEL		43
#define PEC		26

#define MOL		12
#define MOC		46
#define AVL		12
#define AVC		8

#define SPCRPOS		13
#define ANTPOS		52
#define APRISPOS	64
#define BELPOS		76

#define	LSPEC		21
#define LSPECMAX	40


/**/
char	line[MAXL], workl[MAXL];
char	immage[LINES * COLS];
char	namn[SMALL];
char	period[SMALL], betdat[SMALL];
double	data[12];			/* l|nedataarray */

int	specline;		/* n{sta rad f|r specrader */

char	*benamn[] = {
		"M}nadsl|n",
		"\\vertid 50 %",
		"\\vertid 100 %",
		"Semesterl|n",
		"Tj{nstledighet",
		" ",
		"Sjukavdrag",
		"Prelimin{rskatt",
		"Kvarskatt",
		"Rikskuponger",
		"Utl{gg",
		"Reser{kning"
	};
	

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();

/*
	while (instr(*++argv, "-")) {
		if (strncmp(*argv, "-i",2) == 0)
			ibmlst = TRUE;

		else if (strncmp(*argv, "-s", 2) == 0) {
			set(SA4);
		}

		--argc;
	}
*/
	if (argc == 1) {
		mkimmage(stdin);
	}

	else
		while (--argc > 0) {
			if ((fp = fopen(*++argv,"r")) == NULL) {
				fprintf(stderr,"fakt: cannot open %s\n",*argv);
				exit(-1);
			}

			mkimmage(fp);
		}
}
/**/
mkimmage(fp)
FILE	*fp;
{
	char		*p;
	register int	i, rad;
	char		*strins(), *strcpy();

	if ((fgets(line, MAXL, fp)) == NULL) {
		fprintf(stderr, "lnspec: f|r kort fil\n");
		exit(-1);
	}

	*(line + strlen(line) - 1) = '\0';
	strcpy(period, line);

	if ((fgets(line, MAXL, fp)) == NULL) {
		fprintf(stderr, "lnspec: f|r kort fil\n");
		exit(-1);
	}

	*(line + strlen(line) - 1) = '\0';
	strcpy(betdat, line);

	for(;;) {
		for (p = immage, i = 1; i <= (LINES * COLS); p++, i++)
			*p = ' ';

		strins(immage, cur(PEL, PEC + 8), period, L);
		strins(immage, cur(BDL, BDC), betdat, R);

		rad = 1;
		specline = LSPEC;
		while (rad <= 13 && (fgets(line, MAXL, fp)) != NULL) {
			*(line + strlen(line) - 1) = '\0';

			switch(rad) {
				case 1:
					mknamn();
					break;

				case 2:
					sscanf(line, "%lf", &data[ML]);
					mkspcl(ML, ' ');
					break;

				case 3:
					sscanf(line, "%lf", &data[OT1]);
					mkspcl(OT1, ' ');
					break;

				case 4:
					sscanf(line, "%lf", &data[OT2]);
					mkspcl(OT2, ' ');
					break;

				case 5:
					sscanf(line, "%lf", &data[SEM]);
					mkspcl(SEM, ' ');
					break;

				case 6:	
					sscanf(line, "%lf", &data[TJL]);
					mkspcl(TJL, '-');
					break;

				case 7:
					sscanf(line, "%lf", &data[SJDGR]);
					break;

				case 8:
					sscanf(line, "%lf", &data[PERDAG]);
					mkspcl(PERDAG, '-');
					break;

				case 9:
					sscanf(line, "%lf", &data[SKATT]);
					mkspcl(SKATT, '-');
					break;

				case 10:
					sscanf(line, "%lf", &data[KVARSK]);
					mkspcl(KVARSK, '-');
					break;

				case 11:
					sscanf(line, "%lf", &data[RIKSK]);
					mkspcl(RIKSK, '-');
					break;

				case 12:
					sscanf(line, "%lf", &data[UTL]);
					mkspcl(UTL, ' ');
					break;

				case 13:
					sscanf(line, "%lf", &data[RESER]);
					mkspcl(RESER, ' ');
					break;
			}

			rad++;
		}

		if (rad <= 13)
			break;

		mksum();
		mkacc();
		mktxt();
		outimmage();
	}
}

/**/
mknamn()
{
#define	OUTADDR		0
#define INADDR		1

	FILE	*nfp;
	int	mol = MOL;
	int	state;
	char	*strcpy(), *strcat();
	char	matchstr[SMALL];

	strcpy(matchstr, ".NA ");
	strcpy(namn, line);
	strcat(matchstr, line);

	if ((nfp = fopen(PERSREG, "r")) == NULL) {
		fprintf(stderr, "lnspc: namnen f|rsvunna\n");
		exit(-1);
	}

	state = OUTADDR;
	while (fgets(workl, MAXL, nfp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		if (strcmp(matchstr, workl) == 0) {
			state = INADDR;
			break;
		}
	}

	if (state == OUTADDR) {
		fprintf(stderr, "lnspec: fel i namnfil\n");
		exit(-1);
	}

	while (fgets(workl, MAXL, nfp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		if (*workl == '.')
			break;

		else {
			strins(immage, cur(mol, MOC), workl, L);
			mol++;
		}
	}

	fclose(nfp);
}

/**/
mkspcl(x, t)
int	x, t;
{
	char	*strins();
	double	sjk = 0;

	if (x == PERDAG && data[SJDGR] > 0 && data[PERDAG] > 0) {
		sjk = data[SJDGR] * data[PERDAG];

		strins(immage, cur(specline, SPCRPOS), benamn[x], L);
		sprintf(workl, "%-10.0f", data[SJDGR]);
		strins(immage, cur(specline, ANTPOS), workl, R);
		sprintf(workl, "%-10.0f", data[PERDAG]);
		strins(immage, cur(specline, APRISPOS), workl, R);
		sprintf(workl, "-%-10.0f", sjk);
		strins(immage, cur(specline, BELPOS), workl, R);

		if (specline < LSPECMAX)
			specline++;
	}

	else if (data[x] > 0 && x != PERDAG) {
		strins(immage, cur(specline, SPCRPOS), benamn[x], L);
		sprintf(workl, "%c%-10.0f", t, data[x]);
		strins(immage, cur(specline, BELPOS), workl, R);

		if (specline < LSPECMAX)
			specline++;
	}
}


/**/
mkacc()
{
	FILE	*afp;
	char	*p, *p1;

	if ((afp = fopen(ACCREG, "r")) == NULL) {
		fprintf(stderr, "lnspc: accregistret f|rsvunnet\n");
		exit(-1);
	}

	while (fgets(workl, MAXL, afp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		p = workl;
		while (*p != ' ')
			p++;

		*p++ = '\0';

		if (strcmp(namn, workl) == 0) {
			p1 = p;
			while (*p != ' ')
				p++;

			*p++ = '\0';

			strins(immage, cur(ALL, ALC), p1, R);
			strins(immage, cur(ASL, ASC), p, R);
		}
	}

	fclose(afp);
}

/**/
mktxt()
{
	char	*strins();

	strins(immage, cur(AVL, AVC), "IN DEVELOPMENT AB", L);
	strins(immage, cur(AVL + 1, AVC), "Box 2066", L);
	strins(immage, cur(AVL + 3, AVC), "175 02  J[RF[LLA", L);
	strins(immage, cur(PEL, PEC), "Period:", L);
}
/**/
mksum()
{
	double	tot;
	char	*strins();

	tot = data [ML] + data [OT1] + data [OT2] + data [SEM] - data [TJL] - 
	      (data [SJDGR] * data [PERDAG]) - data [SKATT] - data [KVARSK] - 
	      data [RIKSK] + data [UTL] + data [RESER];


	sprintf(workl, "%-10.0f", tot);
	strins(immage, cur(SUL, SUC), workl, R);
}

/**/
outimmage()
{
	char	*p;
	int	i, j;

	for (i = 0; i < LINES; i++)
		for (j = COLS - 1; j >= 0; j--) {
			p = immage + j + i * COLS;
			if ( *p == ' ')
				*p = '\0';

			else
				break;
		}

	for (i = 0; i < LINES; i++)
		puts(immage + i * COLS);
}

/**/
/***************************************************************************
*
*  Strins:	String insert. S{tter in str{ngen part i str{ngen base
*		p} pos. Om a = L sker v{nsterjustering, annars h|ger.
*
*		Returnerar en pointer till det sist insatta tecknet + 1.
*
***************************************************************************/

char	*
strins(base, pos, part, a)
register char	*base, *part;
register int	pos;
int		a;
{
	int	i;

	if (a == L)
		base += pos;

	else {
		for (i = strlen(part) - 1; *(part + i) == ' ' && i >= 0; i--)
			*(part + i) = '\0';

		base += (pos - strlen(part) + 1);
	}

	for (; *part != '\0'; part++, base++)
		*base = *part;

	return(base + 1);
}
/**/
cur(li, col)
int	li;
int	col;
{
	return((li - 1) * COLS + col - 1);
}
