/***************************************************************************

	NYA L\NEPRORAMMET


	Ers{tter Multiplan, ber, accuppd, lnspec samt lon.h

	Anrop:
		lonber spec accny accold

		spec   =  Specifikationsfil
		accny  =  Ny accumulerad l|n och skatt
		accold =  Gammal d:o

	Gjorda {ndringar mot f|reg}ende system:
		Alla utskrifter flyttade tv} (2) sn{pp v{nster.


	M|jliga f|rb{ttringar:
		Utskrift av bokf|ringsunderlag.
		
		Utskrift av utbetalningskort. Uppgifter om bankkonton
		finns i namnfil.

		B{ttre t}lighet mot sm} fel & brister i inputen.

		Path till data i anropet.

	Uppdateringar:
	Tue Dec 16 15:24:33 1986	Originalversion/UI
	Thu Dec 18 20:26:45 1986	Skattej{mkning/UI
	Sun Dec 21 14:24:58 1986	Uppb|rdsdeklaration & bilf|rm}n/UI
	Fri Jan 16 10:31:37 1987	Hantering av kvarskatt/UI
	Tue Jan 20 14:06:06 1987	Fixat sjukavdragsbug /UI
	Fri Jan 22 09:12:18 1988	Nytt f|retagsnamn/GB

***************************************************************************/
/**/
#include <stdio.h>

#define PERSREG		"namnfil"
#define	ATP		"atpprocent"

#define LINES		48	/* Rader p} blanketten */
#define COLS		79	/* Kolumner */

#define	TRUE		1
#define	FALSE		0

#define	SMALL		30
#define MAXL		300
#define MAXNAMN		12

#define	L		0
#define	R		1
#define	M		2
/**/
/* Indexering i dataarrayer mm 

   Anv{nds f|r att indexera i data[] (summering av belopp) och i benam[] [] 
   (specifikationstexter och styrning av summering)

*/

#define	NAMNK		0	/* Namkod */
#define ML		1	/* M}nadsl|n */
#define OT1		2	/* \vertid 1 */
#define OT2		3	/*	   2 */
#define SEM		4	/* Semesterl|n */
#define TJL		5	/* Tj{nstledigt */
#define SJDGR		6	/* Sjukdagar */
#define PERDAG		7	/* Sjukavdrag per dag */
#define SKATT		8	/* Skatt (i absolut belopp, dvs utan ber{nk) */
#define KVARSK		9	/* Kvarskatt */
#define RIKSK		10	/* Rikskuponger */
#define UTL		11	/* Utl{gg */
#define RESER		12	/* Reser{kning */
#define	SKT		13	/* Skattetabell */
#define	SKJM		14	/* Skattej{mkning, skatt ber p} minskad l|n */
#define	SKJP		15	/*		   skatt utg|r % av l|n */
#define	SKJD		16	/*		   skatt ber p} del av l|n */
#define	SKJB		17	/*		   skatt ber{knas p} belopp */
#define	SKJO		18	/*		   skatt ber{kn p} |kad l|n */
#define SKJE		19	/*		   extra avdrag */
#define BIL		20	/* Bilf|rm}n */

#define	NBENAM		21	/* Max index ovan + 1  ######### OBS! #######*/
/**/
/* Div positioner p} l|nespecblanketten */

#define ASL		43	/* Accumulerad skatt, rad */
#define ASC		20	/*	-""-	      kolumn */
#define ALL		43	/* Accumulerad l|n */
#define ALC		11
#define BDL		43	/* Betalningsdag */
#define BDC		62
#define SUL		43	/* Summa */
#define SUC		74
#define PEL		43	/* Period */
#define PEC		24

#define MOL		12	/* Mottagare */
#define MOC		44
#define AVL		12	/* Avs{ndare */
#define AVC		6

#define	LSPEC		21	/* F|rsta rad f|r specrader */
#define LSPECMAX	40	/* Maxrad */

/* Posistioner per rad */

#define SPCRPOS		11	/* Ben{mning */
#define ANTPOS		50	/* Tim, dgr, ant */
#define APRISPOS	62	/* a'-pris */
#define BELPOS		74	/* Belopp */

/**/
char	line[MAXL], workl[MAXL];	/* Inputr{ng, arbetsstr{ng */
char	immage[LINES * COLS];		/* Immage av blanketten */
char	namn[SMALL];			/* Inneh}ller namkod */
char	namnrad[SMALL];			/* Att spara namkod i tillf{lligt */
char	period[SMALL], betdat[SMALL];	/* */
char	*oldacc;

double	data[NBENAM];			/* L|nedataarray */
double	skattlon;			/* Skattepliktig l|n */
double	brutto;				/* Skattepliktig bruttoers{ttning
					   (skattlon - bilf|rm}n) */
double	sjk;				/* Utr{knat sjukavdrag */
double	kvarsk;				/* Accumulerad kvarskatt */
int	manad;				/* M}nadsnummer */

/* F|r uppb|rdsdeklarationen */

double	uppd01;				/* F{lt 01, Kontant bruttoers{ttning */
double	uppd02;				/*	02, Bilf|rm}n */
double	uppd11;				/*	11, Avdragen A-skatt */
double	uppd12;				/*	12, Avdragen kvarskatt */

int	specline;			/* N{sta rad f|r specrader */
FILE	*nyaccfp;

char	*instr();
/**/
/* Specifikationstexter 

   Om andra kolumnen inneh}ller "0" kommer ingen specifikationsrad att
   skrivas ut. Om kolumnen inneh}ller "-" kommer ett minustecken att s{ttas
   i f|re beloppet
*/

char	*benamn[NBENAM] [2] = {
		{" ", "0"},		/* Anv{nds bara f|r .NA */
		{"M}nadsl|n", " "},
		{"\\vertid 50 %", " "},
		{"\\vertid 100 %", " "},
		{"Semesterl|n", " "},
		{"Tj{nstledighet", "-"},
		{"Sjukdagar ", "0"},	/* SJDGR Special, se mkspcl() */
		{"Sjukavdrag", "-"},	/* PERDAG */
		{"Prelimin{rskatt", "-"},
		{"Kvarskatt", "-"},
		{"Rikskuponger", "-"},
		{"Utl{gg", " "},
		{"Reser{kning", " "},
		{" ", "0"},		/* Anv{nds bara f|r SJT */
		{" ", "0"},		/* SKJM */
		{" ", "0"},		/* SKJP */
		{" ", "0"},		/* SKJD */
		{" ", "0"},		/* SKJB */
		{" ", "0"},		/* SKJO */
		{" ", "0"},		/* SKJE	*/
		{" ", "0"},		/* Bilf|rm}n. bara f|r skatteber */
	};
/**/
/*
  Array att per gubbe spara ihop accumulerade l|ner & skatter i
*/

struct	accdata {
		char	namnkod[10];	/* namnkod, max 9 tecken */
		double	acclon;		/* accumulerad l|n */
		double	accskatt;	/* accumulerad skatt  */
		double	acckvar;	/* accumulerad kvarskatt */
	} acc[MAXNAMN];
/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*specfp, *oldaccfp, *fopen();

	if (argc != 4) {
		fprintf(stderr, "lonber: fel antal parametrar\n");
		fprintf(stderr, "        anrop:\n");
		fprintf(stderr, "	   lonber spec nyacc oldacc\n");
		exit(-1);
	}

	if ((specfp = fopen(*++argv, "r")) == NULL) {
		fprintf(stderr, "lonber: kan inte |ppna specfil\n");
		exit(-1);
	}

	if ((nyaccfp = fopen(*++argv, "w")) == NULL) {
		fprintf(stderr, "lonber: kan inte |ppna ny accumulator\n");
		exit(-1);
	}

	if ((oldaccfp = fopen(*++argv, "r")) == NULL) {
		fprintf(stderr, "lonber: kan inte |ppna gamla accumulatorn\n");
		exit(-1);
	}

	oldacc = *argv;		/* gamla accumulatorfilen */
	readacc(oldaccfp);	/* l{s in gamla accumulatorn */
	mkspec(specfp);		/* g|r l|nespec */
	mknyacc();		/* ordna ny accumulatorfil */
	mkuppdek();		/* tillverka uppb|rdsdeklaration */
}
/**/
readacc(fp)		/* l{s in gamla accumulerade l|ner & skatter */
FILE	*fp;
{
	char		*cp, *lp;
	struct accdata	*ap = acc;

	while (fgets(line, MAXL, fp) != NULL) {
		*(line + strlen(line) -1) = '\0';	/* ta bort LF */

		for(cp = ap->namnkod, lp = line; *lp != ' ' && *lp != '\t';)
			*cp++ = *lp++;			/* flytta namnkod */

		*cp = '\0';				/* avsluta namnkod */

		sscanf(lp, "%lf %lf %lf", &(ap->acclon), &(ap->accskatt), 
							&(ap->acckvar));

		ap++;					/* f|r n{sta gubbe */
	}
	ap->namnkod[0] = '\0';		/* slutmarkering i acc */
	fclose(fp);
}
/**/
mkspec(fp)
FILE	*fp;
{
	char	*cp, *strins(), *strcpy();

	for (;;) {
		if ((fgets(line, MAXL, fp)) == NULL) {
			fprintf(stderr, "lonber: f|r kort fil\n");
			exit(-1);
		}

		if (*line == '.')
			break;
	}
/**/
/* Sug in betalningsdatum */

	*(line + strlen(line) - 1) = '\0';	/* skippa LF */

	if (instr(line, ".BE") != line) {
		fprintf(stderr, "lonber: .BE ska vara p} f|rsta raden\n");
		exit(-1);
	}

	for (cp = line; *cp != ' ' && *cp != '\t'; cp++)
		;				/* f|rsta witespace */

	while (*cp == ' ' || *cp == '\t')	/* s} l{nge som vitt */
		cp++;

/* Borde finnas koll p} datum h{r */

	strncpy(betdat, cp, 6);			/* betalningsdatum */
	betdat[6] = '\0';

	strncpy(period, cp, 4);			/* period  (}r, m}n) */
	period[4] = '\0';

	strncpy(workl, cp + 2, 2);		/* M}nad */
	sscanf(workl, "%d", &manad);		/* Numeriskt */
/**/
/* Sug in namnkod */

	for (;;) {
		if ((fgets(line, MAXL, fp)) == NULL) {
			fprintf(stderr, "lonber: f|r kort fil\n");
			exit(-1);
		}

		if (*line == '.')
			break;
	}

	*(line + strlen(line) - 1) = '\0';	/* skippa LF */
	if (instr(line, ".NA") != line) {
		fprintf(stderr, "lonber: namnkod ej p} plats\n");
		exit(-1);
	}
	reset();
	getnamnkod(line);		/* Hamnar i namn */
	mknamn();
/**/
	while (fgets(line, MAXL, fp) != NULL) {
		*(line + strlen(line) - 1) = '\0';

		nocommen();		/* ta bort kommentarer p} raden */

		if (kod(".M]", ML));		/* OBS ! */
		else if (kod(".\\T1", OT1));	/* Om flera koder b|rjar */
		else if (kod(".\\T2", OT2));	/* likadant m}ste den l{ngre */
		else if (kod(".SE", SEM));	/* st} f|rst . Ex SKJM f|re */
		else if (kod(".TJ", TJL));	/* SKT f|re SK */
		else if (kod(".SJ", SJDGR));
		else if (kod(".PERD", PERDAG));
		else if (kod(".KV", KVARSK));
		else if (kod(".RI", RIKSK));
		else if (kod(".UTL", UTL));
		else if (kod(".RES", RESER));
		else if (kod(".SKJM", SKJM));
		else if (kod(".SKJP", SKJP));
		else if (kod(".SKJD", SKJD));
		else if (kod(".SKJB", SKJB));
		else if (kod(".SKJO", SKJO));
		else if (kod(".SKJE", SKJE));
		else if (kod(".SKT", SKT));
		else if (kod(".SK", SKATT));
		else if (kod(".BIL", BIL));
		else if (kod(".NA", NAMNK)) {
			strncpy(namnrad, line, SMALL - 1);
			specslut();
			reset();
			getnamnkod(namnrad);	/* n{sta namn */
			mknamn();				
		}
	}

	specslut();
}
/**/
specslut()		/* Avsluta en l|nespec */
{
	mkskatt();		/* R{kna ut skatt */
	mkspcl();		/* Tillverka l|nespecrader */
	mkacc();		/* Uppdatera accumulerad l|n & skatt */
	uppdsum();		/* Summera f|r uppb|rdsdeklaration */
	mktxt();		/* G|r texter i l|nespecen */
	outimmage();		/* Peta ut den f{rdiga specen */

}
/**/
kod(code, typ)		/* avkoda radkod och addera belopp */
char	*code;
int	typ;
{
	register char	*cp;
	double		tmp;

	if (instr(line, code) == line) {
		for (cp = line; *cp != ' ' && *cp != '\t'; cp++)
			;				/* f|rsta witespace */

		sscanf(cp, "%lf", &tmp);		/* belopp */
		data[typ] += tmp;

		return(TRUE);
	}

	else
		return(FALSE);
}

/**/
mknamn()
{
#define	OUTADDR		0
#define INADDR		1

	FILE	*nfp;
	int	mol = MOL;
	int	state;
	char	*strcpy(), *strcat();
	char	matchstr[SMALL];

	strcpy(matchstr, ".NA ");
	strcat(matchstr, namn);
	if ((nfp = fopen(PERSREG, "r")) == NULL) {
		fprintf(stderr, "lnspc: namnen f|rsvunna\n");
		exit(-1);
	}

	state = OUTADDR;
	while (fgets(workl, MAXL, nfp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		if (strcmp(matchstr, workl) == 0) {
			state = INADDR;
			break;
		}
	}

	if (state == OUTADDR) {
		fprintf(stderr, "lonber: fel i namnfil\n");
		exit(-1);
	}

	while (fgets(workl, MAXL, nfp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		if (*workl == '.')
			break;

		else {
			strins(immage, cur(mol, MOC), workl, L);
			mol++;
		}
	}

	fclose(nfp);
}
/**/
mkspcl()		/* tillverka specifikationsraderna */
{
	register int	i;
	char		*strins();

	for (i = 0; i < NBENAM; i++) {
		if (*benamn[i] [1] == '0')
			continue;		/* Skippa s}dana */

		if (i == PERDAG && data[SJDGR] > 0 && data[PERDAG] > 0) {
			strins(immage, cur(specline, SPCRPOS), 
							benamn[i] [0], L);

			sprintf(workl, "%-10.0f", data[SJDGR]);
			strins(immage, cur(specline, ANTPOS), workl, R);
			sprintf(workl, "%-10.0f", data[PERDAG]);
			strins(immage, cur(specline, APRISPOS), workl, R);
			sprintf(workl, "-%-10.0f", sjk);
			strins(immage, cur(specline, BELPOS), workl, R);

			if (specline < LSPECMAX)
				specline++;
		}

		else if (data[i] > 0 && i != PERDAG && i != SJDGR) {
			strins(immage, cur(specline, SPCRPOS), benamn[i] [0], L);
			sprintf(workl, "%s%-10.0f",benamn[i] [1], data[i]);
			strins(immage, cur(specline, BELPOS), workl, R);

			if (specline < LSPECMAX)
				specline++;
		}
	}
}
/**/
mkacc()		/* Uppdatera accumulerad l|n & skatt samt s{tt in
		   i l|nespecen */
{
	struct accdata	*ap = acc;
	int		done = FALSE;

	while (ap->namnkod[0] != '\0')		/* Kvar i tabellen */
		if (strcmp(namn, ap->namnkod) == 0) {
			ap->acclon += brutto;
			ap->accskatt += data[SKATT];
			ap->acckvar += data[KVARSK];

			sprintf(workl, "%-10.0f", ap->acclon);
			strins(immage, cur(ALL, ALC), workl, R);
			sprintf(workl, "%-10.0f", ap->accskatt);
			strins(immage, cur(ASL, ASC), workl, R);

			kvarsk = ap->acckvar;

			done = TRUE;
			break;
		}

		else
			ap++;

	if (!done) {
		fprintf(stderr, "lonber: S{tt in %s 0 0 0 i %s\n", namn, oldacc);
		exit(-1);
	}
}
/**/
mktxt()
{
	char	*strins();

	strins(immage, cur(AVL, AVC), "Advance Tech Consulting AB", L);
	strins(immage, cur(AVL + 1, AVC), "Box 2066", L);
	strins(immage, cur(AVL + 3, AVC), "175 02  J[RF[LLA", L);
	strins(immage, cur(PEL, PEC), "Period:", L);
}
/**/
mkskatt()		/* r{kna ut skatt */
{
	int		njamk;		/* Antal j{mkningsklausuler */
	int		tmpi;
	long		tmp, lim;
	double		tot;
	register char	*p;
	FILE		*tfp;

	sjk = 0;
	if (data[SJDGR] > 0 && data[PERDAG] > 0)
		sjk = data[SJDGR] * data[PERDAG];

	skattlon = data [ML] + data [OT1] + data[OT2] + data[BIL] + 
		   data [SEM] - data [TJL] - sjk;

	brutto = skattlon - data[BIL];

	if (data[SKATT] > 0 && data[SKT] > 0) {
		fprintf(stderr, "lonber: b}de SK och SKT i .NA %s\n", namn);
		exit(-1);
	}

	njamk = 0;
	njamk = (data[SKJM]) ? njamk + 1 : njamk;	/* r{kna antal */
	njamk = (data[SKJD]) ? njamk + 1 : njamk;	/* j{mkningsklausuler*/
	njamk = (data[SKJB]) ? njamk + 1 : njamk;
	njamk = (data[SKJO]) ? njamk + 1 : njamk;

	if (njamk > 1 || (njamk == 1 && data[SKJP]) > 0) {
		fprintf(stderr, "lonber: kolla j{mkningar i .NA %s\n", namn);
		exit(-1);
	}

	if (data[SKATT] > 0 && (njamk > 0 || data[SKJP]) > 0) {
		fprintf(stderr, "lonber: kolla j{mkningar i .NA %s\n", namn);
		exit(-1);
	}
/**/
	if (data[SKJP] > 0) {			/* Skatt = % av l|n */
		tmp = (long)(brutto * data[SKJP] / 100);
		data[SKATT] = (double)tmp;
	}

	else if (data[SKT]  > 0) {		/* Skattetabell finns */
		if (data[SKJD] > 0)		/* Skatt ber{kn p} % av l|n */
			tmp = (long)(skattlon * data[SKJD] / 100);

		else if (data[SKJB]  > 0)	/* Skatt ber{kn p} belopp */
			tmp = (long)data[SKJB];

		else if (data[SKJM]  > 0)	/* Skatt ber{n p} minskad l */
			tmp = (long)(skattlon - data[SKJM]);

		else if (data[SKJO] > 0)	/* Saktt ber{kn p} |kad l|n */
			tmp = (long)(skattlon + data[SKJO]);

		else
			tmp = (long)skattlon;
/**/
/* Sl} upp i tabell */

		sprintf(workl, "t%ld", (long)data [SKT]);
		if ((tfp = fopen(workl, "r")) == NULL) {
			fprintf(stderr, "lonber: Ingen tabell %s\n", workl);
			exit(-1);
		}

		while (fgets(line, MAXL, tfp) != NULL) {
			*(line + strlen(line) - 1) = '\0';
			p = line;
			while (*p != '\t')
				p++;

			*p++ = '\0';		/* l|negr{ns i line */
						/* skatt i p */

			sscanf(line, "%ld", &lim);
			if (lim >= tmp)
				break;		/* funnit rad i tabell */
		}

		sscanf(p, "%lf", &data [SKATT]);
	}

	data[SKATT] += data[SKJE];		/* ev extra skatteavdrag */
/**/
/* ber{kning av kvarskatt */

	if (manad < 4 && data[KVARSK] > 0) {		/* jan - mars */
		data[KVARSK] /= 3;			/* 1/3 per m}nad */
		sprintf(workl, "%10.1f", data[KVARSK]);	/* en decimal */

		*(p = instr(workl, ".")) = '\0';	/* isolera helt & dec*/
		sscanf(workl, "%lf", &data[KVARSK]);
		sscanf(p + 1, "%d", &tmpi);

		if (tmpi >= 6 && manad < 3)		/* 1 sp}nn mer i jan */
			data[KVARSK] += 1;		/* och feb */

		else if (tmpi >= 3 && manad < 2)	/* 1 sp{nn mer i jan */
			data[KVARSK] += 1;
	}

	else
		data[KVARSK] = 0;			/* Inget april - dec */

	tot = data [ML] + data [OT1] + data [OT2] + data [SEM] +
	      data [UTL] + data [RESER] - data [TJL] - data [RIKSK] -
	      data [SKATT] - data [KVARSK] - sjk;

	sprintf(workl, "%-10.0f", tot);
	strins(immage, cur(SUL, SUC), workl, R);
}
/**/
outimmage()
{
	register char	*p;
	register int	i, j;

	for (i = 0; i < LINES; i++)
		for (j = COLS - 1; j >= 0; j--) {
			p = immage + j + i * COLS;
			if ( *p == ' ')
				*p = '\0';

			else
				break;
		}

	for (i = 0; i < LINES; i++)
		puts(immage + i * COLS);
}

/**/
/***************************************************************************
*
*  Strins:	String insert. S{tter in str{ngen part i str{ngen base
*		p} pos. Om a = L sker v{nsterjustering, annars h|ger.
*
*		Returnerar en pointer till det sist insatta tecknet + 1.
*
***************************************************************************/

char	*
strins(base, pos, part, a)
register char	*base, *part;
register int	pos;
int		a;
{
	register int	i;

	if (a == L)
		base += pos;

	else {
		for (i = strlen(part) - 1; *(part + i) == ' ' && i >= 0; i--)
			*(part + i) = '\0';

		base += (pos - strlen(part) + 1);
	}

	for (; *part != '\0'; part++, base++)
		*base = *part;

	return(base + 1);
}
/**/
char	*instr(s1, s2)		/* S|k r{tt p} s2 i s1 */
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;

		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
/**/
getnamnkod(li)			/* sug ut namnkod */
char	*li;
{
	char		*strcpy();
	register char	*cp, *cpe;

	for (cp = li; *cp != ' ' && *cp != '\t'; cp++)
		;				/* f|rsta witespace */

	while (*cp == ' ' || *cp == '\t')	/* s} l{nge som vitt */
		cp++;

	cpe = cp;
	while (*cpe != '\0' && *cpe != ' ' && *cpe != '\t')
		cpe++;

	*cpe = '\0';
	strcpy(namn, cp);
}
/**/
reset()		/* Rensa immagen */
{
	register int	i;
	register char	*p;

	for (i = 0; i < NBENAM; i++)
		data[i] = 0;

	for (p = immage,i = 1; i <= (LINES * COLS); p++, i++)
		*p = ' ';

	skattlon = 0;
	brutto 	 = 0;
	sjk	 = 0;
	
	strins(immage, cur(PEL, PEC + 8), period, L);
	strins(immage, cur(BDL, BDC), betdat, R);

	specline = LSPEC;

}
/**/
cur(li, col)
int	li;
int	col;
{
	return((li - 1) * COLS + col - 1);
}
/**/
nocommen()	/* Slit bort raden fr}&med ( */
{
	register char	*p = line;

	while (*p != '\0') {
		if (*p == '(') {
			*p = '\0';	/* korta av vid ( */
			break;
		}

		p++;
	}
}
/**/
mkuppdek()		/* tillverka uppb|rdsdeklaration */
{

	FILE	*atpfp;
	double	atp;

	reset();

	if ((atpfp = fopen(ATP, "r")) == NULL) {
		fprintf(stderr, "lonber: Ingen fil atpprocent\n");
		exit(-1);
	}

	if (fgets(line, MAXL, atpfp) == NULL) {
		fprintf(stderr, "lonber: Atpprocent tom\n");
		exit(-1);
	}

	sscanf(line, "%lf", &atp);
	fclose(atpfp);

	atp = (uppd01 + uppd02) * atp;

	mktxt();
	strins(immage, cur(LSPEC, SPCRPOS), 
				"UNDERLAG F\\R UPPB\\RDSDEKLARATION", L);

	strins(immage, cur(LSPEC + 2, SPCRPOS), 
					"Kontant bruttoers{ttning (01)", L);

	sprintf(workl, "%-10.0f", uppd01);
	strins(immage, cur(LSPEC + 2, APRISPOS),workl, R);
	
	strins(immage, cur(LSPEC + 3, SPCRPOS), "Bilf|rm}n (02)", L);
	sprintf(workl, "%-10.0f", uppd02);
	strins(immage, cur(LSPEC + 3, APRISPOS),workl, R);
	
	strins(immage, cur(LSPEC + 4, SPCRPOS), "Avgiftsunderlag A (04)", L);
	sprintf(workl, "%-10.0f", uppd01 + uppd02);
	strins(immage, cur(LSPEC + 4, APRISPOS),workl, R);
	
	sprintf(workl, "%-10.0f", atp);
	strins(immage, cur(LSPEC + 4, BELPOS),workl, R);
	
	strins(immage, cur(LSPEC + 5, SPCRPOS), "Avgift att betala (10)", L);
	sprintf(workl, "%-10.0f", atp);
	strins(immage, cur(LSPEC + 5, BELPOS),workl, R);
	
	strins(immage, cur(LSPEC + 6, SPCRPOS), "Avdragen A-skatt (11)", L);
	sprintf(workl, "%-10.0f", uppd11);
	strins(immage, cur(LSPEC + 6, BELPOS),workl, R);
	
	if (manad == 3) {				/* Bara i mars */
		strins(immage, cur(LSPEC + 7, SPCRPOS), 
						"Avdragen kvarskatt (12)", L);

		sprintf(workl, "%-10.0f", uppd12);
		strins(immage, cur(LSPEC + 7, BELPOS),workl, R);
	}

	strins(immage, cur(LSPEC + 8, SPCRPOS), 
				"Summa avgift & skatt att betala (13)", L);

	sprintf(workl, "%-10.0f", atp + uppd11 + uppd12);
	strins(immage, cur(LSPEC + 8, BELPOS),workl, R);
	strins(immage, cur(SUL, SUC),workl, R);
	
	outimmage();
}
/**/
uppdsum()		/* Summera f|r uppb|rdsdeklaration */
{
	uppd01 += brutto;
	uppd02 += data[BIL];
	uppd11 += data[SKATT];
	if (manad == 3)
		uppd12 += kvarsk;	/* Accumuklerad kvarskat */
}
/**/
mknyacc()		/* tillverka ny accfil */
{
	struct accdata	*ap = acc;

	while (ap->namnkod[0] != '\0') {	/* Kvar i tabellen */
		fprintf(nyaccfp, "%s %-0.0f %-0.0f %-0.0f\n", ap->namnkod,
					ap->acclon, ap->accskatt, ap->acckvar);

		ap++;
	}
}
