/*
Moddar:
	Mon Nov 24 15:17:02 1986	Kundreg i /z/ind/f/p/kundreg

*/
/**/
#include <stdio.h>

#define KUNDREG		"/z/ind/f/p/kundreg"

#define	TRUE		1
#define	FALSE		0
#define TABS		8

#define	SMALL		30
#define MAXL		300
#define LINES		72
#define COLS		75

#define	L		0
#define	R		1
/**/
#define	MPOSIN		40
#define	EPOSIN		48
#define	APOSIN		56

#define	ARTOUT		1
#define	MPOSOUT		55
#define	EPOSOUT		65
#define	APOSOUT		72

#define	LART		29
#define LARTMAX		55

#define	FNL		6
#define	FNC		70
#define	DAL		6
#define	DAC		70
#define LAL		11
#define LAC		1
#define	KUL		11
#define	KUC		38
#define	VRL		20
#define	VRC		1
#define	ERL		23
#define	ERC		1
#define	LTL		20
#define	LTC		20
#define	GML		20
#define	GMC		32
#define	BVL		20
#define	BVC		54
#define	ORL		23
#define	ORC		20
#define	TRL		23
#define	TRC		32
#define	LVL		23
#define	LVC		54
#define	LAL		11
#define	LAC		1
/**/
char	line[MAXL], workl[MAXL];
char	immage[LINES * COLS];

int	artline;		/* n{sta rad f|r ariklar */
int	eng;			/* falgga f|r engelsk text */

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();
	char	*instr();

	if (argc == 1)
		mkimmage(stdin);

	else
		while (--argc > 0) {
			if ((fp = fopen(*++argv,"r")) == NULL) 
				fprintf(stderr,"fakt: cannot open %s\n",*argv);

			else 
				mkimmage(fp);
		}
}
/**/
mkimmage(fp)
FILE	*fp;
{
	char		*p, *instr();
	register int	i;

	for (p = immage, i = 1; i <= (LINES * COLS); p++, i++)
		*p = ' ';

	artline = LART;
	eng = FALSE;

	while ((fgets(line, MAXL, fp)) != NULL) {
		*(line + strlen(line) - 1) = '\0';

		if (instr(line, "(") == line)
			continue;

		else if (instr(line, ".FN") == line) 
			continue;

		else if (instr(line, ".DA") == line) 
			mk(line, DAL, DAC, R);		/* datum */

		else if (instr(line, ".KU") == line) 
			mkku(line);			/* kundnummer */

		else if (instr(line, ".VR") == line) 
			mk(line, VRL, VRC, L);		/* v}r ref */

		else if (instr(line, ".ER") == line) 
			mk(line, ERL, ERC, L);		/* er ref */

		else if (instr(line, ".LT") == line) 
			mk(line, LTL, LTC, L);		/* levtid */

		else if (instr(line, ".GM") == line) 
			mk(line, GML, GMC, L);		/* godsm{rke */

		else if (instr(line, ".BV") == line) 
			continue;

		else if (instr(line, ".OR") == line) 
			mk(line, ORL, ORC, L);		/* ordernummer */

		else if (instr(line, ".TR") == line) 
			mk(line, TRL, TRC, L);		/* transports{tt */

		else if (instr(line, ".LV") == line) 
			mk(line, LVL, LVC, L);		/* levvillkor */

		else if (instr(line, ".LA") == line) 
			mkla(line);			/* levadress */

		else if (instr(line, ".FT") == line) 
			continue;			/* fri text */

		else if (instr(line, ".EN") == line) 
			eng = TRUE;			/* engelsk text */

		else
			decode(line);			/* artikelrad */
	}

	mktxt();
	outimmage();
}
/**/
mk(str, li, co, a)
char	*str;		/* str{ng */
int	li;		/* rad */
int	co;		/* kolumn */
int	a;		/* justrering, L=v{, annars =h| */
{
	char	*strins();

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	strins(immage, cur(li, co), str, a);
}
/**/
mkku(str)
char	*str;
{
#define	OUTADDR		0
#define INADDR		1
#define INNO		3

	FILE	*kfp;
	int	kul = KUL;
	int	state;

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	if ((kfp = fopen(KUNDREG, "r")) == NULL) {
		fprintf(stderr, "kunderna f|rsvunna\n");
		exit(1);
	}

	state = OUTADDR;

	while (fgets(workl, MAXL, kfp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		if (state == INADDR)
			if (*workl == '<')
				break;

			else {
				strins(immage, cur(kul, KUC), workl, L);
				kul++;
			}

		else if (*workl == '<')
			state = INNO;

		else if (state = INNO)
			if (strcmp(str, workl) == 0) 
				state = INADDR;

			else
				state = OUTADDR;
	}

	fclose(kfp);
}
/**/
mkla(str)
char	*str;
{
	int	lal = LAL;
	int	inline = TRUE;
	char	*p;

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	strins(immage, cur(LAL - 2, LAC), "Leveransadress:", L);
	while (inline) {
		for (p = workl; *str != '<'; p++, str++) {
			if (*str == '\0') {
				inline = FALSE;
				break;
			}

			*p = *str;
		}

		*p = '\0';
		strins(immage, cur(lal, LAC), workl, L);
		lal++;
		str++;
	}
}
/**/
mktxt()
{
	strins(immage, cur(3, 1), "\33CIN DEVELOPMENT AB\33Z", L);
	strins(immage, cur(4, 1), "Box 2066", L);
	strins(immage, cur(6, 1), "175 02  J[RF[LLA", L);
	strins(immage, cur(3, 31), "\33CF\\LJESEDEL\33Z", L);

	strins(immage, cur(5, DAC), "Leveransdatum", R);

	strins(immage, cur(26, ARTOUT), "Ben{mning", L);
	strins(immage, cur(26, MPOSOUT), "M{ngd", R);
	strins(immage, cur(26, EPOSOUT), "Enh", L);

	strins(immage, cur(61, 45), "Kvitteras:", L);
	strins(immage, cur(63, 45), "_________________________", L);
	strins(immage, cur(66, 1), "Telefon 0758 - 520 25", L);
}
/**/
decode(str)
char	*str;
{
	char	*strins();
	int	i;

	detab(str, workl);
	str = workl;
	for (i = 0; *str != '\0'; i++, str++)
		;

	for (; i <= EPOSIN + 10; i++, str++)
		*str = ' ';

	str = workl;

	*(str + MPOSIN - 1) = '\0';
	*(str + EPOSIN - 1) = '\0';
	*(str + APOSIN - 1) = '\0';

	strins(immage, cur(artline, ARTOUT), str, L);

	if (*(str + MPOSIN) != ' ') 
		strins(immage, cur(artline, MPOSOUT), str + MPOSIN, R);

	if (*(str + EPOSIN) != ' ')
		strins(immage, cur(artline, EPOSOUT), str + EPOSIN, L);

	if (artline < LARTMAX)
		artline++;
}
/**/
outimmage()
{
	char	*p;
	int	i, j;

	for (i = 0; i < LINES; i++)
		for (j = COLS - 1; j >= 0; j--) {
			p = immage + j + i * COLS;
			if ( *p == ' ')
				*p = '\0';

			else
				break;
		}

	for (i = 0; i < LINES; i++)
		puts(immage + i * COLS);
}
/**/
detab(l, ut)
char	*l;
char	*ut;
{
	register int	cnt;

	cnt = 0;

	while (*l != '\0' ) {
		if (cnt == TABS)
			cnt = 0;

		if (*l == '\n') {
			cnt = 0;
			*ut++ = *l++;
		}

		else if (*l == '\t') {
			while (cnt++ < TABS)
				*ut++ = ' ';

			cnt = 0;
			l++;
		}

		else {
			*ut++ = *l++;
			cnt++;
		}
	}

	*ut = '\0';
}
/**/
/***************************************************************************
*
*  Strins:	String insert. S{tter in str{ngen part i str{ngen base
*		p} pos. Om a = L sker v{nsterjustering, annars h|ger.
*
*		Returnerar en pointer till det sist insatta tecknet + 1.
*
***************************************************************************/

char	*
strins(base, pos, part, a)
register char	*base, *part;
register int	pos;
int		a;
{
	int	i;

	if (a == L)
		base += pos;

	else {
		for (i = strlen(part) - 1; *(part + i) == ' ' && i >= 0; i--)
			*(part + i) = '\0';

		base += (pos - strlen(part) + 1);
	}

	for (; *part != '\0'; part++, base++)
		*base = *part;

	return(base + 1);
}
/**/
cur(li, col)
int	li;
int	col;
{
	return((li - 1) * COLS + col - 1);
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
