.fo 'BU-MPLN-Z8K-ZUS2.2-2.01a'%'9/30/83'
.sp 4
.ce 10
.ul
ZEUS MULTIPLAN VERSION 2.01a
.ul
.sp 1
.ul
INSTALLATION NOTES
.sp 2
.ce 0
Please read the instructions detailed under FIRST-TIME INSTALLATION,
below,
if this version of Multiplan is 
to be the first one installed on your system.
If you have already installed an earlier version of Multiplan,
please read the instructions detailed under 
UPGRADING MULTIPLAN.
.np 
.ul
FIRST-TIME INSTALLATION
.sp 1
Multiplan distribution media is in tar(1) format on media that is appropriate
to target hardware. 
To install Multiplan,
you must be superuser.
Make a directory onto which Multiplan distribution will be
temporarily installed.
Then cd(1) to that directory. 
For example:
.sp 1
.in +4
mkdir /tmp/mpln <cr>
.br
cd /tmp/mpln <cr>
.in -4
.sp 1
Next, 
mount distribution media on an appropriate secondary storage device
(e.g. tape or floppy  drive)
and,
using the tar(1) command,
extract distribution contents to the directory just created.
For example:
.sp 1
.in +4
tar xvf [floppy or tape device name] <cr>
.sp 1
.in -4
When using the tar(1) command 
you may need to specify a blocking factor.
See the media label for the correct blocking factor
and the tar(1) command summary for usage.
.sp 1
Next, examine the supplied 'install' file
extracted from distribution media and now resident on the temporary directory.
This is an executable text file
(shell script) that installs Multiplan software modules
into their appropriate directories.
When invoked, 
\'install' (an executable shell script) may overwrite files that 
already exist.  
If this is the case, backup those files that 'install' will
overwrite.  
.sp 1
Make sure that the following directories exist on your system:
.sp 1
.in +4
/usr/bin
.br
/usr/lib/mp
.in -4
.sp 1
.ne 7
If either of the above two directories does not exist,
create it:
.sp 1
.in +4
mkdir /usr/bin <cr>
.br
chmod 755 /usr/bin <cr>
.br
mkdir /usr/lib/mp <cr>
.br
chmod 775 /usr/lib/mp <cr>
.in -4
.ne 5
.sp 1
Next,
determine if your system has a 'termcap' file named /etc/termcap.
If your system does not have a 'termcap' file,
copy the supplied 'termcap' to the directory /etc:  
.sp 1
.in +4
cp lib/termcap /etc/termcap <cr>
.in -4
.sp 1
The /etc/termcap file is required by Multiplan. 
It contains
descriptions of video terminals and their configuration parameters.
If your system already has a termcap file,
do not copy the supplied 'termcap' file 
unless it can be determined that your existing version 
is archaic or fails to work.
In this case,
refer to /ETC/TERMCAP CAPABILITIES,
below.
.sp
Now run the supplied 'install' file.
This moves the distribution contents to their required  
places in the file system heirarchy, completing installation:
.sp 1
.in +4
install <cr>
.sp 1
.in -4
To run Multiplan, invoke the command 'MP'.  The Multiplan worksheet
will then fill the screen.  Proceed as documented in Part One of the Multiplan 
user's manual.
.sp 1
If Multiplan does not work correctly on your terminal,
make sure that 
the shell environment variables 'TERM' and 'TERMCAP'
are correctly defined. 
These must reflect the type of terminal being used and
the 'termcap' database of terminal descriptions being referenced.
See /ETC/TERMCAP CAPABILITIES, below.
If 'TERM' and 'TERMCAP' are correct and Multiplan still fails,
you may have to rebuild Multiplan.
In this case,
read the REQUIRED TTY(4) DRIVER CAPABILITIES section, below,
for details.
.np
.ul
UPGRADING MULTIPLAN
.sp 1
The following instructions assume that you have already
installed an earlier version of Multiplan.
If the version of Multiplan supplied with this document is 
the first to be installed on
your system,
please read FIRST-TIME INSTALLATION, above.
.sp 1
.ne 4
Multiplan distribution media is in tar(1) format on media that is appropriate
to target hardware. 
To install Multiplan,
you must be superuser.
Make a directory onto which Multiplan distribution will be
temporarily installed.
Then cd(1) to that directory. 
For example:
.sp 1
.in +4
mkdir /tmp/mpln <cr>
.br
cd /tmp/mpln <cr>
.in -4
.sp 1
Next, 
mount distribution media on an appropriate secondary storage device
(e.g. tape or floppy  drive)
and,
using the tar(1) command,
extract distribution contents to the directory just created.
For example:
.sp 1
.in +4
tar xvf [floppy or tape device name] <cr>
.sp 1
.in -4
When using the tar(1) command 
you may need to specify a blocking factor.
See the media label for the correct blocking factor
and the tar(1) command summary for usage.
.sp 1
Make sure that the following directories exist on your system:
.sp 1
.in +4
/usr/bin
.br
/usr/lib/mp
.in -4
.sp 1
.ne 7
If either of the above two directories does not exist,
create it:
.sp 1
.in +4
mkdir /usr/bin <cr>
.br
chmod 755 /usr/bin <cr>
.br
mkdir /usr/lib/mp <cr>
.br
chmod 775 /usr/lib/mp <cr>
.in -4
.ne 5
.sp 1
.ne 8
Next,
determine if your system has a 'termcap' file named /etc/termcap.
If your system does not have a 'termcap' file,
copy the supplied 'lib/termcap' to the directory /etc:  
.sp 1
.in +4
cp lib/termcap /etc/termcap <cr>
.in -4
.sp 1
The /etc/termcap file is required by Multiplan. 
It contains
descriptions of video terminals and their configuration parameters.
If your system already has a termcap file,
do not copy the supplied 'termcap' file 
unless it can be determined that your existing version 
is archaic or fails to work.
In this case,
refer to /ETC/TERMCAP CAPABILITIES,
below.
.sp 1
Next, you may wish to preserve your existing version of Multiplan.
The exact command to use will depend on the version number of
the older copy.
If you are replacing version 1.02 or 1.02PR,
execute the following command as superuser:
.sp 1
.in +4
mv /usr/bin/MP /usr/bin/MP-1.02
.in -4
.sp 1
This will make your older version available through
the command 'MP-1.02'.
Now run 'install' as superuser:
.sp 1
.in +4
install <cr>
.sp 1
.in -4
Next, invoke the command 'MP' to run Multiplan.  
The Multiplan worksheet
will then fill the screen.
Proceed as documented in Part One of
.ul
the Multiplan User's Manual.
.sp 1
If Multiplan does not work correctly on your terminal,
check to be sure that 
the shell environment variables 'TERM' and 'TERMCAP'
are correctly defined. 
These must reflect the type of terminal being used and
the 'termcap' database of terminal descriptions being referenced.
See /ETC/TERMCAP CAPABILITIES, below. 
If 'TERM' and 'TERMCAP' are correct and Multiplan still fails,
you may have to rebuild Multiplan.
In this case,
read the REQUIRED TTY(4) DRIVER CAPABILITIES section below.
.sp
.np
.ul
MULTIPLAN ENVIRONMENT
.sp
In order to ensure that the maximum data space
is available to Multiplan users, Multiplan is
envoked through a small program named 'mpstart'.
This program's function is to execute the Multiplan
system, after stripping all unnecessary data from
the user's environment.
Mpstart will preserve some vital environment variables:
.sp
.in +4
MPLIB        - Multiplan library directory
               (default = /usr/lib/mp)
.br
TERM         - terminal type name
.br
PATH         - command execution directory list
.br
TZ           - local timezone
.in -4
.sp
Mpstart will NOT preserve the TERMCAP variable,
unless it is a file name beginning with '/'.
This allows the user to override the default location
of the terminal capabilities database,
normally '/etc/termcap'.

In the file MP there is included an evironmental variable LPR 
which is used to denote the pathname of the line printer
spooler. If this variable is undefined, then Multiplan
assumes that the line printer spooler is to be found in
the file /usr/bin/lpr. Since /usr/bin/lpr is not the
name used by Zeus, LPR has been set to /usr/bin/nq.
.sp
.ne 15
.np
.ul
SPREADSHEETS CREATED USING OLDER VERSIONS
.sp
The spreadsheets created by version 2.01a
are fully compatible with version 1.02/1.02PR.
Spreadsheets created by version 1.10 are
incompatible with version 2.01a,
when saved using 'normal' format.
Conversion of version 1.10 sheets may be
accomplished through the use of the 'symbolic'
save format.
This is accessed through the T(ransfer) O(ptions)
and T(ransfer) S(ave) commands in Multiplan,
while using the older version MP-1.10.
The procedure is first to load the sheet using Transfer Load,
set up for symbolic format using Transfer Options Symbolic,
and to resave the (now symbolic format) sheet using Transfer Save.
The symbolic format sheet is compatible with version 2.01a;
if a normal format sheet is desired,
the above procedure may be followed in reverse.
.sp 1
.np
.ul
/ETC/TERMCAP CAPABILITIES
.sp
In order for Multiplan to work, the terminal from which Multiplan is
invoked must be recognized by the operating system.  The user's shell
environment variable TERM must equal the ttytype code associated with
the terminal's description in /etc/termcap 
(the system's terminal configuration database).
.sp
.ne 10
The following cursor-addressable functions must be defined 
for the terminal being used 
(in the terminal's /etc/termcap description).
No other termcap fields are necessary.
.sp 1
.nf
.in +4
cm	 - cursor motion (direct addressing)
cl	 - clear screen
up	 - cursor up one line
bc or bs - cursor left or backspace with ctrl-H
.fi
.in -4
.sp 1
.ne 12
If the terminal's termcap entry lacks any of the above entries,
Multiplan will fail and print an error message on the user's screen.
.sp 1
In addition, it is highly recommended that the 'so' and 'se',
or standout and standout end capabilities, be defined.
The highlighting or underline features used by these capabilities
are used by Multiplan to implement multiple screen cursors.
.np
.ul
REQUIRED TTY(4) DRIVER CAPABILITIES
.sp 1
The Multiplan interpreter executable binary 'lib/inter-2.01a' 
has been complied for a Zilog System 8000 
running ZEUS version 2.2 
and may not work if your terminal driver differs
from the standard ZEUS 2.2 driver.  
If your terminal driver is different,
you must re-write the 
terminal-dependent elements of Multiplan 
(abstracted into a module called 'term')
and re-link this into the Multiplan interpreter.
.sp 1
Terminal dependent elements of Multiplan
have been abstracted into a module called 'term'.
This module can be modified as necessary 
to work on a system with a non-standard terminal driver.
C source code for the ZEUS 2.2 edition of 'term' is included
with Multiplan distribution.
See the documentation of 'term' in the file 'doc/term.man'  
for details of 'term' implementation.
.sp 1
Before modifing or writing your own version of the terminal module, 
be sure to make backup copies of 
the files 'obj/term.c' and 'obj/term.h'.  
Make certain that the file '/etc/termcap' exists.
If 'etc/termcap' does not exist,
copy the supplied 'termcap' to '/etc/termcap'.
Also, make certain that
the environment variable 'TERM'
is properly defined 
(and export'ed, if you are using the Bourne shell '/bin/sh'), 
and that the
terminal so specified is among those described in '/etc/termcap'.
.sp 1
Once you have written an appropriate terminal module 'term', 
run the 'build' shell script to
rebuild the Multiplan interperter.
Subsequent invocation of the 'install' shell script
will then install Multiplan.
.sp 1
If you write a non-standard terminal module,
please contact us at the address or phone number below;
other users of Multiplan may be able to benefit from
your successful efforts. 
.sp 1
.in +8
.nf
The Santa Cruz Operation, Inc.
500 Chestnut Street
Santa Cruz, CA 95060
(408) 425 - 7222
.fi
