/*
 * System-independent terminal mode control
 *
 * NOTE:  The various manisfest constants contained within should not have
 *	their values changed without due consideration of the consequences!
 *	(Remember, relocatable binaries assuming these values must work on
 *	all systems.)  Hence, it is Ok to assume these values in the code
 *	(eg: array indicies).
 */

extern int setterm();
extern int tstterm();

/*
 * setterm() actions
 */
#define	TM_SET		0	/* if possible, set this mode	*/
#define TM_CLEAR	1	/* reset this mode		*/
#define TM_SAVE		2	/* preserve tty state           */
#define TM_RESTORE	3	/* restore saved tty state      */

/*
 * Defined terminal modes
 */
#define TM_RAW		0	/* no buffering, no interrupts or quits  */
#define TM_CBREAK	1	/* no buffering, but interrupts & quits  */
#define TM_ECHO		2	/* echo back input			 */
#define TM_CRMOD	3	/* input: CR -> LF	output: LF -> CR */
#define TM_XTABS	4	/* on output, tabs -> appropriate spaces */
#define TM_LCASE	5	/* map a -> A, \a -> a                   */

#define TM_NUMMODES	6	/* number of ``portable'' modes known	 */

