;
;	SYSTEM PARAMETERS.
;
;	HERE THE CONFIGURER ESTABLISHES THE QUANTITIES, AND IN SOME CASES THE
;	POSITIONS, OF VARIOUS MTOS ENTITIES. MANY OF THESE DEFINITIONS ARE
;	REQUIRED TO MATCH SUBSEQUENT DEFINITIONS IN SOME STRAIGHTFORWARD WAY.
;	NOTE THAT THOSE CHANGES FOR THE IBM-PC HAVE BEEN MADE.
;
X_NUM_CPUS	EQU	1	;MUST NEVER BE CHANGED!!!
X_STATIC_TASKS	EQU	2	;NUMBER OF STATIC TASKS (0 TO 4095)
X_INIT_ID	EQU	0	;ID OF STARTUP TASK (0 TO X_STATIC_TASKS-1)
X_OVERLAYS_NUM	EQU	1	;NUMBER OF OVERLAY REGIONS IN SYSTEM.
X_8087_NUM	EQU	1	;NUMBER OF 8087-USING TASKS (0 TO 4095)
X_DRIVER_NUM	EQU	1	;NUMBER OF DEVICE DRIVERS (0 TO 255)
X_UNIT_NUM	EQU	1	;NUMBER OF DRIVER UNITS (0 TO 65025)
X_DISCRETE_NUM	EQU	1	;NUMBER OF DISCRETES' BYTES (0 TO 8192)
X_MEM_POOL_NUM	EQU	1	;NUMBER OF MTOS MEMORY POOLS (0 TO 32)
X_MAILBOX_NUM	EQU	1	;NUMBER OF MAILBOX EXCHANGES (0 TO 255)
X_GEF_NUM	EQU	1	;NUMBER OF GLOBAL EVENT FLAG GROUPS (0 TO 31)
X_SEMA_NUM	EQU	1	;NUMBER OF SEMAPHORES (0 TO 4095)
X_CONTROL_NUM	EQU	1	;NUMBER OF CONTROLLED PROGRAMS (0 TO 255)
X_VECTORS_NUM	EQU	8	;NUMBER OF NONDEVICE INTERRUPT VECTORS
X_SRB_NUM	EQU	32	;NUMBER OF SCHEDULER REQUEST BLOCKS (16 UP)
X_SMR_NUM	EQU	256	;NUMBER OF BLOCKS IN THE SYSTEM MEMORY RESOURCE
				;(16 UP)
X_SVC_VECTOR	EQU	186	;NUMBER OF THE LOWER SVC INTERRUPT VECTOR (THE
				;HIGHER IS ASSUMED TO BE X_SVC_VECTOR+1)
X_SYS_DEV	EQU	0	;SYSTEM CONSOLE= DEVICE DRIVER #0,
X_SYS_UNIT	EQU	0	;SYSTEM CONSOLE= DRIVER UNIT #0.
X_NETMGR_TASK	EQU	-1	;DECLARE NO NETWORK MANAGER TASK.
X_LOADER_TASK	EQU	-1	;DECLARE NO LOADER TASK.
X_ERRLOG_TASK	EQU	-1	;DECLARE NO ERROR LOG TASK.
X_MP_INIT	EQU	0	;MUST NEVER BE CHANGED!!!!!
X_RR_TICKS	EQU	10	;NUMBER OF TICKS PER ROUND-ROBIN INTERVAL.
X_MIN_MEM	EQU	3		;MINIMUM MEMORY NEEDED TO DISPATCH A
					;REQUEST FOR A MEMORY-USING SERVICE.
X_TASK_NUM	EQU	X_STATIC_TASKS+X_SMR_NUM	;POSSIBLE HIGHEST TASK
					;NUMBER, ALLOWING FOR DYNAMIC
					;TCB CREATION FROM SMR.
