;*****************************************************************
;*     MTOS-86xx V3.0:   COMPILE/ASSEMBLE DIAGNOSTIC.            *
;*     F. W. PORRETTO, DECEMBER 3, 1982                          *
;*     FOR INDUSTRIAL PROGRAMMING, INC.                          *
;*****************************************************************
;
;      THIS PROCEDURE COMPILES THE MANY FILES OF THE DIAGNOSTIC PACKAGE,
;      FOR THE PRODUCTION OF OBJECT MODULES TO BE USED BY THE DLIB.CSD
;      PROCEDURE, AND OPTIONALLY FOR THE GENERATION OF LISTINGS. ALL THE
;      MODULES OF THE DIAGNOSTIC MUST BE COMPILED OR ASSEMBLED EXCEPT
;      DIAG86.LIT, WHICH IS AN $INCLUDE FILE.
;
;      INPUT:  %0 SPECIFIES THE RESIDENCE DEVICE OF THE DIAGNOSTIC SOURCE FILES
;              %1 SPECIFIES THE DESTINATION DEVICE FOR THE OBJECT MODULES,
;              %2 SPECIFIES THE DESTINATION FOR THE LISTING FILES.
;      OUTPUT: THE OBJECTS AND LISTINGS FOR THE WHOLE DIAGNOSTIC.
;
;      FOR REFERENCE PURPOSES, THE DIAGNOSTIC MODULES ARE:
;
;      MODULE        CONTENTS
;      ------        --------
;      DIAG86.LIT    LITERALS FOR THE PL/M PARTS OF THE DIAGNOSTIC.
;      DASMUT.ASM    ASSEMBLY LANGUAGE SUPPORT FOR THE PL/M MODULES.
;      DCLOCK.PLM    WALL-CLOCK TESTS.
;      DCP.PLM       CONTROLLED-PROGRAM TESTS.
;      DFLAG.PLM     EVENT FLAG TESTS.
;      DHUMIN.PLM    DIAGNOSTIC OPERATOR INTERFACE PROCEDURES.
;      DINOUT.PLM    DEVICE DRIVER INTERFACE AND CONSOLE DRIVER TESTS.
;      DINRES.PLM    PROCEDURES TO INITIALIZE AND RESET THE DIAGNOSTIC.
;      DMAIL.PLM     MAILBOX TESTS.
;      DMAIN.PLM     DIAGNOSTIC MAIN PROCEDURE, THE "ROOT TASK."
;      DMEM.PLM      MEMORY POOL TESTS.
;      DMSG.PLM      DIAGNOSTIC-TO-OPERATOR MESSAGES.
;      DPLMUT.PLM    PL/M UTILITY PROCEDURES.
;      DSEMA.PLM     SEMAPHORE TESTS.
;      DSPEC.PLM     MISCELLANEOUS SPECIAL TESTS (E.G., OVERLOAD RECOVERY).
;      DTASK.PLM     TASK-TO-TASK COORDINATION TESTS.
;      DTCDS.PLM     TCDS FOR THE 18 TASKS CREATED BY THE ROOT TASK.
;      DTESTS.PLM    PROCEDURE WHICH SEQUENCES THE TEST SUBSECTIONS.
;      DTGT.PLM      TARGET TASKS USED BY VARIOUS TESTS.
;      DTIME.PLM     ELAPSED-TIME MEASUREMENT TESTS.
;
PLM86 %0DCLOCK.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DCLOCK.OBJ)
PLM86 %0DCP.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DCP.OBJ)
PLM86 %0DFLAG.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DFLAG.OBJ)
PLM86 %0DHUMIN.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DHUMIN.OBJ)
PLM86 %0DINOUT.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DINOUT.OBJ)
PLM86 %0DINRES.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DINRES.OBJ)
PLM86 %0DMAIL.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DMAIL.OBJ)
PLM86 %0DMAIN.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DMAIN.OBJ)
PLM86 %0DMEM.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DMEM.OBJ)
PLM86 %0DMSG.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DMSG.OBJ)
PLM86 %0DPLMUT.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DPLMUT.OBJ)
PLM86 %0DSEMA.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DSEMA.OBJ)
PLM86 %0DSPEC.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DSPEC.OBJ)
PLM86 %0DTASK.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DTASK.OBJ)
PLM86 %0DTCDS.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DTCDS.OBJ)
PLM86 %0DTESTS.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DTESTS.OBJ)
PLM86 %0DTGT.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DTGT.OBJ)
PLM86 %0DTIME.PLM LARGE OPTIMIZE(2) DEBUG PRINT(%2) OBJECT(%1DTIME.OBJ)
ASM86 %0DASMUT.ASM OBJECT(%1DASMUT.OBJ) PRINT(%2)
;
;*****************************************************************
