PAGE	60,132
INCLUDE B:BIG.INC
;
;	EFLAGS.ASM:	EVENT FLAGS PROCESSING ROUTINES.
;	F. W. PORRETTO, 12/15/82.
;
;		HERE ARE COLLECTED ALL THE ROUTINES INVOLVED WITH THE PROVISION
;	OF THE FIVE EVENT FLAGS SERVICES, AND NUMEROUS OTHER CONNECTIONS TO
;	THE EVENT FLAG SYSTEM.
;
		NAME	EVENT_FLAG_PROCESSING
;
		PUBLIC	X_SEF,X_REF,X_TEF,X_SEFET,X_WEF
		PUBLIC	X_SET_EF,X_RESET_EF,X_TEST_EF
		PUBLIC	X_WAIT_EF,X_SETET_EF
;
MTOS_CS		SEGMENT PARA PUBLIC
		ASSUME	DS:MTOS_DS,CS:MTOS_CS,SS:MTOS_DS
		EXTRN	X_QUEUE		 :NEAR		;GENERAL QUEUE
		EXTRN	X_DQUEUE	 :NEAR		; HANDLING
		EXTRN	X_GET_SMR        :NEAR	        ;GET SMR BLOCK.
		EXTRN	X_PUT_SMR        :NEAR          ;FREE ONE SMR BLOCK.
		EXTRN	X_QUEUE_TMB	 :NEAR		;TIME QUEUE HANDLING
		EXTRN	X_DQUEUE_TMB	 :NEAR
		EXTRN	X_GET_INTERVAL	 :NEAR		;COMPUTE MSEC TIME
		EXTRN	X_SFLAGS	 :NEAR		;SET CONDITION CODES
		EXTRN	X_GET_TASK_ID    :NEAR		;GET TASK ID FOR TCB
		EXTRN	X_TASK_STATE	 :NEAR		;TASK STATUS SETTING
		EXTRN	X_SET_READY	 :NEAR		;TASK ONTO
							;READY TASK QUEUE
;
;	LOCAL EQUATES
;
GRP		EQU	01H		;SDB OFFSET TO GROUP 
FLAGS		EQU	02H
TME		EQU	04H		;TIME INTERVAL TYPE 
LEN		EQU	05H		;TIME UNITS OFFSET
TYP		EQU	01H		;TYPE OF TEST OPTION 
GRP_MASK	EQU	01FH		;MASK OFF GRP
TYP_MASK	EQU	080H		;ISOLATE TYP FIELD
TME_MASK	EQU	018H		;ISOLATE TME FIELD
PAGE
;*********************************************************************
;*          XFIND_EF:  FIND EVENT FLAG DATA                          *
;*********************************************************************
;
;	THIS PROCEDURE FINDS THE EVENT FLAG DATA IN THE TABLE
;	OF GLOBAL EVENT FLAGS IF THE GROUP ID > 0.  IT FINDS
;	THE DATA IN THE TABLE OF LOCAL EVENT FLAGS IF THE ID = 0.
;
;	INPUT:	DL=	GROUP ID
;		BX=	TCB ADDRESS, NEEDED IF GROUP ID IS ZERO
;	OUTPUT:	DI=	ADDRESS OF EVENT FLAG DATA
;
XFIND_EF	PROC	NEAR
		PUSH	DX			;SAVE REGISTERS
		XOR	DH,DH			;CLEAR DH
		TEST	DX,DX			;GROUP ID = 0 ?
		JNE	FINDGEF			;NO: GLOBAL GROUP.
		CALL	X_GET_TASK_ID		;YES: SET AX = TASK ID
		MOV	DX,EFG_SIZE
		MUL	DX  			;MULTIPLY ID X BYTES PER EFG
		ADD	AX,OFFSET X_LEF_TABLE	;ADD TABLE ADDRESS
		MOV	DI,AX			;RETURN ADDRESS IN DI
		POP	DX			;RESTORE REGISTERS
		RET
FINDGEF:
		MOV	AX,EFG_SIZE		;GLOBAL GROUP SPECIFIED:
		DEC	DX			;FIND ZEROTH ENTRY FOR
						;ID=1, ETC.
		MUL	DX			;MULTIPLY (ID-1) X 
						;BYTES PER EFG
		ADD	AX,OFFSET X_GEF_TABLE	;ADD TABLE ADDRESS
		MOV	DI,AX			;RETURN IN DI
		POP	DX			;RESTORE REGISTERS
		RET
XFIND_EF	ENDP
PAGE
;*************************************************************
;*         ELIM_TMBS: CANCEL ALL SUPERANNUATED TMBS          *
;*************************************************************
;
;	INPUT:	DL=	EF GROUP ID,
;		BX=	TCB ADDRESS,
;		CX=	MASK WORD.
;	OUTPUT:	NONE.
;
;		THIS ROUTINE SIMPLY SWEEPS THROUGH THE TIMER QUEUE FINDING
;	ALL TMBS FOR THE INDICATED EF GROUP, DEACTIVATING AND DEALLOCATING
;	ANY WHICH SHARE ONE OR MORE BITS WITH THE MASK WORD.
;
ELIM_TMBS	PROC	NEAR
		PUSH	DI
		PUSH	SI
		MOV	DI,OFFSET X_TMB_Q	;GET QUEUE HEAD.
ELIM0:
		MOV	SI,[DI]			;GET NEXT TMB ON QUEUE.
		TEST	SI,SI			;END OF QUEUE?
		JE	ELIM9			;YES.
		CMP	BYTE PTR [SI+TMB_TYPE],3	;NO: EF TIMER?
		JNE	ELIM5			;NO, DISCARD IT.
		TEST	DL,DL			;YES: ARE WE LOOKING FOR GRP 0?
		JNE	ELIM1			;NO, BYPASS TCB MATCHUP.
		CMP	BX,[SI+TMB_TCB]		;YES: TCBS MATCH?
		JNE	ELIM5			;NO, DISCARD IT.
ELIM1:
		CMP	DL,[SI+TMB_EFGRP]	;GROUP NUMBERS MATCH?
		JNE	ELIM5			;NO, DISCARD IT.
		MOV	AX,CX			;YES: MASK TO AX,
		AND	AX,[SI+TMB_EFMSK]	;CHECK FOR COMMON BITS:
		JE	ELIM5			;NONE.
		MOV	AX,[SI]			;ONE OR MORE: DETACH TMB
		MOV	[DI],AX			;FROM TIMER QUEUE.
		XCHG	BX,SI
		CALL	X_PUT_SMR		;DEALLOCATE THE TMB.
		XCHG	BX,SI
		JMP	SHORT ELIM0		;LOOK AT NEXT ONE.
ELIM5:
		MOV	DI,SI			;CURRENT BECOMES PREVIOUS,
		JMP	SHORT ELIM0		;AND LOOK AT NEXT ONE.
ELIM9:
		POP	SI
		POP	DI
		RET
ELIM_TMBS	ENDP
PAGE
;*********************************************************************
;*         XMATCH_EF:  TESTS FLAGS FOR MATCH                         *
;*********************************************************************
;
;	THIS PROCEDURE TESTS THE FLAGS TO SEE IF THEY
;	MATCH THE CONDITIONS.
;
;	INPUT:	DH=	TYPE OF TEST (0 FOR 'AND', 1 FOR 'OR').
;		CX=	MASK
;		AX=	FLAGS
;	OUTPUT:	CARRY=	1 FOR MATCH
;		     =	0 FOR NO MATCH
;
XMATCH_EF	PROC	NEAR
		TEST	DH,DH			;AND/OR TEST ?
		JE	MATCHALL		;AND TEST.
MATCHONE:
		AND	AX,CX			;OR TEST: PERFORM MASK OPERA-
		TEST	AX,AX			;TION: ZERO RESULT?
		JE	ONERET			;IF SO, TEST FAILS.
		STC				;IF NOT, TEST SUCCEEDS.
ONERET:
		RET
MATCHALL:
		AND	AX,CX		;AND TEST: PERFORM MASK OPERATION.
		CMP	AX,CX		;DOES MASK MATCH RESULT?
		CLC			;(CLEAR CARRY IN CASE IT DIDN'T)
		JNE	ALLRET		;IF NOT, TEST FAILS.
		STC			;ELSE, TEST SUCCEEDS.
ALLRET:
		RET
XMATCH_EF	ENDP
PAGE
;*********************************************************************
;*              X_SET_EF:  "INNER" SET EVENT FLAGS                   *
;*********************************************************************
;
;	THIS PROCEDURE SETS THE FLAGS, ACTIVATES THE TASKS
;	WHOSE WAIT CONDITIONS ARE SATISFIED AND PREPARES THE
;	SVC STATUS. OTHER SYSTEM FUNCTIONS CAN USE THIS
;	PROCEDURE SINCE NO SDB IS REQUIRED.  ALL THE PARAMETERS
;	ARE PASSED IN REGISTERS.
;
;	INPUT:	DL=	GROUP ID
;		CX=	FLAGS
;		BX=	TCB ADDRESS, NEEDED IF GROUP ID IS ZERO
;	OUTPUT:	AX=	SVC STATUS
;
X_SET_EF	PROC	NEAR
		XOR	AX,AX		;** SPEED KLUDGE: ASSUME NO CHANGE **
		JCXZ	SET_RET		;** IF CX=0, CHANGE IMPOSSIBLE!    **
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	SI
		PUSH	DI
		CALL	XFIND_EF		;LOCATE THE RIGHT GROUP.
		MOV	AX,[DI+EFG_FLAGS]	;GET CURRENT STATE OF FLAGS,
		OR	[DI+EFG_FLAGS],CX	;OR IN THE MASK.
		SUB	AX,[DI+EFG_FLAGS]	;WAS THERE A CHANGE?
		JE	NO_CHANGE		;NO.
;
;	IF ANY FLAG IN THE GROUP HAS CHANGED, WE MUST EXAMINE ANY EWBS ON THE
;	GROUP WAIT QUEUE TO SEE IF THEIR TEST CONDITIONS HAVE JUST BEEN MET.
;	THOSE WHICH ARE NOW SATISFIED MUST NOW BE RELEASED.
;
		MOV	AX,[DI+EFG_FLAGS]	;MOVE FLAG VALUES TO AX.
		ADD	DI,EFG_WAIT		;ADDRESS WAIT QUEUE.
ST0:
		MOV	SI,[DI]			;GET NEXT EWB,
		TEST	SI,SI			;IF ANY...
		JE	ST9			;NONE, WE'RE DONE.
		PUSH	AX			;GOT ONE:
		MOV	DH,[SI+EWB_TYPE]	;GET TEST TYPE,
		MOV	CX,[SI+EWB_MASK]	;GET TEST MASK,
		CALL	XMATCH_EF		;TRY IT OUT...
		POP	AX			;RESTORE FLAG GROUP VALUE
		JC	ST1			;MATCH: PULL EWB LOOSE!
		MOV	DI,SI			;NO: CURRENT BECOMES PREVIOUS,
		JMP	SHORT ST0		;AND LOOK AT NEXT ONE.
ST1:
		PUSH	AX			;YES: SAVE FLAG GROUP AGAIN,
		MOV	BX,[SI+EWB_TCB]		;GET WAITING TASK'S TCB,
		CALL	X_SET_READY		;SET HIM READY AGAIN,
		MOV	BX,[SI]			;GET FORWARD LINK TO NEXT EWB,
		MOV	[DI],BX			;REMOVE EWB FROM QUEUE,
		MOV	BX,SI			;AND FINALLY,
		CALL	X_PUT_SMR		;DEALLOCATE EWB.
		POP	AX			;GET GROUP VALUE AGAIN,
		JMP	SHORT ST0		;AND CHASE THE QUEUE.
ST9:
		MOV	AX,FLAG_CF		;SET SVC RETURN STATUS,
NO_CHANGE:
		POP	DI
		POP	SI
		POP	DX
		POP	CX
		POP	BX
SET_RET:
		RET
X_SET_EF	ENDP
PAGE
;*********************************************************************
;*         X_RESET_EF:  "INNER" RESET EVENT FLAGS                    *
;*********************************************************************
;
;	THIS PROCEDURE RESETS THE FLAGS AND SETS THE STATUS.
;	OTHER SYSTEM FUNCTIONS CAN CALL THIS PROCEDURE SINCE
;	NO SDB IS REQUIRED.  ALL THE PARAMETERS ARE PASSED IN
;	REGISTERS.
;
;	INPUT:	DL=	GROUP ID
;		CX=	FLAGS
;		BX=	TCB ADDRESS, NEEDED IF GROUP ID IS ZERO
;
X_RESET_EF	PROC	NEAR
		XOR	AX,AX		;** SPEED KLUDGE: ASSUME NO CHANGE **
		JCXZ	RS_RET		;** IF CX=0, CHANGE IMPOSSIBLE!    **
		PUSH	CX			;SAVE REGISTERS
		PUSH	DX
		PUSH	DI
		CALL	XFIND_EF		;FIND THE EF
		MOV	AX,[DI+EFG_FLAGS]	;GET FLAGS
		NOT	CX
		AND	[DI+EFG_FLAGS],CX	;PERFORM RESET OPERATION.
		MOV	CX,[DI+EFG_FLAGS]	;FETCH RESULTS TO CX.
		PUSH	AX			;SAVE OLD STATE OF GROUP,
		POP	AX			;RETRIEVE OLD GROUP STATE.
		SUB	AX,CX			;ANY CHANGE IN GROUP?
		JE	RS_NO_CHANGE		;NO.
		MOV	AX,FLAG_CF		;YES.
RS_NO_CHANGE:
		POP	DI
		POP	DX			;RESTORE REGISTERS
		POP	CX
RS_RET:
		RET
X_RESET_EF	ENDP
PAGE
;*********************************************************************
;*         X_TEST_EF:  "INNER" TEST EVENT FLAGS                      *
;*********************************************************************
;
;	THIS PROCEDURE TESTS THE EVENT FLAG GROUP
;	AND PREPARES THE SVC STATUS.  OTHER SYSTEM
;	FUNCTIONS CAN CALL THIS PROCEDURE SINCE NO
;	SDB IS REQUIRED.  ALL THE PARAMETERS ARE
;	PASSED IN REGISTERS.
;
;	INPUT:	DL=	GROUP ID
;		CX=	FLAGS
;		BX=	TCB ADDRESS, NEEDED IF ID IS ZERO
;		DH=	TYPE:	1 FOR THE OR TEST
;		        	0 FOR THE AND TEST
;	OUTPUT:	AX=	SVC STATUS
;
X_TEST_EF	PROC	NEAR
		PUSH	DI
		CALL	XFIND_EF		;FIND THE EF
		MOV	AX,[DI+EFG_FLAGS]	;GET FLAGS
		CALL	XMATCH_EF		;TEST MATCH ?
		JNC	TESTFAIL		;NO MATCH: TEST FAILS.
		MOV	AX,FLAG_CF		;SET MATCH STATUS
		POP	DI
		RET
TESTFAIL:	XOR	AX,AX			;NO MATCH STATUS
		POP	DI
		RET
X_TEST_EF	ENDP
PAGE
;*********************************************************************
;*         X_WAIT_EF:  "INNER" WAIT FOR EVENT FLAG                   *
;*********************************************************************
;
;	THIS PROCEDURE CAUSES THE TASK TO WAIT IF THE TEST
;	CONDITIONS ARE NOT MATCHED AND PREPARES THE SVC STATUS.
;	ALTHOUGH ALL THE PARAMETERS ARE PASSED IN REGISTERS,
;	OTHER SYSTEM FUNCTIONS CAN NOT USE THIS FACILITY BECAUSE
;	THE WAIT BLOCKS MUST POINT TO A TASK.
;
;	INPUT:	DL=	GROUP ID
;		CX=	FLAGS
;		BX=	TCB ADDRESS, NEEDED IF ID IS ZERO
;		DH=	TYPE
;	OUTPUT:	AX=	SVC STATUS
;
X_WAIT_EF	PROC	NEAR
		PUSH	BX			;SAVE REGISTERS
		PUSH	SI
		PUSH	DI
		PUSH	DX			;SAVE THE GROUP NUMBER.
		CALL	XFIND_EF		;FIND EF
		MOV	AX,[DI+EFG_FLAGS]	;GET FLAGS
		CALL	XMATCH_EF		;TEST FOR MATCH NOW
		POP	DX			;RESTORE GROUP NUMBER.
		JNC	YESWAIT			;NO MATCH: BLOCK TASK.
NOWAIT:
		MOV	AX,FLAG_CF		;SET STATUS
		POP	DI
		POP	SI			;RESTORE REGISTERS
		POP	BX
		RET
YESWAIT:
		MOV	SI,BX			;SAVE TCB ADDR IN SI,
		CALL	X_GET_SMR		;ALLOCATE SMR FOR EWB,
		MOV	[BX+EWB_TCB],SI		;INSERT TCB ADDR INTO EWB,
		MOV	[BX+EWB_TYPE],DH	;INSERT TEST TYPE,
		MOV	[BX+EWB_MASK],CX	;INSERT TEST MASK.
		LEA	DI,[DI+EFG_WAIT]	;ADDRESS THE GROUP WAIT QUEUE
		CALL	X_QUEUE			;ATTACH EWB TO WAIT QUEUE
		MOV	BX,SI			;TASK TCB ADDR TO BX SO WE CAN
		MOV	AX,BLOCK+STA_EF		;BLOCK TASK FOR EF WAIT.
		CALL	X_TASK_STATE
		XOR	AX,AX			;SET STATUS
		POP	DI
		POP	SI
		POP	BX
		RET
X_WAIT_EF	ENDP
PAGE
;*********************************************************************
;*         X_SETET_EF:  "INNER" SET EF AFTER ELAPSED TIME            *
;*********************************************************************
;
;	THIS RESETS THE FLAGS, QUEUES A TMB AND PREPARES THE SVC STATUS.
;
;	INPUT:	DL=	GROUP ID
;		CX=	FLAGS
;		BX=	TCB ADDRESS, NEEDED IF GROUP ID IS ZERO
;		AL=	TME (SHIFTED LEFT TWO BITS)
;		AH=	LEN
;	OUTPUT:	AX=	SVC STATUS
;
X_SETET_EF	PROC	NEAR
		PUSH	BX
		PUSH	CX
		PUSH	DI
		PUSH	AX		;SAVE TIME DESCRIPTOR TEMPORARILY
		CALL	XFIND_EF	;LOCATE THE EFG.
		CALL	ELIM_TMBS	;ELIMINATE ALL RELEVANT TMBS,
		NOT	CX		;INVERT THE BIT MASK,
		AND	[DI+EFG_FLAGS],CX	;CLEAR THE FLAGS SPECIFIED,
		NOT	CX		;RETURN MASK TO ORIGINAL CONFIGURATION
		POP	AX		;RETRIEVE TIME SPECIFIER.
		TEST	AH,AH		;ZERO TIME SPECIFIED?
		JNZ	SETET0		;NO.
		POP	DI		;YES, NO MORE TO DO.
		POP	CX
		POP	BX
		XOR	AX,AX
		RET
SETET0:
		PUSH	DX		;SAVE GROUP ID TEMPORARILY.
		PUSH	CX		;LIKEWISE MASK AND
		PUSH	BX		;TCB ADDRESS.
		CALL	X_GET_INTERVAL	;MAKE MSEC INTERVAL IN CX,DX.
		CALL	X_GET_SMR	;ALLOCATE A BLOCK FOR TMB.
		MOV	[BX+TMB_TIME],CX	;INSERT MSEC INTERVAL
		MOV	[BX+TMB_TIME+2],DX	;INTO THE TMB.
		MOV	BYTE PTR [BX+TMB_TYPE],3	;TYPE= 3.
		POP	WORD PTR [BX+TMB_TCB]	;INSERT TCB ADDRESS,
		POP	WORD PTR [BX+TMB_EFMSK]	;FLAG GROUP BIT MASK.
		POP	DX		;RETRIEVE GROUP ID.
		MOV	[BX+TMB_EFGRP],DL	;INSERT THAT TOO.
		CALL	X_QUEUE_TMB	;ACTIVATE THE TIMER.
		POP	DI
		POP	CX
		POP	BX
		XOR	AX,AX
		RET
X_SETET_EF	ENDP
PAGE
;*********************************************************************
;*      X_SEF:      SET EVENT FLAGS SERVICE                          *
;*********************************************************************
;
;	THIS PROCEDURE VALIDATES THE SDB PARAMETERS, SETS THE
;	FLAGS AND PROCESSES THE WAIT QUEUE.  THEN IT RETURNS
;	STATUS TO THE TASK.
;
;	INPUT:	ES:SI=	SDB
;	        BX=	TCB
;	OUTPUT:	NONE
;
X_SEF		PROC 	FAR
		MOV	DL,BYTE PTR ES:[SI+GRP]		;GROUP ID
		AND	DX,GRP_MASK			;ISOLATE GROUP ID
		MOV	CX,ES:[SI+FLAGS]		;FLAGS TO SET
		CMP	DX,X_GEF_NUM			;VALID GROUP ID ?
		MOV	AX,SVC_FAILED+PARM_ERR		;PREPARE TO FAIL...
		JA 	SEF0				;--NO--
		CALL	X_SET_EF			;SET FLAGS, PROCESS
							;QUEUE AND PREPARE
							;STATUS
SEF0:
		CALL	X_SFLAGS			;RETURN STATUS
		RET
X_SEF		ENDP
PAGE
;***********************************************************************
;*      X_REF:   RESET EVENT FLAG SVC                                  *
;***********************************************************************
;
;	THIS PROCEDURE VALIDATES THE SDB PARAMETERS,
;	RESETS THE FLAGS, AND RETURNS THE SVC STATUS
;	TO THE TASK.
;
;	INPUT:	ES:SI=	SDB
;		BX=	TCB
;
X_REF		PROC	FAR
		MOV	DL,BYTE PTR ES:[SI+GRP]		;GROUP ID
		AND	DX,GRP_MASK			;ISOLATE ID
		MOV	CX,ES:[SI+FLAGS]		;FLAGS TO RESET
		CMP	DX,X_GEF_NUM			;VALID ID ?
		MOV	AX,SVC_FAILED+PARM_ERR		;PREPARE TO FAIL...
		JA 	REF0				;--NO--
		CALL	X_RESET_EF			;RESET THE FLAGS
							;AND PREPARE STATUS
REF0:
		CALL	X_SFLAGS			;RETURN STATUS
		RET
X_REF		ENDP
PAGE
;***********************************************************************
;*              X_TEF:    TEST EVENT FLAGS SERVICE                     *
;***********************************************************************
;
;	THIS PROCEDURE VALIDATES THE SDB PARAMETERS, TESTS THE
;	FLAGS AND RETURNS THE STATUS TO THE TASK.
;
;	INPUT:	ES:SI=	SDB
;	        BX=	TCB
;	OUTPUT:	NONE
;
X_TEF		PROC	FAR
		MOV	DL,BYTE PTR ES:[SI+GRP]		;GROUP/TYPE
		MOV	DH,DL
		AND	DL,GRP_MASK			;ISOLATE GROUP
		AND	DH,TYP_MASK			;ISOLATE TYPE
		ROL	DH,1				;RIGHT JUSTIFY TYPE
		MOV	CX,ES:[SI+FLAGS]		;FLAGS TO TEST
		MOV	AX,X_GEF_NUM
		CMP	DL,AL				;VALID GROUP ?
		MOV	AX,SVC_FAILED+PARM_ERR		;PREPARE TO FAIL...
		JA 	TEF0				;--NO--
		CALL	X_TEST_EF			;TEST FLAGS AND
							;PREPARE STATUS
TEF0:
		CALL	X_SFLAGS			;RETURN STATUS
		RET
X_TEF		ENDP
PAGE
;********************************************************************
;*        X_WEF:  BLOCK REQUESTOR TASK PENDING EVENT FLAGS.         *
;********************************************************************
;
;	THIS PROCEDURE VALIDATES THE SDB PARAMETERS AND BLOCKS THE
;	TASK.  THEN IT RETURNS STATUS TO THE TASK.
;
;	INPUT:	ES:SI=	SDB
;		BX=	TCB
;	OUTPUT: NONE
;
X_WEF		PROC	FAR
		MOV	DL,BYTE PTR ES:[SI+GRP]		;GROUP/TYPE
		MOV	DH,DL
		AND	DL,GRP_MASK			;ISOLATE GROUP
		AND	DH,TYP_MASK			;ISOLATE TYPE
		ROL	DH,1				;RIGHT JUSTIFY
		MOV	CX,ES:[SI+FLAGS]		;FLAGS TO AWAIT
		MOV	AX,X_GEF_NUM
		CMP	DL,AL				;VALID GROUP ?
		MOV	AX,SVC_FAILED+PARM_ERR		;PREPARE TO FAIL...
		JA 	WEF0				;--NO--
		CALL	X_WAIT_EF			;WAIT FOR EVENT FLAG
							;AND PREPARE STATUS
WEF0:
		CALL	X_SFLAGS			;RETURN STATUS
		RET
X_WEF		ENDP
PAGE
;**********************************************************************
;*       X_SEFET:  SET EVENT FLAGS AFTER ELAPSED TIME SERVICE.        *
;**********************************************************************
;
;	THIS PROCEDURE VALIDATES THE SDB PARAMETERS, 
;	RESETS THE FLAGS AND QUEUES THE TMB.  THEN IT
;	RETURNS STATUS TO THE TASK.
;
;	INPUT:	ES:SI=	SDB
;	        BX=	TCB
;	OUTPUT:	NONE
;
X_SEFET		PROC	FAR
		MOV	DL,BYTE PTR ES:[SI+GRP]	;GROUP
		AND	DX,GRP_MASK		;ISOLATE GROUP
		MOV	CX,ES:[SI+FLAGS]	;FLAGS TO SET
		MOV	AX,ES:[SI+TME]		;AL=TME
						;AH=LEN
		CMP	DX,X_GEF_NUM		;VALID ID ?
		JA	SEFETERR		;--NO--
		CMP	AL,TME_MASK		;VALID TME ?
		JGE 	SEFETERR		;--NO--
		JCXZ	SEFETERR		;NO FLAGS TO SET: ERROR!
		CALL	X_SETET_EF		;RESET FLAGS,
						;QUEUE TMB TO SET FLAGS,
						;AND PREPARE STATUS
		JMP	SHORT SEFET1		;RETURN THE STATUS.
SEFETERR:
		MOV	AX,SVC_FAILED+PARM_ERR	;ERROR STATUS
SEFET1:
		CALL	X_SFLAGS		;RETURN STATUS
		RET
X_SEFET		ENDP
MTOS_CS		ENDS
		END
