;******************************************************
;*     MTOS-86xx V3.0:  NUCLEUS PRE-LINKAGE PHASE     *
;*     F. W. PORRETTO, NOVEMBER 19, 1982              *
;*     FOR INDUSTRIAL PROGRAMMING, JERICHO, N.Y.      *
;*                                                    *
;*     MODIFIED 5/1/84 FOR MTOS-86xx V3.1:            *
;*     (HWDEP AND C INTERFACE NOW INCLUDED)           *
;*                                                    *
;******************************************************
;
; THE READER WILL NOTE THAT THIS COMMAND FILE CAUSES THE LINKAGE OF
; THE ENTIRE "SYSTEM" PORTION OF THE MTOS-86 DISTRIBUTION
; PACKAGE. IF YOUR SYSTEM INCLUDES DEVICE DRIVERS OTHER THAN THE 
; MTOS-86 CONSOLE DRIVER, INSERT THE NECESSARY COMMANDS HERE
; TO LINK THEM INTO THE NUCLEUS RELOCATABLE IMAGE.
;
; IN THE LINK86 DIRECTIVE, THE (R) ON A COMMENTED LINE INDICATES THAT THE
; FACILITY LINKED IN BY THAT LINE IS REQUIRED; THE (O) ON SUCH A LINE IN-
; DICATES THAT THE FACILITY MAY BE OMITTED IF DESIRED.
;
; INPUT:  %0 SPECIFIES THE DRIVE ON WHICH TO FIND MTOS.LIB,
;         %1 SPECIFIES THE DRIVE ON WHICH TO CREATE AND BUILD MTOS86.LNK,
;         %2 SPECIFIES THE DESTINATION FOR LINKER MESSAGES.
; OUTPUT: MTOS86.LNK, THE NUCLEUS RELOCATABLE IMAGE.
;
DELETE %1MTOS86.LNK
LINK86 &
%0MTOS.LIB(MTOS_INITIALIZATION), &               ;(R) INITIALIZATION
%0MTOS.LIB(MISC_INTERRUPTS), &                   ;(R) INTERRUPT HANDLERS
%0MTOS.LIB(STATE_SERVICE), &                     ;(R) METAROUTINES
%0MTOS.LIB(SCHEDULER_SERVICES), &                ;(R) SYSTEM SCHEDULER
%0MTOS.LIB(PIT_DRIVER), &                        ;(R) SYSTEM CLOCK DRIVER
%0MTOS.LIB(START_END_TASK_SERVICES), &           ;(R) TASK START/STOP
%0MTOS.LIB(CREATE_DELETE_TASKS), &               ;(O) TASK CREATE/DELETE
%0MTOS.LIB(POOL_SVC_SERVICES), &                 ;(O) MEMORY POOLS, PART 1
%0MTOS.LIB(MEMORY_POOL_SERVICES), &              ;(O) MEMORY POOLS, PART 2
%0MTOS.LIB(DEVICE_SERVICES), &                   ;(O) DRIVER SUPPORT STUFF
%0MTOS.LIB(SEMA_CNTRL_PROGRAM_SERVICES), &       ;(O) SEMAS/C-PS
%0MTOS.LIB(PAUSE_RESUME_SERVICES), &             ;(O) TASK PAUSE/RESUME
%0MTOS.LIB(EVENT_FLAG_PROCESSING), &             ;(O) EVENT FLAG CONTROLS
%0MTOS.LIB(NDP_SUPPORT), &                       ;(O) 8087 SUPPORT CODE
%0MTOS.LIB(DEBUG_SUPPORT), &                     ;(O) EXTENSION SUPPORT STUFF
%0MTOS.LIB(MTOS_GENERAL_SUBROUTINES), &          ;(R) VARIOUS ROUTINES
%0MTOS.LIB(HWDEP), &                             ;(R) HARDWARE-DEPENDENCIES
%0MTOS.LIB(C_TO_MTOS), &                         ;(O) C-86 INTERFACE
%0MTOS.LIB(PLM_TO_MTOS), &                       ;(O) PL/M-86 INTERFACE
%0MTOS.LIB(MAILBOX_SERVICES), &                  ;(O) MAILBOX CONTROLS
%0MTOS.LIB(PRIORITY_CHANGE), &                   ;(O) TASK PRIORITY CONTROL
%0MTOS.LIB(DISCRETE_SERVICES), &                 ;(O) DISCRETES CONTROL
%0MTOS.LIB(TIME_SVC_SERVICE), &                  ;(O) ASCII TIME CONTROL
%0MTOS.LIB(TDRIVER) TO %1MTOS86.LNK NAME(SYSTEM_NUCLEUS) MAP PRINT(%2)
;
;  ** END OF PROCEDURE **
;
