PAGE	60,132
INCLUDE B:BIG.INC
;
;	NDP.ASM:	ROUTINES FOR CONTROL 0F 8087 FREE AREAS.
;	F.W. PORRETTO, 8/23/82
;
;		THIS MODULE INCLUDES THE ROUTINES TO ALLOCATE AND DEALLOCATE
;	8087 SAVE AREAS FROM THE 8087 SAVE AREA FREE STACK.
;
		NAME	NDP_SUPPORT
;
;
MTOS_CS		SEGMENT	PARA PUBLIC
		ASSUME	CS:MTOS_CS,DS:MTOS_DS,SS:MTOS_DS
		PUBLIC	X_ALLOC_8087,X_DALLOC_8087
PAGE
;
;	X_ALLOC_8087:	ALLOCATE AN 8087 SAVE AREA.
;
;	INPUT:	NONE.
;
;	OUTPUT:	IF CARRY=0, BP= OFFSET ADDRESS OF 8087 SAVE AREA.
;		IF CARRY=1, FAILURE.
;
X_ALLOC_8087	PROC	NEAR
		CMP	X_8087_STACK,0		;ANY AVAILABLE?
		JNE	X8010			;YES.
		STC				;NO.
		RET
X8010:
		PUSH	DI
		MOV	BP,X_8087_STACK		;GET HEAD ENTRY
		MOV	AX,DS:[BP]		;GET ITS FORWARD LINK
		MOV	X_8087_STACK,AX		;UNLINK IT, UPDATING QUEUE HEAD
		POP	DI
		CLC
		RET
X_ALLOC_8087	ENDP
PAGE
;
;	X_DALLOC_8087:	RETURN 8087 SAVE AREA TO FREE STACK.
;
;	INPUT:	BP= OFFSET ADDRESS OF 8087 SAVE AREA TO DEALLOCATE
;
;	OUTPUT:	NONE.
;
X_DALLOC_8087	PROC	NEAR
		PUSH	DI
		MOV	AX,X_8087_STACK		;GET CURRENT HEAD OF QUEUE
		MOV	DS:[BP],AX		;LINK TO NEW ENTRY
		MOV	X_8087_STACK,BP		;NEW ENTRY NOW BECOMES HEAD.
		POP	DI
		RET
X_DALLOC_8087	ENDP
MTOS_CS		ENDS
		END
