PAGE	60,132
INCLUDE B:BIG.INC
;
;	PRI.ASM:	TASK PRIORITY CHANGING SVC HANDLER.
;	F. W. PORRETTO, 12/15/82
;
		NAME	PRIORITY_CHANGE
;
MTOS_CS		SEGMENT PARA PUBLIC
		ASSUME	DS:MTOS_DS,CS:MTOS_CS,SS:MTOS_DS
		PUBLIC	X_CPRI,X_CHANGE_PRI
		EXTRN	X_DQUEUE_TMB	:NEAR		;TIME QUEUE
		EXTRN	X_QUEUE_TMB	:NEAR		;ROUTINES.
		EXTRN	X_SFLAGS	:NEAR		;SET CONDITON CODES
		EXTRN	X_GET_INHPRI	:NEAR		;GET INHERENT TASK PRI
;
;	LOCAL EQUATES
;
NPS		EQU	01H				;SDB OFFSET OF NEW PRI
							; SOURCE
PRIV		EQU	02H				;SDB OFFSET OF PRI TO
							; USE IF NPS=0
NPS_MASK	EQU	03H				; ISOLATE NPS MASK
PAGE
;**************************************************************
;* 	X_CHANGE_PRI:  INNER CHANGE PRIORITY PROCEDURE        *
;**************************************************************
;
;	THIS PROCEDURE PROCEDURE CHANGES THE TASK'S CURRENT
;	PRIORITY AND PREPARES THE SVC STATUS.  ALL PARAMETERS
;	ARE PASSED VIA REGISTERS.
;
;	INPUT:	DL=	NEW PRIORITY SOURCE (NPS)
;		DH=	PRIORITY TO USE IF NPS=0 (PRIV)
;		BX=	TCB ADDRESS
;	OUTPUT:	AX=	SVC STATUS
;
X_CHANGE_PRI	PROC	NEAR
		PUSH	CX			;SAVE REGISTERS
		PUSH	DI
		PUSH	SI
		PUSH	BX
		MOV	CL,[BX+TCB_PRI]		;GET CURRENT PRIORITY
		CMP	DL,02			;INCREMENT CURRENT PRI?
		JE	INCPRI			;YES.
		JG	DECPRI			;NO, DECREMENT!
		CMP	DL,01			;REVERT TO INHERENT PRI?
		JE	INHPRI			;YES.
		MOV	CH,DH			;USE "PRIV:" GET NEW PRI TO CH
		JMP	SHORT PRISET
INHPRI:
		CALL	X_GET_INHPRI		;GET INHERENT PRI
		MOV	CH,AL			;INTO CH
		JMP	SHORT PRISET
INCPRI:
		MOV	CH,CL			;GET CUR PRI
		CMP	CH,255			;PRI ALREADY AT MAX ?
		JE	PRISET			;YES.
		INC	CH			;NO, BUMP IT 1.
		JMP	SHORT PRISET
DECPRI:
		MOV	CH,CL			;GET CUR PRI
		TEST	CH,CH			;PRI ALREADY MIN?
		JE	PRISET			;YES.
		DEC	CH			;NO, DUMP IT 1.
PRISET:
		MOV	[BX+TCB_PRI],CH		;INSERT NEW PRIORITY.
		XOR	AX,AX			;CLEAR STATUS
		CMP	CL,CH			;CMP NEW AND OLD PRI
		JNE	PRIDONE			;PRI HAS CHANGED.
		MOV	AX,FLAG_CF			;SET FLAG FOR NO CHANGE
PRIDONE:
		POP	BX				;RESTORE REGISTERS
		POP	SI
		POP	DI
		POP	CX
		RET
X_CHANGE_PRI	ENDP
PAGE
;*****************************************************************
;*        X_CPRI:  CHANGE TASK PRIORITY SVC                      *
;*****************************************************************
;
;	THIS PROCEDURE VALIDATES THE SDB PARAMETERS, CHANGES
;	THE TASK'S PRIORITY AND RETURNS STATUS TO THE TASK.
;
;	INPUT:	ES:SI=	SDB ADDRESS
;		BX=	TCB ADDRESS
;	OUTPUT: NONE
;
X_CPRI		PROC	FAR
		MOV	DH,ES:[SI+PRIV]			;GET PRIV PRIORITY
		MOV	DL,ES:[SI+NPS]			;GET NEW PRI SOURCE
		AND	DL,NPS_MASK			;ISOLATE NPS
		CALL	X_CHANGE_PRI			;CHANGE PRIORITY.
		CALL	X_SFLAGS			;STATUS TO TASK.
		RET
X_CPRI		ENDP
MTOS_CS		ENDS
		END
