;******************************************************
;*     MTOS-86xx V3.0:  OBJECT MODULES GENERATOR      *
;*     F. W. PORRETTO, NOVEMBER 19, 1982              *
;*     FOR INDUSTRIAL PROGRAMMING, JERICHO, N.Y.      *
;*                                                    *
;*     MODIFIED 5/1/84 FOR MTOS-86xx V3.1:            *
;*     (NOW ASSEMBLES HWDEP.ASM AND C.ASM)            *
;*                                                    *
;******************************************************
;
; THIS COMMAND FILE CAUSES THE ASSEMBLY OF EVERY CODE-PRODUCING MTOS SOURCE
; FILE EXCEPT XROM.ASM, XRAM.ASM AND THE OPTIONALLY INSTALLED DEBUGGER. THE
; ASSEMBLY STAGE IS PREREQUISITE TO ALL OTHER PHASES OF SYSTEM GENERATION.
;
; NOTE ALSO THAT THE FILES PLM.ASM AND C.ASM, THE TWO HIGH-LEVEL-LANGUAGE
; INTERFACES, MUST BE MOVED ONTO A COMMON MEDIUM WITH THE SYSTEM SOURCE CODE
; BEFORE RUNNING THIS PROCEDURE. THESE FILES ARE DELIVERED ON THE APPLICATION
; DISK, FOR REASONS OF SIZE.
;
; INPUT:  %0 SPECIFIES THE DESTINATION DRIVE FOR THE OBJECT MODULES,
;         %1 SPECIFIES THE DESTINATION FOR THE LISTING FILE,
;         %2 SPECIFIES THE DESTINATION FOR THE ERRORS SUMMARY, WHICH WILL BE
;            USEFUL IF YOU CHOOSE NOT TO LIST OUT THE SOURCE CODE,
;         %3 SPECIFIES THE DRIVE ON WHICH THE ASSEMBLER IS TO BUILD WORK FILES.
; (NOTE THAT THE SOURCE FILES ARE PRESUMED TO BE ON DRIVE 1.)
; OUTPUT: THE MANY MTOS OBJECT MODULES REQUIRED BY LIBGEN.CSD.
;
;     FOR REFERENCE, THE CONTENTS OF THE VARIOUS MODULES ARE:
;
;     MODULE        CONTENTS
;     ------        --------
;     INIT.ASM      SYSTEM INITIALIZATION THREAD.
;     MISCIN.ASM    SVC AND OTHER INTERRUPT HANDLERS.
;     STATES.ASM    STATE-TRANSITION ROUTINES.
;     SRB.ASM       SYSTEM SCHEDULER; SRB-HANDLING ROUTINES.
;     PIT.ASM       CLOCK INTERRUPT HANDLER; ELAPSED-TIME CONTROL ROUTINES.
;     START.ASM     TASK START/TERMINATE SERVICES.
;     CREATE.ASM    CREATE/DELETE TASKS, LOADER SUPPORT AND COORDINATION.
;     ALOC.ASM      MEMORY POOL SERVICE ROUTINES.
;     POOL.ASM      INNER MEMORY POOL CONTROL ROUTINES.
;     RIO.ASM       UNIVERSAL DEVICE DRIVER INTERFACE; DRIVER SUPPORT.
;     BUGS.ASM      EXTENSION SUPPORT SERVICES.
;     SUBR1.ASM     UTILITY SUBROUTINE POOL.
;     PLM.ASM       PL/M-86 SERVICE CALL CONVERSION ROUTINES.
;     C.ASM         C-86 SERVICE CALL CONVERSION ROUTINES.
;     CONDRV.ASM    CONSOLE DRIVER.
;     PAUSE.ASM     TASK PAUSE/RESUME SERVICES.
;     DIS.ASM       DISCRETE SIGNALS CONTROL SERVICES.
;     EFLAGS.ASM    EVENT FLAGS CONTROL AND SERVICES.
;     MAIL.ASM      MAILBOX CONTROL AND SERVICES.
;     PRI.ASM       TASK PRIORITY-ALTERATION SERVICE.
;     TIME.ASM      TASK WALL-CLOCK READ/WRITE SERVICES
;     SEMACP.ASM    SEMAPHORES AND CONTROLLED PROGRAM SERVICES.
;     NDP.ASM       SUPPORT FOR 8087 COPROCESSOR.
;     HWDEP.ASM     HARDWARE-DEPENDENT ROUTINES REQUIRED BY THE NUCLEUS.
;
ASM86 :F1:INIT.ASM OJ(%0INIT.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:MISCIN.ASM OJ(%0MISCIN.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:STATES.ASM OJ(%0STATES.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:SRB.ASM OJ(%0SRB.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:PIT.ASM OJ(%0PIT.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:START.ASM OJ(%0START.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:CREATE.ASM OJ(%0CREATE.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:ALOC.ASM OJ(%0ALOC.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:POOL.ASM OJ(%0POOL.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:RIO.ASM OJ(%0RIO.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:BUGS.ASM OJ(%0BUGS.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:SUBR1.ASM OJ(%0SUBR1.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:PLM.ASM OJ(%0PLM.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:C.ASM OJ(%0C.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:CONDRV.ASM OJ(%0CONDRV.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:PAUSE.ASM OJ(%0PAUSE.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:DIS.ASM OJ(%0DIS.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:EFLAGS.ASM OJ(%0EFLAGS.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:MAIL.ASM OJ(%0MAIL.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:PRI.ASM OJ(%0PRI.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:NDP.ASM OJ(%0NDP.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:TIME.ASM OJ(%0TIME.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:SEMACP.ASM OJ(%0SEMACP.OBJ) PR(%1) EP(%2) WF(%3)
ASM86 :F1:HWDEP.ASM OJ(%0HWDEP.OBJ) PR(%1) EP(%2) WF(%3)
;
;  ** END OF PROCEDURE **
;
