PAGE	60,132
INCLUDE B:EQUS.EQU
;
;	XRAM.ASM:	SYSTEM RAM STRUCTURES FOR MTOS-86 LEVEL II.
;	F. W. PORRETTO, 7/30/81
;
;		HERE ARE DEFINED ALL THE SYSTEM'S RAM DATA STRUCTURES, BOTH
;	LOCAL AND GLOBAL. NOTE THAT THE "ABSDEF" FILE IS NEEDED AT ASSEMBLY
;	TIME TO GENERATE THESE STRUCTURES.
;
;
		NAME	MTOS_RAM_STRUCTURES
		ASSUME	NOTHING
;
;	GLOBAL RAM PUBLICS:
;
MTOS_DS		SEGMENT PARA PUBLIC
		PUBLIC	X_TCB_TABLE
		PUBLIC	X_DCB_TABLE
		PUBLIC	X_UCB_TABLE
		PUBLIC	X_MPB_TABLE
		PUBLIC	X_SCB_TABLE
		PUBLIC	X_GEF_TABLE
		PUBLIC	X_LEF_TABLE
		PUBLIC	X_MBX_TABLE
		PUBLIC	X_OCB_TABLE
		PUBLIC	X_8087_TABLE
		PUBLIC	X_CP_TABLE
		PUBLIC	X_SMR
		PUBLIC	X_SMR_Q
		PUBLIC	X_SMR_LIST
		PUBLIC	X_SMR_AVAIL
		PUBLIC	X_SRB_START
		PUBLIC	X_SRB_FREEQ
		PUBLIC	X_SRB_AVAIL
		PUBLIC	X_SRB_Q
		PUBLIC	X_SRB_QEND
		PUBLIC	X_TMB_Q
		PUBLIC	X_ASCTOD
		PUBLIC	X_TOD_TMB
		PUBLIC	X_ABS_TIME
		PUBLIC	X_LREADY_Q
		PUBLIC	X_8087_STACK
		PUBLIC	X_BREAK_Q
		PUBLIC	XCSRB
		PUBLIC	X_ATCB
		PUBLIC	X_TASK_IPCS
		PUBLIC	X_CTCB
		PUBLIC	X_S_STATE
		PUBLIC	X_TOGGLE
		PUBLIC	X_MTOS_SP
		PUBLIC	X_INTLEVEL
		PUBLIC	X_PID
		PUBLIC	X_ROUND_ROBIN
		PUBLIC	XSEQ
		PUBLIC	XCIRB
		PUBLIC	XDCB
		PUBLIC	XUCB
		PUBLIC	XDEVNUM
		PUBLIC	XDEVUNIT
		PUBLIC	XTUNIT
		PUBLIC	XTNUM
		PUBLIC	XPOINTER
		PUBLIC	XOFFSET	
		PUBLIC	XSEGMENT
		PUBLIC	XSTATUS
		PUBLIC	XERRMSG
		PUBLIC	XPOOLNUM
		PUBLIC	XBLKLEN
		PUBLIC	X_GINIT_SIZE
MTOS_DS		ENDS
;
INCLUDE B:ABSDEF.ASM
PAGE
MTOS_DS		SEGMENT	PARA PUBLIC
;
;	SYSTEM STACK: USED FOR ALL S-STATE AND INTERRUPT LEVEL PROCESSING.
;
		DW	100 DUP (?)
X_MTOS_SP	EQU	THIS WORD
;
;	SYSTEM STATE-TRACKING VARIABLES:
;
XCSRB		DW	?		;CURRENT SRB (OFFSET INTO MTOS_DS)
		DW	?		;(FOR PL/M-86 S STATE ROUTINES.)
X_INTLEVEL	DW	?		;CURRENT INTERRUPT NESTING LEVEL.
X_ATCB		DW	?		;ACTIVE TASK'S TCB OFFSET IN MTOS_DS
X_TASK_IPCS	DD	?		;IP/CS AT WHICH THE LAST TASK WAS LAST
					;SCHEDULED (REQUIRED BY DEBUGGER FOR
					;BREAKPOINT CONTROL).
;
;	MISCELLANEOUS S-STATE MINUTIAE
;
X_CTCB		DW	?		;TCB OFFSET OF TASK WHICH WAS ACTIVE
					;WHEN CURRENT SRB WAS CONSTRUCTED.
X_PID		DW	?		;CONVENIENT PLACE FOR CPU NUMBER.
X_ROUND_ROBIN	DW	?		;TICKS REMAINING IN ROUND-ROBIN COUNT.
X_S_STATE	DD	?		;JUMP POINTER FOR SCHEDULER.
X_TOGGLE	DW	?		;TIEBREAKING TOGGLE FOR SCHEDULER.
;
;	SPECIAL VARIABLES FOR THE DEVICE DRIVERS:
;
XSEQ		DW	?		;SEQUENCE NUMBER CONTROLLER FOR THE
					;SEQUENCING OF IRBS AS CREATED.
XCIRB		DW	?		;CURRENT IRB OFFSET INTO MTOS_DS
		DW	?		;(FOR PL/M-86 S-STATE ROUTINES)
XDCB		DW	?		;CURRENT DCB
		DW	?		;(PL/M-86)
XUCB		DW	?		;CURRENT UCB
		DW	?		;(PL/M-86)
XPOINTER	EQU	THIS WORD	;GENERAL PURPOSE POINTER VARIABLE:
XOFFSET		DW	?		;	OFFSET,
XSEGMENT	DW	?		;	SEGMENT.
XDEVNUM		DB	?		;CURRENT DEVICE NUMBER,
XDEVUNIT	DB	?		;CURRENT UNIT NUMBER.
XTUNIT		DB	?		;TIME-UNIT CODE.
XTNUM		DB	?		;NUMBER OF UNITS
XSTATUS		DD	?		;STATUS TRANSPORT VARIABLE.
XERRMSG		DD	?		;ERROR-MESSAGE TRANSPORT VARIABLE.
XPOOLNUM	DB	?		;POOL NUMBER FOR BLOCK ALLOCATION.
XBLKLEN		DW	?		;LENGTH OF BLOCK NEEDED, BYTES.
PAGE
EVEN
;
;	NOW THE TABULAR STRUCTURES:
;
X_TCB_TABLE	DB	X_STATIC_TASKS DUP (TCB_SIZE DUP (?))
;
;	CONCATENATED TO THE TCB TABLE, TO ALLOW FOR THE ALLOCATION OF TCBS
;	AT RUN TIME, MUST BE THE SMR REGION.
;
X_SMR		DB	X_SMR_NUM DUP (SMR_SIZE DUP (?))
X_DCB_TABLE	LABEL	BYTE
		DB	X_DRIVER_NUM DUP (DCB_SIZE DUP (?))
X_UCB_TABLE	LABEL	BYTE
		DB	X_UNIT_NUM DUP (UCB_SIZE DUP (?))
X_MPB_TABLE	DB	X_MEM_POOL_NUM DUP (MPB_SIZE DUP (?))
X_SCB_TABLE	DB	X_SEMA_NUM DUP (SEM_SIZE DUP (?))
X_CP_TABLE	DB	X_CONTROL_NUM DUP (SEM_SIZE DUP (?))
X_MBX_TABLE	DB	X_MAILBOX_NUM DUP (MBX_SIZE DUP (?))
X_GEF_TABLE	DB	X_GEF_NUM DUP (EFG_SIZE DUP (?))
X_LEF_TABLE	DB	X_TASK_NUM DUP (EFG_SIZE DUP (?))
X_8087_TABLE	DB	X_8087_NUM DUP (NDP_SIZE DUP (?))
X_OCB_TABLE	DB	X_OVERLAYS_NUM DUP (OCB_SIZE DUP (?))
;
;	SECOND, THE UNIQUE STRUCTURES:
;
X_SRB_START	DB	X_SRB_NUM DUP (SRB_SIZE DUP (?))
;
X_SMR_LIST	DW	?	;HEAD OF SMR FREE LIST.
X_SMR_AVAIL	DW	?	;NUMBER OF FREE SMR BLOCKS.
X_SMR_Q		DW	?	;HEAD OF SMR WAIT QUEUE.
;
X_SRB_Q		DW	?			;SRB QUEUE HEAD.
X_SRB_QEND	DW	?			;SRB QUEUE TAIL.
X_SRB_FREEQ	DW	?			;HEAD OF SRB FREE LIST.
X_SRB_AVAIL	DW	?			;COUNT OF FREE SRBS.
;
X_8087_STACK	DW	?		;QUEUE HEAD FOR 8087 SAVE AREAS
					;THAT ARE CURRENTLY UNASSIGNED.
;
X_TMB_Q		DW	?		;HEAD OF ACTIVE TMB QUEUE.
X_ABS_TIME	DW	3 DUP (?)	;ABSOLUTE SYSTEM TIME, MSEC.
X_ASCTOD	DB	6 DUP (?)	;ASCII TIME OF DAY.
X_TOD_TMB	DB	TMB_SIZE DUP (?)	;TIME OF DAY TMB - DEDICATED.
;
X_LREADY_Q	DW	?			;LOCAL READY QUEUE HEAD.
X_BREAK_Q	DW	?			;BREAKPOINT LIST HEAD.
;
X_GINIT_SIZE	EQU	$		;GLOBAL INITIALIZATION LENGTH.
;
MTOS_DS		ENDS
;
		END
