PAGE	60,132
INCLUDE B:EQUS.EQU
;
;	XROM.ASM:	ROM CONFIGURATION FILE FOR MTOS-86 LEVEL II.
;	F. W. PORRETTO, 6/23/82
;
;		THIS FILE CONTAINS ALL THE DATA STRUCTURES NECESSA-
;	RY FOR THE DEFINITION TO MTOS OF THE APPLICATION AND MANY NEEDED 
;	PARTS OF THE SYSTEM. CONFIGURATION IS LARGELY INVOLVED WITH
;	EDITING THIS FILE. HERE THE DEFINITIONS ARE PROVIDED FOR:
;
;		-ALL STATIC TASKS,
;		-ALL DEVICE DRIVERS AND ASSOCIATED PERIPHERAL DEVICES,
;		-ALL NONDEVICE INTERRUPT VECTORS,
;		-ALL MEMORY POOLS,
;		-ALL DISCRETES,
;		-ALL LOW-LEVEL MTOS RESOURCES, SUCH AS EVENT FLAGS OR
;		 SEMAPHORES,
;		-ALL THE SYSTEM'S REQUIRED RUNTIME RESOURCES,
;		-ANY SPECIAL DEFINITIONS REQUIRED BY MTOS WHICH CAN BE
;		 PROVIDED AT ASSEMBLY TIME.
;
;	THE "MTOS-86MP INSTALLATION GUIDE" IS THE REQUISITE MANUAL FOR DEALING
;	WITH THE NECESSITIES INVOLVED HERE. KEEP IT AT YOUR SIDE AS YOU GO
;	THROUGH YOUR SYSTEM CONFIGURATION PROCESS.
;
		NAME	MTOS_ROM_STRUCTURES
		ASSUME	NOTHING
;
		EXTRN	X_INIT_CON:FAR
		EXTRN	X_CON_BR:FAR
		EXTRN	X_ZERO:NEAR
		EXTRN	X_SS:NEAR
		EXTRN	X_NMI:NEAR
		EXTRN	X_BPT:NEAR
		EXTRN	X_INTO:NEAR
		EXTRN	X_PIT_INT:NEAR
		EXTRN	X_SVC_INT:NEAR
		EXTRN	X_SVC_INT1:NEAR
;
;	GLOBAL ROM PUBLICS:
;
MTOS_GROM	SEGMENT PARA PUBLIC
		PUBLIC	X_TCD_TABLE
		PUBLIC	X_DCD_TABLE
		PUBLIC	X_UCD_TABLE
		PUBLIC	X_MPD_TABLE
		PUBLIC	X_DDD_TABLE
		PUBLIC	X_ORD_TABLE
		PUBLIC	X_VECTOR_TABLE
		PUBLIC	X_PID_ROM
MTOS_GROM	ENDS
;
;	DECLARE THE GLOBAL DATA SEGMENT, SO AS TO BE ABLE TO REFER TO IT.
;
MTOS_DS		SEGMENT PARA PUBLIC
MTOS_DS		ENDS
PAGE
;
;	PUBLIC DECLARATIONS FOR THE SYSTEM PARAMETERS
;
		PUBLIC	X_NUM_CPUS
		PUBLIC	X_STATIC_TASKS
		PUBLIC	X_OVERLAYS_NUM
		PUBLIC	X_8087_NUM
		PUBLIC	X_DRIVER_NUM
		PUBLIC	X_UNIT_NUM
		PUBLIC	X_DISCRETE_NUM
		PUBLIC	X_MEM_POOL_NUM
		PUBLIC	X_MAILBOX_NUM
		PUBLIC	X_GEF_NUM
		PUBLIC	X_SEMA_NUM
		PUBLIC	X_CONTROL_NUM
		PUBLIC	X_VECTORS_NUM
		PUBLIC	X_SRB_NUM
		PUBLIC	X_SMR_NUM
		PUBLIC	X_SVC_VECTOR
		PUBLIC	X_SYS_DEV
		PUBLIC	X_SYS_UNIT
		PUBLIC	X_NETMGR_TASK
		PUBLIC	X_LOADER_TASK
		PUBLIC	X_ERRLOG_TASK
		PUBLIC	X_MP_INIT
		PUBLIC	X_RR_TICKS
		PUBLIC	X_INIT_ID
		PUBLIC	X_MIN_MEM
		PUBLIC	X_TASK_NUM
PAGE
INCLUDE B:ABSDEF.ASM
PAGE
;
;	SYMBOLS FOR THE INCLUSION OF THE DYNAMIC DEBUGGER:
;
DEB_DATA	SEGMENT	PARA PUBLIC
DEB_DATA	ENDS
		EXTRN	XDB_ENTRY:FAR
		EXTRN	XDB_STACK:WORD
;
;	SPECIAL SYMBOLS FOR THE STANDARD DIAGNOSTIC:
;
		PUBLIC	X_NUM_DIAG_TASKS,X_DIAG_DEVICE,X_DIAG_UNIT
		PUBLIC	X_DIAG_CP,X_DIAG_GEF_GRP,X_DIAG_SEMA
		PUBLIC	X_DIAG_MEM,X_DIAG_DSCRTE,X_DIAG_MAILBOX
		PUBLIC	X_DIAG_MAIN_TASK
;
X_DIAG_MAIN_TASK EQU	0		;TASK NUMBER OF MAIN DIAGNOSTIC TASK.
X_NUM_DIAG_TASKS EQU	19		;TOTAL TASK COUNT IN DIAGNOSTIC.
X_DIAG_DEVICE	EQU	0		;DIAGNOSTIC CONSOLE.
X_DIAG_UNIT	EQU	0		;    "         "
X_DIAG_CP	EQU	0		;C-P ID FOR DIAGNOSTIC.
X_DIAG_GEF_GRP	EQU	1		;GLOBAL FLAG GROUP FOR DIAGNOSTIC.
X_DIAG_SEMA	EQU	0		;SEMAPHORE FOR DIAGNOSTIC.
X_DIAG_MEM	EQU	0		;MEMORY POOL FOR DIAGNOSTIC.
X_DIAG_DSCRTE	EQU	0		;DISCRETE BYTE FOR DIAGNOSTIC.
X_DIAG_MAILBOX	EQU	0		;MAILBOX FOR DIAGNOSTIC.
;
		EXTRN	DIAG_MAIN_SP:WORD
		EXTRN	DIAG86:FAR
PAGE
;
;	STRUCTURE DEFINITIONS FOR TCD AND DCD, FOR CONVENIENCE.
;
TCD		STRUC
		DD	0	;AX/BX AS A POINTER.
		DW	0	;DS
		DW	0	;ES
		DD	?	;SP/SS
		DD	?	;IP/CS
		DD	0	;LOAD
		DB	0	;OVERRIDE TIME UNIT SPECIFIER.
		DB	0	;NUMBER OF UNITS IN OVERRIDE TIME INTERVAL.
		DB	0	;OVERRIDE PRIORITY INCREMENT.
		DB	0	;OVERRIDE PRIORITY BOUNDARY VALUE.
		DB	?	;INHERENT PRIORITY.
		DB	?	;CPU NUMBER OR 0FFH.
		DW	0	;FLAGS WORD.
		DD	0	;RESERVED, 4 BYTES.
TCD		ENDS
;
DCD		STRUC
		DW	?	;OFFSET ADDRESS OF UCD #0 FOR DRIVER.
		DB	?	;NUMBER OF UNITS ON THE DRIVER.
		DB	0FFH	;CONTROLLER-SHARING DRIVER.
		DD	?	;INITIALIZATION ROUTINE ADDRESS.
		DD	?	;BRANCH TABLE ADDRESS/RIO ENTRY POINT ADDRESS
		DB	?	;DRIVER FLAGS
		DB	?	;MAXIMUM FUNCTION CODE (TYPE 2 DRIVERS ONLY)
		DW	0	;RESERVED, 2 BYTES.
DCD		ENDS
PAGE
;
;	PRIMARY EDITING REGION 1: TASK DEFINITIONS (TCDS)
;
;	HERE THE CONFIGURER PUTS ALL HIS TASKS' TCDS, IN A CONTIGUOUS ARRANGE-
;	MENT WHICH IMPLICITLY ASSIGNS EACH TASK A TASK NUMBER, STARTING FROM
;	ZERO. THE FORMAT OF THE TCD, AND THE CORRECT USAGE OF THE TCD CONVEN-
;	IENCE MACRO FOR DEFINING THEM, ARE BOTH DESCRIBED IN THE MTOS-86MP
;	INSTALLATION GUIDE.
;
MTOS_GROM	SEGMENT PARA PUBLIC
X_TCD_TABLE	LABEL	WORD
;
;	TCD FOR DIAGNOSTIC MAIN TEST TASK:
;
TASK_0		TCD	<,,,DIAG_MAIN_SP,DIAG86,,,,,,100,0,0>
;
;	TCD FOR DYNAMIC DEBUGGER:
;
TASK_1		TCD	<,DEB_DATA,,XDB_STACK,XDB_ENTRY,,,,,,0FFH,0,4>
PAGE
;
;	PRIMARY EDITING REGION 2:	DEVICE AND UNIT DEFINITIONS.
;
;	HERE THE CONFIGURER MUST PROVIDE THE DCDS AND UCDS WHICH DEFINE HIS
;	CHOSEN DEVICE DRIVER CONFIGURATION. THE FORMAT OF THE DCD, AND THE DCD
;	CONVENIENCE MACRO FOR DEFINING THEM, ARE DESCRIBED IN THE MTOS-86MP
;	INSTALLATION GUIDE.
;
X_DCD_TABLE	LABEL	WORD
;
;	DCD FOR DRIVER 0: THE CONSOLE DRIVER.
;
DEVICE_0	DCD	<UCD_000,1,,X_INIT_CON,X_CON_BR,3,7>
;
X_UCD_TABLE	LABEL	WORD
;
;	UNIT 0 FOR DRIVER 0: SYSTEM CONSOLE.
;	THIS IS SET UP FOR 8 BIT DATA FRAMES AND NO PARITY AT 9600 BAUD
;
UCD_000		LABEL	WORD
		DB	0		;OWNER PROCESSOR
		DB	35		;INTERRUPT VECTOR NUMBER
		DD	0		;INIT ROUTINE CONSTRUCTS INTRPT ADDR.
		DW	1		;UNSOLICITED INPUT TASK= DEBUGGER.
		DB	0D6H,096H,0D4H,8,0DAH,04EH,037H,0D8H
		DB	0,0,0,0,0,0,0,0	;UNIT-SPECIFIC DRIVER-DEPENDENT PARAMS.
PAGE
;
;	PRIMARY EDITING REGION 3:	MEMORY POOL DEFINITIONS.
;
;	HERE THE CONFIGURER CONSTRUCTS MEMORY POOL DEFINITIONS (MPDS), WHICH
;	TELL MTOS WHERE AND HOW LARGE HIS POOLS ARE.
;
X_MPD_TABLE	LABEL	WORD
		DD	POOL_0		;POOL 0:
		DW	POOL_0_SIZE	;SO LARGE.
;
;	THE POOL ITSELF IS DEFINED AT THE TAIL END OF THIS MODULE.
;
PAGE
;
;	PRIMARY EDITING REGION 4:	DISCRETES' DEFINITIONS.
;
;	HERE THE CONFIGURER DEFINES HIS DISCRETES BY ENTERING THEIR ADDRESSES
;	INTO HIS DISCRETES' DEFINITION DATA (DDD) TABLE.
;
X_DDD_TABLE	LABEL	WORD
		DD	DD_0		;ONE DISCRETE BYTE.
;
;	NORMALLY THE DISCRETE DEFINITION WOULD BE AN EFFECTIVE ADDRESS; HERE,
;	IT IS MERELY THE ADDRESS OF A BYTE OF GLOBAL RAM MASQUERADING AS A
;	DISCRETE FOR THE PURPOSES OF THE TEST PROGRAMS.
;
PAGE
;
;	PRIMARY EDITING REGION 5:	OVERLAY REGION DEFINITIONS (ORD)
;
;	HERE THE CONFIGURER MUST DEFINE THE OVERLAY REGIONS FOR THE SYSTEM.
;	EACH REGION DEFINITION MUST SPECIFY THE DOUBLEWORD ADDRESS OF THE
;	REGION, AND ITS LENGTH IN BYTES.
;
X_ORD_TABLE	LABEL	WORD
		DW	0		;OVERLAY REGION NUMBER.
		DD	OVREGION_1	;REGION START ADDRESS.
		DW	OV1_LEN		;REGION SIZE, BYTES.
PAGE
;
;	PRIMARY EDITING REGION 6:	CPU NUMBER AND NONDEVICE VECTORS.
;
;	THIS PROVIDES MTOS WITH THE NUMBER IDENTIFYING THE CPU, AND THE TABLE
;	OF NONDEVICE VECTORS TO BE CONSTRUCTED IN LOW MEMORY.
;
X_PID_ROM	DW	0		;CPU #0: DON'T CHANGE THIS!!!
;
X_VECTOR_TABLE	LABEL	WORD
		DW	0		;ZERO DIVIDE.
		DD	X_ZERO
		DW	1		;SINGLE-STEP.
		DD	X_SS
		DW	2		;NONMASKABLE.
		DD	X_NMI
		DW	3		;BREAKPOINT.
		DD	X_BPT
		DW	4		;OVERFLOW.
		DD	X_INTO
		DW	34		;SYSTEM CLOCK.
		DD	X_PIT_INT
		DW	X_SVC_VECTOR	;TYPE 1 SVC.
		DD	X_SVC_INT
		DW	X_SVC_VECTOR+1	;TYPE 2 SVC.
		DD	X_SVC_INT1
;
;	SINCE ALL VECTOR TABLES MUST BE EQUAL IN LENGTH, THE FOLLOWING PSEUDOS
;	ARE USED TO TAKE UP ANY SLACK:
;
		DB	6*(X_VECTORS_NUM+1)-($-X_VECTOR_TABLE) DUP (0FFH)
;
MTOS_GROM	ENDS
PAGE
;
;	ROMABLE ITEMS IN THE MTOS_CS SEGMENT:
;
;	THESE HAVE BEEN PUT HERE TO KEEP THE MTOS EXECUTABLE MODULES AS
;	EMPTY OF DATA AS POSSIBLE, AND TO FACILITATE THE CUSTOMIZATION
;	OF THE SYSTEM BY THEIR EXCLUSION WHEN NOT NEEDED.
;
MTOS_CS		SEGMENT PARA PUBLIC
		EXTRN	X_STRT:FAR
		EXTRN	X_QSTRT:FAR
		EXTRN	X_ENDT:FAR
		EXTRN	X_ENDR:FAR
		EXTRN	X_CPRI:FAR
		EXTRN	X_PAUSE:FAR
		EXTRN	X_RESUME:FAR
		EXTRN	X_SEF:FAR
		EXTRN	X_REF:FAR
		EXTRN	X_TEF:FAR
		EXTRN	X_WEF:FAR
		EXTRN	X_SEFET:FAR
		EXTRN	X_SEND:FAR
		EXTRN	X_RECV:FAR
		EXTRN	X_ALOC:FAR
		EXTRN	X_DALOC:FAR
		EXTRN	X_TIME:FAR
		EXTRN	X_STIME:FAR
		EXTRN	X_DSCRTE:FAR
		EXTRN	X_RIO:FAR
		EXTRN	X_RSF:FAR
		EXTRN	X_TSF:FAR
		EXTRN	X_CNTRL:FAR
		EXTRN	X_QCOPY:FAR
		EXTRN	X_CREATE:FAR
		EXTRN	X_DELETE:FAR
		EXTRN	X_DELTSK:FAR
		EXTRN	X_LOADED:FAR
		EXTRN	X_DBGSVC:FAR
		EXTRN	X_DUMMY:FAR
		EXTRN	X_TYPE_0:NEAR
		EXTRN	X_TYPE_1:NEAR
		EXTRN	X_TYPE_2:NEAR
		EXTRN	X_TYPE_3:NEAR
		EXTRN	X_TYPE_4:NEAR
		EXTRN	X_TYPE_5:NEAR
		EXTRN	X_TYPE_6:NEAR
		EXTRN	X_TYPE_7:NEAR
;
		PUBLIC	X_JT,X_MAX_SVC,X_MEM_RQRD
		PUBLIC	X_TCB_SIZE_VAR,X_DCB_SIZE_VAR,X_UCB_SIZE_VAR
		PUBLIC	X_MPB_SIZE_VAR,X_MPD_SIZE_VAR,X_OCB_SIZE_VAR
		PUBLIC	XVERSION,XMTOSDS,X_UNX_MSG,X_NMI_MSG,X_MSG_ADR
		PUBLIC	X_NO_SMR_MSG
		PUBLIC	X_MSG_SRB_OUT
		PUBLIC	X_TAB,X_TIMUNS
;
;	THE X_JT VECTOR TABLE MUST BE CONFIGURED ONLY IF THE CONFIGURER WISHES
;	TO REMOVE PARTS OF THE SYSTEM. IN THAT CASE, THE ADDRESS ENTRIES COR-
;	RESPONDING TO THE ROUTINES THE CONFIGURER WISHES TO EXCLUDE SHOULD BE
;	REPLACED BY REFERENCES TO X_DUMMY.
;
X_JT		LABEL	DWORD
		DD	X_DUMMY		;NO SVC 0.
		DD	X_STRT
		DD	X_QSTRT
		DD	X_ENDT
		DD	X_ENDR		;SVC 1-4: START GROUP
		DD	X_CPRI
		DD	X_PAUSE
		DD	X_RESUME	;SVC 5-7: TASK CONTROL.
		DD	X_SEF
		DD	X_REF
		DD	X_TEF
		DD	X_SEFET
		DD	X_WEF		;SVC 8-12: FLAGS.
		DD	X_SEND
		DD	X_RECV		;SVC 13-14: MAILBOXING.
		DD	X_ALOC
		DD	X_DALOC		;SVC 15-16: MEMORY POOLS.
		DD	X_CNTRL		;SVC 17: CONTROLLED PGMS.
		DD	X_TIME
		DD	X_STIME		;SVC 18-19: TIME OF DAY.
		DD	X_DSCRTE
		DD	X_RIO		;SVC 20-21: I/O CONTROL.
		DD	X_RSF
		DD	X_TSF		;SVC 22-23: SEMAPHORES.
		DD	X_QCOPY		;SVC 24: COPY INTERNAL START PARAMS
		DD	X_DBGSVC	;SVC 25: DEBUGGER SUPPORT CLUSTER
		DD	X_CREATE	;SVC 26: CREATE DYNAMIC TASK.
		DD	X_DELETE	;    27: ENDT AND DELETE DYNAMIC TASK.
		DD	X_DELTSK	;    28: DELETE TASK IF DORMANT.
		DD	X_LOADED	;SVC 29: OVERLAY LOADER COMPLETED.
;
X_MAX_SVC	EQU	($-X_JT)/4		;NUMBER OF SERVICES.
;
;	MEMORY-REQUIRED TABLE:
;
;	THE BYTES IN THIS TABLE CORRESPOND TO THE SERVICES IN NUMERICAL ORDER.
;	A VALUE OF 0 INDICATES NO MEMORY REQUIRED; A VALUE OF 1 INDICATES THAT
;	THE SERVICE ROUTINE CALLS X_GET_SMR AT LEAST ONCE.
;
X_MEM_RQRD	LABEL	BYTE
		DB	0		;DUMMY NEEDS NOTHING.
		DB	2,2		;STRT AND QSTRT MAY NEED 2 EACH.
		DB	0,1		;ENDT NEEDS NOTHING; ENDR NEEDS ONE.
		DB	0,1,0		;ONLY PAUSE FROM THE CONTROL GROUP.
		DB	0,0,0,1,1	;WEF AND SEFET FROM THE FLAGS GROUP.
		DB	1,1		;MAILBOXING USES SMR COMING AND GOING
		DB	1,0		;ALOC MAY NEED ONE; DALOC NEVER.
		DB	2		;CNTRL NEEDS 2.
		DB	0,0		;TIME OF DAY USES NOTHING.
		DB	0,2		;DSCRTE NEEDS NONE, RIO NEEDS 2.
		DB	0,2		;RESET NEEDS NONE, TEST/SET NEEDS 2
		DB	0		;QCOPY NEEDS NONE.
		DB	1		;DBGSVC MAY NEED ONE.
		DB	3,0,0		;CREATE NEEDS 3, DELETE NEEDS NONE.
		DB	0		;LOADER COMPLETE NEEDS NONE.
EVEN
;
;	CONVENIENT MULTIPLY AND DIVIDE CONSTANTS:
;
X_TCB_SIZE_VAR	DW	TCB_SIZE
X_DCB_SIZE_VAR	DW	DCB_SIZE
X_UCB_SIZE_VAR	DW	UCB_SIZE
X_MPB_SIZE_VAR	DW	MPB_SIZE
X_MPD_SIZE_VAR	DW	MPD_SIZE
X_OCB_SIZE_VAR	DW	OCB_SIZE
;
XVERSION	DB	1,0		;INTERNALLY READABLE VERSION NUMBER.
XMTOSDS		DW	MTOS_DS		;FOR PL/M-86.
;
;	TIMER HANDLER VECTOR TABLE:
;
X_TAB		LABEL	WORD
		DW	X_TYPE_0	;DUMMY.
		DW	X_TYPE_1	;DRIVER OR TIME OF DAY.
		DW	X_TYPE_2	;TASK PAUSE SATISFIED.
		DW	X_TYPE_3	;SEFET INTERVAL EXPIRED.
		DW	X_TYPE_4	;TASK RESTART INTERVAL EXPIRED.
		DW	X_TYPE_5	;TASK PRIORITY OVERRIDE INTERVAL OVER.
		DW	X_TYPE_6	;SEMAPHORE BID TIMEOUT.
		DW	X_TYPE_7	;RESERVE-UNIT TIMEOUT
;
;	TIME-UNITS CONVERSION TABLE (UNIT-TO-MILLISECONDS.)
;
X_TIMUNS	LABEL	WORD
		DW	0,1		;    1 MSEC.
		DW	0,10		;   10 MSEC.
		DW	0,100		;  100 MSEC.
		DW	0,1000		; 1000 MSEC.= 1 SECOND.
		DW	0,60000		;60000 MSEC.= 1 MINUTE.
		DW	54,61056	;           = 1 HOUR (REALLY!)
;
;	ADDRESSES OF SOME INTERNAL ERROR MESSAGES:
;
X_MSG_ADR	DD	ZERO_MSG,SS_MSG,BPT_MSG,INTO_MSG
;
X_NO_SMR_MSG	DB	'** NO SMRS **',13,10,0
X_MSG_SRB_OUT	DB	'** NO SRBS **',13,10,0
X_NMI_MSG	DB	'** NMI INT **',13,10,0
X_UNX_MSG	DB	'** UNX INT **',13,10,0
;
ZERO_MSG	DB	'* DIVIDE BY 0! *',13,10,0
SS_MSG		DB	'* TRAP! *',13,10,0
BPT_MSG		DB	'* BREAKPOINT! *',13,10,0
INTO_MSG	DB	'* OVERFLOW! *',13,10,0
;
MTOS_CS		ENDS
;
PAGE
;
;	SOME TEST RAM:
;
TESTSEG		SEGMENT PARA PUBLIC
POOL_0		DB	16 DUP (?)
POOL_0_SIZE	EQU	16
TESTSEG		ENDS
;
TESTSEG2	SEGMENT PARA PUBLIC
DD_0		DB	?
TESTSEG2	ENDS
;
;	TRIVIAL OVERLAY REGION DEFINITION:
;
OV_SEG		SEGMENT PARA PUBLIC
OVREGION_1	DB	?
OV1_LEN		EQU	1
OV_SEG		ENDS
;
		END
