*H RTZ.CON.1
;UPDATED: 820113 / PH
;REV:     2.00
 
*I RTZ.EQU
*I RTZ.CON.EQU
 
;=======
; Z_CON1 - HANDLER FOR CONSOLE # 1
;=======
 
	GLOBAL	Z_CON1
	EXTERNAL	Z_SGNL,Z_CPRO
	EXTERNAL	Z_CON,Z_CINI,Z_C1SM,Z_C1ST,Z_KMG1
	EXTERNAL	Z_C1RZ,Z_C1GS,Z_INI1
 
Z_CON1
	LD	DE,Z_C1ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,LSTTAB
	LDIR
	LD	HL,(Z_C1GS)	;RECEIVE INTERRUPT SEMAPHORE
	LD	(Z_C1ST+GCHR),HL
 
	LD	IX,Z_C1ST		;SET TABS
	LD	HL,(Z_C1RZ)	;  AND ALLOCATE TYPE-AHEAD RING
	CALL	Z_CINI		;  AND CREATE KEY-SEMAPHORE
 
	LD	DE,Z_KEY1		;SEND "KEY" TO Z_KEY0
	LD	HL,Z_KMG1
	CALL	Z_SGNL
	LD	DE,IPCBAX		;BC:=^IPCB FOR Z_ALM1
	CALL	Z_CPRO		;CREATE Z_ALM1
	CALL	Z_INI1		;DO USER-SUPPLIED INIT
 
; MAIN LOOP
 
	LD	IX,Z_C1ST		;IX:=^STATUS-TABLE
CONLOP
	LD	DE,Z_C1SM		;WAIT AT REQUEST-SEMAPHORE
	CALL	Z_CON
	JR	CONLOP
 
;-------
; IPCBAX - INITIAL PCB FOR Z_ALM1
;-------
 
IPCBAX
	DEFM	'Z_ALM1'
	DEFW	Z_ALM1
	DEFW	62			;STACK SIZE
	DEFB	100			;PRIORITY
 
;=======
; STTTAB - DEFAULT STATUS-TABLE FOR CONSOLE  # 1
;
; ACCESSED BY OFFSET TO IX
;=======
 
	EXTERNAL	Z_DRM1,Z_EDR1,Z_KEY1,Z_KES1,Z_SCH1
 
STTTAB
	DEFB	ASCIBS		;CHRDEL
	DEFB	ASCDEL		;LINDEL
	DEFB	18H			;INPDEL (^X)
	DEFB	10H			;DLE (^P)
	DEFB	13H			;XOFF (^S)
	DEFB	11H			;XON (^Q)
	DEFB	0FH			;KILL (^O)
	DEFB	1			;LFCNT
	DEFB	1			;NULLCT
	DEFB	0FFH			;ECHO (ON)
	DEFW	Z_DRM1		;DRUM (TAB-DRUM)
	DEFW	Z_EDR1		;EDRUM (END OF TAB-DRUM)
	DEFW	Z_KEY1		;KEYSM
	DEFW	Z_KES1		;KEYSAV
	DEFW	Z_SCH1		;SCHR
	DEFW	0			;GCHR
	DEFB	26H			;CONSTT
	DEFB	0			;OUTSTT
	DEFB	0			;CURSOR
	DEFB	0			;--
ASTTAB	EQU	$-STTTAB
 
	DEFW	0			;IQ (TYPE AHEAD RING)
	DEFW	0			;TIQ (TOP OF Z_IQ0)
	DEFW	0			;FIQ (^FRONT OF RING)
	DEFW	0			;EIQ (^END OF RING)
	DEFW	0			;LIQ (LENGTH OF RING)
LSTTAB	EQU	$-STTTAB
 
;=======
; Z_ALM1 - WRITE ALARM ON CONSOLE # 1
;=======
 
	GLOBAL	Z_ALM1
	EXTERNAL	Z_SGNL
	EXTERNAL	Z_A1SM,Z_A1ST
 
Z_ALM1
	LD	DE,Z_A1ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,ASTTAB
	LDIR
	LD	HL,Z_A1ST+OUTSTT
	SET	0,(HL)		;THIS IS AN ALARM PROCESS
 
; MAIN LOOP
 
	LD	IX,Z_A1ST		;IX:=^STATUS-TABLE
ALMLOP
	LD	DE,Z_A1SM		;WAIT AT ALARM-SEMAPHORE
	CALL	Z_CON
	JR	ALMLOP
 
;-------
; Z_GCI1 - RECEIVE HANDLING
;
; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
;          CY = 0  IF NOT
;
; TO BE CALLED BY RECEIVE-INTERRUPT
;-------
 
	GLOBAL	Z_GCI1
	EXTERNAL	Z_GCI
 
Z_GCI1
	PUSH	IX
	LD	IX,Z_C1ST
	JP	Z_GCI
