*H RTZ.CON.2
;UPDATED: 820118 / PH
;REV:     2.00
 
*I RTZ.EQU
*I RTZ.CON.EQU
 
;=======
; Z_CON2 - HANDLER FOR CONSOLE # 2
;=======
 
	GLOBAL	Z_CON2
	EXTERNAL	Z_SGNL,Z_CPRO
	EXTERNAL	Z_CON,Z_CINI,Z_C2SM,Z_C2ST,Z_KMG2
	EXTERNAL	Z_C2RZ,Z_C2GS,Z_INI2
 
Z_CON2
	LD	DE,Z_C2ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,LSTTAB
	LDIR
	LD	HL,(Z_C2GS)	;RECEIVE INTERRUPT SEMAPHORE
	LD	(Z_C2ST+GCHR),HL
 
	LD	IX,Z_C2ST		;SET TABS
	LD	HL,(Z_C2RZ)	;  AND ALLOCATE TYPE-AHEAD RING
	CALL	Z_CINI		;  AND CREATE KEY-SEMAPHORE
 
	LD	DE,Z_KEY2		;SEND "KEY" TO Z_KEY2
	LD	HL,Z_KMG2
	CALL	Z_SGNL
	LD	DE,IPCBAX		;BC:=^IPCB FOR Z_ALM2
	CALL	Z_CPRO		;CREATE Z_ALM2
	CALL	Z_INI2		;DO USER-SUPPLIED INIT
 
; MAIN LOOP
 
	LD	IX,Z_C2ST		;IX:=^STATUS-TABLE
CONLOP
	LD	DE,Z_C2SM		;WAIT AT REQUEST-SEMAPHORE
	CALL	Z_CON
	JR	CONLOP
 
;-------
; IPCBAX - INITIAL PCB FOR Z_ALM2
;-------
 
IPCBAX
	DEFM	'Z_ALM2'
	DEFW	Z_ALM2
	DEFW	62			;STACK SIZE
	DEFB	100			;PRIORITY
 
;=======
; STTTAB - DEFAULT STATUS-TABLE FOR CONSOLE  # 2
;
; ACCESSED BY OFFSET TO IX
;=======
 
	EXTERNAL	Z_DRM2,Z_EDR2,Z_KEY2,Z_KES2,Z_SCH2
 
STTTAB
	DEFB	ASCIBS		;CHRDEL
	DEFB	ASCDEL		;LINDEL
	DEFB	18H			;INPDEL (^X)
	DEFB	10H			;DLE (^P)
	DEFB	13H			;XOFF (^S)
	DEFB	11H			;XON (^Q)
	DEFB	0FH			;KILL (^O)
	DEFB	1			;LFCNT
	DEFB	1			;NULLCT
	DEFB	0FFH			;ECHO (ON)
	DEFW	Z_DRM2		;DRUM (TAB-DRUM)
	DEFW	Z_EDR2		;EDRUM (END OF TAB-DRUM)
	DEFW	Z_KEY2		;KEYSM
	DEFW	Z_KES2		;KEYSAV
	DEFW	Z_SCH2		;SCHR
	DEFW	0			;GCHR
	DEFB	26H			;CONSTT
	DEFB	0			;OUTSTT
	DEFB	0			;CURSOR
	DEFB	0			;--
ASTTAB	EQU	$-STTTAB
 
	DEFW	0			;IQ (TYPE AHEAD RING)
	DEFW	0			;TIQ (TOP OF Z_IQ0)
	DEFW	0			;FIQ (^FRONT OF RING)
	DEFW	0			;EIQ (^END OF RING)
	DEFW	0			;LIQ (LENGTH OF RING)
LSTTAB	EQU	$-STTTAB
 
;=======
; Z_ALM2 - WRITE ALARM ON CONSOLE # 2
;=======
 
	GLOBAL	Z_ALM2
	EXTERNAL	Z_SGNL
	EXTERNAL	Z_A2SM,Z_A2ST
 
Z_ALM2
	LD	DE,Z_A2ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,ASTTAB
	LDIR
	LD	HL,Z_A2ST+OUTSTT
	SET	0,(HL)		;THIS IS AN ALARM PROCESS
 
; MAIN LOOP
 
	LD	IX,Z_A2ST		;IX:=^STATUS-TABLE
ALMLOP
	LD	DE,Z_A2SM		;WAIT AT ALARM-SEMAPHORE
	CALL	Z_CON
	JR	ALMLOP
 
;-------
; Z_GCI2 - RECEIVE HANDLING
;
; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
;          CY = 0  IF NOT
;
; TO BE CALLED BY RECEIVE-INTERRUPT
;-------
 
	GLOBAL	Z_GCI2
	EXTERNAL	Z_GCI
 
Z_GCI2
	PUSH	IX
	LD	IX,Z_C2ST
	JP	Z_GCI
