*H RTZ.CON.3
;UPDATED: 820118 / PH
;REV:     2.00
 
*I RTZ.EQU
*I RTZ.CON.EQU
 
;=======
; Z_CON3 - HANDLER FOR CONSOLE # 3
;=======
 
	GLOBAL	Z_CON3
	EXTERNAL	Z_SGNL,Z_CPRO
	EXTERNAL	Z_CON,Z_CINI,Z_C3SM,Z_C3ST,Z_KMG3
	EXTERNAL	Z_C3RZ,Z_C3GS,Z_INI3
 
Z_CON3
	LD	DE,Z_C3ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,LSTTAB
	LDIR
	LD	HL,(Z_C3GS)	;RECEIVE INTERRUPT SEMAPHORE
	LD	(Z_C3ST+GCHR),HL
 
	LD	IX,Z_C3ST		;SET TABS
	LD	HL,(Z_C3RZ)	;  AND ALLOCATE TYPE-AHEAD RING
	CALL	Z_CINI		;  AND CREATE KEY-SEMAPHORE
 
	LD	DE,Z_KEY3		;SEND "KEY" TO Z_KEY3
	LD	HL,Z_KMG3
	CALL	Z_SGNL
	LD	DE,IPCBAX		;BC:=^IPCB FOR Z_ALM3
	CALL	Z_CPRO		;CREATE Z_ALM3
	CALL	Z_INI3		;DO USER-SUPPLIED INIT
 
; MAIN LOOP
 
	LD	IX,Z_C3ST		;IX:=^STATUS-TABLE
CONLOP
	LD	DE,Z_C3SM		;WAIT AT REQUEST-SEMAPHORE
	CALL	Z_CON
	JR	CONLOP
 
;-------
; IPCBAX - INITIAL PCB FOR Z_ALM3
;-------
 
IPCBAX
	DEFM	'Z_ALM3'
	DEFW	Z_ALM3
	DEFW	62			;STACK SIZE
	DEFB	100			;PRIORITY
 
;=======
; STTTAB - DEFAULT STATUS-TABLE FOR CONSOLE  # 3
;
; ACCESSED BY OFFSET TO IX
;=======
 
	EXTERNAL	Z_DRM3,Z_EDR3,Z_KEY3,Z_KES3,Z_SCH3
 
STTTAB
	DEFB	ASCIBS		;CHRDEL
	DEFB	ASCDEL		;LINDEL
	DEFB	18H			;INPDEL (^X)
	DEFB	10H			;DEL (^P)
	DEFB	13H			;XOFF (^S)
	DEFB	11H			;XON (^Q)
	DEFB	0FH			;KILL (^O)
	DEFB	1			;LFCNT
	DEFB	1			;NULLCT
	DEFB	0FFH			;ECHO (ON)
	DEFW	Z_DRM3		;DRUM (TAB-DRUM)
	DEFW	Z_EDR3		;EDRUM (END OF TAB-DRUM)
	DEFW	Z_KEY3		;KEYSM
	DEFW	Z_KES3		;KEYSAV
	DEFW	Z_SCH3		;SCHR
	DEFW	0			;GCHR
	DEFB	26H			;CONSTT
	DEFB	0			;OUTSTT
	DEFB	0			;CURSOR
	DEFB	0			;--
ASTTAB	EQU	$-STTTAB
 
	DEFW	0			;IQ (TYPE AHEAD RING)
	DEFW	0			;TIQ (TOP OF Z_IQ0)
	DEFW	0			;FIQ (^FRONT OF RING)
	DEFW	0			;EIQ (^END OF RING)
	DEFW	0			;LIQ (LENGTH OF RING)
LSTTAB	EQU	$-STTTAB
 
;=======
; Z_ALM3 - WRITE ALARM ON CONSOLE # 3
;=======
 
	GLOBAL	Z_ALM3
	EXTERNAL	Z_SGNL
	EXTERNAL	Z_A3SM,Z_A3ST
 
Z_ALM3
	LD	DE,Z_A3ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,ASTTAB
	LDIR
	LD	HL,Z_A3ST+OUTSTT
	SET	0,(HL)		;THIS IS AN ALARM PROCESS
 
; MAIN LOOP
 
	LD	IX,Z_A3ST		;IX:=^STATUS-TABLE
ALMLOP
	LD	DE,Z_A3SM		;WAIT AT ALARM-SEMAPHORE
	CALL	Z_CON
	JR	ALMLOP
 
;-------
; Z_GCI3 - RECEIVE HANDLING
;
; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
;          CY = 0  IF NOT
;
; TO BE CALLED BY RECEIVE-INTERRUPT
;-------
 
	GLOBAL	Z_GCI3
	EXTERNAL	Z_GCI
 
Z_GCI3
	PUSH	IX
	LD	IX,Z_C3ST
	JP	Z_GCI
