*H CPU-RELATED COMMANDS
;UPDATED: 820127 / PH
;FILE:    RTZ.DBG.CPU.S
;REV:     2.00
 
;=======
; H_REG - EXAMINE CPU-REGISTERS
;=======
 
	EXTERNAL	Z$TPCB,Z$REGF,Z$OBPT,Z$OOBP,Z$OREG
 
H_REG
	CALL	CHKTP
	PUSH	DE
	POP	IX
	CALL	PPRCST
	XOR	A
	LD	(Z$OBUF),A
	LD	HL,XREG		;HL:=^ASCII-NAMES OF REGISTERS
	LD	DE,Z$$A		;DE:=^CURRENT REGISTER CONTENT
EREG10
	LD	A,(HL)		;END OF REGISTERS ?
	INC	A
	JP	Z,EREG90		;YES
	DEC	A			;RESTORE A
	PUSH	HL
	PUSH	DE
	LD	DE,Z$OBUF+1
	LDI				;MOVE REGNAME TO Z$OBUF
	JP	P,EREG15
	LDI				;DOUBLE REGISTER
EREG15
	EX	DE,HL		;HL:=^Z$OBUF.CUR
	LD	(HL),'='
	INC	HL
	EX	(SP),HL		;HL:=^REGISTER VALUE
	OR	A			;DOUBLE REGISTER ?
	JP	P,EREG20		;NO
	LD	E,(HL)		;YES, DE:=16-BIT VALUE
	INC	HL
	LD	D,(HL)
	DEC	HL
	EX	(SP),HL		;HL:=^Z$OBUF.CUR
	CALL	PUT16_
	JR	EREG25
EREG20
	LD	A,(HL)		;A:=REGISTER  VALUE
	EX	(SP),HL		;HL:=^Z$OBUF.CUR
	CALL	PUT8_
EREG25
	LD	(HL),0FFH
	CALL	OTOBUF
	CALL	STOZ80
	LD	HL,SKIP
	CALL	GETVAL		;DE:=NEW VALUE
	CALL	LODZ80
	POP	HL			;HL:=^REGISTER VALUE
	LD	(HL),E		;UPDATE REGISTER VALUE
	INC	HL
	POP	BC			;BC:=^XREG.CUR
	LD	A,(BC)		;DOUBLE REGISTER ?
	OR	A
	JP	P,EREG30		;NO
	LD	(HL),D		;YES, ONE BYTE MORE
	INC	HL
EREG30
	LD	A,0			;NO <CR>
EREG50
	LD	(Z$OBUF),A
	EX	DE,HL		;DE:=^REGISTER VALUE
	LD	L,C			;HL:=^XREG.CUR
	LD	H,B
	INC	HL			;NEXT REGISTER
	JP	P,EREG10		;8-BIT REGISTER
	INC	HL
	JP	EREG10
SKIP
	CALL	LODZ80
	POP	HL			;HL:=^REGISTER VALUE
	INC	HL
	POP	BC			;BC:=^XREG.CUR
	LD	A,(BC)		;DOUBLE REGISTER ?
	OR	A
	JP	P,SKIP50		;NO
	INC	HL
SKIP50
	LD	A,0DH
	JR	EREG50
EREG90
	CALL	STOZ80		;RESTORE USER REGISTERS
	JR	OUTCR
 
XREG
	DEFM	'acbedlhf'
	DEFB	'i'+80H
	DEFB	'x'
	DEFB	'i'+80H
	DEFB	'y'
	DEFB	0FFH
 
;=======
; PPRCST - PRINT PROCESS STATUS
;
; Accepts: IX = ^PCB
;=======
 
	EXTERNAL	Z$OBUF
 
PPRCST
	LD	HL,Z$OBUF		;PRINT PROCESS NAME
	LD	DE,XPROC
	CALL	PUTSTR
	CALL	PUTNAM
	LD	(HL),0FFH
	CALL	OTOBUF
	CALL	DALREG
	LD	HL,(Z$$PC)
	CALL	PRINST
OUTCR
	LD	HL,XCR
	CALL	OUTSTR
	RET
 
XPROC 	DEFM	'Process: '
      	DEFB	0FFH
XCR   	DEFW	0FF0DH
 
;=======
; DALREG - DISPLAY ALL Z80-REGISTERS
; DCHREH - DISPLAY CHANGED Z80-REGISTERS
;=======
 
	EXTERNAL	Z$OBUF
 
DALREG
	LD	A,0FFH
	JR	REG05
DCHREG
	XOR	A
REG05
	CALL	LODZ80
	LD	(Z$REGF),A	;SWITCH FOR ALL/CHANGED REG
	LD	HL,Z$OBUF		;SET UP Z$OBPT
	LD	(HL),0DH
	INC	HL
	LD	(Z$OBPT),HL
	LD	HL,REGASC		;HL:=^REGISTERNAMES IN ASCII
	LD	DE,Z$$A		;DE:=^CURRENT VALUE
	LD	BC,Z$OREG		;BC:=^LATEST VALUE DISPLAYED
REG10
	LD	A,(HL)		;END OF REGISTERS ?
	OR	A
	JP	M,OTOBUF		;YES, DISPLAY LINE
	PUSH	DE			;SAVE ^CURRENT VALUE
	PUSH	AF
	LD	DE,(Z$OBPT)	;DE:=^Z$OBUF.CUR
	LD	(Z$OOBP),DE	;SAVE THIS IN CASE OF NO CHANGE
	LD	(DE),A		;MOVE REGNAME TO OUTBUF
	INC	DE
	INC	HL
	LD	A,(HL)
	LD	(DE),A
	INC	DE
	LD	A,'='		;PUT OUT EQUAL SIGN
	LD	(DE),A
	INC	DE
	INC	HL
	POP	AF			;GET FIRST LETTER IN REG-NAME
	EX	(SP),HL		;HL:=^CURRENT VALUE
	PUSH	BC
	PUSH	HL
	CP	'a'
	JR	Z,REG_A
	CP	'f'
	JP	Z,REG_F
	LD	A,(HL)		;FETCH REG-VALUE
	INC	HL
	LD	H,(HL)
	LD	L,A
	EX	DE,HL
	CALL	PUT16
REG90
	INC	HL
	LD	(HL),0FFH
	LD	(Z$OBPT),HL	;UPDATE ^Z$OBUF.CUR
	POP	HL
	POP	BC
	LD	A,(BC)
	XOR	(HL)
	LD	D,A
	LD	A,(HL)
	LD	(BC),A
	INC	HL
	INC	BC
	LD	A,(BC)
	XOR	(HL)
	OR	D
REGA1
	LD	D,A
	LD	A,(HL)
	LD	(BC),A
	INC	BC
	INC	HL
	LD	A,(Z$REGF)
	OR	D			;UPDATE OF DISPLAY ?
	PUSH	BC		
	PUSH	HL
	JR	NZ,REGC5		;YES
	LD	HL,(Z$OBPT)	;NO, CLEAR LATEST PART OF --
	LD	DE,(Z$OOBP)	;  Z$OBUF
	AND	A
	SBC	HL,DE
	LD	B,L
	LD	A,' '
REG20
	LD	(DE),A
	INC	DE
	DJNZ	REG20		;REPEAT
REGC5
	POP	DE
	POP	BC
	POP	HL
	JR	REG10
 
REG_F
	LD	BC,FLAGS		;HANDLE FLAGS
	DEC	DE
	DEC	DE
	DEC	DE
	PUSH	HL
	LD	L,(HL)
	EX	DE,HL		;HL:=^Z$OBUF.CUR, E:=FLAG-VALUES
REGD2
	LD	A,(BC)
	INC	BC
	OR	A			;FLAG-BIT ?
	JR	Z,REG9R		;READY
	JP	M,REGE4		;NO
	LD	(HL),A
	LD	A,E
	OR	A
	JP	M,REGE3
	LD	(HL),'.'
REGE3
	INC	HL
REGE4
	RLC	E
	JR	REGD2
REG9R
	INC	HL
	LD	(HL),'f'
	INC	HL
	LD	(HL),'='
	INC	HL
	INC	HL
	EX	DE,HL
	POP	HL
 
; HANDLE REGISTER A
 
REG_A
	LD	A,(HL)
	EX	DE,HL
	DEC	HL
	CALL	PUT8_
	LD	(HL),0FFH		;END OF STRING
	LD	(Z$OBPT),HL
	POP	HL
	POP	BC
	LD	A,(BC)
	XOR	(HL)
	JR	REGA1
 
REGASC
	DEFB	'a'
	DEFB	'='
	DEFM	'bcdehlf'
	DEFB	0
	DEFM	'ixiysp'
	DEFB	0FFH
 
FLAGS
	DEFM	'SZ'
	DEFB	080H
	DEFB	'A'
	DEFB	80H
	DEFB	'P'
	DEFB	80H
	DEFB	'C'
	DEFB	0
 
PALCPU	LD	A,0FFH
	JR	A_185C
PCHCPU	XOR	A
A_185C
	CALL	FR4680
	JP	REG05
 
;=======
; LODZ80 - MOVE Z80-REG FROM STACK TO DISPLAY-ORDER
;
; ACCEPTS: IX = ^PCB
;
; Affects: F
;=======
 
	EXTERNAL	Z$$A,Z$$F,Z$$BC,Z$$DE,Z$$HL,Z$$IX,Z$$IY,Z$$SP,Z$$PC
 
LODZ80
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	L,(IX+PCBSP)	;HL:=^USER STACK
	LD	H,(IX+PCBSP+1)
	LD	DE,Z$$IY
	LDI
	LDI
	LD	DE,Z$$IX
	LDI
	LDI
	LD	DE,Z$$DE
	LDI
	LDI
	LD	DE,Z$$BC
	LDI
	LDI
	LD	DE,Z$$F
	LDI
	LD	DE,Z$$A
	LDI
	LD	DE,Z$$HL
	LDI
	LDI
	LD	DE,Z$$PC
	LDI
	LDI
	LD	(Z$$SP),HL
	POP	HL
	POP	DE
	POP	BC
	RET
 
;=======
; STOZ80 - STORE Z80-REG IN USER STACK
;
; Affects: F
;=======
 
STOZ80
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	DE,(Z$$SP)
	DEC	DE
	LD	HL,Z$$PC+1
	LDD
	LDD
	LD	HL,Z$$HL+1
	LDD
	LDD
	LD	HL,Z$$A
	LDD
	LD	HL,Z$$F
	LDD
	LD	HL,Z$$BC+1
	LDD
	LDD
	LD	HL,Z$$DE+1
	LDD
	LDD
	LD	HL,Z$$IX+1
	LDD
	LDD
	LD	HL,Z$$IY+1
	LDD
	LDD
	POP	HL
	POP	DE
	POP	BC
	RET
 
;=======
; TO4680 - MOVE Z80-REG FROM STACK TO 4680-ORDER
;
; ACCEPTS: IX = ^PCB
;
; AFFECTS: DE,BC
;=======
 
	EXTERNAL	Z$AF,Z$BC,Z$DE,Z$HL,Z$IX,Z$IY,Z$SP,Z$PC
 
TO4680
	PUSH	HL
	LD	L,(IX+PCBSP)	;HL:=^USER STACK
	LD	H,(IX+PCBSP+1)
	LD	DE,Z$IY
	LDI
	LDI
	LD	DE,Z$IX
	LDI
	LDI
	LD	DE,Z$DE
	LDI
	LDI
	LD	DE,Z$BC
	LDI
	LDI
	LD	DE,Z$AF
	LDI
	LDI
	LD	DE,Z$HL
	LDI
	LDI
	LD	DE,Z$PC
	LDI
	LDI
	LD	(Z$SP),HL
	POP	HL
	RET
 
;=======
; FR4680 - MOVE Z80-REG TO STACK FROM 4680-ORDER
;
; AFFECTS: DE,HL,BC
;=======
 
FR4680
	LD	DE,(Z$SP)
	DEC	DE
	LD	HL,Z$PC+1
	LDD
	LDD
	LD	HL,Z$HL+1
	LDD
	LDD
	LD	HL,Z$AF+1
	LDD
	LDD
	LD	HL,Z$BC+1
	LDD
	LDD
	LD	HL,Z$DE+1
	LDD
	LDD
	LD	HL,Z$IX+1
	LDD
	LDD
	LD	HL,Z$IY+1
	LDD
	LDD
	INC	DE
	LD	(IX+PCBSP),E
	LD	(IX+PCBSP+1),D
	RET
