*H DISASSEMBLER
;UPDATED: 820111 / PH
;FILE:    RTZ.DBG.DIS.S
 
	;REVISIONS LIST:
	;
	; REV 1.0:	ORIGINAL VERSION
	; REV 1.1:	LINE FEEDS REMOVED	790217
	;		SHORTENED		790218
	; REV 1.2:	OPERANDS TABBED FROM
	;		MNEMONIC		790218
	; REV 1.3:	ADDRESSES WRITTEN
	;		IN PROPER FORMAT	790225
	; REV 2.0:	COMPLETELY REARRANGED
	;		AND SHORTENED		790315
	; REV 2.1:	MULTIPLE RST 38:S
	;		TREATED AS DEFS		790316
	; REV 2.2:	BLANK LINES AFTER 
	;		JUMPS & RETURNS		790317
	; REV 2.3:	MORE USE OF TABS	790320
	; REV 2.35:	REARRANGED FOR SINGEL
	;		LINE DISASM.		790907
 
	;	   THIS MODULE IS A SUBROUTINE WHICH 
	;	PROVIDES ALL THE RELEVANT FEATURES OF
	;	A DISASSEMBLER.
 
	;	   THE ACTION PERFORMED IS TO CONVERT A
	;	MACHINE CODE INSTRUCTION, POINTED TO BY
	;	IX, INTO AN ASSEMBLER SOURCE STATE-
	;	MENT STRING, WHICH IS PLACED AT IY. 
*E
 
TAB	EQU 9		;RIO TAB CHARACTER
 
DISM
	LD HL,HL_0	;SET UP 'HL' STRING
	LD DE,HL_	;DESTINATION
	LD BC,4		;MOVE 4 CHARS
	LDIR
	LD HL,PHLP_0	;SET UP '(HL)' STRING
	LD DE,PHLP_	;DESTINATION
	LD BC,7
	LDIR
	LD HL,INSTAB	;POINT TO PRIMARY INSTR TABLE
	LD A,(IX)	;GET 1:ST INSTR BYTE
JPSRCH	CALL ADSRCH	;GET JUMP ADDRESS
	JP (HL)		;GO TO IT
 
*H COMMON SUBROUTINES
 
	;ADSRCH SEARCES A  TABLE FOR MATCH WITH SPECIFIED
	;BITS OF A, THEN RETURNS WITH A CORRESPONDING ADD-
	;RESS IN HL
 
ADSRCH	PUSH AF
	XOR (HL)	;PATTERN
	INC HL
	AND (HL)	;MASK BITS
	INC HL
	JR Z,FOUND
	INC HL		;SKIP OVER ADDRESS
	INC HL
	POP AF
	JR ADSRCH
FOUND
	LD A,(HL)	;LO BYTE
	INC HL
	LD H,(HL)	;HI
	LD L,A
	POP AF
	RET
 
	;THE FOLLOWING WRITES THE LEFT FIELDS OF 1, 2, 3 AND 4
	;BYTE INSTRUCTIONS TO OUTPUT STRING
 
SINBYT	LD B,1		;SINGLE BYTE
	JR WRLEFT
 
DULBYT	LD B,2		;DUAL BYTE
	JR WRLEFT
 
TRIBYT	LD B,3		;TRIPLE BYTE
	JR WRLEFT
 
QADBYT	LD B,4		;QUAD BYTE
 
	;WRLEFT WRITES LEFT FIELDS FOR (B) BYTE
	;INSTRUCTIONS
 
WRLEFT	PUSH AF
NOLEFT	INC IX		;STEP UP INSTR POINTER
	DJNZ NOLEFT	;LOOP FOR INSTR LGT
	LD A,TAB	;WRITE TAB
	CALL WRA
	POP AF		;RESTORE INSTR BYTE TO A
	RET
 
	;WRBYT WRITES CONTENTS OF A TO STRING
	;AS TWO HEX DIGITS
 
WRBYT	PUSH AF		;SAVE BYTE
	RRCA		;SHIFT RGT 4
	RRCA
	RRCA
	RRCA
	CALL WRDIG
	POP AF
 
	;WRDIG WRITES FOUR LOW BITS OF A AS HEX DIGIT
 
WRDIG	PUSH AF
	AND 0FH		;MASK LO DIG
	ADD A,90H	;CONVERT TO ASCII
	DAA
	ADC A,40H
	DAA
	CALL WRA
	POP AF
	RET
 
	;LINEND PUTS A SPACE IN STRING
 
LINEND	LD A,' '
 
	;WRA WRITES CONTENTS OF A TO STRING
 
WRA	LD (IY),A
	INC IY
	RET
 
	;WRVAL WRITES A 2-BYTE VALUE IN DE TO
	;STRING WITH LEADING 0
	;IF NECESSARY
 
WRVAL	PUSH AF		;SAVE REGS
	PUSH HL
	LD HL,9		;LESS THAN 10?
	AND A
	SBC HL,DE
	POP HL
	JR NC,ONEDIG	;NO '0' OR 'H'
	LD A,D		;HI BYTE
	RRA		;SHIFT DOWN HI DIGIT
	RRA
	RRA
	RRA
	LD B,0		;MAKE SURE B ZERO AT START
	CALL WRDIG?	;PUT DIGIT
	LD A,D		;GET LO DIGIT
	CALL WRDIG?	;PUT IT
	LD A,E
	RRA
	RRA
	RRA
	RRA
	CALL WRDIG?
	LD A,E
	CALL WRDIG?
	POP AF
	RET
 
ONEDIG	LD A,E
	CALL WRDIG	;PUT THE SINGLE DIGIT
	POP AF
	RET
 
	;WRDIG? WRITES HEX DIGIT. IF NO EARLIER DIGIT
	;WRITTEN, AND THIS DIGIT > 9, INSERTS '0' BEFORE IT
 
WRDIG?	AND 0FH		;MASK LOW NYBBLE
	PUSH AF
	XOR A		;0 BYTE
	CP B		;ALL EARLIER WERE 0?
	JR NZ,NFIRST	;IF NOT, JUMP
	POP AF		;GET DIGIT
	AND A		;THIS ONE 0 TOO?
	RET Z		;IF Y, JUST RETURN
	CP 10		;SHOULD '0' BE INSERTED?
	JR C,NLEAD0
	LD (IY),'0'	;INSERT LEADING ZERO
	INC IY
NLEAD0	INC B		;SIGNAL A DIGIT WRITTEN
	JR WRDIG	;WRITE DIGIT & RETURN
 
NFIRST	POP AF		;WRITE DIGIT UNCONDITIONALLY
	JR WRDIG
 
	;WRWORD WRITES 2 BYTES FROM (IX-2) TO STRING
	;'0' & 'H' INSERTED IF APPLICABLE
	
WRWORD	LD E,(IX-2)
	LD D,(IX-1)
	JR WRVAL
 
	;WR1VAL WRITES CONTENTS OF A TO STRING WITH
	;LEADING '0' & TRAILING 'H' IF NECESSARY
 
WR1VAL	PUSH DE		;SAVE REG
	LD D,0
	LD E,A
	CALL WRVAL
	POP DE
	RET
 
	;WRLD WRITES 'LD ' TO STRING
 
WRLD	LD HL,LD_
 
	;STRWR WRITES THE STRING POINTED TO BY HL
	;OUTPUT STRING. STRING ENDS WITH AN ASCII
	;CHAR WITH BIT 7 SET
 
STRWR	PUSH AF		;SAVE
STWRLP	LD A,(HL)	;GET ONE CHAR
	BIT 7,A		;ENDING CHAR?
	RES 7,A		;KILL SIGNAL BIT
	CALL WRA	;WRITE IT (NO FLAGS DESTROYED)
	INC HL		;POINT TO NEXT
	JR Z,STWRLP	;JUMP IF IT WAS NO END CHAR
	POP AF		;ELSE RETURN
	RET
 
	;FINSRG FINDS AND WRITES SINGLE REG NAME 
	;ACCORDING TO 3 LOWEST BITS OF A
	
FINSRG	AND 7		;MASK REG BITS
	LD HL,SRGTAB	;TABLE OF SINGLE REGS
 
	;STSRCH SEARCHES A TABLE FOR A BYTE. WHEN FOUND,
	;WRITES THE STRING AT THE CORRESPONDING ADDRESS
	
STSRCH	CALL ADSRCH	;FIND THE ADDRESS
	JR STRWR	;WRITE THE STRING
 
	;FINDRG FINDS AND WRITES DOUBLE REG NAME
	;ACCORDING TO BITS 4 & 5 OF A
 
FINDRG	AND 30H		;MASK REG BITS
	LD HL,DRGTAB	;POINT TO DOUBLE REG TABLE
	JR STSRCH
 
	;FINCC FINDS AND WRITES CONDITION CODE
	;ACCORDING TO BIT 3, 4 & 5 OF A
 
FINCC	AND 38H		;MASK CONDITION BITS
	LD HL,CCTAB	;POINT TO COND CODE TABLE
	JR STSRCH
 
	;WRDEST WRITES DESTINATION ADDRESS FOR
	;RELATVIE JUMPS
 
WRDEST	LD E,A		;DISPLACEMENT TO E
	LD D,0
	BIT 7,E		;NEGATIVE OR POSITIVE?
	JR Z,NOTNEG
	LD D,0FFH	;TAKE CARE OF NEGATIVE JUMPS
NOTNEG	PUSH IX		;INSTR POINTER TO HL
	POP HL
	ADD HL,DE
	EX DE,HL	;PUT IN DE
	JP WRVAL	;WRITE VALUE TO STRING
 
*H INSTRUCTION ROUTINES
 
	;ALL UNIMPLEMENTED CPU INSTRUCTIONS
	;TREATED AS DEFINE BYTE
 
DEFINB	CALL SINBYT	
	LD HL,DEFB_	;STRING
	CALL STRWR
	LD A,(IX-1)	;GET BYTE VALUE
	CALL WR1VAL	;WRITE IT
	JP LINEND
 
	;ALL SPECIAL ONE-BYTE INSTRS
 
SPEC	CALL SINBYT
	LD HL,SPCTAB	;FIND STRING AND WRITE IT
	CALL STSRCH
	JP LINEND	;TERM LINE & RETURN
 
	;LD R,R ; LD R,(HL) ;LD (HL),R
 
LDRR	CALL SINBYT
	CALL WRLD
	PUSH AF		;SAVE INS BYTE
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE DEST REG NAME
	LD A,','	;A COMMA
	CALL WRA	;WRITE IT
	POP AF		;GET INS BYTE
	CALL FINSRG	;WRITE SOURCE REG
	JP LINEND	;TERM LINE, RETURN
 
	;ADD A,R ;ADC A,R ;SUB R ;SBC A,R ;AND R ;
	;XOR R ;OR R; CP R
 
ADCP	CALL SINBYT
	PUSH AF		;SAVE INS BYTE
	AND 38H		;MASK REG BITS
	LD HL,ACPTAB	;WRITE MNEMONIC
	CALL STSRCH
	POP AF		;GET INS BYTE
	CALL FINSRG	;WRITE REG NAME
	JP LINEND	;TERM LINE & RETURN
 
	;INC R
 
SRINC	CALL SINBYT
	LD HL,INC_	;WRITE MNEM
	JR SINDE
 
	;DEC R
 
SRDEC	CALL SINBYT
	LD HL,DEC_	;WRITE MNEM
SINDE	CALL STRWR
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
 
	;RST NN
 
RST	CALL SINBYT
	LD HL,RST_	;WRITE MNEM
	CALL STRWR
	AND 38H		;MASK DEST BITS
	CALL WR1VAL	;WRITE JUMP ADR
	JP LINEND	;TERM & RETURN
 
	;INC DD
 
DRINC	CALL SINBYT
	LD HL,INC_	;WRITE MNEM
	JR DINDE
 
	;DEC DD
 
DRDEC	CALL SINBYT
	LD HL,DEC_	;WRITE MNEM
DINDE	CALL STRWR
	CALL FINDRG	;WRITE DREG NAME
	JP LINEND
 
	;ADD HL,DD
 
ADHDR	CALL SINBYT
	LD HL,ADDHL_	;WRITE MNEM
	JR DINDE
 
	;RET CC
 
RETCC	CALL SINBYT
	LD HL,RET_	;WRITE MNEM
	CALL STRWR
	CALL FINCC
	JP LINEND
 
	;PUSH DD
 
PUSH	CALL SINBYT
	LD HL,PUSH_	;MNEM
	JR PUPOP
 
	;POP DD
 
POP	CALL SINBYT
	LD HL,POP_
PUPOP	CALL STRWR
	AND 30H		;MASK DREG BITS
	LD HL,DAFTAB	;WRITE DREG NAME
	CALL STSRCH
	JP LINEND
 
	;LD R,N ;LD (HL),N
 
LDRN	CALL DULBYT
	CALL WRLD	;MNEM
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	LD A,','	;COMMA
	CALL WRA
	LD A,(IX-1)	;GET VALUE BYTE
	CALL WR1VAL	;WRITE IT
	JP LINEND
 
	;DJNZ N
 
DJNZ	CALL DULBYT
	LD HL,DJNZ_	;MNEM
DJNEND	CALL STRWR
RELEND	LD A,(IX-1)	;GET DISPLACEMENT
	CALL WRDEST	;WRITE DEST ADDRESS
	JP LINEND
 
	;JR ; JR CC
 
JREL	CALL DULBYT
	LD HL,JR_	;MNEM
	CALL STRWR
	BIT 5,A		;CONDITIONAL?
	JR Z,RELEND
	AND 18H		;MASK CC BITS
	CALL FINCC	;WRITE CC
	LD A,','	;COMMA
	CALL WRA
	JR RELEND
 
	;ADD A,N; ADC A,N; SUB N; SBC A,N; AND N
	;XOR N; OR N; CP N
 
ADCPN	CALL DULBYT
	AND 38H		;MASK MNEM BITS
	LD HL,ACPTAB	;WRITE MNEM
	CALL STSRCH
	LD A,(IX-1)	;GET VALUE
	CALL WR1VAL
	JP LINEND 
 
	;CALL CC,NN
 
CALLCC	CALL TRIBYT
	LD HL,CALL_	;MNEM
CACC1	CALL STRWR
	CALL FINCC	;WRITE CC
	LD A,','	;COMMA
	CALL WRA
	CALL WRWORD	;WRITE DEST ADDRESS
	JP LINEND
 
	;JP CC,NN
 
JPCC	CALL TRIBYT
	LD HL,JP_	;MNEM
	JR CACC1
 
	;LD DD,NN
 
LDDRNN	CALL TRIBYT
	CALL WRLD	;MNEM
	CALL FINDRG	;WRITE DREG
	LD A,','	;COMMA
	CALL WRA
	CALL WRWORD	;WRITE VALUE
	JP LINEND
 
	;OUT N(N),A
 
OUT	CALL DULBYT
	LD HL,OUT_	;MNEM
	CALL STRWR
	LD A,(IX-1)	;PORT #
	CALL WR1VAL	;WRITE IT
	LD HL,OUTND_	;STRING ',A'
	CALL STRWR
	JP LINEND
 
	;IN A,(N)
 
IN	CALL DULBYT
	LD HL,IN_	;MNEM
	CALL STRWR
	LD A,(IX-1)	;GET PORT #
	CALL WR1VAL
	LD A,')'
	CALL WRA
	JP LINEND
 
	;CALL NN
 
CALL	CALL TRIBYT
	LD HL,CALL_
CALEND	CALL STRWR
	CALL WRWORD	;WRITE DESTINATION
	JP LINEND
 
	;JP NN
 
JP	CALL TRIBYT
	LD HL,JP_
	JR CALEND
 
	;LD (NN),A; LD(NN),HL
 
LDNREG	CALL TRIBYT	;
	CALL WRLD	;MNEM
	PUSH AF
	LD A,'('
	CALL WRA
	CALL WRWORD	;WRITE MEM ADDRESS
	LD A,')'
	CALL WRA
	LD A,','	;A COMMA
	CALL WRA
	POP AF	
	BIT 4,(IX-3)	;TEST HL/A BIT
	JR Z,$+10
	LD A,'A'
	CALL WRA
	JP LINEND
	LD HL,HL_
	CALL STRWR
	JP  LINEND
	
	;LD A,(NN); LD HL,(NN)
 
LDREGN	CALL TRIBYT
	CALL WRLD
	LD HL,HL_
	BIT 4,(IX-3)	;TEST HL/A BIT
	JR Z,$+5
	LD HL,A_
	CALL STRWR
	LD A,','	;COMMA
	CALL WRA
	LD A,'('
	CALL WRA
	CALL WRWORD
	LD A,')'
	CALL WRA
	JP LINEND
 
	;RLC; RRC; RL; RR; SLA; SRA; SRL;
	;BIT; SET; RES
 
CBINS	LD A,(IX+1)	;GET 2:ND INS BYTE
	LD HL,CBTAB
	JP JPSRCH	;JUMP ACCORDING TO OP-CODE
 
	;BIT B,R; BIT B,(HL)
 
BITINS	CALL DULBYT
	LD HL,BIT_
	JR BITEND
 
	;RES B,R; RES B,(HL)
 
RESINS	CALL DULBYT
	LD HL,RES_
	JR BITEND
 
	;SET B,R; SET B,(HL)
 
SETINS	CALL DULBYT
	LD HL,SET_
BITEND	CALL STRWR
	PUSH AF
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	AND 07H		;MASK BIT NUMBER
	CALL WRDIG	;WRITE IT
	LD A,','	;COMMA
	CALL WRA
	POP AF
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
 
	;RLC ;RRC; RL; RR;SLA; SRA; SRL
 
SHIROT	CALL DULBYT
	LD HL,SHRTAB
	CALL STSRCH	;WRITE MNEM
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
	
	;INSTRUCTIONS STARTING WITH HEX ED
 
EDINS	LD HL,EDTAB	;TABLE FOR THESE INSTRS
	LD A,(IX+1)	;GET 2:ND INS BYTE
	JP JPSRCH	;JUMP ACC TO PATTERN
 
	;ALL SPECIAL ED INSTRUCTIONS
 
EDSPEC	CALL DULBYT
	LD HL,EDSTAB	;TABLE WITH STRING ADDRESSES
	LD A,(IX-1)	;GET 2:ND BYTE
	CALL STSRCH	;WRITE STRING
	JP LINEND
 
	;SBC HL,DD
 
SBCHLD	CALL DULBYT
	LD HL,SBCHL_	;STRING
	CALL STRWR
	LD A,(IX-1)	;GET 2:ND BYTE
	CALL FINDRG	;WRITE REG NAME
	JP LINEND
 
	;ADC HL,DD
 
ADCHLD	CALL DULBYT
	LD HL,ADCHL_	;STRING
	CALL STRWR
	LD A,(IX-1)	;GET 2:ND BYTE
	CALL FINDRG	;WRITE REG NAME
	JP LINEND
 
	;IN R,(C)
	
EDIN	CALL DULBYT
	LD HL,EDIN_	;STRING
	CALL STRWR
	RRCA
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	LD HL,CPCP_	;STRING ',(C)'
	CALL STRWR
	JP LINEND
 
	;OUT (C),R
 
EDOUT	CALL DULBYT
	LD HL,EDOUT_	;MNEMONIC
	CALL STRWR
	RRCA		;RIGHT 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
 
	;LD DR,(NN)
 
LDDRAD	CALL QADBYT
	CALL WRLD
	LD A,(IX-3)	;GET 2:ND INS BYTE
	CALL FINDRG	;WRITE REG NAME
	LD HL,IN_+4	;STRING ',C'
	CALL STRWR
	CALL WRWORD	;WRITE ADDRESS
	LD A,')'
	CALL WRA
	JP LINEND
 
	;LD (NN),DR
 
LDADDR	CALL QADBYT
	CALL WRLD
	LD A,'('	;PARANTH.
	CALL WRA
	CALL WRWORD	;WRITE ADDRESS
	LD A,')'	;PARANTH.
	CALL WRA
	LD A,','	;COMMA
	CALL WRA
	LD A,(IX-3)	;GET 2:ND INS BYTE
	CALL FINDRG	;WRITE REG NAME
	JP LINEND
 
	;FOR INDEX IX AND IY INSTRUCTIONS
	;MODIFY STRINGS 'HL' TO 'IX' OR 'IY',
	;AND '(HL)' TO '(IX+00H)' OR '(IY+00H)'
 
INDEX	LD HL,ADDIX_+5	;STRING 'ADD IX,'
	LD (HL),'X'	;INIT IT TO 'IX'
	LD HL,PIXP_0	;'(IX+00H)' STRING
	PUSH HL
	LD HL,IX_0	;'IX' STRING
	BIT 5,(IX)	;IS IT ACTUALLY IX OR IY?
	JR Z,NOTIY
	LD HL,ADDIX_+5	;STRING 'ADD IX,'
	LD (HL),'Y'	;CHANGE TO 'IY'
	POP HL
	LD HL,PIYP_0	;'(IY+00H)' STRING
	PUSH HL
	LD HL,IY_0	;'IY' STRING
NOTIY	LD DE,HL_	;DESTINATION
	LD BC,3		;3 CHARS TO MOVE
	LDIR
	POP HL
	LD DE,PHLP_	;DESTINATION
	LD BC,9		;9 CHARS TO MOVE
	LDIR
	PUSH IY		;SAVE OUTSTRING PTR
	LD IY,PHLP_+3	
	LD A,(IX+2)	;GET DISPLACEMENT BYTE
	AND A		;SET FLAGS
	JR Z,ZERDIS	;ZERO DISPLACEMENT?
	BIT 7,A		;POS OR NEG?
	LD A,'+'
	JR Z,POSDI1	;JUMP IF POSITIVE
	LD A,'-'	;NEGATIVE!
POSDI1	CALL WRA	;WRITE
	LD A,(IX+2)	;GET BYTE AGAIN
	JR Z,POSDI2	;FLAGS UNCHANGED
	NEG		;NEGATIVE -> POSITIVE
POSDI2	CALL WR1VAL	;WRITE VALUE
ZERDIS	LD A,')'+80H	
	CALL WRA
	POP IY		;RESTORE STRING PTR
	
	LD A,(IX+1)	;GET 2:ND BYTE
	LD HL,IXTAB	;SEARCH FOR IT IN A TABLE
	JP JPSRCH	;FIND ADDR & JUMP TO IT
 
IXCB?	LD A,(IX+3)	; 4:TH MUST BE XXXXX110B
	AND 07H
	CP 06H
	JP NZ,DEFINB	;WAS IT X6H OR XEH?
	LD A,(IX+3)	;4:TH MUST NOT BE 36H
	CP 36H
	JP Z,DEFINB
 
	;IT WAS A LEGAL INDEX BIT OR 
	;SHIFT/ROTATE INSTRUCTION
 
IXCB	CALL QADBYT	;MAKE LEFT COLUMNS
	LD A,(IX-1)	;GET LAST OP BYTE
	LD HL,CBTAB	;TABLE WITH JUMP ADDRESSES
	CALL ADSRCH	;SEARCH JUMP ADDRESS
	INC HL		;INC BY 3 TO AVOID 
	INC HL		;'CALL DULBYT' IN THE RE-
	INC HL		;SPECTIVE ROUTINES
	JP (HL)		;MAKE THE SOURCE CODE
 
ADXDR	CALL DULBYT	;WRITE LEFT COLS
	LD HL,ADDIX_	;POINT TO STRING
	JP DINDE	;CONTINUE
 
LDRX	CALL TRIBYT	;LEFT COLS
	JP LDRR+3	;CONTINUE IN LDRR ROUTINE
 
ADCPX	CALL TRIBYT	;LEFT COL:S
	JP ADCP+3	;CONTINUE IN ADCP ROUTINE
 
LDIXNN	CALL QADBYT	;LEFT COL:S
	JP LDDRNN+3
 
LDNRGX	CALL QADBYT	;LEFT COL:S
	JP LDNREG+3
 
DRINCX	CALL DULBYT	;LEFT COL:S
	JP DRINC+3
 
DRDECX	CALL DULBYT	;LEFT COL:S
	JP DRDEC+3
 
LDRGNX	CALL QADBYT	;LEFT COL:S
	JP LDREGN+3
 
SRINCX	CALL TRIBYT
	JP SRINC+3
 
SRDECX	CALL TRIBYT
	JP SRDEC+3
 
LDRNX	CALL QADBYT
	JP LDRN+3
 
POPX	CALL DULBYT
	JP POP+3
 
PUSHX	CALL DULBYT
	JP PUSH+3
 
EXSPIX	CALL DULBYT
	LD HL,XSPIX_	;POINT TO STRING
	CALL STRWR
	LD HL,HL_
	CALL STRWR
	JP LINEND
 
LDSPIX	CALL DULBYT
	LD HL,LDSH_
	CALL STRWR
	JP LINEND
 
JPIX	CALL DULBYT
	LD HL,JP_	;POINT TO STRING
	CALL STRWR
	LD A,'('
	CALL WRA
	LD HL,HL_
	CALL STRWR
	LD A,')'
	CALL WRA
	JP LINEND
	
*H PRIMARY INS TABLE
	
	;PRIMARY INSTRUCTION TABLE
 
INSTAB	DEFW 0FF76H	;HALT
	DEFW SPEC
 
	DEFW 0DFC9H	;JP (HL) AND RET
	DEFW SPEC
 
	DEFW 0FFFFH	;RST 38H
	DEFW RST
 
	DEFW 0C040H	;LD R,R ;LD (HL),R ;LD R,(HL)
	DEFW LDRR
	
	DEFW 0C080H	;ADD ADC SUB SBC AND OR XOR CP
	DEFW ADCP
 
	DEFW 0C704H	;INC R ;INC (HL)
	DEFW SRINC
	
	DEFW 0C705H	;DEC R ;DEC (HL)
	DEFW SRDEC
	
	DEFW 0C7C7H	;RST N
	DEFW RST
	
	DEFW 0CF03H	;INC DD
	DEFW DRINC
	
	DEFW 0CF0BH	;DEC DD
	DEFW DRDEC
	
	DEFW 0CF09H	;ADD HL,DD
	DEFW ADHDR
	
	DEFW 0C7C0H	;RET CC
	DEFW RETCC
	
	DEFW 0CFC5H	;PUSH DR
	DEFW PUSH
	
	DEFW 0CFC1H	;POP DR
	DEFW POP
 
	DEFW 0C706H	;LD R,N ;LD (HL),N
	DEFW LDRN
 
	DEFW 0FF10H	;DJNZ N
	DEFW DJNZ
 
	DEFW 0F700H	;NOP ; EX AF,AF'
	DEFW SPEC
	
	DEFW 0C700H	;RELATIVE JUMPS
	DEFW JREL
 
	DEFW 0C7C6H	;ADD A,N ; ETC.
	DEFW ADCPN
 
	DEFW 0C7C4H	;CALL CC
	DEFW CALLCC
 
	DEFW 0C7C2H	;JP CC
	DEFW JPCC
 
	DEFW 0CF01H	;LD DR,NN
	DEFW LDDRNN
 
	DEFW 0FFD3H	;OUT (N),A
	DEFW OUT
 
	DEFW 0FFDBH	;IN A,(N)
	DEFW IN
 
	DEFW 0FFCDH	;CALL NN
	DEFW CALL
 
	DEFW 0FFC3H	;JP NN
	DEFW JP
 
	DEFW 0FFCBH	;BIT INSTRS + SHIFTS & ROTATES
	DEFW CBINS
	
	DEFW 0FFEDH	;MISCELLANEOUS
	DEFW EDINS
 
	DEFW 0DFDDH	;IX & IY INSTRUCTIONS
	DEFW INDEX	;
 
	DEFW 0EF22H	;LD (NN),A ;LD (NN),HL
	DEFW LDNREG
 
	DEFW 0EF2AH	;LD A,(NN) ;LD HL,(NN)
	DEFW LDREGN
 
	DEFW 0000H	;ALL OTHER WITHOUT MASK
	DEFW SPEC
 
*H MISCELLANEOUS TABLES
	
	;SINGLE REG TABLE
 
SRGTAB	DEFW 0FF00H	;REG B
	DEFW B_
 
	DEFW 0FF01H	;REG C
	DEFW C_
 
	DEFW 0FF02H	;REG D
	DEFW D_
 
	DEFW 0FF03H	;REG E
	DEFW E_
 
	DEFW 0FF04H	;REG H
	DEFW H_
 
	DEFW 0FF05H	;REG L
	DEFW L_
 
	DEFW 0FF06H	;(HL)
	DEFW PHLP_
 
	DEFW 0007H	;ACCUMULATOR WITH NO MASK
	DEFW A_
 
	;DOUBLE REGISTER TABLE
 
DRGTAB	DEFW 0FF30H	;REG SP
	DEFW SP_
 
DAFTAB	DEFW 0FF30H	;REG AF
	DEFW AF_
 
	DEFW 0FF20H	;REG HL
	DEFW HL_
 
	DEFW 0FF10H	;REG DE
	DEFW DE_
 
	DEFW 0000H	;REG BC WITH NO MASK
	DEFW BC_
 
	;ADD - CP TABLE
 
ACPTAB	DEFW 0FF00H	;ADD A
	DEFW ADDA_
 
	DEFW 0FF08H	;ADC A
	DEFW ADCA_
 
	DEFW 0FF10H	;SUB
	DEFW SUB_ 
 
	DEFW 0FF18H	;SBC A
	DEFW SBCA_
	
	DEFW 0FF20H	;AND
	DEFW AND_
 
	DEFW 0FF28H	;XOR
	DEFW XOR_
 
	DEFW 0FF30H	;OR
	DEFW OR_
 
	DEFW 0038H	;CP WITH NO MASK
	DEFW CP_
 
	;CONDITIONN CODE TABLE
 
CCTAB	DEFW 0FF00H	;NZ
	DEFW NZ_
 
	DEFW 0FF08H	;Z
	DEFW Z_
	
	DEFW 0FF10H	;NC
	DEFW NC_
 
	DEFW 0FF18H	;C
	DEFW C_
 
	DEFW 0FF20H	;PO
	DEFW PO_
 
	DEFW 0FF28H	;PE
	DEFW PE_
 
	DEFW 0FF30H	;P
	DEFW P_
 
	DEFW 0038H	;M WITH NO MASK
	DEFW M_
 
	;TABLE OF INSTRS BEGINNING WITH CBH
 
CBTAB	DEFW 0C040H	;BIT
	DEFW BITINS
 
	DEFW 0C080H	;RES
	DEFW RESINS
 
	DEFW 0C0C0H	;SET
	DEFW SETINS
 
	DEFW 3830H	;NOT IMPLEMENTED IN CPU
	DEFW DEFINB
	
	DEFW 0000H	;ALL OTHER WITHOUT MASK
	DEFW SHIROT
 
	;SHIFT & ROTATE TABLE
 
SHRTAB	DEFW 3800H	;RLC
	DEFW RLC_
 
	DEFW 3808H	;RRC
	DEFW RRC_
 
	DEFW 3810H	;RL
	DEFW RL_
 
	DEFW 3818H	;RR
	DEFW RR_
 
	DEFW 3820H	;SLA
	DEFW SLA_
 
	DEFW 3828H	;SRA
	DEFW SRA_
 
	DEFW 0038H	;SRL WITH NO MASK
	DEFW SRL_
 
*H SPEC INSTR TABLE
 
	;SPECIAL INSTRUCTION TABLE
 
SPCTAB	DEFW 0FF00H	;NOP
	DEFW NOP_
 
	DEFW 0FF02H	;LD (BC),A
	DEFW LDBCA_
 
	DEFW 0FF07H	;RLCA
	DEFW RLCA_
 
	DEFW 0FF08H	;EX AF,AF'
	DEFW XAFS_
 
	DEFW 0FF0AH	;LD A,(BC)
	DEFW LDABC_
 
	DEFW 0FF0FH	;RRCA
	DEFW RRCA_
 
	DEFW 0FF12H	;LD (DE),A
	DEFW LDDEA_
 
	DEFW 0FF17H	;RLA
	DEFW RLA_
 
	DEFW 0FF1AH	;LD A,(DE)
	DEFW LDADE_
 
	DEFW 0FF1FH	;RRA
	DEFW RRA_
 
	DEFW 0FF27H	;DAA
	DEFW DAA_
 
	DEFW 0FF2FH	;CPL
	DEFW CPL_
	
	DEFW 0FF37H	;SCF
	DEFW SCF_
 
	DEFW 0FF3FH	;CCF
	DEFW CCF_
 
	DEFW 0FF76H	;HALT
	DEFW HALT_
 
	DEFW 0FFC9H	;RET
	DEFW RET_
 
	DEFW 0FFD9H	;EXX
	DEFW EXX_
 
	DEFW 0FFE3H	;EX SP,HL
	DEFW XSPHL_
 
	DEFW 0FFE9H	;JP (HL)
	DEFW JPHL_
 
	DEFW 0FFEBH	;EX DE,HL
	DEFW XDEHL_
 
	DEFW 0FFF3H	;DI
	DEFW DI_
 
	DEFW 0FFF9H	;LD SP,HL
	DEFW LDSH_
 
	DEFW 00FBH	;EI WITH NO MASK
	DEFW EI_
 
*H MISCELLANEOUS TABLES
 
	;PRIM INS TABLE FOR ED INSTRS
 
EDTAB	DEFW 0FE70H	;NOT IN (HL),C ; OUT (C),(L)
	DEFW DEFINB
 
	DEFW 0C740H	;IN R,(C)
	DEFW EDIN
 
	DEFW 0C741H	;OUT (C),R
	DEFW EDOUT
 
	DEFW 0CF43H	;LD (NN),DR
	DEFW LDADDR
 
	DEFW 0CF4BH	;LD DR,(NN)
	DEFW LDDRAD
 
	DEFW 0E4A0H	;ED SPECIALS
	DEFW EDSPEC
 
	DEFW 0CF42H	;SBC HL,DD
	DEFW SBCHLD
 
	DEFW 0CF4AH	;ADC HL,DD
	DEFW ADCHLD
 
	DEFW 0FF45H	;RETN
	DEFW EDSPEC
 
	DEFW 0FC44H	;NEG, IM 0, LD I,A
	DEFW EDSPEC
 
	DEFW 0FF4DH	;RETI
	DEFW EDSPEC
 
	DEFW 0F656H	;IM 1, LD A,I, IM 2 
	DEFW EDSPEC
 
	DEFW 0EF4FH	;LD R,A, LD A,R
	DEFW EDSPEC
 
	DEFW 0F767H	;RLD, RRD
	DEFW EDSPEC
 
	DEFW 0		;ALL OTHERS
	DEFW DEFINB
 
	;SPECIAL ED INS TABLE
 
EDSTAB	DEFW 0FF44H	;NEG
	DEFW NEG_
 
	DEFW 0FF45H	;RETN
	DEFW RETN_
 
	DEFW 0FF46H	;IM 0
	DEFW IM_0_
 
	DEFW 0FF47H	;LD I,A
	DEFW LDIA_
 
	DEFW 0FF4DH	;RETI
	DEFW RETI_
 
	DEFW 0FF4FH	;LD R,A
	DEFW LDRA_
 
	DEFW 0FF56H	;IM 1
	DEFW IM_1_
 
	DEFW 0FF57H	;LD A,I
	DEFW LDAI_
 
	DEFW 0FF5EH	;IM 2
	DEFW IM_2_
 
	DEFW 0FF5FH	;LD A,R
	DEFW LDAR_
 
	DEFW 0FF67H	;RRD
	DEFW RRD_
 
	DEFW 0FF6FH	;RLD
	DEFW RLD_
 
	DEFW 0FFA0H	;LDI
	DEFW LDI_
 
	DEFW 0FFA1H	;CPI
	DEFW CPI_
 
	DEFW 0FFA2H	;INI
	DEFW INI_
 
	DEFW 0FFA3H	;OUTI
	DEFW OUTI_
 
	DEFW 0FFA8H	;LDD
	DEFW LDD_
 
	DEFW 0FFA9H	;CPD
	DEFW CPD_
 
	DEFW 0FFAAH	;IND
	DEFW IND_
 
	DEFW 0FFABH	;OUTD
	DEFW OUTD_
 
	DEFW 0FFB0H	;LDIR
	DEFW LDIR_
 
	DEFW 0FFB1H	;CPIR
	DEFW CPIR_
 
	DEFW 0FFB2H	;INIR
	DEFW INIR_
 
	DEFW 0FFB3H	;OTIR
	DEFW OTIR_
 
	DEFW 0FFB8H	;LDDR
	DEFW LDDR_
 
	DEFW 0FFB9H	;CPDR
	DEFW CPDR_
 
	DEFW 0FFBAH	;INDR
	DEFW INDR_
 
	DEFW 000BBH	;OTDR WITHOUT MASK
	DEFW OTDR_
	
IXTAB	DEFW 0FFCBH	;BITS,SHIFTS,ROTATES
	DEFW IXCB?	;(IF 4:TH BYTE OK)
 
	DEFW 0CF09H	;ADD IX,DD
	DEFW ADXDR
 
	DEFW 0FF76H	;NO INDEX HALT INSTR
	DEFW DEFINB
 
	DEFW 0C746H	;LD R,(IX+D)
	DEFW LDRX
 
	DEFW 0F870H	;LD (IX+D),R
	DEFW LDRX
 
	DEFW 0C786H	;ADD-CP IX INSTR:S
	DEFW ADCPX
 
	DEFW 0FF21H	;LD IX,NN
	DEFW LDIXNN
 
	DEFW 0FF22H	;LD (NN),IX
	DEFW LDNRGX
 
	DEFW 0FF23H	;INC IX
	DEFW DRINCX
 
	DEFW 0FF2BH	;DEC IX
	DEFW DRDECX
 
	DEFW 0FF2AH	;LD IX,(NN)
	DEFW LDRGNX
 
	DEFW 0FF34H	;INC (IX+D)
	DEFW SRINCX
 
	DEFW 0FF35H	;DEC (IX+D)
	DEFW SRDECX
 
	DEFW 0FF36H	;LD (IX+D),N
	DEFW LDRNX
 
	DEFW 0FFE1H	;POP IX
	DEFW POPX
 
	DEFW 0FFE3H	;EX (SP),IX
	DEFW EXSPIX
 
	DEFW 0FFE5H	;PUSH IX
	DEFW PUSHX
 
	DEFW 0FFE9H	;JP (IX)
	DEFW JPIX
 
	DEFW 0FFF9H	;LD SP,IX
	DEFW LDSPIX
 
	DEFW 0000	;OTHERS ILLEGAL
	DEFW DEFINB
 
*H SOURCE CODE STRINGS
 
	; ***** SOURCE CODE STRINGS *****
 
NOP_	DEFM 'NO'
P_	DEFB 'P'+80H
	
RLCA_	DEFM 'RLC'
A_	DEFB 'A'+80H
 
PIXP_0	DEFM '(IX+00H'
	DEFB ')'+80H
 
PIYP_0	DEFM '(IY+00H'
	DEFB ')'+80H
 
PHLP_0	DEFM '(HL'	;
	DEFB ')'+80H
	
JPHL_	DEFM 'JP'
	DEFB TAB		
PHLP_	DEFS 10	;EITHER '(HL)' OR '(IX+NNH) HERE
	
LDABC_	DEFM 'LD'
	DEFB TAB		
	DEFM 'A,(BC'
	DEFB ')'+80H
	
XAFS_	DEFM 'EX'
	DEFB TAB
	DEFM 'AF,AF'
	DEFB ''''+80H
	
RRCA_	DEFM 'RRC'
	DEFB 'A'+80H
	
RLA_	DEFM 'RL'
	DEFB 'A'+80H
	
RRA_	DEFM 'RR'
	DEFB 'A'+80H
 
DAA_	DEFM 'DA'
	DEFB 'A'+80H
 
CPL_	DEFM 'CP'
	DEFB 'L'+80H
 
SCF_	DEFM 'SC'
	DEFB 'F'+80H
 
CCF_	DEFM 'CC'
	DEFB 'F'+80H
 
RET_	DEFM 'RET'
	DEFB TAB+80H
 
HALT_	DEFM 'HAL'
	DEFB 'T'+80H
 
EXX_	DEFM 'EX'
	DEFB 'X'+80H
 
IX_0	DEFM 'I'
	DEFB 'X'+80H
 
IY_0	DEFM 'I'
	DEFB 'Y'+80H
 
HL_0	DEFM 'H'
L_	DEFB 'L'+80H
 
LDSH_	DEFM 'LD'
	DEFB TAB
	DEFM 'SP,'
HL_	DEFS 5
 
DI_	DEFM 'D'
	DEFB 'I'+80H
 
EI_	DEFM 'E'
	DEFB 'I'+80H
 
LD_	DEFM 'LD'
	DEFB TAB+80H
 
RST_	DEFM 'RST'
	DEFB TAB+80H
 
LDBCA_	DEFM 'LD'
	DEFB TAB
	DEFM '(BC),'
	DEFB 'A'+80H
 
LDDEA_	DEFM 'LD'
	DEFB TAB
	DEFM '(DE),'
	DEFB 'A'+80H
 
LDADE_	DEFM 'LD'
	DEFB TAB
	DEFM 'A,(DE'
	DEFB ')'+80H
 
XDEHL_	DEFM 'EX'
	DEFB TAB
	DEFM 'DE,H'
	DEFB 'L'+80H
 
XSPHL_	DEFM 'EX'
	DEFB TAB
	DEFM '(SP),H'
	DEFB 'L'+80H
 
PUSH_	DEFM 'PUSH'
	DEFB TAB+80H
 
POP_	DEFM 'POP'
	DEFB TAB+80H
 
AF_	DEFM 'A'
	DEFB 'F'+80H
 
DJNZ_	DEFM 'DJNZ'
	DEFB TAB+80H
 
JR_	DEFM 'JR'
	DEFB TAB+80H
 
OUT_	DEFM 'OUT'
	DEFB TAB
	DEFB '('+80H
 
OUTND_	DEFM '),'
	DEFB 'A'+80H
 
IN_	DEFM 'IN'
	DEFB TAB
	DEFM 'A,'
	DEFB '('+80H
 
DEC_	DEFM 'DEC'
	DEFB TAB+80H
 
INC_	DEFM 'INC'
	DEFB TAB+80H
 
SET_	DEFM 'SET'
	DEFB TAB+80H
 
RES_	DEFM 'RES'
	DEFB TAB+80H
 
BIT_	DEFM 'BIT'
	DEFB TAB+80H
 
CALL_	DEFM 'CALL'
	DEFB TAB+80H
 
JP_	DEFM 'JP'
	DEFB TAB+80H
 
BC_	DEFM 'B'
C_	DEFB 'C'+80H
 
DE_	DEFM 'D'
E_	DEFB 'E'+80H
 
SP_	DEFM 'S'
	DEFB 'P'+80H
 
B_	DEFB 'B'+80H
 
D_	DEFB 'D'+80H
 
H_	DEFB 'H'+80H
 
NZ_	DEFM 'N'
Z_	DEFB 'Z'+80H
 
NC_	DEFM 'N'
	DEFB 'C'+80H
 
PO_	DEFM 'P'
	DEFB 'O'+80H
 
PE_	DEFM 'P'
	DEFB 'E'+80H
 
M_	DEFB 'M'+80H
 
ADDA_	DEFM 'ADD'
	DEFB TAB
	DEFM 'A'
	DEFB ','+80H
 
ADCA_	DEFM 'ADC'
	DEFB TAB
	DEFM 'A'
	DEFB ','+80H
 
SUB_	DEFM 'SUB'
	DEFB TAB+80H
 
SBCA_	DEFM 'SBC'
	DEFB TAB
	DEFM 'A'
	DEFB ','+80H
 
AND_	DEFM 'AND'
	DEFB TAB+80H
 
XOR_	DEFM 'XOR'
	DEFB TAB+80H
 
OR_	DEFM 'OR'
	DEFB TAB+80H
 
CP_	DEFM 'CP'
	DEFB TAB+80H
	
ADDHL_	DEFM 'ADD'
	DEFB TAB
	DEFM 'HL'
	DEFB ','+80H
 
RLC_	DEFM 'RLC'
	DEFB TAB+80H
 
RRC_	DEFM 'RRC'
	DEFB TAB+80H
 
RL_	DEFM 'RL'
	DEFB TAB+80H
 
RR_	DEFM 'RR'
	DEFB TAB+80H
 
SLA_	DEFM 'SLA'
	DEFB TAB+80H
 
SRA_	DEFM 'SRA'
	DEFB TAB+80H
 
SRL_	DEFM 'SRL'
	DEFB TAB+80H
 
EDIN_	DEFM 'IN'
	DEFB TAB+80H
 
CPCP_	DEFM ',(C'
	DEFB ')'+80H
 
EDOUT_	DEFM 'OUT'
	DEFB TAB
	DEFM '(C)'
	DEFB ','+80H
 
SBCHL_	DEFM 'SBC'
	DEFB TAB
	DEFM 'HL'
	DEFB ','+80H
 
ADCHL_	DEFM 'ADC'
	DEFB TAB
	DEFM 'HL'
	DEFB ','+80H
 
NEG_	DEFM 'NE'
	DEFB 'G'+80H
 
RETN_	DEFM 'RET'
	DEFB 'N'+80H
 
IM_0_	DEFM 'IM'
	DEFB TAB
	DEFB '0'+80H
 
LDIA_	DEFM 'LD'
	DEFB TAB
	DEFM 'I,'
	DEFB 'A'+80H
 
RETI_	DEFM 'RET'
	DEFB 'I'+80H
 
IM_1_	DEFM 'IM'
	DEFB TAB
	DEFB '1'+80H
 
LDAI_	DEFM 'LD'
	DEFB TAB
	DEFM 'A,'
	DEFB 'I'+80H
 
IM_2_	DEFM 'IM'
	DEFB TAB
	DEFB '2'+80H
 
LDAR_	DEFM 'LD'
	DEFB TAB
	DEFM 'A,'
	DEFB 'R'+80H
 
LDRA_	DEFM 'LD'
	DEFB TAB
	DEFM 'R,'
	DEFB 'A'+80H
 
RLD_	DEFM 'RL'
	DEFB 'D'+80H
 
RRD_	DEFM 'RR'
	DEFB 'D'+80H
 
LDI_	DEFM 'LD'
	DEFB 'I'+80H
 
CPI_	DEFM 'CP'
	DEFB 'I'+80H
	
INI_	DEFM 'IN'
	DEFB 'I'+80H
 
OUTI_	DEFM 'OUT'
	DEFB 'I'+80H
 
LDD_	DEFM 'LD'
	DEFB 'D'+80H
 
CPD_	DEFM 'CP'
	DEFB 'D'+80H
 
IND_	DEFM 'IN'
	DEFB 'D'+80H
 
OUTD_	DEFM 'OUT'
	DEFB 'D'+80H
 
LDIR_	DEFM 'LDI'
	DEFB 'R'+80H
 
CPIR_	DEFM 'CPI'
	DEFB 'R'+80H
 
INIR_	DEFM 'INI'
	DEFB 'R'+80H
 
OTIR_	DEFM 'OTI'
	DEFB 'R'+80H
 
LDDR_	DEFM 'LDD'
	DEFB 'R'+80H
 
CPDR_	DEFM 'CPD'
	DEFB 'R'+80H
 
INDR_	DEFM 'IND'
	DEFB 'R'+80H
 
OTDR_	DEFM 'OTD'
	DEFB 'R'+80H
 
ADDIX_	DEFM 'ADD'
	DEFB TAB
	DEFM 'IX'
	DEFB ','+80H
 
XSPIX_	DEFM 'EX'
	DEFB TAB
	DEFM '(SP)'
	DEFB ','+80H
 
DEFB_	DEFM 'DEFB'
	DEFB TAB+80H
 
DEFS_	DEFM 'DEFS'
	DEFB TAB+80H
 
