*H INITIALIZATIONS FOR RTZ DEBUGGER
;UPDATED: 820119 / PH
;FILE:    RTZ.DBG.INIT.S
;REV:     2.00
 
	EXTERNAL	Z$TRCF,Z$DFLG,Z$TRCT,Z$BPCB
	EXTERNAL	Z_SGNL,Z_CSEM,Z_BPOL,Z$BMSG
	EXTERNAL	Z$SIBP,Z$WABP,Z$PTY
	EXTERNAL	Z_TQUE,Z_WAIT,Z_CPRO,Z$SBTB,Z$WBTB
	EXTERNAL	Z$PMIR,Z$DWRS,Z_DBSM,Z_EWAI
 
DBGINI
	LD	DE,Z$PMIR		;PROM-MIRROR TO RAM
	LD	HL,Z_PMIR
	LD	BC,MIRRSZ
	LDIR
 
	LD	A,0BH		;START WITH TRACE
	LD	(Z$TRCF),A
	XOR	A
	LD	(Z$DFLG),A	;CLEAR DEBUGGER STATUS BITS
	LD	(Z$SBTB),A	;NO SIGNAL BREAKPOINTS
	LD	(Z$WBTB),A	;NO WAIT BREAKPOINTS
	DEC	A
	LD	(Z$TRCT),A	;NO TRACE-POINTS
 
	LD	B,10H		;MARK FOR SUBROUTINE RUN
	LD	DE,Z_WAIT
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_SGNL
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_EWAI
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_CPRO
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_CSEM
	CALL	RBRKAD
 
	LD	IX,(Z_RUNP)	;GET DEBUGGER PRIORITY
	LD	A,(IX+PCBPTY)
	LD	(Z$PTY),A
 
	LD	HL,0
	LD	(Z_TQUE),HL	;TRACE QUEUE EMPTY
	LD	(Z$BPCB),HL	;NO PROCESS BREAKED YET
 
	LD	HL,SIGBR?		;ROUTINE FOR CHECK OF --
	LD	(Z$SIBP),HL	;  SIGNAL BREAKPOINTS
	LD	HL,WAIBR?		;ROUTINE FOR CHECK OF --
	LD	(Z$WABP),HL	;  WAIT BREAKPOINTS
 
	LD	DE,Z_BPOL		;CREATE POOL FOR BREAK-MESSAGES
	CALL	Z_CSEM
	LD	B,6			;BUILD BREAKPOINT MESSAGES --
	LD	IX,Z$BMSG
INIT10
	LD	(IX+MSGLEN),14	;  AND SEN THEM TO Z_BPOL
	LD	(IX+MSGLEN+1),0
	LD	DE,Z_BPOL
	LD	(IX+MSGRSM),E	;RESPONSE-SEMAPHORE
	LD	(IX+MSGRSM+1),D
	PUSH	IX
	POP	HL
	CALL	Z_SGNL
	LD	DE,14+2		;2 BYTES FOR CHECKPOINT ADDRESS
	ADD	IX,DE		;IX:=^NEXT BREAK-MESSAGE
	DJNZ	INIT10
 
	LD	DE,Z_DBSM		;CREATE DEBUGGER EVENT SEMAPHORE
	CALL	Z_CSEM
	LD	DE,Z$DWRS		;DEBUGGER WRITE RESPONSE
	CALL	Z_CSEM
 
	LD	DE,IPCBCC		;CREATE ^C-PROCESS
	CALL	Z_CPRO
 
	RET
 
IPCBCC
	DEFM	'Z$CTRC'
	DEFW	Z_CTRC
	DEFW	50
	DEFB	1
 
;-------
; PROM-MIRROR
;-------
 
Z_PMIR
	DEFW	WEVENT
Z_PMSG
	DEFS	2
	DEFW	ZQCWRB
	DEFW	14
	DEFW	Z_DBSM
	DEFW	XPROMT
	DEFW	2
	DEFS	2
 
	DEFS	2
Z_CONM
	DEFS	2			;LNK
	DEFS	2			;RQC,RC
	DEFW	14			;LEN
	DEFW	Z_DBSM
	DEFS	2			;BAD
	DEFS	2			;BSZ
	DEFS	2			;BCN
 
MIRRSZ	EQU	$-Z_PMIR
