*H I/O
;UPDATED: 811201 / PH
;FILE:    RTZ.DBG.IO
;REV:     2.00
 
OBUFSZ	EQU	200
 
;=======
; INCHAR - READ ONE CHARACTER
;
; RETURNS: A  = READ CHARACTER (B7=0)
;=======
 
	EXTERNAL	Z$IBUF,Z$CONM
 
INCHAR
	PUSH	AF
	PUSH	DE
	PUSH	HL
	LD	A,ZQCRDB		;READ BINARY
	LD	HL,1			;ONE CHARACTER
	JR	INLI50
 
;=======
; INLIN - READ LINE INTO Z$IBUF
;
;=======
 
	EXTERNAL	Z_DBSM
 
INLIN
	PUSH	AF
	PUSH	DE
	PUSH	HL
	LD	A,ZQCRDA		;READ ASCII
	LD	HL,80		;ONE SCREEN LINE
INLI50
	LD	(Z$CONM+MSGRQC),A
	LD	(Z$CONM+MSGBSZ),HL
	LD	HL,Z$IBUF		;INPUT BUFFER
	LD	(Z$CONM+MSGBAD),HL
	PUSH	IX
	CALL	EVQUE
	POP	IX
	POP	HL
	POP	DE
	POP	AF
	LD	A,(Z$IBUF)	;A:=FIRST READ CHARACTER
	RET
 
;=======
; OUTSTR - WRITE STRING ON SCREEN
;
; ACCEPTS: HL = ^STRING,<0FFH>
;=======
 
	EXTERNAL	Z_A0SM,Z$OBUF,Z$DWRS,Z_SGNL
 
OUTSTR
	PUSH	AF			;SAVE AF
	PUSH	DE			;SAVE DE
	PUSH	DE			;BCN
	LD	DE,0FFFFH		;LET <0FFH> TERMINATE
	PUSH	DE			;BSZ
	PUSH	HL			;BAD
	LD	HL,Z$DWRS		;DEBUGGER WRITE RESPONSE SEM
	PUSH	HL			;RSM
	LD	HL,14		;LEN
	PUSH	HL
	LD	L,ZQCWRB		;WRITE BINARY
	PUSH	HL			;RQC
	PUSH	HL			;LNK
	LD	L,0			;HL:=^MESSAGE ON STACK
	ADD	HL,SP
	LD	DE,Z_A0SM
	CALL	Z_SGNL
	LD	DE,Z$DWRS
	CALL	Z_EWAI
	LD	HL,Z$OBUF		;FILL Z$OBUF WITH SPACES
	LD	A,OBUFSZ
OUTS50
	LD	(HL),' '
	INC	HL
	DEC	A
	JR	NZ,OUTS50
	POP	HL			;LNK
	POP	HL			;RQC,RC
	POP	HL			;LEN
	POP	HL			;RSM
	POP	HL			;BAD
	POP	DE			;BSZ
	POP	DE			;BCN
	POP	DE			;RESTORE DE
	POP	AF			;RESTORE AF
	RET
