*H RTZ.DBG.MAIN
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; Z_DBG - REAL-TIME DEBUGGER FOR RTZ
;
; Copyright: DIGITAILOR AB, SWEDEN
;
; REV. 2.00: Released 820128
;      2.01: Released 821029
;=======
 
*I RTZ.EQU
*I GEN.SWITCH.EQU
 
	GLOBAL	Z_DBG
	EXTERNAL	Z$INSP,Z$IBUF,Z$PMSG
*E
 
Z_DBG
	LD	(Z$INSP),SP	;SAVE STACK-GROUND
	CALL	DBGINI		;SET UP FOR DEBUG
	JR	WEVENT
HALLO
	LD	HL,XHALLO		;SAY HALLO TO USER
	CALL	OUTSTR
CMDWAI
	LD	SP,(Z$INSP)	;RESTORE DEBUGGER SP
	LD	DE,Z_C0SM		;PROMPT FOR COMMAND
	LD	HL,Z$PMSG
	CALL	Z_SGNL
	CALL	INLIN
	LD	HL,CMDWAI		;RETURN FOR HANDLERS
	PUSH	HL
	LD	HL,Z$IBUF
	LD	A,(HL)		;JUST A <CR> ?
	CP	0DH
	JR	Z,CMDWAI		;YES
	LD	DE,CMDTAB
	CALL	G_XCMD		;DECODE COMMAND
	PUSH	DE			;PUSH RETURN-PRM FROM DECODER
	RET	NZ			;GO TO HANDLER IF COMMAND IS OK
	JP	CMDERR
 
;=======
; EVQUE - SET UP CHECKPOINT AND WAIT FOR EVENT
; WEVENT - WAIT FOR EVENT AND GO TO HANDLER
;=======
 
	EXTERNAL	Z_DBSM,Z$CONM,Z_C0SM,Z_SGNL
 
EVQUE
	LD	DE,Z_C0SM
	POP	HL
	LD	(Z$CONM-2),HL
	LD	HL,Z$CONM
	CALL	Z_SGNL
WEVENT
	LD	DE,Z_DBSM		;WAIT FOR EVENT
	CALL	Z_EWAI
	PUSH	HL
	POP	IX
	LD	L,(IX-2)		;PICK UP HANDLER ADDRESS
	LD	H,(IX-1)
	JP	(HL)
 
;=======
; H_QUIT - CANCEL DEBUGGING SESSION
;=======
 
	EXTERNAL	Z$DFLG
 
H_QUIT
	LD	HL,Z$DFLG		;DEBUGGER NOT INVOKED !
	RES	1,(HL)
	LD	HL,XABORT		;GOOD BYE
	CALL	OUTSTR
	JP	WEVENT
 
XABORT
	DEFM	'Debugger aborted'
	DEFW	0FF0DH
 
;-------
; STRINGS
;-------
 
XPROMT	DEFM	'.'
      	DEFB	0FFH
XHALLO	DEFB	0DH
      	DEFM	'RTZ.DBG 2.01'
      	DEFW	0FF0DH
 
;-------
; CMDTAB - TABLE OF COMMANDS
;-------
 
CMDTAB
	DEFT	'REGISTER'
	DEFW	H_REG
	DEFT	'DISPLAY'
	DEFW	H_DSB
	DEFT	'STEP'
	DEFW	H_STEP
	DEFT	'INPUT'
	DEFW	H_INP
	DEFT	'OUTPUT'
	DEFW	H_OUT
	DEFT	'SHOW'
	DEFW	H_SHOW
	DEFT	'MODIFY'
	DEFW	H_EXAM
	DEFT	'ABORT'
	DEFW	H_QUIT
	DEFT	'RUN'
	DEFW	H_RUN
	DEFT	'QUEUE'
	DEFW	H_QUEU
	DEFT	'TPCB'
	DEFW	H_TPCB
	DEFT	'BREAK'
	DEFW	H_BRK
	DEFT	'CANCEL'
	DEFW	H_CAN
	DEFT	'LIST'
	DEFW	H_LIST
	DEFT	'EXEQUTE'
	DEFW	H_XEQ
	DEFB	0
