*H RTZ.DBG.SHOW
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; H_QUEU - DISPLAY RTZ-QUEUES
;=======
 
	EXTERNAL	Z$OBUF,Z$XQUE
 
H_QUEU
	CALL	SWITCH		;GET COMMAND SWITCHES
	BIT	BIT_D,E
	JP	NZ,QDELAY
	BIT	BIT_M,D
	JP	NZ,QSEMMG
	BIT	BIT_P,D
	JP	NZ,QSEMP
	BIT	BIT_X,C
	JP	NZ,QEXEC
 
;-------
; DISPLAY TRACE QUEUE
;-------
 
	EXTERNAL	Z_TQUE
 
QTPCB
	LD	HL,XTHEAD
	CALL	OUTSTR
	LD	IX,(Z_TQUE)
	LD	DE,XTNAME
	JR	QUEU30
 
XTHEAD	DEFM	'Trace queue:'
      	DEFW	0FF0DH
XTNAME	DEFM	'Z_TQUE:  '
      	DEFB	0FFH
 
;-------
; DISPLAY EXECUTION QUEUE
;-------
 
QEXEC
	LD	HL,XXHEAD		;PRINT HEAD
	CALL	OUTSTR
	LD	IX,(Z$XQUE)	;IX:=^FIRST PCB IN XQUE
	LD	DE,XXNAME		;PRINT QUEUE-NAME ON FIRST LINE
QUEU30
	LD	HL,Z$OBUF
	CALL	PUTSTR		;PRINT LINE-PREDECESSOR
QUEU49
	LD	B,5			;FIVE NAMES/LINE
QUEU50
	PUSH	IX
	POP	DE
	LD	A,E			;END OF QUEUE ?
	OR	D
	JR	Z,QUEU90		;YES
	CALL	PUTNAM		;MOVE NAME TO OUTBUF
	LD	DE,XARROW		;MOVE ARROW TO OUTBUF
	CALL	PUTSTR
	LD	E,(IX+PCBLNK)	;IX:=DE:=^NEXT PCB
	LD	D,(IX+PCBLNK+1)
	PUSH	DE
	POP	IX
	DJNZ	QUEU50		;NO
	CALL	PUTEOS
	CALL	OTOBUF
	LD	DE,XBLANK
	JR	QUEU30		;NEW LINE
QUEU90
	LD	(HL),'0'		;END OF QUEUE MARK
	INC	HL
	CALL	PUTEOS		;TERMINATE STRING --
	JP	OTOBUF		;  AND WRITE IT.
 
XXHEAD 	DEFM	'Execution queue:'
      	DEFW	0FF0DH
XXNAME	DEFM	'Z$XQUE:  '
      	DEFB	0FFH
XBLANK	DEFM	'         '
      	DEFB	0FFH
XARROW	DEFM	'- '
       	DEFB	0FFH
 
;-------
; DISPLAY DELAY QUEUE
;-------
 
	EXTERNAL	Z$DQUE
 
QDELAY
	LD	HL,XDHEAD		;PRINT HEAD
	CALL	OUTSTR
	LD	IX,(Z$DQUE)	;IX:=^FIRST PCB IN DQUE
	LD	DE,XDNAME		;PRINT QUEUE-NAME ON FIRST LINE
QDEL30
	LD	HL,Z$OBUF
	CALL	PUTSTR		;PRINT LINE-PREDECESSOR
	LD	B,5			;FIVE NAMES/LINE
QDEL50
	PUSH	IX
	POP	DE
	LD	A,E			;END OF QUEUE ?
	OR	D
	JR	Z,QUEU90		;YES
	CALL	PUTNAM		;MOVE NAME TO OUTBUF
	LD	DE,XARROW		;MOVE ARROW TO OUTBUF
	CALL	PUTSTR
	LD	E,(IX+PCBDLK)	;IX:=DE:=^NEXT PCB
	LD	D,(IX+PCBDLK+1)
	PUSH	DE
	POP	IX
	DJNZ	QDEL50		;NO
	CALL	PUTEOS
	CALL	OTOBUF
	LD	DE,XBLANK
	JR	QDEL30		;NEW LINE
 
XDHEAD 	DEFM	'Delay queue:'
      	DEFW	0FF0DH
XDNAME	DEFM	'Z$DQUE:  '
      	DEFB	0FFH
 
;-------
; DISPLAY PROCESS QUEUE AT SEMAPHORE
;-------
 
QSEMP
	CALL	GET1P
	CALL	CHKSEM
	JP	C,ADRERR
	LD	HL,XPHEAD
	CALL	OUTSTR
	LD	HL,Z$OBUF
	INC	DE			;DE:=^PQUE
	INC	DE
	CALL	PUT16
	LD	(HL),':'
	INC	HL
	INC	HL
	EX	DE,HL		;HL:=^PQUE, DE:=OBUF.CUR
	LD	C,(HL)		;IX:=^PQUE.1ST
	INC	HL
	LD	B,(HL)
	PUSH	BC
	POP	IX
	EX	DE,HL
	JP	QUEU49
 
XPHEAD	DEFM	'Semaphore Process queue:'
      	DEFW	0FF0DH
 
;-------
; DISPLAY MESSAGE QUEUE AT SEMAPHORE
;-------
 
QSEMMG
	CALL	GET1P
	CALL	CHKSEM
	JP	C,ADRERR
	LD	HL,XMHEAD
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_		;DE = ^MESSAGE QUEUE
	LD	(HL),':'
	INC	HL
	INC	HL
QSEM49
	LD	B,10
QSEM50
	EX	DE,HL		;NEXT ITEM IN QUEUE
	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A
	EX	DE,HL
	LD	A,E			;END OF QUEUE ?
	OR	D
	JP	Z,QUEU90
	CALL	PUT16_
	PUSH	DE
	LD	DE,XARROW
	CALL	PUTSTR
	POP	DE
	DJNZ	QSEM50
	CALL	PUTEOS
	CALL	OTOBUF
	LD	HL,Z$OBUF
	PUSH	DE
	LD	DE,XBLANK
	CALL	PUTSTR
	POP	DE
	JR	QSEM49
 
XMHEAD	DEFM	'Semaphore Message queue:'
      	DEFW	0FF0DH
 
;=======
; H_SHOW - DISPLAY RTZ-STRUCTURES
;=======
 
H_SHOW
	CALL	SWITCH		;GET COMMAND SWITCHES
	BIT	BIT_S,C
	JP	NZ,SHWSEM
	BIT	BIT_M,D
	JP	NZ,SHWMSG
 
;-------
; SHWPCB - DISPLAY Process Control Block
;-------
 
SHWPCB
	CALL	GET1PC
	CALL	C,CHKTP		;CHECK IF TP IF NO PARAMETER
	CALL	CHKPCB
	JP	C,ADRERR		;INVALID ADDRESS
	LD	HL,XPCBHD		;PRINT HEADER
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_		;PRINT PCB ADDRESS
	PUSH	DE			;IX:=^PCB
	POP	IX
	LD	B,5
PCB10
	LD	E,(IX)
	LD	D,(IX+1)
	CALL	PUT16_
	INC	IX
	INC	IX
	DJNZ	PCB10
	LD	A,(IX)		;GET PCB.PTY
	CALL	PUT8_
	LD	A,(IX+1)		;GET PCB.STT
	CALL	PUT8_
	LD	E,(IX+2)		;GET PCB.NAME
	LD	D,(IX+3)
	EX	DE,HL
	LD	BC,6
	LDIR
	EX	DE,HL
	INC	HL
	LD	E,(IX+6)		;GET PCB.PCBLINK
	LD	D,(IX+7)
	CALL	PUT16
PCBEND
	CALL	PUTEOS
	JP	OTOBUF
 
XPCBHD	DEFM	'     LINK DTIM DLNK SEM   SP  PR ST  NAME  PCBL'
      	DEFW	0FF0DH
 
;-------
; SHWSEM - DISPLAY SEMAPHORE
;-------
 
SHWSEM
	CALL	GET1P
	CALL	CHKSEM
	JP	C,ADRERR
	LD	HL,XSEMHD		;PRINT HEADER
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_		;PRINT SEMAPHORE ADDRESS
	PUSH	DE
	POP	IX
	LD	B,3
SEM10
	LD	E,(IX)
	LD	D,(IX+1)
	CALL	PUT16_
	INC	IX
	INC	IX
	DJNZ	SEM10
	JP	PCBEND
 
XSEMHD	DEFM	'     MQUE PQUE SEML'
      	DEFW	0FF0DH
 
;-------
; SHWMSG - DISPLAY MESSAGE
;-------
 
SHWMSG
	CALL	GET1P
	LD	HL,XMSGHD
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_
	PUSH	DE			;IX:=^MESSAGE
	POP	IX
	LD	E,(IX+MSGLNK)	;LNK
	LD	D,(IX+MSGLNK+1)
	CALL	PUT16_
	LD	A,(IX+MSGRQC)	;RQC
	CALL	PUT8_
	LD	A,(IX+MSGRC)	;RC
	CALL	PUT8_
	PUSH	HL
	LD	E,(IX+MSGLEN)	;DE:=LENGTH
	LD	D,(IX+MSGLEN+1)
	LD	HL,5			;DISPLAY MIN 6 BYTES
	AND	A
	SBC	HL,DE
	JR	C,MSG03		;>5
	LD	E,6
MSG03
	LD	HL,63		;DISPLAY MAX 62 BYTES OF MSG
	AND	A
	SBC	HL,DE
	POP	HL
	PUSH	AF
	JR	NC,MSG05		;<= 62
	LD	E,62
MSG05
	LD	B,E
	DEC	B			;4 BYTES ALREADY WRITTEN
	DEC	B
	DEC	B
	DEC	B
	SRA	B			;WE ARE WRITING WORDS
	PUSH	AF			;SAVE INFO IF ODD # OF BYTES
MSG10
	LD	E,(IX+4)
	LD	D,(IX+5)
	CALL	PUT16_
	INC	IX
	INC	IX
	DJNZ	MSG10
	POP	AF
	LD	A,(IX+4)
	CALL	C,PUT8_
	POP	AF
	LD	DE,XLONGM		;WARNING FOR LONG MESSAGE
	CALL	C,PUTSTR
	JP	PCBEND
 
XMSGHD	DEFM	'     LNK RQC RC LEN  RSM'
      	DEFW	0FF0DH
XLONGM	DEFB	0DH
      	DEFM	'Can''t display whole message'
      	DEFB	0FFH
