*L OFF
;FILE:    RTZ.EQU.S
;UPDATED: 820120 / PH
;REV:     2.00
 
;=======
; ALL INTERNAL EQUATES FOR RTZ/2
;=======
 
;-------
; Initial Process Control Block
;-------
 
IPCNAM	EQU	0		;PROCESS NAME
IPCENT	EQU	6		;PROCESS ENTRY
IPCSTZ	EQU	8		;STACK SIZE
IPCPTY	EQU	10		;PROCESS PRIORITY
 
;-------
; Initial Semaphore
;-------
 
ISMADR	EQU	0		;SEMAPHORE ADDRESS
 
;-------
; Configuration Table - Z$CRTB
;-------
 
CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
CNFNOP	EQU	2		;# OF IPCB:S IN IPT
CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
CNFNOS	EQU	5		;# OF ISEM:S IN IST
 
;-------
; Process Control Block
;-------
 
PCBLNK	EQU	0		;LINK FIELD
PCBDLY	EQU	2		;DELAY TIME
PCBDLK	EQU	4		;DELAY LINK FIELD
PCBSEM	EQU	6		;SEMAPHORE
PCBSP 	EQU	8		;STACK POINTER
PCBPTY	EQU	10		;PROCESS PRIORITY
PCBSTT	EQU	11		;STATUS BITS
PCBNAM	EQU	12		;^NAME
PCBRND	EQU	14		;RANDOM FIELD
PCBPCB	EQU	16		;STATIC PCB-LINK
 
;-------
; Semaphore
;-------
 
SEMMGQ	EQU	0		;MESSAGE QUEUE
SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
 
SEMIMG	EQU	6		;INTERRUPT MESSAGE
 
;-------
; Minimum Message
;-------
 
MSGLNK	EQU	0		;QUEUE LINK
MSGRQC	EQU	2		;REQUEST CODE
MSGRC 	EQU	3		;RETURN CODE
MSGLEN	EQU	4		;LENGTH
MSGRSM	EQU	6		;RESPONSE SEMAPHORE
 
;-------
; Device Request Message
;-------
 
MSGBAD	EQU	8		;BUFFER ADDRESS
MSGBSZ	EQU	10		;BUFFER SIZE
MSGBCN	EQU	12		;BYTE COUNT
 
MSGSEC	EQU	8		;SECONDS
MSGMIN	EQU	9		;MINUTES
MSGHRS	EQU	10		;HOURS
 
MSGWL 	EQU	8		;WANTED LENGTH
MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
 
;-------
; Device Request Bits
;-------
 
ZQBRD 	EQU	1		;00.. ..01 READ
ZQbRD 	EQU	0
ZQBWRT	EQU	2		;00.. ..10 WRITE
ZQbWRT	EQU	1
ZQBASC	EQU	0		;00.. .0.. ASCII
ZQBBIN	EQU	4		;00.. .1.. BINARY
ZQbBIN	EQU	2
ZQBSTT	EQU	8		;00.. 1... STATUS
ZQbSTT	EQU	4
 
;-------
; Device Request Codes
;-------
 
      						;00xx xxxx COMMON CODES
ZQCRDA	EQU	ZQBRD+ZQBASC		;READ ASCII
ZQCRDB	EQU	ZQBRD+ZQBBIN		;READ BINARY
ZQCWRA	EQU	ZQBWRT+ZQBASC		;WRITE ASCII
ZQCWRB	EQU	ZQBWRT+ZQBBIN		;WRITE BINARY
ZQCRDS	EQU	ZQBRD+ZQBSTT		;READ STATUS
ZQCWRS	EQU	ZQBWRT+ZQBSTT		;WRITE STATUS
 
      				;01xx xxxx COMMAND CODES
ZQCRDC	EQU	61H		;READ CLOCK
ZQCWRC	EQU	62H		;WRITE CLOCK
ZQCWAT	EQU	63H		;WAKE AT
ZQCWAF	EQU	64H		;WAKE AFTER
 
ZQCMCF	EQU	68H		;CONDITIONAL, FAST
ZQCMCB	EQU	69H		;CONDITIONAL, BEST
ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
 
;-------
; System Return Codes
;-------
 
ZRCINT	EQU	0		;INTERRUPT MESSAGE
ZRCMIS	EQU	44H		;MISSED INTERRUPT
ZRCTO 	EQU	80H		;1... .... TIME-OUT
 
;-------
; Device Return Codes
;-------
 
ZRCOK 	EQU	0		;NORMAL TERMINATION
ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
ZRCERR	EQU	42H		;UNSPECIFIED ERROR
ZRCBSY	EQU	43H		;DEVICE BUSY
ZRCOVF	EQU	45H		;DATA OVERFLOW
ZRCEOF	EQU	46H		;END OF FILE
ZRCDWN	EQU	47H		;DEVICE OFF LINE
ZRCEOM	EQU	48H		;END OF MEDIA
 
;-------
; HELP EQUATES
;-------
 
STTDLY	EQU	3		;BIT 3 IN PCBSTT
STCKAF	EQU	8		;OFFSET TO AF IN STACK
STCKHL	EQU	10		;OFFSET TO HL IN STACK
STCKPC	EQU	12		;OFFSET TO PC IN STACK
SZISTK	EQU	50		;SIZE OF IDLE STACK
 
*L ON
