*H RTZ.CON.HW.1.SIB
;UPDATED: 820114 / PH
;REV:     2.00
 
;=======
; HARDWARE MODULE FOR RTZ CONSOLE # 1
; -----------------------------------
;
; Device: Channel 2 on SIB-card (8251)
;
; Receiver: Z_06SM, CTC12 (port 86H) on SIB-card
;           4800 Baud
;
; Transmitter: Z_10SM, CTC22 (port 8AH) on SIB-card
;              4800 Baud
;=======
 
*I EQU.CTC
*I SIB.EQU
 
;-------
; DEFINITIONS
;-------
 
	GLOBAL	Z_C1RZ,Z_C1GS
	EXTERNAL	Z_06SM
 
Z_C1RZ	DEFW	30		;SIZE OF TYPE-AHEAD BUFFER
Z_C1GS	DEFW	Z_06SM	;RECEIVE INTERRUPT-SEMAPHORE
*H INIT
 
;=======
; Z_INI1 - USER INITIALIZATION
;=======
 
	GLOBAL	Z_INI1
	EXTERNAL	Z_LDCW,Z_SEVC,Z_00VC
 
Z_INI1
	LD	A,10B		;FORCE 8251 TO "COMMAND"
	OUT	(SIBU2C),A
	LD	A,40H		;INTERNAL RESET
	OUT	(SIBU2C),A
	LD	A,0CEH		;MODE INSTRUCTION
	OUT	(SIBU2C),A
	LD	A,37H		;COMMAND INSTRUCTION
	OUT	(SIBU2C),A
 
	LD	A,C_CTRL+C_TIM+C_ID+C_TC+C_P16
	OUT	(SIBC02),A
	LD	A,1			;4800 BAUD
	OUT	(SIBC02),A
 
	LD	HL,Z_00VC		;VECTORS TO SIB CTC:S
	LD	A,L
	ADD	A,8
	OUT	(SIBC10),A
	ADD	A,8
	OUT	(SIBC20),A
 
	LD	DE,6			;SET UP DIRECT INTERRUPT
	LD	HL,RECINT
	CALL	Z_SEVC
	LD	DE,CWREC
	CALL	Z_LDCW
	LD	DE,CWXMIT		;SET UP CTC FOR XMIT
	CALL	Z_LDCW
	RET
 
CWREC
	DEFB	SIBC12
	DEFB	2
	DEFB	C_CTRL+C_IE+C_CNT+C_TC+C_POS
	DEFB	1
 
CWXMIT
	DEFB	SIBC22
	DEFB	2
	DEFB	C_CTRL+C_IE+C_CNT+C_TC+C_POS
	DEFB	1
 
*H TRANSMITTER / RECEIVER
 
;=======
; Z_SCH1 - SET CHARACTER
;
; ACCEPTS: A  = ASCII CHARACTER
;=======
 
	GLOBAL	Z_SCH1
	EXTERNAL	Z_WAIT,Z_10SM
 
Z_SCH1
	OUT	(SIBU2D),A
	LD	DE,Z_10SM		;WAIT FOR TX-BUFFER EMPTY
	LD	HL,4
	CALL	Z_WAIT
	RET	
 
;=======
; RECINT - UART INTERRUPT
;=======
 
	EXTERNAL	Z_ISGL
	EXTERNAL	Z_GCI1
 
RECINT
	PUSH	AF
	IN	A,(SIBU2D)	;READ CHARACTER
	CALL	Z_GCI1
	POP	AF
	CALL	Z_ISGL
	DEFW	Z_06SM
	DEFB	6
 
	END
