*H RTZ.CON.HW.1.SIO
;Updated: 820115 / PH
 
;=======
; HARDWARE MODULE FOR RTZ CONSOLE # 1
; -----------------------------------
;
; Device: SIO channel A (Metric Card)
;
; Receiver: Z_18SM (I-level 18), 4800 Baud
;
; Transmitter: Z_16SM (I-level 16), 4800 Baud
;=======
 
*I EQU.CTC
 
;-------
; DEFINITIONS
;-------
 
	GLOBAL	Z_C1RZ,Z_C1GS
	EXTERNAL	Z_18SM
 
Z_C1RZ	DEFW	30		;SIZE OF TYPE-AHEAD BUFFER
Z_C1GS	DEFW	Z_18SM	;RECEIVE INTERRUPT SEMAPHORE
SIOAD 	EQU	80H
SIOAC 	EQU	81H
SIOBC 	EQU	83H
BAUDGN	EQU	84H
*E
;=======
; Z_INI1 - USER INITIALIZATION
;=======
 
	GLOBAL	Z_INI1
	EXTERNAL	Z_LDCW,Z_SEVC,Z_00VC
 
Z_INI1
	LD	HL,SIORXR
	LD	(Z_00VC+34),HL
	LD	(Z_00VC+38),HL
 
	LD	A,C_ID+C_TIM+C_P16+C_TC+C_CTRL
	OUT	(BAUDGN),A
	LD	A,1
	OUT	(BAUDGN),A
	LD	DE,16
	LD	HL,SIOTXR
	CALL	Z_SEVC
	LD	DE,18
	LD	HL,SIORXR
	CALL	Z_SEVC
	LD	DE,SIOACW
	CALL	Z_LDCW
	LD	DE,SIOBCW
	CALL	Z_LDCW
	RET
 
SIOACW
	DEFB	SIOAC
	DEFB	9
	DEFB	00011000B		;channel reset
	DEFB	14H			;^4
	DEFB	01001100B		;x16 clock,2 stop,no parity
	DEFB	13H			;^3
	DEFB	01000001B		;7 bits,Rx enable
	DEFB	15H			;^5
	DEFB	10101010B		;DTR,7 bits,Tx enable,RTS
	DEFB	11H			;^1
	DEFB	01011110B		;int enable,status affects
 
SIOBCW
	DEFB	SIOBC
	DEFB	4
	DEFB	2			;^2
	DEFB	32			;vector
	DEFB	1			;^1
	DEFB	100B			;status affects
*H TRANSMITTER
 
;=======
; Z_SCH1 - SET CHARACTER
;
; ACCEPTS: A  = ASCII CHARACTER
;=======
 
	GLOBAL	Z_SCH1
	EXTERNAL	Z_WAIT,Z_16SM
 
Z_SCH1
	PUSH	AF
	LD	A,1			;^1
	DI
	OUT	(SIOAC),A
	LD	A,01011010B	;ENABLE TX-RUPT
	EI
	OUT	(SIOAC),A
	POP	AF
	OUT	(SIOAD),A
	LD	DE,Z_16SM		;WAIT FOR TX-BUFFER EMPTY
	LD	HL,4
	CALL	Z_WAIT
	RET	
	
;=======
; SIOTXR
;=======
 
	EXTERNAL	Z_ISGL
 
SIOTXR
	PUSH	AF
	LD	A,1			;^1
	OUT	(SIOAC),A
	LD	A,01011000B	;DISABLE TX-RUPT
	OUT	(SIOAC),A
	POP	AF
	CALL	Z_ISGL
	DEFW	Z_16SM
	DEFB	16
*H RECEIVER
 
;=======
; SIORXR
;=======
 
	EXTERNAL	Z_GCI1,Z_ISGL
 
SIORXR
	PUSH	AF
	IN	A,(SIOAD)
	CALL	Z_GCI1
	POP	AF
	CALL	Z_ISGL
	DEFW	Z_18SM
	DEFB	18
 
	END
