	title	'exsecond'
;Updated: 821202 / PH
;Created: 821201 / PH
 
;=======
; SECINI
; This initialization routine disables time display,
; builds the message-pool and prepares the real-time
; clock for executing DOESEC every one second.
;
; Accepts: none (can be called from PLZ)
;=======
 
;File:    rtzdecls.s
	unlist
;Updated: 831005 / PH
;Created: <820120 / PH, DIGITAILOR AB
 
;=======
; DECLARATIONS FOR RTZ ASSEMBLER PROCESSES
;
; Valid for versions 2.00 and greater
;=======
 
;-------
; External labels
;-------
 
	external	Z_SGNL,Z_EWAI,Z_WAIT,Z_CPRO,Z_CSEM
	external	Z_LDCW,Z_SEVC,Z_SPTY,Z_ISGL,Z_RUNP
	external	Z_SLCF,Z_SLCT,Z_SLCP,Z_EOMF,Z_00VC
 
	external	Z_00SM,Z_01SM,Z_02SM,Z_03SM,Z_04SM
	external	Z_05SM,Z_06SM,Z_07SM,Z_08SM,Z_09SM
	external	Z_10SM,Z_11SM,Z_12SM,Z_13SM,Z_14SM
	external	Z_15SM,Z_16SM,Z_17SM,Z_18SM,Z_19SM
 
;-------
; Initial Process Control Block
;-------
 
IPCNAM	equ	0		;PROCESS NAME
IPCENT	equ	6		;PROCESS ENTRY
IPCSTZ	equ	8		;STACK SIZE
IPCPTY	equ	10		;PROCESS PRIORITY
 
;-------
; Initial Semaphore
;-------
 
ISMADR	equ	0		;SEMAPHORE ADDRESS
 
;-------
; Process Control Block
;-------
 
PCBLNK	equ	0		;LINK FIELD
PCBDLY	equ	2		;DELAY TIME
PCBDLK	equ	4		;DELAY LINK FIELD
PCBSEM	equ	6		;SEMAPHORE
PCBSP 	equ	8		;STACK POINTER
PCBPTY	equ	10		;PROCESS PRIORITY
PCBSTT	equ	11		;STATUS BITS
PCBNAM	equ	12		;^NAME
PCBRND	equ	14		;RANDOM FIELD
PCBPCB	equ	16		;STATIC PCB-LINK
 
;-------
; Semaphore
;-------
 
SEMMGQ	equ	0		;MESSAGE QUEUE
SEMPRQ	equ	2		;PROCESS (WAITING) QUEUE
SEMSEM	equ	4		;STATIC SEMAPHORE-LINK
 
SEMIMG	equ	6		;INTERRUPT MESSAGE
 
;-------
; Minimum Message
;-------
 
MSGLNK	equ	0		;QUEUE LINK
MSGRQC	equ	2		;REQUEST CODE
MSGRC 	equ	3		;RETURN CODE
MSGLEN	equ	4		;LENGTH
MSGRSM	equ	6		;RESPONSE SEMAPHORE
MSGRST	equ	8		;REMAINDER
 
;-------
; Device Request Message
;-------
 
MSGBAD	equ	8		;BUFFER ADDRESS
MSGBSZ	equ	10		;BUFFER SIZE
MSGBCN	equ	12		;BYTE COUNT
 
MSGSEC	equ	8		;SECONDS
MSGMIN	equ	9		;MINUTES
MSGHRS	equ	10		;HOURS
 
MSGWL 	equ	8		;WANTED LENGTH
MSGSPC	equ	10		;MAX SPACE OR ^FREE SPACE
 
;-------
; Device Request Bits
;-------
 
ZQBRD 	equ	1		;00.. ..01 READ
ZQBWRT	equ	2		;00.. ..10 WRITE
ZQBASC	equ	0		;00.. .0.. ASCII
ZQBBIN	equ	4		;00.. .1.. BINARY
ZQBSTT	equ	8		;00.. 1... STATUS
 
;-------
; Device Request Codes
;-------
 
ZQCRDA	equ	ZQBRD+ZQBASC		;READ ASCII
ZQCRDB	equ	ZQBRD+ZQBBIN		;READ BINARY
ZQCWRA	equ	ZQBWRT+ZQBASC		;WRITE ASCII
ZQCWRB	equ	ZQBWRT+ZQBBIN		;WRITE BINARY
ZQCRDS	equ	ZQBRD+ZQBSTT		;READ STATUS
ZQCWRS	equ	ZQBWRT+ZQBSTT		;WRITE STATUS
 
ZQCRDC	equ	61H		;READ CLOCK
ZQCWRC	equ	62H		;WRITE CLOCK
ZQCWAT	equ	63H		;WAKE AT
ZQCWAF	equ	64H		;WAKE AFTER
 
ZQCMCF	equ	68H		;CONDITIONAL, FAST
ZQCMCB	equ	69H		;CONDITIONAL, BEST
ZQCMUF	equ	6AH		;UNCONDITIONAL, FAST
ZQCMUB	equ	6BH		;UNCONDITIONAL, BEST
 
;-------
; System Return Codes
;-------
 
ZRCINT	equ	0		;INTERRUPT MESSAGE
ZRCMIS	equ	44H		;MISSED INTERRUPT
ZRCTO 	equ	80H		;1... .... TIME-OUT
 
;-------
; Device Return Codes
;-------
 
ZRCOK 	equ	0		;NORMAL TERMINATION
ZRCUNK	equ	41H		;UNKNOWN REQUEST CODE
ZRCERR	equ	42H		;UNSPECIFIED ERROR
ZRCBSY	equ	43H		;DEVICE BUSY
ZRCOVF	equ	45H		;DATA OVERFLOW
ZRCEOF	equ	46H		;END OF FILE
ZRCDWN	equ	47H		;DEVICE OFF LINE
ZRCEOM	equ	48H		;END OF MEDIA
 
	list
;File:    exequ.s
	unlist
;Updated: 821201 / PH
;Created: 821130 / PH
 
; request codes
 
AQCEN 	equ	80H		;enable alarm
AQCDIS	equ	81H		;disable alarm
 
; help equates
 
CLKBFZ	equ	20		;sizeof CLKBUF
ON    	equ	0FFH
OFF   	equ	0
 
	list
 
	global	SECINI
	external	SEC_SM,CLKMSG,Z_A0SM,SECRSM,SECMSG
	external	CLKBUF,CLOKEN,Z_SECS,Z_CKUP,POOLSM,POOLMG
 
SECINI
	PUSH	IX			;save IX (for PLZ)
	XOR	A			;start with no time display
	LD	(CLOKEN),A
	LD	B,8			;build POOLSM
	LD	DE,POOLSM
	LD	IX,POOLMG
SECI10
	LD	(IX+MSGLEN),14
	LD	(IX+MSGLEN+1),0
	PUSH	IX			;HL:=^message
	POP	HL
	LD	DE,POOLSM
	CALL	Z_SGNL
	LD	DE,MSGBCN+2
	ADD	IX,DE
	DJNZ	SECI10
 
	LD	A,ZQCWRA		;set up CLKMSG
	LD	(CLKMSG+MSGRQC),A
	LD	HL,14
	LD	(CLKMSG+MSGLEN),HL
	LD	HL,SECRSM
	LD	(CLKMSG+MSGRSM),HL
	LD	HL,CLKBUF
	LD	(CLKMSG+MSGBAD),HL
	LD	HL,CLKBFZ
	LD	(CLKMSG+MSGBSZ),HL
	LD	DE,SECRSM
	LD	HL,CLKMSG
	CALL	Z_SGNL
	LD	HL,DOESEC		;enable time display
	LD	(Z_CKUP),HL
	POP	IX
	RET
	eject
 
;=======
; DOESEC
; This routine is executed periodically every one second.
; It's invoked by the real-time clock (RTZ.RTC) and runs
; as a subroutine to this process. Time is displayed, if
; enabled, and a message is sent to SEC_SM. This message
; makes it possible for one process, waiting at SEC_SM in
; its idle-phase, to run periodically.
;=======
 
DOESEC
	LD	A,(CLOKEN)	;time display enabled ?
	OR	A
	JR	Z,DOES10		;..no
	LD	DE,SECRSM		;check if last display ready
	LD	HL,0			;..poll
	CALL	Z_WAIT
	LD	A,L
	OR	H
	JR	Z,DOES10		;it wasn't ready, skip it now
	PUSH	HL			;save ^message
	LD	DE,MSGBAD		;HL:=^buffer
	ADD	HL,DE
	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A
	LD	DE,Z_SECS+2	;DE:=hours in BCD
	LD	B,3			;store time in buffer (ASCII)
DOES05
	LD	A,(DE)
	SRL	A			;first high nibble
	SRL	A
	SRL	A
	SRL	A
	OR	30H
	LD	(HL),A
	INC	HL
	LD	A,(DE)		;then low nibble
	AND	0FH
	OR	30H
	LD	(HL),A
	INC	HL
	LD	(HL),':'
	INC	HL
	DEC	DE			;next time
	DJNZ	DOES05
	DEC	HL			;terminate string with <CR>
	LD	(HL),0DH
	LD	DE,Z_A0SM
	POP	HL
	CALL	Z_SGNL
DOES10
	LD	DE,SEC_SM		;send this message every second
	LD	HL,SECMSG
	CALL	Z_SGNL
	RET
 
	end
