(* File:    EX.TIMER.PLZ.S *)
(* Updated: 821202 / PH *)
(* Created: 821201 / PH *)
 
(*=======
; PROCESS TIMER
;
; This process, if enabled, decrements a stop time value
; every second until that value reaches zero. It also
; displays a string every second to show it's working.
; The timing is achieved by a message signaled to SEC_SM
; every second.
;
; The process TIMER initializes itself as disabled and
; must explicitly be enabled by receiving a message at
; TMR_SM. The enabling message is returned to a message-
; pool (POOLSM). Disabling is handled by poling the shared
; variable TIMEEN.
;=======*)
 
#include "rtzdecls.h"
 
constant
	ON := %FF
	OFF := 0
 
external
	POOLSM,SEC_SM,TMR_SM SEMAPHORE
	TIMEEN byte
	DISPLAY procedure (PTR ^byte)
 
global
	TIMER procedure
	local
		PTR RTZ_RTC_MESSAGE_PTR
		TIMER_COUNT word
	entry
BEGIN: do
		TIMEEN := OFF
	WAIT: do
			PTR := RTZ_RTC_MESSAGE_PTR P_EWAI (#TMR_SM)
			TIMEEN := ON
			TIMER_COUNT := word (PTR^.MSGSEC and %F
				+ (PTR^.MSGSEC/%10) * 10
				+ 60 * (PTR^.MSGMIN and %F + (PTR^.MSGMIN/%10) * 10)
				+ 3600 * (PTR^.MSGHRS and %F + (PTR^.MSGHRS/%10) *  10))
			P_SGNL (#POOLSM,W_PTR PTR)
			do
				if TIMER_COUNT = 0 then repeat from BEGIN fi
				if TIMEEN = OFF then repeat from WAIT fi
				PTR := RTZ_RTC_MESSAGE_PTR P_EWAI (#SEC_SM)
				TIMER_COUNT -= 1
				DISPLAY (#'Timer%R')
			od
		od ! WAIT !
	od ! BEGIN !
	end TIMER
 
end EX_TIMER
