	title	'RTZ.CON.0'
;UPDATED: 811124 / PH
 
;FILE:    RTZ.EQU.S
;UPDATED: 820120 / PH
 
;=======
; ALL INTERNAL EQUATES FOR RTZ/2
;=======
 
;-------
; Initial Process Control Block
;-------
 
IPCNAM	EQU	0		;PROCESS NAME
IPCENT	EQU	6		;PROCESS ENTRY
IPCSTZ	EQU	8		;STACK SIZE
IPCPTY	EQU	10		;PROCESS PRIORITY
 
;-------
; Initial Semaphore
;-------
 
ISMADR	EQU	0		;SEMAPHORE ADDRESS
 
;-------
; Configuration Table - Z$CRTB
;-------
 
CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
CNFNOP	EQU	2		;# OF IPCB:S IN IPT
CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
CNFNOS	EQU	5		;# OF ISEM:S IN IST
 
;-------
; Process Control Block
;-------
 
PCBLNK	EQU	0		;LINK FIELD
PCBDLY	EQU	2		;DELAY TIME
PCBDLK	EQU	4		;DELAY LINK FIELD
PCBSEM	EQU	6		;SEMAPHORE
PCBSP 	EQU	8		;STACK POINTER
PCBPTY	EQU	10		;PROCESS PRIORITY
PCBSTT	EQU	11		;STATUS BITS
PCBNAM	EQU	12		;^NAME
PCBRND	EQU	14		;RANDOM FIELD
PCBPCB	EQU	16		;STATIC PCB-LINK
 
;-------
; Semaphore
;-------
 
SEMMGQ	EQU	0		;MESSAGE QUEUE
SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
 
SEMIMG	EQU	6		;INTERRUPT MESSAGE
 
;-------
; Minimum Message
;-------
 
MSGLNK	EQU	0		;QUEUE LINK
MSGRQC	EQU	2		;REQUEST CODE
MSGRC 	EQU	3		;RETURN CODE
MSGLEN	EQU	4		;LENGTH
MSGRSM	EQU	6		;RESPONSE SEMAPHORE
 
;-------
; Device Request Message
;-------
 
MSGBAD	EQU	8		;BUFFER ADDRESS
MSGBSZ	EQU	10		;BUFFER SIZE
MSGBCN	EQU	12		;BYTE COUNT
 
MSGSEC	EQU	8		;SECONDS
MSGMIN	EQU	9		;MINUTES
MSGHRS	EQU	10		;HOURS
 
MSGWL 	EQU	8		;WANTED LENGTH
MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
 
;-------
; Device Request Bits
;-------
 
ZQBRD 	EQU	1		;00.. ..01 READ
;ZQbRD 	EQU	0
ZQBWRT	EQU	2		;00.. ..10 WRITE
;ZQbWRT	EQU	1
ZQBASC	EQU	0		;00.. .0.. ASCII
ZQBBIN	EQU	4		;00.. .1.. BINARY
;ZQbBIN	EQU	2
ZQBSTT	EQU	8		;00.. 1... STATUS
;ZQbSTT	EQU	4
 
;-------
; Device Request Codes
;-------
 
      						;00xx xxxx COMMON CODES
ZQCRDA	EQU	ZQBRD+ZQBASC		;READ ASCII
ZQCRDB	EQU	ZQBRD+ZQBBIN		;READ BINARY
ZQCWRA	EQU	ZQBWRT+ZQBASC		;WRITE ASCII
ZQCWRB	EQU	ZQBWRT+ZQBBIN		;WRITE BINARY
ZQCRDS	EQU	ZQBRD+ZQBSTT		;READ STATUS
ZQCWRS	EQU	ZQBWRT+ZQBSTT		;WRITE STATUS
 
      				;01xx xxxx COMMAND CODES
ZQCRDC	EQU	61H		;READ CLOCK
ZQCWRC	EQU	62H		;WRITE CLOCK
ZQCWAT	EQU	63H		;WAKE AT
ZQCWAF	EQU	64H		;WAKE AFTER
 
ZQCMCF	EQU	68H		;CONDITIONAL, FAST
ZQCMCB	EQU	69H		;CONDITIONAL, BEST
ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
 
;-------
; System Return Codes
;-------
 
ZRCINT	EQU	0		;INTERRUPT MESSAGE
ZRCMIS	EQU	44H		;MISSED INTERRUPT
ZRCTO 	EQU	80H		;1... .... TIME-OUT
 
;-------
; Device Return Codes
;-------
 
ZRCOK 	EQU	0		;NORMAL TERMINATION
ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
ZRCERR	EQU	42H		;UNSPECIFIED ERROR
ZRCBSY	EQU	43H		;DEVICE BUSY
ZRCOVF	EQU	45H		;DATA OVERFLOW
ZRCEOF	EQU	46H		;END OF FILE
ZRCDWN	EQU	47H		;DEVICE OFF LINE
ZRCEOM	EQU	48H		;END OF MEDIA
 
;-------
; HELP EQUATES
;-------
 
STTDLY	EQU	3		;BIT 3 IN PCBSTT
STCKAF	EQU	8		;OFFSET TO AF IN STACK
STCKHL	EQU	10		;OFFSET TO HL IN STACK
STCKPC	EQU	12		;OFFSET TO PC IN STACK
SZISTK	EQU	50		;SIZE OF IDLE STACK
 
;FILE:    RTZ.CON.EQU.S
;UPDATED: 811201 / PH
 
;-------
; STTTAB - OFFSETS IN STATUS-TABLE
;-------
 
CHRDEL	EQU	0
LINDEL	EQU	1
INPDEL	EQU	2
ANC   	EQU	3		;ACCEPT NEXT CHARACTER
SUSPND	EQU	4
RESUME	EQU	5
KILL  	EQU	6
LFCNT 	EQU	7
NULLCT	EQU	8
ECHO  	EQU	9
DRUM  	EQU	10		;^TAB DRUM
EDRUM 	EQU	12
 
KEYSM 	EQU	14
KEYSAV	EQU	16
SCHR  	EQU	18
GCHR  	EQU	20
CONSTT	EQU	22
OUTSTT	EQU	23
CURSOR	EQU	24
 
IQ    	EQU	26
TIQ   	EQU	28
FIQ   	EQU	30
EIQ   	EQU	32
LIQ   	EQU	34
 
;-------
; BITS IN CONSTT
;-------
 
B_READ	EQU	3		;BIT 3 IN CONSTT
ECHOCR	EQU	4		;    4
IA    	EQU	6		;    6  (1="READ", 0="WRITE")
HFDUP 	EQU	7		;    7
 
;-------
; HELP EQUATES
;-------
 
LSTT  	EQU	14		;LENGTH OF USER ACCESSIBLE STATUS-TABLE
EOFMRK	EQU	0FFH
 
;=======
; ASCII-characters
;=======
 
ASCEOT	EQU	4		;^D
ASCIBS	EQU	8		;^H
ASCIHT	EQU	9		;^I  (TAB)
ASCILF	EQU	0AH
ASCICR	EQU	0DH
ASCESC	EQU	1BH		;ESCAPE
ASCDEL	EQU	7FH		;DELETE
 
;=======
; Z_CON0 - HANDLER FOR CONSOLE # 0
;=======
 
	GLOBAL	Z_CON0
	EXTERNAL	Z_SGNL,Z_CPRO
	EXTERNAL	Z_CON,Z_CINI,Z_C0SM
	EXTERNAL	Z_C0RZ,Z_C0GS,Z_INI0
 
Z_CON0
	LD	DE,Z_C0ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,LSTTAB
	LDIR
	LD	HL,(Z_C0GS)	;RECEIVE INTERRUPT SEMAPHORE
	LD	(Z_C0ST+GCHR),HL
 
	LD	IX,Z_C0ST		;SET TABS
	LD	HL,(Z_C0RZ)	;  AND ALLOCATE TYPE-AHEAD RING
	CALL	Z_CINI		;  AND CREATE KEY-SEMAPHORE
 
	LD	DE,Z_KEY0		;SEND "KEY" TO Z_KEY0
	LD	HL,Z_KMG0
	CALL	Z_SGNL
	LD	DE,IPCBAX		;BC:=^IPCB FOR Z_ALM0
	CALL	Z_CPRO		;CREATE Z_ALM0
	CALL	Z_INI0		;DO USER-SUPPLIED INIT
 
; MAIN LOOP
 
	LD	IX,Z_C0ST		;IX:=^STATUS-TABLE
CONLOP
	LD	DE,Z_C0SM		;WAIT AT REQUEST-SEMAPHORE
	CALL	Z_CON
	JR	CONLOP
 
;-------
; IPCBAX - INITIAL PCB FOR Z_ALM0
;-------
 
IPCBAX
	text	'Z_ALM0'
	DEFW	Z_ALM0
	DEFW	62			;STACK SIZE
	DEFB	100			;PRIORITY
 
;=======
; STTTAB - DEFAULT IMPURE AREA FOR CONSOLE  # 0
;
; ACCESSED BY OFFSET TO IX
;=======
 
	EXTERNAL	Z_SCH0
 
STTTAB
	DEFB	ASCIBS		;CHRDEL
	DEFB	ASCDEL		;LINDEL
	DEFB	18H			;INPDEL (^X)
	DEFB	10H			;DLE (^P)
	DEFB	13H			;XOFF (^S)
	DEFB	11H			;XON (^Q)
	DEFB	0FH			;KILL (^O)
	DEFB	1			;LFCNT
	DEFB	1			;NULLCT
	DEFB	0FFH			;ECHO (ON)
	DEFW	Z_DRM0		;DRUM (TAB-DRUM)
	DEFW	Z_EDR0		;EDRUM (END OF TAB-DRUM)
	DEFW	Z_KEY0		;KEYSM
	DEFW	Z_KES0		;KEYSAV
	DEFW	Z_SCH0		;SCHR
	DEFW	0			;GCHR
	DEFB	26H			;CONSTT
	DEFB	0			;OUTSTT
	DEFB	0			;CURSOR
	DEFB	0			;--
ASTTAB	EQU	$-STTTAB
 
	DEFW	0			;IQ (TYPE AHEAD RING)
	DEFW	0			;TIQ (TOP OF Z_IQ0)
	DEFW	0			;FIQ (^FRONT OF RING)
	DEFW	0			;EIQ (^END OF RING)
	DEFW	0			;LIQ (LENGTH OF RING)
LSTTAB	EQU	$-STTTAB
 
;=======
; Z_ALM0 - WRITE ALARM ON CONSOLE # 0
;=======
 
	GLOBAL	Z_ALM0
	EXTERNAL	Z_A0SM

Z_ALM0
	LD	DE,Z_A0ST		;LOAD DEFAULT STATUS-TABLE
	LD	HL,STTTAB
	LD	BC,ASTTAB
	LDIR
	LD	HL,Z_A0ST+OUTSTT
	SET	0,(HL)		;THIS IS AN ALARM PROCESS
 
; MAIN LOOP
 
	LD	IX,Z_A0ST		;IX:=^STATUS-TABLE
ALMLOP
	LD	DE,Z_A0SM		;WAIT AT ALARM-SEMAPHORE
	CALL	Z_CON
	JR	ALMLOP
 
;-------
; Z_GCI0 - RECEIVE HANDLING
;
; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
;          CY = 0  IF NOT
;
; TO BE CALLED BY RECEIVE-INTERRUPT
;-------
 
	GLOBAL	Z_GCI0
	EXTERNAL	Z_GCI
 
Z_GCI0
	PUSH	IX
	LD	IX,Z_C0ST
	JP	Z_GCI
	title	'RTZ.CON.0.RAM'
;UPDATED: 811124 / PH
 
;=======
; RAM FOR CONSOLE # 0
;=======
 
	begin	1

Z_C0ST	DEFS	36		;STATUS-TABLE
Z_A0ST	DEFS	26		;STATUS-TABLE FOR ALARM
Z_KEY0	DEFS	6		;SEM. HOLDING KEY TO SCREEN
Z_KES0	DEFS	2		;SAVE AREA FOR KEY
Z_KMG0	DEFS	2		;"KEY" TO SCREEN
Z_DRM0	DEFS	90		;TAB-DRUM
Z_EDR0	equ	$

	end
