	title	'RTZ.CON.MAIN'
;UPDATED: 811201 / PH
;REV:     2.00
 
;=======
; RTZ.CON - MULTI-CONSOLE DRIVER
;           MAIN MODULE
;
; COPYRIGHT: DIGITAILOR AB, SWEDEN
;
; REV. 2.00:  RELEASED 8111xx
;
; Accepts: IX = ^IMPURE AREA
;=======
 
;FILE:    RTZ.EQU.S
;UPDATED: 820120 / PH
 
;=======
; ALL INTERNAL EQUATES FOR RTZ/2
;=======
 
;-------
; Initial Process Control Block
;-------
 
IPCNAM	EQU	0		;PROCESS NAME
IPCENT	EQU	6		;PROCESS ENTRY
IPCSTZ	EQU	8		;STACK SIZE
IPCPTY	EQU	10		;PROCESS PRIORITY
 
;-------
; Initial Semaphore
;-------
 
ISMADR	EQU	0		;SEMAPHORE ADDRESS
 
;-------
; Configuration Table - Z$CRTB
;-------
 
CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
CNFNOP	EQU	2		;# OF IPCB:S IN IPT
CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
CNFNOS	EQU	5		;# OF ISEM:S IN IST
 
;-------
; Process Control Block
;-------
 
PCBLNK	EQU	0		;LINK FIELD
PCBDLY	EQU	2		;DELAY TIME
PCBDLK	EQU	4		;DELAY LINK FIELD
PCBSEM	EQU	6		;SEMAPHORE
PCBSP 	EQU	8		;STACK POINTER
PCBPTY	EQU	10		;PROCESS PRIORITY
PCBSTT	EQU	11		;STATUS BITS
PCBNAM	EQU	12		;^NAME
PCBRND	EQU	14		;RANDOM FIELD
PCBPCB	EQU	16		;STATIC PCB-LINK
 
;-------
; Semaphore
;-------
 
SEMMGQ	EQU	0		;MESSAGE QUEUE
SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
 
SEMIMG	EQU	6		;INTERRUPT MESSAGE
 
;-------
; Minimum Message
;-------
 
MSGLNK	EQU	0		;QUEUE LINK
MSGRQC	EQU	2		;REQUEST CODE
MSGRC 	EQU	3		;RETURN CODE
MSGLEN	EQU	4		;LENGTH
MSGRSM	EQU	6		;RESPONSE SEMAPHORE
 
;-------
; Device Request Message
;-------
 
MSGBAD	EQU	8		;BUFFER ADDRESS
MSGBSZ	EQU	10		;BUFFER SIZE
MSGBCN	EQU	12		;BYTE COUNT
 
MSGSEC	EQU	8		;SECONDS
MSGMIN	EQU	9		;MINUTES
MSGHRS	EQU	10		;HOURS
 
MSGWL 	EQU	8		;WANTED LENGTH
MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
 
;-------
; Device Request Bits
;-------
 
;ZQBRD 	EQU	1		;00.. ..01 READ
ZQbRD 	EQU	0
;ZQBWRT	EQU	2		;00.. ..10 WRITE
ZQbWRT	EQU	1
ZQBASC	EQU	0		;00.. .0.. ASCII
;ZQBBIN	EQU	4		;00.. .1.. BINARY
ZQbBIN	EQU	2
;ZQBSTT	EQU	8		;00.. 1... STATUS
ZQbSTT	EQU	3

;-------
; Device Request Codes
;-------
 
      						;00xx xxxx COMMON CODES
ZQCRDA	EQU	1		;READ ASCII
ZQCRDB	EQU	5		;READ BINARY
ZQCWRA	EQU	2		;WRITE ASCII
ZQCWRB	EQU	6		;WRITE BINARY
ZQCRDS	EQU	9		;READ STATUS
ZQCWRS	EQU	10		;WRITE STATUS
 
      				;01xx xxxx COMMAND CODES
ZQCRDC	EQU	61H		;READ CLOCK
ZQCWRC	EQU	62H		;WRITE CLOCK
ZQCWAT	EQU	63H		;WAKE AT
ZQCWAF	EQU	64H		;WAKE AFTER
 
ZQCMCF	EQU	68H		;CONDITIONAL, FAST
ZQCMCB	EQU	69H		;CONDITIONAL, BEST
ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
 
;-------
; System Return Codes
;-------
 
ZRCINT	EQU	0		;INTERRUPT MESSAGE
ZRCMIS	EQU	44H		;MISSED INTERRUPT
ZRCTO 	EQU	80H		;1... .... TIME-OUT
 
;-------
; Device Return Codes
;-------
 
ZRCOK 	EQU	0		;NORMAL TERMINATION
ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
ZRCERR	EQU	42H		;UNSPECIFIED ERROR
ZRCBSY	EQU	43H		;DEVICE BUSY
ZRCOVF	EQU	45H		;DATA OVERFLOW
ZRCEOF	EQU	46H		;END OF FILE
ZRCDWN	EQU	47H		;DEVICE OFF LINE
ZRCEOM	EQU	48H		;END OF MEDIA
 
;-------
; HELP EQUATES
;-------
 
STTDLY	EQU	3		;BIT 3 IN PCBSTT
STCKAF	EQU	8		;OFFSET TO AF IN STACK
STCKHL	EQU	10		;OFFSET TO HL IN STACK
STCKPC	EQU	12		;OFFSET TO PC IN STACK
SZISTK	EQU	50		;SIZE OF IDLE STACK
 
;FILE:    RTZ.CON.EQU.S
;UPDATED: 811201 / PH
 
;-------
; STTTAB - OFFSETS IN STATUS-TABLE
;-------
 
CHRDEL	EQU	0
LINDEL	EQU	1
INPDEL	EQU	2
ANC   	EQU	3		;ACCEPT NEXT CHARACTER
SUSPND	EQU	4
RESUME	EQU	5
KILL  	EQU	6
LFCNT 	EQU	7
NULLCT	EQU	8
ECHO  	EQU	9
DRUM  	EQU	10		;^TAB DRUM
EDRUM 	EQU	12
 
KEYSM 	EQU	14
KEYSAV	EQU	16
SCHR  	EQU	18
GCHR  	EQU	20
CONSTT	EQU	22
OUTSTT	EQU	23
CURSOR	EQU	24
 
IQ    	EQU	26
TIQ   	EQU	28
FIQ   	EQU	30
EIQ   	EQU	32
LIQ   	EQU	34
 
;-------
; BITS IN CONSTT
;-------
 
B_READ	EQU	3		;BIT 3 IN CONSTT
ECHOCR	EQU	4		;    4
IA    	EQU	6		;    6  (1="READ", 0="WRITE")
HFDUP 	EQU	7		;    7
 
;-------
; HELP EQUATES
;-------
 
LSTT  	EQU	14		;LENGTH OF USER ACCESSIBLE STATUS-TABLE
EOFMRK	EQU	0FFH
 
;=======
; ASCII-characters
;=======
 
ASCEOT	EQU	4		;^D
ASCIBS	EQU	8		;^H
ASCIHT	EQU	9		;^I  (TAB)
ASCILF	EQU	0AH
ASCICR	EQU	0DH
ASCESC	EQU	1BH		;ESCAPE
ASCDEL	EQU	7FH		;DELETE
 
	GLOBAL	Z_CON
	EXTERNAL	Z_EWAI,Z_SGNL,Z_CSEM
 
	text	'RTZ.CON 2.00'
	eject
 
Z_CON
	CALL	Z_EWAI
	PUSH	HL			;SAVE ^REQUEST
	PUSH	HL			;IY:=^REQUEST MESSAGE
	POP	IY
CONBEG
	LD	L,(IY+MSGBAD)	;HL:=BAD
	LD	H,(IY+MSGBAD+1)
	LD	C,(IY+MSGBSZ)	;BC:=BSZ
	LD	B,(IY+MSGBSZ+1)
	LD	A,(IY+MSGRQC)	;A:=REQUEST CODE
	CP	ZQCRDA
	JR	Z,GOODOP
	CP	ZQCRDB
	JR	Z,GOODOP
	CP	ZQCWRA
	JR	Z,GOODOP
	CP	ZQCWRB
	JR	Z,GOODOP
	CP	ZQCRDS
	JR	Z,RWSTT
	CP	ZQCWRS
	JR	Z,RWSTT
	
BADOP
	LD	(IY+MSGRC),ZRCUNK
	JR	EXIT10
 
; TERMINATION OF CON
 
EXIT
	LD	(IY+MSGRC),ZRCOK
EXIT10
	POP	HL			;HL:=^REQUEST
	LD	E,(IY+MSGRSM)	;DE:=^RESPONSE SEMAPHORE
	LD	D,(IY+MSGRSM+1)
	JP	Z_SGNL
	
;=======
; READ AND WRITE STATUS
;=======
	
RWSTT
	EX	DE,HL		;DE:=BAD
	LD	HL,LSTT
	AND	A
	SBC	HL,BC
	JR	NC,RWST10
	LD	BC,LSTT
RWST10
	LD	(IY+MSGBCN),C
	LD	(IY+MSGBCN+1),B
	PUSH	IX			;HL:=^Z_CXST
	POP	HL
	CP	ZQCRDS
	JR	Z,RWST20
	EX	DE,HL
RWST20
	LDIR
	JR	EXIT
 
GOODOP
	LD	A,C			;BSZ = 0 ?
	OR	B
	JR	NZ,GOOD10		;NO
	LD	(IY+MSGBCN),C
	LD	(IY+MSGBCN+1),B
	JR	EXIT
GOOD10
	BIT	ZQbRD,(IY+MSGRQC)
	JP	NZ,READ
 
;=======
; WRITE OPERATION
;=======
	
WRITE
	RES	IA,(IX+CONSTT)	;INDICATE WRITE OPERATION
	RES	B_READ,(IX+CONSTT)
	PUSH	DE			;GET ACCESS TO SCREEN
	PUSH	HL
	LD	E,(IX+KEYSM)
	LD	D,(IX+KEYSM+1)
	CALL	Z_EWAI
	LD	(IX+KEYSAV),L
	LD	(IX+KEYSAV+1),H
	POP	HL
	POP	DE
WRTLP
	LD	A,(HL)		;A:=CHAR TO BE WRITTEN
	CP	EOFMRK		;END OF FILE ?
	JR	NZ,WRT20
	BIT	ZQbBIN,(IY+MSGRQC);YES, BINARY ?
	JR	NZ,TTYDON		;YES, TERMINATE
WRT20
	CALL	TTYOUT
	INC	HL
	DEC	BC
	CP	ASCICR		;LAST CHAR IS <CR> ?
	CALL	Z,FINLIN		;YES
	LD	A,C			;NO, ALL CHARS WRITTEN ?
	OR	B
	JR	NZ,WRTLP		;NO, GO ON
TTYDON
	PUSH	DE
	PUSH	HL
	LD	E,(IX+KEYSM)	;RETURN SCREEN
	LD	D,(IX+KEYSM+1)
	LD	L,(IX+KEYSAV)
	LD	H,(IX+KEYSAV+1)
	CALL	Z_SGNL
	POP	HL
	POP	DE
TTYD10
	LD	L,(IY+MSGBSZ)	;HL:=REQUESTED BYTE COUNT
	LD	H,(IY+MSGBSZ+1)
	AND	A
	SBC	HL,BC		;BCN:=# OF CHARS WRITTEN
	LD	(IY+MSGBCN),L
	LD	(IY+MSGBCN+1),H
	JP	EXIT
 
;=======
; FINLIN
;=======
	
FINLIN
	PUSH	BC
	LD	A,(IX+CONSTT)	;A:=CONSTT
	PUSH	AF
	RES	IA,(IX+CONSTT)
	CALL	LFS
	CALL	NULLS
	POP	AF
	LD	(IX+CONSTT),A
	POP	BC
	BIT	ZQbBIN,(IY+MSGRQC);BINARY REQUEST ?
	RET	NZ			;YES, GO ON
	POP	HL			;NO, SKIP RETURN FROM FINLIN
	BIT	B_READ,(IX+CONSTT)
	JR	NZ,TTYD10
	JR	TTYDON		;TERMINATE CON
 
;=======
; READ OPERATION
;=======
	
READ
	BIT	0,(IX+OUTSTT)	;ALARM ?
	JP	NZ,BADOP		;YES, READ NOT ALLOWED
	SET	IA,(IX+CONSTT)	;INDICATE READ OPERATION
	SET	B_READ,(IX+CONSTT)
	PUSH	HL			;SAVE BAD PUSH-1
RDLOOP
	CALL	GECHR		;NO, READ CHAR
	CP	(IX+ANC)		;ACCEPT NEXT CHARACTER (^P) ?
	JR	NZ,RD20
 
; HANDLE "ACCEPT NEXT CHARACTER"
 
	BIT	0,(IX+ECHO)	;ECHO ?
	CALL	NZ,KEYOUT		;YES, WRITE BACKSLASH
	CALL	GECHR
	LD	(HL),A
	JP	NODEL4
RD20
	CP	(IX+INPDEL)	;INPUT DELETE ?
	JR	NZ,RD25		;NO
 
; HANDLE INPUT DELETE
 
	POP	HL			;YES, GET BAD POP-1
	RES	IA,(IX+CONSTT)
	LD	A,'\'
	CALL	KEYOUT
	LD	A,ASCICR
	CALL	KEYOUT
	CALL	LFS
	CALL	NULLS
	JP	CONBEG
 
RD25
	LD	(HL),A
	PUSH	HL			;BAD.CUR, PUSH-2
	CP	(IX+CHRDEL)	;CHARACTER DELETE ?
	JR	NZ,LD?
 
; HANDLE CHARACTER DELETE
 
	POP	DE			;DE:=BAD.CUR  POP-2
	POP	HL			;HL:=BAD  POP-1
	PUSH	HL			;PUSH-1
	AND	A
	SBC	HL,DE		;BUFFER EMPTY ?
	EX	DE,HL		;  HL:=BAD.CUR
	JR	Z,RDLOOP		;YES, DO NOTHING
	BIT	0,(IX+ECHO)
	DEC	HL
	JR	Z,DELC20
	LD	A,(HL)
	CP	ASCIHT		;DELETE TAB ?
	PUSH	BC
	LD	B,1			;  ASSUME NO
	JR	NZ,DELC05		;NO
	CALL	GETCNT		;YES
	LD	B,A
	JR	DELC10
DELC05
	CP	20H			;DELETE CONTROL CHARACTER ?
	JR	C,DELC15		;YES
DELC10
	CALL	DELCH
	RES	IA,(IX+CONSTT)
	DJNZ	DELC10
	SET	IA,(IX+CONSTT)
DELC15
	POP	BC
DELC20
	INC	BC
	JR	RDLOOP
 
LD?
	CP	(IX+LINDEL)	;LINE DELETE ?
	JR	NZ,NODEL
 
; HANDLE LINE DELETE
 
DELL05
	POP	HL
	POP	DE
	PUSH	DE
	AND	A
	SBC	HL,DE
	ADD	HL,DE
	DEC	HL
	JR	Z,DELL10
	LD	A,(HL)
	CP	ASCICR
	JR	Z,DELL10
	PUSH	HL
	INC	BC
	PUSH	BC
	LD	B,1
	CP	ASCIHT
	JR	NZ,DELL12
	CALL	GETCNT
	LD	B,A
	JR	DELL15
DELL12
	CP	20H
	JR	C,DELL17
DELL15
	RES	IA,(IX+CONSTT)
	CALL	DELCH
	DJNZ	DELL15
	SET	IA,(IX+CONSTT)
DELL17
	POP	BC
	JR	DELL05
DELL10
	INC	HL
	JP	RDLOOP
 
NODEL
	CP	ASCEOT
	JR	NZ,NODEL2
 
; HANDLE END OF TEXT (^D)
 
	BIT	ZQbBIN,(IY+MSGRQC);BINARY REQUEST ?
	JR	Z,NODEL2		;NO, SKIP EOT-HANDLING
	POP	HL			;HL:=BAD.CUR, POP-2
	LD	(HL),EOFMRK
	DEC	BC
	POP	DE			;POP-1
	LD	L,(IY+MSGBSZ)
	LD	H,(IY+MSGBSZ+1)
	AND	A
	SBC	HL,BC
	LD	(IY+MSGBSZ),L
	LD	(IY+MSGBSZ+1),H
	LD	(IY+MSGRC),ZRCEOF
	JP	EXIT10
 
NODEL2
	CP	14H
	JR	NZ,NODEL3
 
; HANDLE ^T
 
	CALL	GECHR
	CP	' '
	LD	A,1
	JR	NZ,TABSET
	XOR	A
TABSET
	PUSH	DE
	PUSH	HL
	LD	L,(IX+CURSOR)	;HL:=CURSOR
	LD	H,0
	LD	E,(IX+DRUM)
	LD	D,(IX+DRUM+1)
	ADD	HL,DE
	LD	(HL),A
	POP	HL
	POP	DE
	POP	HL
	JP	RDLOOP
 
; HANDLE USUAL CHARACTER
 
NODEL3
	POP	HL			;POP-2
NODEL4
	INC	HL			;NEXT POS IN BAD
	DEC	BC
	CP	ASCICR
	JR	NZ,RD70
 
; HANDLE <CR>
 
	BIT	ECHOCR,(IX+CONSTT)
	JR	NZ,RD80
RD70
	BIT	0,(IX+ECHO)
	CALL	NZ,KEYOUT
RD80
	CP	ASCICR
	POP	DE			;POP-1
	CALL	Z,FINLIN
	LD	A,C
	OR	B
	JP	Z,TTYD10
	PUSH	DE			;PUSH-1
	JP	RDLOOP
 
 
;=======
; TTYOUT
;
; OUTPUT CHAR IN "A"
;=======
 
TTYOUT
	PUSH	AF			;SAVE CHAR
	CP	20H			;PRINTABLE CHAR OR DEL ?
	JR	NC,ED50		;YES
	CP	ASCICR		;NO, <CR> ?
	JR	NZ,ED20		;NO
 
; HANDLE <CR>
 
	LD	(IX+CURSOR),0	;YES, RESET CURSOR
	JR	ED90
 
ED20
	CP	ASCIHT		;TAB ?
	JR	NZ,ED30
 
; HANDLE TABS
 
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	E,(IX+CURSOR)	;DE:=CURSOR
	LD	D,0
	LD	L,(IX+DRUM)	;DE:=HL:=POS IN DRUM
	LD	H,(IX+DRUM+1)
	ADD	HL,DE
	LD	D,H
	LD	E,L
	LD	A,(IX+CONSTT)	;SAVE CONSTT
	PUSH	AF
	RES	IA,(IX+CONSTT)
ED22
	LD	A,' '
	CALL	TTYOUT
	INC	HL			;HL:=NEXT POS IN DRUM
	PUSH	DE
	LD	E,(IX+EDRUM)
	LD	D,(IX+EDRUM+1)
	PUSH	HL
	AND	A
	SBC	HL,DE		;OUT OF DRUM ?
	POP	HL			;  HL:=NEXT POS IN DRUM
	POP	DE			;  DE:=POS IN DRUM
	JR	NC,ED25		;YES, LEAVE TAB-HANDLING
	LD	A,(HL)		;NEXT POS IN DRUM = 0 ?
	OR	A
	JR	Z,ED22		;YES, EXAMINE NEXT POS
	PUSH	HL
	SBC	HL,DE		;HL:=TAB OFFSET
	LD	A,L
	POP	HL			;POS IN DRUM:=TAB OFFSET
	LD	(HL),A
ED25
	POP	AF			;RESTORE CONSTT
	LD	(IX+CONSTT),A
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	RET	
	
ED30
	CP	(IX+CHRDEL)	;BACKSPACE ?
	JR	NZ,ED90		;NO
 
; HANDLE BACK-SPACE
 
	DEC	(IX+CURSOR)
	JR	ED90
 
; HANDLE USUAL CHARACTER AND DELETE
 
ED50
	CP	ASCDEL		;DELETE ?
	JR	Z,ED90
	INC	(IX+CURSOR)	;NO, INCREMENT CURSOR
ED90
	POP	AF			;A:=CHARACTER
	BIT	IA,(IX+CONSTT)		;WRITE OPERATION ?
	JR	Z,ED95		;YES, WRITE CHARACTER
	BIT	HFDUP,(IX+CONSTT);NO, WRITE ONLY IF FULL DUPLEX
ED95
	JP	Z,SECHR
	RET	
 
;=======
; KEYOUT - ASSIGN SCREEN AND "TTYOUT"
;=======
 
KEYOUT
	PUSH	DE
	PUSH	HL
	PUSH	AF
	LD	E,(IX+KEYSM)
	LD	D,(IX+KEYSM+1)
	CALL	Z_EWAI
	POP	AF
	CALL	TTYOUT
	CALL	Z_SGNL
	POP	HL
	POP	DE
	RET
 
;=======
; NULLS
;=======
	
NULLS
	LD	A,(IX+NULLCT)
	OR	A
	RET	Z
	LD	B,A
	XOR	A			;A:=NULL
NULLIT
	BIT	B_READ,(IX+CONSTT)
	PUSH	AF
	CALL	NZ,KEYOUT
	POP	AF
	CALL	Z,TTYOUT
	DJNZ	NULLIT
	RET	
 
;=======
; LFS
;=======
	
LFS
	LD	A,(IX+LFCNT)
	OR	A
	RET	Z
	LD	B,A
	LD	A,ASCILF
	JR	NULLIT
 
;=======
; GETCNT
;=======
	
GETCNT
	PUSH	DE
	PUSH	HL
	LD	E,(IX+DRUM)
	LD	D,(IX+DRUM+1)
	LD	L,(IX+CURSOR)	;HL:=CURSOR
	LD	H,0
	ADD	HL,DE
	LD	E,(IX+EDRUM)
	LD	D,(IX+EDRUM+1)
	AND	A
	PUSH	HL
	SBC	HL,DE
	POP	HL
	LD	A,(HL)
	POP	HL
	POP	DE
	RET	C
	LD	A,1
	RET	
 
;=======
; DELCH - DELETE CHARACTER
;=======
	
DELCH
	LD	A,ASCIBS
	CALL	KEYOUT
	LD	A,' '
	RES	IA,(IX+CONSTT)
	CALL	KEYOUT
	LD	A,ASCIBS
	CALL	KEYOUT
	SET	IA,(IX+CONSTT)
	RET	
 
;=======
; SECHR
;=======
 
SECHR
	PUSH	BC
	PUSH	DE
	PUSH	HL
SCHR10
	LD	L,(IX+SCHR)
	LD	H,(IX+SCHR+1)
	BIT	0,(IX+OUTSTT)	;ALARM OUTPUT ?
	JR	NZ,SCHR20		;YES
	BIT	B_READ,(IX+CONSTT);READ REQUEST ?
	JR	NZ,SCHR20		;YES
	BIT	5,(IX+OUTSTT)	;OUTPUT KILLED ?
	JR	NZ,SCHR40		;YES
	BIT	6,(IX+OUTSTT)	;OUTPUT SUSPENDED ?
	JR	Z,SCHR20		;NO
	PUSH	AF			;YES, SAVE CHAR
	XOR	A			;A:=NULL
	CALL	JPHL			;CALL USER OUTPUT
	POP	AF			;RESTORE CHAR
	JR	SCHR10
SCHR20
	PUSH	AF			;SAVE CHARACTER
	CALL	JPHL
	POP	AF			;RESTORE CHAR
SCHR40
	POP	HL
	POP	DE
	POP	BC
	RET
 
JPHL
	JP	(HL)
 
;=======
; GECHR - GET CHARACTER
;
; RETURNS: A  = ASCII CHARACTER WITH PARITY RESET
;=======
 
GECHR
	PUSH	DE
	PUSH	HL
RMIQ00
	LD	E,(IX+FIQ)	;DE:=^FRONT OF QUEUE
	LD	D,(IX+FIQ+1)
	DI
	LD	L,(IX+EIQ)	;HL:=^END OF QUEUE
	LD	H,(IX+EIQ+1)
	AND	A
	SBC	HL,DE		;QUEUE EMPTY ?
	JR	NZ,RMIQ10		;NO
	EI
	LD	E,(IX+GCHR)	;YES, WAIT FOR INTERRUPT
	LD	D,(IX+GCHR+1)
	CALL	Z_EWAI
	JR	RMIQ00
RMIQ10
	LD	A,(DE)		;A:=FIRST ITEM IN QUEUE
	AND	7FH			;RESET PARITY. CY:=0
	INC	DE			;UPDATE Z_FIQ
	LD	L,(IX+TIQ)	;WRAPAROUND TEST
	LD	H,(IX+TIQ+1)
	SBC	HL,DE		;Z_FIQ = Z_TIQ ?
	JR	NZ,RMIQ20		;NO
	LD	E,(IX+IQ)		;YES, Z_FIQ:=Z_IQ
	LD	D,(IX+IQ+1)
RMIQ20
	LD	(IX+FIQ),E	;RESTORE Z_FIQ
	LD	(IX+FIQ+1),D
	EI
	POP	HL
	POP	DE
	RET	
 
;-------
; Z_GCI - RECEIVE HANDLING
;
; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
;          CY = 0  IF NOT
;
; TO BE CALLED BY RECEIVE-INTERRUPT
;-------
 
	GLOBAL	Z_GCI
 
Z_GCI
	AND	7FH
	CP	(IX+SUSPND)	;SUSPEND OUTPUT ?
	JR	NZ,GCI10
	SET	6,(IX+OUTSTT)	;YES, SUSPEND OUTPUT
GCI15
	POP	IX
	SCF
	RET
GCI10
	CP	(IX+RESUME)	;RESUME OUTPUT ?
	JR	NZ,GCI20
	RES	6,(IX+OUTSTT)	;YES, RESUME OUTPUT
	JR	GCI15
GCI20
	CP	(IX+KILL)		;KILL OUTPUT ?
	JR	NZ,GCI30		;NO
	LD	A,(IX+OUTSTT)	;YES, KILL OUTPUT
	XOR	00100000B
	LD	(IX+OUTSTT),A
	JR	GCI15
GCI30
	PUSH	DE
	PUSH	HL
	LD	E,(IX+EIQ)	;DE:=^END OF QUEUE
	LD	D,(IX+EIQ+1)
	LD	(DE),A		;APPEND ITEM TO QUEUE
	INC	DE			;UPDATE END OF QUEUE
	LD	L,(IX+TIQ)	;WRAPAROUND TEST
	LD	H,(IX+TIQ+1)
	AND	A
	SBC	HL,DE		;Z_EIQ = Z_TIQ ?
	JR	NZ,APIQ10		;NO
	LD	E,(IX+IQ)		;YES, Z_EIQ:=Z_IQ
	LD	D,(IX+IQ+1)
APIQ10
	LD	L,(IX+FIQ)	;HL:=^FRONT OF QUEUE
	LD	H,(IX+FIQ+1)
	AND	A
	SBC	HL,DE		;QUEUE FULL ?
	JR	Z,APIQ20		;YES
	LD	(IX+EIQ),E	;NO, RESTORE Z_EIQ
	LD	(IX+EIQ+1),D
APIQ20
	POP	HL
	POP	DE
	POP	IX
	AND	A			;CLEAR CY
	RET
 
;=======
; Z_CINI - REENTRANT INIT FOR ALL CONSOLES
;=======
 
	GLOBAL	Z_CINI
	EXTERNAL	Z_GETM
 
Z_CINI
	LD	E,L			;DE:=HL=RING-SIZE
	LD	D,H
	CALL	Z_GETM		;ALLOCATE TYPE-AHEAD RING
	LD	(IX+IQ),L
	LD	(IX+IQ+1),H
	LD	(IX+FIQ),L
	LD	(IX+FIQ+1),H
	LD	(IX+EIQ),L
	LD	(IX+EIQ+1),H
	ADD	HL,DE		;CALCULATE TOP OF RING
	LD	(IX+TIQ),L
	LD	(IX+TIQ+1),H
	LD	(IX+LIQ),E	;STORE RING-SIZE
	LD	(IX+LIQ+1),D
 
	LD	L,(IX+DRUM)	;SET TABS
	LD	H,(IX+DRUM+1)
	PUSH	HL
	LD	E,L
	LD	D,H
	INC	DE
	LD	(HL),0
	LD	BC,7
	LDIR
	LD	(HL),0FFH
	POP	HL
	LD	BC,9*8
	LDIR
 
	LD	E,(IX+KEYSM)	;CREATE KEY-SEMAPHORE
	LD	D,(IX+KEYSM+1)
	JP	Z_CSEM

	end
