	title	'RTZ.DBG.MAIN'
;Updated: 821028 / PH
 
;=======
; Z_DBG - REAL-TIME DEBUGGER FOR RTZ
;
; Copyright: DIGITAILOR AB, SWEDEN
;
; REV. 2.00: Released 820128
;      2.01: Released 821029
;=======
 
;FILE:    RTZ.EQU.S
;UPDATED: 820120 / PH
 
;=======
; ALL INTERNAL EQUATES FOR RTZ/2
;=======
 
;-------
; Initial Process Control Block
;-------
 
IPCNAM	EQU	0		;PROCESS NAME
IPCENT	EQU	6		;PROCESS ENTRY
IPCSTZ	EQU	8		;STACK SIZE
IPCPTY	EQU	10		;PROCESS PRIORITY
 
;-------
; Initial Semaphore
;-------
 
ISMADR	EQU	0		;SEMAPHORE ADDRESS
 
;-------
; Configuration Table - Z$CRTB
;-------
 
CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
CNFNOP	EQU	2		;# OF IPCB:S IN IPT
CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
CNFNOS	EQU	5		;# OF ISEM:S IN IST
 
;-------
; Process Control Block
;-------
 
PCBLNK	EQU	0		;LINK FIELD
PCBDLY	EQU	2		;DELAY TIME
PCBDLK	EQU	4		;DELAY LINK FIELD
PCBSEM	EQU	6		;SEMAPHORE
PCBSP 	EQU	8		;STACK POINTER
PCBPTY	EQU	10		;PROCESS PRIORITY
PCBSTT	EQU	11		;STATUS BITS
PCBNAM	EQU	12		;^NAME
PCBRND	EQU	14		;RANDOM FIELD
PCBPCB	EQU	16		;STATIC PCB-LINK
 
;-------
; Semaphore
;-------
 
SEMMGQ	EQU	0		;MESSAGE QUEUE
SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
 
SEMIMG	EQU	6		;INTERRUPT MESSAGE
 
;-------
; Minimum Message
;-------
 
MSGLNK	EQU	0		;QUEUE LINK
MSGRQC	EQU	2		;REQUEST CODE
MSGRC 	EQU	3		;RETURN CODE
MSGLEN	EQU	4		;LENGTH
MSGRSM	EQU	6		;RESPONSE SEMAPHORE
 
;-------
; Device Request Message
;-------
 
MSGBAD	EQU	8		;BUFFER ADDRESS
MSGBSZ	EQU	10		;BUFFER SIZE
MSGBCN	EQU	12		;BYTE COUNT
 
MSGSEC	EQU	8		;SECONDS
MSGMIN	EQU	9		;MINUTES
MSGHRS	EQU	10		;HOURS
 
MSGWL 	EQU	8		;WANTED LENGTH
MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
 
;-------
; Device Request Bits
;-------
 
ZQBRD 	EQU	1		;00.. ..01 READ
;ZQbRD 	EQU	0
ZQBWRT	EQU	2		;00.. ..10 WRITE
;ZQbWRT	EQU	1
ZQBASC	EQU	0		;00.. .0.. ASCII
ZQBBIN	EQU	4		;00.. .1.. BINARY
;ZQbBIN	EQU	2
ZQBSTT	EQU	8		;00.. 1... STATUS
;ZQbSTT	EQU	4
 
;-------
; Device Request Codes
;-------
 
      						;00xx xxxx COMMON CODES
ZQCRDA	EQU	ZQBRD+ZQBASC		;READ ASCII
ZQCRDB	EQU	ZQBRD+ZQBBIN		;READ BINARY
ZQCWRA	EQU	ZQBWRT+ZQBASC		;WRITE ASCII
ZQCWRB	EQU	ZQBWRT+ZQBBIN		;WRITE BINARY
ZQCRDS	EQU	ZQBRD+ZQBSTT		;READ STATUS
ZQCWRS	EQU	ZQBWRT+ZQBSTT		;WRITE STATUS
 
      				;01xx xxxx COMMAND CODES
ZQCRDC	EQU	61H		;READ CLOCK
ZQCWRC	EQU	62H		;WRITE CLOCK
ZQCWAT	EQU	63H		;WAKE AT
ZQCWAF	EQU	64H		;WAKE AFTER
 
ZQCMCF	EQU	68H		;CONDITIONAL, FAST
ZQCMCB	EQU	69H		;CONDITIONAL, BEST
ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
 
;-------
; System Return Codes
;-------
 
ZRCINT	EQU	0		;INTERRUPT MESSAGE
ZRCMIS	EQU	44H		;MISSED INTERRUPT
ZRCTO 	EQU	80H		;1... .... TIME-OUT
 
;-------
; Device Return Codes
;-------
 
ZRCOK 	EQU	0		;NORMAL TERMINATION
ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
ZRCERR	EQU	42H		;UNSPECIFIED ERROR
ZRCBSY	EQU	43H		;DEVICE BUSY
ZRCOVF	EQU	45H		;DATA OVERFLOW
ZRCEOF	EQU	46H		;END OF FILE
ZRCDWN	EQU	47H		;DEVICE OFF LINE
ZRCEOM	EQU	48H		;END OF MEDIA
 
;-------
; HELP EQUATES
;-------
 
STTDLY	EQU	3		;BIT 3 IN PCBSTT
STCKAF	EQU	8		;OFFSET TO AF IN STACK
STCKHL	EQU	10		;OFFSET TO HL IN STACK
STCKPC	EQU	12		;OFFSET TO PC IN STACK
SZISTK	EQU	50		;SIZE OF IDLE STACK
 
	title	'GEN.SWITCH.EQU.S'
;UPDATED: 811023 / PH
 
;=======
; EQUATES FOR BIT-TEST OF COMMAND SWITCHES
;=======
 
; REGISTER E
 
BIT_A 	EQU	0
BIT_B 	EQU	1
BIT_C 	EQU	2
BIT_D 	EQU	3
BIT_E 	EQU	4
BIT_F 	EQU	5
BIT_G 	EQU	6
BIT_H 	EQU	7
 
; REGISTER D
 
BIT_I 	EQU	0
BIT_J 	EQU	1
BIT_K 	EQU	2
BIT_L 	EQU	3
BIT_M 	EQU	4
BIT_N 	EQU	5
BIT_O 	EQU	6
BIT_P 	EQU	7
 
; REGISTER C
 
BIT_Q 	EQU	0
BIT_R 	EQU	1
BIT_S 	EQU	2
BIT_T 	EQU	3
BIT_U 	EQU	4
BIT_V 	EQU	5
BIT_W 	EQU	6
BIT_X 	EQU	7
 
; REGISTER  B
 
BIT_Y 	EQU	0
BIT_Z 	EQU	1
 
	eject
	GLOBAL	Z_DBG
 
Z_DBG
	LD	(Z$INSP),SP	;SAVE STACK-GROUND
	CALL	DBGINI		;SET UP FOR DEBUG
	JR	WEVENT
HALLO
	LD	HL,XHALLO		;SAY HALLO TO USER
	CALL	OUTSTR
CMDWAI
	LD	SP,(Z$INSP)	;RESTORE DEBUGGER SP
	LD	DE,Z_C0SM		;PROMPT FOR COMMAND
	LD	HL,Z$PMSG
	CALL	Z_SGNL
	CALL	INLIN
	LD	HL,CMDWAI		;RETURN FOR HANDLERS
	PUSH	HL
	LD	HL,Z$IBUF
	LD	A,(HL)		;JUST A <CR> ?
	CP	0DH
	JR	Z,CMDWAI		;YES
	LD	DE,CMDTAB
	CALL	G_XCMD		;DECODE COMMAND
	PUSH	DE			;PUSH RETURN-PRM FROM DECODER
	RET	NZ			;GO TO HANDLER IF COMMAND IS OK
	JP	CMDERR
 
;=======
; EVQUE - SET UP CHECKPOINT AND WAIT FOR EVENT
; WEVENT - WAIT FOR EVENT AND GO TO HANDLER
;=======
 
	EXTERNAL	Z_DBSM,Z$CONM,Z_C0SM,Z_SGNL
 
EVQUE
	LD	DE,Z_C0SM
	POP	HL
	LD	(Z$CONM-2),HL
	LD	HL,Z$CONM
	CALL	Z_SGNL
WEVENT
	LD	DE,Z_DBSM		;WAIT FOR EVENT
	CALL	Z_EWAI
	PUSH	HL
	POP	IX
	LD	L,(IX-2)		;PICK UP HANDLER ADDRESS
	LD	H,(IX-1)
	JP	(HL)
 
;=======
; H_QUIT - CANCEL DEBUGGING SESSION
;=======
 
	EXTERNAL	Z$DFLG
 
H_QUIT
	LD	HL,Z$DFLG		;DEBUGGER NOT INVOKED !
	RES	1,(HL)
	LD	HL,XABORT		;GOOD BYE
	CALL	OUTSTR
	JP	WEVENT
 
XABORT
	text	'Debugger aborted'
	DEFW	0FF0DH
 
;-------
; STRINGS
;-------
 
XPROMT	text	'.'
      	DEFB	0FFH
XHALLO	DEFB	0DH
      	text	'RTZ.DBG 2.01'
      	DEFW	0FF0DH
 
;-------
; CMDTAB - TABLE OF COMMANDS
;-------
 
CMDTAB
	DEFT	'REGISTER'
	DEFW	H_REG
	DEFT	'DISPLAY'
	DEFW	H_DSB
	DEFT	'STEP'
	DEFW	H_STEP
	DEFT	'INPUT'
	DEFW	H_INP
	DEFT	'OUTPUT'
	DEFW	H_OUT
	DEFT	'SHOW'
	DEFW	H_SHOW
	DEFT	'MODIFY'
	DEFW	H_EXAM
	DEFT	'ABORT'
	DEFW	H_QUIT
	DEFT	'RUN'
	DEFW	H_RUN
	DEFT	'QUEUE'
	DEFW	H_QUEU
	DEFT	'TPCB'
	DEFW	H_TPCB
	DEFT	'BREAK'
	DEFW	H_BRK
	DEFT	'CANCEL'
	DEFW	H_CAN
	DEFT	'LIST'
	DEFW	H_LIST
	DEFT	'EXEQUTE'
	DEFW	H_XEQ
	DEFB	0
	title	'RTZ.DBG.TRACE'
;UPDATED: 821028 / PH
;Rev:     2.01
 
	EXTERNAL	Z$TRCT,Z$UREG,Z$ADDR,Z$PC
	EXTERNAL	Z$PRRG,Z$TRCF,Z$IPC
	EXTERNAL	Z$ERAM,Z$PTY,Z_SPTY,Z$SP,Z$HL
	EXTERNAL	Z$IY,Z$IY,Z$B,Z$FFIX,Z$AF,Z$DBSP
 
;=======
; H_STEP - TRACE USER CODE
;=======
 
	EXTERNAL	Z$TPCB,Z$ICMD
 
H_STEP
	CALL	CHKTP		;CHECK IF ANY TP
	PUSH	DE			;IX:=^TPCB
	PUSH	DE
	POP	IX
	CALL	TO4680
	CALL	GET1PC		;GET START ADDRESS
	JR	C,STEP05		;NO PARAMETER
	LD	(Z$PC),DE		;SAVE NEW PC
STEP05
	LD	DE,SCFRUT		;ROUTINE SET CARRY
	LD	HL,Z$FFIX+1
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),0C3H		;ROUTINE RES CARRY
	INC	HL			;ALSO JP NN
	LD	DE,RCFRUT
	LD	(HL),E
	INC	HL
	LD	(HL),D
	LD	HL,Z$OBUF		;PRINT PROCESS NAME
	LD	DE,XPROC
	CALL	PUTSTR
	CALL	PUTNAM
	CALL	OTOBUF
	CALL	PALCPU		;PRINT ALL CPU REGISTER
	CALL	BRPNT?		;IS THERE BREAKPOINTS
	XOR	A
	LD	(Z$ICMD),A
	CALL	CNTLDG
	POP	IX
	CALL	FR4680
	RET
 
;=======
; RBRKAD - SET BREAKPOINT
;
; ACCEPTS: DE = BREAK ADDRESS
;=======
 
RBRKAD
	LD	HL,Z$TRCT
SETB10
	LD	A,(HL)
	INC	A
	JR	Z,SETB50 
	INC	HL
	LD	A,(HL)
	XOR	E
	LD	C,A
	INC	HL
	LD	A,(HL)
	XOR	D
	INC	HL
	INC	HL
	OR	C
	JR	NZ,SETB10
	DEC	HL
	DEC	HL
	DEC	HL
	DEC	HL
SETB20
	LD	(HL),B		;PUT MARK
	INC	HL
	LD	(HL),E		;PUT LOW ADDRESS
	INC	HL
	LD	(HL),D		;PUT HIGH ADDRESS
	INC	HL
	LD	A,B			;restore instr.if reset
	OR	A
	JR	Z,SETB25
	LD	A,(DE)		;PUT INST. POINTED TO
	LD	(HL),A		;ADDRESS
	INC	HL
	RET
SETB25
	LD	A,(HL)
	LD	(DE),A
	INC	HL
	RET
SETB50
	LD	A,B			;GET MARK
	OR	A			;IF ZERO IT'S A RESET
	RET	Z
	LD	HL,Z$TRCT-4	;ELSE IT'S A SET BRK
SETB60
	INC	HL			;FIND AN EMPTY PLACE
	INC	HL			;TO PUT THIS NEW
	INC	HL			;BREAK POINT
	INC	HL
	LD	A,(HL)		;IS IT EMPTY
	AND	A
	JR	Z,SETB20
	INC	A
	JR	NZ,SETB60
	CALL	SETB20
	LD	(HL),0FFH
	RET
 
;-------
; ENTER HERE AFTER INSTRUCTION EXECUTED
;-------
 
NXTINS
	CALL	BRPNT?
	AND	30H
	JP	NZ,SUBRUN		;SUB or JTB
	LD	A,(Z$PRRG)
	AND	A
	JR	NZ,NXTI20
	LD	A,(Z$TRCF)
	AND	2
	JP	Z,INTPRT		;SECRET TRACE
NXTI20
	LD	IX,(Z$TPCB)
	CALL	PCHCPU
	LD	A,(Z$PRRG)
	AND	A
	JR	Z,CNTLDG
  
;-------
; SCAN ALL WAT-MARKS
;-------
 
A_1110	LD	HL,Z$TRCT-4
A_1113	PUSH	HL
SWAT10
	POP	HL
A_1115	LD	BC,4
A_1118	ADD	HL,BC
A_1119	LD	A,(HL)
A_111A	INC	A
	JR	Z,CNTLDG		;END OF Z_TRCT
A_111E	PUSH	HL
A_111F	DEC	A
A_1120	AND	0C0H
	JR	Z,SWAT10		;not WAT
A_1125	INC	HL
A_1126	LD	E,(HL)
A_1127	INC	HL
A_1128	LD	D,(HL)
A_1129	INC	HL
A_112A	LD	A,(DE)
A_112B	CP	(HL)
	JR	Z,SWAT10		;NO CHANGE
A_112F	PUSH	DE
A_1130	PUSH	HL
A_1131	EX	DE,HL
A_1132	LD	(Z$ADDR),HL
;               A_1135	CALL	CRLF
;A_1138	CALL	ADRES
A_113B	LD	HL,XWAS
A_113E	CALL	OUTSTR
A_1141	POP	HL
A_1142	PUSH	HL
A_1143	LD	L,(HL)
;A_1144	CALL	PRILIN
A_1147	LD	HL,XIS
A_114A	CALL	OUTSTR
A_114D	POP	DE
A_114E	POP	HL
A_114F	LD	A,(HL)
A_1150	LD	(DE),A
A_1151	LD	L,(HL)
;A_1152	CALL	PRILIN
A_1155	JP	SWAT10
 
XWAS	text	'was '
	DEFB	0FFH
XIS	text	' is '
	DEFB	0FFH
 
;-------
; CONTINUE INTERPRETION
;-------
 
CNTLDG
	LD	HL,(Z$PC)
	CALL	PRINST
	XOR	A
	LD	(Z$PRRG),A
	LD	HL,Z$ICMD
	LD	A,(HL)
	CP	0AH
	JR	Z,INTPRT		;AUTO STEP
	CALL	INCHAR
	LD	C,A
	CP	'X'
	JP	Z,SUBRUN
	CP	'R'
	JP	Z,RUNTRC
	LD	(HL),A
	CP	' '
	JR	Z,INTPRT
	CP	0AH
	RET	NZ			;EXIT
INTPRT
	CALL	EXQINS		;XEQUTE INSTRUCTION
;	JP	Z,NXTINS		;NO JP OR CALL IN EFFECT
;	LD	A,(Z$TRCF)
;	AND	4
;	JP	Z,NXTINS
;	LD	(Z$PRRG),A
;	LD	HL,(Z$IPC)	;PRINT EXECUTED INSTRUCTION
;	CALL	PRINST
	JP	NXTINS
 
;=======
; BRPNT? - IS THIS ADDRESS A BREAKPOINT
;
; ACCEPTS: Z$PC = ADDRESS
;=======
 
BRPNT?
	LD	HL,Z$TRCT
	XOR	A
	LD	B,A
BRP10
	LD	C,(HL)
	LD	A,C
	INC	C
	JR	Z,BRP90		;END OF Z_TRCT
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	C,(HL)
	INC	HL
	AND	A
	JR	Z,BRP10
	PUSH	AF
	AND	0C0H
	JR	Z,BRP30
	LD	A,(DE)
	XOR	C
	LD	DE,Z$PRRG
	EX	DE,HL
	OR	(HL)
	LD	(HL),A
	EX	DE,HL
BRP30
	POP	AF
	AND	3FH
	JR	Z,BRP10
	LD	C,A
	PUSH	HL
	LD	HL,(Z$PC)
	LD	A,H
	XOR	D
	LD	D,A
	LD	A,C
	SUB	20H
	JR	Z,BRP50
	LD	A,L
	XOR	E
BRP50
	POP	HL
	OR	D
	JR	NZ,BRP10
	LD	B,C
	JR	BRP10
BRP90
	LD	A,0FH		;MASK OFF WAT,SUB,JTB
	AND	B			;COMPARE WITH ENTERED
	LD	A,B			;RETURN MARK
	RET	Z			;IF WAT,SUB OR JTB MARK
;	CP	0FH			;IS IT STOP MARK
;	JR	Z,STPMRK		;EXEQUTE IT
	LD	HL,Z$TRCF		;ELSE PLACE MARK IN BUF
	LD	(HL),A
	RET
 
STPMRK
;	LD	HL,XSTOP		;PRINT STOP
;	CALL	OUTSTR
;	LD	HL,(Z$PC)		;AND PRINT WHERE
;	CALL	PRINST
;	JP	EXIT
 
;XSTOP
;	DEFB	0DH
;	text	'STOP '
;	DEFB	0FFH
 
;=======
; Handle subroutine run
;=======
 
SUBRUN
	LD	DE,(Z$DE)		;CHECK IF SYSTEM BREAKPOINT
	LD	HL,Z$SBTB		;HL:=^SIGNAL BREAK TABLE
	CALL	FDTBL
	LD	HL,SYSERR
	JR	NC,SUBR90		;CAN'T STEP SYSTEM BREAK
	LD	HL,Z$WBTB		;HL:=^WAIT BREAK TABLE
	CALL	FDTBL
	LD	HL,SYSERR
	JR	NC,SUBR90		;CAN'T STEP SYSTEM BREAK
	LD	DE,(Z$PC)		;CHECK IF WAIT
	LD	HL,Z_EWAI
	AND	A
	SBC	HL,DE
	JR	Z,SUBR10		;IT IS EWAI
	LD	HL,Z_WAIT
	AND	A
	SBC	HL,DE
	JR	NZ,SUBR20		;NOT WAIT
SUBR10
	LD	HL,(Z$DE)		;CHECK IF ANY MESSAGE
	LD	A,(HL)
	INC	HL
	OR	(HL)
	LD	HL,WAIERR
	JR	Z,SUBR90		;NO MESSAGE
SUBR20
	LD	HL,NXTINS
	PUSH	HL
	LD	HL,XSUBR
;	LD	A,(Z$TRCF)	;SECRET TRACE ?
;	AND	6
;	CALL	NZ,OUTSTR
	CALL	OUTSTR
	LD	L,(IX+PCBPTY)	;RUN WITH USER PRIORITY
	PUSH	DE
	LD	DE,(Z_RUNP)	;DE:=^DEBUGGER PCB
	CALL	Z_SPTY
	POP	DE
	LD	HL,(Z$PC)
	LD	(Z$ADDR),HL
	CALL	I_RET
	CALL	RESTOR
	PUSH	HL
	LD	HL,SUBR50		;RETURN TO SUBR50
	EX	(SP),HL
	PUSH	HL
	LD	HL,(Z$ADDR)
	EX	(SP),HL
	RET
SUBR50
	CALL	SAVALL
	OR	1
	LD	HL,(Z$PTY)	;RESTORE DEBUGGER PRIORITY
	LD	DE,(Z_RUNP)
	JP	Z_SPTY
SUBR90
	PUSH	HL
	CALL	I_RET		;RESTORE PC & SP
	LD	HL,(Z$IPC)
	LD	(Z$PC),HL
	LD	IX,(Z$TPCB)	;FIX USER REGISTERS
	CALL	FR4680
	RET
 
XSUBR
	text	'Subroutine run'
	DEFB	0FFH
 
;=======
; INSTRUCTION MASK TABLE
;=======
 
MASKTB
	DEFB	06		;LD	B,n
	DEFB	0C7H
	DEFW	I_2BYT
 
	DEFB	01		;LD	BC,nn
	DEFB	0CFH
	DEFW	I_3BYT
 
	DEFB	22H		;LD	(nn),HL
	DEFB	0E7H
	DEFW	I_3BYT
 
	DEFB	0C6H		;ADD	A,n
	DEFB	0C7H
	DEFW	I_2BYT
 
	DEFB	0C3H		;JP	nn
	DEFB	0FFH
	DEFW	I_JP
 
	DEFB	0C2H		;JP	NZ,nn
	DEFB	0C7H
	DEFW	I_JPCC
 
	DEFB	0E9H		;JP	(HL)
	DEFB	0FFH
	DEFW	I_JPHL
 
	DEFB	0CDH		;CALL	nn
	DEFB	0FFH
	DEFW	I_CALL
 
	DEFB	0C4H		;CALL	NZ,nn
	DEFB	0C7H
	DEFW	I_CC
 
	DEFB	0C9H		;RET
	DEFB	0FFH
	DEFW	I_RET
 
	DEFB	0C0H		;RET	NZ
	DEFB	0C7H
	DEFW	I_RETC
 
	DEFB	0D3H		;OUT	(n),A
	DEFB	0FFH
	DEFW	I_2BYT
 
	DEFB	0DBH		;IN	A,(n)
	DEFB	0FFH
	DEFW	I_2BYT
 
	DEFB	0C7H		;RST	0
	DEFB	0C7H
	DEFW	I_RST
 
	DEFB	76H		;HALT
	DEFB	0FFH
	DEFW	I_HALT
 
	DEFB	0DDH		;???
	DEFB	0DFH
	DEFW	I_IXIY
 
	DEFB	0EDH		;ED	*.*	3254
	DEFB	0FFH
	DEFW	I_Z80
 
	DEFB	0CBH		;SET	7,A
	DEFB	0FFH
	DEFW	I_2BYT
 
	DEFB	08H		;EX	AF,AF'
	DEFB	0FFH
	DEFW	I_1BYT
 
	DEFB	0D9H		;EXX
	DEFB	0FFH
	DEFW	I_1BYT
 
	DEFB	20H		;JR	NZ,nn
	DEFB	0E7H
	DEFW	I_JRCC
 
	DEFB	18H		;JR	n
	DEFB	0FFH
	DEFW	I_JR
 
	DEFB	10H		;DJNZ	n
	DEFB	0FFH
	DEFW	I_DJNZ
 
	DEFB	0		;NOP
	DEFB	0
	DEFW	I_1BYT
 
IX_TAB
	DEFB	76H
	DEFB	0FFH
	DEFW	I_BAD
 
	DEFB	46H		;LD	B,(HL)
	DEFB	0C7H
	DEFW	I_2BYT
 
	DEFB	70H		;LD	(HL),B
	DEFB	0F8H
	DEFW	I_2BYT
 
	DEFB	86H		;ADD	A,(HL)
	DEFB	0C7H
	DEFW	I_2BYT
 
	DEFB	0CBH		;SET	7,A
	DEFB	0FFH
	DEFW	I_3BYT
 
	DEFB	09		;ADD	HL,BC
	DEFB	0CFH
	DEFW	I_1BYT
 
	DEFB	23H		;INC	HL
	DEFB	0F7H
	DEFW	I_1BYT
 
	DEFB	0E1H		;POP	HL
	DEFB	0D9H
	DEFW	I_1BYT
 
	DEFB	0E3H		;EX	(SP),HL
	DEFB	0FFH
	DEFW	I_1BYT
 
	DEFB	0F9H		;LD	SP,HL
	DEFB	0FFH
	DEFW	I_1BYT
 
	DEFB	21H		;LD	HL,nn
	DEFB	0FFH
	DEFW	I_3BYT
 
	DEFB	22H		;LD	(nn),HL
	DEFB	0F7H
	DEFW	I_3BYT
 
	DEFB	36H		;LD	(HL),n
	DEFB	0FFH
	DEFW	I_3BYT
 
	DEFB	34H		;INC	(HL)
	DEFB	0F4H
	DEFW	I_2BYT
 
	DEFB	0E9H		;JP	(HL)
	DEFB	0FFH
	DEFW	I_JPXY
 
	DEFB	0FFH
 
ED_TAB
	DEFB	70H
	DEFB	0FEH
	DEFW	I_BAD
 
	DEFB	40H		;LD	B,B
	DEFB	0C6H
	DEFW	I_1BYT
 
	DEFB	42H		;LD	B,D
	DEFB	0C7H
	DEFW	I_1BYT
 
	DEFB	43H		;LD	B,E
	DEFB	0C7H
	DEFW	I_3BYT
 
	DEFB	0A0H		;AND	B
	DEFB	0E4H
	DEFW	I_1BYT
 
	DEFB	4EH		;LD	C,(HL)
	DEFB	0FFH
	DEFW	I_BAD
 
	DEFB	46H		;LD	B,(HL)
	DEFB	0E6H
	DEFW	I_1BYT
 
	DEFB	44H		;LD	B,H
	DEFB	0FFH
	DEFW	I_1BYT
 
	DEFB	67H		;LD	H,A
	DEFB	0F7H
	DEFW	I_1BYT
 
	DEFB	45H
	DEFB	0F7H
	DEFW	A_1511
 
	DEFB	0FFH
 
;=======
; EXQINS - EXECUTE INSTRUCTION
;
; RETURNS: FZ if JP or CALL executed (in effect)
;=======
 
EXQINS
	LD	HL,0
	LD	(Z$ERAM+1),HL
	LD	HL,0C300H
	LD	(Z$ERAM+3),HL
	LD	HL,BACK
	LD	(Z$ERAM+5),HL
	LD	DE,MASKTB
	LD	HL,(Z$PC)
	LD	(Z$IPC),HL
	EX	DE,HL
	LD	BC,Z$ERAM
EXQI10
	LD	A,(HL)
	INC	A
	JP	Z,I_BAD
 
	LD	A,(DE)
	XOR	(HL)
	INC	HL
	AND	(HL)
	INC	HL
	INC	HL
	INC	HL
	JR	NZ,EXQI10
	DEC	HL
	LD	A,(HL)
	DEC	HL
	LD	L,(HL)
	LD	H,A
A_1413
	JP	(HL)
 
;-------
; Interpret Executable Instructions
;-------
 
I_3BYT
	LD	A,(DE)
	LD	(BC),A
	INC	DE
	INC	BC
I_2BYT
	LD	A,(DE)
	LD	(BC),A
	INC	DE
	INC	BC
I_1BYT
	LD	A,(DE)
	LD	(BC),A
	INC	DE
	LD	(Z$PC),DE
	CALL	RESTOR
	JP	Z$ERAM		;TO USER INSTRUCTION
BACK
	CALL	SAVALL		;BACK FROM USER INSTR.
	XOR	A
	RET
 
;-------
; Interpret RET and RET cc
;-------
 
I_RETC
	CALL	FLGFIX
	JR	NC,I_JP05
I_RET
	LD	HL,(Z$SP)
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	(Z$SP),HL
	JR	I_JP10
 
;-------
; Interpret JP-instructions
;-------
 
I_JPCC	CALL	FLGFIX
       	JR	C,I_JP08
I_JP03	INC	DE
I_JP04	INC	DE
I_JP05	EX	DE,HL
      	LD	(Z$PC),HL
      	XOR	A
      	RET
 
I_JP  	INC	DE
I_JP08	EX	DE,HL
      	LD	E,(HL)
      	INC	HL
      	LD	D,(HL)
I_JP10	EX	DE,HL
I_JP20	LD	(Z$PC),HL
      	OR	1
      	RET
 
;-------
; Interpret CALL-instructions
;-------
 
I_CC	CALL	FLGFIX
A_145E	JP	NC,I_JP03
A_1461	DEC	DE
I_CALL	INC	DE
A_1463	EX	DE,HL
A_1464	LD	C,(HL)
A_1465	INC	HL
A_1466	LD	B,(HL)
A_1467	EX	DE,HL
CALL50	INC	DE
A_1469	LD	HL,(Z$SP)
A_146C	DEC	HL
A_146D	LD	(HL),D
A_146E	DEC	HL
A_146F	LD	(HL),E
A_1470	LD	(Z$SP),HL
A_1473	LD	H,B
A_1474	LD	L,C
A_1475	JP	I_JP20
 
;-------
; Interpret JP (HL)
;-------
 
I_JPHL
	LD	HL,(Z$HL)
	JP	I_JP20
 
;-------
; Interpret RST-instructions
;-------
 
I_RST
	LD	A,(DE)
	CP	0D7H			;RST 10H ?
	JR	NZ,RST50		;NO, NOT A BREAKPOINT
	CALL	BRKPT?		;DEBUGGER BREAK ?
	JP	NC,SYSERR		;YES, NO MORE STEPPING
	INC	DE
	LD	HL,XASMBP
	CALL	OUTSTR
	JR	I_JP05		;NO
RST50
	AND	38H
	LD	C,A
	LD	B,0
	JR	CALL50
 
XASMBP
	text	'Assembled breakpoint'
	DEFB	0FFH
 
;-------
; Interpret HALT
;-------
 
I_HALT
	INC	DE
	LD	(Z$PC),DE
	LD	HL,XHALT
	JP	OUTSTR
 
XHALT
	text	'Halt'
	DEFB	0FFH
 
;-------
; Bad instruction
;-------
 
I_BAD
	LD	HL,XBAD
	JP	OUTSTR
 
XBAD
	DEFB	0DH
	text	'Non-existing opcode'
	DEFB	0FFH

;-------
; Interpret "ED"-instruction
;-------
 
I_Z80
	LD	HL,ED_TAB
	JR	A_14EC
 
;-------
; Interpret IX- and IY-instructions
;-------
 
I_IXIY	LD	HL,IX_TAB
A_14EC	LD	A,(DE)
A_14ED	LD	(BC),A
A_14EE	INC	DE
A_14EF	INC	BC
A_14F0	JP	EXQI10
 
I_JPXY	DEC	DE
A_1503	LD	A,(DE)
A_1504	CP	0DDH
A_1506	LD	HL,(Z$IX)
A_1509	JR	Z,A_150E
A_150B	LD	HL,(Z$IY)
A_150E	JP	I_JP20
 
A_1511	EX	DE,HL
A_1512	DEC	HL
A_1513	CALL	A_1413
A_1516	JP	I_RET
 
;-------
; Interpret JR
;-------
 
I_JRCC
	LD	A,(DE)
	AND	18H
	CALL	FLGF10
	JP	NC,I_JP04
	DEC	DE
I_JR
	INC	DE
	EX	DE,HL
	LD	E,(HL)
	LD	A,E
	ADD	A,A
	LD	D,0
	JR	NC,I_JR10
	DEC	D
I_JR10
	ADD	HL,DE
	INC	HL
	JP	I_JP20
 
;-------
; Interpret DJNZ
;-------
 
I_DJNZ
	LD	A,(Z$B)
	DEC	A
	LD	(Z$B),A
	JR	NZ,I_JR
	JP	I_JP03
 
;=======
; FLGFIX - FLAG-FIX FOR CONDITIONAL INSTRUCTIONS
;=======
 
FLGFIX
	LD	A,(DE)
FLGF10
	AND	38H
	OR	0C2H
	INC	DE
	LD	(Z$FFIX),A
	LD	HL,(Z$AF)
	PUSH	HL
	POP	AF
	JP	Z$FFIX
 
RCFRUT	AND	A
	RET
 
SCFRUT	SCF
	RET
 
;=======
; SAVALL - SAVE USER REGISTERS
;=======
 
SAVALL
	PUSH	HL
	LD	HL,Z$UREG
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	POP	BC
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	PUSH	AF
	POP	BC
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	PUSH	IX
	POP	BC
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	PUSH	IY
	POP	BC
	LD	(HL),C
	INC	HL
	LD	(HL),B
	POP	DE			;MOVE RET.ADR TO DEBUGGER STACK
	LD	HL,0
	ADD	HL,SP
	LD	(Z$SP),HL
	LD	HL,(Z$DBSP)
	LD	SP,HL
	PUSH	DE
	RET
 
;=======
; RESTOR - RESTORE USER REGISTERS
;=======
 
RESTOR
	POP	DE			;MOVE RET.ADR TO USER STACK
	LD	HL,0		;SAVE DBG-STK
	ADD	HL,SP
	LD	(Z$DBSP),HL
	LD	HL,(Z$SP)
	LD	SP,HL
	PUSH	DE
	LD	HL,Z$UREG
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	HL,(Z$IX)
	PUSH	HL
	POP	IX
	LD	HL,(Z$IY)
	PUSH	HL
	POP	IY
	LD	HL,(Z$AF)
	PUSH	HL
	POP	AF
	LD	HL,(Z$HL)
	RET
 
	EXTERNAL	Z$OBUF
 
PRINST
	EX	DE,HL		;DE:=^INSTRUCTION
	LD	HL,Z$OBUF
	LD	(HL),0DH
	INC	HL
	CALL	PUT16_
	CALL	PUTINS
	JP	OTOBUF
	title	'RTZ.DBG.XEQ'
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; H_XEQ - EXECUTE A RTZ-CALL
;=======
 
	external	Z$P1,Z_EWAI,Z_CPRO,Z_SGNL,Z_WAIT
	external	Z$DMSG
 
H_XEQ
	CALL	PEEL			;PEEL OFF BLANKS
	JP	C,PRMERR
	LD	DE,PROCTB
	LD	(HL),'Z'		;accept all x_....
	CALL	G_CCMD		;GET RTZ-ADDRESS IF ANY
	JP	Z,SYMERR		;NO RTZ-PROCEDURE
	PUSH	DE			;SAVE ^RTZ-PROCEDURE
	CALL	GET2PC
	OR	A
	JP	Z,PRMERR
	DEC	A
	JR	NZ,XEQ10		;two parameters present
	LD	DE,Z$DMSG
XEQ10
	LD	HL,(Z$P1)
	EX	DE,HL
	RET				;TO RTZ-PROCEDURE
 
PROCTB
	DEFT	'Z_CPRO'
	DEFW	Z_CPRO
	DEFT	'Z_SGNL'
	DEFW	Z_SGNL
	DEFT	'Z_WAIT'
	DEFW	Z_WAIT
	DEFT	'Z_EWAI'
	DEFW	Z_EWAI
	DEFB	0
	title	'PORT-RELATED COMMANDS'
;UPDATED: 810901 / PH
;FILE:    RTZ.DBG.PORT.S
 
;=======
; H_INP - READ PORT
;=======
 
	EXTERNAL	Z$OBUF
 
H_INP
	CALL	GET1P		;GET PORT #
	LD	C,E			;C:=PORT #
	LD	HL,Z$OBUF
	LD	DE,XPORT
	CALL	PUTSTR
	LD	A,C			;WRITE PORT #
	CALL	PUT8
	LD	(HL),':'
	INC	HL
	INC	HL
	IN	A,(C)
	CALL	PUT8
	CALL	PUTEOS
	JP	OTOBUF
 
XPORT
	text	'Port '
	DEFB	0FFH
 
;=======
; H_OUT - WRITE TO PORT
;=======
 
	EXTERNAL	Z$P1
 
H_OUT
	CALL	GET2P		;GET PARAMETERS
	LD	BC,(Z$P1)		;C:=PORT #
	OUT	(C),E
	RET
	title	'RTZ.DBG.BREAK'
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; Z_XBRK - ENTRY FOR EXECUTION BREAK-POINT
;=======
 
	GLOBAL	Z_XBRK
	EXTERNAL	Z_EWAI,Z_SGNL,Z$SREG,Z_RUNP
	EXTERNAL	Z$XQUE,Z_DBSM,Z_BPOL,Z$FRXQ,Z$STAT
 
SEMBRK
	EX	(SP),HL		;UPDATED HL TO STACK
	POP	HL
Z_XBRK
	PUSH	HL			;USER PC AND HL ON STACK
	PUSH	AF
	CALL	WAIT			;GET A BREAK-POINT MESSAGE
	LD	A,0FFH		;IN RTZ
	LD	(Z$STAT),A
	PUSH	BC
	PUSH	DE
	PUSH	IX
	PUSH	IY
	PUSH	HL			;IX:=^MESSAGE
	POP	IX
	LD	DE,BRKHDL		;ADDRESS TO HANDLER FOR --
	LD	(IX-2),E		;  BREAKPOINTS TO MESSAGE
	LD	(IX-1),D
	LD	DE,(Z_RUNP)	;^PCB TO MESSAGE
	LD	(IX+8),E
	LD	(IX+8+1),D
	EX	DE,HL		;DE:=^MESSAGE
	LD	HL,0			;SAVE USER SP
	ADD	HL,SP
	LD	IX,(Z$XQUE)
	LD	(IX+PCBSP),L
	LD	(IX+PCBSP+1),H
	CALL	Z$FRXQ		;AWAY FROM  EXECUTION QUEUE
	EX	DE,HL		;HL:=^MESSAGE
	LD	DE,Z_DBSM		;WAKE UP DEBUGGER
	JP	Z_SGNL+3
WAIT
	CALL	Z$SREG		;SAVE REGISTERS
	LD	DE,Z_BPOL
	JP	Z_EWAI+12
 
;=======
; BRKHDL - HANDLER FOR BREAKPOINT OCCURENCE
;=======
 
	EXTERNAL	Z$DFLG,Z$BPCB
 
BRKHDL
	LD	C,(IX+8)		;BC:=^PCB
	LD	B,(IX+8+1)
	CALL	RESPIX
	LD	E,C			;DE:=^PCB
	LD	D,B
	LD	(Z$BPCB),DE	;LAST BREAKED PCB
	LD	HL,Z_TQUE
	CALL	G_ENQ
	PUSH	DE			;IX:=^PCB
	POP	IX
	LD	L,(IX+PCBSP)	;DE:=BREAK ADDRESS
	LD	H,(IX+PCBSP+1)
	LD	DE,STCKPC
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	DEC	DE
	CALL	BRKPT?
	JR	C,BRKH60
	LD	(HL),D		;DEC PC
	DEC	HL
	LD	(HL),E
	LD	A,(IY+3)		;RESTORE USER INSTRUCTION
	LD	(DE),A
	LD	(IY+0),0		;CLEAR MARK
BRKH60
	LD	HL,Z$DFLG		;DEBUGGER INVOKED ALREADY ?
	BIT	1,(HL)
	LD	HL,XHALLO
	CALL	Z,OUTSTR		;NO, SAY HALLO
	CALL	PPRCST		;PRINT PROCESS STATUS
	LD	HL,Z$DFLG		;DEBUGGER INVOKED ALREADY ?
	BIT	1,(HL)
	SET	1,(HL)		;  NOW IT IS
	JP	Z,CMDWAI		;NO, GO AND WAIT FOR COMMAND
	JP	WEVENT
 
;=======
; H_RUN - FREE RUN OF USER CODE
;=======
 
	EXTERNAL	Z$TPCB,Z_TQUE,Z$TOXQ,Z$SCED
 
H_RUN
	CALL	CHKTP		;DE:=^PCB TO BE RESUMED
	PUSH	DE
	POP	IX			;FIX USER PC
	CALL	GET1PC
	JR	C,RUN10
	LD	L,(IX+PCBSP)	;HL:=SP
	LD	H,(IX+PCBSP+1)
	LD	BC,STCKPC		;HL:=^PC IN STACK
	ADD	HL,BC
	LD	(HL),E
	INC	HL
	LD	(HL),D
RUN10
RUNTRC
	LD	DE,(Z$TPCB)
	LD	HL,Z_TQUE
	CALL	G_REMQ
	LD	C,E
	LD	B,D
	CALL	RESM			;RESUME THIS PROCESS
	LD	HL,(Z_TQUE)	;FIRST IN Z_TQUE NEW TPCB
	LD	A,L			;Z_TQUE EMPTY ?
	OR	H
	RET	NZ			;NO, GO ON DEBUGGING
	JP	H_QUIT		;GOOD NIGHT
 
RESM
	CALL	Z$SREG
	CALL	Z$TOXQ
	JP	Z$SCED
 
;=======
; Set new Traced Process (TPCB)
;=======
 
H_TPCB
	CALL	SWITCH
	LD	A,D			;SAVE L-SWITCH
	LD	DE,(Z$BPCB)
	BIT	BIT_L,A
	JR	NZ,TPCB10		;SET LAST BREAKED PCB TO TPCB
	CALL	GET1PC
	JR	C,TPCB50		;NO PARAMETER
TPCB10
	LD	HL,Z_TQUE
	CALL	G_REMQ		;EXIST THIS ADDRESS IN Z_TQUE
	JP	C,ADRERR		;NO
	LD	HL,(Z_TQUE)	;YES, MAKE IT FIRST ITEM
	LD	(Z_TQUE),DE
	PUSH	DE			;YES, IX:=^PCB
	POP	IX
	EX	DE,HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	JP	PPRCST
TPCB50
	CALL	CHKTP		;DISPLAY NAME OF TPCB
	PUSH	DE			;IX:=^TPCB
	POP	IX
	LD	HL,Z$OBUF
	CALL	PUTNAM
	CALL	PUTEOS
	JP	OTOBUF
 
;=======
; SET and CANCEL BREAKPOINTS
;=======
 
	EXTERNAL	Z$SBTB,Z$WBTB
 
H_BRK
	CALL	SWITCH
	BIT	BIT_S,C
	JR	NZ,BRKSIG
	BIT	BIT_W,C
	JR	NZ,BRKWAI
 
	CALL	GET1P
	CALL	BRKPT?		;already a breakpoint ?
	RET	NC			;yes, do nothing
	LD	B,0BH
	CALL	RBRKAD
	LD	A,0D7H		;INSERT BREAKPOINT
	LD	(DE),A
	RET
 
BRKSIG
	CALL	GET1P
	LD	HL,Z$SBTB		;HL:=^TABLE OF SIGNAL-BREAKS
	PUSH	HL
	JR	BRKW10
BRKWAI
	CALL	GET1P
	LD	HL,Z$WBTB		;HL:=^TABLE OF WAIT-BREAKS
	PUSH	HL
BRKW10
	CALL	CHKSEM
	POP	HL
	JP	C,ADRERR
	LD	A,10			;ALLOW TEN BREAKPOINTS
	CALL	CAPTBL
	JP	C,OVFERR		;TABLE OVERFLOW
	RET
 
H_CAN
	CALL	SWITCH
	BIT	BIT_S,C
	JR	NZ,CANSIG
	BIT	BIT_W,C
	JR	NZ,CANWAI
 
	CALL	GET1P
	LD	B,0
	JP	RBRKAD
 
CANSIG
	CALL	GET1P
	LD	HL,Z$SBTB		;HL:=^TABLE OF SIGNAL-BREAKS
	JR	CANW10
CANWAI
	CALL	GET1P
	LD	HL,Z$WBTB		;HL:=^TABLE OF WAIT-BREAKS
CANW10
	CALL	RMTBL
	JP	C,ADRERR		;NOT IN TABLE
	RET
 
;=======
; BRKPT? - IS THIS A DEBUGGER ORIGINATED BREAK ?
;
; Accepts: DE = BREAK ADDRESS
;
; Returns: TC if not found
;          IY = ^TRACE BLOCK if found
;
; Affects: IY,A,F,C
;=======
 
	EXTERNAL	Z$TRCT
 
BRKPT?
	LD	IY,Z$TRCT-4	;SCAN Z$TRCT
BRP?10
	INC	IY
	INC	IY
	INC	IY
	INC	IY
	LD	C,(IY+0)		;C:=MARK
	LD	A,C
	INC	C			;END OF TABLE ?
	SCF
	RET	Z			;YES, NOT FOUND
	OR	A			;ANY MARK ?
	JR	Z,BRP?10		;NO, EXAMINE NEXT ITEM
	PUSH	DE			;SAVE ARGUMENT
	LD	A,E			;COMPARE THIS ITEM WITH DE
	XOR	(IY+1)
	LD	E,A
	LD	A,D
	XOR	(IY+2)
	OR	E
	POP	DE
	RET	Z
	JR	BRP?10
 
;=======
; LIST BREAKPOINTS
;=======
 
	EXTERNAL	Z$OBUF,Z$SBTB,Z$WBTB,Z$TRCT
 
H_LIST
	LD	HL,Z$OBUF
	LD	DE,XIBPS
	CALL	PUTSTR
	CALL	SCNIBP
	LD	HL,Z$OBUF
	LD	DE,XSBPS
	CALL	PUTSTR
	LD	BC,Z$SBTB
	CALL	SCNZBP
	LD	HL,Z$OBUF
	LD	DE,XWBPS
	CALL	PUTSTR
	LD	BC,Z$WBTB
 
SCNZBP
	LD	A,(BC)		;TABLE EMPTY ?
	OR	A
	JR	Z,SCNZ90		;YES
	PUSH	HL			;SAVE ^Z$OBUF.CUR
	LD	L,C			;HL:=^TABLE OF BREAKPOINTS
	LD	H,B
	LD	B,A			;B:=# OF BREAKPOINTS
SCNZ10
	INC	HL			;DE:=CURRENT BREAKPOINT
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	(SP),HL		;HL:=^Z$OBUF.CUR
	CALL	PUT16_
	EX	(SP),HL		;HL:=^TABLE.CUR
	DJNZ	SCNZ10
SCNZ50
	POP	HL			;HL:=^Z$OBUF.CUR
SCNZ90
	CALL	PUTEOS
	JP	OTOBUF
 
SCNIBP
	PUSH	HL			;SAVE ^Z$OBUF.CUR
	LD	HL,Z$TRCT+5*4
SCNI10
	LD	A,(HL)		;END OF TABLE ?
	INC	A
	JR	Z,SCNZ50		;YES
	INC	HL			;DE:=CURRENT BREAKPOINT
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	INC	HL
	EX	(SP),HL		;HL:=^Z$OBUF.CUR
	DEC	A
	CALL	NZ,PUT16_
	EX	(SP),HL		;HL:=^TABLE.CUR
	JR	SCNI10
 
XIBPS
	text	'Instruction:'
	DEFW	0FF0DH
XSBPS
	text	'Signal:'
	DEFW	0FF0DH
XWBPS
	text	'Wait:'
	DEFW	0FF0DH
 
;=======
; HANDLE SEMAPHORE BREAKPOINTS
; Extension of RTZ.KERNEL
;=======
 
	EXTERNAL	Z$BRET
 
SIGBR?
	LD	BC,Z$SBTB		;BC:=^TABLE OF SIGNAL-BREAKS
	JR	WAIBR1
WAIBR?
	LD	BC,Z$WBTB		;BC:=^TABLE OF WAIT-BREAKS
WAIBR1
	PUSH	BC			;HL:=^TABLE
	EX	(SP),HL
	POP	IY			;SAVE HL IN IY
	CALL	FDTBL
	PUSH	IY			;RESTORE HL
	POP	HL
	RET	C			;NO BREAK AT THIS SEMAPHORE
	POP	HL			;SAVE RETURN FROM THIS ROUTINE
	LD	(Z$BRET),HL
	POP	IY			;FIX PROCESS-STACK
	POP	IX
	POP	DE
	POP	BC
	POP	AF
	POP	HL
	PUSH	HL
	PUSH	HL
	LD	HL,SEMBRK
	EX	(SP),HL
	PUSH	HL
	PUSH	AF
	PUSH	BC
	PUSH	DE
	PUSH	IX
	PUSH	IY
	LD	IX,(Z$XQUE)
	LD	C,(IX+PCBSP)
	LD	B,(IX+PCBSP+1)
	DEC	BC
	DEC	BC
	DEC	BC
	DEC	BC
	LD	(IX+PCBSP),C
	LD	(IX+PCBSP+1),B
	LD	IY,(Z$BRET)
	JP	(IY)
 
;=======
; CTRCHD - HANDLER FOR ^C
;=======
 
CTRCHD
	CALL	RESPIX		;RETURN MESSAGE
	LD	HL,Z$DFLG
	BIT	1,(HL)		;DEBUGGER INVOKED ALREADY ?
	JP	NZ,WEVENT		;YES, NO ACTION
	SET	1,(HL)
	LD	HL,XHALLO		;NO, SAY HALLO AND PROMPT --
	CALL	OUTSTR		;  FOR COMMAND
	JP	CMDWAI
 
;=======
; Z_CTRC - Process for delivery of ^C-message
;=======
 
	EXTERNAL	Z_DWAS,Z$TTYS
 
Z_CTRC
	LD	DE,(Z_DWAS)	;DE:=DEBUGGER WAKE SEMAPHORE
	CALL	Z_EWAI
	LD	A,' '
	LD	(Z$ICMD),A	;STOP AUTO-STEP
	LD	(Z$TTYS),A	;BREAK LONG DISPLAY
	LD	DE,Z_BPOL
	CALL	Z_EWAI
	LD	BC,CTRCHD
	LD	E,L
	LD	D,H
	DEC	HL
	LD	(HL),B
	DEC	HL
	LD	(HL),C
	EX	DE,HL
	LD	DE,Z_DBSM
	CALL	Z_SGNL
	JR	Z_CTRC
	title	'RTZ.DBG.SHOW'
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; H_QUEU - DISPLAY RTZ-QUEUES
;=======
 
	EXTERNAL	Z$OBUF,Z$XQUE
 
H_QUEU
	CALL	SWITCH		;GET COMMAND SWITCHES
	BIT	BIT_D,E
	JP	NZ,QDELAY
	BIT	BIT_M,D
	JP	NZ,QSEMMG
	BIT	BIT_P,D
	JP	NZ,QSEMP
	BIT	BIT_X,C
	JP	NZ,QEXEC
 
;-------
; DISPLAY TRACE QUEUE
;-------
 
	EXTERNAL	Z_TQUE
 
QTPCB
	LD	HL,XTHEAD
	CALL	OUTSTR
	LD	IX,(Z_TQUE)
	LD	DE,XTNAME
	JR	QUEU30
 
XTHEAD	text	'Trace queue:'
      	DEFW	0FF0DH
XTNAME	text	'Z_TQUE:  '
      	DEFB	0FFH
 
;-------
; DISPLAY EXECUTION QUEUE
;-------
 
QEXEC
	LD	HL,XXHEAD		;PRINT HEAD
	CALL	OUTSTR
	LD	IX,(Z$XQUE)	;IX:=^FIRST PCB IN XQUE
	LD	DE,XXNAME		;PRINT QUEUE-NAME ON FIRST LINE
QUEU30
	LD	HL,Z$OBUF
	CALL	PUTSTR		;PRINT LINE-PREDECESSOR
QUEU49
	LD	B,5			;FIVE NAMES/LINE
QUEU50
	PUSH	IX
	POP	DE
	LD	A,E			;END OF QUEUE ?
	OR	D
	JR	Z,QUEU90		;YES
	CALL	PUTNAM		;MOVE NAME TO OUTBUF
	LD	DE,XARROW		;MOVE ARROW TO OUTBUF
	CALL	PUTSTR
	LD	E,(IX+PCBLNK)	;IX:=DE:=^NEXT PCB
	LD	D,(IX+PCBLNK+1)
	PUSH	DE
	POP	IX
	DJNZ	QUEU50		;NO
	CALL	PUTEOS
	CALL	OTOBUF
	LD	DE,XBLANK
	JR	QUEU30		;NEW LINE
QUEU90
	LD	(HL),'0'		;END OF QUEUE MARK
	INC	HL
	CALL	PUTEOS		;TERMINATE STRING --
	JP	OTOBUF		;  AND WRITE IT.
 
XXHEAD 	text	'Execution queue:'
      	DEFW	0FF0DH
XXNAME	text	'Z$XQUE:  '
      	DEFB	0FFH
XBLANK	text	'         '
      	DEFB	0FFH
XARROW	text	'- '
       	DEFB	0FFH
 
;-------
; DISPLAY DELAY QUEUE
;-------
 
	EXTERNAL	Z$DQUE
 
QDELAY
	LD	HL,XDHEAD		;PRINT HEAD
	CALL	OUTSTR
	LD	IX,(Z$DQUE)	;IX:=^FIRST PCB IN DQUE
	LD	DE,XDNAME		;PRINT QUEUE-NAME ON FIRST LINE
QDEL30
	LD	HL,Z$OBUF
	CALL	PUTSTR		;PRINT LINE-PREDECESSOR
	LD	B,5			;FIVE NAMES/LINE
QDEL50
	PUSH	IX
	POP	DE
	LD	A,E			;END OF QUEUE ?
	OR	D
	JR	Z,QUEU90		;YES
	CALL	PUTNAM		;MOVE NAME TO OUTBUF
	LD	DE,XARROW		;MOVE ARROW TO OUTBUF
	CALL	PUTSTR
	LD	E,(IX+PCBDLK)	;IX:=DE:=^NEXT PCB
	LD	D,(IX+PCBDLK+1)
	PUSH	DE
	POP	IX
	DJNZ	QDEL50		;NO
	CALL	PUTEOS
	CALL	OTOBUF
	LD	DE,XBLANK
	JR	QDEL30		;NEW LINE
 
XDHEAD 	text	'Delay queue:'
      	DEFW	0FF0DH
XDNAME	text	'Z$DQUE:  '
      	DEFB	0FFH
 
;-------
; DISPLAY PROCESS QUEUE AT SEMAPHORE
;-------
 
QSEMP
	CALL	GET1P
	CALL	CHKSEM
	JP	C,ADRERR
	LD	HL,XPHEAD
	CALL	OUTSTR
	LD	HL,Z$OBUF
	INC	DE			;DE:=^PQUE
	INC	DE
	CALL	PUT16
	LD	(HL),':'
	INC	HL
	INC	HL
	EX	DE,HL		;HL:=^PQUE, DE:=OBUF.CUR
	LD	C,(HL)		;IX:=^PQUE.1ST
	INC	HL
	LD	B,(HL)
	PUSH	BC
	POP	IX
	EX	DE,HL
	JP	QUEU49
 
XPHEAD	text	'Semaphore Process queue:'
      	DEFW	0FF0DH
 
;-------
; DISPLAY MESSAGE QUEUE AT SEMAPHORE
;-------
 
QSEMMG
	CALL	GET1P
	CALL	CHKSEM
	JP	C,ADRERR
	LD	HL,XMHEAD
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_		;DE = ^MESSAGE QUEUE
	LD	(HL),':'
	INC	HL
	INC	HL
QSEM49
	LD	B,10
QSEM50
	EX	DE,HL		;NEXT ITEM IN QUEUE
	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A
	EX	DE,HL
	LD	A,E			;END OF QUEUE ?
	OR	D
	JP	Z,QUEU90
	CALL	PUT16_
	PUSH	DE
	LD	DE,XARROW
	CALL	PUTSTR
	POP	DE
	DJNZ	QSEM50
	CALL	PUTEOS
	CALL	OTOBUF
	LD	HL,Z$OBUF
	PUSH	DE
	LD	DE,XBLANK
	CALL	PUTSTR
	POP	DE
	JR	QSEM49
 
XMHEAD	text	'Semaphore Message queue:'
      	DEFW	0FF0DH
 
;=======
; H_SHOW - DISPLAY RTZ-STRUCTURES
;=======
 
H_SHOW
	CALL	SWITCH		;GET COMMAND SWITCHES
	BIT	BIT_S,C
	JP	NZ,SHWSEM
	BIT	BIT_M,D
	JP	NZ,SHWMSG
 
;-------
; SHWPCB - DISPLAY Process Control Block
;-------
 
SHWPCB
	CALL	GET1PC
	CALL	C,CHKTP		;CHECK IF TP IF NO PARAMETER
	CALL	CHKPCB
	JP	C,ADRERR		;INVALID ADDRESS
	LD	HL,XPCBHD		;PRINT HEADER
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_		;PRINT PCB ADDRESS
	PUSH	DE			;IX:=^PCB
	POP	IX
	LD	B,5
PCB10
	LD	E,(IX+0)
	LD	D,(IX+1)
	CALL	PUT16_
	INC	IX
	INC	IX
	DJNZ	PCB10
	LD	A,(IX+0)		;GET PCB.PTY
	CALL	PUT8_
	LD	A,(IX+1)		;GET PCB.STT
	CALL	PUT8_
	LD	E,(IX+2)		;GET PCB.NAME
	LD	D,(IX+3)
	EX	DE,HL
	LD	BC,6
	LDIR
	EX	DE,HL
	INC	HL
	LD	E,(IX+6)		;GET PCB.PCBLINK
	LD	D,(IX+7)
	CALL	PUT16
PCBEND
	CALL	PUTEOS
	JP	OTOBUF
 
XPCBHD	text	'     LINK DTIM DLNK SEM   SP  PR ST  NAME  PCBL'
      	DEFW	0FF0DH
 
;-------
; SHWSEM - DISPLAY SEMAPHORE
;-------
 
SHWSEM
	CALL	GET1P
	CALL	CHKSEM
	JP	C,ADRERR
	LD	HL,XSEMHD		;PRINT HEADER
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_		;PRINT SEMAPHORE ADDRESS
	PUSH	DE
	POP	IX
	LD	B,3
SEM10
	LD	E,(IX+0)
	LD	D,(IX+1)
	CALL	PUT16_
	INC	IX
	INC	IX
	DJNZ	SEM10
	JP	PCBEND
 
XSEMHD	text	'     MQUE PQUE SEML'
      	DEFW	0FF0DH
 
;-------
; SHWMSG - DISPLAY MESSAGE
;-------
 
SHWMSG
	CALL	GET1P
	LD	HL,XMSGHD
	CALL	OUTSTR
	LD	HL,Z$OBUF
	CALL	PUT16_
	PUSH	DE			;IX:=^MESSAGE
	POP	IX
	LD	E,(IX+MSGLNK)	;LNK
	LD	D,(IX+MSGLNK+1)
	CALL	PUT16_
	LD	A,(IX+MSGRQC)	;RQC
	CALL	PUT8_
	LD	A,(IX+MSGRC)	;RC
	CALL	PUT8_
	PUSH	HL
	LD	E,(IX+MSGLEN)	;DE:=LENGTH
	LD	D,(IX+MSGLEN+1)
	LD	HL,5			;DISPLAY MIN 6 BYTES
	AND	A
	SBC	HL,DE
	JR	C,MSG03		;>5
	LD	E,6
MSG03
	LD	HL,63		;DISPLAY MAX 62 BYTES OF MSG
	AND	A
	SBC	HL,DE
	POP	HL
	PUSH	AF
	JR	NC,MSG05		;<= 62
	LD	E,62
MSG05
	LD	B,E
	DEC	B			;4 BYTES ALREADY WRITTEN
	DEC	B
	DEC	B
	DEC	B
	SRA	B			;WE ARE WRITING WORDS
	PUSH	AF			;SAVE INFO IF ODD # OF BYTES
MSG10
	LD	E,(IX+4)
	LD	D,(IX+5)
	CALL	PUT16_
	INC	IX
	INC	IX
	DJNZ	MSG10
	POP	AF
	LD	A,(IX+4)
	CALL	C,PUT8_
	POP	AF
	LD	DE,XLONGM		;WARNING FOR LONG MESSAGE
	CALL	C,PUTSTR
	JP	PCBEND
 
XMSGHD	text	'     LNK RQC RC LEN  RSM'
      	DEFW	0FF0DH
XLONGM	DEFB	0DH
      	text	'Can''t display whole message'
      	DEFB	0FFH
	title	'RTZ.DBG.BUF'
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; GETVAL - GET VALUE
;
; ACCEPTS: HL = RETURN ADDRESS IF 1ST CHARACTER IS SPACE
;
; RETURNS: DE = BINARY VALUE
;          EXITS IF UNVALID OR NO ENTRY
;=======
 
	EXTERNAL	Z$IBUF
 
GETVAL
	CALL	INCHAR		;GET 1ST CHAR SEPARATE
	EX	(SP),HL		;ASSUME ' ' OR '^'
	CP	' '
	RET	Z
	CP	'^'
	RET	Z
	CP	0DH
	JP	Z,CMDWAI		;EXIT
	EX	(SP),HL		;RESTORE NORMAL RETURN
	LD	HL,Z$IBUF-1	;SAVE 1ST CHARACTER
	LD	(HL),A
	CALL	INLIN		;GET REST OF INPUT
	CALL	GET16
	JP	NZ,DATERR		;UNVALID ENTRY
	RET
 
;=======
; GET1P - GET EXACTLY ONE PARAMETER
; GET1PC - GET ONE PARAMETER CONDITIONAL
;
; ACCEPTS: HL = ^STRING
;
; RETURNS: DE = BINARY VALUE
;          HL = ^1ST NON-DIGIT
;          Z$P1 = BINARY VALUE
;          TC IF NO PARAMETER
;          EXITS IF UNVALID STRING
;=======
 
	EXTERNAL	Z$P1
 
GET1P
	CALL	GET1PC
	JP	C,PRMERR
	RET
GET1PC
	CALL	PEEL			;PEEL OFF BLANKS
	RET	C
	CALL	GETNUM
	JP	NZ,PRMERR		;INCORRECT TERMINATOR
	LD	(Z$P1),DE
	RET
 
;=======
; GET2P - GET EXACTLY TWO PARAMETERS
; GET2PC - GET TWO PARAMETERS CONDITIONAL
;
; ACCEPTS: HL = ^STRING
;
; RETURNS: DE = 2ND PARAMETER
;          HL = ^1ST NON-DIGIT AFTER 2ND PRM
;          Z$P1 = 1ST PARAMETER
;          Z$P2 = 2ND PARAMETER
;          TC IF LESS THAN 2 PARAMETERS
;          A  = # OF FOUND PARAMETERS
;          EXITS IF UNVALID ENTRY
;=======
 
	EXTERNAL	Z$P2,Z$P1
 
GET2P
	CALL	GET2PC
	JP	C,PRMERR
	RET
GET2PC
	CALL	PEEL			;PEEL OFF BLANKS
	LD	A,0			;NO PARAMETER FOUND
	RET	C
	CALL	GETNUM
	LD	A,0			;NO PARAMETER FOUND
	RET	C
	LD	(Z$P1),DE
	LD	A,(HL)		;DELIMITER MUST BE ','
	CP	0DH			;ONE PARAMETER ?
	JR	Z,GET2PB		;YES
	CP	','
	JP	NZ,PRMERR
	INC	HL
	CALL	PEEL
	CALL	GETNUM
	JP	NZ,PRMERR		;INCORRECT TERMINATOR
	LD	A,2
	JR	NC,GET2PA		;VALUE PRESENT
GET2PB
	LD	A,1			;ONE PARAMETER FOUND
	LD	DE,1			;NO VALUE DEFAULTS TO 1
GET2PA
	LD	(Z$P2),DE
	RET
 
;=======
; GETNUM - SCAN AN ASCII-STRING CONSIDERING SPECIAL
;          CHARACTERS
;
; ACCEPTS: HL = ^STRING
;
; RETURNS: DE = BINARY VALUE
;          HL = ^FIRST NON-HEXDIGIT
;          TZ IF 1ST NON-DIGIT IS <CR>
;          TC IF NO DIGIT IS ENTERED
;
; AFFECTS: A
;=======
 
GETNUM
	LD	A,(HL)
	CP	'@'
	JR	NZ,GETN10
 
; THIS IS AN INDIRECT VALUE
 
	INC	HL
	CALL	GETNUM		;RECURS
	EX	DE,HL		;HL:=^VALUE
	LD	A,(HL)		;HL:=VALUE
	INC	HL
	LD	H,(HL)
	LD	L,A
	EX	DE,HL
	RET
 
GETN10
	CP	'$'
	JR	NZ,GET16		;normal digits
 
; Register content
 
	INC	HL			;A:=first letter
	LD	A,(HL)
	INC	HL			;HL:=^second letter
	PUSH	HL			;save ^string
	CP	'S'			;special treatment for SP
	JR	Z,GETNSP
	CP	'I'			;take second letter if index
	JR	NZ,GETN15
	LD	A,(HL)
GETN15
	LD	HL,REGTBL		;look for register
	LD	BC,REGTSZ
	CPIR
	JP	NZ,PRMERR		;not a register
	CALL	CHKTP
	PUSH	DE
	POP	IX
	LD	L,(IX+PCBSP)
	LD	H,(IX+PCBSP+1)
	ADD	HL,BC
	ADD	HL,BC
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
GETN18
	POP	HL			;HL:=^terminator ?
	INC	HL
	LD	A,(HL)
	XOR	0DH			;CY:=0
	RET
GETNSP
	CALL	CHKTP
	PUSH	DE
	POP	IX
	LD	E,(IX+PCBSP)
	LD	D,(IX+PCBSP+1)
	LD	HL,2*7		;reach user part of stack
	ADD	HL,DE
	EX	DE,HL
	JR	GETN18
 
REGTBL
	text	'PH BDXY'
REGTSZ	equ	$-REGTBL
 
;=======
; GET16 - SCAN AN ASCII-STRING FOR A 4-DIGIT HEX-VALUE
;
; ACCEPTS: HL = ^STRING
;
; RETURNS: DE = BINARY VALUE
;          HL = ^FIRST NON-HEXDIGIT
;          TZ IF 1ST NON-DIGIT IS <CR>
;          TC IF NO DIGIT IS ENTERED
;
; AFFECTS: A
;=======
 
GET16
	PUSH	BC
	EX	DE,HL
	LD	HL,0			;ZERO SO FAR
	LD	B,-1			;NO DIGITS ENTERED
GET16A
	LD	A,(DE)		;A:=NEXT CHARACTER
	CALL	CNVHEX		;HEX ?
	INC	DE			;INC BUFFER POINTER
	INC	B			;KEEP TRACK OF ENTERED DIGITS
	JR	NC,GET16A		;GO ON AS LONG AS DIGITS
	EX	DE,HL
	DEC	HL
	DEC	B
	LD	A,(HL)		;A:=NON-DIGIT
	CP	0DH			;TZ IF <CR>
	LD	A,B
	RLA				;TC IF NO DIGIT
	POP	BC
	RET
 
;=======
; CNVHEX - CONVERT HEX-DIGIT
;
; ACCEPTS: HL = BINARY VALUE
;          A  = CHARACTER TO BE CONVERTED
;
; RETURNS: HL = HL*16+bin(A) IF HEXDIGIT
;          TC IF NON-HEXDIGIT
;
; AFFECTS: A
;=======
 
CNVHEX
	SUB	'0'
	RET	C			;< '0'
	ADD	A,0E9H
	RET	C			;> 'F'
	ADD	A,6
	JP	P,CNVH50		;>= 'A'
	ADD	A,7
	RET	C			;> '9'
CNVH50
	ADD	A,10
	ADD	HL,HL		;HL:=HL*16
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	OR	L			;CLEAR CY
	LD	L,A
	RET
 
;=======
; PEEL - PEEL OFF BLANKS
;
; ACCEPTS: HL = ^STRING
;
; RETURNS: HL = ^FIRST NON-BLANK
;          TC IF NO BLANK AT ALL
;
; AFFECTS: A
;=======
 
PEEL
	LD	A,(HL)
	CP	' '
	SCF
	RET	NZ			;NO BLANK AT ALL
PEEL50
	INC	HL
	LD	A,(HL)
	CP	' '
	JR	Z,PEEL50
	AND	A			;CLEAR CY
	RET
 
;=======
; PUT16 - PUT A 16-BIT BINARY VALUE INTO AN ASCII-STRING
;
; ACCEPTS: DE = BINARY VALUE
;          HL = ^STRING
;
; RETURNS: HL = HL+4
;
; AFFECTS: A,F
;=======
 
PUT16
	LD	A,D			;START WITH HIGH-BYTE
	CALL	PUT8
	LD	A,E			;THEN TAKE LOW-BYTE
 
;=======
; PUT8 - PUT A 8-BIT BINARY VALUE INTO AN ASCII-STRING
;
; ACCEPTS: A  = BINARY VALUE
;          HL = ^STRING
;
; RETURNS: HL = HL+2
;
; AFFECTS: A,F
;=======
 
PUT8
	PUSH	AF			;START WITH UPPER NIBBLE
	RRA
	RRA
	RRA
	RRA
	CALL	PUT4
	POP	AF
 
;=======
; PUT4 - PUT A 4-BIT BINARY VALUE INTO AN ASCII-STRING
;
; ACCEPTS: A (LOW) = BINARY VALUE
;          HL      = ^STRING
;
; RETURNS: HL      = HL+1
;
; AFFECTS: A,F
;=======
 
PUT4
	AND	0FH			;CLEAR UPPER NIBBLE
	ADD	A,90H		;convert to ASCII
	DAA
	ADC	A,40H
	DAA
	LD	(HL),A
	INC	HL
	RET
 
;=======
; PUTEOS - PUT <CR>,0FFH INTO A STRING
;
; ACCEPTS: HL = ^STRING
;
; RETURNS: HL = HL+1 (i.e. HL = ^EOS-MARK)
;=======
 
PUTEOS
	LD	(HL),0DH
	INC	HL
	LD	(HL),0FFH
	RET
 
;=======
; PUTSTR - CONCATENATE STRINGS
;
; ACCEPTS: DE = ^<STRING TO BE APPENDED>,<0FFH>
;          HL = ^STRING
;
; RETURNS: DE = ^POSITION AFTER APPENDED STRING (SRC)
;          HL = ^POSITION AFTER APPENDED STRING (DST)
;
; AFFECTS: A,F
;=======
 
PUTSTR
	LD	A,(DE)		;MOVE ONE CHARACTER
	LD	(HL),A
	INC	A			;END OF STRING ?
	RET	Z			;YES, WORK IS DONE
	INC	DE
	INC	HL
	JR	PUTSTR
 
;=======
; OTOBUF - PRINT Z$OBUF
;
; AFFECTS: HL
;=======
 
	EXTERNAL	Z$OBUF
 
OTOBUF
	LD	HL,Z$OBUF
	JP	OUTSTR
 
;=======
; PUT8_ - PUT8 + ' '
; PUT16_ - PUT16 + ' '
;=======
 
PUT8_
	CALL	PUT8
	JR	PUT8_5
PUT16_
	CALL	PUT16
PUT8_5
	LD	(HL),' '
	INC	HL
	RET
 
;=======
; PUTINS - PUT INSTRUCTION (DISSASSEMBLED)
;
; Accepts: DE = ^INSTRUCTION
;          HL = ^STRING
;
; Returns: HL = ^NEXT POS IN STRING
;
; Affects: A,F
;=======
 
PUTINS
	PUSH	BC
	PUSH	DE
	PUSH	IX
	PUSH	IY
	PUSH	DE			;IX:=^INPUT LOCATION
	POP	IX
	PUSH	HL			;IY:=^STRING
	POP	IY
	CALL	DISM
	PUSH	IY			;HL:=^NEXT POS IN STRING
	POP	HL
	LD	(HL),0FFH		;END MARK
	POP	IY
	POP	IX
	POP	DE
	POP	BC
	RET
 
;=======
; PUTNAM - PUT PROCESS NAME AND PCB ADDRESS
;
; ACCEPTS: IX = ^PCB
;          HL = ^STRING
;
; RETURNS: HL = ^POSITION AFTER APPENDED STRING (DST)
;
; AFFECTS: A,F,DE
;=======
 
PUTNAM
	PUSH	BC			;SAVE BC
	LD	E,(IX+PCBNAM)	;DE:=^PROCESS NAME
	LD	D,(IX+PCBNAM+1)
	LD	BC,6			;MOVE NAME TO OUTBUF
	EX	DE,HL
	LDIR
	EX	DE,HL		;MOVE ADDRESS TO OUTBUF
	POP	BC
	LD	(HL),','
	INC	HL
	PUSH	IX
	POP	DE
	CALL	PUT16_
	LD	(HL),0FFH
	RET
	title	'RTZ.DBG.SBR'
;UPDATED: 821028 / PH
;REV:     2.01
 
;=======
; CHKTP - CHECK IF ANY TP PRESENT
;
; returns: DE = ^TPCB if present
;
; affects: A,F
;=======
 
CHKTP
	LD	DE,(Z$TPCB)
	LD	A,E
	OR	D
	JP	Z,TPERR
	RET
 
;=======
; CHKSEM - CHECK IF SEMAPHORE
; CHKPCB - CHECK IF PROCESS
; CHKQUE - CHECK IF IN QUEUE
;
; ACCEPTS: HL = ^QUEUE-HEAD (CHKQUE ONLY)
;          DE = ^SEARCHED ITEM
;
; RETURNS: TC IF NOT FOUND
;
; AFFECTS: AF,BC,HL
;=======
 
	EXTERNAL	Z$FSEM,Z$FPCB
 
CHKSEM
	LD	BC,4			;OFFSET TO STATIC SEM-LINK
	LD	HL,Z$FSEM		;SEMAPHORE QUEUE-HEAD
	JR	CHKQ10
CHKPCB
	LD	BC,16		;OFFSET TO STATIC PCB-LINK
	LD	HL,Z$FPCB		;PCB QUEUE-HEAD
	JR	CHKQ10
CHKQUE
	LD	BC,0			;NO OFFSET TO LINK
CHKQ10
	LD	A,(HL)		;HL:=^NEXT ITEM
	INC	HL
	LD	H,(HL)
	LD	L,A
	OR	H
	SCF
	RET	Z			;END OF QUEUE, NOT FOUND
	AND	A
	SBC	HL,DE		;THIS IS IT ?
	RET	Z			;YES, READY
	ADD	HL,DE		;RESTORE HL
	ADD	HL,BC		;ADJUST FOR OFFSET TO LINK
	JR	CHKQ10
 
;=======
; RESPIX - Send message back to RESPONSE-SEMAPHORE
;
; ACCEPTS: IX = ^MESSAGE
;
; RETURNS: --
;
; AFFECTS: DE,HL
;=======
 
RESPIX
	PUSH	IX			;HL:=^MESSAGE
	POP	HL
	LD	E,(IX+MSGRSM)
	LD	D,(IX+MSGRSM+1)
	JP	Z_SGNL
	title	'COMMAND DECODERS'
;UPDATED: 811111 / PH
 
;=======
; G_XCMD - SHORTHAND COMMAND DECODER
;
; ACCEPTS: DE = ^TABLE OF COMMANDS
;          HL = ^COMMAND STRING
;
; RETURNS: HL = ^DELIMITER IN GIVEN COMMAND IF MATCH
;          DE = RETURN PARAMETER IF MATCH
;               0 IF NOT FOUND
;               1 IF AMBIGOUS COMMAND
;          FZ IF OK
;
; AFFECTS: A
;
; Table organisation:
;
; LENGTH byte STRING array [* byte] PARAMETER word
; 0 = end of table
;
; example:      DEFB 5
;               text 'FIRST'
;               DEFW 0101H
;               DEFB 6
;               text 'SECOND'
;               DEFW 0202H
;               DEFB 0
;=======
 
G_XCMD
	PUSH	BC
	PUSH	IX
	PUSH	IY
	LD	IX,0			;CLEAR RETURN PARAMETER
DSH000
	LD	A,(DE)		;B:=COMMAND.LEN
	LD	B,A
	INC	DE			;DE:=^COMMAND.STRING
	OR	A			;END OF TABLE ?
	JR	Z,DSH900		;YES
	PUSH	HL			;SAVE ^STRING
DSH050
	LD	A,(DE)		;MATCH ?
	CP	(HL)
	JR	NZ,DSH200		;NO
	INC	DE			;YES, NEXT CHARACTER
	INC	HL
	LD	A,(HL)		;NEXT CHARACTER IS DELIMITER ?
	CALL	DELIM?
	JR	Z,DSH100		;YES, COMPLETE MATCH
	DJNZ	DSH050		;GO ON
	INC	DE			;NO MATCH, SKIP TO NEXT COMMAND
	INC	DE			;  SKIP THIS RETURN PARAMETER
	POP	HL			;RESTORE ^STRING TO BE DECODED
	JR	DSH000
DSH100
	PUSH	HL			;IY:=^DELIMITER
	POP	IY
	PUSH	IX			;HL:=RETURN PARAMETER
	POP	HL
	LD	A,L			;RETURN PARAMETER ALREADY SET ?
	OR	H
	LD	IX,1
	JR	NZ,DSH905		;YES, TERMINATE (AMBIGOUS COMMAND)
	LD	L,B			;SET RETURN PARAMETER
	LD	H,0
	DEC	L
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	PUSH	DE			;IX:=RETURN PARAMETER
	POP	IX
	JR	DSH250
DSH200
	LD	L,B			;SKIP THIS COMMAND AND TRY NEXT
	LD	H,0			;HL:=CHARACTERS LEFT IN COMMAND
	INC	L			;SKIP THIS RETURN PARAMETER
	INC	L
	ADD	HL,DE		;DE:=^NEXT COMMAND
DSH250
	EX	DE,HL
	POP	HL			;RESTORE ^STRING TO BE DECODED
	JR	DSH000
DSH905
	POP	HL
DSH900
	PUSH	IX			;DE:=RETURN PARAMETER
	POP	DE
	PUSH	IY			;HL:=^DELIMITER
	POP	HL
	POP	IY			;RESTORE REGISTERS
	POP	IX
	POP	BC
	LD	A,E			;UPDATE ZERO-FLAG
	AND	0FEH
	OR	D
	RET
 
;=======
; G_CCMD - COMPLETE COMMAND DECODER
;
; ACCEPTS: DE = ^TABLE OF COMMANDS
;          HL = ^COMMAND STRING
;
; RETURNS: HL = ^DELIMITER IN GIVEN COMMAND IF MATCH
;          DE = RETURN PARAMETER IF MATCH
;               0 IF NOT FOUND
;          FZ IF OK
;
; AFFECTS: A
;
; Table organisation:
;
; LENGTH byte STRING array [* byte] PARAMETER word
; 0 = end of table
;
; example:      DEFB 5
;               text 'FIRST'
;               DEFW 0101H
;               DEFB 6
;               text 'SECOND'
;               DEFW 0202H
;               DEFB 0
;=======
 
G_CCMD
	PUSH	BC
DSC000
	LD	A,(DE)		;GET COMMAND.LEN
	INC	DE			;DE:=^COMMAND.STRING
	LD	BC,0			;ASSUME 0 RETURN
	OR	A			;END OF COMMAND TABLE ?
	JR	Z,DSC900		;YES
	PUSH	HL			;SAVE ^STRING
	LD	B,A
DSC050
	LD	A,(DE)		;MATCH SO FAR ?
	CP	(HL)
	JR	NZ,DSC200		;NO, EXAMINE NEXT COMMAND
	INC	DE			;YES, NEXT CHARACTER
	INC	HL
	DJNZ	DSC050		;GO ON IF CHARACTERS LEFT
	LD	A,(HL)		;COMPLETE MATCH, CHECK FOR --
	CALL	DELIM?		;  DELIMITER
	EX	DE,HL		;GET RETURN PARAMETER
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	EX	DE,HL
	JR	Z,DSC150		;DELIMITER OK
	POP	HL
	JR	DSC000		;TOO LONG STRING, TEST NEXT
DSC150
	POP	DE
DSC900
	LD	E,C			;DE:=RETURN PARAMETER
	LD	D,B
	POP	BC
	LD	A,E			;SET FLAGS
	OR	D
	RET
DSC200
	LD	L,B			;SKIP THIS COMMAND AND TRY NEXT
	LD	H,0			;HL:=CHARACTERS LEFT IN COMMAND
	INC	L			;COMPENSATE FOR RETURN PARAMETER
	INC	L
	ADD	HL,DE		;DE:=^NEXT COMMAND
	EX	DE,HL
	POP	HL
	JR	DSC000
 
;=======
; DELIM? - CHECK IF DELIMITER
;
; ACCEPTS: HL = ^CHARACTER
;
; RETURNS: TZ IF <CR>,'/' OR ' '
;=======
 
DELIM?
	CP	0DH
	RET	Z
	CP	'/'
	RET	Z
	CP	' '
	RET
	title	'GEN.TABLE'
;UPDATED: 800507 / PH
 
;=======
;
;       TABLE HANDLING
;       ==============
;
; A TABLE in this module holds 16-bits items
; proceeded by one byte giving the number of items
; currently in the table.
; The first byte should be initialized to zero !
;
; example:
;
; ATABLE: DEFS	1
;         DEFS	14*2
;
; This table can hold 14 items.
;=======
 
;=======
; CAPTBL - CONDITIONAL APPEND TO TABLE
;
; ACCEPTS: HL = ^TABLE
;          DE = ITEM TO APPEND
;          A  = MAXIMUM # OF ITEMS ALLOWED
;
; RETURNS: FC IF SUCCESSFUL APPEND
;          TC IF TABLE FULL
;
; AFFECTS: A,B,C,HL
;=======
 
CAPTBL
	DEC	A
	CP	(HL)			;FULL ?
	RET	C			;YES
 
;=======
; APTBL - APPEND TO TABLE
;
; ACCEPTS: HL = ^TABLE
;          DE = ITEM TO APPEND
;
; AFFECTS: B,C,HL,F
;=======
 
APTBL
	LD	C,(HL)		;C:=# OF ITEMS IN TABLE
	INC	(HL)			;ONE ITEM MORE
	LD	B,0			;BC:=# OF ITEMS IN TABLE
	INC	HL			;HL:=^FIRST ITEM
	ADD	HL,BC		;HL:=^FIRST EMPTY POSITION
	ADD	HL,BC
	LD	(HL),E		;APPEND NEW ITEM (LOW)
	INC	HL
	LD	(HL),D		;APPEND NEW ITEM (HIGHBYTE)
	RET
 
;=======
; RMTBL - REMOVE FROM TABLE
;
; ACCEPTS: HL = ^TABLE
;          DE = ITEM TO BE REMOVED
;
; RETURNS: FC IF REMOVAL
;          TC IF NO REMOVAL
;
; AFFECTS: A,B,C,DE,HL
;=======
 
RMTBL
	PUSH	HL			;SAVE ^TABLE-HEAD
	CALL	FDTBL		;IF "DE" NOT EXISTS IN TBL
	POP	DE			;DE:=^TABLE-HEAD
	RET	C			;  THEN NO REMOVAL
	EX	DE,HL		;DE:=^ITEM TO BE REMOVED
	DEC	(HL)			;ONE ITEM LESS
	LD	L,E
	LD	H,D
	INC	HL			;HL:=^NEXT ITEM IN TBL
	INC	HL
	AND	A			;TRUE REMOVAL
	DEC	B			;B:=# OF ITEMS LEFT IN TABLE
	RET	Z			;RET IF LAST ITEM
	LD	C,B			;BC:=# OF BYTES LEFT IN TABLE
	LD	B,0
	SLA	C
	RL	B
	LDIR				;COMPRESS TBL
	RET
 
;=======
; FDTBL - FIND IN TABLE
;
; ACCEPTS: HL = ^TABLE
;          DE = ITEM LOOKED FOR
;
; RETURNS: B  = # OF ITEMS LEFT (INCLUDING HL^)
;          FC IF MATCH
;            HL = ^MATCHING ITEM
;          TC IF NO MATCH
;            HL = ^FIRST EMPTY POSITION
;
; AFFECTS: A,HL
;=======
 
FDTBL
	LD	B,(HL)		;B:=# OF ITEMS IN TABLE
	INC	B
FDTBL1
	INC	HL			;HL:=^CURRENT ITEM (LOWBYTE)
	DEC	B			;END OF TABLE ?
	SCF
	RET	Z			;YES, RETURN (CY=1)
	LD	A,(HL)		;A:=CURRENT LOWBYTE
	CP	E			;PARTIAL MATCH ?
	INC	HL			;HL:=^CURRENT HIGHBYTE
	JR	NZ,FDTBL1		;NO
	LD	A,(HL)		;YES, TEST HIGHBYTE
	CP	D			;MATCH ?
	JR	NZ,FDTBL1		;NO
	DEC	HL			;HL:=^MATCHING LOWBYTE
	AND	A			;YES, --
	RET				;  RETURN WITH CY=0
	title	'GEN.QUEUE'
;UPDATED: 810901  / PH
 
;=======
; G_ENQ - APPEND TO QUEUE
;
; ACCEPTS: HL = ^QUEUE-HEAD
;          DE = ^ITEM TO BE APPENDED
;
; AFFECTS: AF,HL
;=======
 
G_ENQ
	LD	A,(HL)
	INC	HL
	OR	(HL)			;LAST ITEM ?
	JR	Z,ENQ50		;YES, HL -> 0
	LD	A,(HL)		;NO, HL:=^NEXT ITEM
	DEC	HL
	LD	L,(HL)
	LD	H,A
	JR	G_ENQ
ENQ50
	LD	(HL),D		;FIX HL -> DE
	DEC	HL
	LD	(HL),E
	LD	(DE),A		;FIX DE -> 0
	INC	DE
	LD	(DE),A
	DEC	DE
	RET
 
;=======
; G_DEQ - REMOVE FIRST ITEM OF QUEUE
;
; ACCEPTS: HL = ^QUEUE-HEAD
;
; RETURNS: HL = ^REMOVED ITEM IF NOT EMPTY
;          TC IF QUEUE WAS EMPTY
;
; AFFECTS: AF,HL
;=======
 
G_DEQ
	LD	A,(HL)		;CHECK IF EMPTY
	INC	HL
	OR	(HL)
	SCF				;ASSUME EMPTY
	RET	Z
	PUSH	DE
	LD	D,(HL)		;DE:=^1ST ITEM
	DEC	HL
	LD	E,(HL)
	LD	A,(DE)		;FIX HL -> 2ND
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	LD	(HL),A
	DEC	DE
	EX	DE,HL
	POP	DE
	AND	A			;CLEAR CY
	RET
 
;=======
; G_REMQ - REMOVE OUT OF QUEUE
;
; ACCEPTS: HL = ^QUEUE-HEAD
;          DE = ^ITEM TO BE REMOVED
;
; RETURNS: TC IF NOT FOUND
;
; AFFECTS: AF,HL
;=======
 
G_REMQ
	PUSH	BC
	LD	C,E			;BC:=^SEARCHED ITEM
	LD	B,D
REMQ10
	LD	E,(HL)		;SET UP "HL -> DE ->"
	INC	HL
	LD	D,(HL)
	EX	DE,HL		;DE -> HL ->
	LD	A,L
	OR	H
	SCF
	JR	Z,REMQ50		;END OF QUEUE, NOT FOUND
	AND	A
	SBC	HL,BC		;ITEM FOUND ?
	ADD	HL,BC		;HL:=^NEXT ITEM TO BE CHECKED
	JR	NZ,REMQ10
	INC	BC			;DE -> BC -> xx
	LD	A,(BC)		;FIX DE -> xx
	LD	(DE),A
	DEC	BC
	DEC	DE
	LD	A,(BC)
	LD	(DE),A
REMQ50
	LD	E,C
	LD	D,B
	POP	BC
	RET
	title	'GEN.SWITCH'
;UPDATED: 810824 / PH
 
;=======
; SWITCH - DECODE COMMAND SWITCHES
;
; ACCEPTS: HL = ^'/' IN COMMAND STRING
;
; RETURNS: BCDE = BITPATTERN ACCORDING TO SWITCHES
;          HL = ^FIRST NON-SWITCH (' ' OR CR) IF '/'
;               IS FOUND, ELSE UNAFFECTED
;
; AFFECTS: A,F
;=======
 
SWITCH
	XOR	A
	LD	E,A			;BCDE:=0
	LD	D,A
	LD	C,A
	LD	B,A
	LD	A,(HL)		;MUST START WITH A '/'
	CP	'/'
	RET	NZ
	PUSH	HL
SWIT03
	POP	HL
SWIT05
	INC	HL			;NEXT CHARACTER
	LD	A,(HL)
	CP	' '			;READY IF ' ' OR CR
	RET	Z
	CP	0DH
	RET	Z
	SUB	'A'			;< 'A'
	JR	C,SWIT05		;YES, NEXT CHARACTER
	CP	'Z'-'A'+1		;> 'Z'
	JR	NC,SWIT05
	PUSH	HL
	LD	L,33			;32 BITS TO ROTATE
SWIT10
	RR	B
	RR	C
	RR	D
	RR	E
	DEC	L			;KEEP TRACK OF ROTATIONS
	JR	Z,SWIT03		;READY
	SUB	1			;affect CY
	JR	SWIT10
	title	'MEMORY RELATED COMMANDS'
;UPDATED: 820119 / PH
;FILE:    RTZ.DBG.MEMORY.S
 
;=======
; H_EXAM - EXAMINE MEMORY AS BYTES OR WORDS
;=======
 
	EXTERNAL	Z$P1,Z$OBUF
 
H_EXAM
	CALL	SWITCH		;GET COMMAND SWITCHES
	BIT	BIT_W,C
	JR	NZ,EXW
 
;=======
; EXB - EXAMINE MEMORY AS BYTES
;=======
 
EXB
	CALL	GET1P		;GET ONE PARAMETER
	XOR	A			;NO CR THE FIRST TIME
	JR	EXB12
EXB10
	LD	A,0DH
EXB12
	LD	HL,Z$OBUF
	LD	(HL),A
	INC	HL
EXB20
	CALL	PUT16_
	LD	A,(DE)		;GET CURRENT VALUE
	CALL	PUT8_
	LD	(HL),0FFH
	CALL	OTOBUF
	LD	HL,EXB50		;RET.ADR IF ' '
	CALL	GETVAL		;GET NEW VALUE IF ANY ?
	LD	HL,(Z$P1)		;HL:=CURRENT ADDRESS
	LD	(HL),E		;INSERT NEW VALUE
	INC	HL			;EXAMINE NEXT ADDRESS
	LD	(Z$P1),HL
	EX	DE,HL
	LD	HL,Z$OBUF
	JR	EXB20
EXB50
	LD	HL,(Z$P1)		;HL:=CURRENT ADDRESS
	CP	' '
	JR	Z,EXB52
	DEC	HL			;EXAMINE LAST ADDRESS
	JR	EXB54
EXB52
	INC	HL			;EXAMINE NEXT ADDRESS
EXB54
	LD	(Z$P1),HL
	EX	DE,HL
	JR	EXB10
 
;=======
; EXW - EXAMINE MEMORY AS WORDS
;=======
 
EXW
	CALL	GET1P		;GET ONE PARAMETER
	XOR	A			;NO CR THE FIRST TIME
	JR	EXW12
EXW10
	LD	A,0DH
EXW12
	LD	HL,Z$OBUF
	LD	(HL),A
	INC	HL
EXW20
	CALL	PUT16_
	EX	DE,HL
	LD	A,(HL)		;GET CURRENT VALUE
	INC	HL
	LD	H,(HL)
	LD	L,A
	EX	DE,HL
	CALL	PUT16_
	LD	(HL),0FFH
	CALL	OTOBUF
	LD	HL,EXW50		;RET.ADR IF ' '
	CALL	GETVAL		;GET NEW VALUE IF ANY ?
	LD	HL,(Z$P1)		;HL:=CURRENT ADDRESS
	LD	(HL),E		;INSERT NEW VALUE
	INC	HL
	LD	(HL),D
	INC	HL			;EXAMINE NEXT ADDRESS
	LD	(Z$P1),HL
	EX	DE,HL
	LD	HL,Z$OBUF
	JR	EXW20
EXW50
	LD	HL,(Z$P1)		;HL:=CURRENT ADDRESS
	CP	' '
	JR	Z,EXW52
	DEC	HL			;EXAMINE LAST ADDRESS
	DEC	HL
	JR	EXW54
EXW52
	INC	HL			;EXAMINE NEXT ADDRESS
	INC	HL
EXW54
	LD	(Z$P1),HL
	EX	DE,HL
	JR	EXW10
 
;=======
; H_DSB - DISPLAY MEMORY AS BYTES
;=======
 
	EXTERNAL	Z$P1,Z$OBUF,Z$P2,Z$TTYS
 
H_DSB
	CALL	GET2PC
	OR	A
	JP	Z,PRMERR		;NO PARAMETER
	DEC	A
	JR	NZ,DSB05		;TWO PARAMETERS
	LD	A,10H		;ONE PARAMETER
	LD	(Z$P2),A		;  DISPLAY 16 BYTES
DSB05
	XOR	A			;CLEAR BREAK-FLAG
	LD	(Z$TTYS),A
DSB10
	LD	A,(Z$TTYS)	;BREAK DISPLAY ?
	OR	A
	RET	NZ
	LD	A,16			;16 VALUES/LINE
	LD	B,A			;LINE-LOOP
	LD	C,A			;ASCII-COUNTER
	LD	DE,(Z$P1)		;DE:=START ADDRESS
	PUSH	DE			;SAVE IT FOR ASCII DISPLAY
	LD	HL,Z$OBUF
	CALL	PUT16_
	INC	HL
DSB15
	LD	A,(DE)		;A:=VALUE
	INC	DE
	CALL	PUT8_
	PUSH	HL
	LD	HL,(Z$P2)		;COUNT DOWN
	DEC	HL
	LD	(Z$P2),HL
	LD	A,L
	OR	H
	POP	HL
	JR	Z,DSB40		;ALL BYTES DISPLAYED
	DEC	B			;END OR MIDDLE OF LINE ?
	JR	Z,DSB23		;END OF LINE
	LD	A,B
	CP	8
	JR	NZ,DSB15
	INC	HL			;MIDDLE OF LINE
	JR	DSB15
 
;-------
; ASCII PART OF LINE
;-------
 
DSB23
	INC	HL
	INC	HL
	INC	HL
	LD	(Z$P1),DE		;SAVE CURRENT ADDRESS
	POP	DE			;GET START ADDRESS AGAIN
DSB24
	LD	A,(DE)
	INC	DE
	AND	7FH
	CP	20H
	JR	C,DSB25
	CP	7FH
	JR	NZ,DSB26
DSB25
	LD	A,'.'
DSB26
	LD	(HL),A
	INC	HL
	LD	A,B			;A:=LINE COUNTER
	DEC	C			;SAME # OF ASCII CHARACTERS
	CP	C
	JR	NZ,DSB24
	CALL	PUTEOS
	CALL	OTOBUF
	LD	HL,(Z$P2)		;ALL DONE ?
	LD	A,L
	OR	H
	JR	NZ,DSB10
	RET
 
;-------
; FILL LINE WITH SPACES
;-------
 
DSB40
	DEC	B
	LD	A,B
DSB42
	JR	Z,DSB23
	INC	HL
	INC	HL
	INC	HL
	CP	8
	JR	NZ,DSB44
	INC	HL
DSB44
	DEC	A
	JR	DSB42
	title	'INITIALIZATIONS FOR RTZ DEBUGGER'
;UPDATED: 820119 / PH
;FILE:    RTZ.DBG.INIT.S
;REV:     2.00
 
	EXTERNAL	Z$TRCF,Z$DFLG,Z$TRCT,Z$BPCB
	EXTERNAL	Z_SGNL,Z_CSEM,Z_BPOL,Z$BMSG
	EXTERNAL	Z$SIBP,Z$WABP,Z$PTY
	EXTERNAL	Z_TQUE,Z_WAIT,Z_CPRO,Z$SBTB,Z$WBTB
	EXTERNAL	Z$PMIR,Z$DWRS,Z_DBSM,Z_EWAI
 
DBGINI
	LD	DE,Z$PMIR		;PROM-MIRROR TO RAM
	LD	HL,Z_PMIR
	LD	BC,MIRRSZ
	LDIR
 
	LD	A,0BH		;START WITH TRACE
	LD	(Z$TRCF),A
	XOR	A
	LD	(Z$DFLG),A	;CLEAR DEBUGGER STATUS BITS
	LD	(Z$SBTB),A	;NO SIGNAL BREAKPOINTS
	LD	(Z$WBTB),A	;NO WAIT BREAKPOINTS
	DEC	A
	LD	(Z$TRCT),A	;NO TRACE-POINTS
 
	LD	B,10H		;MARK FOR SUBROUTINE RUN
	LD	DE,Z_WAIT
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_SGNL
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_EWAI
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_CPRO
	CALL	RBRKAD
	LD	B,10H
	LD	DE,Z_CSEM
	CALL	RBRKAD
 
	LD	IX,(Z_RUNP)	;GET DEBUGGER PRIORITY
	LD	A,(IX+PCBPTY)
	LD	(Z$PTY),A
 
	LD	HL,0
	LD	(Z_TQUE),HL	;TRACE QUEUE EMPTY
	LD	(Z$BPCB),HL	;NO PROCESS BREAKED YET
 
	LD	HL,SIGBR?		;ROUTINE FOR CHECK OF --
	LD	(Z$SIBP),HL	;  SIGNAL BREAKPOINTS
	LD	HL,WAIBR?		;ROUTINE FOR CHECK OF --
	LD	(Z$WABP),HL	;  WAIT BREAKPOINTS
 
	LD	DE,Z_BPOL		;CREATE POOL FOR BREAK-MESSAGES
	CALL	Z_CSEM
	LD	B,6			;BUILD BREAKPOINT MESSAGES --
	LD	IX,Z$BMSG
INIT10
	LD	(IX+MSGLEN),14	;  AND SEN THEM TO Z_BPOL
	LD	(IX+MSGLEN+1),0
	LD	DE,Z_BPOL
	LD	(IX+MSGRSM),E	;RESPONSE-SEMAPHORE
	LD	(IX+MSGRSM+1),D
	PUSH	IX
	POP	HL
	CALL	Z_SGNL
	LD	DE,14+2		;2 BYTES FOR CHECKPOINT ADDRESS
	ADD	IX,DE		;IX:=^NEXT BREAK-MESSAGE
	DJNZ	INIT10
 
	LD	DE,Z_DBSM		;CREATE DEBUGGER EVENT SEMAPHORE
	CALL	Z_CSEM
	LD	DE,Z$DWRS		;DEBUGGER WRITE RESPONSE
	CALL	Z_CSEM
 
	LD	DE,IPCBCC		;CREATE ^C-PROCESS
	CALL	Z_CPRO
 
	RET
 
IPCBCC
	text	'Z$CTRC'
	DEFW	Z_CTRC
	DEFW	50
	DEFB	1
 
;-------
; PROM-MIRROR
;-------
 
Z_PMIR
	DEFW	WEVENT
Z_PMSG
	DEFS	2
	DEFW	ZQCWRB
	DEFW	14
	DEFW	Z_DBSM
	DEFW	XPROMT
	DEFW	2
	DEFS	2
 
	DEFS	2
Z_CONM
	DEFS	2			;LNK
	DEFS	2			;RQC,RC
	DEFW	14			;LEN
	DEFW	Z_DBSM
	DEFS	2			;BAD
	DEFS	2			;BSZ
	DEFS	2			;BCN
 
MIRRSZ	EQU	$-Z_PMIR
	title	'CPU-RELATED COMMANDS'
;UPDATED: 820127 / PH
;FILE:    RTZ.DBG.CPU.S
;REV:     2.00
 
;=======
; H_REG - EXAMINE CPU-REGISTERS
;=======
 
	EXTERNAL	Z$TPCB,Z$REGF,Z$OBPT,Z$OOBP,Z$OREG
 
H_REG
	CALL	CHKTP
	PUSH	DE
	POP	IX
	CALL	PPRCST
	XOR	A
	LD	(Z$OBUF),A
	LD	HL,XREG		;HL:=^ASCII-NAMES OF REGISTERS
	LD	DE,Z$$A		;DE:=^CURRENT REGISTER CONTENT
EREG10
	LD	A,(HL)		;END OF REGISTERS ?
	INC	A
	JP	Z,EREG90		;YES
	DEC	A			;RESTORE A
	PUSH	HL
	PUSH	DE
	LD	DE,Z$OBUF+1
	LDI				;MOVE REGNAME TO Z$OBUF
	JP	P,EREG15
	LDI				;DOUBLE REGISTER
EREG15
	EX	DE,HL		;HL:=^Z$OBUF.CUR
	LD	(HL),'='
	INC	HL
	EX	(SP),HL		;HL:=^REGISTER VALUE
	OR	A			;DOUBLE REGISTER ?
	JP	P,EREG20		;NO
	LD	E,(HL)		;YES, DE:=16-BIT VALUE
	INC	HL
	LD	D,(HL)
	DEC	HL
	EX	(SP),HL		;HL:=^Z$OBUF.CUR
	CALL	PUT16_
	JR	EREG25
EREG20
	LD	A,(HL)		;A:=REGISTER  VALUE
	EX	(SP),HL		;HL:=^Z$OBUF.CUR
	CALL	PUT8_
EREG25
	LD	(HL),0FFH
	CALL	OTOBUF
	CALL	STOZ80
	LD	HL,SKIP
	CALL	GETVAL		;DE:=NEW VALUE
	CALL	LODZ80
	POP	HL			;HL:=^REGISTER VALUE
	LD	(HL),E		;UPDATE REGISTER VALUE
	INC	HL
	POP	BC			;BC:=^XREG.CUR
	LD	A,(BC)		;DOUBLE REGISTER ?
	OR	A
	JP	P,EREG30		;NO
	LD	(HL),D		;YES, ONE BYTE MORE
	INC	HL
EREG30
	LD	A,0			;NO <CR>
EREG50
	LD	(Z$OBUF),A
	EX	DE,HL		;DE:=^REGISTER VALUE
	LD	L,C			;HL:=^XREG.CUR
	LD	H,B
	INC	HL			;NEXT REGISTER
	JP	P,EREG10		;8-BIT REGISTER
	INC	HL
	JP	EREG10
SKIP
	CALL	LODZ80
	POP	HL			;HL:=^REGISTER VALUE
	INC	HL
	POP	BC			;BC:=^XREG.CUR
	LD	A,(BC)		;DOUBLE REGISTER ?
	OR	A
	JP	P,SKIP50		;NO
	INC	HL
SKIP50
	LD	A,0DH
	JR	EREG50
EREG90
	CALL	STOZ80		;RESTORE USER REGISTERS
	JR	OUTCR
 
XREG
	text	'acbedlhf'
	DEFB	'i'+80H
	DEFB	'x'
	DEFB	'i'+80H
	DEFB	'y'
	DEFB	0FFH
 
;=======
; PPRCST - PRINT PROCESS STATUS
;
; Accepts: IX = ^PCB
;=======
 
	EXTERNAL	Z$OBUF
 
PPRCST
	LD	HL,Z$OBUF		;PRINT PROCESS NAME
	LD	DE,XPROC
	CALL	PUTSTR
	CALL	PUTNAM
	LD	(HL),0FFH
	CALL	OTOBUF
	CALL	DALREG
	LD	HL,(Z$$PC)
	CALL	PRINST
OUTCR
	LD	HL,XCR
	CALL	OUTSTR
	RET
 
XPROC 	text	'Process: '
      	DEFB	0FFH
XCR   	DEFW	0FF0DH
 
;=======
; DALREG - DISPLAY ALL Z80-REGISTERS
; DCHREH - DISPLAY CHANGED Z80-REGISTERS
;=======
 
	EXTERNAL	Z$OBUF
 
DALREG
	LD	A,0FFH
	JR	REG05
DCHREG
	XOR	A
REG05
	CALL	LODZ80
	LD	(Z$REGF),A	;SWITCH FOR ALL/CHANGED REG
	LD	HL,Z$OBUF		;SET UP Z$OBPT
	LD	(HL),0DH
	INC	HL
	LD	(Z$OBPT),HL
	LD	HL,REGASC		;HL:=^REGISTERNAMES IN ASCII
	LD	DE,Z$$A		;DE:=^CURRENT VALUE
	LD	BC,Z$OREG		;BC:=^LATEST VALUE DISPLAYED
REG10
	LD	A,(HL)		;END OF REGISTERS ?
	OR	A
	JP	M,OTOBUF		;YES, DISPLAY LINE
	PUSH	DE			;SAVE ^CURRENT VALUE
	PUSH	AF
	LD	DE,(Z$OBPT)	;DE:=^Z$OBUF.CUR
	LD	(Z$OOBP),DE	;SAVE THIS IN CASE OF NO CHANGE
	LD	(DE),A		;MOVE REGNAME TO OUTBUF
	INC	DE
	INC	HL
	LD	A,(HL)
	LD	(DE),A
	INC	DE
	LD	A,'='		;PUT OUT EQUAL SIGN
	LD	(DE),A
	INC	DE
	INC	HL
	POP	AF			;GET FIRST LETTER IN REG-NAME
	EX	(SP),HL		;HL:=^CURRENT VALUE
	PUSH	BC
	PUSH	HL
	CP	'a'
	JR	Z,REG_A
	CP	'f'
	JP	Z,REG_F
	LD	A,(HL)		;FETCH REG-VALUE
	INC	HL
	LD	H,(HL)
	LD	L,A
	EX	DE,HL
	CALL	PUT16
REG90
	INC	HL
	LD	(HL),0FFH
	LD	(Z$OBPT),HL	;UPDATE ^Z$OBUF.CUR
	POP	HL
	POP	BC
	LD	A,(BC)
	XOR	(HL)
	LD	D,A
	LD	A,(HL)
	LD	(BC),A
	INC	HL
	INC	BC
	LD	A,(BC)
	XOR	(HL)
	OR	D
REGA1
	LD	D,A
	LD	A,(HL)
	LD	(BC),A
	INC	BC
	INC	HL
	LD	A,(Z$REGF)
	OR	D			;UPDATE OF DISPLAY ?
	PUSH	BC		
	PUSH	HL
	JR	NZ,REGC5		;YES
	LD	HL,(Z$OBPT)	;NO, CLEAR LATEST PART OF --
	LD	DE,(Z$OOBP)	;  Z$OBUF
	AND	A
	SBC	HL,DE
	LD	B,L
	LD	A,' '
REG20
	LD	(DE),A
	INC	DE
	DJNZ	REG20		;REPEAT
REGC5
	POP	DE
	POP	BC
	POP	HL
	JR	REG10
 
REG_F
	LD	BC,FLAGS		;HANDLE FLAGS
	DEC	DE
	DEC	DE
	DEC	DE
	PUSH	HL
	LD	L,(HL)
	EX	DE,HL		;HL:=^Z$OBUF.CUR, E:=FLAG-VALUES
REGD2
	LD	A,(BC)
	INC	BC
	OR	A			;FLAG-BIT ?
	JR	Z,REG9R		;READY
	JP	M,REGE4		;NO
	LD	(HL),A
	LD	A,E
	OR	A
	JP	M,REGE3
	LD	(HL),'.'
REGE3
	INC	HL
REGE4
	RLC	E
	JR	REGD2
REG9R
	INC	HL
	LD	(HL),'f'
	INC	HL
	LD	(HL),'='
	INC	HL
	INC	HL
	EX	DE,HL
	POP	HL
 
; HANDLE REGISTER A
 
REG_A
	LD	A,(HL)
	EX	DE,HL
	DEC	HL
	CALL	PUT8_
	LD	(HL),0FFH		;END OF STRING
	LD	(Z$OBPT),HL
	POP	HL
	POP	BC
	LD	A,(BC)
	XOR	(HL)
	JR	REGA1
 
REGASC
	DEFB	'a'
	DEFB	'='
	text	'bcdehlf'
	DEFB	0
	text	'ixiysp'
	DEFB	0FFH
 
FLAGS
	text	'SZ'
	DEFB	080H
	DEFB	'A'
	DEFB	80H
	DEFB	'P'
	DEFB	80H
	DEFB	'C'
	DEFB	0
 
PALCPU	LD	A,0FFH
	JR	A_185C
PCHCPU	XOR	A
A_185C
	CALL	FR4680
	JP	REG05
 
;=======
; LODZ80 - MOVE Z80-REG FROM STACK TO DISPLAY-ORDER
;
; ACCEPTS: IX = ^PCB
;
; Affects: F
;=======
 
	EXTERNAL	Z$$A,Z$$F,Z$$BC,Z$$DE,Z$$HL,Z$$IX,Z$$IY,Z$$SP,Z$$PC
 
LODZ80
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	L,(IX+PCBSP)	;HL:=^USER STACK
	LD	H,(IX+PCBSP+1)
	LD	DE,Z$$IY
	LDI
	LDI
	LD	DE,Z$$IX
	LDI
	LDI
	LD	DE,Z$$DE
	LDI
	LDI
	LD	DE,Z$$BC
	LDI
	LDI
	LD	DE,Z$$F
	LDI
	LD	DE,Z$$A
	LDI
	LD	DE,Z$$HL
	LDI
	LDI
	LD	DE,Z$$PC
	LDI
	LDI
	LD	(Z$$SP),HL
	POP	HL
	POP	DE
	POP	BC
	RET
 
;=======
; STOZ80 - STORE Z80-REG IN USER STACK
;
; Affects: F
;=======
 
STOZ80
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	DE,(Z$$SP)
	DEC	DE
	LD	HL,Z$$PC+1
	LDD
	LDD
	LD	HL,Z$$HL+1
	LDD
	LDD
	LD	HL,Z$$A
	LDD
	LD	HL,Z$$F
	LDD
	LD	HL,Z$$BC+1
	LDD
	LDD
	LD	HL,Z$$DE+1
	LDD
	LDD
	LD	HL,Z$$IX+1
	LDD
	LDD
	LD	HL,Z$$IY+1
	LDD
	LDD
	POP	HL
	POP	DE
	POP	BC
	RET
 
;=======
; TO4680 - MOVE Z80-REG FROM STACK TO 4680-ORDER
;
; ACCEPTS: IX = ^PCB
;
; AFFECTS: DE,BC
;=======
 
	EXTERNAL	Z$AF,Z$BC,Z$DE,Z$HL,Z$IX,Z$IY,Z$SP,Z$PC
 
TO4680
	PUSH	HL
	LD	L,(IX+PCBSP)	;HL:=^USER STACK
	LD	H,(IX+PCBSP+1)
	LD	DE,Z$IY
	LDI
	LDI
	LD	DE,Z$IX
	LDI
	LDI
	LD	DE,Z$DE
	LDI
	LDI
	LD	DE,Z$BC
	LDI
	LDI
	LD	DE,Z$AF
	LDI
	LDI
	LD	DE,Z$HL
	LDI
	LDI
	LD	DE,Z$PC
	LDI
	LDI
	LD	(Z$SP),HL
	POP	HL
	RET
 
;=======
; FR4680 - MOVE Z80-REG TO STACK FROM 4680-ORDER
;
; AFFECTS: DE,HL,BC
;=======
 
FR4680
	LD	DE,(Z$SP)
	DEC	DE
	LD	HL,Z$PC+1
	LDD
	LDD
	LD	HL,Z$HL+1
	LDD
	LDD
	LD	HL,Z$AF+1
	LDD
	LDD
	LD	HL,Z$BC+1
	LDD
	LDD
	LD	HL,Z$DE+1
	LDD
	LDD
	LD	HL,Z$IX+1
	LDD
	LDD
	LD	HL,Z$IY+1
	LDD
	LDD
	INC	DE
	LD	(IX+PCBSP),E
	LD	(IX+PCBSP+1),D
	RET
	title	'I/O'
;UPDATED: 811201 / PH
;FILE:    RTZ.DBG.IO
;REV:     2.00
 
OBUFSZ	EQU	200
 
;=======
; INCHAR - READ ONE CHARACTER
;
; RETURNS: A  = READ CHARACTER (B7=0)
;=======
 
	EXTERNAL	Z$IBUF,Z$CONM
 
INCHAR
	PUSH	AF
	PUSH	DE
	PUSH	HL
	LD	A,ZQCRDB		;READ BINARY
	LD	HL,1			;ONE CHARACTER
	JR	INLI50
 
;=======
; INLIN - READ LINE INTO Z$IBUF
;
;=======
 
	EXTERNAL	Z_DBSM
 
INLIN
	PUSH	AF
	PUSH	DE
	PUSH	HL
	LD	A,ZQCRDA		;READ ASCII
	LD	HL,80		;ONE SCREEN LINE
INLI50
	LD	(Z$CONM+MSGRQC),A
	LD	(Z$CONM+MSGBSZ),HL
	LD	HL,Z$IBUF		;INPUT BUFFER
	LD	(Z$CONM+MSGBAD),HL
	PUSH	IX
	CALL	EVQUE
	POP	IX
	POP	HL
	POP	DE
	POP	AF
	LD	A,(Z$IBUF)	;A:=FIRST READ CHARACTER
	RET
 
;=======
; OUTSTR - WRITE STRING ON SCREEN
;
; ACCEPTS: HL = ^STRING,<0FFH>
;=======
 
	EXTERNAL	Z_A0SM,Z$OBUF,Z$DWRS,Z_SGNL
 
OUTSTR
	PUSH	AF			;SAVE AF
	PUSH	DE			;SAVE DE
	PUSH	DE			;BCN
	LD	DE,0FFFFH		;LET <0FFH> TERMINATE
	PUSH	DE			;BSZ
	PUSH	HL			;BAD
	LD	HL,Z$DWRS		;DEBUGGER WRITE RESPONSE SEM
	PUSH	HL			;RSM
	LD	HL,14		;LEN
	PUSH	HL
	LD	L,ZQCWRB		;WRITE BINARY
	PUSH	HL			;RQC
	PUSH	HL			;LNK
	LD	L,0			;HL:=^MESSAGE ON STACK
	ADD	HL,SP
	LD	DE,Z_A0SM
	CALL	Z_SGNL
	LD	DE,Z$DWRS
	CALL	Z_EWAI
	LD	HL,Z$OBUF		;FILL Z$OBUF WITH SPACES
	LD	A,OBUFSZ
OUTS50
	LD	(HL),' '
	INC	HL
	DEC	A
	JR	NZ,OUTS50
	POP	HL			;LNK
	POP	HL			;RQC,RC
	POP	HL			;LEN
	POP	HL			;RSM
	POP	HL			;BAD
	POP	DE			;BSZ
	POP	DE			;BCN
	POP	DE			;RESTORE DE
	POP	AF			;RESTORE AF
	RET
	title	'PRINT ERROR-MESSAGES'
;UPDATED: 820115 / PH
;FILE:    RTZ.DBG.ERROR.S
 
CMDERR
	LD	A,E			;A:=RETURN CODE FROM DECODER
	LD	HL,XUNCMD		;ASSUME UNKNOWN COMMAND
	OR	A
	JR	Z,PRINT
	LD	HL,XAMB		;MUST BE AMBIGOUS COMMAND
	JR	PRINT
OVFERR
	LD	HL,XOVFER
	JR	PRINT
SYMERR
	LD	HL,XSYMER
	JR	PRINT
TPERR
	LD	HL,XTPER
	JR	PRINT
ADRERR
	LD	HL,XADRER
	JR	PRINT
DATERR
	LD	HL,XDATER
	JR	PRINT
SYSERR
	LD	HL,XSYSER
	JR	PRINT
WAIERR
	LD	HL,XWAIER
	JR	PRINT
PRMERR
	LD	HL,XPRMER
PRINT
	CALL	OUTSTR
	JP	CMDWAI
 
;-------
; ERROR MESSAGES
;-------
 
XUNCMD
	text	'Unknown command'
	DEFW	0FF0DH
XAMB
	text	'Ambigous command'
	DEFW	0FF0DH
XPRMER
	text	'Parameter error'
	DEFW	0FF0DH
XDATER
	text	'Unvalid value'
	DEFW	0FF0DH
XTPER
	text	'No Traced Process'
	DEFW	0FF0DH
XADRER
	text	'Invalid address'
	DEFW	0FF0DH
XSYMER
	text	'Undefined symbol'
	DEFW	0FF0DH
XOVFER
	text	'Table full'
	DEFW	0FF0DH
XSYSER
	text	'Debugger breakpoint'
	DEFW	0FF0DH
XWAIER
	text	'No message'
	DEFW	0FF0DH
	title	'DISASSEMBLER'
;UPDATED: 820111 / PH
;FILE:    RTZ.DBG.DIS.S
 
	;REVISIONS LIST:
	;
	; REV 1.0:	ORIGINAL VERSION
	; REV 1.1:	LINE FEEDS REMOVED	790217
	;		SHORTENED		790218
	; REV 1.2:	OPERANDS TABBED FROM
	;		MNEMONIC		790218
	; REV 1.3:	ADDRESSES WRITTEN
	;		IN PROPER FORMAT	790225
	; REV 2.0:	COMPLETELY REARRANGED
	;		AND SHORTENED		790315
	; REV 2.1:	MULTIPLE RST 38:S
	;		TREATED AS DEFS		790316
	; REV 2.2:	BLANK LINES AFTER 
	;		JUMPS & RETURNS		790317
	; REV 2.3:	MORE USE OF TABS	790320
	; REV 2.35:	REARRANGED FOR SINGEL
	;		LINE DISASM.		790907
 
	;	   THIS MODULE IS A SUBROUTINE WHICH 
	;	PROVIDES ALL THE RELEVANT FEATURES OF
	;	A DISASSEMBLER.
 
	;	   THE ACTION PERFORMED IS TO CONVERT A
	;	MACHINE CODE INSTRUCTION, POINTED TO BY
	;	IX, INTO AN ASSEMBLER SOURCE STATE-
	;	MENT STRING, WHICH IS PLACED AT IY. 
	eject
 
TAB	EQU 9		;RIO TAB CHARACTER
 
DISM
	LD HL,HL_0	;SET UP 'HL' STRING
	LD DE,HL_	;DESTINATION
	LD BC,4		;MOVE 4 CHARS
	LDIR
	LD HL,PHLP_0	;SET UP '(HL)' STRING
	LD DE,PHLP_	;DESTINATION
	LD BC,7
	LDIR
	LD HL,INSTAB	;POINT TO PRIMARY INSTR TABLE
	LD A,(IX+0)	;GET 1:ST INSTR BYTE
JPSRCH	CALL ADSRCH	;GET JUMP ADDRESS
	JP (HL)		;GO TO IT
 
	title	'COMMON SUBROUTINES'
 
	;ADSRCH SEARCES A  TABLE FOR MATCH WITH SPECIFIED
	;BITS OF A, THEN RETURNS WITH A CORRESPONDING ADD-
	;RESS IN HL
 
ADSRCH	PUSH AF
	XOR (HL)	;PATTERN
	INC HL
	AND (HL)	;MASK BITS
	INC HL
	JR Z,FOUND
	INC HL		;SKIP OVER ADDRESS
	INC HL
	POP AF
	JR ADSRCH
FOUND
	LD A,(HL)	;LO BYTE
	INC HL
	LD H,(HL)	;HI
	LD L,A
	POP AF
	RET
 
	;THE FOLLOWING WRITES THE LEFT FIELDS OF 1, 2, 3 AND 4
	;BYTE INSTRUCTIONS TO OUTPUT STRING
 
SINBYT	LD B,1		;SINGLE BYTE
	JR WRLEFT
 
DULBYT	LD B,2		;DUAL BYTE
	JR WRLEFT
 
TRIBYT	LD B,3		;TRIPLE BYTE
	JR WRLEFT
 
QADBYT	LD B,4		;QUAD BYTE
 
	;WRLEFT WRITES LEFT FIELDS FOR (B) BYTE
	;INSTRUCTIONS
 
WRLEFT	PUSH AF
NOLEFT	INC IX		;STEP UP INSTR POINTER
	DJNZ NOLEFT	;LOOP FOR INSTR LGT
	LD A,TAB	;WRITE TAB
	CALL WRA
	POP AF		;RESTORE INSTR BYTE TO A
	RET
 
	;WRBYT WRITES CONTENTS OF A TO STRING
	;AS TWO HEX DIGITS
 
WRBYT	PUSH AF		;SAVE BYTE
	RRCA		;SHIFT RGT 4
	RRCA
	RRCA
	RRCA
	CALL WRDIG
	POP AF
 
	;WRDIG WRITES FOUR LOW BITS OF A AS HEX DIGIT
 
WRDIG	PUSH AF
	AND 0FH		;MASK LO DIG
	ADD A,90H	;CONVERT TO ASCII
	DAA
	ADC A,40H
	DAA
	CALL WRA
	POP AF
	RET
 
	;LINEND PUTS A SPACE IN STRING
 
LINEND	LD A,' '
 
	;WRA WRITES CONTENTS OF A TO STRING
 
WRA	LD (IY+0),A
	INC IY
	RET
 
	;WRVAL WRITES A 2-BYTE VALUE IN DE TO
	;STRING WITH LEADING 0
	;IF NECESSARY
 
WRVAL	PUSH AF		;SAVE REGS
	PUSH HL
	LD HL,9		;LESS THAN 10?
	AND A
	SBC HL,DE
	POP HL
	JR NC,ONEDIG	;NO '0' OR 'H'
	LD A,D		;HI BYTE
	RRA		;SHIFT DOWN HI DIGIT
	RRA
	RRA
	RRA
	LD B,0		;MAKE SURE B ZERO AT START
	CALL WRDIG?	;PUT DIGIT
	LD A,D		;GET LO DIGIT
	CALL WRDIG?	;PUT IT
	LD A,E
	RRA
	RRA
	RRA
	RRA
	CALL WRDIG?
	LD A,E
	CALL WRDIG?
	POP AF
	RET
 
ONEDIG	LD A,E
	CALL WRDIG	;PUT THE SINGLE DIGIT
	POP AF
	RET
 
	;WRDIG? WRITES HEX DIGIT. IF NO EARLIER DIGIT
	;WRITTEN, AND THIS DIGIT > 9, INSERTS '0' BEFORE IT
 
WRDIG?	AND 0FH		;MASK LOW NYBBLE
	PUSH AF
	XOR A		;0 BYTE
	CP B		;ALL EARLIER WERE 0?
	JR NZ,NFIRST	;IF NOT, JUMP
	POP AF		;GET DIGIT
	AND A		;THIS ONE 0 TOO?
	RET Z		;IF Y, JUST RETURN
	CP 10		;SHOULD '0' BE INSERTED?
	JR C,NLEAD0
	LD (IY+0),'0'	;INSERT LEADING ZERO
	INC IY
NLEAD0	INC B		;SIGNAL A DIGIT WRITTEN
	JR WRDIG	;WRITE DIGIT & RETURN
 
NFIRST	POP AF		;WRITE DIGIT UNCONDITIONALLY
	JR WRDIG
 
	;WRWORD WRITES 2 BYTES FROM (IX-2) TO STRING
	;'0' & 'H' INSERTED IF APPLICABLE
	
WRWORD	LD E,(IX-2)
	LD D,(IX-1)
	JR WRVAL
 
	;WR1VAL WRITES CONTENTS OF A TO STRING WITH
	;LEADING '0' & TRAILING 'H' IF NECESSARY
 
WR1VAL	PUSH DE		;SAVE REG
	LD D,0
	LD E,A
	CALL WRVAL
	POP DE
	RET
 
	;WRLD WRITES 'LD ' TO STRING
 
WRLD	LD HL,LD_
 
	;STRWR WRITES THE STRING POINTED TO BY HL
	;OUTPUT STRING. STRING ENDS WITH AN ASCII
	;CHAR WITH BIT 7 SET
 
STRWR	PUSH AF		;SAVE
STWRLP	LD A,(HL)	;GET ONE CHAR
	BIT 7,A		;ENDING CHAR?
	RES 7,A		;KILL SIGNAL BIT
	CALL WRA	;WRITE IT (NO FLAGS DESTROYED)
	INC HL		;POINT TO NEXT
	JR Z,STWRLP	;JUMP IF IT WAS NO END CHAR
	POP AF		;ELSE RETURN
	RET
 
	;FINSRG FINDS AND WRITES SINGLE REG NAME 
	;ACCORDING TO 3 LOWEST BITS OF A
	
FINSRG	AND 7		;MASK REG BITS
	LD HL,SRGTAB	;TABLE OF SINGLE REGS
 
	;STSRCH SEARCHES A TABLE FOR A BYTE. WHEN FOUND,
	;WRITES THE STRING AT THE CORRESPONDING ADDRESS
	
STSRCH	CALL ADSRCH	;FIND THE ADDRESS
	JR STRWR	;WRITE THE STRING
 
	;FINDRG FINDS AND WRITES DOUBLE REG NAME
	;ACCORDING TO BITS 4 & 5 OF A
 
FINDRG	AND 30H		;MASK REG BITS
	LD HL,DRGTAB	;POINT TO DOUBLE REG TABLE
	JR STSRCH
 
	;FINCC FINDS AND WRITES CONDITION CODE
	;ACCORDING TO BIT 3, 4 & 5 OF A
 
FINCC	AND 38H		;MASK CONDITION BITS
	LD HL,CCTAB	;POINT TO COND CODE TABLE
	JR STSRCH
 
	;WRDEST WRITES DESTINATION ADDRESS FOR
	;RELATVIE JUMPS
 
WRDEST	LD E,A		;DISPLACEMENT TO E
	LD D,0
	BIT 7,E		;NEGATIVE OR POSITIVE?
	JR Z,NOTNEG
	LD D,0FFH	;TAKE CARE OF NEGATIVE JUMPS
NOTNEG	PUSH IX		;INSTR POINTER TO HL
	POP HL
	ADD HL,DE
	EX DE,HL	;PUT IN DE
	JP WRVAL	;WRITE VALUE TO STRING
 
	title	'INSTRUCTION ROUTINES'
 
	;ALL UNIMPLEMENTED CPU INSTRUCTIONS
	;TREATED AS DEFINE BYTE
 
DEFINB	CALL SINBYT	
	LD HL,DEFB_	;STRING
	CALL STRWR
	LD A,(IX-1)	;GET BYTE VALUE
	CALL WR1VAL	;WRITE IT
	JP LINEND
 
	;ALL SPECIAL ONE-BYTE INSTRS
 
SPEC	CALL SINBYT
	LD HL,SPCTAB	;FIND STRING AND WRITE IT
	CALL STSRCH
	JP LINEND	;TERM LINE & RETURN
 
	;LD R,R ; LD R,(HL) ;LD (HL),R
 
LDRR	CALL SINBYT
	CALL WRLD
	PUSH AF		;SAVE INS BYTE
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE DEST REG NAME
	LD A,','	;A COMMA
	CALL WRA	;WRITE IT
	POP AF		;GET INS BYTE
	CALL FINSRG	;WRITE SOURCE REG
	JP LINEND	;TERM LINE, RETURN
 
	;ADD A,R ;ADC A,R ;SUB R ;SBC A,R ;AND R ;
	;XOR R ;OR R; CP R
 
ADCP	CALL SINBYT
	PUSH AF		;SAVE INS BYTE
	AND 38H		;MASK REG BITS
	LD HL,ACPTAB	;WRITE MNEMONIC
	CALL STSRCH
	POP AF		;GET INS BYTE
	CALL FINSRG	;WRITE REG NAME
	JP LINEND	;TERM LINE & RETURN
 
	;INC R
 
SRINC	CALL SINBYT
	LD HL,INC_	;WRITE MNEM
	JR SINDE
 
	;DEC R
 
SRDEC	CALL SINBYT
	LD HL,DEC_	;WRITE MNEM
SINDE	CALL STRWR
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
 
	;RST NN
 
RST	CALL SINBYT
	LD HL,RST_	;WRITE MNEM
	CALL STRWR
	AND 38H		;MASK DEST BITS
	CALL WR1VAL	;WRITE JUMP ADR
	JP LINEND	;TERM & RETURN
 
	;INC DD
 
DRINC	CALL SINBYT
	LD HL,INC_	;WRITE MNEM
	JR DINDE
 
	;DEC DD
 
DRDEC	CALL SINBYT
	LD HL,DEC_	;WRITE MNEM
DINDE	CALL STRWR
	CALL FINDRG	;WRITE DREG NAME
	JP LINEND
 
	;ADD HL,DD
 
ADHDR	CALL SINBYT
	LD HL,ADDHL_	;WRITE MNEM
	JR DINDE
 
	;RET CC
 
RETCC	CALL SINBYT
	LD HL,RET_	;WRITE MNEM
	CALL STRWR
	CALL FINCC
	JP LINEND
 
	;PUSH DD
 
PUSH	CALL SINBYT
	LD HL,PUSH_	;MNEM
	JR PUPOP
 
	;POP DD
 
POP	CALL SINBYT
	LD HL,POP_
PUPOP	CALL STRWR
	AND 30H		;MASK DREG BITS
	LD HL,DAFTAB	;WRITE DREG NAME
	CALL STSRCH
	JP LINEND
 
	;LD R,N ;LD (HL),N
 
LDRN	CALL DULBYT
	CALL WRLD	;MNEM
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	LD A,','	;COMMA
	CALL WRA
	LD A,(IX-1)	;GET VALUE BYTE
	CALL WR1VAL	;WRITE IT
	JP LINEND
 
	;DJNZ N
 
DJNZ	CALL DULBYT
	LD HL,DJNZ_	;MNEM
DJNEND	CALL STRWR
RELEND	LD A,(IX-1)	;GET DISPLACEMENT
	CALL WRDEST	;WRITE DEST ADDRESS
	JP LINEND
 
	;JR ; JR CC
 
JREL	CALL DULBYT
	LD HL,JR_	;MNEM
	CALL STRWR
	BIT 5,A		;CONDITIONAL?
	JR Z,RELEND
	AND 18H		;MASK CC BITS
	CALL FINCC	;WRITE CC
	LD A,','	;COMMA
	CALL WRA
	JR RELEND
 
	;ADD A,N; ADC A,N; SUB N; SBC A,N; AND N
	;XOR N; OR N; CP N
 
ADCPN	CALL DULBYT
	AND 38H		;MASK MNEM BITS
	LD HL,ACPTAB	;WRITE MNEM
	CALL STSRCH
	LD A,(IX-1)	;GET VALUE
	CALL WR1VAL
	JP LINEND 
 
	;CALL CC,NN
 
CALLCC	CALL TRIBYT
	LD HL,CALL_	;MNEM
CACC1	CALL STRWR
	CALL FINCC	;WRITE CC
	LD A,','	;COMMA
	CALL WRA
	CALL WRWORD	;WRITE DEST ADDRESS
	JP LINEND
 
	;JP CC,NN
 
JPCC	CALL TRIBYT
	LD HL,JP_	;MNEM
	JR CACC1
 
	;LD DD,NN
 
LDDRNN	CALL TRIBYT
	CALL WRLD	;MNEM
	CALL FINDRG	;WRITE DREG
	LD A,','	;COMMA
	CALL WRA
	CALL WRWORD	;WRITE VALUE
	JP LINEND
 
	;OUT N(N),A
 
OUT	CALL DULBYT
	LD HL,OUT_	;MNEM
	CALL STRWR
	LD A,(IX-1)	;PORT #
	CALL WR1VAL	;WRITE IT
	LD HL,OUTND_	;STRING ',A'
	CALL STRWR
	JP LINEND
 
	;IN A,(N)
 
IN	CALL DULBYT
	LD HL,IN_	;MNEM
	CALL STRWR
	LD A,(IX-1)	;GET PORT #
	CALL WR1VAL
	LD A,')'
	CALL WRA
	JP LINEND
 
	;CALL NN
 
CALL	CALL TRIBYT
	LD HL,CALL_
CALEND	CALL STRWR
	CALL WRWORD	;WRITE DESTINATION
	JP LINEND
 
	;JP NN
 
JP	CALL TRIBYT
	LD HL,JP_
	JR CALEND
 
	;LD (NN),A; LD(NN),HL
 
LDNREG	CALL TRIBYT	;
	CALL WRLD	;MNEM
	PUSH AF
	LD A,'('
	CALL WRA
	CALL WRWORD	;WRITE MEM ADDRESS
	LD A,')'
	CALL WRA
	LD A,','	;A COMMA
	CALL WRA
	POP AF	
	BIT 4,(IX-3)	;TEST HL/A BIT
	JR Z,$+10
	LD A,'A'
	CALL WRA
	JP LINEND
	LD HL,HL_
	CALL STRWR
	JP  LINEND
	
	;LD A,(NN); LD HL,(NN)
 
LDREGN	CALL TRIBYT
	CALL WRLD
	LD HL,HL_
	BIT 4,(IX-3)	;TEST HL/A BIT
	JR Z,$+5
	LD HL,A_
	CALL STRWR
	LD A,','	;COMMA
	CALL WRA
	LD A,'('
	CALL WRA
	CALL WRWORD
	LD A,')'
	CALL WRA
	JP LINEND
 
	;RLC; RRC; RL; RR; SLA; SRA; SRL;
	;BIT; SET; RES
 
CBINS	LD A,(IX+1)	;GET 2:ND INS BYTE
	LD HL,CBTAB
	JP JPSRCH	;JUMP ACCORDING TO OP-CODE
 
	;BIT B,R; BIT B,(HL)
 
BITINS	CALL DULBYT
	LD HL,BIT_
	JR BITEND
 
	;RES B,R; RES B,(HL)
 
RESINS	CALL DULBYT
	LD HL,RES_
	JR BITEND
 
	;SET B,R; SET B,(HL)
 
SETINS	CALL DULBYT
	LD HL,SET_
BITEND	CALL STRWR
	PUSH AF
	RRCA		;SHIFT R 3
	RRCA
	RRCA
	AND 07H		;MASK BIT NUMBER
	CALL WRDIG	;WRITE IT
	LD A,','	;COMMA
	CALL WRA
	POP AF
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
 
	;RLC ;RRC; RL; RR;SLA; SRA; SRL
 
SHIROT	CALL DULBYT
	LD HL,SHRTAB
	CALL STSRCH	;WRITE MNEM
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
	
	;INSTRUCTIONS STARTING WITH HEX ED
 
EDINS	LD HL,EDTAB	;TABLE FOR THESE INSTRS
	LD A,(IX+1)	;GET 2:ND INS BYTE
	JP JPSRCH	;JUMP ACC TO PATTERN
 
	;ALL SPECIAL ED INSTRUCTIONS
 
EDSPEC	CALL DULBYT
	LD HL,EDSTAB	;TABLE WITH STRING ADDRESSES
	LD A,(IX-1)	;GET 2:ND BYTE
	CALL STSRCH	;WRITE STRING
	JP LINEND
 
	;SBC HL,DD
 
SBCHLD	CALL DULBYT
	LD HL,SBCHL_	;STRING
	CALL STRWR
	LD A,(IX-1)	;GET 2:ND BYTE
	CALL FINDRG	;WRITE REG NAME
	JP LINEND
 
	;ADC HL,DD
 
ADCHLD	CALL DULBYT
	LD HL,ADCHL_	;STRING
	CALL STRWR
	LD A,(IX-1)	;GET 2:ND BYTE
	CALL FINDRG	;WRITE REG NAME
	JP LINEND
 
	;IN R,(C)
	
EDIN	CALL DULBYT
	LD HL,EDIN_	;STRING
	CALL STRWR
	RRCA
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	LD HL,CPCP_	;STRING ',(C)'
	CALL STRWR
	JP LINEND
 
	;OUT (C),R
 
EDOUT	CALL DULBYT
	LD HL,EDOUT_	;MNEMONIC
	CALL STRWR
	RRCA		;RIGHT 3
	RRCA
	RRCA
	CALL FINSRG	;WRITE REG NAME
	JP LINEND
 
	;LD DR,(NN)
 
LDDRAD	CALL QADBYT
	CALL WRLD
	LD A,(IX-3)	;GET 2:ND INS BYTE
	CALL FINDRG	;WRITE REG NAME
	LD HL,IN_+4	;STRING ',C'
	CALL STRWR
	CALL WRWORD	;WRITE ADDRESS
	LD A,')'
	CALL WRA
	JP LINEND
 
	;LD (NN),DR
 
LDADDR	CALL QADBYT
	CALL WRLD
	LD A,'('	;PARANTH.
	CALL WRA
	CALL WRWORD	;WRITE ADDRESS
	LD A,')'	;PARANTH.
	CALL WRA
	LD A,','	;COMMA
	CALL WRA
	LD A,(IX-3)	;GET 2:ND INS BYTE
	CALL FINDRG	;WRITE REG NAME
	JP LINEND
 
	;FOR INDEX IX AND IY INSTRUCTIONS
	;MODIFY STRINGS 'HL' TO 'IX' OR 'IY',
	;AND '(HL)' TO '(IX+00H)' OR '(IY+00H)'
 
INDEX	LD HL,ADDIX_+5	;STRING 'ADD IX,'
	LD (HL),'X'	;INIT IT TO 'IX'
	LD HL,PIXP_0	;'(IX+00H)' STRING
	PUSH HL
	LD HL,IX_0	;'IX' STRING
	BIT 5,(IX+0)	;IS IT ACTUALLY IX OR IY?
	JR Z,NOTIY
	LD HL,ADDIX_+5	;STRING 'ADD IX,'
	LD (HL),'Y'	;CHANGE TO 'IY'
	POP HL
	LD HL,PIYP_0	;'(IY+00H)' STRING
	PUSH HL
	LD HL,IY_0	;'IY' STRING
NOTIY	LD DE,HL_	;DESTINATION
	LD BC,3		;3 CHARS TO MOVE
	LDIR
	POP HL
	LD DE,PHLP_	;DESTINATION
	LD BC,9		;9 CHARS TO MOVE
	LDIR
	PUSH IY		;SAVE OUTSTRING PTR
	LD IY,PHLP_+3	
	LD A,(IX+2)	;GET DISPLACEMENT BYTE
	AND A		;SET FLAGS
	JR Z,ZERDIS	;ZERO DISPLACEMENT?
	BIT 7,A		;POS OR NEG?
	LD A,'+'
	JR Z,POSDI1	;JUMP IF POSITIVE
	LD A,'-'	;NEGATIVE!
POSDI1	CALL WRA	;WRITE
	LD A,(IX+2)	;GET BYTE AGAIN
	JR Z,POSDI2	;FLAGS UNCHANGED
	NEG		;NEGATIVE -> POSITIVE
POSDI2	CALL WR1VAL	;WRITE VALUE
ZERDIS	LD A,')'+80H	
	CALL WRA
	POP IY		;RESTORE STRING PTR
	
	LD A,(IX+1)	;GET 2:ND BYTE
	LD HL,IXTAB	;SEARCH FOR IT IN A TABLE
	JP JPSRCH	;FIND ADDR & JUMP TO IT
 
IXCB?	LD A,(IX+3)	; 4:TH MUST BE XXXXX110B
	AND 07H
	CP 06H
	JP NZ,DEFINB	;WAS IT X6H OR XEH?
	LD A,(IX+3)	;4:TH MUST NOT BE 36H
	CP 36H
	JP Z,DEFINB
 
	;IT WAS A LEGAL INDEX BIT OR 
	;SHIFT/ROTATE INSTRUCTION
 
IXCB	CALL QADBYT	;MAKE LEFT COLUMNS
	LD A,(IX-1)	;GET LAST OP BYTE
	LD HL,CBTAB	;TABLE WITH JUMP ADDRESSES
	CALL ADSRCH	;SEARCH JUMP ADDRESS
	INC HL		;INC BY 3 TO AVOID 
	INC HL		;'CALL DULBYT' IN THE RE-
	INC HL		;SPECTIVE ROUTINES
	JP (HL)		;MAKE THE SOURCE CODE
 
ADXDR	CALL DULBYT	;WRITE LEFT COLS
	LD HL,ADDIX_	;POINT TO STRING
	JP DINDE	;CONTINUE
 
LDRX	CALL TRIBYT	;LEFT COLS
	JP LDRR+3	;CONTINUE IN LDRR ROUTINE
 
ADCPX	CALL TRIBYT	;LEFT COL:S
	JP ADCP+3	;CONTINUE IN ADCP ROUTINE
 
LDIXNN	CALL QADBYT	;LEFT COL:S
	JP LDDRNN+3
 
LDNRGX	CALL QADBYT	;LEFT COL:S
	JP LDNREG+3
 
DRINCX	CALL DULBYT	;LEFT COL:S
	JP DRINC+3
 
DRDECX	CALL DULBYT	;LEFT COL:S
	JP DRDEC+3
 
LDRGNX	CALL QADBYT	;LEFT COL:S
	JP LDREGN+3
 
SRINCX	CALL TRIBYT
	JP SRINC+3
 
SRDECX	CALL TRIBYT
	JP SRDEC+3
 
LDRNX	CALL QADBYT
	JP LDRN+3
 
POPX	CALL DULBYT
	JP POP+3
 
PUSHX	CALL DULBYT
	JP PUSH+3
 
EXSPIX	CALL DULBYT
	LD HL,XSPIX_	;POINT TO STRING
	CALL STRWR
	LD HL,HL_
	CALL STRWR
	JP LINEND
 
LDSPIX	CALL DULBYT
	LD HL,LDSH_
	CALL STRWR
	JP LINEND
 
JPIX	CALL DULBYT
	LD HL,JP_	;POINT TO STRING
	CALL STRWR
	LD A,'('
	CALL WRA
	LD HL,HL_
	CALL STRWR
	LD A,')'
	CALL WRA
	JP LINEND
	
	title	'PRIMARY INS TABLE'
	
	;PRIMARY INSTRUCTION TABLE
 
INSTAB	DEFW 0FF76H	;HALT
	DEFW SPEC
 
	DEFW 0DFC9H	;JP (HL) AND RET
	DEFW SPEC
 
	DEFW 0FFFFH	;RST 38H
	DEFW RST
 
	DEFW 0C040H	;LD R,R ;LD (HL),R ;LD R,(HL)
	DEFW LDRR
	
	DEFW 0C080H	;ADD ADC SUB SBC AND OR XOR CP
	DEFW ADCP
 
	DEFW 0C704H	;INC R ;INC (HL)
	DEFW SRINC
	
	DEFW 0C705H	;DEC R ;DEC (HL)
	DEFW SRDEC
	
	DEFW 0C7C7H	;RST N
	DEFW RST
	
	DEFW 0CF03H	;INC DD
	DEFW DRINC
	
	DEFW 0CF0BH	;DEC DD
	DEFW DRDEC
	
	DEFW 0CF09H	;ADD HL,DD
	DEFW ADHDR
	
	DEFW 0C7C0H	;RET CC
	DEFW RETCC
	
	DEFW 0CFC5H	;PUSH DR
	DEFW PUSH
	
	DEFW 0CFC1H	;POP DR
	DEFW POP
 
	DEFW 0C706H	;LD R,N ;LD (HL),N
	DEFW LDRN
 
	DEFW 0FF10H	;DJNZ N
	DEFW DJNZ
 
	DEFW 0F700H	;NOP ; EX AF,AF'
	DEFW SPEC
	
	DEFW 0C700H	;RELATIVE JUMPS
	DEFW JREL
 
	DEFW 0C7C6H	;ADD A,N ; ETC.
	DEFW ADCPN
 
	DEFW 0C7C4H	;CALL CC
	DEFW CALLCC
 
	DEFW 0C7C2H	;JP CC
	DEFW JPCC
 
	DEFW 0CF01H	;LD DR,NN
	DEFW LDDRNN
 
	DEFW 0FFD3H	;OUT (N),A
	DEFW OUT
 
	DEFW 0FFDBH	;IN A,(N)
	DEFW IN
 
	DEFW 0FFCDH	;CALL NN
	DEFW CALL
 
	DEFW 0FFC3H	;JP NN
	DEFW JP
 
	DEFW 0FFCBH	;BIT INSTRS + SHIFTS & ROTATES
	DEFW CBINS
	
	DEFW 0FFEDH	;MISCELLANEOUS
	DEFW EDINS
 
	DEFW 0DFDDH	;IX & IY INSTRUCTIONS
	DEFW INDEX	;
 
	DEFW 0EF22H	;LD (NN),A ;LD (NN),HL
	DEFW LDNREG
 
	DEFW 0EF2AH	;LD A,(NN) ;LD HL,(NN)
	DEFW LDREGN
 
	DEFW 0000H	;ALL OTHER WITHOUT MASK
	DEFW SPEC
 
	title	'MISCELLANEOUS TABLES'	
	;SINGLE REG TABLE
 
SRGTAB	DEFW 0FF00H	;REG B
	DEFW B_
 
	DEFW 0FF01H	;REG C
	DEFW C_
 
	DEFW 0FF02H	;REG D
	DEFW D_
 
	DEFW 0FF03H	;REG E
	DEFW E_
 
	DEFW 0FF04H	;REG H
	DEFW H_
 
	DEFW 0FF05H	;REG L
	DEFW L_
 
	DEFW 0FF06H	;(HL)
	DEFW PHLP_
 
	DEFW 0007H	;ACCUMULATOR WITH NO MASK
	DEFW A_
 
	;DOUBLE REGISTER TABLE
 
DRGTAB	DEFW 0FF30H	;REG SP
	DEFW SP_
 
DAFTAB	DEFW 0FF30H	;REG AF
	DEFW AF_
 
	DEFW 0FF20H	;REG HL
	DEFW HL_
 
	DEFW 0FF10H	;REG DE
	DEFW DE_
 
	DEFW 0000H	;REG BC WITH NO MASK
	DEFW BC_
 
	;ADD - CP TABLE
 
ACPTAB	DEFW 0FF00H	;ADD A
	DEFW ADDA_
 
	DEFW 0FF08H	;ADC A
	DEFW ADCA_
 
	DEFW 0FF10H	;SUB
	DEFW SUB_ 
 
	DEFW 0FF18H	;SBC A
	DEFW SBCA_
	
	DEFW 0FF20H	;AND
	DEFW AND_
 
	DEFW 0FF28H	;XOR
	DEFW XOR_
 
	DEFW 0FF30H	;OR
	DEFW OR_
 
	DEFW 0038H	;CP WITH NO MASK
	DEFW CP_
 
	;CONDITIONN CODE TABLE
 
CCTAB	DEFW 0FF00H	;NZ
	DEFW NZ_
 
	DEFW 0FF08H	;Z
	DEFW Z_
	
	DEFW 0FF10H	;NC
	DEFW NC_
 
	DEFW 0FF18H	;C
	DEFW C_
 
	DEFW 0FF20H	;PO
	DEFW PO_
 
	DEFW 0FF28H	;PE
	DEFW PE_
 
	DEFW 0FF30H	;P
	DEFW P_
 
	DEFW 0038H	;M WITH NO MASK
	DEFW M_
 
	;TABLE OF INSTRS BEGINNING WITH CBH
 
CBTAB	DEFW 0C040H	;BIT
	DEFW BITINS
 
	DEFW 0C080H	;RES
	DEFW RESINS
 
	DEFW 0C0C0H	;SET
	DEFW SETINS
 
	DEFW 3830H	;NOT IMPLEMENTED IN CPU
	DEFW DEFINB
	
	DEFW 0000H	;ALL OTHER WITHOUT MASK
	DEFW SHIROT
 
	;SHIFT & ROTATE TABLE
 
SHRTAB	DEFW 3800H	;RLC
	DEFW RLC_
 
	DEFW 3808H	;RRC
	DEFW RRC_
 
	DEFW 3810H	;RL
	DEFW RL_
 
	DEFW 3818H	;RR
	DEFW RR_
 
	DEFW 3820H	;SLA
	DEFW SLA_
 
	DEFW 3828H	;SRA
	DEFW SRA_
 
	DEFW 0038H	;SRL WITH NO MASK
	DEFW SRL_
 
	title	'SPEC INSTR TABLE'
 
	;SPECIAL INSTRUCTION TABLE
 
SPCTAB	DEFW 0FF00H	;NOP
	DEFW NOP_
 
	DEFW 0FF02H	;LD (BC),A
	DEFW LDBCA_
 
	DEFW 0FF07H	;RLCA
	DEFW RLCA_
 
	DEFW 0FF08H	;EX AF,AF'
	DEFW XAFS_
 
	DEFW 0FF0AH	;LD A,(BC)
	DEFW LDABC_
 
	DEFW 0FF0FH	;RRCA
	DEFW RRCA_
 
	DEFW 0FF12H	;LD (DE),A
	DEFW LDDEA_
 
	DEFW 0FF17H	;RLA
	DEFW RLA_
 
	DEFW 0FF1AH	;LD A,(DE)
	DEFW LDADE_
 
	DEFW 0FF1FH	;RRA
	DEFW RRA_
 
	DEFW 0FF27H	;DAA
	DEFW DAA_
 
	DEFW 0FF2FH	;CPL
	DEFW CPL_
	
	DEFW 0FF37H	;SCF
	DEFW SCF_
 
	DEFW 0FF3FH	;CCF
	DEFW CCF_
 
	DEFW 0FF76H	;HALT
	DEFW HALT_
 
	DEFW 0FFC9H	;RET
	DEFW RET_
 
	DEFW 0FFD9H	;EXX
	DEFW EXX_
 
	DEFW 0FFE3H	;EX SP,HL
	DEFW XSPHL_
 
	DEFW 0FFE9H	;JP (HL)
	DEFW JPHL_
 
	DEFW 0FFEBH	;EX DE,HL
	DEFW XDEHL_
 
	DEFW 0FFF3H	;DI
	DEFW DI_
 
	DEFW 0FFF9H	;LD SP,HL
	DEFW LDSH_
 
	DEFW 00FBH	;EI WITH NO MASK
	DEFW EI_
 
	title	'MISCELLANEOUS TABLES'
 
	;PRIM INS TABLE FOR ED INSTRS
 
EDTAB	DEFW 0FE70H	;NOT IN (HL),C ; OUT (C),(L)
	DEFW DEFINB
 
	DEFW 0C740H	;IN R,(C)
	DEFW EDIN
 
	DEFW 0C741H	;OUT (C),R
	DEFW EDOUT
 
	DEFW 0CF43H	;LD (NN),DR
	DEFW LDADDR
 
	DEFW 0CF4BH	;LD DR,(NN)
	DEFW LDDRAD
 
	DEFW 0E4A0H	;ED SPECIALS
	DEFW EDSPEC
 
	DEFW 0CF42H	;SBC HL,DD
	DEFW SBCHLD
 
	DEFW 0CF4AH	;ADC HL,DD
	DEFW ADCHLD
 
	DEFW 0FF45H	;RETN
	DEFW EDSPEC
 
	DEFW 0FC44H	;NEG, IM 0, LD I,A
	DEFW EDSPEC
 
	DEFW 0FF4DH	;RETI
	DEFW EDSPEC
 
	DEFW 0F656H	;IM 1, LD A,I, IM 2 
	DEFW EDSPEC
 
	DEFW 0EF4FH	;LD R,A, LD A,R
	DEFW EDSPEC
 
	DEFW 0F767H	;RLD, RRD
	DEFW EDSPEC
 
	DEFW 0		;ALL OTHERS
	DEFW DEFINB
 
	;SPECIAL ED INS TABLE
 
EDSTAB	DEFW 0FF44H	;NEG
	DEFW NEG_
 
	DEFW 0FF45H	;RETN
	DEFW RETN_
 
	DEFW 0FF46H	;IM 0
	DEFW IM_0_
 
	DEFW 0FF47H	;LD I,A
	DEFW LDIA_
 
	DEFW 0FF4DH	;RETI
	DEFW RETI_
 
	DEFW 0FF4FH	;LD R,A
	DEFW LDRA_
 
	DEFW 0FF56H	;IM 1
	DEFW IM_1_
 
	DEFW 0FF57H	;LD A,I
	DEFW LDAI_
 
	DEFW 0FF5EH	;IM 2
	DEFW IM_2_
 
	DEFW 0FF5FH	;LD A,R
	DEFW LDAR_
 
	DEFW 0FF67H	;RRD
	DEFW RRD_
 
	DEFW 0FF6FH	;RLD
	DEFW RLD_
 
	DEFW 0FFA0H	;LDI
	DEFW LDI_
 
	DEFW 0FFA1H	;CPI
	DEFW CPI_
 
	DEFW 0FFA2H	;INI
	DEFW INI_
 
	DEFW 0FFA3H	;OUTI
	DEFW OUTI_
 
	DEFW 0FFA8H	;LDD
	DEFW LDD_
 
	DEFW 0FFA9H	;CPD
	DEFW CPD_
 
	DEFW 0FFAAH	;IND
	DEFW IND_
 
	DEFW 0FFABH	;OUTD
	DEFW OUTD_
 
	DEFW 0FFB0H	;LDIR
	DEFW LDIR_
 
	DEFW 0FFB1H	;CPIR
	DEFW CPIR_
 
	DEFW 0FFB2H	;INIR
	DEFW INIR_
 
	DEFW 0FFB3H	;OTIR
	DEFW OTIR_
 
	DEFW 0FFB8H	;LDDR
	DEFW LDDR_
 
	DEFW 0FFB9H	;CPDR
	DEFW CPDR_
 
	DEFW 0FFBAH	;INDR
	DEFW INDR_
 
	DEFW 000BBH	;OTDR WITHOUT MASK
	DEFW OTDR_
	
IXTAB	DEFW 0FFCBH	;BITS,SHIFTS,ROTATES
	DEFW IXCB?	;(IF 4:TH BYTE OK)
 
	DEFW 0CF09H	;ADD IX,DD
	DEFW ADXDR
 
	DEFW 0FF76H	;NO INDEX HALT INSTR
	DEFW DEFINB
 
	DEFW 0C746H	;LD R,(IX+D)
	DEFW LDRX
 
	DEFW 0F870H	;LD (IX+D),R
	DEFW LDRX
 
	DEFW 0C786H	;ADD-CP IX INSTR:S
	DEFW ADCPX
 
	DEFW 0FF21H	;LD IX,NN
	DEFW LDIXNN
 
	DEFW 0FF22H	;LD (NN),IX
	DEFW LDNRGX
 
	DEFW 0FF23H	;INC IX
	DEFW DRINCX
 
	DEFW 0FF2BH	;DEC IX
	DEFW DRDECX
 
	DEFW 0FF2AH	;LD IX,(NN)
	DEFW LDRGNX
 
	DEFW 0FF34H	;INC (IX+D)
	DEFW SRINCX
 
	DEFW 0FF35H	;DEC (IX+D)
	DEFW SRDECX
 
	DEFW 0FF36H	;LD (IX+D),N
	DEFW LDRNX
 
	DEFW 0FFE1H	;POP IX
	DEFW POPX
 
	DEFW 0FFE3H	;EX (SP),IX
	DEFW EXSPIX
 
	DEFW 0FFE5H	;PUSH IX
	DEFW PUSHX
 
	DEFW 0FFE9H	;JP (IX)
	DEFW JPIX
 
	DEFW 0FFF9H	;LD SP,IX
	DEFW LDSPIX
 
	DEFW 0000	;OTHERS ILLEGAL
	DEFW DEFINB
 
	title	'SOURCE CODE STRINGS'
 
	; ***** SOURCE CODE STRINGS *****
 
NOP_	text 'NO'
P_	DEFB 'P'+80H
	
RLCA_	text 'RLC'
A_	DEFB 'A'+80H
 
PIXP_0	text '(IX+00H'
	DEFB ')'+80H
 
PIYP_0	text '(IY+00H'
	DEFB ')'+80H
 
PHLP_0	text '(HL'	;
	DEFB ')'+80H
	
JPHL_	text 'JP'
	DEFB TAB		
PHLP_	DEFS 10	;EITHER '(HL)' OR '(IX+NNH) HERE
	
LDABC_	text 'LD'
	DEFB TAB		
	text 'A,(BC'
	DEFB ')'+80H
	
XAFS_	text 'EX'
	DEFB TAB
	text 'AF,AF'
	DEFB ''''+80H
	
RRCA_	text 'RRC'
	DEFB 'A'+80H
	
RLA_	text 'RL'
	DEFB 'A'+80H
	
RRA_	text 'RR'
	DEFB 'A'+80H
 
DAA_	text 'DA'
	DEFB 'A'+80H
 
CPL_	text 'CP'
	DEFB 'L'+80H
 
SCF_	text 'SC'
	DEFB 'F'+80H
 
CCF_	text 'CC'
	DEFB 'F'+80H
 
RET_	text 'RET'
	DEFB TAB+80H
 
HALT_	text 'HAL'
	DEFB 'T'+80H
 
EXX_	text 'EX'
	DEFB 'X'+80H
 
IX_0	text 'I'
	DEFB 'X'+80H
 
IY_0	text 'I'
	DEFB 'Y'+80H
 
HL_0	text 'H'
L_	DEFB 'L'+80H
 
LDSH_	text 'LD'
	DEFB TAB
	text 'SP,'
HL_	DEFS 5
 
DI_	text 'D'
	DEFB 'I'+80H
 
EI_	text 'E'
	DEFB 'I'+80H
 
LD_	text 'LD'
	DEFB TAB+80H
 
RST_	text 'RST'
	DEFB TAB+80H
 
LDBCA_	text 'LD'
	DEFB TAB
	text '(BC),'
	DEFB 'A'+80H
 
LDDEA_	text 'LD'
	DEFB TAB
	text '(DE),'
	DEFB 'A'+80H
 
LDADE_	text 'LD'
	DEFB TAB
	text 'A,(DE'
	DEFB ')'+80H
 
XDEHL_	text 'EX'
	DEFB TAB
	text 'DE,H'
	DEFB 'L'+80H
 
XSPHL_	text 'EX'
	DEFB TAB
	text '(SP),H'
	DEFB 'L'+80H
 
PUSH_	text 'PUSH'
	DEFB TAB+80H
 
POP_	text 'POP'
	DEFB TAB+80H
 
AF_	text 'A'
	DEFB 'F'+80H
 
DJNZ_	text 'DJNZ'
	DEFB TAB+80H
 
JR_	text 'JR'
	DEFB TAB+80H
 
OUT_	text 'OUT'
	DEFB TAB
	DEFB '('+80H
 
OUTND_	text '),'
	DEFB 'A'+80H
 
IN_	text 'IN'
	DEFB TAB
	text 'A,'
	DEFB '('+80H
 
DEC_	text 'DEC'
	DEFB TAB+80H
 
INC_	text 'INC'
	DEFB TAB+80H
 
SET_	text 'SET'
	DEFB TAB+80H
 
RES_	text 'RES'
	DEFB TAB+80H
 
BIT_	text 'BIT'
	DEFB TAB+80H
 
CALL_	text 'CALL'
	DEFB TAB+80H
 
JP_	text 'JP'
	DEFB TAB+80H
 
BC_	text 'B'
C_	DEFB 'C'+80H
 
DE_	text 'D'
E_	DEFB 'E'+80H
 
SP_	text 'S'
	DEFB 'P'+80H
 
B_	DEFB 'B'+80H
 
D_	DEFB 'D'+80H
 
H_	DEFB 'H'+80H
 
NZ_	text 'N'
Z_	DEFB 'Z'+80H
 
NC_	text 'N'
	DEFB 'C'+80H
 
PO_	text 'P'
	DEFB 'O'+80H
 
PE_	text 'P'
	DEFB 'E'+80H
 
M_	DEFB 'M'+80H
 
ADDA_	text 'ADD'
	DEFB TAB
	text 'A'
	DEFB ','+80H
 
ADCA_	text 'ADC'
	DEFB TAB
	text 'A'
	DEFB ','+80H
 
SUB_	text 'SUB'
	DEFB TAB+80H
 
SBCA_	text 'SBC'
	DEFB TAB
	text 'A'
	DEFB ','+80H
 
AND_	text 'AND'
	DEFB TAB+80H
 
XOR_	text 'XOR'
	DEFB TAB+80H
 
OR_	text 'OR'
	DEFB TAB+80H
 
CP_	text 'CP'
	DEFB TAB+80H
	
ADDHL_	text 'ADD'
	DEFB TAB
	text 'HL'
	DEFB ','+80H
 
RLC_	text 'RLC'
	DEFB TAB+80H
 
RRC_	text 'RRC'
	DEFB TAB+80H
 
RL_	text 'RL'
	DEFB TAB+80H
 
RR_	text 'RR'
	DEFB TAB+80H
 
SLA_	text 'SLA'
	DEFB TAB+80H
 
SRA_	text 'SRA'
	DEFB TAB+80H
 
SRL_	text 'SRL'
	DEFB TAB+80H
 
EDIN_	text 'IN'
	DEFB TAB+80H
 
CPCP_	text ',(C'
	DEFB ')'+80H
 
EDOUT_	text 'OUT'
	DEFB TAB
	text '(C)'
	DEFB ','+80H
 
SBCHL_	text 'SBC'
	DEFB TAB
	text 'HL'
	DEFB ','+80H
 
ADCHL_	text 'ADC'
	DEFB TAB
	text 'HL'
	DEFB ','+80H
 
NEG_	text 'NE'
	DEFB 'G'+80H
 
RETN_	text 'RET'
	DEFB 'N'+80H
 
IM_0_	text 'IM'
	DEFB TAB
	DEFB '0'+80H
 
LDIA_	text 'LD'
	DEFB TAB
	text 'I,'
	DEFB 'A'+80H
 
RETI_	text 'RET'
	DEFB 'I'+80H
 
IM_1_	text 'IM'
	DEFB TAB
	DEFB '1'+80H
 
LDAI_	text 'LD'
	DEFB TAB
	text 'A,'
	DEFB 'I'+80H
 
IM_2_	text 'IM'
	DEFB TAB
	DEFB '2'+80H
 
LDAR_	text 'LD'
	DEFB TAB
	text 'A,'
	DEFB 'R'+80H
 
LDRA_	text 'LD'
	DEFB TAB
	text 'R,'
	DEFB 'A'+80H
 
RLD_	text 'RL'
	DEFB 'D'+80H
 
RRD_	text 'RR'
	DEFB 'D'+80H
 
LDI_	text 'LD'
	DEFB 'I'+80H
 
CPI_	text 'CP'
	DEFB 'I'+80H
	
INI_	text 'IN'
	DEFB 'I'+80H
 
OUTI_	text 'OUT'
	DEFB 'I'+80H
 
LDD_	text 'LD'
	DEFB 'D'+80H
 
CPD_	text 'CP'
	DEFB 'D'+80H
 
IND_	text 'IN'
	DEFB 'D'+80H
 
OUTD_	text 'OUT'
	DEFB 'D'+80H
 
LDIR_	text 'LDI'
	DEFB 'R'+80H
 
CPIR_	text 'CPI'
	DEFB 'R'+80H
 
INIR_	text 'INI'
	DEFB 'R'+80H
 
OTIR_	text 'OTI'
	DEFB 'R'+80H
 
LDDR_	text 'LDD'
	DEFB 'R'+80H
 
CPDR_	text 'CPD'
	DEFB 'R'+80H
 
INDR_	text 'IND'
	DEFB 'R'+80H
 
OTDR_	text 'OTD'
	DEFB 'R'+80H
 
ADDIX_	text 'ADD'
	DEFB TAB
	text 'IX'
	DEFB ','+80H
 
XSPIX_	text 'EX'
	DEFB TAB
	text '(SP)'
	DEFB ','+80H
 
DEFB_	text 'DEFB'
	DEFB TAB+80H
 
DEFS_	text 'DEFS'
	DEFB TAB+80H
 
	title	'RTZ.DBG.RAM'
;UPDATED: 821028 / PH
;REV:     2.01
 
;-------
; COMMON VARIABLES
;-------
 
	global	Z$P1,Z$P2,Z$INSP,Z$DFLG,Z$TPCB,Z_TQUE
	global	Z$IBUF,Z$PTY,Z$TTYS,Z$BPCB,Z$OBUF
 
Z$P1  	DEFS	2		;1ST PARAMETER IN COMMAND
Z$P2  	DEFS	2		;2ND PARAMETER IN COMMAND
Z$INSP	DEFS	2		;GROUND VALUE FOR DBG-SP
Z$DFLG	DEFS	1		;STATUS BITS
Z$BPCB	DEFS	2		;LAST BREAKED PCB
Z$TPCB	DEFS	0		;^PCB FOR TRACED PROCESS
Z_TQUE	DEFS	2		;HEAD OF TRACE QUEUE
Z$TTYS	DEFS	1		;SET BY ^C-PROCESS
Z$PTY 	DEFS	1		;DEBUGGER PRIORITY
      	DEFS	1
Z$IBUF	DEFS	100
Z$OBUF	DEFS	200
 
;-------
; BREAK
;-------
 
	global	Z$SBTB,Z$WBTB,Z$BRET
 
Z$SBTB	DEFS	1
      	DEFS	2*10		;TABLE OF SIGNAL BREAKPOINTS
Z$WBTB	DEFS	1
      	DEFS	2*10		;TABLE OF WAIT BREAKPOINTS
Z$BRET	DEFS	2
 
;-------
; CPU
;-------
 
	global	Z$REGF,Z$OBPT,Z$OOBP,Z$OREG,Z$$PC,Z$$SP
	global	Z$$A,Z$$F,Z$$BC,Z$$DE,Z$$HL,Z$$IX,Z$$IY
 
Z$$A   	DEFS	1
Z$$BC  	DEFS	2
Z$$DE  	DEFS	2
Z$$HL  	DEFS	2
Z$$F   	DEFS	1
Z$$IX  	DEFS	2
Z$$IY  	DEFS	2
Z$$SP  	DEFS	2
Z$$PC 	DEFS	2
 
Z$REGF	DEFS	1		;
Z$OBPT	DEFS	2		;
Z$OOBP	DEFS	2		;
Z$OREG	DEFS	15		;LATEST VALUE DISPLAYED
 
;-------
; TRACE
;-------
 
	global	Z$UREG,Z$BC,Z$C,Z$B,Z$DE,Z$E,Z$D,Z$HL
	global	Z$L,Z$H,Z$AF,Z$FLAG,Z$A,Z$IX,Z$IY,Z$SP
	global	Z$TRCF,Z$TRCT,Z$DBSP,Z$ERAM
	global	Z$PC,Z$FFIX,Z$ADDR,Z$IPC,Z$ICMD
 
Z$UREG
Z$BC
Z$C   	DEFS	1		;USER C
Z$B   	DEFS	1		;USER B
Z$DE
Z$E   	DEFS	1		;USER E
Z$D   	DEFS	1		;USER D
Z$HL
Z$L   	DEFS	1		;USER L
Z$H   	DEFS	1		;USER H
Z$AF
Z$FLAG	DEFS	1		;USER FLAGS
Z$A   	DEFS	1		;USER A
Z$IX  	DEFS	2		;USER IX
Z$IY  	DEFS	2		;USER IY
Z$SP  	DEFS	2		;USER SP
Z$PC  	DEFS	2		;USER PC
 
Z$DBSP	DEFS	2		;DEBUGGER SP
Z$TRCF	DEFS	1		;TRACE FLAG
Z$TRCT	DEFS	55		;TRACE POINT TABLE
Z$ERAM	DEFS	7		;EXECUTION AREA FOR "STEP"
Z$ICMD	DEFS	1		;LATEST INTERPRET COMMAND
Z$ADDR	DEFS	2		;TEMP.STORAGE FOR "PC"
Z$IPC 	DEFS	2		;LAST INTERPRETED INSTRUCTION
Z$FFIX	DEFS	6		;RAM FOR FLAG-FIX CODE
 
	global	Z$PRRG
 
Z$PRRG	DEFS	1
 
;-------
; RTZ-ORIENTED RAM
;-------
 
	global	Z_DBSM,Z$DWRS,Z_BPOL,Z$BMSG,Z$DMSG
 
Z_DBSM	DEFS	6		;DEBUGGER EVENT-SEMAPHORE
Z$DWRS	DEFS	6		;DEBUGGER WRITE RESPONSE SEM
Z_BPOL	DEFS	6		;POOL FOR BREAK-MESSAGES
      	DEFS	2		;STORAGE FOR CHECKPOINT ADDRESS
Z$BMSG	DEFS	14		;BREAKPOINT-MESSAGE
      	DEFS	(2+14)*5	;ANOTHER 5 BREAK-MESSAGES
Z$DMSG	DEFS	8		;dummy message for .E Z_SGNL 53CB
 
;-------
; PROM-MIRROR
;-------
 
	global	Z$PMIR,Z$PMSG,Z$CONM
 
Z$PMIR
      	DEFS	2		;STORAGE FOR CHECKPOINT ADDRESS
Z$PMSG	DEFS	14		;PROMPT MESSAGE
      	DEFS	2		;STORAGE FOR CHECKPOINT ADDRESS
Z$CONM	DEFS	14		;CONSOLE MESSAGE
  
      	END
